//-------------Mission 19-------------
// Originally: Intro mission 'GIVE ME LIBERTY' and 'LUIGI'S GIRLS'

:M19_GIVEMELIBERTY
03A4: name_thread 'EIGHT'
054C: use_GXT_table 'LUIGI1'
gosub @MISSION_START_EIGHTBALL
if
    wasted_or_busted
then
    gosub @MISSION_EIGHTBALL_FAILED
end
gosub @MISSION_CLEANUP_EIGHTBALL
end_thread

:MISSION_START_EIGHTBALL
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_8BALL = 1
0317: increment_mission_attempts
01B6: set_weather 1
00C0: set_current_time 4 0
03CB: set_camera 472.0 -937.0 42.5625
wait 0 ms
//0004: $FLAG_BLIP_ON_EIGHTBALL = 0    -not used
//0004: $FLAG_PLAYER_GOT_COPS_MESSAGE_EIGHTBALL = 0    -not used
//0004: $FLAG_PLAYER_GOT_CAR_MESSAGE1_EIGHTBALL = 0    -not used
0004: $FLAG_PLAYER_IN_AREA = 0
0004: $FLAG_EIGHTBALL_IN_AREA = 0
0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_LM1 = 0
//0004: $FLAG_PLAYER_NOT_IN_CAR_MESSAGE_LM1 = 0    -not used
//0004: $NO_OF_PASSENGERS_CAR_LM1 = 0    -not used
0004: $FLAG_GIRL1_IN_CAR_LM1 = 0
//0004: $PASSENGER_COUNT_LM1 = 0    -not used
//0004: $TOTAL_SPACE_IN_CAR_LM1 = 0    -not used
0004: $FLAG_BLIP_ON_GIRL1_LM1 = 0
//0004: $FLAG_COORD_BLIP_ON = 0    -not used
0004: $BLOB_FLAG = 1
//0004: $FLAG_LUIGI_COORD1_BLIP_CREATED = 0    -not used
//0004: $FLAG_LUIGI_PED1_BLIP_CREATED = 0    -not used
//0004: $FLAG_GIRL1_IN_GROUP_LM1 = 0    -not used
0004: $FLAG_PLAYER_HAD_VEHICLE_MESSAGE_LM1 = 0
//0004: $FLAG_PLAYER_IN_AREA_LM1 = 0    -not used
//0004: $FLAG_EIGHTBALL_IN_AREA_LM1 = 0    -not used
0004: $FLAG_HELP_8BALL1 = 0
0004: $FLAG_HELP_8BALL2 = 0
0004: $FLAG_CAR_MESSAGE_8BALL = 0
0004: $FLAG_BRAKE_MESSAGE = 0
0004: $FLAG_HBRAKE_MESSAGE = 0
//0004: $FLAG_LOOK2_8BALL = 0    -not used
//0004: $FLAG_LOOK3_8BALL = 0    -not used
0004: $FLAG_MISTY_STOP = 0
0004: $FLAG_PLAYER_HAD_CAMERA_MESSAGE_8BALL = 0
0004: $FLAG_GIRL_IN_GROUP_LM1 = 0
0004: $FLAG_TIMER_STOPPED_FLASHING_8BALL = 0
if
    0038:   $FLAG_REACHED_HIDEOUT == 0
then
    0247: request_model #KURUMA
    023C: load_special_actor 1 'EIGHT'
    038B: load_all_models_now
    0005: $EIGHT_CAR_X_COORD = 0.0
    0005: $EIGHT_CAR_Y_COORD = 0.0
    0005: $EIGHT_CAR_Z_COORD = 0.0
    0005: $EIGHT_CAR_ANGLE = 0.0
    0004: $EIGHT_CAR_PRIM_COLOR = 0
    0004: $EIGHT_CAR_SEC_COLOR = 0
else
    jump @HIDEOUT_REACHED
end
while true
    if or
        823D:   NOT   special_actor 1 loaded
        8248:   NOT   model #KURUMA available
    jf break
    wait 0 ms
end
if
    0038:   $BROKEN_BRIDGE_OBJECTS_INITIALIZED == 0
then
    029B: $BROKEN_BRIDGE_REMAINS = init_object #BRIDGEFUKA at 380.688 -937.875 46.1875
    01C7: remove_object_from_mission_cleanup_list $BROKEN_BRIDGE_REMAINS
    029B: $BROKEN_BRIDGE_POLICE_CARS = init_object #BRIDGEFUKB at 452.812 -939.188 44.9375
    01C7: remove_object_from_mission_cleanup_list $BROKEN_BRIDGE_POLICE_CARS
    0004: $BROKEN_BRIDGE_OBJECTS_INITIALIZED = 1
end
0352: set_actor $SCRIPT_CONTROLLED_PLAYER skin_to 'PLAYERP'
while 8248:   NOT   model #NULL available
    wait 0 ms
end
0353: refresh_actor $SCRIPT_CONTROLLED_PLAYER
0171: set_player $PLAYER z_angle_to 180.0
if
    82BD:   NOT   debug_mode == DEBUG_MASTERDEBUG
then
    00A5: $EIGHT_CAR = create_car #KURUMA at 477.0 -945.5 41.75
    0229: set_car $EIGHT_CAR color_to 58 1
else
    0247: request_model #DELODRV
    while 8248:   NOT   model #DELODRV available
        wait 0 ms
    end
    00A5: $EIGHT_CAR = create_car #DELODRV at 477.0 -945.5 41.75
    02AC: set_car $EIGHT_CAR immunities 1 1 1 1 1
end
0175: set_car $EIGHT_CAR z_angle_to 262.375
009A: $8BALL_CHAR = create_actor 21 #SPECIAL01 at 476.875 -942.438 41.75
0245: set_actor $8BALL_CHAR walk_style_to  30
01ED: reset_actor $8BALL_CHAR flags
01BE: set_actor $8BALL_CHAR to_look_at_spot 476.875 -939.938 41.75
022D: set_actor $8BALL_CHAR to_look_at_player $PLAYER
016E: override_restart at 476.875 -939.938 41.75 180.0
0177: set_object $PORTLAND_HIDEOUT_DOOR z_angle_to 0.0
02A3: toggle_widescreen 1 (on)
01B4: set_player $PLAYER can_move 0 (frozen)
02A2: create_particle 4 at 456.625 -936.875 44.3125 0
02A2: create_particle 4 at 453.3125 -938.4375 44.0625 0
02A2: create_particle 4 at 451.4375 -942.375 45.75 0
02A2: create_particle 10 at 448.5625 -938.5 44.4375 0
02A2: create_particle 10 at 455.5 -935.625 44.0 0
02A2: create_particle 10 at 454.25 -938.875 44.125 0
018E: stop_sound $FIRE_SOUND_8BALL
018D: $FIRE_SOUND_8BALL = create_sound 102 at 455.5 -935.625 44.0
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
015F: set_camera_position 450.0 -936.75 45.75 0.0 0.0 0.0
0159: camera_on_ped $8BALL_CHAR 15 2
03CF: load_wav 'LIB_A1' as 1
0169: set_fade_color 0 0 0
016A: fade 1 (out)  1000 ms
while fading
    wait 0 ms
end
0169: set_fade_color 0 0 0
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
end
wait 2000 ms
if
    0118:   actor $8BALL_CHAR dead
then
    00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
    jump @MISSION_EIGHTBALL_FAILED
end
if
    0119:   car $EIGHT_CAR wrecked
then
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    else
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_EIGHTBALL_FAILED
    end
else
    if and
        01F4:   car $EIGHT_CAR flipped
        01C1:   car $EIGHT_CAR stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
015F: set_camera_position 469.562 -933.0 45.9375 0.0 0.0 0.0
0160: point_camera 470.188 -933.688 45.5625 2
00BA: text_styled 'EBAL' 5000 ms 2   // 'GIVE ME LIBERTY'
03D1: play_wav 1
00BC: print_now 'EBAL_A' 5000 ms 1   // I know a place on the edge of the Red Light District where we can lay low,
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
end
03D5: remove_text 'EBAL_A'   // I know a place on the edge of the Red Light District where we can lay low,
040D: unload_wav 1
03CF: load_wav 'LIB_A2' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
end
03D1: play_wav 1
00BC: print_now 'EBAL_A1' 5000 ms 1   // but my hands are all messed up so you better drive, brother.
if
    03D2:   wav 1 ended
then
    03D5: remove_text 'EBAL_A1'   // but my hands are all messed up so you better drive, brother.
end
if
    0118:   actor $8BALL_CHAR dead
then
    00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
    jump @MISSION_EIGHTBALL_FAILED
end
if
    0119:   car $EIGHT_CAR wrecked
then
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    else
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_EIGHTBALL_FAILED
    end
else
    if and
        01F4:   car $EIGHT_CAR flipped
        01C1:   car $EIGHT_CAR stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
022F: set_actor $8BALL_CHAR stop_looking
039E: set_char_cant_be_dragged_out $8BALL_CHAR 0
01D4: actor $8BALL_CHAR go_to_car $EIGHT_CAR and_enter_it_as_a_passenger
while 80DB:   NOT   actor $8BALL_CHAR in_car $EIGHT_CAR
    wait 0 ms
    if
        03D2:   wav 1 ended
    then
        03D5: remove_text 'EBAL_A1'   // but my hands are all messed up so you better drive, brother.
    end
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
end
if
    03D2:   wav 1 ended
then
    03D5: remove_text 'EBAL_A1'   // but my hands are all messed up so you better drive, brother.
end
if
    0038:   $FLAG_DONE_RADIO_8BALL == 0
then
    041E: set_radio_station 0 0
    0004: $FLAG_DONE_RADIO_8BALL = 1
else
    041E: set_radio_station 0 -1
end
039E: set_char_cant_be_dragged_out $8BALL_CHAR 1
0526: set_actor_stay_in_car $8BALL_CHAR 1
02A3: toggle_widescreen 0 (off)
015A: restore_camera
0373: set_camera_directly_behind_player
01B4: set_player $PLAYER can_move 1 (unfrozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
0186: $MARKER_ABOVE_EIGHT_CAR = create_marker_above_car $EIGHT_CAR
wait 500 ms
if
    03D2:   wav 1 ended
then
    03D5: remove_text 'EBAL_A1'   // but my hands are all messed up so you better drive, brother.
end
if
    0118:   actor $8BALL_CHAR dead
then
    00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
    jump @MISSION_EIGHTBALL_FAILED
end
if
    0119:   car $EIGHT_CAR wrecked
then
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    else
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_EIGHTBALL_FAILED
    end
else
    if and
        01F4:   car $EIGHT_CAR flipped
        01C1:   car $EIGHT_CAR stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
// gives the player the help message for entering cars
// Code optimized and made compatible with GInput
0293: $CONTROLMODE = current_controls
if
    8038:   NOT   $CONTROLMODE == 2
then
	03E5: text_box 'EBAL_1'   // Press the~h~ ~k~~VEHICLE_ENTER_EXIT~ button~w~ to ~h~enter ~w~or ~h~exit~w~ a vehicle.
else
    03E5: text_box 'EBAL_1B'   // Press the~h~ ~k~~VEHICLE_ENTER_EXIT~ button~w~ to ~h~enter ~w~or ~h~exit~w~ a vehicle.
end
0006: 17@ = 0
wait 3000 ms
if
    0118:   actor $8BALL_CHAR dead
then
    00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
    jump @MISSION_EIGHTBALL_FAILED
end
if
    0119:   car $EIGHT_CAR wrecked
then
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    else
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_EIGHTBALL_FAILED
    end
else
    if and
        01F4:   car $EIGHT_CAR flipped
        01C1:   car $EIGHT_CAR stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
while true
    if or
        80DC:   NOT   player $PLAYER driving $EIGHT_CAR
        80DB:   NOT   actor $8BALL_CHAR in_car $EIGHT_CAR
    jf break
    wait 0 ms
    if
        001B:   120000 > 17@
    then
        0110: clear_player $PLAYER wanted_level
    end
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
// creates two cops cars that drive onto the bridge
00A5: $GML_POLICE_CAR1 = create_car #POLICE at 748.188 -945.0  19.75
0129: $GML_POLICE_OFFICER1 = create_actor 4 #COP in_car $GML_POLICE_CAR1 driverseat
01ED: reset_actor $GML_POLICE_OFFICER1 flags
0175: set_car $GML_POLICE_CAR1 z_angle_to 90.0
0397: car $GML_POLICE_CAR1 siren = 1 (on)   // never used in VC
00AE: set_car $GML_POLICE_CAR1 driving_style 2  // DRIVINGMODE_AVOIDCARS
00AD: set_car $GML_POLICE_CAR1 max_speed_to 20.0
00A7: car $GML_POLICE_CAR1 drive_to 378.875 -916.688 48.0
00A5: $GML_POLICE_CAR2 = create_car #POLICE at 739.062 -946.6875  19.75
0129: $GML_POLICE_OFFICER2 = create_actor 4 #COP in_car $GML_POLICE_CAR2 driverseat
01ED: reset_actor $GML_POLICE_OFFICER2 flags
0175: set_car $GML_POLICE_CAR2 z_angle_to 90.0
0397: car $GML_POLICE_CAR2 siren = 1 (on)   // never used in VC
00AE: set_car $GML_POLICE_CAR2 driving_style 2  // DRIVINGMODE_AVOIDCARS
00AD: set_car $GML_POLICE_CAR2 max_speed_to 20.0
00A7: car $GML_POLICE_CAR2 drive_to 383.688 -922.188 48.0
0164: remove_blip $MARKER_ABOVE_EIGHT_CAR
// Accelertation help messages
wait 500 ms
if
    001B:   120000 > 17@
then
    0110: clear_player $PLAYER wanted_level
end
if
    0119:   car $EIGHT_CAR wrecked
then
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    else
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_EIGHTBALL_FAILED
    end
else
    if and
        01F4:   car $EIGHT_CAR flipped
        01C1:   car $EIGHT_CAR stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
if
    0118:   actor $8BALL_CHAR dead
then
    00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
    jump @MISSION_EIGHTBALL_FAILED
end
// Code optimized and made compatible with GInput
0293: $CONTROLMODE = current_controls
if
    8038:   NOT   $CONTROLMODE == 3
then
	03E5: text_box 'HELP4_A'   // Press the~h~ ~k~~VEHICLE_ACCELERATE~ button~w~ to ~h~accelerate.
else
    03E5: text_box 'HELP4_D'   // Push the~h~ right analog stick~w~ up to ~h~accelerate.
end
018A: $RADAR_BLIP_COORD1_EIGHTBALL = create_checkpoint_at 540.0 -309.0 14.5
0006: 16@ = 0
0004: $BLOB_FLAG = 1
if
    001B:   120000 > 17@
then
    0110: clear_player $PLAYER wanted_level
end
040D: unload_wav 1
03CF: load_wav 'LIB_A' as 1
0006: 16@ = 0
while 001B:   10000 > 16@
    wait 0 ms
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
        if
            80DC:   NOT   player $PLAYER driving $EIGHT_CAR
        then
            0004: $BLOB_FLAG = 0
            if
                0038:   $FLAG_CAR_MESSAGE_8BALL == 0
            then
                00BC: print_now 'IN_VEH' 5000 ms 1   // ~g~Hey! Get back in the vehicle!
                0164: remove_blip $RADAR_BLIP_COORD1_EIGHTBALL
                0186: $MARKER_ABOVE_EIGHT_CAR = create_marker_above_car $EIGHT_CAR
                0004: $FLAG_CAR_MESSAGE_8BALL = 1
            end
        else
            0004: $BLOB_FLAG = 1
            if
                0038:   $FLAG_CAR_MESSAGE_8BALL == 1
            then
                0164: remove_blip $MARKER_ABOVE_EIGHT_CAR
                018A: $RADAR_BLIP_COORD1_EIGHTBALL = create_checkpoint_at 540.0 -309.0 14.5
                0004: $FLAG_CAR_MESSAGE_8BALL = 0
            end
        end
    end
    if and
        00E5:   player $PLAYER 0 near_point_in_car 540.0 -309.0 radius 20.0 20.0
        00DC:   player $PLAYER driving $EIGHT_CAR
        0038:   $FLAG_HELP_8BALL1 == 0
    then
        03E5: text_box 'HELP1'   // Stop in the center of the blue marker.
        0004: $FLAG_HELP_8BALL1 = 1
    end
end
03E5: text_box 'EBAL_3'   // This is the ~h~radar~w~. Use it to navigate the city, follow the ~h~blip~w~ on the ~h~radar~w~ to find the hideout!
03E7: flash_hud 8
0006: 16@ = 0
// waiting for the player to get to Luigi's
while true
    if or
        81A0:   NOT   player $PLAYER stopped $BLOB_FLAG in_cube_in_car 544.375 -303.375 13.25 535.062 -311.688 16.0  // never used in VC
        81AA:   NOT   actor $8BALL_CHAR stopped 0 in_cube_in_car 544.375 -303.375 13.25 535.062 -311.688 16.0  // never used in VC
        8442:   NOT   player $PLAYER in_car $EIGHT_CAR
        8448:   NOT   actor $8BALL_CHAR in_car $EIGHT_CAR
        83D0:   NOT   wav 1 loaded
    jf break
    wait 0 ms
    if
        001B:   120000 > 17@
    then
        0110: clear_player $PLAYER wanted_level
    end
    if
        0038:   $FLAG_TIMER_STOPPED_FLASHING_8BALL == 0
    then
        if
            0019:   16@ > 4000
        then
            03E7: flash_hud -1
            0004: $FLAG_TIMER_STOPPED_FLASHING_8BALL = 1
        end
    end
    if
        0038:   $FLAG_BRAKE_MESSAGE == 0
    then
        if
            0029:   16@ >= 10000
        then
			// Code optimized and made compatible with GInput
            0293: $CONTROLMODE = current_controls
            if
                8038:   NOT   $CONTROLMODE == 3
            then
                03E5: text_box 'HELP5_A'   // Press the~h~ ~k~~VEHICLE_BRAKE~ button~w~ to ~h~brake~w~, or to ~h~reverse~w~ if the vehicle has stopped.
            else
				03E5: text_box 'HELP5_D'   // Pull the ~h~right analog stick~w~ back to ~h~brake~w~, or to ~h~reverse~w~ if the vehicle has stopped.
			end
            0004: $FLAG_BRAKE_MESSAGE = 1
            0006: 16@ = 0
        end
    end
    if
        0019:   16@ > 10000
    then
        if
            0038:   $FLAG_HBRAKE_MESSAGE == 0
        then
			// Code optimized and made compatible with GInput
            0293: $CONTROLMODE = current_controls
            if
                0038:   $CONTROLMODE == 2
            then
				03E5: text_box 'HELP6_C'   // Press the~h~ ~k~~VEHICLE_HANDBRAKE~ button ~w~to apply the vehicle's ~h~handbrake.
			else
				if
					0038:   $CONTROLMODE == 3
				then
					03E5: text_box 'HELP6_D'   // Press the~h~ ~k~~VEHICLE_HANDBRAKE~ button ~w~to apply the vehicle's ~h~handbrake.
				else
					03E5: text_box 'HELP6_A'   // Press the~h~ ~k~~VEHICLE_HANDBRAKE~ button ~w~to apply the vehicle's ~h~handbrake.
				end
            end
            0004: $FLAG_HBRAKE_MESSAGE = 1
        end
    end
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
        if
            80DC:   NOT   player $PLAYER driving $EIGHT_CAR
        then
            0004: $BLOB_FLAG = 0
            if
                0038:   $FLAG_CAR_MESSAGE_8BALL == 0
            then
                00BC: print_now 'IN_VEH' 5000 ms 1   // ~g~Hey! Get back in the vehicle!
                0164: remove_blip $RADAR_BLIP_COORD1_EIGHTBALL
                0186: $MARKER_ABOVE_EIGHT_CAR = create_marker_above_car $EIGHT_CAR
                0004: $FLAG_CAR_MESSAGE_8BALL = 1
            end
        else
            0004: $BLOB_FLAG = 1
            if
                0038:   $FLAG_CAR_MESSAGE_8BALL == 1
            then
                0164: remove_blip $MARKER_ABOVE_EIGHT_CAR
                018A: $RADAR_BLIP_COORD1_EIGHTBALL = create_checkpoint_at 540.0 -309.0 14.5
                0004: $FLAG_CAR_MESSAGE_8BALL = 0
            end
        end
    end
    if and
        00E5:   player $PLAYER 0 near_point_in_car 540.0 -309.0 radius 20.0 20.0
        00DC:   player $PLAYER driving $EIGHT_CAR
        0038:   $FLAG_HELP_8BALL1 == 0
    then
        03E5: text_box 'HELP1'   // Stop in the center of the blue marker.
        0004: $FLAG_HELP_8BALL1 = 1
    end
end
03E6: remove_text_box
0164: remove_blip $RADAR_BLIP_COORD1_EIGHTBALL
// ******************************Player and 8ball are at base scripted cutscene*************
02A3: toggle_widescreen 1 (on)
0110: clear_player $PLAYER wanted_level
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
01B4: set_player $PLAYER can_move 0 (frozen)
if
    8119:   NOT   car $GML_POLICE_CAR1 wrecked
then
    00A6: destroy_car $GML_POLICE_CAR1
end
if
    8119:   NOT   car $GML_POLICE_CAR2 wrecked
then
    00A6: destroy_car $GML_POLICE_CAR2
end
0395: clear_area 1 at 551.75 -310.062 -100.0 range 2.0
00AA: store_car $EIGHT_CAR position_to $EIGHT_CAR_X_COORD $EIGHT_CAR_Y_COORD $EIGHT_CAR_Z_COORD
0174: $EIGHT_CAR_ANGLE = car $EIGHT_CAR z_angle
03F3: get_car $EIGHT_CAR color $EIGHT_CAR_PRIM_COLOR $EIGHT_CAR_SEC_COLOR

while 834D:   NOT unknown_rotate_object $PORTLAND_HIDEOUT_DOOR angle 210.0 10.0 0
    wait 0 ms
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
0395: clear_area 1 at 554.688 -308.188 14.5625 range 3.0
01F5: $SCRIPT_CONTROLLED_PLAYER = get_player_char $PLAYER
01ED: reset_actor $SCRIPT_CONTROLLED_PLAYER flags
01D3: actor $8BALL_CHAR leave_car $EIGHT_CAR
0519: lock_car $EIGHT_CAR in_position 1
while 00DB:   actor $8BALL_CHAR in_car $EIGHT_CAR
    wait 0 ms
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
end

03D1: play_wav 1
00BC: print_now 'EBAL_B' 7000 ms 1   // This is the place right here, let's get off the street and find a change of clothes!
0239: actor $8BALL_CHAR run_to 557.688 -308.562
if
    03D2:   wav 1 ended
then
    03D5: remove_text 'EBAL_B'   // This is the place right here, let's get off the street and find a change of clothes!
end
wait 1000 ms
if
    03D2:   wav 1 ended
then
    03D5: remove_text 'EBAL_B'   // This is the place right here, let's get off the street and find a change of clothes!
end
if
    0118:   actor $8BALL_CHAR dead
then
    00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
    jump @MISSION_EIGHTBALL_FAILED
end
if
    0119:   car $EIGHT_CAR wrecked
then
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    else
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_EIGHTBALL_FAILED
    end
else
    if and
        01F4:   car $EIGHT_CAR flipped
        01C1:   car $EIGHT_CAR stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
if
    03D2:   wav 1 ended
then
    03D5: remove_text 'EBAL_B'   // This is the place right here, let's get off the street and find a change of clothes!
end
02B9: deactivate_garage $PORTLAND_HIDEOUT_GARAGE
01D3: actor $SCRIPT_CONTROLLED_PLAYER leave_car $EIGHT_CAR
0395: clear_area 1 at 533.625 -311.688 14.25 range 1.0
if
    0339:   objects_in_cube 535.375 -309.875 12.0 530.188 -314.688 18.0 0 1 1 1 1
then
    015F: set_camera_position 513.25 -295.25 25.125 0.0 0.0 0.0
    0160: point_camera 514.062 -295.75 25.125 2
else
    015F: set_camera_position 533.625 -311.688 14.25 0.0 0.0 0.0
    0160: point_camera 534.562 -311.5 14.5 2
end

while 00DB:   actor $SCRIPT_CONTROLLED_PLAYER in_car $EIGHT_CAR
    wait 0 ms
    if
        03D2:   wav 1 ended
    then
        03D5: remove_text 'EBAL_B'   // This is the place right here, let's get off the street and find a change of clothes!
    end
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
end
0239: actor $SCRIPT_CONTROLLED_PLAYER run_to 557.375 -308.5
0006: 17@ = 0

while true
    if or
        8038:   NOT   $FLAG_PLAYER_IN_AREA == 2
        8038:   NOT   $FLAG_EIGHTBALL_IN_AREA == 2
    jf break
    wait 0 ms
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        0038:   $FLAG_PLAYER_IN_AREA == 0
    then
        if
            00ED:   actor $SCRIPT_CONTROLLED_PLAYER 0 near_point_on_foot 557.375 -308.5 radius 0.5 0.5
        then
            0239: actor $SCRIPT_CONTROLLED_PLAYER run_to 557.375 -305.562
            0004: $FLAG_PLAYER_IN_AREA = 1
        end
    end
    if
        0038:   $FLAG_EIGHTBALL_IN_AREA == 0
    then
        if
            00ED:   actor $8BALL_CHAR 0 near_point_on_foot 557.688 -308.562 radius 0.5 0.5
        then
            0239: actor $8BALL_CHAR run_to 559.188 -304.25
            0004: $FLAG_EIGHTBALL_IN_AREA = 1
        end
    end
    if
        0038:   $FLAG_PLAYER_IN_AREA == 1
    then
        if
            00ED:   actor $SCRIPT_CONTROLLED_PLAYER 0 near_point_on_foot 557.375 -305.562 radius 0.5 0.5
        then
            0004: $FLAG_PLAYER_IN_AREA = 2
        end
    end
    if
        0038:   $FLAG_EIGHTBALL_IN_AREA == 1
    then
        if
            00ED:   actor $8BALL_CHAR 0 near_point_on_foot 559.188 -304.25 radius 0.5 0.5
        then
            0004: $FLAG_EIGHTBALL_IN_AREA = 2
        end
    end
    if
        0029:   17@ >= 10000
    then
        if or
            8038:   NOT   $FLAG_PLAYER_IN_AREA == 2
            8038:   NOT   $FLAG_EIGHTBALL_IN_AREA == 2
        then
            0055: set_player_coordinates $PLAYER at 557.375 -305.562 13.6875
            009F: set_actor $SCRIPT_CONTROLLED_PLAYER idle
            00A1: put_actor $8BALL_CHAR at 559.188 -304.25 13.6875
            009F: set_actor $8BALL_CHAR idle
        end
    end
end
015F: set_camera_position 551.75 -310.062 15.875 0.0 0.0 0.0
0160: point_camera 552.688 -309.75 15.75 2
009F: set_actor $8BALL_CHAR idle
011C: actor $SCRIPT_CONTROLLED_PLAYER clear_objective
03E5: text_box 'S_PROMP'                       // When not on a mission you can ~h~save your game here~w~, this will advance time six hours.
wait 4000 ms
if
    0119:   car $EIGHT_CAR wrecked
then
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    else
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_EIGHTBALL_FAILED
    end
else
    if and
        01F4:   car $EIGHT_CAR flipped
        01C1:   car $EIGHT_CAR stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
if
    0118:   actor $8BALL_CHAR dead
then
    00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
    jump @MISSION_EIGHTBALL_FAILED
end
0299: activate_garage $PORTLAND_HIDEOUT_GARAGE
03E5: text_box 'S_PROM2' // The garage next door can store one vehicle when you save your game.
0160: point_camera 552.75 -310.5 15.6875 2
0055: set_player_coordinates $PLAYER at 560.875 -311.375 13.6875
00A1: put_actor $8BALL_CHAR at 549.25 -309.188 13.5625
// Clothes change
//8-BAll change
if
    8118:   NOT   actor $8BALL_CHAR dead
then
    0352: set_actor $8BALL_CHAR skin_to 'EIGHT2'
    while 8248:   NOT   model #SPECIAL01 available
        wait 0 ms
        if
            0119:   car $EIGHT_CAR wrecked
        then
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        else
            if and
                01F4:   car $EIGHT_CAR flipped
                01C1:   car $EIGHT_CAR stopped
            then
                00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
                jump @MISSION_EIGHTBALL_FAILED
            end
        end
    end
    if
        8118:   NOT   actor $8BALL_CHAR dead
    then
        0353: refresh_actor $8BALL_CHAR
    end
end
//Player change
if
    8118:   NOT   actor $SCRIPT_CONTROLLED_PLAYER dead
then
    0352: set_actor $SCRIPT_CONTROLLED_PLAYER skin_to 'PLAYER'
    while 8248:   NOT   model #NULL available
        wait 0 ms
        if
            0119:   car $EIGHT_CAR wrecked
        then
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        else
            if and
                01F4:   car $EIGHT_CAR flipped
                01C1:   car $EIGHT_CAR stopped
            then
                00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
                jump @MISSION_EIGHTBALL_FAILED
            end
        end
    end
    if
        8118:   NOT   actor $SCRIPT_CONTROLLED_PLAYER dead
    then
        0353: refresh_actor $SCRIPT_CONTROLLED_PLAYER
    end
end
wait 3000 ms
if
    0119:   car $EIGHT_CAR wrecked
then
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    else
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_EIGHTBALL_FAILED
    end
else
    if and
        01F4:   car $EIGHT_CAR flipped
        01C1:   car $EIGHT_CAR stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
if
    0118:   actor $8BALL_CHAR dead
then
    00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
    jump @MISSION_EIGHTBALL_FAILED
end
0055: set_player_coordinates $PLAYER at 548.5 -308.188 13.5625
01B7: release_weather
01D4: actor $8BALL_CHAR go_to_car $EIGHT_CAR and_enter_it_as_a_passenger
wait 1500 ms
if
    0118:   actor $8BALL_CHAR dead
then
    00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
    jump @MISSION_EIGHTBALL_FAILED
end
if
    0119:   car $EIGHT_CAR wrecked
then
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    else
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_EIGHTBALL_FAILED
    end
else
    if and
        01F4:   car $EIGHT_CAR flipped
        01C1:   car $EIGHT_CAR stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
01D5: actor $SCRIPT_CONTROLLED_PLAYER go_to_and_drive_car $EIGHT_CAR
0395: clear_area 1 at 533.625 -311.688 14.25 range 1.0
if
    0339:   objects_in_cube 535.375 -309.875 12.0 540.188 -314.688 18.0 0 1 1 1 1
then
    015F: set_camera_position 513.25 -295.25 25.125 0.0 0.0 0.0
    0160: point_camera 514.062 -295.75 25.125 2
else
    015F: set_camera_position 533.625 -311.688 14.25 0.0 0.0 0.0
    0160: point_camera 534.562 -311.5 14.5 2
end
03E6: remove_text_box

while true
    if or
        80DC:   NOT   player $PLAYER driving $EIGHT_CAR
        80DB:   NOT   actor $8BALL_CHAR in_car $EIGHT_CAR
    jf break
    wait 0 ms
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
while 834D:   NOT unknown_rotate_object $PORTLAND_HIDEOUT_DOOR angle 0.0 10.0 0
    wait 0 ms
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
02EB: restore_camera_jumpcut
03C8: set_camera_in_front_of_player
02A3: toggle_widescreen 0 (off)
01B4: set_player $PLAYER can_move 1 (unfrozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
0519: lock_car $EIGHT_CAR in_position 0
0004: $BLOB_FLAG = 1
// *************Restart function for 8ball and the player at players hideout***************
:HIDEOUT_REACHED
if
    0038:   $FLAG_REACHED_HIDEOUT == 1
then
    02A3: toggle_widescreen 1 (on)
    01B4: set_player $PLAYER can_move 0 (frozen)
    01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
    0171: set_player $PLAYER z_angle_to 90.0
    0395: clear_area 1 at 533.625 -311.688 14.25 range 1.0
    if
        0339:   objects_in_cube 535.375 -309.875 12.0 530.188 -314.688 18.0 0 1 1 1 1
    then
        015F: set_camera_position 513.25 -295.25 25.125 0.0 0.0 0.0
        0160: point_camera 514.062 -295.75 25.125 2
    else
        015F: set_camera_position 533.625 -311.688 14.25 0.0 0.0 0.0
        0160: point_camera 534.562 -311.5 14.5 2
    end
    0177: set_object $PORTLAND_HIDEOUT_DOOR z_angle_to 0.0
    023C: load_special_actor 1 'EIGHT2'
    0247: request_model #KURUMA
    038B: load_all_models_now
    while true
        if or
            823D:   NOT   special_actor 1 loaded
            8248:   NOT   model #KURUMA available
        jf break
        wait 0 ms
    end
    01B7: release_weather
    00A5: $EIGHT_CAR = create_car #KURUMA at $EIGHT_CAR_X_COORD $EIGHT_CAR_Y_COORD $EIGHT_CAR_Z_COORD
    0175: set_car $EIGHT_CAR z_angle_to $EIGHT_CAR_ANGLE
    0229: set_car $EIGHT_CAR color_to $EIGHT_CAR_PRIM_COLOR $EIGHT_CAR_SEC_COLOR
    01D5: actor $SCRIPT_CONTROLLED_PLAYER go_to_and_drive_car $EIGHT_CAR
    009A: $8BALL_CHAR = create_actor 21 #SPECIAL01 at 549.25 -309.188 13.5625
    0245: set_actor $8BALL_CHAR walk_style_to  30
    0173: set_actor $8BALL_CHAR z_angle_to 90.0
    01ED: reset_actor $8BALL_CHAR flags
    0239: actor $8BALL_CHAR run_to 549.25 -309.188  //activate running animation
    01D4: actor $8BALL_CHAR go_to_car $EIGHT_CAR and_enter_it_as_a_passenger
    while true
        if or
            80DC:   NOT   player $PLAYER driving $EIGHT_CAR
            80DB:   NOT   actor $8BALL_CHAR in_car $EIGHT_CAR
        jf break
        wait 0 ms
        if
            0119:   car $EIGHT_CAR wrecked
        then
            if
                0118:   actor $8BALL_CHAR dead
            then
                00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
                jump @MISSION_EIGHTBALL_FAILED
            else
                00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
                jump @MISSION_EIGHTBALL_FAILED
            end
        else
            if and
                01F4:   car $EIGHT_CAR flipped
                01C1:   car $EIGHT_CAR stopped
            then
                00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
                jump @MISSION_EIGHTBALL_FAILED
            end
        end
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
    039E: set_char_cant_be_dragged_out $8BALL_CHAR 1
    02EB: restore_camera_jumpcut
    03C8: set_camera_in_front_of_player
    02A3: toggle_widescreen 0 (off)
    01B4: set_player $PLAYER can_move 1 (unfrozen)
    01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
end
// **************************************end of the restart stuff***************************
if
    0038:   $FLAG_REACHED_HIDEOUT == 0
then
    03AE: remove_objects_from_cube 469.0 -948.0 36.0 430.125 -924.312 56.0
    018E: stop_sound $FIRE_SOUND_8BALL
    0108: destroy_object $BROKEN_BRIDGE_REMAINS
    0108: destroy_object $BROKEN_BRIDGE_POLICE_CARS
    03B6: replace_model_at 692.25 -933.75 21.0 radius 50.0 from #LOD_LAND014 to #INDHELIX_BARRIER
    0363: toggle_model_render_at 692.25 -933.75 21.0 radius 50.0 object #INDHELIX_BARRIER 1
end
0004: $FLAG_REACHED_HIDEOUT = 1
016E: override_restart at 548.5 -308.188 13.5625 90.0
if
    0118:   actor $8BALL_CHAR dead
then
    00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
    jump @MISSION_EIGHTBALL_FAILED
end
018A: $GML_LUIGI_CHECKPOINT = create_checkpoint_at 571.188 -426.0 -100.0
040D: unload_wav 1
03CF: load_wav 'LIB_B' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
        if
            80DC:   NOT   player $PLAYER driving $EIGHT_CAR
        then
            0004: $BLOB_FLAG = 0
            if
                0038:   $FLAG_CAR_MESSAGE_8BALL == 0
            then
                00BC: print_now 'IN_VEH' 5000 ms 1   // ~g~Hey! Get back in the vehicle!
                0164: remove_blip $GML_LUIGI_CHECKPOINT
                0186: $MARKER_ABOVE_EIGHT_CAR = create_marker_above_car $EIGHT_CAR
                0004: $FLAG_CAR_MESSAGE_8BALL = 1
            end
        else
            0004: $BLOB_FLAG = 1
            if
                0038:   $FLAG_CAR_MESSAGE_8BALL == 1
            then
                0164: remove_blip $MARKER_ABOVE_EIGHT_CAR
                018A: $GML_LUIGI_CHECKPOINT = create_checkpoint_at 571.188 -426.0 -100.0
                0004: $FLAG_CAR_MESSAGE_8BALL = 0
            end
        end
    end
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
03D1: play_wav 1
00BC: print_now 'EBAL_D' 5000 ms 1   // I know a guy, he's connected, his name's Luigi.
wait 2000 ms
if
    0119:   car $EIGHT_CAR wrecked
then
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    else
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_EIGHTBALL_FAILED
    end
else
    if and
        01F4:   car $EIGHT_CAR flipped
        01C1:   car $EIGHT_CAR stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        80DC:   NOT   player $PLAYER driving $EIGHT_CAR
    then
        0004: $BLOB_FLAG = 0
        if
            0038:   $FLAG_CAR_MESSAGE_8BALL == 0
        then
            00BC: print_now 'IN_VEH' 5000 ms 1   // ~g~Hey! Get back in the vehicle!
            0164: remove_blip $GML_LUIGI_CHECKPOINT
            0186: $MARKER_ABOVE_EIGHT_CAR = create_marker_above_car $EIGHT_CAR
            0004: $FLAG_CAR_MESSAGE_8BALL = 1
        end
    else
        0004: $BLOB_FLAG = 1
        if
            0038:   $FLAG_CAR_MESSAGE_8BALL == 1
        then
            0164: remove_blip $MARKER_ABOVE_EIGHT_CAR
            018A: $GML_LUIGI_CHECKPOINT = create_checkpoint_at 571.188 -426.0 -100.0
            0004: $FLAG_CAR_MESSAGE_8BALL = 0
        end
    end
end
if
    0118:   actor $8BALL_CHAR dead
then
    00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
    jump @MISSION_EIGHTBALL_FAILED
end
00BC: print_now 'EBAL_D1' 7000 ms 1   // Me an' him go back so I could probably get you some work. C'mon lets head over there.
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
        if
            80DC:   NOT   player $PLAYER driving $EIGHT_CAR
        then
            0004: $BLOB_FLAG = 0
            if
                0038:   $FLAG_CAR_MESSAGE_8BALL == 0
            then
                00BC: print_now 'IN_VEH' 5000 ms 1   // ~g~Hey! Get back in the vehicle!
                0164: remove_blip $GML_LUIGI_CHECKPOINT
                0186: $MARKER_ABOVE_EIGHT_CAR = create_marker_above_car $EIGHT_CAR
                0004: $FLAG_CAR_MESSAGE_8BALL = 1
            end
        else
            0004: $BLOB_FLAG = 1
            if
                0038:   $FLAG_CAR_MESSAGE_8BALL == 1
            then
                0164: remove_blip $MARKER_ABOVE_EIGHT_CAR
                018A: $GML_LUIGI_CHECKPOINT = create_checkpoint_at 571.188 -426.0 -100.0
                0004: $FLAG_CAR_MESSAGE_8BALL = 0
            end
        end
    end
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
03D5: remove_text 'EBAL_D'   // I know a guy, he's connected, his name's Luigi.
03D5: remove_text 'EBAL_D1'   // Me an' him go back so I could probably get you some work. C'mon lets head over there.
040D: unload_wav 1
03CF: load_wav 'LIB_C' as 1

while true
    if or
        81A0:   NOT   player $PLAYER stopped $BLOB_FLAG in_cube_in_car 568.75 -420.188 20.0 573.25 -431.062 24.0  // never used in VC
        81AA:   NOT   actor $8BALL_CHAR stopped 0 in_cube_in_car 568.75 -420.188 20.0 573.25 -431.062 24.0  // never used in VC
        80DC:   NOT   player $PLAYER driving $EIGHT_CAR
        80DB:   NOT   actor $8BALL_CHAR in_car $EIGHT_CAR
        83D0:   NOT   wav 1 loaded
    jf break
    wait 0 ms
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
        if
            80DC:   NOT   player $PLAYER driving $EIGHT_CAR
        then
            0004: $BLOB_FLAG = 0
            if
                0038:   $FLAG_CAR_MESSAGE_8BALL == 0
            then
                00BC: print_now 'IN_VEH' 5000 ms 1   // ~g~Hey! Get back in the vehicle!
                0164: remove_blip $GML_LUIGI_CHECKPOINT
                0186: $MARKER_ABOVE_EIGHT_CAR = create_marker_above_car $EIGHT_CAR
                0004: $FLAG_CAR_MESSAGE_8BALL = 1
            end
        else
            0004: $BLOB_FLAG = 1
            if
                0038:   $FLAG_CAR_MESSAGE_8BALL == 1
            then
                0164: remove_blip $MARKER_ABOVE_EIGHT_CAR
                018A: $GML_LUIGI_CHECKPOINT = create_checkpoint_at 571.188 -426.0 -100.0
                0004: $FLAG_CAR_MESSAGE_8BALL = 0
            end
        end
    end
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if and
        00E5:   player $PLAYER 0 near_point_in_car 567.75 -425.562 radius 15.0 15.0
        00DC:   player $PLAYER driving $EIGHT_CAR
        0038:   $FLAG_HELP_8BALL2 == 0
    then
        03E5: text_box 'HELP1'   // Stop in the center of the blue marker.
        0004: $FLAG_HELP_8BALL2 = 1
    end
end
03E6: remove_text_box
0164: remove_blip $GML_LUIGI_CHECKPOINT
02A3: toggle_widescreen 1 (on)
0110: clear_player $PLAYER wanted_level
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
01B4: set_player $PLAYER can_move 0 (frozen)
0395: clear_area 1 at 552.375 -417.25 19.875 range 10.0
01F5: $SCRIPT_CONTROLLED_PLAYER = get_player_char $PLAYER
01ED: reset_actor $SCRIPT_CONTROLLED_PLAYER flags
01D3: actor $SCRIPT_CONTROLLED_PLAYER leave_car $EIGHT_CAR
01D3: actor $8BALL_CHAR leave_car $EIGHT_CAR
03D1: play_wav 1
00BC: print_now 'EBAL_G' 7000 ms 1   // This is Luigi's club. Let's go round the back and use the service door.
while 00DB:   actor $SCRIPT_CONTROLLED_PLAYER in_car $EIGHT_CAR
    wait 0 ms
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
    if
        03D2:   wav 1 ended
    then
        03D5: remove_text 'EBAL_G'   // This is Luigi's club. Let's go round the back and use the service door.
    end
end
if
    0118:   actor $8BALL_CHAR dead
then
    00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
    jump @MISSION_EIGHTBALL_FAILED
end
while 00DB:   actor $8BALL_CHAR in_car $EIGHT_CAR
    wait 0 ms
    if
        0119:   car $EIGHT_CAR wrecked
    then
        if
            0118:   actor $8BALL_CHAR dead
        then
            00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    else
        if and
            01F4:   car $EIGHT_CAR flipped
            01C1:   car $EIGHT_CAR stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        03D2:   wav 1 ended
    then
        03D5: remove_text 'EBAL_G'   // This is Luigi's club. Let's go round the back and use the service door.
    end
end
01C3: remove_references_to_car $EIGHT_CAR
0211: actor $SCRIPT_CONTROLLED_PLAYER walk_to 562.062 -426.25
0211: actor $8BALL_CHAR walk_to 562.25 -424.562
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
03D5: remove_text 'EBAL_G'   // This is Luigi's club. Let's go round the back and use the service door.
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
039E: set_char_cant_be_dragged_out $8BALL_CHAR 0
03E6: remove_text_box
01BD: $PRE_CUTSCENE_START_TIME = current_time_in_ms
0004: $PRE_CUTSCENE_ELAPSED_TIME = 0

while true
    if and
        83EE:   NOT   player $PLAYER controllable
        001A:   5000 > $PRE_CUTSCENE_ELAPSED_TIME
    jf break
    wait 0 ms
    if
        0118:   actor $8BALL_CHAR dead
    then
        00BC: print_now 'EBAL_4' 5000 ms 1   // ~r~8-Ball's dead!
        jump @MISSION_EIGHTBALL_FAILED
    end
    01BD: $PRE_CUTSCENE_CURRENT_TIME = current_time_in_ms
    0084: $PRE_CUTSCENE_ELAPSED_TIME = $PRE_CUTSCENE_CURRENT_TIME
    0060: $PRE_CUTSCENE_ELAPSED_TIME -= $PRE_CUTSCENE_START_TIME
end
03EF: player $PLAYER make_safe
0169: set_fade_color 0 0 0
016A: fade 0 (in)  1500 ms
03AF: set_streaming 0 (disabled)
00BA: text_styled 'LM1' 5000 ms 2   // 'LUIGI'S GIRLS'
0247: request_model #INDHIBUILD3
0247: request_model #LUIGIINEERCLUB
0247: request_model #LUIGIINEERCLUB
023C: load_special_actor 2 'MICKY'
023C: load_special_actor 3 'LUIGI'
02F3: load_object #CUTOBJ01 'LUDOOR'
02F3: load_object #CUTOBJ02 'MICKYH'
02F3: load_object #CUTOBJ03 'EIGHTH'
02F3: load_object #CUTOBJ04 'LUIGIH'
02F3: load_object #CUTOBJ05 'PLAYERH'
while fading
    wait 0 ms
end
038B: load_all_models_now
03DE: set_pedestrians_density_multiplier_to 0.0
042B: clear_peds_from_cube 941.5 -471.688 7.0 845.75 -257.938 31.0
if
    8118:   NOT   actor $8BALL_CHAR dead
then
    0192: set_actor $8BALL_CHAR objective_to_stand_still
end
0192: set_actor $SCRIPT_CONTROLLED_PLAYER objective_to_stand_still
while true
    if or
        823D:   NOT   special_actor 2 loaded
        823D:   NOT   special_actor 3 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
    jf break
    wait 0 ms
end
while true
    if or
        8248:   NOT   model #CUTOBJ03 available
        8248:   NOT   model #CUTOBJ04 available
        8248:   NOT   model #CUTOBJ05 available
        8248:   NOT   model #INDHIBUILD3  available
        8248:   NOT   model #LUIGIINEERCLUB available
        8248:   NOT   model #LUIGIINEERCLUB available
    jf break
    wait 0 ms
end
009B: destroy_actor_instantly $8BALL_CHAR
0363: toggle_model_render_at 555.875 -416.875 21.0 radius 6.0 object #BACKDOOR 0
02E4: load_cutscene_data 'L1_LG'
0244: set_cutscene_pos 565.75 -427.5 19.8125
02E5: $CUTSCENE_PLAYER = create_cutscene_object #NULL
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_MICKY = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_MICKY 'MICKY'
02E5: $CUTSCENE_EIGHT = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_EIGHT 'EIGHT2'
02E5: $CUTSCENE_LUIGI = create_cutscene_object #SPECIAL03
02E6: set_cutscene_anim $CUTSCENE_LUIGI 'LUIGI'
//02F4: create_cutscene_actor $MICKY_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_MICKY
//02F5: set_head_anim $MICKY_CSHEAD 'MICKY'
//02F4: create_cutscene_actor $EIGHT_CSHEAD _from_head #CUTOBJ03 _and_body $CUTSCENE_EIGHT
//02F5: set_head_anim $EIGHT_CSHEAD 'EIGHT'
//02F4: create_cutscene_actor $LUIGI_CSHEAD _from_head #CUTOBJ04 _and_body $CUTSCENE_LUIGI
//02F5: set_head_anim $LUIGI_CSHEAD 'LUIGI'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ05 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
02E5: $CS_LUDOOR = create_cutscene_object #CUTOBJ01
02E6: set_cutscene_anim $CS_LUDOOR 'LUDOOR'
0395: clear_area 1 at 561.562 -426.188 19.875 range 1.0
0055: set_player_coordinates $PLAYER at 561.562 -426.188 19.875
0171: set_player $PLAYER z_angle_to 270.0
0006: 16@ = 0
while 001B:   3500 > 16@
    wait 0 ms
end
016A: fade 1 (back)  1500 ms
0395: clear_area 1 at 552.375 -417.25 19.875 range 10.0
0395: clear_area 1 at 557.75 -425.5 19.875 range 3.0
0395: clear_area 1 at 561.25 -425.562 19.75 range 3.0
0395: clear_area 1 at 564.688 -425.688 20.0 range 0.5
03AD: set_rubbish 0 (invisible)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
0336: set_player_visible $PLAYER 0
while 001A:   11165 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'EBAL_H' 10000 ms 1   // Wait here man while I go in and talk to Luigi.
while 001A:   13416 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
03D5: remove_text 'EBAL_H'   // Wait here man while I go in and talk to Luigi.
while 001A:   30834 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'EBAL_J' 10000 ms 1   // 8-Ball's got some business up stairs.
while 001A:   33186 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'EBAL_K' 10000 ms 1   // Maybe you can do me a favor.
while 001A:   35235 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'EBAL_L' 10000 ms 1   // One of my girls needs a ride so grab a car and pick up Misty from the clinic. Then bring her back here.
while 001A:   41551 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'EBAL_M' 10000 ms 1   // Remember no one messes with my girls!
while 001A:   45634 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'EBAL_N' 10000 ms 1   // So keep your hands on the wheel!
while 001A:   47560 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'EBAL_O' 10000 ms 1   // If you don't mess this up maybe there be more work for you. Now get outta here!
while 001A:   51911 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
03D5: remove_text 'EBAL_O'   // If you don't mess this up maybe there be more work for you. Now get outta here!
while 001A:   52500 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
0373: set_camera_directly_behind_player
wait 500 ms
03AF: set_streaming 1 (enabled)
016A: fade 1 (out)  1500 ms
03AD: set_rubbish 1 (visible)
03CB: set_camera 585.25 -425.375 21.0
0363: toggle_model_render_at 555.875 -416.875 21.0 radius 6.0 object #BACKDOOR 1
0296: unload_special_actor 1
0296: unload_special_actor 2
0296: unload_special_actor 3
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CUTOBJ03
0249: mark_model_as_no_longer_needed #CUTOBJ04
0249: mark_model_as_no_longer_needed #CUTOBJ05
0249: mark_model_as_no_longer_needed #INDHIBUILD3
0249: mark_model_as_no_longer_needed #LUIGICLUBOUT
0249: mark_model_as_no_longer_needed #LUIGIINEERCLUB
01B4: set_player $PLAYER can_move 1 (unfrozen)
03DE: set_pedestrians_density_multiplier_to 1.0
// *****************************************END OF CUTSCENE*********************************
// *****************************************LUIGI'S GIRLS***********************************
023C: load_special_actor 2 'MISTY'
00BC: print_now 'EBAL_5' 5000 ms 1   // ~g~Get a vehicle!

while 823D:   NOT   special_actor 2 loaded
    wait 0 ms
end
009A: $MISTY_CHAR = create_actor 21 #SPECIAL02 at 809.56 -592.75 19.875
01ED: reset_actor $MISTY_CHAR flags
0173: set_actor $MISTY_CHAR z_angle_to 90.0
0245: set_actor $MISTY_CHAR walk_style_to  43
0187: $MISTY_CAR_MARKER = create_marker_above_actor $MISTY_CHAR
0004: $FLAG_BLIP_ON_GIRL1_LM1 = 1
040D: unload_wav 1
03CF: load_wav 'LIB_D' as 1
while true
    if or
        80E0:   NOT   player $PLAYER driving
        83D0:   NOT   wav 1 loaded
    jf break
    wait 0 ms
    if
        0118:   actor $MISTY_CHAR dead
    then
        00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
        jump @MISSION_EIGHTBALL_FAILED
    end
    if
        00E0:   player $PLAYER driving
    then
        00DA: $MISTY_CAR = player $PLAYER car
    end
end
// Code optimized and made compatible with GInput
03E6: remove_text_box
0293: $CONTROLMODE = current_controls
if
    0038:   $CONTROLMODE == 0
then
    03E5: text_box 'RADIO_A'   // Press the ~h~~k~~VEHICLE_CHANGE_RADIO_STATION~ button~w~ to cycle through the ~h~radio stations.
end
if
    0038:   $CONTROLMODE == 1
then
    03E5: text_box 'RADIO_B'   // Press the ~h~~k~~VEHICLE_CHANGE_RADIO_STATION~ button~w~ to cycle through the ~h~radio stations.
end
if
    0038:   $CONTROLMODE == 2
then
    03E5: text_box 'RADIO_C'   // Press the ~h~~k~~VEHICLE_CHANGE_RADIO_STATION~ button~w~ to cycle through the ~h~radio stations.
end
if
    0038:   $CONTROLMODE == 3
then
    03E5: text_box 'RADIO_D'   // Press the ~h~~k~~VEHICLE_CHANGE_RADIO_STATION~ button~w~ to cycle through the ~h~radio stations.
end
if
    0038:   $CONTROLMODE == 4
then
	// New text for GInput
    03E5: text_box 'RADIO_E'   // Use  ~<~  and  ~>~  to cycle through the ~h~radio stations.
end
00BC: print_now 'EBAL_6' 5000 ms 1   // ~g~Pick up Misty!

while 0038:   $FLAG_GIRL1_IN_CAR_LM1 == 0
    wait 0 ms
    if
        0038:   $FLAG_GIRL_IN_GROUP_LM1 == 0
    then
        if
            0118:   actor $MISTY_CHAR dead
        then
            00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
            jump @MISSION_EIGHTBALL_FAILED
        end
        if
            0038:   $FLAG_MISTY_STOP == 0
        then
            if
                00EB:   player $PLAYER 0 near_actor_in_car $MISTY_CHAR radius 20.0 20.0
            then
                03E5: text_box 'LM1_7'   // Stop the vehicle next to Misty and allow her to enter it.
                0004: $FLAG_MISTY_STOP = 1
            end
        end
        if
            80E0:   NOT   player $PLAYER driving
        then
            if
                0038:   $FLAG_PLAYER_HAD_VEHICLE_MESSAGE_LM1 == 0
            then
                00BC: print_now 'IN_VEH2' 5000 ms 1   // ~g~You need some wheels for this job!
                if
                    0038:   $FLAG_BLIP_ON_GIRL1_LM1 == 1
                then
                    0164: remove_blip $MISTY_CAR_MARKER
                    0004: $FLAG_BLIP_ON_GIRL1_LM1 = 0
                end
                0004: $FLAG_PLAYER_HAD_VEHICLE_MESSAGE_LM1 = 1
            end
        else
            00DA: $MISTY_CAR = player $PLAYER car
            if
                0038:   $FLAG_PLAYER_HAD_VEHICLE_MESSAGE_LM1 == 1
            then
                00BC: print_now 'EBAL_6' 5000 ms 1   // ~g~Pick up Misty!
                if
                    0038:   $FLAG_BLIP_ON_GIRL1_LM1 == 0
                then
                    0187: $MISTY_CAR_MARKER = create_marker_above_actor $MISTY_CHAR
                    0004: $FLAG_BLIP_ON_GIRL1_LM1 = 1
                end
                0004: $FLAG_PLAYER_HAD_VEHICLE_MESSAGE_LM1 = 0
            end
        end
        if
            00E0:   player $PLAYER driving
        then
            00DA: $MISTY_CAR = player $PLAYER car
            if
                00EB:   player $PLAYER 0 near_actor_in_car $MISTY_CHAR radius 8.0 8.0
            then
                if
                    029F:   player $PLAYER stopped
                then
                    01D4: actor $MISTY_CHAR go_to_car $MISTY_CAR and_enter_it_as_a_passenger

                    while true
                        if or
                            80DB:   NOT   actor $MISTY_CHAR in_car $MISTY_CAR
                            80DC:   NOT   player $PLAYER driving $MISTY_CAR
                        jf break
                        wait 0 ms
                        if
                            0118:   actor $MISTY_CHAR dead
                        then
                            00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
                            jump @MISSION_EIGHTBALL_FAILED
                        end
                        if
                            0119:   car $MISTY_CAR wrecked
                        then
                            if
                                0118:   actor $MISTY_CHAR dead
                            then
                                00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
                                jump @MISSION_EIGHTBALL_FAILED
                            else
                                00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
                                jump @MISSION_EIGHTBALL_FAILED
                            end
                        end
                        if
                            00DB:   actor $MISTY_CHAR in_car $MISTY_CAR
                        then
                            039E: set_char_cant_be_dragged_out $MISTY_CHAR 1
                        end
                        if
                            80DC:   NOT   player $PLAYER driving $MISTY_CAR
                        then
                            if
                                0038:   $FLAG_PLAYER_HAD_VEHICLE_MESSAGE_LM1 == 0
                            then
                                00BC: print_now 'IN_VEH' 5000 ms 1   // ~g~Hey! Get back in the vehicle!
                                if
                                    0038:   $FLAG_BLIP_ON_GIRL1_LM1 == 1
                                then
                                    0164: remove_blip $MISTY_CAR_MARKER
                                    0186: $MISTY_CAR_MARKER2 = create_marker_above_car $MISTY_CAR
                                    0004: $FLAG_BLIP_ON_GIRL1_LM1 = 0
                                end
                                0004: $FLAG_PLAYER_HAD_VEHICLE_MESSAGE_LM1 = 1
                            end
                        else
                            if
                                0038:   $FLAG_PLAYER_HAD_VEHICLE_MESSAGE_LM1 == 1
                            then
                                00BC: print_now 'EBAL_6' 5000 ms 1   // ~g~Pick up Misty!
                                if
                                    0038:   $FLAG_BLIP_ON_GIRL1_LM1 == 0
                                then
                                    0187: $MISTY_CAR_MARKER = create_marker_above_actor $MISTY_CHAR
                                    0164: remove_blip $MISTY_CAR_MARKER2
                                    0004: $FLAG_BLIP_ON_GIRL1_LM1 = 1
                                end
                                0004: $FLAG_PLAYER_HAD_VEHICLE_MESSAGE_LM1 = 0
                            end
                        end
                    end //while
                    0164: remove_blip $MISTY_CAR_MARKER
                    0164: remove_blip $MISTY_CAR_MARKER2
                    0004: $FLAG_BLIP_ON_GIRL1_LM1 = 0
                    0004: $FLAG_GIRL_IN_GROUP_LM1 = 1
                end
            end
        end
    end
    if
        0038:   $FLAG_GIRL_IN_GROUP_LM1 == 1
    then
        if
            0118:   actor $MISTY_CHAR dead
        then
            00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
            jump @MISSION_EIGHTBALL_FAILED
        end
        if
            0119:   car $MISTY_CAR wrecked
        then
            if
                0118:   actor $MISTY_CHAR dead
            then
                00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
                jump @MISSION_EIGHTBALL_FAILED
            else
                00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
                jump @MISSION_EIGHTBALL_FAILED
            end
        end
        if
            80DC:   NOT   player $PLAYER driving $MISTY_CAR
        then
            if
                0038:   $FLAG_PLAYER_HAD_CAR_MESSAGE_LM1 == 0
            then
                00BC: print_now 'IN_VEH' 5000 ms 1   // ~g~Hey! Get back in the vehicle!
                0186: $MISTY_CAR_MARKER2 = create_marker_above_car $MISTY_CAR
                0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_LM1 = 1
            end
        end
        if
            00DC:   player $PLAYER driving $MISTY_CAR
        then
            if
                00DB:   actor $MISTY_CHAR in_car $MISTY_CAR
            then
                00BC: print_now 'LM1_9' 10000 ms 1   // Hi I'm Misty.
                03D1: play_wav 1
                039E: set_char_cant_be_dragged_out $MISTY_CHAR 0
                0004: $FLAG_GIRL1_IN_CAR_LM1 = 1
            end
            if
                0038:   $FLAG_PLAYER_HAD_CAR_MESSAGE_LM1 == 1
            then
                0164: remove_blip $MISTY_CAR_MARKER2
                0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_LM1 = 0
            end
        end
    end
end
0164: remove_blip $MISTY_CAR_MARKER
01DF: tie_actor $MISTY_CHAR to_player $PLAYER
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        0118:   actor $MISTY_CHAR dead
    then
        00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
        jump @MISSION_EIGHTBALL_FAILED
    else
        if and
            8320:   NOT   actor $MISTY_CHAR in_range_of_player $PLAYER
            0038:   $FLAG_BLIP_ON_GIRL1_LM1 == 0
        then
            00BC: print_now 'HEY4' 5000 ms 1   // ~g~Lose Misty and Luigi will lose your face! Go and get her!
            0187: $MISTY_CAR_MARKER = create_marker_above_actor $MISTY_CHAR
            0004: $FLAG_BLIP_ON_GIRL1_LM1 = 1
        end
        if and
            00E9:   player $PLAYER 0 near_actor $MISTY_CHAR radius 8.0 8.0
            0038:   $FLAG_BLIP_ON_GIRL1_LM1 == 1
        then
            01DF: tie_actor $MISTY_CHAR to_player $PLAYER
            0164: remove_blip $MISTY_CAR_MARKER
            0004: $FLAG_BLIP_ON_GIRL1_LM1 = 0
        end
    end
    if
        0119:   car $MISTY_CAR wrecked
    then
        if
            0118:   actor $MISTY_CHAR dead
        then
            00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
            jump @MISSION_EIGHTBALL_FAILED
        else
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
end
03D5: remove_text 'LM1_9'   // Hi I'm Misty.
040D: unload_wav 1
00BC: print_now 'LM1_2' 7000 ms 1   // ~g~Take Misty to Luigi's Club.
018A: $LG_CHECKPOINT_TO_LUIGIS = create_checkpoint_at 571.188 -426.0 -100.0
0004: $BLOB_FLAG = 1
// Code  made compatible with GInput
0293: $CONTROLMODE = current_controls
if
	8038:   NOT   $CONTROLMODE == 4
then
	03E5: text_box 'LOOK_A'   // Press and hold the ~h~~k~~VEHICLE_LOOKLEFT~ button ~w~or the ~h~~k~~VEHICLE_LOOKRIGHT~ button~w~ to look ~h~left~w~ or ~h~right~w~ while in a vehicle. Press both to look ~h~behind~w~.
else
	// New text for GInput
	03E5: text_box 'LOOK_B'   // Push the ~h~right analog stick ~w~left or right to look ~h~left ~w~or ~h~right ~w~while in a vehicle. Push the ~h~right analog stick ~w~down to look ~h~behind~w~.
end
0006: 16@ = 0
while true
    if or
        81A8:   NOT   actor $MISTY_CHAR stopped $BLOB_FLAG in_cube 568.75 -420.188 20.0 573.25 -431.062 24.0  // never used in VC
        819E:   NOT   player $PLAYER stopped 0 in_cube 568.75 -420.188 20.0 573.25 -431.062 24.0  // never used in VC
    jf break
    wait 0 ms
    if
        0038:   $FLAG_PLAYER_HAD_CAMERA_MESSAGE_8BALL == 0
    then
		// Code optimized and made compatible with GInput
        0293: $CONTROLMODE = current_controls
        if
            0019:   16@ > 10000
        then
			if
				82BD:   NOT   debug_mode == DEBUG_SKIPHELP
			then
				if
					8038:   NOT   $CONTROLMODE == 1
				then
					03E5: text_box 'CAM_A'   // Press the ~h~~k~~CAMERA_CHANGE_VIEW_ALL_SITUATIONS~ button~w~ to change ~h~camera ~w~modes when on foot or in a vehicle.
				else
					03E5: text_box 'CAM_B'   // Press the ~h~directional button up~w~ and ~h~down~w~ to change ~h~camera ~w~modes when on foot or in a vehicle.
				end
			end
			0004: $FLAG_PLAYER_HAD_CAMERA_MESSAGE_8BALL = 1
        end
    end
    if
        0118:   actor $MISTY_CHAR dead
    then
        00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
        jump @MISSION_EIGHTBALL_FAILED
    else
        if and
            8320:   NOT   actor $MISTY_CHAR in_range_of_player $PLAYER
            0038:   $FLAG_BLIP_ON_GIRL1_LM1 == 0
        then
            00BC: print_now 'HEY4' 5000 ms 1   // ~g~Lose Misty and Luigi will lose your face! Go and get her!
            0187: $MISTY_CAR_MARKER = create_marker_above_actor $MISTY_CHAR
            0164: remove_blip $LG_CHECKPOINT_TO_LUIGIS
            0004: $BLOB_FLAG = 0
            0004: $FLAG_BLIP_ON_GIRL1_LM1 = 1
        end
        if and
            00E9:   player $PLAYER 0 near_actor $MISTY_CHAR radius 8.0 8.0
            0038:   $FLAG_BLIP_ON_GIRL1_LM1 == 1
        then
            01DF: tie_actor $MISTY_CHAR to_player $PLAYER
            00BC: print_now 'LM1_2' 7000 ms 1   // ~g~Take Misty to Luigi's Club.
            018A: $LG_CHECKPOINT_TO_LUIGIS = create_checkpoint_at 571.188 -426.0 -100.0
            0164: remove_blip $MISTY_CAR_MARKER
            0004: $BLOB_FLAG = 1
            0004: $FLAG_BLIP_ON_GIRL1_LM1 = 0
        end
    end

end
0164: remove_blip $LG_CHECKPOINT_TO_LUIGIS
01E0: leave_group $MISTY_CHAR
// *********************************MISTY CUT AT END****************************************
02A3: toggle_widescreen 1 (on)
01B4: set_player $PLAYER can_move 0 (frozen)
0110: clear_player $PLAYER wanted_level
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
0395: clear_area 1 at 552.375 -417.25 19.875 range 10.0
0247: request_model #INDHIBUILD3
0247: request_model #LUIGICLUBOUT
0247: request_model #LUIGIINEERCLUB
038B: load_all_models_now
if
    00DF:   actor $MISTY_CHAR driving
then
    039E: set_char_cant_be_dragged_out $MISTY_CHAR 0
    00D9: $MISTY_CAR = actor $MISTY_CHAR car
    01D3: actor $MISTY_CHAR leave_car $MISTY_CAR

    while 00DF:   actor $MISTY_CHAR driving
        wait 0 ms
        if
            0118:   actor $MISTY_CHAR dead
        then
            00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
            jump @MISSION_EIGHTBALL_FAILED
        end
    end
end
while true
    if or
        8248:   NOT   model #INDHIBUILD3 available
        8248:   NOT   model #LUIGICLUBOUT available
        8248:   NOT   model #LUIGIINEERCLUB available
    jf break
    wait 0 ms
    if
        0118:   actor $MISTY_CHAR dead
    then
        00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
// Misty walks to the top of the alleyway
0211: actor $MISTY_CHAR walk_to 565.125 -425.375
0006: 17@ = 0
while 001B:   1000 > 17@
    wait 0 ms
    if
        0118:   actor $MISTY_CHAR dead
    then
        00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
        jump @MISSION_EIGHTBALL_FAILED
    end
end
if
    0118:   actor $MISTY_CHAR dead
then
    00BC: print_now 'MISTY1' 5000 ms 1   // ~r~Misty is morgue-meat!
    jump @MISSION_EIGHTBALL_FAILED
end
00A1: put_actor $MISTY_CHAR at 563.875 -425.75 19.875
0173: set_actor $MISTY_CHAR z_angle_to 90.0
0579: $MISTY_CHAR    //unknown: stop_actor_walking ??
0211: actor $MISTY_CHAR walk_to 552.062 -425.188
02A3: toggle_widescreen 1 (on)
015F: set_camera_position 547.562 -425.562 20.375 0.0 0.0 0.0
0160: point_camera 555.188 -421.062 21.0 2
01E3: text_1number_styled 'M_PASS' 1500 5000 ms 1   // MISSION PASSED! $~1~
0109: player $PLAYER money += 1500
0394: play_music 1
0006: 17@ = 0
while 001B:   5000 > 17@
    wait 0 ms
end
0169: set_fade_color 0 0 0
016A: fade 0 (in)  1000 ms
while fading
    wait 0 ms
end
wait 0 ms
0373: set_camera_directly_behind_player
wait 0 ms
02A3: toggle_widescreen 0 (off)
wait 0 ms
02EB: restore_camera_jumpcut
wait 750 ms
016A: fade 1 (out)  250 ms
01B4: set_player $PLAYER can_move 1 (unfrozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
jump @MISSION_EIGHTBALL_PASSED

:MISSION_EIGHTBALL_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
0004: $ON_LUIGIS_GIRLS_MISSION = 0
if
    0038:   $FLAG_REACHED_HIDEOUT == 0
then
    0255: restart_critical_mission 476.9 -939.95  41.8 angle  180.0    //was ints for the angle
else
    0255: restart_critical_mission 548.5 -308.2  13.6 angle  90.0      //was ints for the angle
end
mission_cleanup

while 8256:   NOT   player $PLAYER defined
    wait 0 ms
end
return

:MISSION_EIGHTBALL_PASSED
01F6: cancel_override_restart
0004: $LUIGIS_GIRLS_COMPLETED = 1
0318: set_latest_mission_passed 'LM1'   // 'LUIGI'S GIRLS'
030C: set_mission_points += 1
//0004: $FLAG_LUIGI_MISSION1_PASSED = 1      NEVER USED
0110: clear_player $PLAYER wanted_level
02A7: $LUIGI_MISSION_MARKER = create_icon_marker_and_sphere 16 at 557.75 -425.75 19.875
004F: create_thread @LUIGI_MISSION2_LOOP
004F: create_thread @BLOB_HELP_LOOP
004F: create_thread @LUIGI_MESSAGE
004F: create_thread @BIKE_HELP
return

:MISSION_CLEANUP_EIGHTBALL
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_8BALL = 0
03AE: remove_objects_from_cube 469.0 -948.0 36.0 430.125 -924.312 56.0
018E: stop_sound $FIRE_SOUND_8BALL
031A: remove_all_fires
0169: set_fade_color 0 0 0
0249: mark_model_as_no_longer_needed #INDHIBUILD3
0249: mark_model_as_no_longer_needed #LUIGICLUBOUT
0249: mark_model_as_no_longer_needed #LUIGIINEERCLUB
0249: mark_model_as_no_longer_needed #KURUMA
0249: mark_model_as_no_longer_needed #DELODRV
0164: remove_blip $RADAR_BLIP_COORD1_EIGHTBALL
0164: remove_blip $GML_LUIGI_CHECKPOINT
0164: remove_blip $MARKER_ABOVE_EIGHT_CAR
009B: destroy_actor_instantly $8BALL_CHAR
009B: destroy_actor_instantly $MISTY_CHAR
0164: remove_blip $LG_CHECKPOINT_TO_LUIGIS
0164: remove_blip $MISTY_CAR_MARKER
0164: remove_blip $MISTY_CAR_MARKER2
03E7: flash_hud -1
if
    8119:   NOT   car $GML_POLICE_CAR1 wrecked
then
    01C3: remove_references_to_car $GML_POLICE_CAR1  // Like turning a car into any random car
end
if
    8119:   NOT   car $GML_POLICE_CAR2 wrecked
then
    01C3: remove_references_to_car $GML_POLICE_CAR2  // Like turning a car into any random car
end
if
    8118:   NOT   actor $MISTY_CHAR dead
then
    039E: set_char_cant_be_dragged_out $MISTY_CHAR 0
end
mission_cleanup
return
