//-------------Mission 47-------------
// Originally: Asuka mission 4 'PAYDAY FOR RAY'

:M47_PAYDAYFORRAY
03A4: name_thread 'ASUKA4'
054C: use_GXT_table 'ASU4'
058E: set_restart_mission_taxi_destination 118.24 -684.80 21.96 angle 181.0
gosub @MISSION_START_ASUKA4
if
    wasted_or_busted
then
    gosub @MISSION_ASUKA4_FAILED
end
gosub @MISSION_CLEANUP_ASUKA4
end_thread

:MISSION_START_ASUKA4
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_ASUKA1 = 1
wait 0 ms
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'ASUKAH'
02F3: load_object #CUTOBJ03 'MINNOTE'
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'ASUKA'
0247: request_model #CONDO_IVY
0247: request_model #KMRICNDO01
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CUTOBJ03 available
    jf break
    wait 0 ms
end
while true
    if or
        8248:   NOT   model #CONDO_IVY available
        8248:   NOT   model #KMRICNDO01 available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'A4_PDR'
0244: set_cutscene_pos 188.062 -636.938 21.5625
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_ASUKA = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_ASUKA 'ASUKA'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
//02F4: create_cutscene_actor $ASUKA_CSHEAD _from_head #CUTOBJ02 _and_body  $CUTSCENE_ASUKA
//02F5: set_head_anim $ASUKA_CSHEAD 'ASUKA'
02E5: $CS_NOTE = create_cutscene_object #CUTOBJ03
02E6: set_cutscene_anim $CS_NOTE 'MINNOTE'
0395: clear_area 1 at 188.562 -639.375 22.5625 range 1.0
0055: set_player_coordinates $PLAYER at 188.562 -639.375 22.0
0171: set_player $PLAYER z_angle_to 180.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   805 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_A' 10000 ms 1   // // It's my handsome handyman!
while 001A:   3370 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_B' 10000 ms 1   // // Maria's all tied up at the moment but I'll tell her you called.
while 001A:   6758 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_C' 10000 ms 1   // // Who's that? Asuka? I know I've been a naughty girl but I really need to pee! OK?
while 001A:   12673 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_D' 10000 ms 1   // // It's time you met our man inside the LPD.
while 001A:   15481 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_E' 10000 ms 1   // // Here's his payment for the last little job he did for us.
while 001A:   18606 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_F' 10000 ms 1   // // He is understandably cautious.
while 001A:   21381 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_G' 10000 ms 1   // // Get to the pay phone in Torrington as quick as you can and await his instructions.
while 001A:   25955 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BE: text_clear_all
while 001A:   29333 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
03AD: set_rubbish 1 (visible)
02EA: clear_cutscene
03C8: set_camera_in_front_of_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CUTOBJ03
0249: mark_model_as_no_longer_needed #CONDO_IVY
0249: mark_model_as_no_longer_needed #KMRICNDO01
0296: unload_special_actor 1
0296: unload_special_actor 2
029B: $PHONE_1_OBJ = init_object #FAKETARGET at -105.812 -1537.5601 32.0
01C7: remove_object_from_mission_cleanup_list $PHONE_1_OBJ
029B: $PHONE_2_OBJ = init_object #FAKETARGET at -388.5 -699.062 32.0
01C7: remove_object_from_mission_cleanup_list $PHONE_2_OBJ
029B: $PHONE_3_OBJ = init_object #FAKETARGET at -130.25 -135.0 22.0
01C7: remove_object_from_mission_cleanup_list $PHONE_3_OBJ
029B: $PHONE_4_OBJ = init_object #FAKETARGET at -274.75 -964.75 32.0625
01C7: remove_object_from_mission_cleanup_list $PHONE_4_OBJ
0004: $COUNTDOWN_AS4 = 211000
014E: set_timer_to $COUNTDOWN_AS4 type 1
0188: $BLIP1_AS4 = create_marker_above_object $PHONE_1_OBJ
024C: text_phone $PHONE_RAY1 'AM4_1A'  // requires updated dinput8.dll  // Get to the Phone in West Belleville Park.
03CF: load_wav 'A4_A' as 1
while true
    if or
        80F6:   NOT player $PLAYER 0 near_point_on_foot -105.812 -1537.5601 32.0 radius 1.0 1.0 3.0
        8447:   NOT is_player_lifting_a_phone $PLAYER  // requires updated dinput8.dll
    jf break
    wait 0 ms
    if
        0038:   $COUNTDOWN_AS4 == 0
    then
        00BC: print_now 'OUTTIME' 5000 ms 1   // // ~r~Too slow man too slow!
        jump @MISSION_ASUKA4_FAILED
    end
end
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
0396: freeze_onscreen_timer  1
015F: set_camera_position -120.188 -1549.88 38.4375 0.0 0.0 0.0
0160: point_camera -119.5 -1549.1899 38.0625 2
while 83C2:   NOT   phone $PHONE_RAY1 answered  // requires updated dinput8.dll
    wait 0 ms
end
03D1: play_wav 1
while 0447:   player $PLAYER lifting_a_phone  // requires updated dinput8.dll
    wait 0 ms
end
02EB: restore_camera_jumpcut
0396: freeze_onscreen_timer 0
0164: remove_blip $BLIP1_AS4
0188: $BLIP1_AS4 = create_marker_above_object $PHONE_2_OBJ
024C: text_phone $PHONE_RAY2 'AM4_1B'  // requires updated dinput8.dll  // Get to the Phone on Liberty Campus.
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
03CF: load_wav 'A4_B' as 1
while true
    if or
        80F6:   NOT   player $PLAYER 0 near_point_on_foot -388.5 -699.062 32.0 radius 1.0 1.0 3.0
        8447:   NOT is_player_lifting_a_phone $PLAYER  // requires updated dinput8.dll
    jf break
    wait 0 ms
    if
        0038:   $COUNTDOWN_AS4 == 0
    then
        00BC: print_now 'OUTTIME' 5000 ms 1   // // ~r~Too slow man too slow!
        jump @MISSION_ASUKA4_FAILED
    end
end
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
0396: freeze_onscreen_timer 1
015F: set_camera_position -412.4375 -702.5 39.5625 0.0 0.0 0.0
0160: point_camera -411.5 -702.375 39.25 2
while 83C2:   NOT   phone $PHONE_RAY2 answered  // requires updated dinput8.dll
    wait 0 ms
end
03D1: play_wav 1
while 0447:   player $PLAYER lifting_a_phone  // requires updated dinput8.dll
    wait 0 ms
end
02EB: restore_camera_jumpcut
0396: freeze_onscreen_timer  0
0164: remove_blip $BLIP1_AS4
0188: $BLIP1_AS4 = create_marker_above_object $PHONE_3_OBJ
024C: text_phone $PHONE_RAY3 'AM4_1C'  // requires updated dinput8.dll  // Get to the Phone in South Belleville Park.
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
03CF: load_wav 'A4_C' as 1
while true
    if or
        80F6:   NOT   player $PLAYER 0 near_point_on_foot -130.25 -135.0 22.0 radius 1.0 1.0 3.0
        8447:   NOT is_player_lifting_a_phone $PLAYER  // requires updated dinput8.dll
    jf break
    wait 0 ms
    if
        0038:   $COUNTDOWN_AS4 == 0
    then
        00BC: print_now 'OUTTIME' 5000 ms 1   // // ~r~Too slow man too slow!
       jump @MISSION_ASUKA4_FAILED
    end
end
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
0396: freeze_onscreen_timer  1
015F: set_camera_position -143.375 -130.5 26.0 0.0 0.0 0.0
0160: point_camera -142.5 -130.812 25.6875 2
while 83C2:   NOT   phone $PHONE_RAY3 answered  // requires updated dinput8.dll
    wait 0 ms
end
03D1: play_wav 1
while 0447:   player $PLAYER lifting_a_phone  // requires updated dinput8.dll
    wait 0 ms
end
02EB: restore_camera_jumpcut
0396: freeze_onscreen_timer  0
0164: remove_blip $BLIP1_AS4
0188: $BLIP1_AS4 = create_marker_above_object $PHONE_4_OBJ
024C: text_phone $PHONE_RAY4 'AM4_1D'  // requires updated dinput8.dll  // Meet me in the toilet block in the park.
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
03CF: load_wav 'A4_D' as 1
while true
    if or
        80F6:   NOT   player $PLAYER 0 near_point_on_foot -274.75 -964.75 32.0625 radius 1.0 1.0 3.0
        8447:   NOT is_player_lifting_a_phone $PLAYER  // requires updated dinput8.dll
    jf break
    wait 0 ms
    if
        0038:   $COUNTDOWN_AS4 == 0
    then
        00BC: print_now 'OUTTIME' 5000 ms 1   // // ~r~Too slow man too slow!
        jump @MISSION_ASUKA4_FAILED
    end
end
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
0396: freeze_onscreen_timer  1
015F: set_camera_position -283.3125 -973.062 36.5 0.0 0.0 0.0
0160: point_camera -282.625 -972.438 36.125 2
while 83C2:   NOT   phone $PHONE_RAY4 answered  // requires updated dinput8.dll
    wait 0 ms
end
03D1: play_wav 1
while 0447:   player $PLAYER lifting_a_phone  // requires updated dinput8.dll
    wait 0 ms
end
02EB: restore_camera_jumpcut
014F: stop_timer $COUNTDOWN_AS4
0164: remove_blip $BLIP1_AS4
018A: $BLIP1_AS4 = create_checkpoint_at -296.25 -725.375 28.75
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
0004: $RAYS_CUTSCENE_FLAG = 1
while 80F6:   NOT   player $PLAYER 1 near_point_on_foot -296.25 -725.375 28.75 radius 1.0 1.0 2.0
    wait 0 ms
end
0164: remove_blip $BLIP1_AS4
01BD: $PRE_CUTSCENE_START_TIME = current_time_in_ms
0004: $PRE_CUTSCENE_ELAPSED_TIME = 0
while true
    if and
        83EE:   NOT   player $PLAYER controllable
        001A:   5000 > $PRE_CUTSCENE_ELAPSED_TIME
    jf break
    wait 0 ms
    01BD: $PRE_CUTSCENE_CURRENT_TIME = current_time_in_ms
    0084: $PRE_CUTSCENE_ELAPSED_TIME = $PRE_CUTSCENE_CURRENT_TIME
    0060: $PRE_CUTSCENE_ELAPSED_TIME -= $PRE_CUTSCENE_START_TIME
end
01B4: set_player $PLAYER can_move 0 (frozen)
0110: clear_player $PLAYER wanted_level
0169: set_fade_color 0 0 0
016A: fade 0  1500 ms
03AF: set_streaming 0 (disabled)
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'RAY'
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'RAYH'
while fading
    wait 0 ms
end
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'R0_PDR2'
0244: set_cutscene_pos -295.625 -726.625 27.6875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_RAY = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_RAY 'RAY'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
//02F4: create_cutscene_actor $RAY_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_RAY
//02F5: set_head_anim $RAY_CSHEAD 'RAY'
0395: clear_area 1 at -296.0 -723.5 28.0 range 1.0
0055: set_player_coordinates $PLAYER at -296.0 -723.5 28.0
0171: set_player $PLAYER z_angle_to 90.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   2887 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_3' 10000 ms 1   // // You must be Asuka's new errand boy!
while 001A:   6583 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_4' 10000 ms 1   // // You got the money? Is it all here?
while 001A:   10279 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_5' 10000 ms 1   // // I know what you're thinking another bent cop.
while 001A:   13282 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_6' 10000 ms 1   // // Well it's a bent world.
while 001A:   15014 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_7' 10000 ms 1   // // Just 'cause I lost a few partners those suckers from internal affairs have started sniffing around.
while 001A:   20212 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_8' 10000 ms 1   // // Reckon they can smell me.
while 001A:   21944 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_9' 10000 ms 1   // // Well this city is just one big open sewer.
while 001A:   24716 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_10' 10000 ms 1   // // But I'm gonna need some non-union help.
while 001A:   27719 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM4_11' 10000 ms 1   // // And if you're interested you'll know where to find me.
while 001A:   30611 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BE: text_clear_all
while 001A:   31666 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while fading
    wait 0 ms
end
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
03AD: set_rubbish 1 (visible)
00BE: text_clear_all
02EA: clear_cutscene
0373: set_camera_directly_behind_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
jump @MISSION_ASUKA4_PASSED

:MISSION_ASUKA4_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // // MISSION FAILED!
return

:MISSION_ASUKA4_PASSED
0004: $PAYDAY_FOR_RAY_COMPLETED = 1
0394: play_music 1
01E3: text_1number_styled 'M_PASS' 11000 5000 ms 1   // // MISSION PASSED! $~1~
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 11000
0318: set_latest_mission_passed 'AM4'   // // 'PAYDAY FOR RAY'
030C: set_mission_points += 1
0373: set_camera_directly_behind_player
004F: create_thread @ASUKA_MISSION5_LOOP
// if started with DEBUG_MASTERDEBUG on, these are already running
0164: remove_blip $RAY_MISSION_MARKER
02A7: $RAY_MISSION_MARKER = create_icon_marker_and_sphere 18 at -296.25 -725.375 28.75
0459: end_thread_named 'RM1'
004F: create_thread @RAY_MISSION1_LOOP
return

:MISSION_CLEANUP_ASUKA4
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_ASUKA1 = 0
014F: stop_timer $COUNTDOWN_AS4
0164: remove_blip $BLIP1_AS4
024E: disable_phone $PHONE_RAY1
024E: disable_phone $PHONE_RAY2
024E: disable_phone $PHONE_RAY3
024E: disable_phone $PHONE_RAY4
040D: unload_wav 1
0108: destroy_object $PHONE_1_OBJ
0108: destroy_object $PHONE_2_OBJ
0108: destroy_object $PHONE_3_OBJ
0108: destroy_object $PHONE_4_OBJ
0004: $RAYS_CUTSCENE_FLAG = 0
0396: freeze_onscreen_timer 0
mission_cleanup
return
