//-------------Mission 71-------------
// Originally: Asuka Suburban Mission 1 'BAIT'

:M71_BAIT
03A4: name_thread 'ASUSB1'
054C: use_GXT_table 'ASU6'
058E: set_restart_mission_taxi_destination 26.0 -398.2 27.64 90.0
gosub @MISSION_START_AS1
if
    wasted_or_busted
then
    gosub @MISSION_AS1_FAILED
end
gosub @MISSION_CLEANUP_AS1
end_thread

:MISSION_START_AS1
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_ASUKA2 = 1
wait 0 ms
0247: request_model #CSITECUTSCENE
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'ASUKA'
023C: load_special_actor 3 'MIGUEL'
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'ASUKAH'
02F3: load_object #CUTOBJ03 'WHIP'
038B: load_all_models_now
while 8248:   NOT   model #CSITECUTSCENE available
    wait 0 ms
end
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        823D:   NOT   special_actor 3 loaded
    jf break
    wait 0 ms
end
while true
    if or
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CUTOBJ03 available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'A6_BAIT'
03AF: set_streaming 1 (enabled)
0244: set_cutscene_pos 34.0 -327.5 24.4375
02E5: $CUTSCENE_PLAYER = create_cutscene_object  #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_ASUKA = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_ASUKA 'ASUKA'
02E5: $INTRO_MIGUEL = create_cutscene_object #SPECIAL03
02E6: set_cutscene_anim $INTRO_MIGUEL 'MIGUEL'
//02F4: create_cutscene_actor $PLAYER_CSHEAD from_head #CUTOBJ01 and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
//02F4: create_cutscene_actor $ASUKA_CSHEAD from_head #CUTOBJ02 and_body $CUTSCENE_ASUKA
//02F5: set_head_anim $ASUKA_CSHEAD 'ASUKA'
02E5: $CS_WHIP = create_cutscene_object #CUTOBJ03
02E6: set_cutscene_anim $CS_WHIP 'WHIP'
0055: set_player_coordinates $PLAYER at 18.75 -327.25 23.1875
0171: set_player $PLAYER z_angle_to 270.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   3598 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS1_A' 10000 ms 1   // // ~w~Miguel seems to think I'm mistreating him.
while 001A:   6277 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS1_B' 10000 ms 1   // // ~w~Still he's revealed the extent to which Catalina fears your quest for revenge.
while 001A:   12209 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS1_C' 10000 ms 1   // // ~w~She has three death squads dotted around Liberty whose sole job is to hunt you down.
while 001A:   17758 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS1_D' 10000 ms 1   // // ~w~Act as the bait and get the death squads to follow you to Pike Creek
while 001A:   22581 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AS1_E' 10000 ms 1   // // ~w~where some of my men will be waiting for them.
while 001A:   29000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
016A: fade 0  0 ms
0373: set_camera_directly_behind_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0296: unload_special_actor 2
0296: unload_special_actor 3
0249: mark_model_as_no_longer_needed #CSITECUTSCENE
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CUTOBJ03
03AD: set_rubbish 1 (visible)
03AF: set_streaming 1 (enabled)
03B7: process_cut_scene_only 1 (false)
0004: $FLAG_YAK1_DEAD = 0
0004: $FLAG_YAK2_DEAD = 0
0004: $FLAG_YAK3_DEAD = 0
0004: $FLAG_YAK4_DEAD = 0
0004: $FLAG_YAK5_DEAD = 0
0004: $FLAG_YAK6_DEAD = 0
//0004: $FLAG_ALL_YAK_DEAD = 0

0004: $COUNTER_YAKUZA_KILLED_AS1 = 0

//0004: $FLAG_BLIP_REMOVED_A = 0
//0004: $FLAG_BLIP_REMOVED_B = 0
//0004: $FLAG_BLIP_REMOVED_C = 0
//0004: $FLAG_BLIP_REMOVED_D = 0

//0004: $FLAG_CAR_A_BLIP = 0
//0004: $FLAG_CAR_B_BLIP = 0
//0004: $FLAG_CAR_C_BLIP = 0
//0004: $FLAG_CAR_D_BLIP = 0

0004: $YAK1_MISSION = 0
//0004: $YAK4_MISSION = 0

0004: $FLAG_CARTEL_A_CREATED = 0
0004: $FLAG_CARTEL_B_CREATED = 0
0004: $FLAG_CARTEL_C_CREATED = 0
0004: $FLAG_CARTEL_D_CREATED = 0
0004: $FLAG_YAKUZA_CREATED_AS1 = 0

0004: $CARTEL1_AS1_DEAD = 0
0004: $CARTEL2_AS1_DEAD = 0
0004: $CARTEL3_AS1_DEAD = 0
0004: $CARTEL4_AS1_DEAD = 0
0004: $CARTEL5_AS1_DEAD = 0
0004: $CARTEL6_AS1_DEAD = 0
0004: $CARTEL7_AS1_DEAD = 0
0004: $CARTEL8_AS1_DEAD = 0
0004: $CARTEL9_AS1_DEAD = 0
0004: $CARTEL10_AS1_DEAD = 0
0004: $CARTEL11_AS1_DEAD = 0
0004: $CARTEL12_AS1_DEAD = 0
0004: $CARTEL13_AS1_DEAD = 0
0004: $CARTEL14_AS1_DEAD = 0
0004: $CARTEL15_AS1_DEAD = 0
0004: $CARTEL16_AS1_DEAD = 0

0004: $COUNTER_CARTELS_KILLED_AS1 = 0
0004: $COUNTER_ASUKAS_REVENGE = 0
0004: $COUNTER_BAILOUTS = 0
//0004: $COUNTER_YAK_AMMO = 0

0004: $FLAG_BAILOUT_A = 0
0004: $FLAG_BAILOUT_B = 0
0004: $FLAG_BAILOUT_C = 0
0004: $FLAG_BAILOUT_D = 0

0004: $YAKS_A_KILLED_BY_PLAYER = 0
0004: $YAKS_B_KILLED_BY_PLAYER = 0
0004: $YAKS_KILLED_BY_PLAYER = 0

//0004: $TIMER_AS3_START = 0
0004: $TIMER_AS3_NOW = 0
//0004: $TIMER_AS3_DIF = 0
0004: $PARTICLE_TIME = 0
0004: $FLAG_PARTICLE = 0

0004: $FLAG_A_ATTACK = 0
0004: $FLAG_B_ATTACK = 0
0004: $FLAG_C_ATTACK = 0
0004: $FLAG_D_ATTACK = 0

0004: $FLAG_WELLYBOB = 0

0005: $KILLZONE_CENT_X = -1520.0
0005: $KILLZONE_CENT_Y = 105.0
0005: $KILLZONE_MIN_X = -1589.0
0005: $KILLZONE_MIN_Y = 85.0
0005: $KILLZONE_MAX_X = -1513.0
0005: $KILLZONE_MAX_Y = 160.0

0005: $CARTEL_A_X = -1331.812  // PUNK NOODLES
0005: $CARTEL_A_Y = -247.5

0005: $CARTEL_B_X = -1212.0  // DAM (EAST END)
0005: $CARTEL_B_Y = 562.0

0005: $CARTEL_C_X = -1049.0// AIRPORT
0005: $CARTEL_C_Y = -722.0

0005: $CARTEL_D_X = -794.0  // CEDAR GROVE
0005: $CARTEL_D_Y = 251.5  //

0005: $YAK1_X = -1503.0
0005: $YAK1_Y = 110.25
0005: $YAK2_X = -1520.0
0005: $YAK2_Y = 90.375
0005: $YAK3_X = -1540.19
0005: $YAK3_Y = 94.0625
0005: $YAK4_X = -1495.0
0005: $YAK4_Y = 119.562
0005: $YAK5_X = -1508.25
0005: $YAK5_Y = 95.5
0005: $YAK6_X = -1519.5
0005: $YAK6_Y = 122.562

0005: $CAR_A_AS1_X = 0.0
0005: $CAR_A_AS1_Y = 0.0
0005: $CAR_A_AS1_Z = 0.0
0005: $CAR_B_AS1_X = 0.0
0005: $CAR_B_AS1_Y = 0.0
0005: $CAR_B_AS1_Z = 0.0
0005: $CAR_C_AS1_X = 0.0
0005: $CAR_C_AS1_Y = 0.0
0005: $CAR_C_AS1_Z = 0.0
0005: $CAR_D_AS1_X = 0.0
0005: $CAR_D_AS1_Y = 0.0
0005: $CAR_D_AS1_Z = 0.0

018A: $BLIP_CARTEL_A_AS1 = create_checkpoint_at $CARTEL_A_X $CARTEL_A_Y 39.2
018A: $BLIP_CARTEL_B_AS1 = create_checkpoint_at $CARTEL_B_X $CARTEL_B_Y 79.0
018A: $BLIP_CARTEL_D_AS1 = create_checkpoint_at $CARTEL_D_X $CARTEL_D_Y 75.7

018A: $BLIP_KILLZONE = create_checkpoint_at $KILLZONE_CENT_X $KILLZONE_CENT_Y 76.0
0165: set_marker $BLIP_KILLZONE color_to 4
03C4: set_status_text_to $COUNTER_CARTELS_KILLED_AS1 0  'KILLS'   // // KILLS:
01E8: switch_roads_off $KILLZONE_MIN_X $KILLZONE_MIN_Y 71.0 -1505.0 $KILLZONE_MAX_Y 91.0
if
    02BD:   debug_mode == DEBUG_MASTEREXTRAS2
then
    $TOTAL_KILLS_NEEDED_AS1 = 16
    018A: $BLIP_CARTEL_C_AS1 = create_checkpoint_at $CARTEL_C_X $CARTEL_C_Y 14.5
    $TOTAL_REWARD_AS1 = 50000
else
    $TOTAL_KILLS_NEEDED_AS1 = 12
    $TOTAL_REWARD_AS1 = 35000
end
0247: request_model #GANG07
0247: request_model #SHOTGUN
0247: request_model #UZI
0247: request_model #AK47
0247: request_model #M16
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #GANG07 available
        8248:   NOT   model #SHOTGUN available
        8248:   NOT   model #UZI available
        8248:   NOT   model #AK47 available
        8248:   NOT   model #M16 available
    jf break
    wait 0 ms
end
0247: request_model #GANG08
0247: request_model #GANG11
0247: request_model #GANG12
0247: request_model #SENTINEL
while true
    if or
        8248:   NOT   model #GANG08 available
        8248:   NOT   model #GANG11 available
        8248:   NOT   model #GANG12 available
        8248:   NOT   model #SENTINEL available
    jf break
    wait 0 ms
end
0297: reset_num_of_models_killed_by_player
while 001C:   $TOTAL_KILLS_NEEDED_AS1 > $COUNTER_CARTELS_KILLED_AS1
    wait 0 ms
    0054: store_player $PLAYER position_to $PLAYER_X $PLAYER_Y $PLAYER_Z
    if
        00F5:   player $PLAYER 0 near_point $KILLZONE_MIN_X $KILLZONE_MIN_Y 65.0 radius $KILLZONE_MAX_X $KILLZONE_MAX_Y 75.0
    then
        0004: $FLAG_WELLYBOB = 1
    else
        0004: $FLAG_WELLYBOB = 0
    end
    gosub @YAK_DEATHS
    if
        001C:   $COUNTER_BAILOUTS > $COUNTER_ASUKAS_REVENGE
    then
        00BC: print_now 'AS1_H' 3000 ms 1   // // ~r~You failed to lead the Deathsquad into the Yakuza trap!!
        jump @MISSION_AS1_FAILED
    end
    if
        0018:   $COUNTER_YAKUZA_KILLED_AS1 > 5
    then
        00BC: print_now 'AS1_G' 3000 ms 1   // // ~r~All the Yakuza are dead!!
        jump @MISSION_AS1_FAILED
    end
    gosub @CARTEL_DEATHS
    gosub @VEGETABLES
    gosub @UNHAPPY_CAR_CHECK
    if
        0038:   $FLAG_YAKUZA_CREATED_AS1 == 0
    then
        if or
            0121:   player $PLAYER in_zone 'SUB_IND'
            0121:   player $PLAYER in_zone 'BIG_DAM'
        then
            if
                03C6:   is_collision_in_memory 3
            then
                if
                    0038:   $FLAG_YAK1_DEAD == 0
                then
                    009A: $YAKUZA1_AS1 = create_actor 10 #GANG07 at $YAK1_X $YAK1_Y 76.0
                    0173: set_actor $YAKUZA1_AS1 z_angle_to 130.0
                    01ED: reset_actor $YAKUZA1_AS1 flags
                    011A: set_actor $YAKUZA1_AS1 flags 4096
                    011A: set_actor $YAKUZA1_AS1 flags 64
                    035F: set_actor $YAKUZA1_AS1 armour_to 100
                    01B2: give_actor $YAKUZA1_AS1 weapon 25 ammo 999  // Load the weapon model before using this
                    0350: set_char_stay_in_same_place $YAKUZA1_AS1  1
                end
                if
                    0038:   $FLAG_YAK2_DEAD == 0
                then
                    009A: $YAKUZA2_AS1 = create_actor 10 #GANG08 at $YAK2_X $YAK2_Y 80.0
                    0173: set_actor $YAKUZA2_AS1 z_angle_to 45.0
                    01ED: reset_actor $YAKUZA2_AS1 flags
                    011A: set_actor $YAKUZA2_AS1 flags 4096
                    011A: set_actor $YAKUZA2_AS1 flags 64
                    035F: set_actor $YAKUZA2_AS1 armour_to 100
                    01B2: give_actor $YAKUZA2_AS1 weapon 21 ammo 999  // Load the weapon model before using this
                    0350: set_char_stay_in_same_place $YAKUZA2_AS1  1
                end
                if
                    0038:   $FLAG_YAK3_DEAD == 0
                then
                    009A: $YAKUZA3_AS1 = create_actor 10 #GANG08 at $YAK3_X $YAK3_Y 80.0
                    0173: set_actor $YAKUZA3_AS1 z_angle_to 295.0
                    01ED: reset_actor $YAKUZA3_AS1 flags
                    011A: set_actor $YAKUZA3_AS1 flags 4096
                    011A: set_actor $YAKUZA3_AS1 flags 64
                    035F: set_actor $YAKUZA3_AS1 armour_to 100
                    01B2: give_actor $YAKUZA3_AS1 weapon 25 ammo 999  // Load the weapon model before using this
                    0350: set_char_stay_in_same_place $YAKUZA3_AS1  1
                end
                if
                    0038:   $FLAG_YAK4_DEAD == 0
                then
                    009A: $YAKUZA4_AS1 = create_actor 10 #GANG07 at $YAK4_X $YAK4_Y 80.0
                    0173: set_actor $YAKUZA4_AS1 z_angle_to 130.0
                    01ED: reset_actor $YAKUZA4_AS1 flags
                    011A: set_actor $YAKUZA4_AS1 flags 4096
                    011A: set_actor $YAKUZA4_AS1 flags 64
                    035F: set_actor $YAKUZA4_AS1 armour_to 100
                    01B2: give_actor $YAKUZA4_AS1 weapon 25 ammo 999  // Load the weapon model before using this
                    0350: set_char_stay_in_same_place $YAKUZA4_AS1  1
                end
                if
                    0038:   $FLAG_YAK5_DEAD == 0
                then
                    009A: $YAKUZA5_AS1 = create_actor 10 #GANG07 at $YAK5_X $YAK5_Y 80.4375
                    0173: set_actor $YAKUZA5_AS1 z_angle_to 60.0
                    01ED: reset_actor $YAKUZA5_AS1 flags
                    011A: set_actor $YAKUZA5_AS1 flags 4096
                    011A: set_actor $YAKUZA5_AS1 flags 2097152
                    035F: set_actor $YAKUZA5_AS1 armour_to 100
                    01B2: give_actor $YAKUZA5_AS1 weapon 25 ammo 999  // Load the weapon model before using this
                    0350: set_char_stay_in_same_place $YAKUZA5_AS1  1
                end
                if
                    0038:   $FLAG_YAK6_DEAD == 0
                then
                    009A: $YAKUZA6_AS1 = create_actor 10 #GANG08 at $YAK6_X $YAK6_Y 74.75
                    0173: set_actor $YAKUZA6_AS1 z_angle_to 180.0
                    01ED: reset_actor $YAKUZA6_AS1 flags
                    011A: set_actor $YAKUZA6_AS1 flags 4096
                    011A: set_actor $YAKUZA6_AS1 flags 2097152
                    035F: set_actor $YAKUZA6_AS1 armour_to 100
                    01B2: give_actor $YAKUZA6_AS1 weapon 21 ammo 999  // Load the weapon model before using this
                    0350: set_char_stay_in_same_place $YAKUZA6_AS1  1
                end
                0004: $FLAG_YAKUZA_CREATED_AS1 = 1
            end
        end
    end
    if
        0038:   $FLAG_YAKUZA_CREATED_AS1 == 1
    then
        if
            83C6:   NOT is_collision_in_memory 3
        then
            009B: destroy_actor_instantly $YAKUZA1_AS1
            009B: destroy_actor_instantly $YAKUZA2_AS1
            009B: destroy_actor_instantly $YAKUZA3_AS1
            009B: destroy_actor_instantly $YAKUZA4_AS1
            009B: destroy_actor_instantly $YAKUZA5_AS1
            009B: destroy_actor_instantly $YAKUZA6_AS1
            0004: $FLAG_YAKUZA_CREATED_AS1 = 0
        end
        {IF counter_yak_ammo = 0
            IF counter_asukas_revenge = 1
                IF NOT IS_CHAR_DEAD    yakuza1_as1
                    ADD_AMMO_TO_CHAR yakuza1_as1 WEAPONTYPE_CHAINGUN 30
                ENDIF
                IF NOT IS_CHAR_DEAD    yakuza2_as1
                    ADD_AMMO_TO_CHAR yakuza2_as1 WEAPONTYPE_SHOTGUN 7
                ENDIF
                IF NOT IS_CHAR_DEAD    yakuza3_as1
                    ADD_AMMO_TO_CHAR yakuza3_as1 WEAPONTYPE_CHAINGUN 30
                ENDIF
                IF NOT IS_CHAR_DEAD    yakuza4_as1
                    ADD_AMMO_TO_CHAR yakuza4_as1 WEAPONTYPE_M16 60
                ENDIF
                IF NOT IS_CHAR_DEAD    yakuza5_as1
                    ADD_AMMO_TO_CHAR yakuza5_as1 WEAPONTYPE_M16 60
                ENDIF
                IF NOT IS_CHAR_DEAD    yakuza6_as1
                    ADD_AMMO_TO_CHAR yakuza6_as1 WEAPONTYPE_SHOTGUN 7
                ENDIF
                ++ counter_yak_ammo
            ENDIF
        ENDIF
        IF counter_yak_ammo = 1
            IF counter_asukas_revenge = 2
                IF NOT IS_CHAR_DEAD    yakuza1_as1
                    ADD_AMMO_TO_CHAR yakuza1_as1 WEAPONTYPE_CHAINGUN 30
                ENDIF
                IF NOT IS_CHAR_DEAD    yakuza2_as1
                    ADD_AMMO_TO_CHAR yakuza2_as1 WEAPONTYPE_SHOTGUN 7
                ENDIF
                IF NOT IS_CHAR_DEAD    yakuza3_as1
                    ADD_AMMO_TO_CHAR yakuza3_as1 WEAPONTYPE_CHAINGUN 30
                ENDIF
                IF NOT IS_CHAR_DEAD    yakuza4_as1
                    ADD_AMMO_TO_CHAR yakuza4_as1 WEAPONTYPE_M16 60
                ENDIF
                IF NOT IS_CHAR_DEAD    yakuza5_as1
                    ADD_AMMO_TO_CHAR yakuza5_as1 WEAPONTYPE_M16 60
                ENDIF
                IF NOT IS_CHAR_DEAD    yakuza6_as1
                    ADD_AMMO_TO_CHAR yakuza6_as1 WEAPONTYPE_SHOTGUN 7
                ENDIF
                ++ counter_yak_ammo
            ENDIF
        ENDIF}
    end
    //--------------------------------CARTEL DEATH SQUAD 1 GENERATOR----------------------------------------
    if
        0038:   $FLAG_CARTEL_A_CREATED == 0
    then
        if or
            0121:   player $PLAYER in_zone 'SUB_IND'
            0121:   player $PLAYER in_zone 'AIRPORT'
        then
            00A5: $CARTEL_CAR_A_AS1 = create_car #SENTINEL at $CARTEL_A_X $CARTEL_A_Y 40.0
            0175: set_car $CARTEL_CAR_A_AS1 z_angle_to 270.0
            03ED: set_upsidedown_car_not_damaged $CARTEL_CAR_A_AS1 1
            0129: $CARTEL1_AS1 = create_actor 12 #GANG12 in_car $CARTEL_CAR_A_AS1 driverseat
            01C8: $CARTEL2_AS1 = create_actor 12 #GANG12 in_car $CARTEL_CAR_A_AS1 passenger_seat 0
            01C8: $CARTEL3_AS1 = create_actor 12 #GANG12 in_car $CARTEL_CAR_A_AS1 passenger_seat 1
            01C8: $CARTEL4_AS1 = create_actor 12 #GANG12 in_car $CARTEL_CAR_A_AS1 passenger_seat 2
            00A9: set_car $CARTEL_CAR_A_AS1 to_normal_driver
            0004: $FLAG_CARTEL_A_CREATED = 1
        end
    end
    //-----------------------------------CARTEL DEATH SQUAD 1 ATTACK-----------------------------------------
    if
        0038:   $FLAG_CARTEL_A_CREATED == 1
    then
        if
            0038:   $FLAG_A_ATTACK == 0
        then
            if
                00E3:   player $PLAYER 0 near_point $CARTEL_A_X $CARTEL_A_Y radius 30.0 30.0
            then
                if
                    8119:   NOT   car $CARTEL_CAR_A_AS1 wrecked
                then
                    03AB: set_vehicle $CARTEL_CAR_A_AS1 strong 1
                    020A: set_car $CARTEL_CAR_A_AS1 door_status_to 2
                    02AA: set_car $CARTEL_CAR_A_AS1 immune_to_nonplayer 1
                    0164: remove_blip $BLIP_CARTEL_A_AS1
                    00AD: set_car $CARTEL_CAR_A_AS1 max_speed_to 50.0
                    00AF: set_car $CARTEL_CAR_A_AS1 mission 2  // MISSION_RAMPLAYER_FARAWAY
                    00AE: set_car $CARTEL_CAR_A_AS1 driving_style 2  // DRIVINGMODE_AVOIDCARS
                    0186: $BLIP_CARTELCAR_A = create_marker_above_car $CARTEL_CAR_A_AS1
                    03FB: car $CARTEL_CAR_A_AS1 bind_to_current_island 0 (false)
                    0004: $FLAG_A_ATTACK = 1
                end
            else
                if
                    0119:   car $CARTEL_CAR_A_AS1 wrecked
                then
                    0164: remove_blip $BLIP_CARTEL_A_AS1
                end
            end
        end
        if and
            0119:   car $CARTEL_CAR_A_AS1 wrecked
            0038:   $FLAG_A_ATTACK == 0
        then
            00BC: print_now 'AS1_H' 3000 ms 1   // // ~r~You failed to lead the Deathsquad into the Yakuza trap!!
            jump @MISSION_AS1_FAILED
        end
        if
            8119:   NOT   car $CARTEL_CAR_A_AS1 wrecked
        then
            if and
                0038:   $FLAG_BAILOUT_A == 0
                0038:   $FLAG_A_ATTACK == 1
            then
                if
                    81AD:   NOT   car $CARTEL_CAR_A_AS1 0 near_point $PLAYER_X $PLAYER_Y 40.0 40.0
                then
                    00AD: set_car $CARTEL_CAR_A_AS1 max_speed_to 30.0
                else
                    00AD: set_car $CARTEL_CAR_A_AS1 max_speed_to 60.0
                end
                if
                    8185:   NOT   car $CARTEL_CAR_A_AS1 health >= 250
                then
                    gosub @BAILOUT_A
                end
                if and
                    80E0:   NOT   player $PLAYER driving
                    0038:   $FLAG_BAILOUT_A == 0
                    8119:   NOT   car $CARTEL_CAR_A_AS1 wrecked
                then
                    if
                        0038:   $FLAG_WELLYBOB == 0
                    then
                        0054: store_player $PLAYER position_to $PLAYER_X $PLAYER_Y $PLAYER_Z
                        if
                            01AF:   car $CARTEL_CAR_A_AS1 0 near_point $PLAYER_X $PLAYER_Y $PLAYER_Z radius 10.0 10.0 5.0
                        then
                            gosub @BAILOUT_A
                        end
                    end
                end
                if
                    8119:   NOT   car $CARTEL_CAR_A_AS1 wrecked
                then
                    if and
                        01AF:   car $CARTEL_CAR_A_AS1 0 near_point $KILLZONE_CENT_X $KILLZONE_CENT_Y 76.0 radius 17.0 30.0 3.0
                        0038:   $FLAG_BAILOUT_A == 0
                    then
                        02AA: set_car $CARTEL_CAR_A_AS1 immune_to_nonplayer 0
                        0008: $COUNTER_ASUKAS_REVENGE += 1
                        gosub @BAILOUT_A
                    end
                end
            end
        end
        if
            0038:   $FLAG_BAILOUT_A == 1
        then
            if
                8118:   NOT   actor $CARTEL1_AS1 dead
            then
                01CC: actor $CARTEL1_AS1 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $CARTEL2_AS1 dead
            then
                01CC: actor $CARTEL2_AS1 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $CARTEL3_AS1 dead
            then
                01CC: actor $CARTEL3_AS1 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $CARTEL4_AS1 dead
            then
                if and
                    00ED:   actor $CARTEL4_AS1 0 near_point_on_foot $KILLZONE_CENT_X $KILLZONE_CENT_Y radius 15.0 15.0
                    8118:   NOT   actor $YAKUZA1_AS1 dead
                then
                    01CB: actor $CARTEL4_AS1 kill_actor $YAKUZA1_AS1
                else
                    01CC: actor $CARTEL4_AS1 kill_player $PLAYER
                end
            end
        end
    end
    //--------------------------------CARTEL DEATH SQUAD 2 GENERATOR-----------------------------------
    if
        0038:   $FLAG_CARTEL_B_CREATED == 0
    then
        if
            0121:   player $PLAYER in_zone 'BIG_DAM'
        then
            00A5: $CARTEL_CAR_B_AS1 = create_car #SENTINEL at $CARTEL_B_X $CARTEL_B_Y 80.1875
            03ED: set_upsidedown_car_not_damaged $CARTEL_CAR_B_AS1 1
            0175: set_car $CARTEL_CAR_B_AS1 z_angle_to 180.0
            0129: $CARTEL5_AS1 = create_actor 12 #GANG11 in_car $CARTEL_CAR_B_AS1 driverseat
            01C8: $CARTEL6_AS1 = create_actor 12 #GANG12 in_car $CARTEL_CAR_B_AS1 passenger_seat 0
            01C8: $CARTEL7_AS1 = create_actor 12 #GANG11 in_car $CARTEL_CAR_B_AS1 passenger_seat 1
            01C8: $CARTEL8_AS1 = create_actor 12 #GANG12 in_car $CARTEL_CAR_B_AS1 passenger_seat 2
            00A9: set_car $CARTEL_CAR_B_AS1 to_normal_driver
            0004: $FLAG_CARTEL_B_CREATED = 1
        end
    end
    //-----------------------------------CARTEL DEATH SQUAD 2 ATTACK----------------------------------
    if
        0038:   $FLAG_CARTEL_B_CREATED == 1
    then
        if
            0038:   $FLAG_B_ATTACK == 0
        then
            if
                00E3:   player $PLAYER 0 near_point $CARTEL_B_X $CARTEL_B_Y radius 40.0 40.0
            then
                if
                    8119:   NOT   car $CARTEL_CAR_B_AS1 wrecked
                then
                    03AB: set_vehicle $CARTEL_CAR_B_AS1 strong 1
                    020A: set_car $CARTEL_CAR_B_AS1 door_status_to 2
                    02AA: set_car $CARTEL_CAR_B_AS1 immune_to_nonplayer 1
                    0164: remove_blip $BLIP_CARTEL_B_AS1
                    00AD: set_car $CARTEL_CAR_B_AS1 max_speed_to 50.0
                    00AF: set_car $CARTEL_CAR_B_AS1 mission 2  // MISSION_RAMPLAYER_FARAWAY
                    00AE: set_car $CARTEL_CAR_B_AS1 driving_style 2  // DRIVINGMODE_AVOIDCARS
                    0186: $BLIP_CARTELCAR_B = create_marker_above_car $CARTEL_CAR_B_AS1
                    03FB: car $CARTEL_CAR_B_AS1 bind_to_current_island 0 (false)
                    0004: $FLAG_B_ATTACK = 1
                end
            else
                if
                    0119:   car $CARTEL_CAR_B_AS1 wrecked
                then
                    0164: remove_blip $BLIP_CARTEL_B_AS1
                end
            end
        end
        if and
            0119:   car $CARTEL_CAR_B_AS1 wrecked
            0038:   $FLAG_B_ATTACK == 0
        then
            00BC: print_now 'AS1_H' 3000 ms 1   // // ~r~You failed to lead the Deathsquad into the Yakuza trap!!
            jump @MISSION_AS1_FAILED
        end
        if
            8119:   NOT   car $CARTEL_CAR_B_AS1 wrecked
        then
            if and
                0038:   $FLAG_BAILOUT_B == 0
                0038:   $FLAG_B_ATTACK == 1
            then
                if
                    81AD:   NOT   car $CARTEL_CAR_B_AS1 0 near_point $PLAYER_X $PLAYER_Y 40.0 40.0
                then
                    00AD: set_car $CARTEL_CAR_B_AS1 max_speed_to 30.0
                else
                    00AD: set_car $CARTEL_CAR_B_AS1 max_speed_to 60.0
                end
                if
                    8185:   NOT   car $CARTEL_CAR_B_AS1 health >= 250
                then
                    gosub @BAILOUT_B
                end
                if and
                    80E0:   NOT   player $PLAYER driving
                    0038:   $FLAG_BAILOUT_B == 0
                    8119:   NOT   car $CARTEL_CAR_B_AS1 wrecked
                then
                    if
                        0038:   $FLAG_WELLYBOB == 0
                    then
                        0054: store_player $PLAYER position_to $PLAYER_X $PLAYER_Y $PLAYER_Z
                        if
                            01AF:   car $CARTEL_CAR_B_AS1 0 near_point $PLAYER_X $PLAYER_Y $PLAYER_Z radius 10.0 10.0 5.0
                        then
                            gosub @BAILOUT_B
                        end
                    end
                end
                if
                    8119:   NOT   car $CARTEL_CAR_B_AS1 wrecked
                then
                    if and
                        01AF:   car $CARTEL_CAR_B_AS1 0 near_point $KILLZONE_CENT_X $KILLZONE_CENT_Y 76.0 radius 17.0 30.0 3.0
                        0038:   $FLAG_BAILOUT_B == 0
                    then
                        02AA: set_car $CARTEL_CAR_B_AS1 immune_to_nonplayer 0
                        0008: $COUNTER_ASUKAS_REVENGE += 1
                        gosub @BAILOUT_B
                    end
                end
            end
        end
        if
            0038:   $FLAG_BAILOUT_B == 1
        then
            if
                8118:   NOT   actor $CARTEL5_AS1 dead
            then
                01CC: actor $CARTEL5_AS1 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $CARTEL6_AS1 dead
            then
                01CC: actor $CARTEL6_AS1 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $CARTEL7_AS1 dead
            then
                01CC: actor $CARTEL7_AS1 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $CARTEL8_AS1 dead
            then
                if and
                    00ED:   actor $CARTEL8_AS1 0 near_point_on_foot $KILLZONE_CENT_X $KILLZONE_CENT_Y radius 15.0 15.0
                    8118:   NOT   actor $YAKUZA4_AS1 dead
                then
                    01CB: actor $CARTEL8_AS1 kill_actor $YAKUZA4_AS1
                else
                    01CC: actor $CARTEL8_AS1 kill_player $PLAYER
                end
            end
        end
    end
    //  Car3 commented out from original R* source
    if
        02BD:   debug_mode == DEBUG_MASTEREXTRAS2
    then
    //--------------------------------CARTEL DEATH SQUAD 3 GENERATOR-----------------------------------
        if
            0038:   $FLAG_CARTEL_C_CREATED == 0
        then
            if
                0121:   player $PLAYER in_zone 'AIRPORT'
            then
                00A5: $CARTEL_CAR_C_AS1 = create_car #SENTINEL at $CARTEL_C_X $CARTEL_C_Y 15.0
                03ED: set_upsidedown_car_not_damaged $CARTEL_CAR_C_AS1 1
                0175: set_car $CARTEL_CAR_C_AS1 z_angle_to 180.0
                0129: $CARTEL9_AS1  = create_actor 12 #GANG11 in_car $CARTEL_CAR_C_AS1 driverseat
                01C8: $CARTEL10_AS1 = create_actor 12 #GANG12 in_car $CARTEL_CAR_C_AS1 passenger_seat 0
                01C8: $CARTEL11_AS1 = create_actor 12 #GANG11 in_car $CARTEL_CAR_C_AS1 passenger_seat 1
                01C8: $CARTEL12_AS1 = create_actor 12 #GANG12 in_car $CARTEL_CAR_C_AS1 passenger_seat 2
                00A9: set_car $CARTEL_CAR_C_AS1 to_normal_driver
                0004: $FLAG_CARTEL_C_CREATED = 1
            end
        end
    //-----------------------------------CARTEL DEATH SQUAD 3 ATTACK----------------------------------
        if
            $FLAG_CARTEL_C_CREATED == 1
        then
            if
                $FLAG_C_ATTACK == 0
            then
                if
                    00E3:   player $PLAYER 0 near_point $CARTEL_C_X $CARTEL_C_Y 36.0 radius 30.0
                then
                    if
                        8119:   NOT   car $CARTEL_CAR_C_AS1 wrecked
                    then
                        03AB: set_vehicle $CARTEL_CAR_C_AS1 strong 1
                        020A: set_car $CARTEL_CAR_C_AS1 door_status_to 2
                        02AA: set_car $CARTEL_CAR_C_AS1 immune_to_nonplayer 1
                        0164: remove_blip $BLIP_CARTEL_C_AS1
                        00AD: set_car $CARTEL_CAR_C_AS1 max_speed_to 50.0
                        00AF: set_car $CARTEL_CAR_C_AS1 mission 2  // MISSION_RAMPLAYER_FARAWAY
                        00AE: set_car $CARTEL_CAR_C_AS1 driving_style 2  // DRIVINGMODE_AVOIDCARS
                        0186: $BLIP_CARTELCAR_C = create_marker_above_car $CARTEL_CAR_C_AS1
                        03FB: car $CARTEL_CAR_C_AS1 bind_to_current_island 0 (false)
                        0004: $FLAG_C_ATTACK = 1
                    end
                else
                    if
                        0119:   car $CARTEL_CAR_C_AS1 wrecked
                    then
                        0164: remove_blip $BLIP_CARTEL_C_AS1
                    end
                end
            end

            if and
                0119:   car $CARTEL_CAR_C_AS1 wrecked
                0038:   $FLAG_C_ATTACK == 0
            then
                00BC: print_now 'AS1_H' 3000 ms 1   // // ~r~You failed to lead the Deathsquad into the Yakuza trap!!
                jump @MISSION_AS1_FAILED
            end

            if
                8119:   NOT   car $CARTEL_CAR_C_AS1 wrecked
            then
                if and
                    $FLAG_BAILOUT_C == 0
                    $FLAG_C_ATTACK == 1
                then
                    if
                        81AD:   NOT   car $CARTEL_CAR_C_AS1 0 near_point $PLAYER_X $PLAYER_Y 40.0 40.0
                    then
                        00AD: set_car $CARTEL_CAR_C_AS1 max_speed_to 30.0
                    else
                        00AD: set_car $CARTEL_CAR_C_AS1 max_speed_to 50.0
                    end
                    if
                        8185:   NOT   car $CARTEL_CAR_C_AS1 health >= 250
                    then
                        gosub @BAILOUT_C
                    end

                    if and
                        80E0:   NOT   player $PLAYER driving
                        $FLAG_BAILOUT_C == 0
                        8119:   NOT   car $CARTEL_CAR_C_AS1 wrecked
                    then
                        if
                            $FLAG_WELLYBOB == 0
                        then
                            0054: store_player $PLAYER position_to $PLAYER_X $PLAYER_Y $PLAYER_Z
                            if
                                01AF:   car $CARTEL_CAR_C_AS1 0 near_point $PLAYER_X $PLAYER_Y $PLAYER_Z radius 10.0 10.0 5.0
                            then
                                gosub @BAILOUT_C
                            end
                        end
                    end
                    if
                        8119:   NOT   car $CARTEL_CAR_C_AS1 wrecked
                    then
                        if and
                            01AF:   car $CARTEL_CAR_C_AS1 0 near_point $KILLZONE_CENT_X $KILLZONE_CENT_Y 76.0 radius 17.0 30.0 3.0
                            0038:   $FLAG_BAILOUT_C == 0
                        then
                            02AA: set_car $CARTEL_CAR_C_AS1 immune_to_nonplayer 0
                            0008: $COUNTER_ASUKAS_REVENGE += 1
                            gosub @BAILOUT_C
                        end
                    end
                end
            end

            if
                $FLAG_BAILOUT_C == 1
            then
                if
                    8118:   NOT   actor $CARTEL9_AS1 dead
                then
                    01CC: actor $CARTEL9_AS1 kill_player $PLAYER
                end
                if
                    8118:   NOT   actor $CARTEL10_AS1 dead
                then
                    01CC: actor $CARTEL10_AS1 kill_player $PLAYER
                end
                if
                    8118:   NOT   actor $CARTEL11_AS1 dead
                then
                    01CC: actor $CARTEL11_AS1 kill_player $PLAYER
                end
                if
                    8118:   NOT   actor $CARTEL12_AS1 dead
                then
                    if and
                        00ED:   actor $CARTEL12_AS1 0 near_point_on_foot $KILLZONE_CENT_X $KILLZONE_CENT_Y radius 15.0 15.0
                        8118:   NOT   actor $YAKUZA1_AS1 dead
                    then
                        01CB: actor $CARTEL12_AS1 kill_actor $YAKUZA1_AS1
                    else
                        01CC: actor $CARTEL12_AS1 kill_player $PLAYER
                    end
                end
            end
        end
    end
    //--------------------------------CARTEL DEATH SQUAD 4 GENERATOR-----------------------------------
    if
        0038:   $FLAG_CARTEL_D_CREATED == 0
    then
        if
            00F5:   player $PLAYER 0 near_point $CARTEL_D_X $CARTEL_D_Y 76.0 radius 70.0 70.0 20.0
        then
            00A5: $CARTEL_CAR_D_AS1 = create_car #SENTINEL at $CARTEL_D_X $CARTEL_D_Y 76.0
            03ED: set_upsidedown_car_not_damaged $CARTEL_CAR_D_AS1 1
            0175: set_car $CARTEL_CAR_D_AS1 z_angle_to 180.0
            00A9: set_car $CARTEL_CAR_D_AS1 to_normal_driver
            0129: $CARTEL13_AS1 = create_actor 12 #GANG11 in_car $CARTEL_CAR_D_AS1 driverseat
            01C8: $CARTEL14_AS1 = create_actor 12 #GANG12 in_car $CARTEL_CAR_D_AS1 passenger_seat 0
            01C8: $CARTEL15_AS1 = create_actor 12 #GANG11 in_car $CARTEL_CAR_D_AS1 passenger_seat 1
            01C8: $CARTEL16_AS1 = create_actor 12 #GANG12 in_car $CARTEL_CAR_D_AS1 passenger_seat 2
            00A9: set_car $CARTEL_CAR_D_AS1 to_normal_driver
            0004: $FLAG_CARTEL_D_CREATED = 1
        end
    end
    //-----------------------------------CARTEL DEATH SQUAD 4 ATTACK----------------------------------
    if
        0038:   $FLAG_CARTEL_D_CREATED == 1
    then
        if
            0038:   $FLAG_D_ATTACK == 0
        then
            if
                00F5:   player $PLAYER 0 near_point $CARTEL_D_X $CARTEL_D_Y 76.0 radius 30.0 30.0 20.0
            then
                if
                    8119:   NOT   car $CARTEL_CAR_D_AS1 wrecked
                then
                    03AB: set_vehicle $CARTEL_CAR_D_AS1 strong 1
                    020A: set_car $CARTEL_CAR_D_AS1 door_status_to 2
                    02AA: set_car $CARTEL_CAR_D_AS1 immune_to_nonplayer 1
                    0164: remove_blip $BLIP_CARTEL_D_AS1
                    00AD: set_car $CARTEL_CAR_D_AS1 max_speed_to 50.0
                    00AF: set_car $CARTEL_CAR_D_AS1 mission 2  // MISSION_RAMPLAYER_FARAWAY
                    00AE: set_car $CARTEL_CAR_D_AS1 driving_style 2  // DRIVINGMODE_AVOIDCARS
                    0186: $BLIP_CARTELCAR_D = create_marker_above_car $CARTEL_CAR_D_AS1
                    03FB: car $CARTEL_CAR_D_AS1 bind_to_current_island 0 (false)
                    0004: $FLAG_D_ATTACK = 1
                end
            else
                if
                    0119:   car $CARTEL_CAR_D_AS1 wrecked
                then
                    0164: remove_blip $BLIP_CARTEL_D_AS1
                end
            end
        end
        if and
            0119:   car $CARTEL_CAR_D_AS1 wrecked
            0038:   $FLAG_D_ATTACK == 0
        then
            00BC: print_now 'AS1_H' 3000 ms 1   // // ~r~You failed to lead the Deathsquad into the Yakuza trap!!
            jump @MISSION_AS1_FAILED
        end
        if
            8119:   NOT   car $CARTEL_CAR_D_AS1 wrecked
        then
            if and
                0038:   $FLAG_BAILOUT_D == 0
                0038:   $FLAG_D_ATTACK == 1
            then
                if
                    81AD:   NOT   car $CARTEL_CAR_D_AS1 0 near_point $PLAYER_X $PLAYER_Y 40.0 40.0
                then
                    00AD: set_car $CARTEL_CAR_D_AS1 max_speed_to 30.0
                else
                    00AD: set_car $CARTEL_CAR_D_AS1 max_speed_to 60.0
                end
                if
                    8185:   NOT   car $CARTEL_CAR_D_AS1 health >= 250
                then
                    gosub @BAILOUT_D
                end
                if and
                    80E0:   NOT   player $PLAYER driving
                    0038:   $FLAG_BAILOUT_D == 0
                    8119:   NOT   car $CARTEL_CAR_D_AS1 wrecked
                then
                    if
                        0038:   $FLAG_WELLYBOB == 0
                    then
                        0054: store_player $PLAYER position_to $PLAYER_X $PLAYER_Y $PLAYER_Z
                        if
                            01AF:   car $CARTEL_CAR_D_AS1 0 near_point $PLAYER_X $PLAYER_Y $PLAYER_Z radius 10.0 10.0 5.0
                        then
                            gosub @BAILOUT_D
                        end
                    end
                end
                if
                    8119:   NOT   car $CARTEL_CAR_D_AS1 wrecked
                then
                    if and
                        01AF:   car $CARTEL_CAR_D_AS1 0 near_point $KILLZONE_CENT_X $KILLZONE_CENT_Y 76.0 radius 17.0 30.0 3.0
                        0038:   $FLAG_BAILOUT_D == 0
                    then
                        02AA: set_car $CARTEL_CAR_D_AS1 immune_to_nonplayer 0
                        0008: $COUNTER_ASUKAS_REVENGE += 1
                        gosub @BAILOUT_D
                    end
                end
            end
        end
        if
            0038:   $FLAG_BAILOUT_D == 1
        then
            if
                8118:   NOT   actor $CARTEL13_AS1 dead
            then
                01CC: actor $CARTEL13_AS1 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $CARTEL14_AS1 dead
            then
                01CC: actor $CARTEL14_AS1 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $CARTEL15_AS1 dead
            then
                01CC: actor $CARTEL15_AS1 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $CARTEL16_AS1 dead
            then
                if and
                    00ED:   actor $CARTEL16_AS1 0 near_point_on_foot $KILLZONE_CENT_X $KILLZONE_CENT_Y radius 15.0 15.0
                    8118:   NOT   actor $YAKUZA4_AS1 dead
                then
                    01CB: actor $CARTEL16_AS1 kill_actor $YAKUZA4_AS1
                else
                    01CC: actor $CARTEL16_AS1 kill_player $PLAYER
                end
            end
        end
    end
    {
    //----------------------------------------------YAK1 MISSIONS------------------------------------------------------
    IF flag_yakuza_created_as1 = 1
        IF NOT IS_CHAR_DEAD yakuza1_as1
            IF flag_cartel_a_created = 1
                IF NOT IS_CHAR_DEAD cartel3_as1
                AND yak1_mission = 0
                    IF IS_CHAR_IN_AREA_2D cartel3_as1 killzone_min_x killzone_min_y killzone_max_x killzone_max_y false
                        SET_CHAR_OBJ_KILL_CHAR_ON_FOOT yakuza1_as1 cartel3_as1
                        yak1_mission = 1
                    ENDIF
                ENDIF
            ENDIF

            IF flag_cartel_b_created = 1
                IF NOT IS_CHAR_DEAD cartel8_as1
                AND yak1_mission = 0
                    IF IS_CHAR_IN_AREA_2D cartel8_as1 killzone_min_x killzone_min_y killzone_max_x killzone_max_y false
                        SET_CHAR_OBJ_KILL_CHAR_ON_FOOT yakuza1_as1 cartel8_as1
                        yak1_mission = 2
                    ENDIF
                ENDIF
            ENDIF

            IF flag_cartel_c_created = 1
                IF NOT IS_CHAR_DEAD cartel9_as1
                AND yak1_mission = 0
                    IF IS_CHAR_IN_AREA_2D cartel9_as1 killzone_min_x killzone_min_y killzone_max_x killzone_max_y false
                        SET_CHAR_OBJ_KILL_CHAR_ON_FOOT yakuza1_as1 cartel9_as1
                        yak1_mission = 3
                    ENDIF
                ENDIF
                IF NOT IS_CHAR_DEAD cartel10_as1
                AND yak1_mission = 0
                    IF IS_CHAR_IN_AREA_2D cartel10_as1 killzone_min_x killzone_min_y killzone_max_x killzone_max_y false
                        SET_CHAR_OBJ_KILL_CHAR_ON_FOOT yakuza1_as1 cartel10_as1
                        yak1_mission = 4
                    ENDIF
                ENDIF
                IF NOT IS_CHAR_DEAD cartel11_as1
                AND yak1_mission = 0
                    IF IS_CHAR_IN_AREA_2D cartel11_as1 killzone_min_x killzone_min_y killzone_max_x killzone_max_y false
                        SET_CHAR_OBJ_KILL_CHAR_ON_FOOT yakuza1_as1 cartel11_as1
                        yak1_mission = 5
                    ENDIF
                ENDIF
                IF NOT IS_CHAR_DEAD cartel12_as1
                AND yak1_mission = 0
                    IF IS_CHAR_IN_AREA_2D cartel12_as1 killzone_min_x killzone_min_y killzone_max_x killzone_max_y false
                        SET_CHAR_OBJ_KILL_CHAR_ON_FOOT yakuza1_as1 cartel12_as1
                        yak1_mission = 6
                    ENDIF
                ENDIF
            ENDIF

            IF flag_cartel_d_created = 1
                IF NOT IS_CHAR_DEAD cartel16_as1
                AND yak1_mission = 0
                    IF IS_CHAR_IN_AREA_2D cartel16_as1 killzone_min_x killzone_min_y killzone_max_x killzone_max_y false
                        SET_CHAR_OBJ_KILL_CHAR_ON_FOOT yakuza1_as1 cartel16_as1
                        yak1_mission = 7
                    ENDIF
                ENDIF
            ENDIF

        ENDIF
    ENDIF

//------------------------------------------YAK4 MISSIONS---------------------------------------------

    IF flag_yakuza_created_as1 = 1
        IF NOT IS_CHAR_DEAD yakuza4_as1
            IF flag_cartel_a_created = 1
                IF NOT IS_CAR_DEAD cartel_car_a_as1
                AND yak4_mission = 0
                    IF IS_CAR_IN_AREA_2D cartel_car_a_as1 killzone_min_x killzone_min_y killzone_max_x killzone_max_y false
                        SET_CHAR_OBJ_DESTROY_CAR yakuza4_as1 cartel_car_a_as1
                        yak4_mission = 1
                    ENDIF
                ENDIF
            ENDIF
            IF flag_cartel_b_created = 1
                IF NOT IS_CAR_DEAD cartel_car_b_as1
                AND yak4_mission = 0
                    IF IS_CAR_IN_AREA_2D cartel_car_b_as1 killzone_min_x killzone_min_y killzone_max_x killzone_max_y false
                        SET_CHAR_OBJ_DESTROY_CAR yakuza4_as1 cartel_car_b_as1
                        yak4_mission = 2
                    ENDIF
                ENDIF
            ENDIF

            IF flag_cartel_c_created = 1
                IF NOT IS_CAR_DEAD cartel_car_c_as1
                AND yak4_mission = 0
                    IF IS_CAR_IN_AREA_2D cartel_car_c_as1 killzone_min_x killzone_min_y killzone_max_x killzone_max_y false
                        SET_CHAR_OBJ_DESTROY_CAR yakuza4_as1 cartel_car_c_as1
                        yak4_mission = 3
                    ENDIF
                ENDIF
            ENDIF

            IF flag_cartel_d_created = 1
                IF NOT IS_CAR_DEAD cartel_car_d_as1
                AND yak4_mission = 0
                    IF IS_CAR_IN_AREA_2D cartel_car_d_as1 killzone_min_x killzone_min_y killzone_max_x killzone_max_y false
                        SET_CHAR_OBJ_DESTROY_CAR yakuza4_as1 cartel_car_d_as1
                        yak4_mission = 4
                    ENDIF
                ENDIF
            ENDIF

        ENDIF
    ENDIF
    }
end //while
if
    0018:   $COUNTER_ASUKAS_REVENGE > 2
then
    jump @MISSION_AS1_PASSED
else
    00BC: print_now 'AS1_H' 3000 ms 1   // // ~r~You failed to lead the Deathsquad into the Yakuza trap!!
end

:MISSION_AS1_FAILED
00BA: text_styled 'M_FAIL' 2000 ms 1   // // MISSION FAILED!
if
    0130:   player $PLAYER busted  // never used in VC  - //crash
then
    016E: override_restart at 5.25 -1123.38 31.0 180.0
    //0420: override_police_station 2  // gta 3 only  - //crash
end
if
    0117:   player $PLAYER wasted
then
    016E: override_restart at -151.5 -17.75 22.1875 180.0
    //041F: override_hospital 2  // gta 3 only  - //crash
end
return

:MISSION_AS1_PASSED
0004: $BAIT_COMPLETED = 1
01E3: text_1number_styled 'M_PASS' $TOTAL_REWARD_AS1 5000 ms 1   // // MISSION PASSED! $~1~
0394: play_music 1
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += $TOTAL_REWARD_AS1
0318: set_latest_mission_passed 'AS1'   // // 'BAIT'
030C: set_mission_points += 1
004F: create_thread @ASUKA_SUBURBAN_MISSION2_LOOP
return

:MISSION_CLEANUP_AS1
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_ASUKA2 = 0
0151: remove_status_text $COUNTER_CARTELS_KILLED_AS1
gosub @BLIP_REMOVAL
0164: remove_blip $BLIP_CARTEL_A_AS1
0164: remove_blip $BLIP_CARTEL_B_AS1
0164: remove_blip $BLIP_CARTEL_C_AS1
0164: remove_blip $BLIP_CARTEL_D_AS1
0164: remove_blip $BLIP_KILLZONE
0164: remove_blip $BLIP_CARTELCAR_A
0164: remove_blip $BLIP_CARTELCAR_B
0164: remove_blip $BLIP_CARTELCAR_C
0164: remove_blip $BLIP_CARTELCAR_D
01C3: remove_references_to_car $CARTEL_CAR_A_AS1  // Like turning a car into any random car
01C3: remove_references_to_car $CARTEL_CAR_B_AS1  // Like turning a car into any random car
01C3: remove_references_to_car $CARTEL_CAR_C_AS1  // Like turning a car into any random car
01C3: remove_references_to_car $CARTEL_CAR_D_AS1  // Like turning a car into any random car
0249: mark_model_as_no_longer_needed #GANG07
0249: mark_model_as_no_longer_needed #GANG08
0249: mark_model_as_no_longer_needed #GANG11
0249: mark_model_as_no_longer_needed #GANG12
0249: mark_model_as_no_longer_needed #SENTINEL
0249: mark_model_as_no_longer_needed #SHOTGUN
0249: mark_model_as_no_longer_needed #UZI
0249: mark_model_as_no_longer_needed #AK47
0249: mark_model_as_no_longer_needed #M16
mission_cleanup
return

:YAK_DEATHS
if
    0038:   $FLAG_YAKUZA_CREATED_AS1 == 1
then
    if
        0118:   actor $YAKUZA1_AS1 dead
    then
        if
            0038:   $FLAG_YAK1_DEAD == 0
        then
            0008: $COUNTER_YAKUZA_KILLED_AS1 += 1
            0004: $FLAG_YAK1_DEAD = 1
        end
    end
    if
        0118:   actor $YAKUZA2_AS1 dead
    then
        if
            0038:   $FLAG_YAK2_DEAD == 0
        then
            0008: $COUNTER_YAKUZA_KILLED_AS1 += 1
            0004: $FLAG_YAK2_DEAD = 1
        end
    end
    if
        0118:   actor $YAKUZA3_AS1 dead
    then
        if
            0038:   $FLAG_YAK3_DEAD == 0
        then
            0008: $COUNTER_YAKUZA_KILLED_AS1 += 1
            0004: $FLAG_YAK3_DEAD = 1
        end
    end
    if
        0118:   actor $YAKUZA4_AS1 dead
    then
        if
            0038:   $FLAG_YAK4_DEAD == 0
        then
            0008: $COUNTER_YAKUZA_KILLED_AS1 += 1
            0004: $FLAG_YAK4_DEAD = 1
        end
    end
    if
        0118:   actor $YAKUZA5_AS1 dead
    then
        if
            0038:   $FLAG_YAK5_DEAD == 0
        then
            0008: $COUNTER_YAKUZA_KILLED_AS1 += 1
            0004: $FLAG_YAK5_DEAD = 1
        end
    end
    if
        0118:   actor $YAKUZA6_AS1 dead
    then
        if
            0038:   $FLAG_YAK6_DEAD == 0
        then
            0008: $COUNTER_YAKUZA_KILLED_AS1 += 1
            0004: $FLAG_YAK6_DEAD = 1
        end
    end
    0298: $YAKS_A_KILLED_BY_PLAYER = rampage_kills #GANG07
    0298: $YAKS_B_KILLED_BY_PLAYER = rampage_kills #GANG08
    0084: $YAKS_KILLED_BY_PLAYER = $YAKS_A_KILLED_BY_PLAYER
    0058: $YAKS_KILLED_BY_PLAYER += $YAKS_B_KILLED_BY_PLAYER
    if
        0018:   $YAKS_KILLED_BY_PLAYER > 2
    then
        if
            8118:   NOT   actor $YAKUZA1_AS1 dead
        then
            011A: set_actor $YAKUZA1_AS1 flags 1
        end
        if
            8118:   NOT   actor $YAKUZA2_AS1 dead
        then
            011A: set_actor $YAKUZA2_AS1 flags 1
        end
        if
            8118:   NOT   actor $YAKUZA3_AS1 dead
        then
            011A: set_actor $YAKUZA3_AS1 flags 1
        end
        if
            8118:   NOT   actor $YAKUZA4_AS1 dead
        then
            011A: set_actor $YAKUZA4_AS1 flags 1
        end
        if
            8118:   NOT   actor $YAKUZA5_AS1 dead
        then
            011A: set_actor $YAKUZA5_AS1 flags 1
        end
        if
            8118:   NOT   actor $YAKUZA6_AS1 dead
        then
            011A: set_actor $YAKUZA6_AS1 flags 1
        end
    end
end
return

:BAILOUT_A
if
    0038:   $FLAG_BAILOUT_A == 0
then
    0004: $FLAG_BAILOUT_A = 1
    0008: $COUNTER_BAILOUTS += 1
    0164: remove_blip $BLIP_CARTELCAR_A
    020A: set_car $CARTEL_CAR_A_AS1 door_status_to 1
    if and
        8118:   NOT   actor $CARTEL1_AS1 dead
        8119:   NOT   car $CARTEL_CAR_A_AS1 wrecked
    then
        01D3: actor $CARTEL1_AS1 leave_car $CARTEL_CAR_A_AS1
        while 00DB:   actor $CARTEL1_AS1 in_car $CARTEL_CAR_A_AS1
            wait 0 ms
            if or
                0118:   actor $CARTEL1_AS1 dead
                0119:   car $CARTEL_CAR_A_AS1 wrecked
            then
                jump @C_A_2
            end
        end //while
        011A: set_actor $CARTEL1_AS1 flags 1
        01B2: give_actor $CARTEL1_AS1 weapon 26 ammo 100  // Load the weapon model before using this
        0187: $BLIP_CARTEL1 = create_marker_above_actor $CARTEL1_AS1
    end

    :C_A_2
    if and
        8118:   NOT   actor $CARTEL2_AS1 dead
        8119:   NOT   car $CARTEL_CAR_A_AS1 wrecked
    then
        01D3: actor $CARTEL2_AS1 leave_car $CARTEL_CAR_A_AS1
        while 00DB:   actor $CARTEL2_AS1 in_car $CARTEL_CAR_A_AS1
            wait 0 ms
            if or
                0118:   actor $CARTEL2_AS1 dead
                0119:   car $CARTEL_CAR_A_AS1 wrecked
            then
                jump @C_A_3
            end
        end //while
        011A: set_actor $CARTEL2_AS1 flags 1
        01B2: give_actor $CARTEL2_AS1 weapon 26 ammo 100  // Load the weapon model before using this
        0187: $BLIP_CARTEL2 = create_marker_above_actor $CARTEL2_AS1
    end

    :C_A_3
    if and
        8118:   NOT   actor $CARTEL3_AS1 dead
        8119:   NOT   car $CARTEL_CAR_A_AS1 wrecked
    then
        01D3: actor $CARTEL3_AS1 leave_car $CARTEL_CAR_A_AS1
        while 00DB:   actor $CARTEL3_AS1 in_car $CARTEL_CAR_A_AS1
            wait 0 ms
            if or
                0118:   actor $CARTEL3_AS1 dead
                0119:   car $CARTEL_CAR_A_AS1 wrecked
            then
                jump @C_A_4
            end
        end //while
        011A: set_actor $CARTEL3_AS1 flags 1
        01B2: give_actor $CARTEL3_AS1 weapon 21 ammo 15  // Load the weapon model before using this
        0187: $BLIP_CARTEL3 = create_marker_above_actor $CARTEL3_AS1
    end

    :C_A_4
    if and
        8118:   NOT   actor $CARTEL4_AS1 dead
        8119:   NOT   car $CARTEL_CAR_A_AS1 wrecked
    then
        01D3: actor $CARTEL4_AS1 leave_car $CARTEL_CAR_A_AS1
        while 00DB:   actor $CARTEL4_AS1 in_car $CARTEL_CAR_A_AS1
            wait 0 ms
            if or
                0118:   actor $CARTEL4_AS1 dead
                0119:   car $CARTEL_CAR_A_AS1 wrecked
            then
                jump @C_A_5
            end
        end //while
        011A: set_actor $CARTEL4_AS1 flags 1
        01B2: give_actor $CARTEL4_AS1 weapon 21 ammo 15  // Load the weapon model before using this
        0187: $BLIP_CARTEL4 = create_marker_above_actor $CARTEL4_AS1
    end

    :C_A_5
    //MARK_CAR_AS_NO_LONGER_NEEDED cartel_car_a_as1
end
return

:BAILOUT_B
if
    0038:   $FLAG_BAILOUT_B == 0
then
    0004: $FLAG_BAILOUT_B = 1
    0008: $COUNTER_BAILOUTS += 1
    0164: remove_blip $BLIP_CARTELCAR_B
    020A: set_car $CARTEL_CAR_B_AS1 door_status_to 1
    if and
        8118:   NOT   actor $CARTEL5_AS1 dead
        8119:   NOT   car $CARTEL_CAR_B_AS1 wrecked
    then
        01D3: actor $CARTEL5_AS1 leave_car $CARTEL_CAR_B_AS1
        while 00DB:   actor $CARTEL5_AS1 in_car $CARTEL_CAR_B_AS1
            wait 0 ms
            if or
                0118:   actor $CARTEL5_AS1 dead
                0119:   car $CARTEL_CAR_B_AS1 wrecked
            then
                jump @C_B_2
            end
        end //while
        011A: set_actor $CARTEL5_AS1 flags 1
        01B2: give_actor $CARTEL5_AS1 weapon 23 ammo 90  // Load the weapon model before using this
        0187: $BLIP_CARTEL5 = create_marker_above_actor $CARTEL5_AS1
    end

    :C_B_2
    if and
        8118:   NOT   actor $CARTEL6_AS1 dead
        8119:   NOT   car $CARTEL_CAR_B_AS1 wrecked
    then
        01D3: actor $CARTEL6_AS1 leave_car $CARTEL_CAR_B_AS1
        while 00DB:   actor $CARTEL6_AS1 in_car $CARTEL_CAR_B_AS1
            wait 0 ms
            if or
                0118:   actor $CARTEL6_AS1 dead
                0119:   car $CARTEL_CAR_B_AS1 wrecked
            then
                jump @C_B_3
            end
        end //while
        011A: set_actor $CARTEL6_AS1 flags 1
        01B2: give_actor $CARTEL6_AS1 weapon 23 ammo 90  // Load the weapon model before using this
        0187: $BLIP_CARTEL6 = create_marker_above_actor $CARTEL6_AS1
    end

    :C_B_3
    if and
        8118:   NOT   actor $CARTEL7_AS1 dead
        8119:   NOT   car $CARTEL_CAR_B_AS1 wrecked
    then
        01D3: actor $CARTEL7_AS1 leave_car $CARTEL_CAR_B_AS1
        while 00DB:   actor $CARTEL7_AS1 in_car $CARTEL_CAR_B_AS1
            wait 0 ms
            if or
                0118:   actor $CARTEL7_AS1 dead
                0119:   car $CARTEL_CAR_B_AS1 wrecked
            then
                jump @C_B_4
            end
        end //while
        011A: set_actor $CARTEL7_AS1 flags 1
        01B2: give_actor $CARTEL7_AS1 weapon 23 ammo 90  // Load the weapon model before using this
        0187: $BLIP_CARTEL7 = create_marker_above_actor $CARTEL7_AS1
    end

    :C_B_4
    if and
        8118:   NOT   actor $CARTEL8_AS1 dead
        8119:   NOT   car $CARTEL_CAR_B_AS1 wrecked
    then
        01D3: actor $CARTEL8_AS1 leave_car $CARTEL_CAR_B_AS1
        while 00DB:   actor $CARTEL8_AS1 in_car $CARTEL_CAR_B_AS1
            wait 0 ms
            if or
                0118:   actor $CARTEL8_AS1 dead
                0119:   car $CARTEL_CAR_B_AS1 wrecked
            then
                jump @C_B_5
            end
        end //while
        011A: set_actor $CARTEL8_AS1 flags 1
        01B2: give_actor $CARTEL8_AS1 weapon 26 ammo 100  // Load the weapon model before using this
        0187: $BLIP_CARTEL8 = create_marker_above_actor $CARTEL8_AS1
    end

    :C_B_5
end
return

:BAILOUT_C
if
    $FLAG_BAILOUT_C == 0
then
    $FLAG_BAILOUT_C = 1
    0008: $COUNTER_BAILOUTS += 1
    0164: remove_blip $BLIP_CARTELCAR_C
    020A: set_car $CARTEL_CAR_C_AS1 door_status_to 1
    if and
        8118:   NOT is_char_dead $CARTEL9_AS1
        8119:   NOT is_car_dead    $CARTEL_CAR_C_AS1
    then
        01D3: set_char_obj_leave_car $CARTEL9_AS1 $CARTEL_CAR_C_AS1
        while 00DB:   is_char_in_car $CARTEL9_AS1 $CARTEL_CAR_C_AS1
            wait 0 ms
            if or
                0118:   is_char_dead $CARTEL9_AS1
                0119:   is_car_dead $CARTEL_CAR_C_AS1
            then
                jump @C_C_2
            end
        end //while
        011A: set_char_threat_search $CARTEL9_AS1 1
        01B2: give_weapon_to_char $CARTEL9_AS1 21 ammo 10
        0187: $BLIP_CARTEL9 = add_blip_for_char $CARTEL9_AS1
    end

    :C_C_2
    if and
        8118:   NOT is_char_dead $CARTEL10_AS1
        8119:   NOT is_car_dead    $CARTEL_CAR_C_AS1
    then
        01D3: set_char_obj_leave_car $CARTEL10_AS1 $CARTEL_CAR_C_AS1
        while 00DB:   is_char_in_car $CARTEL10_AS1 $CARTEL_CAR_C_AS1
            wait 0 ms
            if or
                0118:   is_char_dead $CARTEL10_AS1
                0119:   is_car_dead $CARTEL_CAR_C_AS1
            then
                jump @C_C_3
            end
        end
        011A: set_char_threat_search $CARTEL10_AS1 1
        01B2: give_weapon_to_char $CARTEL10_AS1 26 ammo 100
        0187: $BLIP_CARTEL10 = add_blip_for_char $CARTEL10_AS1
    end

    :C_C_3
    if and
        8118:    NOT is_char_dead $CARTEL11_AS1
        8119:   NOT is_car_dead    $CARTEL_CAR_C_AS1
    then
        01D3: set_char_obj_leave_car $CARTEL11_AS1 $CARTEL_CAR_C_AS1
        while 00DB:   is_char_in_car $CARTEL11_AS1 $CARTEL_CAR_C_AS1
            wait 0 ms
            if or
                0118:    is_char_dead $CARTEL11_AS1
                0119:   is_car_dead $CARTEL_CAR_C_AS1
            then
                jump @C_C_4
            end
        end
        011A: set_char_threat_search $CARTEL11_AS1 1
        01B2: give_weapon_to_char $CARTEL11_AS1 26 ammo 100
        0187: $BLIP_CARTEL11 = add_blip_for_char $CARTEL11_AS1
    end

    :C_C_4
    if and
        8118:    NOT is_char_dead $CARTEL12_AS1
        8119:   NOT is_car_dead    $CARTEL_CAR_C_AS1
    then
        01D3: set_char_obj_leave_car $CARTEL12_AS1 $CARTEL_CAR_C_AS1
        while 00DB:   is_char_in_car $CARTEL12_AS1 $CARTEL_CAR_C_AS1
            wait 0
            if or
                0118:    is_char_dead $CARTEL12_AS1
                0119:   is_car_dead $CARTEL_CAR_C_AS1
            then
                jump @C_C_5
            end
        end
        011A: set_char_threat_search $CARTEL12_AS1 1
        01B2: give_weapon_to_char $CARTEL12_AS1 21 ammo 15
        0187: $BLIP_CARTEL12 = add_blip_for_char $CARTEL12_AS1
    end

    :C_C_5
end
return

:BAILOUT_D
if
    0038:   $FLAG_BAILOUT_D == 0
then
    0004: $FLAG_BAILOUT_D = 1
    0008: $COUNTER_BAILOUTS += 1
    0164: remove_blip $BLIP_CARTELCAR_D
    020A: set_car $CARTEL_CAR_D_AS1 door_status_to 1
    if and
        8118:   NOT   actor $CARTEL13_AS1 dead
        8119:   NOT   car $CARTEL_CAR_D_AS1 wrecked
    then
        01D3: actor $CARTEL13_AS1 leave_car $CARTEL_CAR_D_AS1
        while 00DB:   actor $CARTEL13_AS1 in_car $CARTEL_CAR_D_AS1
            wait 0 ms
            if or
                0118:   actor $CARTEL13_AS1 dead
                0119:   car $CARTEL_CAR_D_AS1 wrecked
            then
                jump @C_D_2
            end
        end
        011A: set_actor $CARTEL13_AS1 flags 1
        01B2: give_actor $CARTEL13_AS1 weapon 26 ammo 100  // Load the weapon model before using this
        0187: $BLIP_CARTEL13 = create_marker_above_actor $CARTEL13_AS1
    end

    :C_D_2
    if and
        8118:   NOT   actor $CARTEL14_AS1 dead
        8119:   NOT   car $CARTEL_CAR_D_AS1 wrecked
    then
        01D3: actor $CARTEL14_AS1 leave_car $CARTEL_CAR_D_AS1
        while 00DB:   actor $CARTEL14_AS1 in_car $CARTEL_CAR_D_AS1
            wait 0 ms
            if or
                0118:   actor $CARTEL14_AS1 dead
                0119:   car $CARTEL_CAR_D_AS1 wrecked
            then
                jump @C_D_3
            end
        end
        011A: set_actor $CARTEL14_AS1 flags 1
        01B2: give_actor $CARTEL14_AS1 weapon 26 ammo 100  // Load the weapon model before using this
        0187: $BLIP_CARTEL14 = create_marker_above_actor $CARTEL14_AS1
    end

    :C_D_3
    if and
        8118:   NOT   actor $CARTEL15_AS1 dead
        8119:   NOT   car $CARTEL_CAR_D_AS1 wrecked
    then
        01D3: actor $CARTEL15_AS1 leave_car $CARTEL_CAR_D_AS1
        while 00DB:   actor $CARTEL15_AS1 in_car $CARTEL_CAR_D_AS1
            wait 0 ms
            if or
                0118:   actor $CARTEL15_AS1 dead
                0119:   car $CARTEL_CAR_D_AS1 wrecked
            then
                jump @C_D_4
            end
        end
        011A: set_actor $CARTEL15_AS1 flags 1
        01B2: give_actor $CARTEL15_AS1 weapon 21 ammo 15  // Load the weapon model before using this
        0187: $BLIP_CARTEL15 = create_marker_above_actor $CARTEL15_AS1
    end

    :C_D_4
    if and
        8118:   NOT   actor $CARTEL16_AS1 dead
        8119:   NOT   car $CARTEL_CAR_D_AS1 wrecked
    then
        01D3: actor $CARTEL16_AS1 leave_car $CARTEL_CAR_D_AS1
        while 00DB:   actor $CARTEL16_AS1 in_car $CARTEL_CAR_D_AS1
            wait 0 ms
            if or
                0118:   actor $CARTEL16_AS1 dead
                0119:   car $CARTEL_CAR_D_AS1 wrecked
            then
                jump @C_D_5
            end
        end
        011A: set_actor $CARTEL16_AS1 flags 1
        01B2: give_actor $CARTEL16_AS1 weapon 26 ammo 100  // Load the weapon model before using this
        0187: $BLIP_CARTEL16 = create_marker_above_actor $CARTEL16_AS1
    end

    :C_D_5
end
return

:CARTEL_DEATHS
if
    0038:   $FLAG_CARTEL_A_CREATED == 1
then
    if
        0038:   $CARTEL1_AS1_DEAD == 0
    then
        if
            0118:   actor $CARTEL1_AS1 dead
        then
            if
                0038:   $CARTEL1_AS1_DEAD == 0
            then
                0004: $CARTEL1_AS1_DEAD = 1
                0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                0164: remove_blip $BLIP_CARTEL1
            end
        end
    end
    if
        0038:   $CARTEL2_AS1_DEAD == 0
    then
        if
            0118:   actor $CARTEL2_AS1 dead
        then
            if
                0038:   $CARTEL2_AS1_DEAD == 0
            then
                0004: $CARTEL2_AS1_DEAD = 1
                0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                0164: remove_blip $BLIP_CARTEL2
            end
        end
    end
    if
        0038:   $CARTEL3_AS1_DEAD == 0
    then
        if
            0118:   actor $CARTEL3_AS1 dead
        then
            if
                0038:   $CARTEL3_AS1_DEAD == 0
            then
                    0004: $CARTEL3_AS1_DEAD = 1
                    0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                    0164: remove_blip $BLIP_CARTEL3
                if
                    0038:   $YAK1_MISSION == 1
                then
                    0004: $YAK1_MISSION = 0
                end
            end
        end
    end
    if
        0038:   $CARTEL4_AS1_DEAD == 0
    then
        if
            0118:   actor $CARTEL4_AS1 dead
        then
            if
                0038:   $CARTEL4_AS1_DEAD == 0
            then
                0004: $CARTEL4_AS1_DEAD = 1
                0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                0164: remove_blip $BLIP_CARTEL4
            end
        end
    end
    if
        0038:   $CARTEL4_AS1_DEAD == 1
    then
        if
            0038:   $CARTEL3_AS1_DEAD == 1
        then
            if
                0038:   $CARTEL2_AS1_DEAD == 1
            then
                if
                    0038:   $CARTEL1_AS1_DEAD == 1
                then
                    if
                        0038:   $FLAG_BAILOUT_A == 0
                    then
                        0008: $COUNTER_BAILOUTS += 1
                        0004: $FLAG_BAILOUT_A = 1
                    end
                end
            end
        end
    end
end
if
    0038:   $FLAG_CARTEL_B_CREATED == 1
then
    if
        0038:   $CARTEL5_AS1_DEAD == 0
    then
        if
            0118:   actor $CARTEL5_AS1 dead
        then
            if
                0038:   $CARTEL5_AS1_DEAD == 0
            then
                0004: $CARTEL5_AS1_DEAD = 1
                0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                0164: remove_blip $BLIP_CARTEL5
            end
        end
    end
    if
        0038:   $CARTEL6_AS1_DEAD == 0
    then
        if
            0118:   actor $CARTEL6_AS1 dead
        then
            if
                0038:   $CARTEL6_AS1_DEAD == 0
            then
                0004: $CARTEL6_AS1_DEAD = 1
                0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                0164: remove_blip $BLIP_CARTEL6
            end
        end
    end
    if
        0038:   $CARTEL7_AS1_DEAD == 0
    then
        if
            0118:   actor $CARTEL7_AS1 dead
        then
            if
                0038:   $CARTEL7_AS1_DEAD == 0
            then
                0004: $CARTEL7_AS1_DEAD = 1
                0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                0164: remove_blip $BLIP_CARTEL7
            end
        end
    end
    if
        0038:   $CARTEL8_AS1_DEAD == 0
    then
        if
            0118:   actor $CARTEL8_AS1 dead
        then
            if
                0038:   $CARTEL8_AS1_DEAD == 0
            then
                0004: $CARTEL8_AS1_DEAD = 1
                0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                0164: remove_blip $BLIP_CARTEL8
                if
                   0038:   $YAK1_MISSION == 2
                then
                    0004: $YAK1_MISSION = 0
                end
            end
        end
    end
    if
        0038:   $CARTEL8_AS1_DEAD == 1
    then
        if
            0038:   $CARTEL7_AS1_DEAD == 1
        then
            if
                0038:   $CARTEL6_AS1_DEAD == 1
            then
                if
                    0038:   $CARTEL5_AS1_DEAD == 1
                then
                    if
                        0038:   $FLAG_BAILOUT_B == 0
                    then
                        0008: $COUNTER_BAILOUTS += 1
                        0004: $FLAG_BAILOUT_B = 1
                    end
                end
            end
        end
    end
end
if
    02BD:   debug_mode == DEBUG_MASTEREXTRAS2
then
    if
        $FLAG_CARTEL_C_CREATED == 1
    then
        if
            $CARTEL9_AS1_DEAD == 0
        then
            if
                0118:   is_char_dead $CARTEL9_AS1
            then
                if
                    $CARTEL9_AS1_DEAD == 0
                then
                    $CARTEL9_AS1_DEAD = 1
                    0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                    0164: remove_blip $BLIP_CARTEL9
                    if
                        $YAK1_MISSION == 3
                    then
                        $YAK1_MISSION = 0
                    end
                end
            end
        end

        if
            $CARTEL10_AS1_DEAD == 0
        then
            if
                0118:   is_char_dead $CARTEL10_AS1
            then
                if
                    $CARTEL10_AS1_DEAD == 0
                then
                    $CARTEL10_AS1_DEAD = 1
                    0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                    0164: remove_blip $BLIP_CARTEL10
                    if
                        $YAK1_MISSION == 4
                    then
                        $YAK1_MISSION = 0
                    end
                end
            end
        end

        if
            $CARTEL11_AS1_DEAD == 0
        then
            if
                0118:   is_char_dead $CARTEL11_AS1
            then
                if
                    $CARTEL11_AS1_DEAD == 0
                then
                    $CARTEL11_AS1_DEAD = 1
                    0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                    0164: remove_blip $BLIP_CARTEL11
                    if
                        $YAK1_MISSION == 5
                    then
                        $YAK1_MISSION = 0
                    end
                end
            end
        end

        if
            $CARTEL12_AS1_DEAD == 0
        then
            if
                0118:   is_char_dead $CARTEL12_AS1
            then
                if
                    $CARTEL12_AS1_DEAD == 0
                then
                    $CARTEL12_AS1_DEAD = 1
                    0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                    0164: remove_blip $BLIP_CARTEL12
                    if
                        $YAK1_MISSION == 6
                    then
                        $YAK1_MISSION = 0
                    end
                end
            end
        end

        if
            $CARTEL12_AS1_DEAD == 1
        then
            if
                $CARTEL11_AS1_DEAD == 1
            then
                if
                    $CARTEL10_AS1_DEAD == 1
                then
                    if
                        $CARTEL9_AS1_DEAD == 1
                    then
                        $FLAG_CARTEL_C_CREATED = 2
                    end
                end
            end
        end
    end
end
if
    0038:   $FLAG_CARTEL_D_CREATED == 1
then
    if
        0038:   $CARTEL13_AS1_DEAD == 0
    then
        if
            0118:   actor $CARTEL13_AS1 dead
        then
            if
                0038:   $CARTEL13_AS1_DEAD == 0
            then
                0004: $CARTEL13_AS1_DEAD = 1
                0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                0164: remove_blip $BLIP_CARTEL13
            end
        end
    end
    if
        0038:   $CARTEL14_AS1_DEAD == 0
    then
        if
            0118:   actor $CARTEL14_AS1 dead
        then
            if
                0038:   $CARTEL14_AS1_DEAD == 0
            then
                0004: $CARTEL14_AS1_DEAD = 1
                0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                0164: remove_blip $BLIP_CARTEL14
            end
        end
    end
    if
        0038:   $CARTEL15_AS1_DEAD == 0
    then
        if
            0118:   actor $CARTEL15_AS1 dead
        then
            if
                0038:   $CARTEL15_AS1_DEAD == 0
            then
                0004: $CARTEL15_AS1_DEAD = 1
                0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                0164: remove_blip $BLIP_CARTEL15
            end
        end
    end
    if
        0038:   $CARTEL16_AS1_DEAD == 0
    then
        if
            0118:   actor $CARTEL16_AS1 dead
        then
            if
                0038:   $CARTEL16_AS1_DEAD == 0
            then
                0004: $CARTEL16_AS1_DEAD = 1
                0008: $COUNTER_CARTELS_KILLED_AS1 += 1
                0164: remove_blip $BLIP_CARTEL16
                if
                    0038:   $YAK1_MISSION == 7
                then
                    0004: $YAK1_MISSION = 0
                end
            end
        end
    end
    if
        0038:   $CARTEL16_AS1_DEAD == 1
    then
        if
            0038:   $CARTEL15_AS1_DEAD == 1
        then
            if
                0038:   $CARTEL14_AS1_DEAD == 1
            then
                if
                    0038:   $CARTEL13_AS1_DEAD == 1
                then
                    if
                        0038:   $FLAG_BAILOUT_D == 0
                    then
                        0008: $COUNTER_BAILOUTS += 1
                        0004: $FLAG_BAILOUT_D = 1
                    end
                end
            end
        end
    end
end
return

:CARTEL_CAR_A_STUCK
if
    8119:   NOT   car $CARTEL_CAR_A_AS1 wrecked
then
    if and
        01F4:   car $CARTEL_CAR_A_AS1 flipped
        01C1:   car $CARTEL_CAR_A_AS1 stopped
    then
        if
            82CA:   NOT   car $CARTEL_CAR_A_AS1 bounding_sphere visible
        then
            00AA: store_car $CARTEL_CAR_A_AS1 position_to $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z
            03D3: point $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z get_nearby_vector $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z $CARTEL_HEADING
            if
                80C2:   NOT   sphere onscreen $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z 3.0
            then
                00AB: put_car $CARTEL_CAR_A_AS1 at $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z
                0175: set_car $CARTEL_CAR_A_AS1 z_angle_to $CARTEL_HEADING
                0450: set_james_car $CARTEL_CAR_A_AS1 on_path_to_player
            end
        else
            gosub @BAILOUT_A
        end
    end
    if
        02BF:   car $CARTEL_CAR_A_AS1 sunk
    then
        if
            82CA:   NOT   car $CARTEL_CAR_A_AS1 bounding_sphere visible
        then
            00AA: store_car $CARTEL_CAR_A_AS1 position_to $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z
            03D3: point $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z get_nearby_vector $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z $CARTEL_HEADING
            if
                80C2:   NOT   sphere onscreen $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z 3.0
            then
                00AB: put_car $CARTEL_CAR_A_AS1 at $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z
                0175: set_car $CARTEL_CAR_A_AS1 z_angle_to $CARTEL_HEADING
                0450: set_james_car $CARTEL_CAR_A_AS1 on_path_to_player
            end
        else
            0004: $FLAG_BAILOUT_A = 1
            0008: $COUNTER_BAILOUTS += 1
            0164: remove_blip $BLIP_CARTELCAR_A
            039C: set_car_watertight $CARTEL_CAR_A_AS1 0
            gosub @CARTEL_DEATHS
            return
        end
    end
else
    0164: remove_blip $BLIP_CARTELCAR_A
end
return

:CARTEL_CAR_B_STUCK
if
    8119:   NOT   car $CARTEL_CAR_B_AS1 wrecked
then
    if and
        01F4:   car $CARTEL_CAR_B_AS1 flipped
        01C1:   car $CARTEL_CAR_B_AS1 stopped
    then
        if
            82CA:   NOT   car $CARTEL_CAR_B_AS1 bounding_sphere visible
        then
            00AA: store_car $CARTEL_CAR_B_AS1 position_to $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z
            03D3: point $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z get_nearby_vector $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z $CARTEL_HEADING
            if
                80C2:   NOT   sphere onscreen $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z 3.0
            then
                00AB: put_car $CARTEL_CAR_B_AS1 at $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z
                0175: set_car $CARTEL_CAR_B_AS1 z_angle_to $CARTEL_HEADING
                0450: set_james_car $CARTEL_CAR_B_AS1 on_path_to_player
            end
        else
            gosub @BAILOUT_B
        end
    end
    if
        02BF:   car $CARTEL_CAR_B_AS1 sunk
    then
        if
            82CA:   NOT   car $CARTEL_CAR_B_AS1 bounding_sphere visible
        then
            00AA: store_car $CARTEL_CAR_B_AS1 position_to $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z
            03D3: point $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z get_nearby_vector $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z $CARTEL_HEADING
            if
                80C2:   NOT   sphere onscreen $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z 3.0
            then
                00AB: put_car $CARTEL_CAR_B_AS1 at $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z
                0175: set_car $CARTEL_CAR_B_AS1 z_angle_to $CARTEL_HEADING
                0450: set_james_car $CARTEL_CAR_B_AS1 on_path_to_player
            end
        else
            0004: $FLAG_BAILOUT_B = 1
            039C: set_car_watertight $CARTEL_CAR_B_AS1 0
            0008: $COUNTER_BAILOUTS += 1
            0164: remove_blip $BLIP_CARTELCAR_B
            gosub @CARTEL_DEATHS
            return
        end
    end
else
    0164: remove_blip $BLIP_CARTELCAR_B
end
return

:CARTEL_CAR_C_STUCK
if
    8119:   NOT is_car_dead $CARTEL_CAR_C_AS1
then
    if and
        01F4:   is_car_upsidedown $CARTEL_CAR_C_AS1
        01C1:   is_car_stopped $CARTEL_CAR_C_AS1
    then
        if
            82CA:   NOT is_car_on_screen $CARTEL_CAR_C_AS1
        then
            00AA: get_car_coordinates $CARTEL_CAR_C_AS1 $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z
            03D3: get_closest_car_node_with_heading $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z $CARTEL_HEADING
            if
                80C2:   NOT is_point_on_screen $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z 3.0
            then
                00AB: set_car_coordinates $CARTEL_CAR_C_AS1 $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z
                0175: set_car_heading    $CARTEL_CAR_C_AS1 $CARTEL_HEADING
            else
                gosub @BAILOUT_C
            end
        end
    end

    if
        02BF:   is_car_in_water $CARTEL_CAR_C_AS1
    then
        if
            82CA:   NOT is_car_on_screen $CARTEL_CAR_C_AS1
        then
            00AA: get_car_coordinates $CARTEL_CAR_C_AS1 $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z
            03D3: get_closest_car_node_with_heading $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z $CARTEL_HEADING
            if
                80C2:   NOT is_point_on_screen $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z 3.0
            then
                00AB: set_car_coordinates $CARTEL_CAR_C_AS1 $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z
                0175: set_car_heading    $CARTEL_CAR_C_AS1 $CARTEL_HEADING
            end
        else
            $FLAG_BAILOUT_C = 1
            0164: remove_blip    $BLIP_CARTELCAR_C
            gosub @CARTEL_DEATHS
            return
        end
    end
else
    0164: REMOVE_BLIP    $BLIP_CARTELCAR_C
end

return

:CARTEL_CAR_D_STUCK
if
    8119:   NOT   car $CARTEL_CAR_D_AS1 wrecked
then
    if and
        01F4:   car $CARTEL_CAR_D_AS1 flipped
        01C1:   car $CARTEL_CAR_D_AS1 stopped
    then
        if
            82CA:   NOT   car $CARTEL_CAR_D_AS1 bounding_sphere visible
        then
            00AA: store_car $CARTEL_CAR_D_AS1 position_to $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z
            03D3: point $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z get_nearby_vector $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z $CARTEL_HEADING
            if
                80C2:   NOT   sphere onscreen $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z 3.0
            then
                00AB: put_car $CARTEL_CAR_D_AS1 at $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z
                0175: set_car $CARTEL_CAR_D_AS1 z_angle_to $CARTEL_HEADING
                0450: set_james_car $CARTEL_CAR_D_AS1 on_path_to_player
            end
        else
            gosub @BAILOUT_D
        end
    end
    if
        02BF:   car $CARTEL_CAR_D_AS1 sunk
    then
       if
            82CA:   NOT   car $CARTEL_CAR_D_AS1 bounding_sphere visible
       then
            00AA: store_car $CARTEL_CAR_D_AS1 position_to $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z
            03D3: point $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z get_nearby_vector $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z $CARTEL_HEADING
            if
                80C2:   NOT   sphere onscreen $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z 3.0
            then
                00AB: put_car $CARTEL_CAR_D_AS1 at $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z
                0175: set_car $CARTEL_CAR_D_AS1 z_angle_to $CARTEL_HEADING
                0450: set_james_car $CARTEL_CAR_D_AS1 on_path_to_player
            end
       else
            0004: $FLAG_BAILOUT_D = 1
            039C: set_car_watertight $CARTEL_CAR_D_AS1 0
            0008: $COUNTER_BAILOUTS += 1
            0164: remove_blip $BLIP_CARTELCAR_D
            gosub @CARTEL_DEATHS
            return
       end
    end
else
    0164: remove_blip $BLIP_CARTELCAR_D
end
return

:VEGETABLES
if
    0038:   $FLAG_CARTEL_A_CREATED == 1
then
    if
        8119:   NOT   car $CARTEL_CAR_A_AS1 wrecked
    then
        if and
            0038:   $FLAG_BAILOUT_A == 0
            0038:   $FLAG_A_ATTACK == 1
        then
            gosub @CARTEL_CAR_A_STUCK
        end
    else
        0164: remove_blip $BLIP_CARTELCAR_A
    end
end
if
    0038:   $FLAG_CARTEL_B_CREATED == 1
then
    if
        8119:   NOT   car $CARTEL_CAR_B_AS1 wrecked
    then
        if and
            0038:   $FLAG_BAILOUT_B == 0
            0038:   $FLAG_B_ATTACK == 1
        then
            gosub @CARTEL_CAR_B_STUCK
        end
    else
        0164: remove_blip $BLIP_CARTELCAR_B
    end
end
if
    $MASTERLCEXTRAS == 1
then
    if
        $FLAG_CARTEL_C_CREATED == 1
    then
        if
            8119:   NOT   car $CARTEL_CAR_C_AS1 wrecked
        then
            if and
                $FLAG_BAILOUT_C == 0
                $FLAG_C_ATTACK == 1
            then
                gosub @CARTEL_CAR_C_STUCK
            end
        else
            0164: remove_blip $BLIP_CARTELCAR_C
        end
    end
end

if
    0038:   $FLAG_CARTEL_D_CREATED == 1
then
    if
        8119:   NOT   car $CARTEL_CAR_D_AS1 wrecked
    then
        if and
            0038:   $FLAG_BAILOUT_D == 0
            0038:   $FLAG_D_ATTACK == 1
        then
            gosub @CARTEL_CAR_D_STUCK
        end
    else
        0164: remove_blip $BLIP_CARTELCAR_D
    end
end
return

:BLIP_REMOVAL
0164: remove_blip $BLIP_CARTEL1
0164: remove_blip $BLIP_CARTEL2
0164: remove_blip $BLIP_CARTEL3
0164: remove_blip $BLIP_CARTEL4
0164: remove_blip $BLIP_CARTEL5
0164: remove_blip $BLIP_CARTEL6
0164: remove_blip $BLIP_CARTEL7
0164: remove_blip $BLIP_CARTEL8
0164: remove_blip $BLIP_CARTEL9
0164: remove_blip $BLIP_CARTEL10
0164: remove_blip $BLIP_CARTEL11
0164: remove_blip $BLIP_CARTEL12
0164: remove_blip $BLIP_CARTEL13
0164: remove_blip $BLIP_CARTEL14
0164: remove_blip $BLIP_CARTEL15
0164: remove_blip $BLIP_CARTEL16
if
    0038:   $FLAG_YAK1_DEAD == 0
then
    01C2: remove_references_to_actor $YAKUZA1_AS1  // Like turning an actor into a random pedestrian
end
if
    0038:   $FLAG_YAK2_DEAD == 0
then
    01C2: remove_references_to_actor $YAKUZA2_AS1  // Like turning an actor into a random pedestrian
end
if
    0038:   $FLAG_YAK3_DEAD == 0
then
    01C2: remove_references_to_actor $YAKUZA3_AS1  // Like turning an actor into a random pedestrian
end
if
    0038:   $FLAG_YAK4_DEAD == 0
then
    01C2: remove_references_to_actor $YAKUZA4_AS1  // Like turning an actor into a random pedestrian
end
if
    0038:   $FLAG_YAK5_DEAD == 0
then
    01C2: remove_references_to_actor $YAKUZA5_AS1  // Like turning an actor into a random pedestrian
end
if
    0038:   $FLAG_YAK6_DEAD == 0
then
    01C2: remove_references_to_actor $YAKUZA6_AS1  // Like turning an actor into a random pedestrian
end
return

:UNHAPPY_CAR_CHECK
01BD: $TIMER_AS3_NOW = current_time_in_ms
if
    001C:   $TIMER_AS3_NOW > $PARTICLE_TIME
then
    0084: $PARTICLE_TIME = $TIMER_AS3_NOW
    0008: $PARTICLE_TIME += 6000
    0004: $FLAG_PARTICLE = 1
end
if
    0038:   $FLAG_PARTICLE == 1
then
    if and
        8119:   NOT   car $CARTEL_CAR_A_AS1 wrecked
        0038:   $FLAG_A_ATTACK == 1
        0038:   $FLAG_BAILOUT_A == 0
    then
        0086: $CAR_A_X_OLD = $CAR_A_AS1_X
        0086: $CAR_A_Y_OLD = $CAR_A_AS1_Y
        //0086: $CAR_A_Z_OLD = $CAR_A_AS1_Z   not used
        00AA: store_car $CARTEL_CAR_A_AS1 position_to $CAR_A_AS1_X $CAR_A_AS1_Y $CAR_A_AS1_Z
        if
            01AD:   car $CARTEL_CAR_A_AS1 0 near_point $CAR_A_X_OLD $CAR_A_Y_OLD 3.0 3.0
        then
            if
                82CA:   NOT   car $CARTEL_CAR_A_AS1 bounding_sphere visible
            then
                03D3: point $CAR_A_AS1_X $CAR_A_AS1_Y $CAR_A_AS1_Z get_nearby_vector $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z $CARTEL_HEADING
                if
                    80C2:   NOT   sphere onscreen $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z 3.0
                then
                    00AB: put_car $CARTEL_CAR_A_AS1 at $CARTEL_CAR_A_AS1_X $CARTEL_CAR_A_AS1_Y $CARTEL_CAR_A_AS1_Z
                    0175: set_car $CARTEL_CAR_A_AS1 z_angle_to $CARTEL_HEADING
                    0450: set_james_car $CARTEL_CAR_A_AS1 on_path_to_player
                end
            end
        end
    end
    if and
        8119:   NOT   car $CARTEL_CAR_B_AS1 wrecked
        0038:   $FLAG_B_ATTACK == 1
        0038:   $FLAG_BAILOUT_B == 0
    then
        0086: $CAR_B_X_OLD = $CAR_B_AS1_X
        0086: $CAR_B_Y_OLD = $CAR_B_AS1_Y
        //0086: $CAR_B_Z_OLD = $CAR_B_AS1_Z
        00AA: store_car $CARTEL_CAR_B_AS1 position_to $CAR_B_AS1_X $CAR_B_AS1_Y $CAR_B_AS1_Z
        if
            01AD:   car $CARTEL_CAR_B_AS1 0 near_point $CAR_B_X_OLD $CAR_B_Y_OLD 3.0 3.0
        then
            if
                82CA:   NOT   car $CARTEL_CAR_B_AS1 bounding_sphere visible
            then
                03D3: point $CAR_B_AS1_X $CAR_B_AS1_Y $CAR_B_AS1_Z get_nearby_vector $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z $CARTEL_HEADING
                if
                    80C2:   NOT   sphere onscreen $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z 3.0
                then
                    00AB: put_car $CARTEL_CAR_B_AS1 at $CARTEL_CAR_B_AS1_X $CARTEL_CAR_B_AS1_Y $CARTEL_CAR_B_AS1_Z
                    0175: set_car $CARTEL_CAR_B_AS1 z_angle_to $CARTEL_HEADING
                    0450: set_james_car $CARTEL_CAR_B_AS1 on_path_to_player
                end
            end
        end
    end
    if
        02BD:   debug_mode == DEBUG_MASTEREXTRAS2
    then
        if and
            8119:   NOT   car $CARTEL_CAR_C_AS1 wrecked
            0038:   $FLAG_C_ATTACK == 1
            0038:   $FLAG_BAILOUT_C == 0
        then
            0086: $CAR_C_X_OLD = $CAR_C_AS1_X
            0086: $CAR_C_Y_OLD = $CAR_C_AS1_Y
            //0086: $CAR_C_Z_OLD = $CAR_C_AS1_Z
            00AA: store_car $CARTEL_CAR_C_AS1 position_to $CAR_C_AS1_X $CAR_C_AS1_Y $CAR_C_AS1_Z
            if
                01AD:   car $CARTEL_CAR_C_AS1 0 near_point $CAR_C_X_OLD $CAR_C_Y_OLD 3.0 3.0
            then
                if
                    82CA:   NOT   car $CARTEL_CAR_C_AS1 bounding_sphere visible
                then
                    03D3: point $CAR_C_AS1_X $CAR_C_AS1_Y $CAR_C_AS1_Z get_nearby_vector $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z $CARTEL_HEADING
                    if
                        80C2:   NOT   sphere onscreen $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z 3.0
                    then
                        00AB: put_car $CARTEL_CAR_C_AS1 at $CARTEL_CAR_C_AS1_X $CARTEL_CAR_C_AS1_Y $CARTEL_CAR_C_AS1_Z
                        0175: set_car $CARTEL_CAR_C_AS1 z_angle_to $CARTEL_HEADING
                        0450: set_james_car $CARTEL_CAR_C_AS1 on_path_to_player
                    end
                end
            end
        end
    end
    if and
        8119:   NOT   car $CARTEL_CAR_D_AS1 wrecked
        0038:   $FLAG_D_ATTACK == 1
        0038:   $FLAG_BAILOUT_D == 0
    then
        0086: $CAR_D_X_OLD = $CAR_D_AS1_X
        0086: $CAR_D_Y_OLD = $CAR_D_AS1_Y
        //0086: $CAR_D_Z_OLD = $CAR_D_AS1_Z
        00AA: store_car $CARTEL_CAR_D_AS1 position_to $CAR_D_AS1_X $CAR_D_AS1_Y $CAR_D_AS1_Z
        if
            01AD:   car $CARTEL_CAR_D_AS1 0 near_point $CAR_D_X_OLD $CAR_D_Y_OLD 3.0 3.0
        then
            if
                82CA:   NOT   car $CARTEL_CAR_D_AS1 bounding_sphere visible
            then
                03D3: point $CAR_D_AS1_X $CAR_D_AS1_Y $CAR_D_AS1_Z get_nearby_vector $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z $CARTEL_HEADING
                if
                    80C2:   NOT   sphere onscreen $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z 3.0
                then
                    00AB: put_car $CARTEL_CAR_D_AS1 at $CARTEL_CAR_D_AS1_X $CARTEL_CAR_D_AS1_Y $CARTEL_CAR_D_AS1_Z
                    0175: set_car $CARTEL_CAR_D_AS1 z_angle_to $CARTEL_HEADING
                    0450: set_james_car $CARTEL_CAR_D_AS1 on_path_to_player
                end
            end
        end
    end
    0004: $FLAG_PARTICLE = 0
end
return