:CAR_CRUSHER
thread 'CARCRSH'
0247: request_model 502
038B: load_all_models_now
// Speed (units/20ms)
3@ = 0.07
// Angular speed
4@ = 0.1
// Objects (we now have a proper crane!)
02FB: create_crusher_crane 784.75 51.75 800.75 56.0625 814.75 46.25 808.0 59.875 11.0 180.0
029B: $CRUSHER_BODY = init object #CRUSHERCRUSH at 804.73 60.3852  7.09806
01C7: remove_object $CRUSHER_BODY from_mission_cleanup_list
0392: object $CRUSHER_BODY toggle_in_moving_list 0

//space's independent lid, helis doesn't work
:CRUSHER_LID
0006: 0@ = 0  // 'skip reward' flag - set to 1 if player dies in the crusher
0107: $CRUSHER_LID = create object 502 at 804.55  65.0512  10.0
0453: object $CRUSHER_LID set_rotation  -90.0  0.0  0.0
while true
    wait 250 ms
    if
        0038:   $CRUSHER_HAS_CAR == 0
    then
        053E: $CRUSHER_CAR = get_random_car -1 in_area 801.63 57.8 814.0 63.3
        if
            8038:   NOT $CRUSHER_CAR == -1
        then
            if
                00B1:   car $CRUSHER_CAR 0 ()in_cube 801.63 57.8 5.0 814.0 63.3 20.0
            then
                0004: $CRUSHER_HAS_CAR = 1
                0004: $IS_CAR_CRUSHED = 1
                0007: 13@ = -90.0
                //Calculates vehicle class and car health used as modifier for reward
                0007: 1@ = 70.0                  // reward base value used for all models not listed below
                if  or                      // poorfamily
                    0137:   car $CRUSHER_CAR id == #ESPERANT
                    0137:   car $CRUSHER_CAR id == #IDAHO
                    0137:   car $CRUSHER_CAR id == #MANANA
                    0137:   car $CRUSHER_CAR id == #MOONBEAM
                    0137:   car $CRUSHER_CAR id == #PEREN
                    0137:   car $CRUSHER_CAR id == #RUMPO
                    0137:   car $CRUSHER_CAR id == #STALLION
                then
                    0007: 1@ = 30.0
                    jump @CC_REWARD
                end
                if  or                      // worker
                    0137:   car $CRUSHER_CAR id == #BOBCAT
                    0137:   car $CRUSHER_CAR id == #MULE
                    0137:   car $CRUSHER_CAR id == #PONY
                    0137:   car $CRUSHER_CAR id == #YANKEE
                then
                    0007: 1@ = 45.0
                    jump @CC_REWARD
                end
                if  or                      // taxi / normal / moped
                    0137:   car $CRUSHER_CAR id == #TAXI
                    0137:   car $CRUSHER_CAR id == #CABBIE
                    0137:   car $CRUSHER_CAR id == #MRWHOOP
                    0137:   car $CRUSHER_CAR id == #PATRIOT
                    0137:   car $CRUSHER_CAR id == #FAGGIO
                    0137:   car $CRUSHER_CAR id == #PIZZABOY
                then
                    0007: 1@ = 55.0
                    jump @CC_REWARD
                end
                if or                      // richfamily / motorbike
                    0137:   car $CRUSHER_CAR id == #BLISTA
                    0137:   car $CRUSHER_CAR id == #KURUMA
                    0137:   car $CRUSHER_CAR id == #LANDSTAL
                    0137:   car $CRUSHER_CAR id == #ANGEL
                    0137:   car $CRUSHER_CAR id == #FREEWAY
                    0137:   car $CRUSHER_CAR id == #PCJ600
                    0137:   car $CRUSHER_CAR id == #SANCHEZ
                then
                    0007: 1@ = 85.0
                    jump @CC_REWARD
                end
                if or                      // big
                    0137:   car $CRUSHER_CAR id == #BUS
                    0137:   car $CRUSHER_CAR id == #COACH
                    0137:   car $CRUSHER_CAR id == #FLATBED
                    0137:   car $CRUSHER_CAR id == #LINERUN
                    0137:   car $CRUSHER_CAR id == #SECURICA
                    0137:   car $CRUSHER_CAR id == #TRASH
                then
                    0007: 1@ = 100.0
                    jump @CC_REWARD
                end
                if or                      // executive
                    0137:   car $CRUSHER_CAR id == #BANSHEE
                    0137:   car $CRUSHER_CAR id == #CHEETAH
                    0137:   car $CRUSHER_CAR id == #INFERNUS
                    0137:   car $CRUSHER_CAR id == #SENTINEL
                    0137:   car $CRUSHER_CAR id == #STINGER
                    0137:   car $CRUSHER_CAR id == #STRETCH
                then
                    0007: 1@ = 115.0
                end

                :CC_REWARD
                0227: 2@  = car $CRUSHER_CAR health // used as modifier for reward
                008F: 2@ = integer to float 2@
                0017: 2@ /= 1000.0                 // max health is 1000, so we need to divide by this factor
                006B: 1@ *= 2@
                008E: 1@ = float 1@ to integer
                wait 3250 ms                       // synchronize movement of magnet and lid
                //close lid
                while 0033:   0.0 >= 13@
                    wait 25 ms
                    000B: 13@ +=  1.0
                    0453: object $CRUSHER_LID set_rotation 13@ 0.0 0.0
                end
                0453: object $CRUSHER_LID set_rotation 0.0 0.0 0.0
                if
                    0256:   player $PLAYER defined
                then
                    if
                        0057:   player $PLAYER 0 ()in_cube 801.63 57.8 5.0 814.0 63.3 20.0 //player in crusher
                    then
                        0222: set_player $PLAYER health_to 0
                        0006: 0@ = 1  // disables reward
                    end
                end
                // actual crushing process - move object etc.
                0006: 4@ = 0  // switch used to alternate between left and right
                0006: 5@ = 2000  // time span for shaking until vehicle is destroyed
                0006: 6@ = 5    // determines frequency
                0006: 16@ = 0
                gosub @CC_SHAKE
                00A6: destroy_car $CRUSHER_CAR
                0006: 5@ = 1000  // time span for shaking after vehicle is destroyed
                0006: 16@ = 0
                gosub @CC_SHAKE
                // end of crushing, give reward if player wasn't killed in the crusher
                if and
                    0256:   player $PLAYER defined
                    0039:   0@ == 0
                then
                    0109: player $PLAYER money += 1@
                end
                while 0021:    13@  >  -90.0
                    wait  25 ms
                    000F:  13@ -=  1.0
                    0453: object $CRUSHER_LID set_rotation  13@  0.0  0.0
                end
                0453: object $CRUSHER_LID set_rotation -90.0 0.0 0.0
                0006: 0@ = 0
                0004: $CRUSHER_HAS_CAR = 0
                //040D: unload_wav 2
                $IS_CAR_CRUSHED = 0
                $IS_CAR_PICKED_UP = 0
            end
        end
    end
end
// emulates shaking animation, currently 5 states
:CC_SHAKE
if
    0019:   16@ > 5@
    //0039:   3@ == 0
then
    return
end
if
    0039:   4@ == 0
then //move left
    01BC: put_object $CRUSHER_BODY at 804.70 60.3852  7.09806
    wait 6@ ms
    01BC: put_object $CRUSHER_BODY at 804.67 60.3852  7.09806
    wait 6@ ms
    01BC: put_object $CRUSHER_BODY at 804.70 60.3852  7.09806
    wait 6@ ms
    01BC: put_object $CRUSHER_BODY at 804.73 60.3852  7.09806
    0006: 4@ = 1 // left
    jump @CC_SHAKE
else // move right
    01BC: put_object $CRUSHER_BODY at 804.76 60.3852  7.09806
    wait 6@ ms
    01BC: put_object $CRUSHER_BODY at 804.79 60.3852  7.09806
    wait 6@ ms
    01BC: put_object $CRUSHER_BODY at 804.76 60.3852  7.09806
    wait 6@ ms
    01BC: put_object $CRUSHER_BODY at 804.73 60.3852  7.09806
    0006: 4@ = 0 // right
    jump @CC_SHAKE
end
