//-------------Mission 79-------------
// Originally: Catalina 'THE EXCHANGE'

:M79_THEEXCHANGE
03A4: name_thread 'CAT1'
054C: use_GXT_table 'FINALE'
058E: set_restart_mission_taxi_destination -698.75 235.7 66.25 90.0
gosub @MISSION_START_CAT1
if
    wasted_or_busted
then
    gosub @MISSION_CAT1_FAILED
end
gosub @MISSION_CLEANUP_CAT1
end_thread

:MISSION_START_CAT1
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION =  1
0004: $ON_MISSION_FOR_CATALINA =  1
wait  0 ms
0004: $ADDED_THE_BLIP_FOR_MARIA =  0
0004: $BEEN_ON_HELI_PAD =  0
0004: $SET_AS_LEADER_BEFORE =  0
0004: $MARIA_CREATED_BEFORE =  0
0004: $CAMERA_CUT =  0
015C: set_zone_gang_info 'WEE_DAM' 1 (day)  0 0 0 0 0 0 0 0 0 0 0
015C: set_zone_gang_info 'WEE_DAM' 0 (night)  0 0 0 0 0 0 0 0 0 0 0
0152: set_zone_car_info 'WEE_DAM' 1 (day)  0 0 0 0 0 0 0 0 0 0 0
0152: set_zone_car_info 'WEE_DAM' 0 (night)  0 0 0 0 0 0 0 0 0 0 0
0110: clear_player $PLAYER wanted_level
023C: load_special_actor  1 'PLAYER'
023C: load_special_actor  2 'MARIA'
023C: load_special_actor  3 'CAT'
023C: load_special_actor  4 'COL2'  // actually used by cutscene
023C: load_special_actor  5 'COLROB'
02F3: load_object #CUTOBJ01 'FULCASE'
02F3: load_object #CUTOBJ02 'CATH'
0247: request_model #GANG11
0247: request_model #GANG12
0247: request_model #COLUMB
0247: request_model #FLATBED
0247: request_model #MAVERICK
0247: request_model #COLT45
0247: request_model #ROCKET
0247: request_model #UZI
0247: request_model #FLAME
0247: request_model #AK47
0247: request_model #M16
0247: request_model #NEW_COLMANSN
0247: request_model #LANDPART15
0247: request_model #SECURITY_HUT
0247: request_model #COLUMANSION_WALL
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor  1 loaded
        823D:   NOT   special_actor  2 loaded
        823D:   NOT   special_actor  3 loaded
        823D:   NOT   special_actor  4 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
    jf break
    wait  0 ms
end
while true
    if or
        8248:   NOT   model #GANG11 available
        8248:   NOT   model #GANG12 available
        8248:   NOT   model #MAVERICK available
        8248:   NOT   model #COLT45 available
        8248:   NOT   model #ROCKET available
    jf break
    wait  0 ms
end
while true
    if or
        8248:   NOT   model #UZI available
        8248:   NOT   model #FLAME available
        8248:   NOT   model #AK47 available
        8248:   NOT   model #M16 available
    jf break
    wait  0 ms
end
while true
    if or
        8248:   NOT   model #COLUMB available
        8248:   NOT   model #NEW_COLMANSN available
        8248:   NOT   model #LANDPART15 available
        8248:   NOT   model #SECURITY_HUT available
        8248:   NOT   model #COLUMANSION_WALL available
    jf break
    wait  0 ms
end
03CB: set_camera -698.5  243.5  65.25
02E4: load_cutscene_data 'C1_TEX'
0244: set_cutscene_pos -693.5  249.1875  65.3125
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_MARIA = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_MARIA 'MARIA'
02E5: $CUTCSENE_CAT = create_cutscene_object #SPECIAL03
02E6: set_cutscene_anim $CUTCSENE_CAT 'CAT'
02E5: $CS_COLOB2 = create_cutscene_object #SPECIAL05
02E6: set_cutscene_anim $CS_COLOB2 'COLROB'
02E5: $CS_COLOB3 = create_cutscene_object #GANG11
02E6: set_cutscene_anim $CS_COLOB3 'GANG11'
02E5: $CS_COLOB4 = create_cutscene_object #GANG12
02E6: set_cutscene_anim $CS_COLOB4 'GANG12'
02E5: $CS_CASE = create_cutscene_object #CUTOBJ01
02E6: set_cutscene_anim $CS_CASE 'FULCASE'
//02F4: create_cutscene_actor $CAT_CSHEAD from_head #CUTOBJ02 and_body $CUTCSENE_CAT
//02F5: set_head_anim $CAT_CSHEAD 'CAT'
00A5: $COLOMBIAN_CAR1 = create_car #COLUMB at -757.875  291.75  67.75
0175: set_car $COLOMBIAN_CAR1 z_angle_to  226.0
009A: $COLOMBIAN_GUARD1 = create_actor  12 #GANG11 at -730.375  293.375 -100.0
01B2: give_actor $COLOMBIAN_GUARD1 weapon  23 ammo  200  // Load the weapon model before using this
009A: $COLOMBIAN_GUARD3 = create_actor  12 #GANG11 at -703.0625  252.375 -100.0
01B2: give_actor $COLOMBIAN_GUARD3 weapon  23 ammo  200  // Load the weapon model before using this
0173: set_actor $COLOMBIAN_GUARD3 z_angle_to  0.0
009A: $COLOMBIAN_GUARD4 = create_actor  12 #GANG12 at -693.0  251.75 -100.0
01B2: give_actor $COLOMBIAN_GUARD4 weapon  23 ammo  200  // Load the weapon model before using this
0173: set_actor $COLOMBIAN_GUARD4 z_angle_to  0.0
009A: $COLOMBIAN_GUARD12 = create_actor  12 #GANG11 at -727.375  301.0  76.6875
01B2: give_actor $COLOMBIAN_GUARD12 weapon  25 ammo  200  // Load the weapon model before using this
0173: set_actor $COLOMBIAN_GUARD12 z_angle_to  0.0
0350: set_char_stay_in_same_place $COLOMBIAN_GUARD12   1
009A: $COLOMBIAN_GUARD13 = create_actor  12 #GANG12 at -709.0  301.0  76.6875
01B2: give_actor $COLOMBIAN_GUARD13 weapon  25 ammo  200  // Load the weapon model before using this
0173: set_actor $COLOMBIAN_GUARD13 z_angle_to  0.0
0350: set_char_stay_in_same_place $COLOMBIAN_GUARD13   1
03BF: set_player $PLAYER ignored_by_everyone_to  1 (true)
020F: actor $COLOMBIAN_GUARD1 look_at_player $PLAYER
020F: actor $COLOMBIAN_GUARD12 look_at_player $PLAYER
020F: actor $COLOMBIAN_GUARD13 look_at_player $PLAYER
0395: clear_area 1 at -697.75 246.5 60.0 range 4.5
009A: $COLOMBIAN_GUARD2 = create_actor  12 #GANG12 at -715.0625  282.5625 -100.0
0173: set_actor $COLOMBIAN_GUARD2 z_angle_to  229.0
0223: set_actor $COLOMBIAN_GUARD2 health_to  0
016A: fade  1 (back)  1500 ms
03AD: set_rubbish  0 (invisible)
03AF: set_streaming  1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:    22000 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
0055: set_player_coordinates $PLAYER at -698.25  253.0 -100.0
while 001A:    32166 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'CAT2_A'  10000 ms  2  // The real question is, did you turn up to rescue Maria or to get me back?
while 001A:    38548 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'CAT2_B'  10000 ms  2  // Well I got news for you,
while 001A:    40043 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'CAT2_B2'  10000 ms  2  // shooting you will be a pleasure but dating you was only business.
while 001A:    43684 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'CAT2_C'  10000 ms  2  // You are muy peccinno amigo!
while 001A:    45711 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'CAT2_D'  10000 ms  2  // Throw over the cash.
while 001A:    52048 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'CAT2_E'  10000 ms  2  // You have been a busy boy!
while 001A:    54527 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'CAT2_E2'  10000 ms  2  // But you haven't learned, I'm not to be trusted.
while 001A:    57558 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'CAT2_E3'  10000 ms  2  // Kill the idiot.
while 001A:    58661 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BE: text_clear_all
while 001A:    65000 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BE: text_clear_all
032B: $DEAD_GUARDS_GUN = create_weapon_pickup #COLT45  3 ammo  48 at -715.0625  282.5625  68.5625
0395: clear_area 1 at -716.75 284.0 62.875 range 1.0
0055: set_player_coordinates $PLAYER at -716.75  284.0 -100.0
0171: set_player $PLAYER z_angle_to  232.0
while 82E9:   NOT cutscene_reached_end
    wait  0 ms
end
03AD: set_rubbish  1 (visible)
02EA: clear_cutscene
03BF: set_player $PLAYER ignored_by_everyone_to  1 (true)
0373: set_camera_directly_behind_player
03B8: clear_weapons_from_player $PLAYER
if
    0038:   $NICKED_HALF_A_MIL_BEFORE ==  0
then
    0109: player $PLAYER money += -500000
    0004: $NICKED_HALF_A_MIL_BEFORE =  1
end
0296: unload_special_actor  1
0296: unload_special_actor  4
0296: unload_special_actor  5
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #NEW_COLMANSN
0249: mark_model_as_no_longer_needed #LANDPART15
0249: mark_model_as_no_longer_needed #SECURITY_HUT
0249: mark_model_as_no_longer_needed #COLUMANSION_WALL
while 8248:   NOT   model #FLATBED available
    wait  0 ms
end
00BC: print_now 'CATINF1'  5000 ms  2  // ~g~Get Catalina!
wait  1000 ms
03BF: set_player $PLAYER ignored_by_everyone_to  0 (false)
0004: $COUNTDOWN_CAT1 =  421000
014E: set_timer_to $COUNTDOWN_CAT1 type 1
if and
    8118:   NOT   actor $COLOMBIAN_GUARD1 dead
    8118:   NOT   actor $COLOMBIAN_GUARD2 dead
    8118:   NOT   actor $COLOMBIAN_GUARD12 dead
    8118:   NOT   actor $COLOMBIAN_GUARD13 dead
then
    01CC: actor $COLOMBIAN_GUARD1 kill_player $PLAYER
    011A: set_actor $COLOMBIAN_GUARD1 flags  1
    01CC: actor $COLOMBIAN_GUARD2 kill_player $PLAYER
    011A: set_actor $COLOMBIAN_GUARD2 flags  1
    01CC: actor $COLOMBIAN_GUARD12 kill_player $PLAYER
    011A: set_actor $COLOMBIAN_GUARD12 flags  1
    01CC: actor $COLOMBIAN_GUARD13 kill_player $PLAYER
    011A: set_actor $COLOMBIAN_GUARD13 flags  1
end
if and
    8118:   NOT   actor $COLOMBIAN_GUARD3 dead
    8118:   NOT   actor $COLOMBIAN_GUARD4 dead
then
    011A: set_actor $COLOMBIAN_GUARD3 flags  1
    011A: set_actor $COLOMBIAN_GUARD4 flags  1
end
022B: switch_ped_roads_off -1277.5625  337.0  16.0 -1288.5625  361.375  36.0
while 0057:   player $PLAYER  0 ()in_cube -783.0  241.6875  56.0 -627.375  365.1875  96.0
    wait  0 ms
    if
        0038:   $COUNTDOWN_CAT1 ==  0
    then
        jump @MISSION_CAT1_FAILED
    end
    0110: clear_player $PLAYER wanted_level
end
//03B2: start_catalina_heli
0004: $ESCAPE_CHOPPER = -1
004F: create_thread @START_CATALINA_HELI
while 0038:   $ESCAPE_CHOPPER == -1
    wait  0 ms
    //03B9: grab_catalina_heli $ESCAPE_CHOPPER
end
wait  1000 ms
if
    8119:   NOT   car $ESCAPE_CHOPPER wrecked
then
    0186: $PRE_CUTSCENE_ELAPSED_TIME8 = create_marker_above_car $ESCAPE_CHOPPER
    018B: change_blip $PRE_CUTSCENE_ELAPSED_TIME8 display 2
    015F: set_camera_position -699.5  243.6875  68.6875  0.0  0.0  0.0
    0158: camera_on_vehicle $ESCAPE_CHOPPER  15  1
    02A3: toggle_widescreen  1 (on)
    01B4: set_player $PLAYER can_move  0 (frozen)
    01F7: set_player $PLAYER ignored_by_cops_state_to  1 (true)
    03BF: set_player $PLAYER ignored_by_everyone_to  1 (true)
    02AC: set_car $ESCAPE_CHOPPER immunities  1  1  1  1  1
end
if
    00E0:   player $PLAYER driving
then
    0221: set_player $PLAYER trapped_in_car  1
end
wait  5000 ms
015A: restore_camera
02A3: toggle_widescreen  0 (off)
01B4: set_player $PLAYER can_move  1 (unfrozen)
0221: set_player $PLAYER trapped_in_car  0
01F7: set_player $PLAYER ignored_by_cops_state_to  0 (false)
03BF: set_player $PLAYER ignored_by_everyone_to  0 (false)
if
    00E0:   player $PLAYER driving
then
    0221: set_player $PLAYER trapped_in_car  0
end
00BC: print_now 'CATINF2'  5000 ms  2  // ~g~Follow the chopper to find Catalina.
while 8121:   NOT   player $PLAYER in_zone 'BIG_DAM'
    wait  0 ms
    if
        0038:   $COUNTDOWN_CAT1 ==  0
    then
        00BC: print_now 'OUTTIME'  5000 ms  1  // ~r~Too slow, man, too slow!
        jump @MISSION_CAT1_FAILED
    end
    if
        //03B5:   catalina_shot_down
        0119:   car $ESCAPE_CHOPPER wrecked
    then
        jump @END_OF_GAME
    end
    0110: clear_player $PLAYER wanted_level
end //while
03F1: pedtype  12 add_threat  1
0237: set_gang  5 primary_weapon_to  23 secondary_weapon_to  25
01C2: remove_references_to_actor $COLOMBIAN_GUARD1  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_GUARD2  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_GUARD3  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_GUARD4  // Like turning an actor into a random pedestrian
00A5: $COLOMBIAN_CAR6 = create_car #COLUMB at -1281.75  310.0 -100.0
0175: set_car $COLOMBIAN_CAR6 z_angle_to  104.6875
00A5: $COLOMBIAN_CAR7 = create_car #COLUMB at -1287.25  310.25 -100.0
0175: set_car $COLOMBIAN_CAR7 z_angle_to  78.75
009A: $COLOMBIAN_GUARD14 = create_actor  12 #GANG11 at -1290.5  309.6875 -100.0
0173: set_actor $COLOMBIAN_GUARD14 z_angle_to  220.0
011A: set_actor $COLOMBIAN_GUARD14 flags  1
01B2: give_actor $COLOMBIAN_GUARD14 weapon  25 ammo  500  // Load the weapon model before using this
009A: $COLOMBIAN_GUARD15 = create_actor  12 #GANG12 at -1278.0  311.0 -100.0
0173: set_actor $COLOMBIAN_GUARD15 z_angle_to  176.0
011A: set_actor $COLOMBIAN_GUARD15 flags  1
01B2: give_actor $COLOMBIAN_GUARD15 weapon  25 ammo  500  // Load the weapon model before using this
00A5: $COLOMBIAN_CAR2 = create_car #COLUMB at -1370.688  464.0625 -100.0
0175: set_car $COLOMBIAN_CAR2 z_angle_to  194.0
00A5: $COLOMBIAN_CAR3 = create_car #COLUMB at -1368.75  458.875 -100.0
0175: set_car $COLOMBIAN_CAR3 z_angle_to  330.75
032B: $ROCKET_LAUNCH = create_weapon_pickup #ROCKET  3 ammo  3 at -1484.688  347.6875  37.375
while 8057:   NOT   player $PLAYER 0 ()in_cube -1245.4449  306.841  45.514 -1573.59  504.646  5.5139
    wait  0 ms
    if
        0038:   $COUNTDOWN_CAT1 ==  0
    then
        00BC: print_now 'OUTTIME'  5000 ms  1  // ~r~Too slow, man, too slow!
        jump @MISSION_CAT1_FAILED
    end
    if
        //03B5:   catalina_shot_down
        0119:   car $ESCAPE_CHOPPER wrecked
    then
        jump @END_OF_GAME
    end
    0110: clear_player $PLAYER wanted_level
end //while
01F7: set_player $PLAYER ignored_by_cops_state_to  1 (true)
while 8057:   NOT   player $PLAYER  0 ()in_cube -1262.375  391.5  56.0 -1459.25  485.0625  6.0
    wait  0 ms
    if
        0038:   $COUNTDOWN_CAT1 ==  0
    then
        jump @MISSION_CAT1_FAILED
    end
    if
        //03B5:   catalina_shot_down
        0119:   car $ESCAPE_CHOPPER wrecked
    then
        jump @END_OF_GAME
    end
    0110: clear_player $PLAYER wanted_level
end //while
01C2: remove_references_to_actor $COLOMBIAN_GUARD14  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COLOMBIAN_GUARD15  // Like turning an actor into a random pedestrian
01C3: remove_references_to_car $COLOMBIAN_CAR6  // Like turning a car into any random car
01C3: remove_references_to_car $COLOMBIAN_CAR7  // Like turning a car into any random car
009A: $COLOMBIAN_GUARD5 = create_actor  12 #GANG11 at -1372.188  467.875 -100.0
0173: set_actor $COLOMBIAN_GUARD5 z_angle_to  272.0
011A: set_actor $COLOMBIAN_GUARD5 flags  1
01B2: give_actor $COLOMBIAN_GUARD5 weapon  26 ammo  500  // Load the weapon model before using this
009A: $COLOMBIAN_GUARD6 = create_actor  12 #GANG12 at -1370.0  454.75 -100.0
0173: set_actor $COLOMBIAN_GUARD6 z_angle_to  247.0
011A: set_actor $COLOMBIAN_GUARD6 flags  1
01B2: give_actor $COLOMBIAN_GUARD6 weapon  26 ammo  500  // Load the weapon model before using this
009A: $COLOMBIAN_GUARD7 = create_actor  12 #GANG11 at -1422.75  472.0 -100.0
0173: set_actor $COLOMBIAN_GUARD7 z_angle_to  237.0
0350: set_char_stay_in_same_place $COLOMBIAN_GUARD7   1
011A: set_actor $COLOMBIAN_GUARD7 flags  1
01B2: give_actor $COLOMBIAN_GUARD7 weapon  26 ammo  500  // Load the weapon model before using this
02E2: set_actor $COLOMBIAN_GUARD7 weapon_accuracy_to  40
009A: $COLOMBIAN_GUARD8 = create_actor  12 #GANG12 at -1477.25  445.25 -100.0
0173: set_actor $COLOMBIAN_GUARD8 z_angle_to  287.0
0350: set_char_stay_in_same_place $COLOMBIAN_GUARD8   1
011A: set_actor $COLOMBIAN_GUARD8 flags  1
01B2: give_actor $COLOMBIAN_GUARD8 weapon  26 ammo  500  // Load the weapon model before using this
02E2: set_actor $COLOMBIAN_GUARD8 weapon_accuracy_to  40
00A5: $COLOMBIAN_CAR4 = create_car #FLATBED at -1421.062  464.375 -100.0
0175: set_car $COLOMBIAN_CAR4 z_angle_to  215.0
00A5: $COLOMBIAN_CAR5 = create_car #FLATBED at -1509.75  406.875 -100.0
0175: set_car $COLOMBIAN_CAR5 z_angle_to  322.0
00A5: $COLOMBIAN_CAR8 = create_car #FLATBED at -1499.188  393.6875 -100.0
0175: set_car $COLOMBIAN_CAR8 z_angle_to  23.75
009A: $COLOMBIAN_GUARD16 = create_actor  12 #GANG11 at -1400.25  453.75 -100.0
0173: set_actor $COLOMBIAN_GUARD16 z_angle_to  289.0
011A: set_actor $COLOMBIAN_GUARD16 flags  1
01B2: give_actor $COLOMBIAN_GUARD16 weapon  25 ammo  500  // Load the weapon model before using this
0350: set_char_stay_in_same_place $COLOMBIAN_GUARD16   1
009A: $COLOMBIAN_GUARD17 = create_actor  12 #GANG12 at -1401.25  475.75 -100.0
0173: set_actor $COLOMBIAN_GUARD17 z_angle_to  224.0
011A: set_actor $COLOMBIAN_GUARD17 flags  1
01B2: give_actor $COLOMBIAN_GUARD17 weapon  25 ammo  500  // Load the weapon model before using this
009A: $COLOMBIAN_GUARD18 = create_actor  12 #GANG11 at -1439.875  440.0625 -100.0
0173: set_actor $COLOMBIAN_GUARD18 z_angle_to  292.0
011A: set_actor $COLOMBIAN_GUARD18 flags  1
01B2: give_actor $COLOMBIAN_GUARD18 weapon  26 ammo  500  // Load the weapon model before using this
009A: $COLOMBIAN_GUARD19 = create_actor  12 #GANG12 at -1460.375  448.75 -100.0
0173: set_actor $COLOMBIAN_GUARD19 z_angle_to  272.0
011A: set_actor $COLOMBIAN_GUARD19 flags  1
01B2: give_actor $COLOMBIAN_GUARD19 weapon  26 ammo  500  // Load the weapon model before using this
0350: set_char_stay_in_same_place $COLOMBIAN_GUARD19   1
009A: $COLOMBIAN_GUARD22 = create_actor  12 #GANG12 at -1494.5  424.1875 -100.0
0173: set_actor $COLOMBIAN_GUARD22 z_angle_to  278.0
011A: set_actor $COLOMBIAN_GUARD22 flags  1
01B2: give_actor $COLOMBIAN_GUARD22 weapon  25 ammo  500  // Load the weapon model before using this
009A: $COLOMBIAN_GUARD23 = create_actor  12 #GANG12 at -1505.0  379.875 -100.0
0173: set_actor $COLOMBIAN_GUARD23 z_angle_to  309.0
011A: set_actor $COLOMBIAN_GUARD23 flags  1
01B2: give_actor $COLOMBIAN_GUARD23 weapon  25 ammo  500  // Load the weapon model before using this
009A: $COLOMBIAN_GUARD24 = create_actor  12 #GANG12 at -1506.688  384.75 -100.0
0173: set_actor $COLOMBIAN_GUARD24 z_angle_to  309.0
011A: set_actor $COLOMBIAN_GUARD24 flags  1
01B2: give_actor $COLOMBIAN_GUARD24 weapon  26 ammo  500  // Load the weapon model before using this
009A: $COLOMBIAN_GUARD26 = create_actor  12 #GANG12 at -1491.75  407.5 -100.0
0173: set_actor $COLOMBIAN_GUARD26 z_angle_to  319.0
011A: set_actor $COLOMBIAN_GUARD26 flags  1
01B2: give_actor $COLOMBIAN_GUARD26 weapon  26 ammo  500  // Load the weapon model before using this
while 8057:   NOT   player $PLAYER  0 ()in_cube -1446.188  446.0  26.0 -1556.688  366.5625  36.0
    wait  0 ms
    if
        0038:   $COUNTDOWN_CAT1 ==  0
    then
        00BC: print_now 'OUTTIME'  5000 ms  1  // ~r~Too slow, man, too slow!
        jump @MISSION_CAT1_FAILED
    end
    if
        //03B5:   catalina_shot_down
        0119:   car $ESCAPE_CHOPPER wrecked
    then
        jump @END_OF_GAME
    end
    0110: clear_player $PLAYER wanted_level
end //while
01C3: remove_references_to_car $COLOMBIAN_CAR2  // Like turning a car into any random car
01C3: remove_references_to_car $COLOMBIAN_CAR3  // Like turning a car into any random car
009A: $COLOMBIAN_GUARD9 = create_actor  12 #GANG11 at -1518.0  370.875 -100.0
0173: set_actor $COLOMBIAN_GUARD9 z_angle_to  342.0
011A: set_actor $COLOMBIAN_GUARD9 flags  1
01B2: give_actor $COLOMBIAN_GUARD9 weapon  31 ammo  1000  // Load the weapon model before using this
02E2: set_actor $COLOMBIAN_GUARD9 weapon_accuracy_to  30
009A: $COLOMBIAN_GUARD10 = create_actor  12 #GANG12 at -1539.875  343.0 -100.0
0173: set_actor $COLOMBIAN_GUARD10 z_angle_to  342.0
011A: set_actor $COLOMBIAN_GUARD10 flags  1
01B2: give_actor $COLOMBIAN_GUARD10 weapon  31 ammo  1000  // Load the weapon model before using this
0350: set_char_stay_in_same_place $COLOMBIAN_GUARD10   1
009A: $COLOMBIAN_GUARD20 = create_actor  12 #GANG11 at -1523.5  368.0 -100.0
0173: set_actor $COLOMBIAN_GUARD20 z_angle_to  7.0
011A: set_actor $COLOMBIAN_GUARD20 flags  1
01B2: give_actor $COLOMBIAN_GUARD20 weapon  26 ammo  1000  // Load the weapon model before using this
02E2: set_actor $COLOMBIAN_GUARD20 weapon_accuracy_to  30
0350: set_char_stay_in_same_place $COLOMBIAN_GUARD20   1
009A: $COLOMBIAN_GUARD21 = create_actor  12 #GANG11 at -1511.25  357.0625 -100.0
0173: set_actor $COLOMBIAN_GUARD21 z_angle_to  58.0
011A: set_actor $COLOMBIAN_GUARD21 flags  1
01B2: give_actor $COLOMBIAN_GUARD21 weapon  25 ammo  1000  // Load the weapon model before using this
02E2: set_actor $COLOMBIAN_GUARD21 weapon_accuracy_to  30
0350: set_char_stay_in_same_place $COLOMBIAN_GUARD21   1
009A: $COLOMBIAN_GUARD25 = create_actor  12 #GANG11 at -1534.375  334.0625 -100.0
0173: set_actor $COLOMBIAN_GUARD25 z_angle_to  3.0
011A: set_actor $COLOMBIAN_GUARD21 flags  1
01B2: give_actor $COLOMBIAN_GUARD25 weapon  25 ammo  1000  // Load the weapon model before using this
02E2: set_actor $COLOMBIAN_GUARD25 weapon_accuracy_to  30
0350: set_char_stay_in_same_place $COLOMBIAN_GUARD25   1
009A: $MARIA = create_actor  21 #SPECIAL02 at -1536.562  338.5625 -100.0
02AB: set_actor $MARIA immunities  1  1  1  1  1
0245: set_actor $MARIA walk_style_to  43
022D: set_actor $MARIA to_look_at_player $PLAYER
0173: set_actor $MARIA z_angle_to  339.0
0004: $MARIA_CREATED_BEFORE =  1
009A: $CATALINA = create_actor  21 #SPECIAL03 at -1517.0  346.0625 -100.0
02AB: set_actor $CATALINA immunities  1  1  1  1  1
0245: set_actor $CATALINA walk_style_to  43
if
    8118:   NOT   actor $CATALINA dead
then
    015F: set_camera_position -1525.562  334.375  38.0625  0.0  0.0  0.0
    0159: camera_on_ped $MARIA  15  2
    01B4: set_player $PLAYER can_move  0 (frozen)
    02A3: toggle_widescreen  1 (on)
    03BF: set_player $PLAYER ignored_by_everyone_to  1 (true)
    if
        00E0:   player $PLAYER driving
    then
        0221: set_player $PLAYER trapped_in_car  1
    end
    03CF: load_wav 'C_1' as 1
    wait  3000 ms
    if
        8118:   NOT   actor $CATALINA dead
    then
        0159: camera_on_ped $CATALINA  15  1
        0239: actor $CATALINA run_to -1492.0  336.1
        00BC: print_now 'CAT2_J'  3000 ms  2  // Get this thing airborne!!
    end
    while 83D0:   NOT   wav_loaded 1
        wait  0 ms
    end
    03D1: play_wav 1
end
wait 3000 ms
if
    03D2:   wav 1 ended
then
    040D: unload_wav 1
end
02A3: toggle_widescreen  0 (off)
01B4: set_player $PLAYER can_move  1 (unfrozen)
02EB: restore_camera_jumpcut
//009B: destroy_actor_instantly $CATALINA
03BF: set_player $PLAYER ignored_by_everyone_to  0 (false)
if
    00E0:   player $PLAYER driving
then
    0221: set_player $PLAYER trapped_in_car  0
end
wait  1000 ms
if
    8118:   NOT   actor $MARIA dead
then
    02AB: set_actor $MARIA immunities  0  0  0  0  0
end
if
    8119:   NOT   car $ESCAPE_CHOPPER wrecked
then
    02AC: set_car $ESCAPE_CHOPPER immunities  0  0  0  0  0
    004F: create_thread @CATALINA_HELI_TAKE_OFF
    //03B3: catalina_heli_take_off
end
if
    8119:   NOT   car $COLOMBIAN_CAR5 wrecked
then
    0129: $COLOMBIAN_GUARD11 = create_actor  12 #GANG12 in_car $COLOMBIAN_CAR5 driverseat
    01B2: give_actor $COLOMBIAN_GUARD11 weapon  25 ammo  300  // Load the weapon model before using this
    00AF: set_car $COLOMBIAN_CAR5 mission 2  // MISSION_RAMPLAYER_FARAWAY
    00AD: set_car $COLOMBIAN_CAR5 max_speed_to  40.0
    00AE: set_car $COLOMBIAN_CAR5 driving_style 3  // DRIVINGMODE_PLOUGHTHROUGH
end
while 8119:   NOT car $ESCAPE_CHOPPER wrecked   //83B5:   NOT   catalina_shot_down
    wait  0 ms
    0054: store_player $PLAYER position_to $PLAYERX_CAT $PLAYERY_CAT $PLAYERZ_CAT
    if
        0038:   $COUNTDOWN_CAT1 ==  0
    then
        00BC: print_now 'OUTTIME'  5000 ms  1  // ~r~Too slow, man, too slow!
        jump @MISSION_CAT1_FAILED
    end
    if
        0118:   actor $MARIA dead
    then
        00BC: print_now 'BITCH_D'  5000 ms  1  // ~g~Maria's dead!
        jump @MISSION_CAT1_FAILED
    end
    if
        00FC:   player $PLAYER  0 ()near_actor $MARIA on_foot radius  10.0  10.0  3.0
    then
        if
            0038:   $SET_AS_LEADER_BEFORE ==  0
        then
            022F: set_actor $MARIA stop_looking
            01DF: tie_actor $MARIA to_player $PLAYER
            0004: $SET_AS_LEADER_BEFORE =  1
        end
    else
        if
            0038:   $SET_AS_LEADER_BEFORE ==  1
        then
            0004: $SET_AS_LEADER_BEFORE =  0
        end
    end
    if
        0057:   player $PLAYER  0 ()in_cube -1477.0  327.75  35.0 -1550.562  368.375  46.0
    then
        if
            0038:   $BEEN_ON_HELI_PAD ==  0
        then
            if
                8118:   NOT   actor $COLOMBIAN_GUARD10 dead
            then
                0350: set_char_stay_in_same_place $COLOMBIAN_GUARD10   0
                01CC: actor $COLOMBIAN_GUARD10 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $COLOMBIAN_GUARD20 dead
            then
                0350: set_char_stay_in_same_place $COLOMBIAN_GUARD20   0
                01CC: actor $COLOMBIAN_GUARD20 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $COLOMBIAN_GUARD21 dead
            then
                0350: set_char_stay_in_same_place $COLOMBIAN_GUARD21   0
                01CC: actor $COLOMBIAN_GUARD21 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $COLOMBIAN_GUARD25 dead
            then
                0350: set_char_stay_in_same_place $COLOMBIAN_GUARD25   0
                01CC: actor $COLOMBIAN_GUARD25 kill_player $PLAYER
            end
            0004: $BEEN_ON_HELI_PAD =  1
        end
    end
    0110: clear_player $PLAYER wanted_level
end //while

:END_OF_GAME
0169: set_fade_color  255  255  255
016A: fade  0 ()  500 ms
014F: stop_timer $COUNTDOWN_CAT1
0164: remove_blip $PRE_CUTSCENE_ELAPSED_TIME8
00A6: destroy_car $ESCAPE_CHOPPER
$ESCAPE_CHOPPER = -1
//03B4: remove_catalina_heli
if
    0038:   $MARIA_CREATED_BEFORE ==  0
then
    009A: $MARIA = create_actor  21 #SPECIAL02 at -1536.562  338.5625 -100.0
    02AB: set_actor $MARIA immunities  1  1  1  1  1
    0245: set_actor $MARIA walk_style_to  43
    022D: set_actor $MARIA to_look_at_player $PLAYER
    0173: set_actor $MARIA z_angle_to  339.0
end
016A: fade  1 (back)  500 ms
while 8320:   NOT   actor $MARIA in_range_of_player $PLAYER
    wait  0 ms
    if
        0118:   actor $MARIA dead
    then
        00BC: print_now 'BITCH_D'  5000 ms  1  // ~g~Maria's dead!
        jump @MISSION_CAT1_FAILED
    end
    if
        8320:   NOT   actor $MARIA in_range_of_player $PLAYER
    then
        if
            0038:   $ADDED_THE_BLIP_FOR_MARIA ==  0
        then
            0187: $MARIAS_BLIP = create_marker_above_actor $MARIA
            0004: $ADDED_THE_BLIP_FOR_MARIA =  1
        end
    else
        if
            0038:   $ADDED_THE_BLIP_FOR_MARIA ==  1
        then
            0164: remove_blip $MARIAS_BLIP
            0004: $ADDED_THE_BLIP_FOR_MARIA =  0
        end
    end
    if
        00FC:   player $PLAYER  0 ()near_actor $MARIA on_foot radius  10.0  10.0  3.0
    then
        if
            0038:   $SET_AS_LEADER_BEFORE ==  0
        then
            022F: set_actor $MARIA stop_looking
            01DF: tie_actor $MARIA to_player $PLAYER
            0004: $SET_AS_LEADER_BEFORE =  1
        end
    else
        if
            0038:   $SET_AS_LEADER_BEFORE ==  1
        then
            0004: $SET_AS_LEADER_BEFORE =  0
        end
    end
    if
        0057:   player $PLAYER  0 ()in_cube -1477.0  327.75  35.0 -1550.562  368.375  46.0
    then
        if
            0038:   $BEEN_ON_HELI_PAD ==  0
        then
            if
                8118:   NOT   actor $COLOMBIAN_GUARD10 dead
            then
                0350: set_char_stay_in_same_place $COLOMBIAN_GUARD10   0
                01CC: actor $COLOMBIAN_GUARD10 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $COLOMBIAN_GUARD20 dead
            then
                0350: set_char_stay_in_same_place $COLOMBIAN_GUARD20   0
                01CC: actor $COLOMBIAN_GUARD20 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $COLOMBIAN_GUARD21 dead
            then
                0350: set_char_stay_in_same_place $COLOMBIAN_GUARD21   0
                01CC: actor $COLOMBIAN_GUARD21 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $COLOMBIAN_GUARD25 dead
            then
                0350: set_char_stay_in_same_place $COLOMBIAN_GUARD25   0
                01CC: actor $COLOMBIAN_GUARD25 kill_player $PLAYER
            end
            0004: $BEEN_ON_HELI_PAD =  1
        end
    end
    0110: clear_player $PLAYER wanted_level
end //while
01BD: $PRE_CUTSCENE_START_TIME = current_time_in_ms
0004: $PRE_CUTSCENE_ELAPSED_TIME =  0
while true
    if and
        83EE:   NOT   player $PLAYER controllable
        001A:    5000 > $PRE_CUTSCENE_ELAPSED_TIME //    if player is not in control after 5 secs do the cutscene anyway
    jf break
    wait  0 ms
    if
        0118:   actor $MARIA dead
    then
        00BC: print_now 'BITCH_D'  5000 ms  1  // ~g~Maria's dead!
        jump @MISSION_CAT1_FAILED
    end
    01BD: $PRE_CUTSCENE_CURRENT_TIME = current_time_in_ms
    0084: $PRE_CUTSCENE_ELAPSED_TIME = $PRE_CUTSCENE_CURRENT_TIME
    0060: $PRE_CUTSCENE_ELAPSED_TIME -= $PRE_CUTSCENE_START_TIME
end //while
03EF: player $PLAYER make_safe
0110: clear_player $PLAYER wanted_level
0169: set_fade_color  0  0  0
016A: fade  0 ()  1500 ms
0006:  16@ =  0
01B6: set_weather  0
while 001B:    1500 >  16@
    wait  0 ms
end
023C: load_special_actor  1 'PLAYER'
023C: load_special_actor  2 'MARIA'
while true
    if or
        823D:   NOT   special_actor  1 loaded
        823D:   NOT   special_actor  2 loaded
    jf break
    wait  0 ms
end
02E4: load_cutscene_data 'END'
0451: load_end_of_game_tune
0244: set_cutscene_pos -1366.75  451.75  28.5
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_MARIA = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_MARIA 'MARIA'
if
    8118:   NOT   actor $COLOMBIAN_GUARD8 dead
then
    0223: set_actor $COLOMBIAN_GUARD8 health_to  0
end
016A: fade  1 (back)  1500 ms
03AD: set_rubbish  0 (invisible)
02E7: start_cutscene
043F: play_end_of_game_tune
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:    5507 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_A'  10000 ms  2  // Residents in Cedar Grove have been coming to terms
while 001A:    7855 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_B'  10000 ms  2  // with the emotional aftermath of a full blown war
while 001A:    10313 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_C'  10000 ms  2  // that hit the area yesterday.
while 001A:    13610 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_D'  10000 ms  2  // Local resident, Clive Denver described to police
while 001A:    16428 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_E'  10000 ms  2  // a single gunman that he saw fleeing the scene, with a dark haired woman.
while 001A:    20514 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_F'  10000 ms  2  // Oh, you know, we're gonna have such fun, 'cos you know, you know,
while 001A:    22827 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_G'  10000 ms  2  // I love you, I, I, I, I really do, 'cos you're such a big strong man
while 001A:    26173 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_H'  10000 ms  2  // and that's just what I need.
while 001A:    28028 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_I'  10000 ms  2  // Anyway, what was I saying?
while 001A:    29276 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_J'  10000 ms  2  // Oh, you know, I forget. But you know what it's like, don't you?
while 001A:    31901 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_K'  10000 ms  2  // The sound of explosions shook nearby homes as people ran for cover.
while 001A:    35772 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_L'  10000 ms  2  // Several citizens were injured in the panic as ground fire was exchanged
while 001A:    38820 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_M'  10000 ms  2  // between ground forces and a helicopter circling the dam.
while 001A:    42136 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_N'  10000 ms  2  // Yeah, we got a good view from down here in the gardens.
while 001A:    44646 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_O'  10000 ms  2  // When the 'copter finally got taken out,
while 001A:    46971 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_P'  10000 ms  2  // better than the fireworks on the 4th of July.
while 001A:    49254 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_Q'  10000 ms  2  // With the death toll already over twenty,
while 001A:    51621 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_R'  10000 ms  2  // police are still finding bodies.
while 001A:    54000 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_S'  10000 ms  2  // There have been no official denials concerning rumours
while 001A:    56584 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_T'  10000 ms  2  // that the dead were members of the Colombian Cartel,
while 001A:    59278 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'END_U'  4000 ms  2  // and still no leads as to the cause of the massacre.
while 001A:    66666 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
043C: set_music_does_fade  0
0169: set_fade_color  1  1  1
016A: fade  0 ()  2000 ms
while fading
    wait  0 ms
end
while 82E9:   NOT cutscene_reached_end
    wait  0 ms
end
00BE: text_clear_all
02EA: clear_cutscene
gosub @MISSION_START_CREDITS
jump @MISSION_CAT1_PASSED

:MISSION_CAT1_FAILED
00BA: text_styled 'M_FAIL'  5000 ms  1  // MISSION FAILED!
if
    8118:   NOT   actor $MARIA dead
then
    034F: remove_char_elegantly $MARIA
end
return

:MISSION_CAT1_PASSED
0004: $THE_EXCHANGE_COMPLETED =  1
// 0004: $FLAG_ALL_MISSIONS_DONE =  1    not used anywhere else in the code
0110: clear_player $PLAYER wanted_level
0318: set_latest_mission_passed 'CAT2'  // 'THE EXCHANGE'
030C: set_mission_points +=  1
0164: remove_blip $COLOMBIAN_MANSION_MARKER
014C: set_parked_car_generator $SPECIAL_TANK cars_to_generate_to  101
014C: set_parked_car_generator $LC_HELI02 cars_to_generate_to  101
034C: shoreside_complete
return

:MISSION_CLEANUP_CAT1
0004: $FLAG_PLAYER_ON_MISSION =  0
0004: $ON_MISSION_FOR_CATALINA =  0
0249: mark_model_as_no_longer_needed #GANG11
0249: mark_model_as_no_longer_needed #GANG12
0249: mark_model_as_no_longer_needed #COLUMB
0249: mark_model_as_no_longer_needed #FLATBED
0249: mark_model_as_no_longer_needed #MAVERICK
0249: mark_model_as_no_longer_needed #COLT45
0249: mark_model_as_no_longer_needed #ROCKET
0249: mark_model_as_no_longer_needed #UZI
0249: mark_model_as_no_longer_needed #FLAME
0249: mark_model_as_no_longer_needed #AK47
0249: mark_model_as_no_longer_needed #M16
0296: unload_special_actor  1
0296: unload_special_actor  2
0296: unload_special_actor  3
0296: unload_special_actor  4
014F: stop_timer $COUNTDOWN_CAT1
022A: switch_ped_roads_on -1277.5625  337.0  16.0 -1288.5625  361.375  36.0
0164: remove_blip $PRE_CUTSCENE_ELAPSED_TIME8
0164: remove_blip $MARIAS_BLIP
009B: destroy_actor_instantly $CATALINA
//03B4: remove_catalina_heli
00A6: destroy_car $ESCAPE_CHOPPER
$ESCAPE_CHOPPER = -1
0215: destroy_pickup $ROCKET_LAUNCH
0215: destroy_pickup $DEAD_GUARDS_GUN
015C: set_zone_gang_info 'WEE_DAM' 1 (day)  8 0 0 0 0 0 100 0 0 0 0
015C: set_zone_gang_info 'WEE_DAM' 0 (night)  5 0 0 0 0 0 100 0 0 0 0
0152: set_zone_car_info 'WEE_DAM' 1 (day)  0 0 0 0 0 0 0 0 0 0 0
0152: set_zone_car_info 'WEE_DAM' 0 (night)  0 0 0 0 0 0 0 0 0 0 0
mission_cleanup
return

:MISSION_START_CREDITS
wait  0 ms
01B4: set_player $PLAYER can_move  0 (frozen)
03BF: set_player $PLAYER ignored_by_everyone_to  1 (true)
0336: set_player_visible $PLAYER  0
03AD: set_rubbish  0 (invisible)
02A3: toggle_widescreen  1 (on)
0109: player $PLAYER money +=  1000000
0434: show_credits
0006:  16@ =  0
00C0: set_current_time  2  40
jump @FIRST_CREDITS_LOOP

while 8436:   NOT   reached_end_of_credits
    wait  0 ms
    if
        0038:   $CAMERA_CUT ==  0
    then
        016A: fade  0 ()  1500 ms
        while fading
            wait  0 ms
            if
                0019:    16@ >  1000    //was 40000 - allows you to skip cutscene right away
            then
                if
                    00E1:   key_pressed  0  16
                then
                    jump @FINAL_FINAL_SCENE
                end
            end
        end //while

        :FIRST_CREDITS_LOOP
        0055: set_player_coordinates $PLAYER at -696.875  248.0 -100.0
        015F: set_camera_position -699.375  265.0625  88.8125  0.0  0.0  0.0
        0160: point_camera -698.9375  264.1875  88.625  2
        0006:  17@ =  0
        while 001B:    20000 >  17@
            wait  0 ms
            if
                0019:    16@ >  1000    //was 40000 - allows you to skip cutscene right away
            then
                if
                    00E1:   key_pressed  0  16
                then
                    jump @FINAL_FINAL_SCENE
                end
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        016A: fade  1 (back)  1500 ms
        0006:  17@ =  0
        while 001B:    30000 >  17@
            wait  0 ms
            if
                0019:    16@ >  1000    //was 40000 - allows you to skip cutscene right away
            then
                if
                    00E1:   key_pressed  0  16
                then
                    jump @FINAL_FINAL_SCENE
                end
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        0004: $CAMERA_CUT =  1
    end
    if
        0038:   $CAMERA_CUT ==  1
    then
        016A: fade  0 ()  1500 ms
        while fading
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        0055: set_player_coordinates $PLAYER at -1509.25 -7.0 -100.0
        015F: set_camera_position -1511.438 -17.6875  81.9375  0.0  0.0  0.0
        0160: point_camera -1510.688 -17.0  81.8125  2
        00C0: set_current_time  5  40
        0006:  17@ =  0
        while 001B:    20000 >  17@
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        016A: fade  1 (back)  1500 ms
        0006:  17@ =  0
        while 001B:    30000 >  17@
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        0004: $CAMERA_CUT =  2
    end
    if
        0038:   $CAMERA_CUT ==  2
    then
        016A: fade  0 ()  1500 ms
        while fading
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        0055: set_player_coordinates $PLAYER at -803.6875 -3.25 -100.0
        015F: set_camera_position -748.0625  19.25  60.375  0.0  0.0  0.0
        0160: point_camera -748.9375  18.9375  60.0  2
        0006:  17@ =  0
        while 001B:    20000 >  17@
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        016A: fade  1 (back)  1500 ms
        0006:  17@ =  0
        while 001B:    30000 >  17@
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        0004: $CAMERA_CUT =  3
    end
    if
        0038:   $CAMERA_CUT ==  3
    then
        016A: fade  0 ()  1500 ms
        while fading
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //whie
        0055: set_player_coordinates $PLAYER at -1190.6875 -717.25 -100.0
        015F: set_camera_position -1294.5 -656.375  61.4375  0.0  0.0  0.0
        0160: point_camera -1293.625 -656.875  61.25  2
        00C0: set_current_time  22  0
        0006:  17@ =  0
        while 001B:    20000 >  17@
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        016A: fade  1 (back)  1500 ms
        0006:  17@ =  0
        while 001B:    30000 >  17@
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        0004: $CAMERA_CUT =  4
    end
    if
        0038:   $CAMERA_CUT ==  4
    then
        016A: fade  0 ()  1500 ms
        while fading
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        0055: set_player_coordinates $PLAYER at -867.6875 -611.6875  49.25
        015F: set_camera_position -906.5625 -611.125  73.5625  0.0  0.0  0.0
        0160: point_camera -905.6875 -611.5625  73.4375  2
        0006:  17@ =  0
        while 001B:    20000 >  17@
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        016A: fade  1 (back)  1500 ms
        0006:  17@ =  0
        while 001B:    30000 >  17@
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        0004: $CAMERA_CUT =  5
    end
    if
        0038:   $CAMERA_CUT ==  5
    then
        016A: fade  0 ()  1500 ms
        while fading
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        0055: set_player_coordinates $PLAYER at -1006.5625 -155.875 -100.0
        015F: set_camera_position -1041.5625 -219.0625  31.75  0.0  0.0  0.0
        0160: point_camera -1041.125 -218.1875  31.6875  2
        00C0: set_current_time  1  20
        01B6: set_weather  2
        0006:  17@ =  0
        while 001B:    20000 >  17@
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        016A: fade  1 (back)  1500 ms
        0006:  17@ =  0
        while 001B:    40000 >  17@
            wait  0 ms
            if
                00E1:   key_pressed  0  16
            then
                jump @FINAL_FINAL_SCENE
            end
            if
                0436:   reached_end_of_credits
            then
                jump @FINAL_FINAL_SCENE
            end
        end //while
        0004: $CAMERA_CUT =  0
    end
end //while

:FINAL_FINAL_SCENE
0435: end_credits
00C0: set_current_time  7  0
043C: set_music_does_fade  1
016A: fade  0 ()  2000 ms
while fading
    wait  0 ms
end
0336: set_player_visible $PLAYER  1
0222: set_player $PLAYER health_to  100
0395: clear_area 1 at -1001.75 -1.75 18.75 range 2.0
0055: set_player_coordinates $PLAYER at -1001.75 -1.75 -100.0
03CB: set_camera -1001.75 -1.75  25.0
0171: set_player $PLAYER z_angle_to  180.0
009B: destroy_actor_instantly $MARIA
02EB: restore_camera_jumpcut
03C8: set_camera_in_front_of_player
02A3: toggle_widescreen  0 (off)
0006:  17@ =  0
0004: $FLAG_PLAYER_ON_MISSION =  0
0004: $ON_MISSION_FOR_CATALINA =  0
0006:  17@ =  0
while 001B:    2500 >  17@
    wait  0 ms
end
016A: fade  1 (back)  2000 ms
0440: stop_cutscene_music
while fading
    wait  0 ms
end
return
