// -------------------------------------------------------
// ALL VARIABLES DEFINED BELOW UNLOCK FEATURES OF THE CODE
// -------------------------------------------------------
:DEBUG_VARIABLES
//0004: $MASTERLCDEBUG                = 1 // Set to 1 for open city at start (ie. no story start), car spawn and extra abilities at start (replaced with 02BD: DEBUG_MASTERDEBUG)
0004: $MASTERLCEXTRAS1              = 1 // Set to 1 for Building Warp, Extra Parked Cars, and Airport Helicopters
//0004: $MASTERLCEXTRAS2              = 1 // Set to 1 for extra code that R* commented out: Ton1, Kenji2, Bait, and Espresso-2-Go (replaced with 02BD: DEBUG_MASTEREXTRAS2)
//0004: $MASTERLCPACKAGESCOMPLETED    = 0 // Set to 1 to have 100 hidden packages rewards (replaced with 02BD: DEBUG_MASTERPACKAGESCOMPLETED)
//0004: $MASTERLCPARAMEDICCOMPLETED   = 0 // Set to 1 to have level 12 paramedic reward (infinite run) (replaced with 02BD: DEBUG_MASTERPARAMEDICCOMPLETED)
//0004: $MASTERLCVIGILANTECOMPLETED   = 0 // Set to 1 to have all vigilante rewards (bribes at hideout) (replaced with 02BD: DEBUG_MASTERVIGILANTECOMPLETED)
//0004: $MASTERLCFIREFIGHTERCOMPLETED = 0 // Set to 1 to have firefighter reward (flamethrower) (replaced with 02BD: DEBUG_MASTERFIREFIGHTERCOMPLETED)
//0004: $MASTERLCIEGARAGESCOMPLETED   = 0 // Set to 1 to complete the 2 IE garages and EV crane (replaced with 02BD: DEBUG_MASTERIEGARAGESCOMPLETED)
//0004: $MASTERLC100COMPLETED         = 0 // Set to 1 to have all the 100% rewards (replaced with 02BD: DEBUG_MASTER100COMPLETED)
//0004: $SKIP_HELP                    = 0 // Set to 1 to hide the usual help/pager messages (replaced with 02BD: DEBUG_SKIPHELP)
return

:STARTER         //This thread is here to start the first mission for every boss if $MASTERLCDEBUG is on
03A4: name_thread 'TMP_THR'
0111: set_deatharrest_state 0 (disabled)

wait 1000 ms
if
    02BD:   debug_mode == DEBUG_MASTERDEBUG
then                                                    // Starter treads
    004F: create_thread @COORDS                         // Enable if you need coordinates display in DEBUG mode
    004F: create_thread @MEAT_MISSION1_LOOP          //THE CROOK
    //004F: create_thread @MEAT_MISSION2_LOOP           //THE THIEVES
    //004F: create_thread @MEAT_MISSION3_LOOP           //THE WIFE
    //004F: create_thread @MEAT_MISSION4_LOOP           //HER LOVER
    004F: create_thread @DIABLO_PHONE_START
    004F: create_thread @YARDIE_PHONE_START
    004F: create_thread @HOOD_PHONE_START
    004F: create_thread @JOEYS_BUGGY_LOOP

    004F: create_thread @CRAIGSCODE                   //Craig's custom code, for the DeLorean and General Lee
    004F: create_thread @DELGLSPAWN                   //Spawns DeLorean and General Lee
    004F: create_thread @CARSPAWN                     //Spawns PCJ and Hunter

    03A5: garage $GARAGE_BANK type 7 #SECURICA
    034B: commerical_passed

    //0055: set_player_coordinates $PLAYER at  560.75 -425.75 19.875

    02A7: $LUIGI_MISSION_MARKER = create_icon_marker_and_sphere 16 at 557.75 -425.75 19.875
    004F: create_thread @LUIGI_MISSION2_LOOP          //DONT SPANK MA BITCH UP
    //004F: create_thread @LUIGI_MISSION3_LOOP          //DRIVE MISTY FOR ME
    //004F: create_thread @LUIGI_MISSION4_LOOP          //PUMP ACTION PIMP
    //004F: create_thread @LUIGI_MISSION5_LOOP          //THE FUZZ BALL

    //0055: set_player_coordinates $PLAYER at  856.69 -873.0  20.3

    02A7: $JOEY_MISSION_MARKER = create_icon_marker_and_sphere  13 at  856.69 -870.0  20.3
    004F: create_thread @JOEY_MISSION1_LOOP           //MIKE LIPS LAST LUNCH
    //004F: create_thread @JOEY_MISSION2_LOOP           //FAREWELL CHUNK YLEE CHONG
    //004F: create_thread @JOEY_MISSION3_LOOP           //VAN HEIST
    //004F: create_thread @JOEY_MISSION4_LOOP           //CIPRIANIS CHAUFFEUR
    //004F: create_thread @JOEY_MISSION5_LOOP           //DEAD SKUNK IN THE TRUNK
    //004F: create_thread @JOEY_MISSION6_LOOP           //THE GETAWAY

    //0055: set_player_coordinates $PLAYER at 884.56 -324.0 33.5

    02A7: $TONI_MISSION_MARKER = create_icon_marker_and_sphere 22 at 884.56 -321.0 33.5
    004F: create_thread @TONI_MISSION1_LOOP             //TAKING OUT THE LAUNDRY
    //004F: create_thread @TONI_MISSION2_LOOP             //THE PICKUP
    //004F: create_thread @TONI_MISSION3_LOOP             //SALVATORES CALLED A MEETING
    //004F: create_thread @TONI_MISSION4_LOOP             //TRIADS AND TRIBULATIONS
    //004F: create_thread @TONI_MISSION5_LOOP             //BLOW FISH

    //0055: set_player_coordinates $PLAYER at  1123.69 -187.25 62.5625

    02A7: $SALVATORE_MISSION_MARKER = create_icon_marker_and_sphere 19 at 1120.69 -187.25 62.5625
    004F: create_thread @FRANKIE_MISSION1_LOOP          //CHAPERONE
    //004F: create_thread @FRANKIE_MISSION2_LOOP          //CUTTING THE GRASS
    //004F: create_thread @FRANKIE_MISSION21_LOOP         //BOMB DA BASE ACT I
    //004F: create_thread @FRANKIE_MISSION3_LOOP          //BOMB DA BASE ACT II
    //004F: create_thread @FRANKIE_MISSION4_LOOP          //LAST REQUESTS

    //0055: set_player_coordinates $PLAYER at  188.688 -644.0 22.0625

    02A7: $ASUKA_MISSION_MARKER = create_icon_marker_and_sphere 4 at 188.688 -643.0 22.0625
    004F: create_thread @ASUKA_MISSION1_LOOP            //SAYONARA SALVATORE
    //004F: create_thread @ASUKA_MISSION2_LOOP            //UNDER SURVEILLANCE
    //004F: create_thread @ASUKA_MISSION3_LOOP            //PAPARAZZI PURGE
    //004F: create_thread @ASUKA_MISSION4_LOOP            //PAYDAY FOR RAY
    //004F: create_thread @ASUKA_MISSION5_LOOP            //TWO FACED TANNER

    //0055: set_player_coordinates $PLAYER at  121.3 -1415.4 32.2

    02A7: $KENJI_MISION_MARKER = create_icon_marker_and_sphere 14 at 124.062 -1413.0 32.0625
    004F: create_thread @KENJI_MISSION1_LOOP            //KANBU BUST OUT
    //004F: create_thread @KENJI_MISSION2_LOOP            //GRAND THEFT AUTO
    //004F: create_thread @KENJI_MISSION3_LOOP            //DEAL STEAL
    //004F: create_thread @KENJI_MISSION4_LOOP            //SHIMA
    //004F: create_thread @KENJI_MISSION5_LOOP            //SMACKDOWN

    //0055: set_player_coordinates $PLAYER at  -293.25 -725.375 28.75

    02A7: $RAY_MISSION_MARKER = create_icon_marker_and_sphere 18 at -296.25 -725.375 28.75
    004F: create_thread @RAY_MISSION1_LOOP              //SILENCE THE SNEAK
    //004F: create_thread @RAY_MISSION2_LOOP              //ARMS SHORTAGE
    //004F: create_thread @RAY_MISSION3_LOOP              //EVIDENCE DASH
    //004F: create_thread @RAY_MISSION4_LOOP              //GONE FISHING
    //004F: create_thread @RAY_MISSION5_LOOP              //PLASTER BLASTER
    //004F: create_thread @RAY_MISSION6_LOOP              //MARKED MAN

    //0055: set_player_coordinates $PLAYER at  -250.9375 -1548.6899 34.25

    02A7: $DONALD_MISSION_MARKER = create_icon_marker_and_sphere 9 at -248.9375 -1548.6899 34.25
    004F: create_thread @LOVE_MISSION1_LOOP             //LIBERATOR
    //004F: create_thread @LOVE_MISSION2_LOOP             //WAKA GASHIRA WIPEOUT
    //004F: create_thread @LOVE_MISSION3_LOOP             //A DROP IN THE OCEAN
    //004F: create_thread @LOVE_MISSION4_LOOP             //GRAND THEFT AERO
    //004F: create_thread @LOVE_MISSION5_LOOP             //ESCORT SERVICE
    //004F: create_thread @LOVE_MISSION6_LOOP             //DECOY
    //004F: create_thread @LOVE_MISSION7_LOOP             //LOVES DISAPPERANCE

    //0055: set_player_coordinates $PLAYER at  31.938 -328.0  26.25

    02A7: $ASUKA2_MISSION_MARKER = create_icon_marker_and_sphere 4 at 31.938 -328.0  26.25
    004F: create_thread @ASUKA_SUBURBAN_MISSION1_LOOP   //BAIT
    //004F: create_thread @ASUKA_SUBURBAN_MISSION2_LOOP   //ESPRESSO 2 GO
    //004F: create_thread @ASUKA_SUBURBAN_MISSION3_LOOP   //SAM

    //0055: set_player_coordinates $PLAYER at  -697.75  240.875  66.0

    02A7: $COLOMBIAN_MANSION_MARKER = create_icon_marker_and_sphere  6 at -697.75 246.5 66.0
    004F: create_thread @CAT_MISSION1_LOOP              //THE EXCHANGE
end
end_thread

//#####################################################################################
//#####################################################################################
// END TEMP THREAD INIT / BEGIN COORDINATES DISPLAY THREAD
//#####################################################################################
//#####################################################################################

:COORDS
03A4: name_thread 'PLR_POS'

while true
    wait 0 ms
    if
        0256:   player $PLAYER defined
    then
        0007: 4@ = 10.0
        0007: 5@ = 420.0   //10.0  changed to show coords at the bottom of the screen
        00A0: store_actor $SCRIPT_CONTROLLED_PLAYER position_to 7@ 8@ 9@
        0172: 10@ = actor $SCRIPT_CONTROLLED_PLAYER z_angle
        // X
        0087: 2@ = 7@
        gosub @COORDS_FRACT
        gosub @COORDS_DRAW
        // Y
        0087: 2@ = 8@
        gosub @COORDS_FRACT
        gosub @COORDS_DRAW
        // Z
        0087: 2@ = 9@
        gosub @COORDS_FRACT
        gosub @COORDS_DRAW
        // Angle
        0087: 2@ = 10@
        gosub @COORDS_FRACT
        gosub @COORDS_DRAW
        wait 750 ms
        03F0: text_draw_toggle  0
    end
end

:COORDS_FRACT
008E: 0@ = float_to_integer 2@    // Get the integer part
008F: 3@ = integer_to_float 0@    // By transforming back to float, fractional part disappears
0063: 2@ -= 3@                    // By subtracting integer part from original number, get only fractional part
0013: 2@ *=  100.0                // Round fractional part to two digits
008E: 1@ = float_to_integer 2@    // Convert fractional part to int
0095: make 1@ absolute_integer    // Fraction should be always positive
return

:COORDS_DRAW
gosub @COORDS_DRAW_SETUP
if
    0019:    1@ >  9
then
    045B: text_draw_2numbers  4@ 5@ 'POS1'  0@  1@  // ~1~.~1~
else
    045B: text_draw_2numbers  4@ 5@ 'POS2'  0@  1@  // ~1~.0~1~
end
000B: 4@ +=  40.0     //5@ +=  15.0    changed to switch to horizontal stacking
return

:COORDS_DRAW_SETUP
0340: set_text_draw_color  200  0  0  255
0341: set_text_draw_align_justify 1
03E4: set_text_draw_align_right  0
0343: set_text_linewidth  500.0
0348: set_text_draw_proportional  1
0342: set_text_draw_centered  0
0345: set_text_draw_in_box  0
033F: set_text_draw_letter_width_height 0.3 1.4 //0.5  1.8
return

//#####################################################################################
//#####################################################################################
// END COORDINATES DISPLAY THREAD / BEGIN CAR SPAWN
//#####################################################################################
//#####################################################################################

:CARSPAWN
03A4: name_thread 'C_SPAWN'

const
    HEADING = 0@
    CAR1X   = 1@
    CAR1Y   = 2@
    CAR1Z   = 3@
    CAR2X   = 4@
    CAR2Y   = 5@
    CAR2Z   = 6@
    CAR1    = 7@
    CAR2    = 8@
end

while true
    wait 500 ms
    if
        0256:   player $PLAYER defined
    then
        if
            80E0:   NOT   player $PLAYER driving
        then
            if and
                00E1:   key_pressed 0 16
                00E1:   key_pressed 0 18
            then
                0172: HEADING = actor $SCRIPT_CONTROLLED_PLAYER z_angle
                04C4: create_coordinate CAR1X CAR1Y CAR1Z from_actor $SCRIPT_CONTROLLED_PLAYER offset -4.0 0.0 0.0
                04C4: create_coordinate CAR2X CAR2Y CAR2Z from_actor $SCRIPT_CONTROLLED_PLAYER offset 4.0 0.0 0.0
                0247: request_model #PCJ600
                0247: request_model #HUNTER
                //038B: load_all_models_now  // stutters game as it is forced to load models immediately
                while true
                    if or
                        8248:  NOT  model #PCJ600 available
                        8248:  NOT  model #HUNTER available
                    jf break
                    wait 0 ms
                end
                018C: play_sound 1 at 0.0 0.0 0.0
                00A5: CAR1 = create_car #PCJ600 at CAR1X CAR1Y CAR1Z
                00A5: CAR2 = create_car #HUNTER at CAR2X CAR2Y CAR2Z
                //02AC: set_car CAR1 immunities 1 1 1 1 1
                //02AC: set_car CAR2 immunities 1 1 1 1 1
                0175: set_car CAR1 z_angle_to HEADING
                0175: set_car CAR2 z_angle_to HEADING
                0249: mark_model_as_no_longer_needed #PCJ600
                0249: mark_model_as_no_longer_needed #HUNTER
                01C3: remove_references_to_car CAR1  // Like turning a car into any random car
                01C3: remove_references_to_car CAR2  // Like turning a car into any random car
            end
        end
    end
end
