//-------------Mission 81-------------
// Originally: Distribution

:M81_ICECRE1
03A4: name_thread 'ICECRE1'
var
$icecre1_time_temp       : int
$icecre1_help_time_diff  : int
$icecre1_help_time_start : int
$icecre1_time_start_1    : int
$icecre1_time_diff_1     : int
$icecre1_time_start_2    : int
$icecre1_time_diff_2     : int
$icecre1_time_start_3    : int
$icecre1_time_diff_3     : int
$icecre1_time_start_4    : int
$icecre1_time_diff_4     : int
end
const
ped_icecre1_customer_1  = 0@
blip_icecre1_customer_1 = 1@
ped_icecre1_customer_2  = 2@
blip_icecre1_customer_2 = 3@
ped_icecre1_customer_3  = 4@
blip_icecre1_customer_3 = 5@
ped_icecre1_customer_4  = 6@
blip_icecre1_customer_4 = 7@
icecre1_player_vehicle  = 8@
end
gosub @mission_start_icecre1
if
    0112:   wasted_or_busted
then
    gosub @mission_icecre1_failed
end
gosub @mission_cleanup_icecre1
end_thread

:mission_start_icecre1
$FLAG_PLAYER_ON_MISSION = 1
054C: use_GXT_table 'ICECRE1'
$icecre1_status = 0
$flag_icecre1_counter_displayed = 0
$flag_icecre1_customer_1 = 0
$flag_icecre1_customer_2 = 0
$flag_icecre1_customer_3 = 0
$flag_icecre1_customer_4 = 0
$icecream_counter = 0
$icecre1_count_drugs = 0
$icecre1_count_wanted = 0
00BA: text_styled 'CREAM' 4000 ms 5   // 'DISTRIBUTION'
if
    00E0:   player $PLAYER driving
then
    03C1: icecre1_player_vehicle = player $PLAYER car_no_save
else
    jump @mission_icecre1_failed
end
01BD: $icecre1_help_time_start = current_time_in_ms

while true
    wait 0
    
    // display help message
    if
        not $flag_icecre1_help == 4
    then
        if
            02BD:   debug_mode == DEBUG_SKIPHELP
        then
            $flag_icecre1_help = 4
        end
        01BD: $icecre1_time_temp = current_time_in_ms
        $icecre1_help_time_diff = $icecre1_time_temp
        $icecre1_help_time_diff -= $icecre1_help_time_start
        if and
            $flag_icecre1_help == 0
            $icecre1_help_time_diff > 0
        then
            03E5: text_box 'ICC1_16'  // Use your Mr. Whoopee van to distribute Cherry Poppers product around Liberty City.
            $flag_icecre1_help += 1
        end
        if and
            $flag_icecre1_help == 1
            $icecre1_help_time_diff > 6000
        then
            03E5: text_box 'ICC1_7'  // You receive money for each transaction you make, but the more transactions you make the more police attention you get.
            $flag_icecre1_help += 1
        end
        if and
            $flag_icecre1_help == 2
            $icecre1_help_time_diff > 12000
        then
            03E5: text_box 'ICC1_8'  // To make a transaction, ~h~park your van ~g~and press the ~h~~k~~VEHICLE_HORN~ ~w~button to play the ice cream jingle to attract customers.
            $flag_icecre1_help += 1
        end
        if and
            $flag_icecre1_help == 3
            $icecre1_help_time_diff > 18000
        then
            03E5: text_box 'ICC1_9'  // Local gangs will not appreciate you doing business on their turf so expect hostility if you do so.
            $flag_icecre1_help += 1
        end
    end

    // display onscreen counter
    if
        $flag_icecre1_counter_displayed == 0
    then
        if
            8119:   not car icecre1_player_vehicle wrecked
        then
            if
                0383:   player icecre1_player_vehicle car_horn_activated == true
            then
                03C4: set_status_text_to $icecream_counter 0 'ICC1_5'  // Deals done:
                $icecre1_status = 1
                $flag_icecre1_counter_displayed = 1
            end
        end
    end
   
    // set threat for all gangs
    if
        $icecre1_status == 1
    then
        03F1: pedtype 7 add_threat 1
        03F1: pedtype 8 add_threat 1
        03F1: pedtype 9 add_threat 1
        03F1: pedtype 10 add_threat 1
        03F1: pedtype 11 add_threat 1
        03F1: pedtype 12 add_threat 1
        03F1: pedtype 13 add_threat 1
        $icecre1_status = 2
    end
   
    if
        8119:   not car icecre1_player_vehicle wrecked
    then
        if
            80DC:   not player $PLAYER driving icecre1_player_vehicle
        then
            jump @mission_icecre1_complete
        end
    end
   
    if
        0119:   car icecre1_player_vehicle wrecked
    then
        jump @mission_icecre1_complete
    end
   
    if
        8119:   not car icecre1_player_vehicle wrecked
    then
        if
            029F:   player $PLAYER stopped
        then
            if
                0383:   player icecre1_player_vehicle car_horn_activated == true
            then
                0054: store_player $PLAYER position_to $icecre1_posx $icecre1_posy $icecre1_posz
                0086: $icecre1_area_x1 = $icecre1_posx
                0009: $icecre1_area_x1 += 20.0
                0086: $icecre1_area_y1 = $icecre1_posy
                0009: $icecre1_area_y1 += 20.0
                0086: $icecre1_area_x2 = $icecre1_posx
                000D: $icecre1_area_x2 -= 20.0
                0086: $icecre1_area_y2 = $icecre1_posy
                000D: $icecre1_area_y2 -= 20.0
               
                // customer 1
                if
                    $flag_icecre1_customer_1 == 0
                then
                    058F: ped_icecre1_customer_1 = random_ice_cream_customer_in_area $icecre1_area_x1 $icecre1_area_y1 $icecre1_area_x2 $icecre1_area_y2 flag 1 0 1
                    if
                        not  ped_icecre1_customer_1 == -1
                    then
                        if
                            8118:   not actor ped_icecre1_customer_1 dead
                        then
                            0580: $status_icecre1_customer_1 = distribution_mission_status distribution_actor ped_icecre1_customer_1 distribution_car icecre1_player_vehicle
                            if
                                $status_icecre1_customer_1 == 1
                            then
                                0187: blip_icecre1_customer_1 = create_marker_above_actor ped_icecre1_customer_1
                                01BD: $icecre1_time_start_1 = current_time_in_ms
                                $flag_icecre1_customer_1 = 1
                            else
                                01C2: remove_references_to_actor ped_icecre1_customer_1
                            end
                        end
                    end
                end
               
                // customer 2
                if
                    $flag_icecre1_customer_2 == 0
                then
                    058F: ped_icecre1_customer_2 = random_ice_cream_customer_in_area $icecre1_area_x1 $icecre1_area_y1 $icecre1_area_x2 $icecre1_area_y2 flag 1 0 1
                    if
                        not  ped_icecre1_customer_2 == -1
                    then
                        if
                            8118:   not actor ped_icecre1_customer_2 dead
                        then
                            0580: $status_icecre1_customer_2 = distribution_mission_status distribution_actor ped_icecre1_customer_2 distribution_car icecre1_player_vehicle
                            if
                                $status_icecre1_customer_2 == 1
                            then
                                0187: blip_icecre1_customer_2 = create_marker_above_actor ped_icecre1_customer_2
                                01BD: $icecre1_time_start_2 = current_time_in_ms
                                $flag_icecre1_customer_2 = 1
                            else
                                01C2: remove_references_to_actor ped_icecre1_customer_2
                            end
                        end
                    end
                end
               
                // customer 3
                if
                    $flag_icecre1_customer_3 == 0
                then
                    058F: ped_icecre1_customer_3 = random_ice_cream_customer_in_area $icecre1_area_x1 $icecre1_area_y1 $icecre1_area_x2 $icecre1_area_y2 flag 1 0 1
                    if
                        not  ped_icecre1_customer_3 == -1
                    then
                        if
                            8118:   not actor ped_icecre1_customer_3 dead
                        then
                            0580: $status_icecre1_customer_3 = distribution_mission_status distribution_actor ped_icecre1_customer_3 distribution_car icecre1_player_vehicle
                            if
                                $status_icecre1_customer_3 == 1
                            then
                                0187: blip_icecre1_customer_3 = create_marker_above_actor ped_icecre1_customer_3
                                01BD: $icecre1_time_start_3 = current_time_in_ms
                                $flag_icecre1_customer_3 = 1
                            else
                                01C2: remove_references_to_actor ped_icecre1_customer_3
                            end
                        end
                    end
                end
               
                // customer 4
                if
                    $flag_icecre1_customer_4 == 0
                then
                    058F: ped_icecre1_customer_4 = random_ice_cream_customer_in_area $icecre1_area_x1 $icecre1_area_y1 $icecre1_area_x2 $icecre1_area_y2 flag 1 0 1
                    if
                        not  ped_icecre1_customer_4 == -1
                    then
                        if
                            8118:   not actor ped_icecre1_customer_4 dead
                        then
                            0580: $status_icecre1_customer_4 = distribution_mission_status distribution_actor ped_icecre1_customer_4 distribution_car icecre1_player_vehicle
                            if
                                $status_icecre1_customer_4 == 1
                            then
                                0187: blip_icecre1_customer_4 = create_marker_above_actor ped_icecre1_customer_4
                                01BD: $icecre1_time_start_4 = current_time_in_ms
                                $flag_icecre1_customer_4 = 1
                            else
                                01C2: remove_references_to_actor ped_icecre1_customer_4
                            end
                        end
                    end
                end
               
                // no customers
                if
                    ped_icecre1_customer_1 == -1
                then
                    if
                        ped_icecre1_customer_2 == -1
                    then
                        if
                            ped_icecre1_customer_3 == -1
                        then
                            if
                                ped_icecre1_customer_4 == -1
                            then
                                00BC: text_highpriority 'ICC1_4' 1000 ms 1  // ~g~There aren't any customers in this area try another one.
                            end
                        end
                    end
                end
            end
        end
    end
   
    // customer 1
    if
        $flag_icecre1_customer_1 == 1
    then
        if
            8118:   not actor ped_icecre1_customer_1 dead
        then
            01BD: $icecre1_time_temp = current_time_in_ms
            $icecre1_time_diff_1 = $icecre1_time_temp
            $icecre1_time_diff_1 -= $icecre1_time_start_1
            if
                50000 > $icecre1_time_diff_1
            then
                if
                    0586:   actor_attempted_attractor ped_icecre1_customer_1
                then
                    if
                        058B:   actor ped_icecre1_customer_1 bought_ice_cream
                    then
                        $icecream_counter += 1
                        $icecre1_count_wanted += 1
                        if
                            0121:   player $PLAYER in_zone 'IND_ZON'  // Portland
                        then
                            0109: player $PLAYER money += 8
                            $icecre1_count_drugs += 10
                        else
                            if
                                0121:   player $PLAYER in_zone 'COM_ZON'  // Staunton
                            then
                                0109: player $PLAYER money += 10
                                $icecre1_count_drugs += 12
                            else
                                if
                                    0121:   player $PLAYER in_zone 'SUB_ZON'  // Shoreside
                                then
                                    0109: player $PLAYER money += 15
                                    $icecre1_count_drugs += 18
                                else
                                    0109: player $PLAYER money += 12
                                    $icecre1_count_drugs += 10
                                end
                            end
                        end
                    end
                    0164: disable_marker blip_icecre1_customer_1
                    01C2: remove_references_to_actor ped_icecre1_customer_1
                    $flag_icecre1_customer_1 = 0
                end
            else
                0164: disable_marker blip_icecre1_customer_1
                01C2: remove_references_to_actor ped_icecre1_customer_1
                $flag_icecre1_customer_1 = 0
            end
        else
            0164: disable_marker blip_icecre1_customer_1
            01C2: remove_references_to_actor ped_icecre1_customer_1
            $flag_icecre1_customer_1 = 0
        end
    end
   
    // customer 2
    if
        $flag_icecre1_customer_2 == 1
    then
        if
            8118:   not actor ped_icecre1_customer_2 dead
        then
            01BD: $icecre1_time_temp = current_time_in_ms
            $icecre1_time_diff_2 = $icecre1_time_temp
            $icecre1_time_diff_2 -= $icecre1_time_start_2
            if
                50000 > $icecre1_time_diff_2
            then
                if
                    0586:   actor_attempted_attractor ped_icecre1_customer_2
                then
                    if
                        058B:   actor ped_icecre1_customer_2 bought_ice_cream
                    then
                        $icecream_counter += 1
                        $icecre1_count_wanted += 1
                        if
                            0121:   player $PLAYER in_zone 'IND_ZON'  // Portland
                        then
                            0109: player $PLAYER money += 8
                            $icecre1_count_drugs += 10
                        else
                            if
                                0121:   player $PLAYER in_zone 'COM_ZON'  // Staunton
                            then
                                0109: player $PLAYER money += 10
                                $icecre1_count_drugs += 12
                            else
                                if
                                    0121:   player $PLAYER in_zone 'SUB_ZON'  // Shoreside
                                then
                                    0109: player $PLAYER money += 15
                                    $icecre1_count_drugs += 18
                                else
                                    0109: player $PLAYER money += 12
                                    $icecre1_count_drugs += 10
                                end
                            end
                        end
                    end
                    0164: disable_marker blip_icecre1_customer_2
                    01C2: remove_references_to_actor ped_icecre1_customer_2
                    $flag_icecre1_customer_2 = 0
                end
            else
                0164: disable_marker blip_icecre1_customer_2
                01C2: remove_references_to_actor ped_icecre1_customer_2
                $flag_icecre1_customer_2 = 0
            end
        else
            0164: disable_marker blip_icecre1_customer_2
            01C2: remove_references_to_actor ped_icecre1_customer_2
            $flag_icecre1_customer_2 = 0
        end
    end
   
    // customer 3
    if
        $flag_icecre1_customer_3 == 1
    then
        if
            8118:   not actor ped_icecre1_customer_3 dead
        then
            01BD: $icecre1_time_temp = current_time_in_ms
            $icecre1_time_diff_3 = $icecre1_time_temp
            $icecre1_time_diff_3 -= $icecre1_time_start_3
            if
                50000 > $icecre1_time_diff_3
            then
                if
                    0586:   actor_attempted_attractor ped_icecre1_customer_3
                then
                    if
                        058B:   actor ped_icecre1_customer_3 bought_ice_cream
                    then
                        $icecream_counter += 1
                        $icecre1_count_wanted += 1
                        if
                            0121:   player $PLAYER in_zone 'IND_ZON'  // Portland
                        then
                            0109: player $PLAYER money += 8
                            $icecre1_count_drugs += 10
                        else
                            if
                                0121:   player $PLAYER in_zone 'COM_ZON'  // Staunton
                            then
                                0109: player $PLAYER money += 10
                                $icecre1_count_drugs += 12
                            else
                                if
                                    0121:   player $PLAYER in_zone 'SUB_ZON'  // Shoreside
                                then
                                    0109: player $PLAYER money += 15
                                    $icecre1_count_drugs += 18
                                else
                                    0109: player $PLAYER money += 12
                                    $icecre1_count_drugs += 10
                                end
                            end
                        end
                    end
                    0164: disable_marker blip_icecre1_customer_3
                    01C2: remove_references_to_actor ped_icecre1_customer_3
                    $flag_icecre1_customer_3 = 0
                end
            else
                0164: disable_marker blip_icecre1_customer_3
                01C2: remove_references_to_actor ped_icecre1_customer_3
                $flag_icecre1_customer_3 = 0
            end
        else
            0164: disable_marker blip_icecre1_customer_3
            01C2: remove_references_to_actor ped_icecre1_customer_3
            $flag_icecre1_customer_3 = 0
        end
    end
   
    // customer 4
    if
        $flag_icecre1_customer_4 == 1
    then
        if
            8118:   not actor ped_icecre1_customer_4 dead
        then
            01BD: $icecre1_time_temp = current_time_in_ms
            $icecre1_time_diff_4 = $icecre1_time_temp
            $icecre1_time_diff_4 -= $icecre1_time_start_4
            if
                50000 > $icecre1_time_diff_4
            then
                if
                    0586:   actor_attempted_attractor ped_icecre1_customer_4
                then
                    if
                        058B:   actor ped_icecre1_customer_4 bought_ice_cream
                    then
                        $icecream_counter += 1
                        $icecre1_count_wanted += 1
                        if
                            0121:   player $PLAYER in_zone 'IND_ZON'  // Portland
                        then
                            0109: player $PLAYER money += 8
                            $icecre1_count_drugs += 10
                        else
                            if
                                0121:   player $PLAYER in_zone 'COM_ZON'  // Staunton
                            then
                                0109: player $PLAYER money += 10
                                $icecre1_count_drugs += 12
                            else
                                if
                                    0121:   player $PLAYER in_zone 'SUB_ZON'  // Shoreside
                                then
                                    0109: player $PLAYER money += 15
                                    $icecre1_count_drugs += 18
                                else
                                    0109: player $PLAYER money += 12
                                    $icecre1_count_drugs += 10
                                end
                            end
                        end
                    end
                    0164: disable_marker blip_icecre1_customer_4
                    01C2: remove_references_to_actor ped_icecre1_customer_4
                    $flag_icecre1_customer_4 = 0
                end
            else
                0164: disable_marker blip_icecre1_customer_4
                01C2: remove_references_to_actor ped_icecre1_customer_4
                $flag_icecre1_customer_4 = 0
            end
        else
            0164: disable_marker blip_icecre1_customer_4
            01C2: remove_references_to_actor ped_icecre1_customer_4
            $flag_icecre1_customer_4 = 0
        end
    end
   
    if
        $icecre1_count_wanted >= 4
    then
        01C0: $icecre1_wanted_level = player $PLAYER wanted_level
        $icecre1_wanted_level += 1
        010D: set_player $PLAYER wanted_level_to $icecre1_wanted_level
        $icecre1_count_wanted = 0
    end
end

:mission_icecre1_failed
return

:mission_icecre1_complete
return

:mission_cleanup_icecre1
$FLAG_PLAYER_ON_MISSION = 0
if
    $icecream_counter > 49
then
    00BA: text_styled 'ICE_AT1' 5000 ms 5  // Distribution mission completed
else
    00BA: text_styled 'ICC1_17' 5000 ms 5  // Distribution mission over
end
01E3: text_1number_styled 'ICC1_19' number $icecream_counter time 5000 style 6  // Total deals done: ~1~
if
    $LAST_REQUESTS_COMPLETED == 0
then
    03F2: pedtype 7 remove_threat 1  // Mafia
end
if and
    $TRIAL_BY_FIRE_COMPLETED == 0  
    $BLOW_FISH_COMPLETED == 0  
then
    03F2: pedtype 8 remove_threat 1  // Triads
end
if
    $UZI_RIDER_COMPLETED == 0  
then
    03F2: pedtype 9 remove_threat 1  // Diablos
end
if
    $KINGDOM_COME_COMPLETED == 0  
then
    03F2: pedtype 11 remove_threat 1  // Yardies
end
03F2: pedtype 10 remove_threat 1  // Yakuza
03F2: pedtype 13 remove_threat 1  // Hoods
0164: disable_marker blip_icecre1_customer_1
0164: disable_marker blip_icecre1_customer_2
0164: disable_marker blip_icecre1_customer_3
0164: disable_marker blip_icecre1_customer_4
01C2: remove_references_to_actor ped_icecre1_customer_1 
01C2: remove_references_to_actor ped_icecre1_customer_2 
01C2: remove_references_to_actor ped_icecre1_customer_3 
01C2: remove_references_to_actor ped_icecre1_customer_4 
0151: remove_status_text $icecream_counter
0536: increment_drug_deals_made_by $icecream_counter
//042F: save_record 2 integer $icecream_counter
mission_cleanup
return