//-------------Mission 52-------------
// Originally: Kenji mission 4 'SHIMA'

:M52_SHIMA
03A4: name_thread 'KENJI4'
054C: use_GXT_table 'KENJI4'
058E: set_restart_mission_taxi_destination 75.0 -1400.0 31.65 0.0
gosub @MISSION_START_KENJI4
if
    wasted_or_busted
then
    gosub @MISSION_KENJI4_FAILED
end
gosub @MISSION_CLEANUP_KENJI4
end_thread

:MISSION_START_KENJI4
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_KENJI = 1
0317: increment_mission_attempts
wait 0 ms
0004: $COUNTER_NUMBER_OF_HISPANICS_DEAD = 0
0004: $FLAG_HISPANIC1_KM4_DEAD = 0
0004: $FLAG_HISPANIC2_KM4_DEAD = 0
0004: $FLAG_HISPANIC3_KM4_DEAD = 0
0004: $FLAG_HISPANIC4_KM4_DEAD = 0
0004: $FLAG_HISPANIC5_KM4_DEAD = 0
0004: $FLAG_HISPANIC6_KM4_DEAD = 0
0004: $FLAG_BRIEFCASE3_PICKEDUP_KM4 = 0
0004: $FLAG_HISPANIC1_HATE_PLAYER_KM4 = 0
0004: $FLAG_HISPANIC2_HATE_PLAYER_KM4 = 0
0004: $FLAG_HISPANIC3_HATE_PLAYER_KM4 = 0
0004: $FLAG_HISPANIC4_HATE_PLAYER_KM4 = 0
0004: $FLAG_HISPANIC5_HATE_PLAYER_KM4 = 0
0004: $SWITCH_GANG_DIABLO_OFF = 1
//0004: $FLAG_PLAYER_HAD_MESSAGE_KM4 = 0
0004: $FLAG_BRIEFCASE1_CREATED_KM4 = 0
0004: $FLAG_BRIEFCASE2_CREATED_KM4 = 0
0004: $FLAG_BRIEFCASE3_CREATED_KM4 = 0
0004: $FLAG_BRIEFCASE1_COLLECTED_KM4 = 0
0004: $FLAG_BRIEFCASE2_COLLECTED_KM4 = 0
0004: $FLAG_BRIEFCASE3_COLLECTED_KM4 = 0
03B6: replace_model_at -423.371 -487.666 21.166 radius 50.0 from #CONVSTORE01 to #CONVSTRE_DMGE01
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'KENJI'
0247: request_model #GANG07
02F3: load_object #CUTOBJ01 'KENJIH'
02F3: load_object #CUTOBJ02 'PLAYERH'
0247: request_model #CASINO_GARDEN
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #GANG07 available
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CASINO_GARDEN available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'K4_SHI'
0244: set_cutscene_pos 141.375 -1382.12 73.3125
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_KENJI = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_KENJI 'KENJI'
02E5: $CUTSCENE_YAKUZA = create_cutscene_object #GANG07
02E6: set_cutscene_anim $CUTSCENE_YAKUZA 'GANG07'
//02F4: create_cutscene_actor $KENJI_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_KENJI
//02F5: set_head_anim $KENJI_CSHEAD 'KENJI'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
0395: clear_area 1 at 124.062 -1413.0 31.0625 range 1.0
0055: set_player_coordinates $PLAYER at 124.062 -1413.0 31.0625
0171: set_player $PLAYER z_angle_to 132.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   3580 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM4_A' 10000 ms 1   // To be truly strong it is important that you never show weakness.
while 001A:   8316 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM4_B' 10000 ms 1   // The business's fortunate enough to have our protection settle their accounts today.
while 001A:   13513 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM4_C' 10000 ms 1   // Go and collect the money immediately so we can enter it into the casino accounts.
while 001A:   17808 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
03D5: remove_text 'KM4_C'   // Go and collect the money immediately so we can enter it into the casino accounts.
while 001A:   18333 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
03AD: set_rubbish 1 (visible)
03C8: set_camera_in_front_of_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CASINO_GARDEN
0247: request_model #GANG05
0247: request_model #GANG07
0247: request_model #UZI
while true
    if or
        8248:   NOT   model #GANG07 available
        8248:   NOT   model #GANG05 available
        8248:   NOT   model #UZI available
    jf break
    wait 0 ms
end
0213: $BRIEFCASE1_KM4 = create_pickup #BRIEFCASE type 3 at -98.25 -1580.0 31.6875
0004: $FLAG_BRIEFCASE1_CREATED_KM4 = 1
03DC: $RADAR_BLIP_COORD2_KM4 = create_marker_above_pickup $BRIEFCASE1_KM4
while 8214:   NOT   pickup $BRIEFCASE1_KM4 picked_up
    wait 0 ms
end
0004: $FLAG_BRIEFCASE1_COLLECTED_KM4 = 1
00BC: print_now 'KM4_8' 5000 ms 1   // ~g~Briefcase collected!
0164: remove_blip $RADAR_BLIP_COORD2_KM4
0213: $BRIEFCASE2_KM4 = create_pickup #BRIEFCASE type 3 at -215.5 -1110.5 31.625
0004: $FLAG_BRIEFCASE2_CREATED_KM4 = 1
03DC: $RADAR_BLIP_COORD3_KM4 = create_marker_above_pickup $BRIEFCASE2_KM4
009A: $HISPANIC6_KM4 = create_actor 9 #GANG05 at -212.812 -1113.1899 31.1875
01B2: give_actor $HISPANIC6_KM4 weapon 23 ammo 30000  // Load the weapon model before using this
01ED: reset_actor $HISPANIC6_KM4 flags
01BE: set_actor $HISPANIC6_KM4 to_look_at_spot -214.438 -1111.75 31.0
022B: switch_ped_roads_off -456.567 -1003.07 6.0 -135.729 -413.068 41.0
while 8214:   NOT   pickup $BRIEFCASE2_KM4 picked_up
    wait 0 ms
    if
        0038:   $FLAG_HISPANIC6_KM4_DEAD == 0
    then
        if
            0118:   actor $HISPANIC6_KM4 dead
        then
            0004: $FLAG_HISPANIC6_KM4_DEAD = 1
        else
            if
                00E9:   player $PLAYER 0 near_actor $HISPANIC6_KM4 radius 10.0 10.0
            then
                011A: set_actor $HISPANIC6_KM4 flags 1
                0243: set_actor $HISPANIC6_KM4 ped_stats_to 16
                01CC: actor $HISPANIC6_KM4 kill_player $PLAYER
            end
        end
    end
end //while
0004: $FLAG_BRIEFCASE2_COLLECTED_KM4 = 1
00BC: print_now 'KM4_8' 5000 ms 1   // ~g~Briefcase collected!
0164: remove_blip $RADAR_BLIP_COORD3_KM4
018A: $RADAR_BLIP_COORD5_KM4 = create_checkpoint_at -426.5 -484.188 21.1875
while 80F8:   NOT   player $PLAYER stopped 1 near_point -426.5 -484.188 21.1875 radius 4.0 4.0 3.0
    wait 0 ms
end
02A3: toggle_widescreen 1 (on)
0164: remove_blip $RADAR_BLIP_COORD5_KM4   // Gets disabled here, but this is currently skipped so I dupilcated it at the end of the cutscene (i.e. instantly)
01B4: set_player $PLAYER can_move 0 (frozen)
0395: clear_area 1 at -426.0 -488.875 24.6875 range 2.0
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1
015F: set_camera_position -422.3125 -502.938 27.3125 0.0 0.0 0.0
0160: point_camera -422.3125 -502.0 26.9375 2
01F5: $SCRIPT_CONTROLLED_PLAYER = get_player_char $PLAYER
if
    00E0:   player $PLAYER driving
then
    00DA: $KENJI4_PLAYER_CAR = player $PLAYER car
    01D3: actor $SCRIPT_CONTROLLED_PLAYER leave_car $KENJI4_PLAYER_CAR
    while 00DB:   actor $SCRIPT_CONTROLLED_PLAYER in_car $KENJI4_PLAYER_CAR
        wait 0 ms
        if
            0119:   car $KENJI4_PLAYER_CAR wrecked
        then
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_KENJI4_FAILED
        end
    end
end
0211: actor $SCRIPT_CONTROLLED_PLAYER walk_to -427.0625 -488.812
0006: 17@ = 0
while 001B:   1000 > 17@
    wait 0 ms
end
// **************************************CUT SCENE WITH SHOP KEEPER*************************
01BD: $PRE_CUTSCENE_START_TIME = current_time_in_ms
0004: $PRE_CUTSCENE_ELAPSED_TIME = 0
while true
    if and
        83EE:   NOT   player $PLAYER controllable
        001A:   5000 > $PRE_CUTSCENE_ELAPSED_TIME
    jf break
    wait 0 ms
    01BD: $PRE_CUTSCENE_CURRENT_TIME = current_time_in_ms
    0084: $PRE_CUTSCENE_ELAPSED_TIME = $PRE_CUTSCENE_CURRENT_TIME
    0060: $PRE_CUTSCENE_ELAPSED_TIME -= $PRE_CUTSCENE_START_TIME
end
01B4: set_player $PLAYER can_move 0 (frozen)
0169: set_fade_color 0 0 0
016A: fade 0  1500 ms
03AF: set_streaming 0 (disabled)
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'KEEPER'
02F3: load_object #CUTOBJ01 'KEEPERH'
02F3: load_object #CUTOBJ02 'PLAYERH'
02F3: load_object #CUTOBJ03 'SHDOOR'
while fading
    wait 0 ms
end
009F: set_actor $SCRIPT_CONTROLLED_PLAYER objective_to-1
03DE: set_pedestrians_density_multiplier_to 0.0
042B: clear_peds_from_cube -452.625 -565.688 16.0 352.6875 -396.75 26.0
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CUTOBJ03 available
    jf break
    wait 0 ms
end
0363: toggle_model_render_at -423.25 -487.562 21.0625 radius 6.0 object #CONVSTORE01_DOOR 0
02E4: load_cutscene_data 'K4_SHI2'
0244: set_cutscene_pos -423.125 -491.375 21.125
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_KEEPER = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_KEEPER 'KEEPER'
02E5: $CS_SHOPDOOR = create_cutscene_object #CUTOBJ03
02E6: set_cutscene_anim $CS_SHOPDOOR 'SHDOOR'
//02F4: create_cutscene_actor $KEEPER_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_KEEPER
//02F5: set_head_anim $KEEPER_CSHEAD 'KEEPER'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
0395: clear_area 1 at -428.0 -489.375 21.125 range 1.0
0055: set_player_coordinates $PLAYER at -428.0 -489.375 21.125
0171: set_player $PLAYER z_angle_to 101.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   2690 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM4_1' 10000 ms 1   // I can't pay you and I wouldn't pay you if I could!
while 001A:   4898 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM4_9' 10000 ms 1   // Some young gang just jacked out the place! They took everything!
while 001A:   7467 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM4_2' 10000 ms 1   // You guys are useless.
while 001A:   8511 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM4_10' 10000 ms 1   // What kind of Yakuza are YOU anyway...?
while 001A:   10710 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
03D5: remove_text 'KM4_10'   // What kind of Yakuza are YOU anyway...?
while 001A:   11000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
03AD: set_rubbish 1
0373: set_camera_directly_behind_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0373: set_camera_directly_behind_player
0363: toggle_model_render_at -423.25 -487.562 21.0625 radius 6.0 object #CONVSTORE01_DOOR 1
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CUTOBJ03
03DE: set_pedestrians_density_multiplier_to 1.0   // Made 0 in cutscene
02A3: toggle_widescreen 0 (off)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)    // Made 1 in cutscene
01B4: set_player $PLAYER can_move 1 (unfrozen)
022A: switch_ped_roads_on -456.567 -1003.07 6.0 -135.729 -413.068 41.0   // Removes the ped block cube (hopefully) over the park.  Again the co-ordinates should be right as I took them out the LC files
03BF: set_player $PLAYER ignored_by_everyone_to 0
0167: $RADAR_BLIP_COORD1_KM4 = create_marker_at 603.0 -180.0 15.0 5 3
0168: set_marker $RADAR_BLIP_COORD1_KM4 size_to 3
0167: $RADAR_BLIP_DUMMY1_KM4 = create_marker_at 595.0 -190.0 15.0 1 3
0168: set_marker $RADAR_BLIP_DUMMY1_KM4 size_to 3
0167: $RADAR_BLIP_DUMMY2_KM4 = create_marker_at 596.0 -184.0 15.0 1 3
0168: set_marker $RADAR_BLIP_DUMMY2_KM4 size_to 3
0167: $RADAR_BLIP_DUMMY3_KM4 = create_marker_at 608.0 -182.0 15.0 1 3
0168: set_marker $RADAR_BLIP_DUMMY3_KM4 size_to 3
0167: $RADAR_BLIP_DUMMY4_KM4 = create_marker_at 608.0 -190.0 15.0 1 3
0168: set_marker $RADAR_BLIP_DUMMY4_KM4 size_to 3
0167: $RADAR_BLIP_DUMMY5_KM4 = create_marker_at 604.0 -183.0 15.0 1 3
0168: set_marker $RADAR_BLIP_DUMMY5_KM4 size_to 3
00BC: print_now 'KM4_4' 7000 ms 1   // ~g~Punish the gang responsible and retrieve the ~b~protection money~g~!
while 83C6:   NOT is_collision_in_memory 1
    wait 0 ms
end
0213: $BRIEFCASE3_KM4 = create_pickup #BRIEFCASE type 3 at 603.0 -180.0 10.5
0004: $FLAG_BRIEFCASE3_CREATED_KM4 = 1
03DC: $RADAR_BLIP_COORD4_KM4 = create_marker_above_pickup $BRIEFCASE3_KM4
0164: remove_blip $RADAR_BLIP_COORD1_KM4
009A: $HISPANIC1_KM4 = create_actor 9 #GANG05 at 595.0 -190.0 10.5   // Hope these are high-enough - I could do with putting in a co-ordinate mod, but CBA :)
0187: $RADAR_BLIP_DIABLO1_KM4 = create_marker_above_actor $HISPANIC1_KM4
0164: remove_blip $RADAR_BLIP_DUMMY1_KM4
01B2: give_actor $HISPANIC1_KM4 weapon 23 ammo 30000  // Load the weapon model before using this  - Don't know what it should be, but weapon 3 is the golf club
01ED: reset_actor $HISPANIC1_KM4 flags
0243: set_actor $HISPANIC1_KM4 ped_stats_to 16
009A: $HISPANIC2_KM4 = create_actor 9 #GANG05 at 596.0 -184.0 10.5
0187: $RADAR_BLIP_DIABLO2_KM4 = create_marker_above_actor $HISPANIC2_KM4
0164: remove_blip $RADAR_BLIP_DUMMY2_KM4
01B2: give_actor $HISPANIC2_KM4 weapon 23 ammo 30000  // Load the weapon model before using this
01ED: reset_actor $HISPANIC2_KM4 flags
0243: set_actor $HISPANIC2_KM4 ped_stats_to 16
009A: $HISPANIC3_KM4 = create_actor 9 #GANG05 at 608.0 -182.0 10.5
0187: $RADAR_BLIP_DIABLO3_KM4 = create_marker_above_actor $HISPANIC3_KM4
0164: remove_blip $RADAR_BLIP_DUMMY3_KM4
01B2: give_actor $HISPANIC3_KM4 weapon 23 ammo 30000  // Load the weapon model before using this
01ED: reset_actor $HISPANIC3_KM4 flags
0243: set_actor $HISPANIC3_KM4 ped_stats_to 16
009A: $HISPANIC4_KM4 = create_actor 9 #GANG05 at 608.0 -190.0 10.5
0187: $RADAR_BLIP_DIABLO4_KM4 = create_marker_above_actor $HISPANIC4_KM4
0164: remove_blip $RADAR_BLIP_DUMMY4_KM4
01B2: give_actor $HISPANIC4_KM4 weapon 23 ammo 30000  // Load the weapon model before using this
01ED: reset_actor $HISPANIC4_KM4 flags
0243: set_actor $HISPANIC4_KM4 ped_stats_to 16
009A: $HISPANIC5_KM4 = create_actor 9 #GANG05 at 604.0 -183.0 10.5
0187: $RADAR_BLIP_DIABLO5_KM4 = create_marker_above_actor $HISPANIC5_KM4
0164: remove_blip $RADAR_BLIP_DUMMY5_KM4
01B2: give_actor $HISPANIC5_KM4 weapon 23 ammo 30000  // Load the weapon model before using this
01ED: reset_actor $HISPANIC5_KM4 flags
0243: set_actor $HISPANIC5_KM4 ped_stats_to 16
while true
    if or
        0038:   $FLAG_BRIEFCASE3_PICKEDUP_KM4 == 0
        001A:   5 > $COUNTER_NUMBER_OF_HISPANICS_DEAD
    jf break
    wait 0 ms
    if
        0038:   $FLAG_HISPANIC1_KM4_DEAD == 0
    then
        if
            0118:   actor $HISPANIC1_KM4 dead
        then
            0164: remove_blip $RADAR_BLIP_DIABLO1_KM4
            0008: $COUNTER_NUMBER_OF_HISPANICS_DEAD += 1
            0004: $FLAG_HISPANIC1_KM4_DEAD = 1
        end
    end
    if
        0038:   $FLAG_HISPANIC2_KM4_DEAD == 0
    then
        if
            0118:   actor $HISPANIC2_KM4 dead
        then
            0164: remove_blip $RADAR_BLIP_DIABLO2_KM4
            0008: $COUNTER_NUMBER_OF_HISPANICS_DEAD += 1
            0004: $FLAG_HISPANIC2_KM4_DEAD = 1
        end
    end
    if
        0038:   $FLAG_HISPANIC3_KM4_DEAD == 0
    then
        if
            0118:   actor $HISPANIC3_KM4 dead
        then
            0164: remove_blip $RADAR_BLIP_DIABLO3_KM4
            0008: $COUNTER_NUMBER_OF_HISPANICS_DEAD += 1
            0004: $FLAG_HISPANIC3_KM4_DEAD = 1
        end
    end
    if
        0038:   $FLAG_HISPANIC4_KM4_DEAD == 0
    then
        if
            0118:   actor $HISPANIC4_KM4 dead
        then
            0164: remove_blip $RADAR_BLIP_DIABLO4_KM4
            0008: $COUNTER_NUMBER_OF_HISPANICS_DEAD += 1
            0004: $FLAG_HISPANIC4_KM4_DEAD = 1
        end
    end
    if
        0038:   $FLAG_HISPANIC5_KM4_DEAD == 0
    then
        if
            0118:   actor $HISPANIC5_KM4 dead
        then
            0164: remove_blip $RADAR_BLIP_DIABLO5_KM4
            0008: $COUNTER_NUMBER_OF_HISPANICS_DEAD += 1
            0004: $FLAG_HISPANIC5_KM4_DEAD = 1
        end
    end
    if
        0038:   $FLAG_BRIEFCASE3_PICKEDUP_KM4 == 0
    then
        if
            0214:   pickup $BRIEFCASE3_KM4 picked_up
        then
            0164: remove_blip $RADAR_BLIP_COORD4_KM4
            00BC: print_now 'KM4_8' 5000 ms 1   // ~g~Briefcase collected!
            0004: $FLAG_BRIEFCASE3_COLLECTED_KM4 = 1
            0004: $FLAG_BRIEFCASE3_PICKEDUP_KM4 = 1
        end
    end
    if
        00F5:   player $PLAYER 0 near_point 605.0 -185.0 10.1875 radius 25.0 25.0 10.0
    then
        if and
            0038:   $FLAG_HISPANIC1_KM4_DEAD == 0
            0038:   $FLAG_HISPANIC1_HATE_PLAYER_KM4 == 0
        then
            011A: set_actor $HISPANIC1_KM4 flags 1
            020F: actor $HISPANIC1_KM4 look_at_player $PLAYER
            01CC: actor $HISPANIC1_KM4 kill_player $PLAYER
            0004: $FLAG_HISPANIC1_HATE_PLAYER_KM4 = 1
        end
        if and
            0038:   $FLAG_HISPANIC2_KM4_DEAD == 0
            0038:   $FLAG_HISPANIC2_HATE_PLAYER_KM4 == 0
        then
            011A: set_actor $HISPANIC2_KM4 flags 1
            020F: actor $HISPANIC2_KM4 look_at_player $PLAYER
            01CC: actor $HISPANIC2_KM4 kill_player $PLAYER
            0004: $FLAG_HISPANIC2_HATE_PLAYER_KM4 = 1
        end
        if and
            0038:   $FLAG_HISPANIC3_KM4_DEAD == 0
            0038:   $FLAG_HISPANIC3_HATE_PLAYER_KM4 == 0
        then
            011A: set_actor $HISPANIC3_KM4 flags 1
            020F: actor $HISPANIC3_KM4 look_at_player $PLAYER
            01CC: actor $HISPANIC3_KM4 kill_player $PLAYER
            0004: $FLAG_HISPANIC3_HATE_PLAYER_KM4 = 1
        end
        if and
            0038:   $FLAG_HISPANIC4_KM4_DEAD == 0
            0038:   $FLAG_HISPANIC4_HATE_PLAYER_KM4 == 0
        then
            011A: set_actor $HISPANIC4_KM4 flags 1
            020F: actor $HISPANIC4_KM4 look_at_player $PLAYER
            01CC: actor $HISPANIC4_KM4 kill_player $PLAYER
            0004: $FLAG_HISPANIC4_HATE_PLAYER_KM4 = 1
        end
        if and
            0038:   $FLAG_HISPANIC5_KM4_DEAD == 0
            0038:   $FLAG_HISPANIC5_HATE_PLAYER_KM4 == 0
        then
            011A: set_actor $HISPANIC5_KM4 flags 1
            020F: actor $HISPANIC5_KM4 look_at_player $PLAYER
            01CC: actor $HISPANIC5_KM4 kill_player $PLAYER
            0004: $FLAG_HISPANIC5_HATE_PLAYER_KM4 = 1
        end
    end
end
00BC: print_now 'KM4_11' 5000 ms 1   // ~g~Take the money back to the casino!
018A: $RADAR_BLIP_COORD6_KM4 = create_checkpoint_at 117.25 -1465.75 23.5625
0004: $BLOB_FLAG = 1
while 80F8:   NOT   player $PLAYER stopped $BLOB_FLAG near_point 117.25 -1465.75 23.5625 radius 4.0 4.0 4.0   // Random :/, uses a variable to set the sphere type
    wait 0 ms
end
0164: remove_blip $RADAR_BLIP_COORD6_KM4
02A3: toggle_widescreen 1 (on)
01B4: set_player $PLAYER can_move 0 (frozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1
01F5: $SCRIPT_CONTROLLED_PLAYER = get_player_char $PLAYER
if
    00E0:   player $PLAYER driving
then
    00DA: $CAR_CUT_KM4 = player $PLAYER car
    01D3: actor $SCRIPT_CONTROLLED_PLAYER leave_car $CAR_CUT_KM4
    while 00DC:   player $PLAYER driving $CAR_CUT_KM4
        wait 0 ms
        if
            0119:   car $CAR_CUT_KM4 wrecked
        then
            00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_KENJI4_FAILED
        end
    end //while
end
015F: set_camera_position 85.375 -1479.5601 32.125 0.0 0.0 0.0
0160: point_camera 85.812 -1478.75 32.375 2
0055: set_player_coordinates $PLAYER at 90.812 -1477.12 -100.0
0211: actor $SCRIPT_CONTROLLED_PLAYER walk_to 93.562 -1465.0
while 8126:   NOT   actor $SCRIPT_CONTROLLED_PLAYER walking
    wait 0 ms
end
0169: set_fade_color 0 0 0
016A: fade 0  1000 ms
while fading
    wait 0 ms
end
0055: set_player_coordinates $PLAYER at 91.75 -1486.38 23.625
0171: set_player $PLAYER z_angle_to 180.0
02EB: restore_camera_jumpcut
03C8: set_camera_in_front_of_player
0169: set_fade_color 0 0 0
016A: fade 1 (back)  1000 ms
while fading
    wait 0 ms
end
02A3: toggle_widescreen 0 (off)
01B4: set_player $PLAYER can_move 1 (unfrozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
03BF: set_player $PLAYER ignored_by_everyone_to 0
jump @MISSION_KENJI4_PASSED

:MISSION_KENJI4_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
return

:MISSION_KENJI4_PASSED
0004: $SHIMA_COMPLETED = 1
0318: set_latest_mission_passed 'KM4'   // 'SHIMA'
030C: set_mission_points += 1
01E3: text_1number_styled 'M_PASS' 10000 5000 ms 1   // MISSION PASSED! $~1~
0394: play_music 1
0109: player $PLAYER money += 10000
0110: clear_player $PLAYER wanted_level
004F: create_thread @KENJI_MISSION5_LOOP
return

:MISSION_CLEANUP_KENJI4
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_KENJI = 0
0004: $SWITCH_GANG_DIABLO_OFF = 0
if
    0038:   $FLAG_BRIEFCASE1_CREATED_KM4 == 1
then
    if
        0038:   $FLAG_BRIEFCASE1_COLLECTED_KM4 == 0
    then
        0215: destroy_pickup $BRIEFCASE1_KM4
    end
end
if
    0038:   $FLAG_BRIEFCASE2_CREATED_KM4 == 1
then
    if
        0038:   $FLAG_BRIEFCASE2_COLLECTED_KM4 == 0
    then
        0215: destroy_pickup $BRIEFCASE2_KM4
    end
end
if
    0038:   $FLAG_BRIEFCASE3_CREATED_KM4 == 1
then
    if
        0038:   $FLAG_BRIEFCASE3_COLLECTED_KM4 == 0
    then
        0215: destroy_pickup $BRIEFCASE3_KM4
    end
end
0164: remove_blip $RADAR_BLIP_DIABLO1_KM4
0164: remove_blip $RADAR_BLIP_DIABLO2_KM4
0164: remove_blip $RADAR_BLIP_DIABLO3_KM4
0164: remove_blip $RADAR_BLIP_DIABLO4_KM4
0164: remove_blip $RADAR_BLIP_DIABLO5_KM4
0249: mark_model_as_no_longer_needed #GANG05
0249: mark_model_as_no_longer_needed #GANG07
0249: mark_model_as_no_longer_needed #UZI
0164: remove_blip $RADAR_BLIP_COORD2_KM4
0164: remove_blip $RADAR_BLIP_COORD3_KM4
0164: remove_blip $RADAR_BLIP_COORD4_KM4
0164: remove_blip $RADAR_BLIP_COORD5_KM4
0164: remove_blip $RADAR_BLIP_COORD1_KM4
0164: remove_blip $RADAR_BLIP_COORD6_KM4
0164: remove_blip $RADAR_BLIP_DUMMY1_KM4
0164: remove_blip $RADAR_BLIP_DUMMY2_KM4
0164: remove_blip $RADAR_BLIP_DUMMY3_KM4
0164: remove_blip $RADAR_BLIP_DUMMY4_KM4
0164: remove_blip $RADAR_BLIP_DUMMY5_KM4
022A: switch_ped_roads_on -456.567 -1003.07 6.0 -135.729 -413.068 41.0
mission_cleanup
return
