//-------------Mission 69-------------
// Originally: Donald Love mission 6 'DECOY'

:M69_DECOY
03A4: name_thread 'LOVE6'
054C: use_GXT_table 'LOVE6'
058E: set_restart_mission_taxi_destination -284.8 -1547.9 31.65 0.0
gosub @MISSION_START_LOVE6
if
    wasted_or_busted
then
    gosub @MISSION_LOVE6_FAILED
end
gosub @MISSION_CLEANUP_LOVE6
end_thread

:MISSION_START_LOVE6
$FLAG_PLAYER_ON_MISSION = 1
$ON_MISSION_FOR_LOVE = 1
increment_mission_attempts
$GET_IN_VAN = 0
$SURVIVAL_TIME = 180000

023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'LOVE2'
02F3: load_object #CUTOBJ01 'LOVEH'
0247: request_model #TSHRORCKGRDN
0247: request_model #TSHRORCKGRDN_ALFAS
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #TSHRORCKGRDN available
        8248:   NOT   model #TSHRORCKGRDN_ALFAS available
        8248:   NOT   model #CUTOBJ01 available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'D6_STS'
0244: set_cutscene_pos -249.8125 -1532.88 249.5
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_LOVE = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_LOVE 'LOVE2'   //
//02F4: create_cutscene_actor $LOVE_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_LOVE
//02F5: set_head_anim $LOVE_CSHEAD 'LOVE'
0395: clear_area 1 at -252.5625 -1548.4399 34.0 range 2.0
0055: set_player_coordinates $PLAYER at -252.5625 -1548.4399 34.0
0171: set_player $PLAYER z_angle_to 90.0
016A: fade 1 (back)  1500 ms
02E7: start_cutscene
03AD: set_rubbish 0 (invisible)
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   1526 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'LOVE6_A' 5000 ms 1   // A lesson in business my friend.

while 001A:   3011 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'LOVE6_E' 5000 ms 1   // If you have a unique commodity the world and his wife will try to wrestle it from your grasp...

while 001A:   7026 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'LOVE6_B' 5000 ms 1   // even if they have little understanding as to its true value.

while 001A:   10679 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'LOVE6_C' 5000 ms 1   // SWAT teams have cordoned off the area around my associate and the package.

while 001A:   14011 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'LOVE6_D' 5000 ms 1   // Get over there pick up the van and act as a decoy.

while 001A:   16741 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'LOVE6_F' 5000 ms 1   // Keep them busy and he should make good his escape.
while 001A:   20333 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   not cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
016A: fade 0  0 ms
02BC: set_swat_required 1
0373: set_camera_directly_behind_player
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #TSHRORCKGRDN
0249: mark_model_as_no_longer_needed #TSHRORCKGRDN_ALFAS
0247: request_model #ENFORCER
0247: request_model #SWAT
0247: request_model #COP
0247: request_model #POLICE
0247: request_model #SECURICA
0247: request_model #COLT45
0247: request_model #SHOTGUN
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #ENFORCER available
        8248:   NOT   model #POLICE available
        8248:   NOT   model #COP available
        8248:   NOT   model #SWAT available
        8248:   NOT   model #SECURICA available
        8248:   NOT   model #COLT45 available
        8248:   NOT   model #SHOTGUN available
    jf break
    wait 0 ms
end
02A3: toggle_widescreen 0 (off)
03AD: set_rubbish 1 (visible)
03AF: set_streaming 1 (enabled)
01B4: set_player $PLAYER can_move 1 (unfrozen)
016A: fade 1 (back)  1500 ms
03CF: load_wav 'LO6_A' as 1
while fading
    wait 0 ms
end

// ******************************************END OF CUTSCENE********************************

0167: $DECOY_VAN_BLIP = create_marker_at -1361.5 -73.5 45.0 0 2
0168: set_marker $DECOY_VAN_BLIP size_to 3
while 83C6:   NOT is_collision_in_memory 3
    wait 0 ms
end
while 80E3:   NOT   player $PLAYER 0 near_point -1361.5 -73.5 radius 200.0 200.0
    wait 0 ms
end
01F0: set_max_wanted_level_to 6
00A5: $DECOY_VAN = create_car #SECURICA at -1361.5 -73.5 45.0
0175: set_car $DECOY_VAN z_angle_to 270.0
00A9: set_car $DECOY_VAN to_normal_driver
020A: set_car $DECOY_VAN door_status_to 1
03AB: set_vehicle $DECOY_VAN strong 1

0164: remove_blip $DECOY_VAN_BLIP
0186: $DECOY_VAN_BLIP = create_marker_above_car $DECOY_VAN

00A5: $SWAT_1 = create_car #ENFORCER at -1340.5 11.0 50.0
0175: set_car $SWAT_1 z_angle_to 119.0
00A9: set_car $SWAT_1 to_normal_driver
0129: $PED_SWAT_1 = create_actor 6 #SWAT in_car $SWAT_1 driverseat
01B2: give_actor $PED_SWAT_1 weapon 23 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_SWAT_1 objective_to-1
011C: actor $PED_SWAT_1 clear_objective
00AF: set_car $SWAT_1 mission 0

00A5: $SWAT_2 = create_car #ENFORCER at -1447.38 -46.375 55.0
0175: set_car $SWAT_2 z_angle_to 212.0
00A9: set_car $SWAT_2 to_normal_driver
0129: $PED_SWAT_2 = create_actor 6 #SWAT in_car $SWAT_2 driverseat
01B2: give_actor $PED_SWAT_2 weapon 23 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_SWAT_2 objective_to-1
011C: actor $PED_SWAT_2 clear_objective
00AF: set_car $SWAT_2 mission 0

00A5: $SWAT_3 = create_car #ENFORCER at -1453.38 -63.5625 54.6875
0175: set_car $SWAT_3 z_angle_to 321.0
00A9: set_car $SWAT_3 to_normal_driver
0129: $PED_SWAT_3 = create_actor 6 #SWAT in_car $SWAT_3 driverseat
01B2: give_actor $PED_SWAT_3 weapon 23 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_SWAT_3 objective_to-1
011C: actor $PED_SWAT_3 clear_objective
00AF: set_car $SWAT_3 mission 0

00A5: $SWAT_4 = create_car #ENFORCER at -1298.25 -108.688 40.6875
0175: set_car $SWAT_4 z_angle_to 103.0
00A9: set_car $SWAT_4 to_normal_driver
0129: $PED_SWAT_4 = create_actor 6 #SWAT in_car $SWAT_4 driverseat
01B2: give_actor $PED_SWAT_4 weapon 23 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_SWAT_4 objective_to-1
011C: actor $PED_SWAT_4 clear_objective
00AF: set_car $SWAT_4 mission 0

00A5: $SWAT_5 = create_car #ENFORCER at -1292.0 -111.0 40.5
0175: set_car $SWAT_5 z_angle_to 108.5
00A9: set_car $SWAT_5 to_normal_driver
0129: $PED_SWAT_5 = create_actor 6 #SWAT in_car $SWAT_5 driverseat
01B2: give_actor $PED_SWAT_5 weapon 23 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_SWAT_5 objective_to-1
011C: actor $PED_SWAT_5 clear_objective
00AF: set_car $SWAT_5 mission 0

00A5: $COP_1 = create_car #POLICE at -1318.0 -120.25 39.5625
0175: set_car $COP_1 z_angle_to 270.0
00A9: set_car $COP_1 to_normal_driver
0129: $PED_COP_1 = create_actor 6 #COP in_car $COP_1 driverseat
01B2: give_actor $PED_COP_1 weapon 21 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_COP_1 objective_to-1
011C: actor $PED_COP_1 clear_objective
00AF: set_car $COP_1 mission 0

00A5: $COP_2 = create_car #POLICE at -1353.75 4.375 49.6875
0175: set_car $COP_2 z_angle_to 262.0
00A9: set_car $COP_2 to_normal_driver
0129: $PED_COP_2 = create_actor 6 #COP in_car $COP_2 driverseat
01B2: give_actor $PED_COP_2 weapon 21 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_COP_2 objective_to-1
011C: actor $PED_COP_2 clear_objective
00AF: set_car $COP_2 mission 0

00A5: $COP_3 = create_car #POLICE at -1449.38 -50.0 54.5625
0175: set_car $COP_3 z_angle_to 202.0
00A9: set_car $COP_3 to_normal_driver
0129: $PED_COP_3 = create_actor 6 #COP in_car $COP_3 driverseat
01B2: give_actor $PED_COP_3 weapon 21 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_COP_3 objective_to-1
011C: actor $PED_COP_3 clear_objective
00AF: set_car $COP_3 mission 0

009A: $PED_SWAT_6 = create_actor 6 #SWAT at -1450.6899 -63.875 54.75
0173: set_actor $PED_SWAT_6 z_angle_to 342.0
01B2: give_actor $PED_SWAT_6 weapon 23 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_SWAT_6 objective_to-1
011C: actor $PED_SWAT_6 clear_objective

009A: $PED_SWAT_7 = create_actor 6 #SWAT at -1300.25 -111.188 40.0
0173: set_actor $PED_SWAT_7 z_angle_to 41.0
01B2: give_actor $PED_SWAT_7 weapon 23 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_SWAT_7 objective_to-1
011C: actor $PED_SWAT_7 clear_objective

009A: $PED_SWAT_8 = create_actor 6 #SWAT at -1295.5 -113.0 40.0
0173: set_actor $PED_SWAT_8 z_angle_to 173.0
01B2: give_actor $PED_SWAT_8 weapon 23 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_SWAT_8 objective_to-1
011C: actor $PED_SWAT_8 clear_objective

009A: $PED_COP_4 = create_actor 6 #COP at -1438.38 -47.75 54.75
0173: set_actor $PED_COP_4 z_angle_to 255.0
01B2: give_actor $PED_COP_4 weapon 21 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_COP_4 objective_to-1
011C: actor $PED_COP_4 clear_objective

009A: $PED_COP_5 = create_actor 6 #COP at -1319.0 -91.1875 42.0
0173: set_actor $PED_COP_5 z_angle_to 339.0
01B2: give_actor $PED_COP_5 weapon 21 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_COP_5 objective_to-1
011C: actor $PED_COP_5 clear_objective

009A: $PED_COP_6 = create_actor 6 #COP at -1340.0 5.5 49.75
0173: set_actor $PED_COP_6 z_angle_to 169.0
01B2: give_actor $PED_COP_6 weapon 21 ammo 9999  // Load the weapon model before using this
009F: set_actor $PED_COP_6 objective_to-1
011C: actor $PED_COP_6 clear_objective
while 80DC:   NOT   player $PLAYER driving $DECOY_VAN
    wait 0 ms

    if
        0119:   car $DECOY_VAN wrecked
    then
        jump @MISSION_LOVE6_FAILED
    end
end
053F: set_car $DECOY_VAN tires_vulnerable 0       //Remove this to make the tires pop like in VC
0164: remove_blip $DECOY_VAN_BLIP
if
    8118:   NOT   actor $PED_SWAT_6 dead
then
    01CC: actor $PED_SWAT_6 kill_player $PLAYER
    01C2: remove_references_to_actor $PED_SWAT_6  // Like turning an actor into a random pedestrian
end
if
    8118:   NOT   actor $PED_SWAT_7 dead
then
    01D9: actor $PED_SWAT_7 destroy_car $DECOY_VAN
    01C2: remove_references_to_actor $PED_SWAT_7  // Like turning an actor into a random pedestrian
end
if
    8118:   NOT   actor $PED_SWAT_8 dead
then
    01CC: actor $PED_SWAT_8 kill_player $PLAYER
    01C2: remove_references_to_actor $PED_SWAT_8  // Like turning an actor into a random pedestrian
end
if
    8118:   NOT   actor $PED_COP_4 dead
then
    01D9: actor $PED_COP_4 destroy_car $DECOY_VAN
    01C2: remove_references_to_actor $PED_COP_4  // Like turning an actor into a random pedestrian
end
if
    8118:   NOT   actor $PED_COP_5 dead
then
    01CC: actor $PED_COP_5 kill_player $PLAYER
    01C2: remove_references_to_actor $PED_COP_5  // Like turning an actor into a random pedestrian
end
if
    8118:   NOT   actor $PED_COP_6 dead
then
    01D9: actor $PED_COP_6 destroy_car $DECOY_VAN
    01C2: remove_references_to_actor $PED_COP_6  // Like turning an actor into a random pedestrian
end
if
    8119:   NOT   car $SWAT_1 wrecked
then
    00AD: set_car $SWAT_1 max_speed_to 100.0
    00AE: set_car $SWAT_1 driving_style 2  // DRIVINGMODE_AVOIDCARS
    032C: car $SWAT_1 ram $DECOY_VAN
    01C3: remove_references_to_car $SWAT_1  // Like turning a car into any random car
end
if
    8119:   NOT   car $SWAT_2 wrecked
then
    00AD: set_car $SWAT_2 max_speed_to 100.0
    00AE: set_car $SWAT_2 driving_style 2  // DRIVINGMODE_AVOIDCARS
    032C: car $SWAT_2 ram $DECOY_VAN
    01C3: remove_references_to_car $SWAT_2  // Like turning a car into any random car
end
if
    8119:   NOT   car $SWAT_3 wrecked
then
    00AD: set_car $SWAT_3 max_speed_to 100.0
    00AE: set_car $SWAT_3 driving_style 2  // DRIVINGMODE_AVOIDCARS
    032C: car $SWAT_3 ram $DECOY_VAN
    01C3: remove_references_to_car $SWAT_3  // Like turning a car into any random car
end
if
    8119:   NOT   car $SWAT_4 wrecked
then
    00AD: set_car $SWAT_4 max_speed_to 100.0
    00AE: set_car $SWAT_4 driving_style 2  // DRIVINGMODE_AVOIDCARS
    032C: car $SWAT_4 ram $DECOY_VAN
    01C3: remove_references_to_car $SWAT_4  // Like turning a car into any random car
end
if
    8119:   NOT   car $SWAT_5 wrecked
then
    00AD: set_car $SWAT_5 max_speed_to 100.0
    00AE: set_car $SWAT_5 driving_style 2  // DRIVINGMODE_AVOIDCARS
    032C: car $SWAT_5 ram $DECOY_VAN
    01C3: remove_references_to_car $SWAT_5  // Like turning a car into any random car
end
if
    8119:   NOT   car $COP_1 wrecked
then
    00AD: set_car $COP_1 max_speed_to 100.0
    00AE: set_car $COP_1 driving_style 2  // DRIVINGMODE_AVOIDCARS
    032C: car $COP_1 ram $DECOY_VAN
    01C3: remove_references_to_car $COP_1  // Like turning a car into any random car
end
if
    8119:   NOT   car $COP_2 wrecked
then
    00AD: set_car $COP_2 max_speed_to 100.0
    00AE: set_car $COP_2 driving_style 2  // DRIVINGMODE_AVOIDCARS
    032C: car $COP_2 ram $DECOY_VAN
    01C3: remove_references_to_car $COP_2  // Like turning a car into any random car
end
if
    8119:   NOT   car $COP_3 wrecked
then
    00AD: set_car $COP_3 max_speed_to 100.0
    00AE: set_car $COP_3 driving_style 2  // DRIVINGMODE_AVOIDCARS
    032C: car $COP_3 ram $DECOY_VAN
    01C3: remove_references_to_car $COP_3  // Like turning a car into any random car
end
010D: set_player $PLAYER wanted_level_to 5
014E: set_timer_to $SURVIVAL_TIME type 1   //now it counts down
00BC: print_now 'LOVE6_1' 5000 ms 1   // ~g~Now lead the cops away from the warehouse!
if
    03D0:   wav 1 loaded   //unload later
then
    03D1: play_wav 1
end
0227: $DECOY_VAN_HEALTH = car $DECOY_VAN health
000C: $DECOY_VAN_HEALTH -= 250
0010: $DECOY_VAN_HEALTH *= 100
0014: $DECOY_VAN_HEALTH /= 750
0084: $DECOY_VAN_HEALTH2 = $DECOY_VAN_HEALTH
0004: $DECOY_VAN_HEALTH = 100
0060: $DECOY_VAN_HEALTH -= $DECOY_VAN_HEALTH2
if
    $DECOY_VAN_HEALTH > 100
then
    $DECOY_VAN_HEALTH = 100
end
03C4: set_status_text_to $DECOY_VAN_HEALTH 1 (bar)  'DAM'   // Damage
while $SURVIVAL_TIME > 0
    wait 0 ms
    if
        0119:   car $DECOY_VAN wrecked
    then
        jump @MISSION_LOVE6_FAILED
    end
    010D: set_player $PLAYER wanted_level_to 6
    0227: $DECOY_VAN_HEALTH = car $DECOY_VAN health
    000C: $DECOY_VAN_HEALTH -= 250
    0010: $DECOY_VAN_HEALTH *= 100
    0014: $DECOY_VAN_HEALTH /= 750
    0084: $DECOY_VAN_HEALTH2 = $DECOY_VAN_HEALTH
    0004: $DECOY_VAN_HEALTH = 100
    0060: $DECOY_VAN_HEALTH -= $DECOY_VAN_HEALTH2
    if
        0018:   $DECOY_VAN_HEALTH > 100
    then
        0004: $DECOY_VAN_HEALTH = 100
    end
    if
        80DC:   NOT   player $PLAYER driving $DECOY_VAN
    then
        if
            $GET_IN_VAN == 0
        then
            01BD: $OUT_OF_CAR_TIMER_START = current_time_in_ms
            if
                0018:   $SURVIVAL_TIME > 15000
            then
                $OUT_OF_CAR_TIMER = 15000
            else
                0084: $OUT_OF_CAR_TIMER = $SURVIVAL_TIME
            end

            0186: $DECOY_VAN_BLIP = create_marker_above_car $DECOY_VAN
            $GET_IN_VAN = 1
        end
        01BD: $OUT_OF_CAR_TIMER_PRESENT = current_time_in_ms
        0084: $OUT_OF_CAR_TIMER_DIFF = $OUT_OF_CAR_TIMER_PRESENT
        0060: $OUT_OF_CAR_TIMER_DIFF -= $OUT_OF_CAR_TIMER_START
        0060: $OUT_OF_CAR_TIMER -= $OUT_OF_CAR_TIMER_DIFF
        0084: $OUT_OF_CAR_TIMER_START = $OUT_OF_CAR_TIMER_PRESENT
        0084: $OUT_OF_CAR_TIMER_SECS = $OUT_OF_CAR_TIMER
        0014: $OUT_OF_CAR_TIMER_SECS /= 1000
        01E5: text_1number_highpriority 'LOVE6_3' $OUT_OF_CAR_TIMER_SECS 200 ms 1   // ~g~You have ~1~ seconds to return to the Securicar before you fail the mission.
        if
            001A:   1 > $OUT_OF_CAR_TIMER_SECS
        then
            00BC: print_now 'LOVE6_4' 3000 ms 1   // ~r~You ditched the Decoy Securicar!
            jump @MISSION_LOVE6_FAILED
        end
    end
    if and
        00DC:   player $PLAYER driving $DECOY_VAN
        0038:   $GET_IN_VAN == 1
    then
        0164: remove_blip $DECOY_VAN_BLIP
        0004: $GET_IN_VAN = 0
    end
end
if
    00E3:   player $PLAYER 0 near_point -1361.5 -73.5 radius 160.0 160.0
then
    00BC: print_now 'LOVE6_2' 5000 ms 1   // ~r~You failed to lead the police far enough away!
    jump @MISSION_LOVE6_FAILED
end
jump @MISSION_LOVE6_PASSED

:MISSION_LOVE6_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
return

:MISSION_LOVE6_PASSED
0004: $DECOY_COMPLETED = 1
01E3: text_1number_styled 'M_PASS' 35000 5000 ms 1   // MISSION PASSED! $~1~
0109: player $PLAYER money += 35000
0110: clear_player $PLAYER wanted_level
0318: set_latest_mission_passed 'LOVE6'   // 'DECOY'
0394: play_music 1
030C: set_mission_points += 1
004F: create_thread @LOVE_MISSION7_LOOP
return

:MISSION_CLEANUP_LOVE6
040D: unload_wav 1
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_LOVE = 0
0164: remove_blip $DECOY_VAN_BLIP
014F: stop_timer $SURVIVAL_TIME
0151: remove_status_text $DECOY_VAN_HEALTH
02BC: set_swat_required 0
0249: mark_model_as_no_longer_needed #SECURICA
0249: mark_model_as_no_longer_needed #POLICE
0249: mark_model_as_no_longer_needed #COP
0249: mark_model_as_no_longer_needed #ENFORCER
0249: mark_model_as_no_longer_needed #SWAT
0249: mark_model_as_no_longer_needed #COLT45
0249: mark_model_as_no_longer_needed #SHOTGUN
mission_cleanup
return
