//-------------Mission 54-------------
// Originally: Ray mission 1 'SILENCE THE SNEAK'

:M54_SILENCETHESNEAK
03A4: name_thread 'RAY1'
054C: use_GXT_table 'RAY1'
058E: set_restart_mission_taxi_destination -221.6 -696.3 31.66 180.0
gosub @MISSION_START_RAY1
if
    wasted_or_busted
then
    gosub @MISSION_RAY1_FAILED
end
gosub @MISSION_CLEANUP_RAY1
end_thread

:MISSION_START_RAY1
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_RAY = 1
0004: $RAYS_CUTSCENE_FLAG = 1
0317: increment_mission_attempts
wait 0 ms
0004: $WANTED_LVL_FLAG_R1 = 0
0004: $GAME_TIMER_R1 = 0
0004: $GAME_TIMER_START_R1 = 0
0004: $CAR_MOVING_STUCK_FLAG = 0
0004: $GETAWAY_STUCK_FLAG = 0
0004: $GET_AWAY_CAR_HEALTH = 1000
0004: $GAME_TIMER_CURRENT_R1 = 0
0005: $GET_AWAY_CAR_X = 0.0
0005: $GET_AWAY_CAR_Y = 0.0
0005: $GET_AWAY_CAR_Z = 0.0
0004: $MFAIL_TIMER = 0
0004: $MFAIL_TIMER_CURRENT = 0
0004: $MFAIL_TIMER_STARTED = 0
0004: $MFAIL_TIMER_RESET_FLAG = 0
0004: $CARLOCK_FLAG = 0
023C: load_special_actor  1 'PLAYER'
023C: load_special_actor  2 'RAY'
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'RAYH'
0247: request_model #TOILET
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor  1 available
        823D:   NOT   special_actor  2 available
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #TOILET  available
    jf break
    wait  0 ms
end
0395: clear_area 1 at -296.0 -723.5 28.0 range 1.0
0055: set_player_coordinates $PLAYER  at  -296.0 -723.5  28.0
0171: player $PLAYER z_angle_to 90.0
02E4: load_cutscene_data 'R1_SW'
0244: set_cutscene_pos  -295.625 -726.625  27.6875
02E5: $CUTSCENE_PLAYER create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_RAY create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_RAY 'RAY'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
//02F4: create_cutscene_actor $RAY_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_RAY
//02F5: set_head_anim $RAY_CSHEAD 'RAY'
016A: fade 1 (back)  1500 ms
041D: set_camera_near_clip  0.1875
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   2070 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM1_A'  8000 ms  1  // That scumbag McAffrey, he took more bribes than anyone.
while 001A:   6097 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM1_B'  8000 ms  1  // He thinks he's gonna get an honorable discharge if he turns states evidence.
while 001A:   9509 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM1_C'  8000 ms  1  // He just squealed!
while 001A:   11019 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM1_D'  8000 ms  1  // He's under armed protection in WitSec property down in Newport some apartment behind the car park.
while 001A:   16109 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM1_E'  8000 ms  1  // Torch that place that should flush 'em out and you'll hunt 'em down make sure he never talks to nobody.
while 001A:   21333 > $CUT_SCENE_TIME
    wait  0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade  0  1500 ms
01B1: give_player $PLAYER weapon  12 ammo  12
while 82E9:   NOT cutscene_reached_end
    wait  0 ms
end
00BE: text_clear_all
while fading
    wait  0 ms
end
02EA: clear_cutscene
016A: fade  0  0 ms
041D: set_camera_near_clip  0.875
0373: set_camera_directly_behind_for_follow_ped
0296: unload_special_actor  1
0296: unload_special_actor  2
0249: mark_model_as_no_longer_needed #TOILET
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0247: request_model #LI_MAN2
0247: request_model #SENTINEL
0247: request_model #AK47
0247: request_model #GRENADE
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #LI_MAN2 available
        8248:   NOT   model #SENTINEL available
        8248:   NOT   model #AK47 available
        8248:   NOT   model #GRENADE available
    jf break
    wait  0 ms
end
03AF: set_streaming 1 (enabled)
016A: fade 1 (back)  1500 ms
0004: $RAYS_CUTSCENE_FLAG =  0
while fading
    wait  0 ms
end
0247: request_model #SAFEHOUSE
018A: $RAY1_BLIP = create_checkpoint_at 43.0 -443.1875 35.875
00BC: print_now 'RM1_1' 5000 ms 1   // // ~g~Check out the witness protection house.
while 8199:   NOT   player $PLAYER 0 in_rectangle -4.6875 -471.375 40.9375 -431.0625  // never used in VC
    wait 0 ms
end
01B4: set_player $PLAYER can_move 0 (frozen)
02A3: toggle_widescreen 1 (on)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
03F4: set_all_cars_can_be_damaged 0
015F: set_camera_position 38.25 -444.6875 34.5 0.0 0.0 0.0
0160: point_camera 39.125 -444.25 34.75 1
wait 3000 ms
01B4: set_player $PLAYER can_move 1 (unfrozen)
02A3: toggle_widescreen 0 (off)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
03F4: set_all_cars_can_be_damaged 1
015A: restore_camera
03CF: load_wav 'R1_A' as 1
0004: $RAY1_GRENADE_AMMO = 0
0004: $RAY1_ROCKET_AMMO = 0
0004: $POLICE_GUARD2 = 0
while 82EE:   NOT projectile_in_cube_keep  41.5 -445.1875  34.0625  45.0625 -441.1875  37.6875
    wait 0 ms
    0419: $RAY1_GRENADE_AMMO = player $PLAYER weapon 12 ammo
    0419: $RAY1_ROCKET_AMMO = player $PLAYER weapon 30 ammo
    0058: $RAY1_GRENADE_AMMO += $RAY1_ROCKET_AMMO
    if
        0038:   $POLICE_GUARD2 == 0
    then
        if
            0038:   $RAY1_GRENADE_AMMO  == 0
        then
            00BC: print_now 'RM1_4' 5000 ms 1   // // ~g~You have used all the grenades! Get some more from ammunation!
            0164: remove_blip $RAY1_BLIP
            02A8: $RAY1_BLIP = create_marker 23 at 11.5 -713.5 32.0625
            0004: $POLICE_GUARD2 = 1
        end
    end
    if
        0038:   $POLICE_GUARD2 == 1
    then
        if
            0018:   $RAY1_GRENADE_AMMO > 0
        then
            00BC: print_now 'RM1_5' 5000 ms 1   // // ~g~Go back and torch the safehouse!
            0164: remove_blip $RAY1_BLIP
            018A: $RAY1_BLIP = create_checkpoint_at 43.0 -443.1875 35.875
            0004: $POLICE_GUARD2 = 0
        end
    end
end //while
02EF: destroy_projectiles_in_area  41.1 -445.2  34.1  45.1 -441.2  37.7
01B4: set_player $PLAYER can_move 0 (frozen)
02A3: toggle_widescreen 1 (on)
03BF: set_player $PLAYER ignored_by_everyone_to 1 (true)
03F4: set_all_cars_can_be_damaged 0
015F: set_camera_position 38.25 -444.6875 34.5 0.0 0.0 0.0
0160: point_camera 39.125 -444.25 34.75 1
wait 100 ms
020C: create_explosion_with_radius 0 at 43.0 -443.5 34.875
wait 500 ms
02CF: $FIRE_1 = create_fire_at 42.0 -444.0  34.0625
02CF: $FIRE_2 = create_fire_at 42.0 -443.0  34.0625
02CF: $FIRE_3 = create_fire_at 44.0 -444.0  34.0625
02CF: $FIRE_4 = create_fire_at 44.0 -443.0  34.0625
0444: create_fire_audio $FIRE_1 1
0444: create_fire_audio $FIRE_2 0
0444: create_fire_audio $FIRE_3 0
0444: create_fire_audio $FIRE_4 0
wait 250 ms
009A: $BURNING_COP = create_actor 4 #COP at 43.0 -444.6875 34.25
wait 250 ms
02A2: create_particle 4 at 42.0 -441.5625 34.875 0
02A2: create_particle 4 at 43.0 -443.25 34.875 0
0001: wait 800 ms 
02A2: create_particle 4 at 41.0 -443.3125 36.0 0
0001: wait 500 ms 
02A2: create_particle 4 at 41.0 -442.6875 36.0 0
02A2: create_particle 4 at 41.0 -443.75 36.0 0
wait 1500 ms
01B4: set_player $PLAYER can_move 1 (unfrozen)
02A3: toggle_widescreen 0 (off)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
03F4: set_all_cars_can_be_damaged 1
02EB: restore_camera_jumpcut
0373: set_camera_directly_behind_player
00A5: $GET_AWAY_CAR = create_car #SENTINEL at  45.0 -437.5  27.0625
0175: set_car $GET_AWAY_CAR z_angle_to 90.0
020A: set_car $GET_AWAY_CAR door_status_to 3
03AB: set_vehicle $GET_AWAY_CAR strong 1
0129: $POLICE_GUARD1 = create_actor 4 #COP in_car $GET_AWAY_CAR driverseat
01C8: $THE_WITNESS = create_actor 4 #LI_MAN2 in_car $GET_AWAY_CAR passenger_seat 1
009A: $POLICE_GUARD2 = create_actor 4 #COP at 41.5 -435.125 26.0625
01B2: give_actor $POLICE_GUARD2 weapon 25 ammo 5000  // Load the weapon model before using this
0211: actor $POLICE_GUARD2 walk_to 39.0 -435.125
009A: $POLICE_GUARD3 = create_actor 4 #COP at 41.5 -439.6875 26.0625
01B2: give_actor $POLICE_GUARD3 weapon 25 ammo 5000  // Load the weapon model before using this
0211: actor $POLICE_GUARD3 walk_to 39.0 -439.6875
02B9: deactivate_garage $WITSEC_HOUSE_GARAGE
0299: activate_garage $WITSEC_HOUSE_GARAGE
0164: remove_blip $RAY1_BLIP
00AD: set_car $GET_AWAY_CAR max_speed_to 20.0
00AE: set_car $GET_AWAY_CAR driving_style 2  // DRIVINGMODE_AVOIDCARS
00A8: set_car $GET_AWAY_CAR to_psycho_driver
0428: set_car_avoid_level_transitions $GET_AWAY_CAR flag 1
00BC: print_now 'RM1_2' 5000 ms 1   // // ~g~Take out McAffrey!
01BD: $GAME_TIMER_START_R1 = current_time_in_ms
while 00A2:   actor $THE_WITNESS alive
    if
        8118:   NOT   actor $POLICE_GUARD2 dead
    then
        if
            80A3:   NOT   actor $POLICE_GUARD2 0 in_rectangle 40.0 -441.5 51.0 -434.0
        then
            01CA: actor $POLICE_GUARD2 kill_player $PLAYER
        end
    end
    if
        8118:   NOT   actor $POLICE_GUARD3 dead
    then
        if
            80A3:   NOT   actor $POLICE_GUARD3 0 in_rectangle 40.0 -441.5 51.0 -434.0
        then
            01CA: actor $POLICE_GUARD3 kill_player $PLAYER
        end
    end
    if
        0038:   $WANTED_LVL_FLAG_R1 == 0
    then
        01BD: $GAME_TIMER_CURRENT_R1 = current_time_in_ms
        0084: $GAME_TIMER_R1 = $GAME_TIMER_CURRENT_R1
        0060: $GAME_TIMER_R1 -= $GAME_TIMER_START_R1
        if
            0018:   $GAME_TIMER_R1 > 3000
        then
            010E: set_player $PLAYER minimum_wanted_level_to 2
            0187: $RAY1_BLIP = create_marker_above_actor $THE_WITNESS
            if
                03D0:   wav 1 loaded
            then
                03D1: play_wav  1
            end
            0004: $WANTED_LVL_FLAG_R1 = 1
        end
    end
    if
        0038:   $WANTED_LVL_FLAG_R1 == 1
    then
        if and
            80E9:   NOT   player $PLAYER 0 near_actor $THE_WITNESS radius 160.0 160.0
            82CB:   NOT   actor $THE_WITNESS is_on_screen
        then
            if
                0038:   $MFAIL_TIMER_RESET_FLAG == 0
            then
                0164: remove_blip $RAY1_BLIP
                01BD: $MFAIL_TIMER_STARTED = current_time_in_ms
                0004: $MFAIL_TIMER_RESET_FLAG = 1
            end
            if
                0038:   $MFAIL_TIMER_RESET_FLAG == 1
            then
                01BD: $MFAIL_TIMER_CURRENT = current_time_in_ms
                0084: $MFAIL_TIMER = $MFAIL_TIMER_CURRENT
                0060: $MFAIL_TIMER -= $MFAIL_TIMER_STARTED
                if
                    0018:   $MFAIL_TIMER > 4000
                then
                    if
                        82CB:   NOT   actor $THE_WITNESS is_on_screen
                    then
                        0004: $MFAIL_TIMER_RESET_FLAG = 0
                        009B: destroy_actor_instantly $THE_WITNESS
                        00BC: print_now 'RM1_3' 5000 ms 1   // // ~r~McAffrey escaped!
                        jump @MISSION_RAY1_FAILED
                    end
                end
            end
        end
        if
            0038:   $MFAIL_TIMER_RESET_FLAG == 1
        then
            if or
                00E9:   player $PLAYER 0 near_actor $THE_WITNESS radius 160.0 160.0
                02CB:   actor $THE_WITNESS is_on_screen
            then
                0164: remove_blip $RAY1_BLIP
                0187: $RAY1_BLIP = create_marker_above_actor $THE_WITNESS
                0004: $MFAIL_TIMER_RESET_FLAG = 0
            end
        end
    end
    if
        80DF:   NOT   actor $THE_WITNESS driving
    then
        01D0: actor $THE_WITNESS avoid_player $PLAYER
    end
    if
        8119:   NOT   car $GET_AWAY_CAR wrecked
    then
        if
            00DB:   actor $THE_WITNESS in_car $GET_AWAY_CAR
        then
            if
                0038:   $CARLOCK_FLAG == 0
            then
                if
                    81AD:   NOT   car $GET_AWAY_CAR 0 near_point 45.0 -437.5 40.0 40.0
                then
                    020A: set_car $GET_AWAY_CAR door_status_to 1
                    00AD: set_car $GET_AWAY_CAR max_speed_to 40.0
                    03AB: set_vehicle $GET_AWAY_CAR strong 0
                    if
                        0185:   car $GET_AWAY_CAR health >= 800
                    then
                        0224: set_car $GET_AWAY_CAR health_to 800
                    end
                    0004: $CARLOCK_FLAG = 1
                end
            end
            if and
                01F4:   car $GET_AWAY_CAR flipped
                01C1:   car $GET_AWAY_CAR stopped
            then
                01D3: actor $THE_WITNESS leave_car $GET_AWAY_CAR
                if
                    8118:   NOT   actor $POLICE_GUARD1 dead
                then
                    01CA: actor $POLICE_GUARD1 kill_player $PLAYER
                    01B2: give_actor $POLICE_GUARD1 weapon 25 ammo 5000  // Load the weapon model before using this
                end
            end
            if
                00DC:   player $PLAYER driving $GET_AWAY_CAR
            then
                01D3: actor $THE_WITNESS leave_car $GET_AWAY_CAR
                if
                    8118:   NOT   actor $POLICE_GUARD1 dead
                then
                    01CA: actor $POLICE_GUARD1 kill_player $PLAYER
                    01B2: give_actor $POLICE_GUARD1 weapon 25 ammo 5000  // Load the weapon model before using this
                end
            end
            0227: $GET_AWAY_CAR_HEALTH = car $GET_AWAY_CAR health
            if
                001A:   200 > $GET_AWAY_CAR_HEALTH
            then
                01D3: actor $THE_WITNESS leave_car $GET_AWAY_CAR
                if
                    8118:   NOT   actor $POLICE_GUARD1 dead
                then
                    01CA: actor $POLICE_GUARD1 kill_player $PLAYER
                    01B2: give_actor $POLICE_GUARD1 weapon 25 ammo 5000  // Load the weapon model before using this
                end
            end
            if
                01C1:   car $GET_AWAY_CAR stopped
            then
                if
                    0038:   $GETAWAY_STUCK_FLAG == 0
                then
                    0006: 16@ = 0
                    0004: $GETAWAY_STUCK_FLAG = 1
                end
                if
                    0038:   $GETAWAY_STUCK_FLAG == 1
                then
                    if
                        0019:   16@ > 5000
                    then
                        01D3: actor $THE_WITNESS leave_car $GET_AWAY_CAR
                        if
                            8118:   NOT   actor $POLICE_GUARD1 dead
                        then
                            01CA: actor $POLICE_GUARD1 kill_player $PLAYER
                            01B2: give_actor $POLICE_GUARD1 weapon 25 ammo 5000  // Load the weapon model before using this
                        end
                    end
                end
            end
            if
                81C1:   NOT   car $GET_AWAY_CAR stopped
            then
                0004: $GETAWAY_STUCK_FLAG = 0
            end
            if
                01AD:   car $GET_AWAY_CAR 0 near_point $BA3 $BA4 3.0 3.0
            then
                if
                    0038:   $CAR_MOVING_STUCK_FLAG == 0
                then
                    0006: 17@ = 0
                    0004: $CAR_MOVING_STUCK_FLAG = 1
                end
                if
                    0038:   $CAR_MOVING_STUCK_FLAG == 1
                then
                    if
                        0019:   17@ > 8000
                    then
                        01D3: actor $THE_WITNESS leave_car $GET_AWAY_CAR
                        if
                            8118:   NOT   actor $POLICE_GUARD1 dead
                        then
                            01CA: actor $POLICE_GUARD1 kill_player $PLAYER
                            01B2: give_actor $POLICE_GUARD1 weapon 25 ammo 5000  // Load the weapon model before using this
                        end
                    end
                end
            else
                00AA: store_car $GET_AWAY_CAR position_to $GET_AWAY_CAR_X $GET_AWAY_CAR_Y $GET_AWAY_CAR_Z
                0004: $CAR_MOVING_STUCK_FLAG = 0
            end
        end
    end
    wait 0 ms
end //while
jump @MISSION_RAY1_PASSED

:MISSION_RAY1_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // // MISSION FAILED!
return

:MISSION_RAY1_PASSED
0004: $SILENCE_THE_SNEAK_COMPLETED = 1
01E3: text_1number_styled 'M_PASS' 30000 5000 ms 1   // // MISSION PASSED! $~1~
0109: player $PLAYER money += 30000
0110: clear_player $PLAYER wanted_level
0394: play_music 1
0318: set_latest_mission_passed 'RM1'   // // 'SILENCE THE SNEAK'
030C: set_mission_points += 1
004F: create_thread @RAY_MISSION2_LOOP
return

:MISSION_CLEANUP_RAY1
0164: remove_blip $RAY1_BLIP
03AE: remove_objects_from_cube 37.0 -449.0 31.0 48.0 -436.0 39.0
0249: mark_model_as_no_longer_needed #LI_MAN2
0249: mark_model_as_no_longer_needed #SENTINEL
0249: mark_model_as_no_longer_needed #GRENADE
0249: mark_model_as_no_longer_needed #AK47
0249: mark_model_as_no_longer_needed #SAFEHOUSE
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_RAY = 0
031A: remove_all_fires
mission_cleanup
return
