//-------------Mission 56-------------
// Originally: Ray mission 3 'EVIDENCE DASH'

:M56_EVIDENCEDASH
03A4: name_thread 'RAY3'
054C: use_GXT_table 'RAY3'
058E: set_restart_mission_taxi_destination -221.6 -696.3 31.66 180.0
gosub @MISSION_START_RAY3
if
    wasted_or_busted
then
    gosub @MISSION_RAY3_FAILED
end
gosub @MISSION_CLEANUP_RAY3
end_thread

:MISSION_START_RAY3
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_RAY = 1
0004: $RAYS_CUTSCENE_FLAG = 1
0317: increment_mission_attempts
wait 0 ms
0005: $IA_START_X = -388.0
0005: $IA_START_Y = -1380.5
0005: $IA_START_Z = 32.0

0004: $AMOUNT_DAMAGE_IA_DROP_EVIDENCE = 1

//0004: $WANTED_LEVEL_CHANGE = 1

0004: $DROP_ONE_FLAG = 0
0004: $DROP_EVIDENCE = 0

0004: $GREEN = 250
0004: $RED = 0
0004: $RED_INCREASE_FLAG = 0
0004: $RED_DECREASE_FLAG = 0
0004: $GREEN_INCREASE_FLAG = 0
0004: $GREEN_DECREASE_FLAG = 0

0004: $TIMERA_RESET_FLAG = 0
0004: $IA_HAVE_EVIDENCE_FLAG = 0
0004: $TEMPORARY_HEALTH_VAR = 0
0004: $IA_CAR_PREVIOUS_HEALTH = 0
0004: $IA_CAR_CURRENT_HEALTH = 0
0004: $AMOUNT_OF_EVIDENCE_PLAYER_HAS = 0
0004: $GET_COORDS_FLAG = 0
0004: $TIMERC_RESET_FLAG_R3 = 0
0004: $TIMERD_RESET_FLAG_R3 = 0
0004: $TIMERD_CURRENT_R3 = 0
0004: $TIMERD_STARTED_R3 = 0
0004: $TIMERD_R3 = 0

0004: $TIMER_FOR_SPEED = 0
0004: $RESET_FOR_TIMER = 0

0005: $OBJECT_CURRENT_COORDS_X = 0.0
0005: $OBJECT_CURRENT_COORDS_Y = 0.0
0005: $OBJECT_CURRENT_COORDS_Z = 0.0
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'RAY'
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'RAYH'
0247: request_model #TOILET
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #TOILET available
    jf break
    wait 0 ms
end
0395: clear_area 1 at -296.0 -723.5 28.0 range 1.0
0055: set_player_coordinates $PLAYER at -296.0 -723.5 28.0
0171: set_player $PLAYER z_angle_to 90.0
02E4: load_cutscene_data 'R3_ED'
0244: set_cutscene_pos -295.625 -726.625 27.6875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_RAY = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_RAY 'RAY'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
//02F4: create_cutscene_actor $RAY_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_RAY
//02F5: set_head_anim $RAY_CSHEAD 'RAY'
016A: fade 1 (back)  1500 ms
041D: set_camera_near_clip 0.1875
02E7: start_cutscene
03AF: set_streaming 0 (disabled)
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   10381 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM3_A' 10000 ms 1   // // I know a real important man in town a soft touch
while 001A:   13529 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM3_H' 10000 ms 1   // // with shall we say exotic tastes and the money to indulge them.
while 001A:   17950 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM3_B' 10000 ms 1   // // He's involved in a legal matter and the prosecution has some rather embarrassing photos of him
while 001A:   23502 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM3_C' 10000 ms 1   // // at a morgue party or something.
while 001A:   26180 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM3_D' 10000 ms 1   // // The evidence is being driven across town.
while 001A:   29179 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM3_E' 10000 ms 1   // // You are going to have to ram that car and collect each little bit of evidence as it falls out.
while 001A:   34865 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM3_F' 10000 ms 1   // // When you've got it all leave it in the car and torch it.
while 001A:   39290 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM3_G' 10000 ms 1   // // We're both gonna do pretty well outta this kid.
while 001A:   41666 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
016A: fade 0  0 ms
041D: set_camera_near_clip 0.875
0171: set_player $PLAYER z_angle_to 90.0
0373: set_camera_directly_behind_player
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #TOILET
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0247: request_model #FILES
0247: request_model #BOBCAT
0247: request_model #B_MAN3
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #BOBCAT available
        8248:   NOT   model #B_MAN3 available
        8248:   NOT   model #FILES available
    jf break
    wait 0 ms
end
016A: fade 1 (back)  1500 ms
03AF: set_streaming 1 (enabled)
0004: $RAYS_CUTSCENE_FLAG = 0
while fading
    wait 0 ms
end
00A5: $IA_CAR_RM3 = create_car #BOBCAT at $IA_START_X $IA_START_Y $IA_START_Z
0428: set_car_avoid_level_transitions $IA_CAR_RM3 flag 1
039C: set_car_watertight $IA_CAR_RM3 1
0129: $IA_CAR_DRIVER_1 = create_actor 4 #B_MAN3 in_car $IA_CAR_RM3 driverseat
039E: set_char_cant_be_dragged_out $IA_CAR_DRIVER_1 1
02AA: set_car $IA_CAR_RM3 immune_to_nonplayer 1
03ED: set_upsidedown_car_not_damaged $IA_CAR_RM3 1
02AC: set_car $IA_CAR_RM3 immunities 1 1 1 0 1
00AD: set_car $IA_CAR_RM3 max_speed_to 20.0
00AE: set_car $IA_CAR_RM3 driving_style 2  // DRIVINGMODE_AVOIDCARS
00A8: set_car $IA_CAR_RM3 to_psycho_driver
0186: $PROSECUTION_CAR_BLIP = create_marker_above_car $IA_CAR_RM3
020A: set_car $IA_CAR_RM3 door_status_to 2
if
    0038:   $FLAG_PLAYER_ON_MISSION == 0
then
    0187: $RAYS_EVIDENCE_BLIP = create_marker_above_actor $IA_CAR_DRIVER_1
end
00AA: store_car $IA_CAR_RM3 position_to $CAR_STUCK_X $CAR_STUCK_Y $CAR_STUCK_Z
00AA: store_car $IA_CAR_RM3 position_to $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
0009: $IA_CAR_Z += 3.0
0107: $EVIDENCE_1 = create_object #FILES at $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
0009: $IA_CAR_Z += 1.0
0107: $EVIDENCE_2 = create_object #FILES at $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
0009: $IA_CAR_Z += 1.0
0107: $EVIDENCE_3 = create_object #FILES at $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
0009: $IA_CAR_Z += 1.0
0107: $EVIDENCE_4 = create_object #FILES at $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
0009: $IA_CAR_Z += 1.0
0107: $EVIDENCE_5 = create_object #FILES at $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
0009: $IA_CAR_Z += 1.0
0107: $EVIDENCE_6 = create_object #FILES at $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
0382: set_object $EVIDENCE_1 collision_detection 0
0382: set_object $EVIDENCE_2 collision_detection 0
0382: set_object $EVIDENCE_3 collision_detection 0
0382: set_object $EVIDENCE_4 collision_detection 0
0382: set_object $EVIDENCE_5 collision_detection 0
0382: set_object $EVIDENCE_6 collision_detection 0
035C: place_object $EVIDENCE_1 relative_to_car $IA_CAR_RM3 offset 0.25 -1.6875 -0.0625
035C: place_object $EVIDENCE_2 relative_to_car $IA_CAR_RM3 offset 0.25 -1.1875 -0.0625
035C: place_object $EVIDENCE_3 relative_to_car $IA_CAR_RM3 offset -0.25 -1.1875 -0.0625
035C: place_object $EVIDENCE_4 relative_to_car $IA_CAR_RM3 offset 0.25 -0.6875 -0.0625
035C: place_object $EVIDENCE_5 relative_to_car $IA_CAR_RM3 offset -0.25 -0.6875 -0.0625
035C: place_object $EVIDENCE_6 relative_to_car $IA_CAR_RM3 offset -0.25 -1.6875 -0.0625
0004: $IA_HAVE_EVIDENCE_FLAG = 1
//Main loop
while true
    wait 0 ms
    if
        0119:   car $IA_CAR_RM3 wrecked
    then
        if
            02BF:   car $IA_CAR_RM3 sunk
        then
            if
                81FC:   NOT   player $PLAYER near_car $IA_CAR_RM3 radius 50.0 50.0 0
            then
                if
                    82CA:   NOT   car $IA_CAR_RM3 is_on_screen
                then
                    00AA: store_car $IA_CAR_RM3 position_to $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
                    03D3: point $IA_CAR_X $IA_CAR_Y $IA_CAR_Z get_nearby_vector $IA_CAR_X $IA_CAR_Y $IA_CAR_Z $WARP_HEADING
                    if
                        80C2:   NOT   sphere_onscreen $IA_CAR_X $IA_CAR_Y $IA_CAR_Z 3.0
                    then
                        00AB: put_car $IA_CAR_RM3 at $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
                        0175: set_car $IA_CAR_RM3 z_angle_to $WARP_HEADING
                    end
                end
            else
                00BC: print_now 'RM3_6' 5000 ms 1   // // ~r~The photos will be washed up all over Liberty!
                jump @MISSION_RAY3_FAILED
            end
        else
            jump @MISSION_RAY3_PASSED
        end
    end
    if and
        01F4:   car $IA_CAR_RM3 flipped
        01C1:   car $IA_CAR_RM3 stopped
    then
        if
            82CA:   NOT   car $IA_CAR_RM3 is_on_screen
        then
            00AA: store_car $IA_CAR_RM3 position_to $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
            03D3: point $IA_CAR_X $IA_CAR_Y $IA_CAR_Z get_nearby_vector $IA_CAR_X $IA_CAR_Y $IA_CAR_Z $WARP_HEADING
            if
                80C2:   NOT   sphere_onscreen $IA_CAR_X $IA_CAR_Y $IA_CAR_Z 3.0
            then
                00AB: put_car $IA_CAR_RM3 at $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
                0175: set_car $IA_CAR_RM3 z_angle_to $WARP_HEADING
            end
        else
            if
                8038:   NOT   $DROP_EVIDENCE == 6
            then
                gosub @CREATE_ANOTHER_CAR
            end
        end
    end
    if
        0038:   $TIMERA_RESET_FLAG == 1
    then
        if
            81C1:   NOT   car $IA_CAR_RM3 stopped
        then
            0004: $TIMERA_RESET_FLAG = 0
        end
    end
    if
        01C1:   car $IA_CAR_RM3 stopped
    then
        if
            0038:   $TIMERA_RESET_FLAG == 0
        then
            0006: 16@ = 0
            0004: $TIMERA_RESET_FLAG = 1
        end
        if and
            0019:   16@ > 5000
            0038:   $TIMERA_RESET_FLAG == 1
        then
            if
                82CA:   NOT   car $IA_CAR_RM3 is_on_screen
            then
                00AA: store_car $IA_CAR_RM3 position_to $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
                03D3: point $IA_CAR_X $IA_CAR_Y $IA_CAR_Z get_nearby_vector $IA_CAR_X $IA_CAR_Y $IA_CAR_Z $WARP_HEADING
                if
                    80C2:   NOT   sphere_onscreen $IA_CAR_X $IA_CAR_Y $IA_CAR_Z 4.0
                then
                    00AB: put_car $IA_CAR_RM3 at $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
                    0175: set_car $IA_CAR_RM3 z_angle_to $WARP_HEADING
                    0004: $TIMERA_RESET_FLAG = 0
                end
            else
                if
                    8038:   NOT   $DROP_EVIDENCE == 6
                then
                    gosub @CREATE_ANOTHER_CAR
                end
            end
        end
    end
    if
        01AF:   car $IA_CAR_RM3 0 near_point $CAR_STUCK_X $CAR_STUCK_Y $CAR_STUCK_Z radius 4.0 4.0 4.0
    then
        if
            0038:   $TIMERC_RESET_FLAG_R3 == 0
        then
            01BD: $TIMERC_STARTED_R3 = current_time_in_ms
            0004: $TIMERC_RESET_FLAG_R3 = 1
        end
        if
            0038:   $TIMERC_RESET_FLAG_R3 == 1
        then
            01BD: $TIMERC_CURRENT_R3 = current_time_in_ms
            0084: $TIMERC_R3 = $TIMERC_CURRENT_R3
            0060: $TIMERC_R3 -= $TIMERC_STARTED_R3
            if
                0018:   $TIMERC_R3 > 8000
            then
                if
                    82CA:   NOT   car $IA_CAR_RM3 is_on_screen
                then
                    00AA: store_car $IA_CAR_RM3 position_to $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
                    03D3: point $IA_CAR_X $IA_CAR_Y $IA_CAR_Z get_nearby_vector $IA_CAR_X $IA_CAR_Y $IA_CAR_Z $WARP_HEADING
                    if
                        838A:   NOT   car_in_cube $IA_CAR_X $IA_CAR_Y $IA_CAR_Z 4.0 4.0 4.0
                    then
                        if
                            80C2:   NOT   sphere_onscreen $IA_CAR_X $IA_CAR_Y $IA_CAR_Z 4.0
                        then
                            00AB: put_car $IA_CAR_RM3 at $IA_CAR_X $IA_CAR_Y $IA_CAR_Z
                            0175: set_car $IA_CAR_RM3 z_angle_to $WARP_HEADING
                            0004: $TIMERC_RESET_FLAG_R3 = 0
                        end
                    end
                else
                    if
                        8038:   NOT   $DROP_EVIDENCE == 6
                    then
                        gosub @CREATE_ANOTHER_CAR
                    end
                end
            end
        end
    end
    if
        81AF:   NOT   car $IA_CAR_RM3 0 near_point $CAR_STUCK_X $CAR_STUCK_Y $CAR_STUCK_Z radius 4.0 4.0 4.0
    then
        00AA: store_car $IA_CAR_RM3 position_to $CAR_STUCK_X $CAR_STUCK_Y $CAR_STUCK_Z
        0004: $TIMERC_RESET_FLAG_R3 = 0
    end
    01BD: $TIMER_FOR_SPEED = current_time_in_ms
    0060: $TIMER_FOR_SPEED -= $RESET_FOR_TIMER
    if
        0018:   $TIMER_FOR_SPEED > 1000
    then
        01BD: $RESET_FOR_TIMER = current_time_in_ms
        if
            01FC:   player $PLAYER near_car $IA_CAR_RM3 radius 20.0 20.0 0
        then
            00AD: set_car $IA_CAR_RM3 max_speed_to 50.0
        else
            if
                01FC:   player $PLAYER near_car $IA_CAR_RM3 radius 50.0 50.0 0
            then
                00AD: set_car $IA_CAR_RM3 max_speed_to 41.0
            else
                if
                    01FC:   player $PLAYER near_car $IA_CAR_RM3 radius 90.0 90.0 0
                then
                    00AD: set_car $IA_CAR_RM3 max_speed_to 34.0
                else
                    if
                        01FC:   player $PLAYER near_car $IA_CAR_RM3 radius 130.0 130.0 0
                    then
                        00AD: set_car $IA_CAR_RM3 max_speed_to 28.0
                    else
                        00AD: set_car $IA_CAR_RM3 max_speed_to 20.0
                    end
                end
            end
        end
    end
    if
        0038:   $IA_HAVE_EVIDENCE_FLAG == 0
    then
        if
            0019:   17@ > 500
        then
            if
                00F5:   player $PLAYER 0 near_point $OBJECT_CURRENT_COORDS_X $OBJECT_CURRENT_COORDS_Y $OBJECT_CURRENT_COORDS_Z radius 1.5 1.5 1.5
            then
                gosub @EVIDENCE_COLLECTED
            end
        end
        if
            0019:   17@ > 10000
        then
            if
                00E3:   player $PLAYER 0 near_point $OBJECT_CURRENT_COORDS_X $OBJECT_CURRENT_COORDS_Y radius 1.5 1.5
            then
                gosub @EVIDENCE_COLLECTED
            end
        end
        if
            0019:   17@ > 120000
        then
            if
                00E3:   player $PLAYER 0 near_point $OBJECT_CURRENT_COORDS_X $OBJECT_CURRENT_COORDS_Y radius 30.0 30.0
            then
                gosub @EVIDENCE_COLLECTED
            end
        end
    end
    0084: $IA_CAR_PREVIOUS_HEALTH = $IA_CAR_CURRENT_HEALTH
    0227: $IA_CAR_CURRENT_HEALTH = car $IA_CAR_RM3 health
    if
        0038:   $IA_HAVE_EVIDENCE_FLAG == 1
    then
        if
            020D:   car $IA_CAR_RM3 upright
        then
            0084: $TEMPORARY_HEALTH_VAR = $IA_CAR_PREVIOUS_HEALTH
            0060: $TEMPORARY_HEALTH_VAR -= $AMOUNT_DAMAGE_IA_DROP_EVIDENCE
            if
                001C:   $TEMPORARY_HEALTH_VAR > $IA_CAR_CURRENT_HEALTH
            then
                00BC: print_now 'RM3_4' 3000 ms 1   // // ~g~The Prosecution has dropped the evidence!
                0224: set_car $IA_CAR_RM3 health_to 1000
                0004: $IA_CAR_CURRENT_HEALTH = 1000
                0004: $IA_CAR_PREVIOUS_HEALTH = 1000
                0004: $IA_HAVE_EVIDENCE_FLAG = 0
                0004: $DROP_ONE_FLAG = 0
                0004: $GET_COORDS_FLAG = 1
            end
        end
    end
    if and
        0038:   $IA_HAVE_EVIDENCE_FLAG == 0
        0038:   $DROP_ONE_FLAG == 0
    then
        0008: $DROP_EVIDENCE += 1
        0164: remove_blip $RAYS_EVIDENCE_BLIP
        if
            0038:   $DROP_EVIDENCE == 1
        then
            035C: place_object $EVIDENCE_1 relative_to_car $IA_CAR_RM3 offset 0.25 -1.6875 0.1875
            0188: $RAYS_EVIDENCE_BLIP = create_marker_above_object $EVIDENCE_1
            0382: set_object $EVIDENCE_1 collision_detection 1
            0392: object $EVIDENCE_1 toggle_in_moving_list 1
            038C: object $EVIDENCE_1 scatter 0.0 0.0 16.0
            035D: make_object $EVIDENCE_1 targetable
            010E: set_player $PLAYER minimum_wanted_level_to 2
            00AD: set_car $IA_CAR_RM3 max_speed_to 100.0
            00AE: set_car $IA_CAR_RM3 driving_style 2  // DRIVINGMODE_AVOIDCARS
            0006: 17@ = 0
        end
        if
            0038:   $DROP_EVIDENCE == 2
        then
            035C: place_object $EVIDENCE_2 relative_to_car $IA_CAR_RM3 offset 0.25 -1.1875 0.1875
            0188: $RAYS_EVIDENCE_BLIP = create_marker_above_object $EVIDENCE_2
            0382: set_object $EVIDENCE_2 collision_detection 1
            0392: object $EVIDENCE_2 toggle_in_moving_list 1
            038C: object $EVIDENCE_2 scatter 0.0 0.0 16.0
            035D: make_object $EVIDENCE_2 targetable
            0006: 17@ = 0
        end
        if
            0038:   $DROP_EVIDENCE == 3
        then
            035C: place_object $EVIDENCE_3 relative_to_car $IA_CAR_RM3 offset -0.25 -1.1875 0.1875
            0188: $RAYS_EVIDENCE_BLIP = create_marker_above_object $EVIDENCE_3
            0382: set_object $EVIDENCE_3 collision_detection 1
            0392: object $EVIDENCE_3 toggle_in_moving_list 1
            038C: object $EVIDENCE_3 scatter 0.0 0.0 16.0
            035D: make_object $EVIDENCE_3 targetable
            0006: 17@ = 0
        end
        if
            0038:   $DROP_EVIDENCE == 4
        then
            035C: place_object $EVIDENCE_4 relative_to_car $IA_CAR_RM3 offset 0.25 -0.6875 0.1875
            0188: $RAYS_EVIDENCE_BLIP = create_marker_above_object $EVIDENCE_4
            0382: set_object $EVIDENCE_4 collision_detection 1
            0392: object $EVIDENCE_4 toggle_in_moving_list 1
            038C: object $EVIDENCE_4 scatter 0.0 0.0 16.0
            035D: make_object $EVIDENCE_4 targetable
            0006: 17@ = 0
        end
        if
            0038:   $DROP_EVIDENCE == 5
        then
            035C: place_object $EVIDENCE_5 relative_to_car $IA_CAR_RM3 offset -0.25 -0.6875 0.1875
            0188: $RAYS_EVIDENCE_BLIP = create_marker_above_object $EVIDENCE_5
            0382: set_object $EVIDENCE_5 collision_detection 1
            0392: object $EVIDENCE_5 toggle_in_moving_list 1
            038C: object $EVIDENCE_5 scatter 0.0 0.0 16.0
            035D: make_object $EVIDENCE_5 targetable
            0006: 17@ = 0
        end
        if
            0038:   $DROP_EVIDENCE == 6
        then
            035C: place_object $EVIDENCE_6 relative_to_car $IA_CAR_RM3 offset -0.25 -1.6875 0.1875
            0188: $RAYS_EVIDENCE_BLIP = create_marker_above_object $EVIDENCE_6
            0382: set_object $EVIDENCE_6 collision_detection 1
            0392: object $EVIDENCE_6 toggle_in_moving_list 1
            038C: object $EVIDENCE_6 scatter 0.0 0.0 16.0
            035D: make_object $EVIDENCE_6 targetable
            0164: remove_blip $PROSECUTION_CAR_BLIP
            0006: 17@ = 0
        end
        0004: $DROP_ONE_FLAG = 1
    end
    if
        0038:   $GET_COORDS_FLAG == 1
    then
        if
            0038:   $DROP_EVIDENCE == 1
        then
            01BB: store_object $EVIDENCE_1 position_to $OBJECT_CURRENT_COORDS_X $OBJECT_CURRENT_COORDS_Y $OBJECT_CURRENT_COORDS_Z
        end
        if
            0038:   $DROP_EVIDENCE == 2
        then
            01BB: store_object $EVIDENCE_2 position_to $OBJECT_CURRENT_COORDS_X $OBJECT_CURRENT_COORDS_Y $OBJECT_CURRENT_COORDS_Z
        end
        if
            0038:   $DROP_EVIDENCE == 3
        then
            01BB: store_object $EVIDENCE_3 position_to $OBJECT_CURRENT_COORDS_X $OBJECT_CURRENT_COORDS_Y $OBJECT_CURRENT_COORDS_Z
        end
        if
            0038:   $DROP_EVIDENCE == 4
        then
            01BB: store_object $EVIDENCE_4 position_to $OBJECT_CURRENT_COORDS_X $OBJECT_CURRENT_COORDS_Y $OBJECT_CURRENT_COORDS_Z
        end
        if
            0038:   $DROP_EVIDENCE == 5
        then
            01BB: store_object $EVIDENCE_5 position_to $OBJECT_CURRENT_COORDS_X $OBJECT_CURRENT_COORDS_Y $OBJECT_CURRENT_COORDS_Z
        end
        if
            0038:   $DROP_EVIDENCE == 6
        then
            01BB: store_object $EVIDENCE_6 position_to $OBJECT_CURRENT_COORDS_X $OBJECT_CURRENT_COORDS_Y $OBJECT_CURRENT_COORDS_Z
        end
    end
    if
        0038:   $IA_HAVE_EVIDENCE_FLAG == 0
    then
        if
            0038:   $RED == 0
        then
            0004: $RED_DECREASE_FLAG = 0
            0004: $RED_INCREASE_FLAG = 1
        end
        if
            0038:   $RED == 250
        then
            0004: $RED_DECREASE_FLAG = 1
            0004: $RED_INCREASE_FLAG = 0
        end
        if
            0038:   $RED_INCREASE_FLAG == 1
        then
            0008: $RED += 10
        end
        if
            0038:   $RED_DECREASE_FLAG == 1
        then
            000C: $RED -= 10
        end
        if
            0038:   $GREEN == 0
        then
            0004: $GREEN_DECREASE_FLAG = 0
            0004: $GREEN_INCREASE_FLAG = 1
        end
        if
            0038:   $GREEN == 250
        then
            0004: $GREEN_DECREASE_FLAG = 1
            0004: $GREEN_INCREASE_FLAG = 0
        end
        if
            0038:   $GREEN_INCREASE_FLAG == 1
        then
            0008: $GREEN += 10
        end
        if
            0038:   $GREEN_DECREASE_FLAG == 1
        then
            000C: $GREEN -= 10
        end
        024F: create_corona 0.5 6 0 with_color $RED $GREEN 0 at_point $OBJECT_CURRENT_COORDS_X $OBJECT_CURRENT_COORDS_Y $OBJECT_CURRENT_COORDS_Z
    end
    if
        001A:   1 > $DROP_EVIDENCE
    then
        035C: place_object $EVIDENCE_1 relative_to_car $IA_CAR_RM3 offset 0.25 -1.6875 -0.0625
    end
    if
        001A:   2 > $DROP_EVIDENCE
    then
        035C: place_object $EVIDENCE_2 relative_to_car $IA_CAR_RM3 offset 0.25 -1.1875 -0.0625
    end
    if
        001A:   3 > $DROP_EVIDENCE
    then
        035C: place_object $EVIDENCE_3 relative_to_car $IA_CAR_RM3 offset -0.25 -1.1875 -0.0625
    end
    if
        001A:   4 > $DROP_EVIDENCE
    then
        035C: place_object $EVIDENCE_4 relative_to_car $IA_CAR_RM3 offset 0.25 -0.6875 -0.0625
    end
    if
        001A:   5 > $DROP_EVIDENCE
    then
        035C: place_object $EVIDENCE_5 relative_to_car $IA_CAR_RM3 offset -0.25 -0.6875 -0.0625
    end
    if
        001A:   6 > $DROP_EVIDENCE
    then
        035C: place_object $EVIDENCE_6 relative_to_car $IA_CAR_RM3 offset -0.25 -1.6875 -0.0625
    end
    if
        0038:   $AMOUNT_OF_EVIDENCE_PLAYER_HAS == 6
    then
        0164: remove_blip $RAYS_EVIDENCE_BLIP
        00BC: print_now 'RM3_1' 5000 ms 1   // // ~g~Leave the evidence in a car then torch the car.
        while 80E0:   NOT   player $PLAYER driving
            wait 0 ms
        end
        00DA: $PLAYERS_CAR = player $PLAYER car
        while 00E0:   player $PLAYER driving
            wait 0 ms
        end
        if
            8119:   NOT   car $PLAYERS_CAR wrecked
        then
            0186: $RAYS_EVIDENCE_BLIP = create_marker_above_car $PLAYERS_CAR
            0151: remove_status_text $AMOUNT_OF_EVIDENCE_PLAYER_HAS
            00BC: print_now 'RM3_7' 5000 ms 1   // // ~g~Now torch the car!
            while 8119:   NOT   car $PLAYERS_CAR wrecked
                wait 0 ms
            end
            jump @MISSION_RAY3_PASSED
        else
            jump @MISSION_RAY3_PASSED
        end
    end
end //while

:MISSION_RAY3_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // // MISSION FAILED!
return

:MISSION_RAY3_PASSED
0004: $EVIDENCE_DASH_COMPLETED = 1
01E3: text_1number_styled 'M_PASS' 10000 5000 ms 1   // // MISSION PASSED! $~1~
0109: player $PLAYER money += 10000
0110: clear_player $PLAYER wanted_level
0318: set_latest_mission_passed 'RM3'   // // 'EVIDENCE DASH'
0394: play_music 1
030C: set_mission_points += 1
004F: create_thread @RAY_MISSION4_LOOP
if
    82BD:   NOT   debug_mode == DEBUG_MASTERDEBUG
then
    02A7: $DONALD_MISSION_MARKER = create_icon_marker_and_sphere 9 at -248.9375 -1548.6899 34.25
    004F: create_thread @LOVE_MISSION1_LOOP
end
return

:MISSION_CLEANUP_RAY3
0164: remove_blip $RAYS_EVIDENCE_BLIP
0164: remove_blip $PROSECUTION_CAR_BLIP
0151: remove_status_text $AMOUNT_OF_EVIDENCE_PLAYER_HAS
0249: mark_model_as_no_longer_needed #BOBCAT
0249: mark_model_as_no_longer_needed #B_MAN3
0249: mark_model_as_no_longer_needed #DONKEYMAG
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_RAY = 0
mission_cleanup
return

:CREATE_ANOTHER_CAR
if
    0038:   $TIMERD_RESET_FLAG_R3 == 0
then
    01BD: $TIMERD_STARTED_R3 = current_time_in_ms
    0004: $TIMERD_RESET_FLAG_R3 = 1
end
if
    0038:   $TIMERD_RESET_FLAG_R3 == 1
then
    01BD: $TIMERD_CURRENT_R3 = current_time_in_ms
    0084: $TIMERD_R3 = $TIMERD_CURRENT_R3
    0060: $TIMERD_R3 -= $TIMERD_STARTED_R3
    if
        0018:   $TIMERD_R3 > 15000
    then
        00BC: print_now 'RM3_8' 5000 ms 1   // // ~r~That car is a decoy!!
        0164: remove_blip $PROSECUTION_CAR_BLIP
        01C3: remove_references_to_car $IA_CAR_RM3  // Like turning a car into any random car
        01C2: remove_references_to_actor $IA_CAR_DRIVER_1  // Like turning an actor into a random pedestrian
        if
            00E3:   player $PLAYER 0 near_point $IA_START_X $IA_START_Y radius 150.0 150.0
        then
            00A5: $IA_CAR_RM3 = create_car #BOBCAT at -80.188 -667.375 31.25
        else
            00A5: $IA_CAR_RM3 = create_car #BOBCAT at $IA_START_X $IA_START_Y $IA_START_Z
        end
        0129: $IA_CAR_DRIVER_1 = create_actor 4 #B_MAN3 in_car $IA_CAR_RM3 driverseat
        039C: set_car_watertight $IA_CAR_RM3 1
        039E: set_char_cant_be_dragged_out $IA_CAR_DRIVER_1 1
        02AA: set_car $IA_CAR_RM3 immune_to_nonplayer 1
        03ED: set_upsidedown_car_not_damaged $IA_CAR_RM3 1
        02AC: set_car $IA_CAR_RM3 immunities 1 1 1 0 1
        00AD: set_car $IA_CAR_RM3 max_speed_to 100.0
        00AE: set_car $IA_CAR_RM3 driving_style 2  // DRIVINGMODE_AVOIDCARS
        00A8: set_car $IA_CAR_RM3 to_psycho_driver
        0186: $PROSECUTION_CAR_BLIP = create_marker_above_car $IA_CAR_RM3
        020A: set_car $IA_CAR_RM3 door_status_to 2
        0428: set_car_avoid_level_transitions $IA_CAR_RM3 flag 1
        0004: $TIMERD_RESET_FLAG_R3 = 0
    end
end
return

:EVIDENCE_COLLECTED
0164: remove_blip $RAYS_EVIDENCE_BLIP
0004: $GET_COORDS_FLAG = 0
018C: play_sound 82 at $OBJECT_CURRENT_COORDS_X $OBJECT_CURRENT_COORDS_Y $OBJECT_CURRENT_COORDS_Z
if
    0038:   $DROP_EVIDENCE == 1
then
    0108: destroy_object $EVIDENCE_1
    03C4: set_status_text_to $AMOUNT_OF_EVIDENCE_PLAYER_HAS 0  'COLLECT'   // // COLLECTED:
end
if
    0038:   $DROP_EVIDENCE == 2
then
    0108: destroy_object $EVIDENCE_2
end
if
    0038:   $DROP_EVIDENCE == 3
then
    0108: destroy_object $EVIDENCE_3
end
if
    0038:   $DROP_EVIDENCE == 4
then
    0108: destroy_object $EVIDENCE_4
end
if
    0038:   $DROP_EVIDENCE == 5
then
    0108: destroy_object $EVIDENCE_5
end
if
    0038:   $DROP_EVIDENCE == 6
then
    0108: destroy_object $EVIDENCE_6
end
0008: $AMOUNT_OF_EVIDENCE_PLAYER_HAS += 1
01E5: text_1number_highpriority 'RM3_5' $AMOUNT_OF_EVIDENCE_PLAYER_HAS 5000 ms 1   // // ~g~You have ~1~ of 6 evidence packages.
0004: $IA_HAVE_EVIDENCE_FLAG = 1
0006: 17@ = 0
return
