//-------------Mission 58-------------
// Originally: Ray mission 5 'PLASTER BLASTER'

:M58_PLASTERBLASTER
03A4: name_thread 'RAY5'
054C: use_GXT_table 'RAY5'
058E: set_restart_mission_taxi_destination -221.6 -696.3 31.66 180.0
gosub @MISSION_START_RAY5
if
    wasted_or_busted
then
    gosub @MISSION_RAY5_FAILED
end
gosub @MISSION_CLEANUP_RAY5
end_thread

:MISSION_START_RAY5
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_RAY = 1
0004: $RAYS_CUTSCENE_FLAG = 1
wait 0 ms
//0004: $FLAG_BODYCAST_CLEAR = 0
0004: $FLAG_REDALERT = 0
0004: $FLAG_RANDOM_RAY5 = 0
0004: $FLAG_POLICE_TRIGGER = 0
0004: $FLAG_AUDIO = 0
0004: $AMBULANCE_HEALTH = 0
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'RAY'
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'RAYH'
0247: request_model #TOILET
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #TOILET available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'R5_PB'
03AF: set_streaming 1 (enabled)
0244: set_cutscene_pos -295.625 -726.625 27.6875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_RAY = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_RAY 'RAY'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
//02F4: create_cutscene_actor $RAY_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_RAY
//02F5: set_head_anim $RAY_CSHEAD 'RAY'
0395: clear_area 1 at -296.0 -723.5 28.0 range 1.0
0055: set_player_coordinates $PLAYER at -296.0 -723.5 28.0
0171: set_player $PLAYER z_angle_to 90.0
016A: fade 1 (back)  1500 ms
02E7: start_cutscene
03AD: set_rubbish 0 (invisible)
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   919 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM5_A' 2000 ms 1   // // You useless bastard!
while 001A:   3082 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM5_A1' 4500 ms 1   // // You totally messed up! My ass is on the line and you can't even kill a god damned fly.
while 001A:   7840 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM5_B' 3000 ms 1   // // I paid you good money to kill that witness and he ain't dead!
while 001A:   10868 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM5_B1' 2000 ms 1   // // And today he's gonna make a Federal Deposition!
while 001A:   13138 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM5_C' 4000 ms 1   // // He's being moved any second now from the Carson General Hospital up in Rockford.
while 001A:   17626 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM5_D' 2500 ms 1   // // If he squeals I squeal....
while 001A:   24333 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
016A: fade 0  0 ms
0373: set_camera_directly_behind_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #TOILET
03AF: set_streaming 1 (enabled)
03AD: set_rubbish 1 (visible)
0004: $RAYS_CUTSCENE_FLAG = 0
0247: request_model #AMBULAN
0247: request_model #ENFORCER
0247: request_model #COP
0247: request_model #SWAT
while true
    if or
        8248:   NOT   model #AMBULAN available
        8248:   NOT   model #COP available
        8248:   NOT   model #SWAT available
        8248:   NOT   model #ENFORCER available
    jf break
    wait 0 ms
end
00A5: $SWATVAN1 = create_car #ENFORCER at 82.75 -1064.0 32.375
0175: set_car $SWATVAN1 z_angle_to 50.0
00A9: set_car $SWATVAN1 to_normal_driver
0397: car $SWATVAN1 siren = 1 (true)   // never used in VC
00A5: $SWATVAN2 = create_car #ENFORCER at 0.375 -1185.1899 32.375
0175: set_car $SWATVAN2 z_angle_to 150.0
00A9: set_car $SWATVAN2 to_normal_driver
0397: car $SWATVAN2 siren = 1 (true)   // never used in VC
009A: $SWAT1_RC5 = create_actor 4 #SWAT at 79.562 -1060.25 32.1875
0173: set_actor $SWAT1_RC5 z_angle_to 0.0
01ED: reset_actor $SWAT1_RC5 flags
011A: set_actor $SWAT1_RC5 flags 1
01B2: give_actor $SWAT1_RC5 weapon 26 ammo 100  // Load the weapon model before using this
01B9: set_actor $SWAT1_RC5 armed_weapon_to 26
0350: set_char_stay_in_same_place $SWAT1_RC5  1
035F: set_actor $SWAT1_RC5 armour_to 100
009A: $SWAT2_RC5 = create_actor 4 #SWAT at 30.0 -1146.6899 29.0
0173: set_actor $SWAT2_RC5 z_angle_to 270.0
01ED: reset_actor $SWAT2_RC5 flags
011A: set_actor $SWAT2_RC5 flags 1
01B2: give_actor $SWAT2_RC5 weapon 26 ammo 100  // Load the weapon model before using this
01B9: set_actor $SWAT2_RC5 armed_weapon_to 26
0350: set_char_stay_in_same_place $SWAT2_RC5  1
035F: set_actor $SWAT2_RC5 armour_to 100
009A: $SWAT3_RC5 = create_actor 4 #SWAT at -3.5 -1184.0601 32.1875
0173: set_actor $SWAT3_RC5 z_angle_to 100.0
01ED: reset_actor $SWAT3_RC5 flags
011A: set_actor $SWAT3_RC5 flags 1
01B2: give_actor $SWAT3_RC5 weapon 26 ammo 100  // Load the weapon model before using this
01B9: set_actor $SWAT3_RC5 armed_weapon_to 26
0350: set_char_stay_in_same_place $SWAT3_RC5  1
035F: set_actor $SWAT3_RC5 armour_to 100
009A: $SWAT4_RC5 = create_actor 4 #SWAT at 1.0 -1122.0 32.0
0173: set_actor $SWAT4_RC5 z_angle_to 230.0
01ED: reset_actor $SWAT4_RC5 flags
011A: set_actor $SWAT4_RC5 flags 1
01B2: give_actor $SWAT4_RC5 weapon 26 ammo 100  // Load the weapon model before using this
01B9: set_actor $SWAT4_RC5 armed_weapon_to 26
0350: set_char_stay_in_same_place $SWAT4_RC5  1
035F: set_actor $SWAT4_RC5 armour_to 100
03CF: load_wav 'R5_A' as 1

:AMB_GENERATOR
0004: $AMBULANCE_HEALTH = 0
03C4: set_status_text_to $AMBULANCE_HEALTH 1 (bar)  'DAM'   // // Damage
00A5: $AMBULANCE_RC5 = create_car #AMBULAN at 52.25 4.5 17.375
0186: $BLIP_AMBULANCE_RC5 = create_marker_above_car $AMBULANCE_RC5
0129: $COP_DRIVER = create_actor 6 #COP in_car $AMBULANCE_RC5 driverseat
020A: set_car $AMBULANCE_RC5 door_status_to 2
0175: set_car $AMBULANCE_RC5 z_angle_to 166.0
00AD: set_car $AMBULANCE_RC5 max_speed_to 20.0
00AE: set_car $AMBULANCE_RC5 driving_style 0  // DRIVINGMODE_STOPFORCARS
02AA: set_car $AMBULANCE_RC5 immune_to_nonplayer 1
0227: $AMBULANCE_HEALTH = car $AMBULANCE_RC5 health
0099: $RANDOM_RAY5 = random_integer_0-to-65535
if
    001A:   21846 > $RANDOM_RAY5
then
    00A7: car $AMBULANCE_RC5 drive_to -483.875 18.0 32.5
end
if and
    0018:   $RANDOM_RAY5 > 21845
    001A:   43691 > $RANDOM_RAY5
then
    00A7: car $AMBULANCE_RC5 drive_to 67.875 -404.875 32.5
    0004: $FLAG_RANDOM_RAY5 = 1
end
if
    0018:   $RANDOM_RAY5 > 43690
then
    00A7: car $AMBULANCE_RC5 drive_to -348.1875 -804.688 32.5
    0004: $FLAG_RANDOM_RAY5 = 2
end
while 0038:   $FLAG_REDALERT == 0
    wait 0 ms
    if
        8119:   NOT   car $AMBULANCE_RC5 wrecked
    then
        00AA: store_car $AMBULANCE_RC5 position_to $AMB_RC5_X $AMB_RC5_Y $AMB_RC5_Z
        0227: $AMBULANCE_HEALTH = car $AMBULANCE_RC5 health
        0010: $AMBULANCE_HEALTH *= -1
        0008: $AMBULANCE_HEALTH += 1000
        if
            0038:   $FLAG_RANDOM_RAY5 == 0
        then
            if
                01AD:   car $AMBULANCE_RC5 0 near_point -483.875 18.0 15.0 15.0
            then
                00A7: car $AMBULANCE_RC5 drive_to 70.188 -1137.6899 32.0 //---amb goto penultimate waypoint
                0004: $FLAG_RANDOM_RAY5 = 3
            end
        end
        if
            0038:   $FLAG_RANDOM_RAY5 == 1
        then
            if
                01AD:   car $AMBULANCE_RC5 0 near_point 67.875 -404.875 15.0 15.0
            then
                00A7: car $AMBULANCE_RC5 drive_to 70.188 -1137.6899 32.0 //---amb goto penultimate waypoint
                0004: $FLAG_RANDOM_RAY5 = 3
            end
        end
        if
            0038:   $FLAG_RANDOM_RAY5 == 2
        then
            if
                01AD:   car $AMBULANCE_RC5 0 near_point -348.1875 -804.688 15.0 15.0
            then
                00A7: car $AMBULANCE_RC5 drive_to 70.188 -1137.6899 32.0 //---amb goto penultimate waypoint
                0004: $FLAG_RANDOM_RAY5 = 3
            end
        end
        if
            0038:   $FLAG_RANDOM_RAY5 == 3
        then
            if
                01AD:   car $AMBULANCE_RC5 0 near_point 70.188 -1137.6899 15.0 15.0
            then
                0004: $FLAG_REDALERT = 1
                00A7: car $AMBULANCE_RC5 drive_to 27.0 -1138.0 29.0 //----amb goto final destination
                00AD: set_car $AMBULANCE_RC5 max_speed_to 15.0
                00AE: set_car $AMBULANCE_RC5 driving_style 0  // DRIVINGMODE_STOPFORCARS
            end
        end
        if
            02CA:   car $AMBULANCE_RC5 is_on_screen
        then
            02AA: set_car $AMBULANCE_RC5 immune_to_nonplayer 0
        else
            02AA: set_car $AMBULANCE_RC5 immune_to_nonplayer 1
        end
    else
        00BC: print_now 'RM5_3' 2500 ms 1   // // ~g~It was a decoy!
        01C3: remove_references_to_car $AMBULANCE_RC5  // Like turning a car into any random car
        01C2: remove_references_to_actor $COP_DRIVER  // Like turning an actor into a random pedestrian
        0164: remove_blip $BLIP_AMBULANCE_RC5
        0151: remove_status_text $AMBULANCE_HEALTH
        0004: $FLAG_RANDOM_RAY5 = 0
        0004: $FLAG_POLICE_TRIGGER = 0
        jump @AMB_GENERATOR
    end
    if
        00E3:   player $PLAYER 0 near_point $AMB_RC5_X $AMB_RC5_Y radius 25.0 25.0
    then
        if
            8119:   NOT   car $AMBULANCE_RC5 wrecked
        then
            00BC: print_now 'RM5_2' 3000 ms 1   // // ~g~You've been spotted!!
            00AD: set_car $AMBULANCE_RC5 max_speed_to 28.0
            00AE: set_car $AMBULANCE_RC5 driving_style 3  // DRIVINGMODE_PLOUGHTHROUGH
            00A7: car $AMBULANCE_RC5 drive_to 70.188 -1137.6899 32.0
            03D1: play_wav 1
            0397: car $AMBULANCE_RC5 siren = 1 (true)   // never used in VC
            010E: set_player $PLAYER minimum_wanted_level_to 2
            0004: $FLAG_REDALERT = 1
            0004: $FLAG_POLICE_TRIGGER = 1
        end
    end
    gosub @SWAT_TEAM
end //while
//------either; player has 'been spotted'-police despatched
//------OR; ambulance has reached penultimate way point
while 0038:   $FLAG_REDALERT == 1
    wait 0 ms
    if
        8119:   NOT   car $AMBULANCE_RC5 wrecked
    then
        0227: $AMBULANCE_HEALTH = car $AMBULANCE_RC5 health
        0010: $AMBULANCE_HEALTH *= -1
        0008: $AMBULANCE_HEALTH += 1000
        if
            8185:   NOT   car $AMBULANCE_RC5 health >= 900 //---ambulance damaged enough to force bailout
        then
            jump @INJURED_COP_BAILOUT
        end
        if
            01AD:   car $AMBULANCE_RC5 0 near_point 70.188 -1137.6899 15.0 15.0
        then
            00AD: set_car $AMBULANCE_RC5 max_speed_to 10.0
            0004: $FLAG_REDALERT = 2
            00A7: car $AMBULANCE_RC5 drive_to 27.0 -1138.0 29.0 //----amb goto final destination
            00AD: set_car $AMBULANCE_RC5 max_speed_to 15.0
            00AE: set_car $AMBULANCE_RC5 driving_style 0  // DRIVINGMODE_STOPFORCARS
        end
        if
            02CA:   car $AMBULANCE_RC5 is_on_screen
        then
            02AA: set_car $AMBULANCE_RC5 immune_to_nonplayer 0
        else
            02AA: set_car $AMBULANCE_RC5 immune_to_nonplayer 1
        end
    else
        00BC: print_now 'RM5_3' 2500 ms 1   // // ~g~It was a decoy!
        01C3: remove_references_to_car $AMBULANCE_RC5
        01C2: remove_references_to_actor $COP_DRIVER
        0164: remove_blip $BLIP_AMBULANCE_RC5
        0151: remove_status_text $AMBULANCE_HEALTH
        0004: $FLAG_RANDOM_RAY5 = 0
        0004: $FLAG_POLICE_TRIGGER = 0
        jump @AMB_GENERATOR
    end
    if and
        00E3:   player $PLAYER 0 near_point $AMB_RC5_X $AMB_RC5_Y radius 25.0 25.0 //---player taken the bait ---police close in
        0038:   $FLAG_POLICE_TRIGGER == 0
    then
        if
            8119:   NOT   car $AMBULANCE_RC5 wrecked
        then
            00BC: print_now 'RM5_2' 3000 ms 1   // // ~g~You've been spotted!!
            00AD: set_car $AMBULANCE_RC5 max_speed_to 28.0
            00AE: set_car $AMBULANCE_RC5 driving_style 3  // DRIVINGMODE_PLOUGHTHROUGH
            00A7: car $AMBULANCE_RC5 drive_to 70.188 -1137.6899 32.0
            03D1: play_wav 1
            0397: car $AMBULANCE_RC5 siren = 1 (true)   // never used in VC
            010E: set_player $PLAYER minimum_wanted_level_to 2
            0004: $FLAG_REDALERT = 1
            0004: $FLAG_POLICE_TRIGGER = 1
        end
    end
    gosub @SWAT_TEAM
end //while
//----ambulance has reached penultimate waypoint
while 0038:   $FLAG_REDALERT == 2
    wait 0 ms
    if
        8119:   NOT   car $AMBULANCE_RC5 wrecked
    then
        0227: $AMBULANCE_HEALTH = car $AMBULANCE_RC5 health
        0010: $AMBULANCE_HEALTH *= -1
        0008: $AMBULANCE_HEALTH += 1000
        if
            01AD:   car $AMBULANCE_RC5 1 near_point 27.0 -1138.0 5.0 5.0
        then
            0004: $FLAG_REDALERT = 3
            00AD: set_car $AMBULANCE_RC5 max_speed_to 0.0
            00AE: set_car $AMBULANCE_RC5 driving_style 0  // DRIVINGMODE_STOPFORCARS
            0397: car $AMBULANCE_RC5 siren = 0 (false)   // never used in VC
            00A9: set_car $AMBULANCE_RC5 to_normal_driver
        end
        if
            8185:   NOT   car $AMBULANCE_RC5 health >= 900
        then
            jump @INJURED_COP_BAILOUT
        end
        if
            02CA:   car $AMBULANCE_RC5 is_on_screen
        then
            02AA: set_car $AMBULANCE_RC5 immune_to_nonplayer 0
        else
            02AA: set_car $AMBULANCE_RC5 immune_to_nonplayer 1
        end
    else
        00BC: print_now 'RM5_3' 2500 ms 1   // // ~g~It was a decoy!
        01C3: remove_references_to_car $AMBULANCE_RC5  // Like turning a car into any random car
        01C2: remove_references_to_actor $COP_DRIVER  // Like turning an actor into a random pedestrian
        0164: remove_blip $BLIP_AMBULANCE_RC5
        0151: remove_status_text $AMBULANCE_HEALTH
        0004: $FLAG_RANDOM_RAY5 = 0
        0004: $FLAG_REDALERT = 0
        jump @AMB_GENERATOR
    end
    if and
        00E3:   player $PLAYER 0 near_point $AMB_RC5_X $AMB_RC5_Y radius 25.0 25.0
        0038:   $FLAG_POLICE_TRIGGER == 0
    then
        00BC: print_now 'RM5_2' 3000 ms 1   // // ~g~You've been spotted!!
        010E: set_player $PLAYER minimum_wanted_level_to 2
        0004: $FLAG_POLICE_TRIGGER = 1
    end
    gosub @SWAT_TEAM
end //while
jump @MISSION_RAY5_FAILED

:INJURED_COP_BAILOUT
0164: remove_blip $BLIP_AMBULANCE_RC5
00AA: store_car $AMBULANCE_RC5 position_to $AMB_RC5_X $AMB_RC5_Y $AMB_RC5_Z
0009: $AMB_RC5_Z += 2.5
0107: $INJURED_COP_RC5 = create_object #BODYCAST at $AMB_RC5_X $AMB_RC5_Y $AMB_RC5_Z
0382: set_object $INJURED_COP_RC5 collision_detection 1
0392: object $INJURED_COP_RC5 toggle_in_moving_list 1
035D: make_object $INJURED_COP_RC5 targetable
038C: object $INJURED_COP_RC5 scatter 0.0 0.0 5.0
0188: $BLIP_INJURED_COP_RC5 = create_marker_above_object $INJURED_COP_RC5
010E: set_player $PLAYER minimum_wanted_level_to 3
0151: remove_status_text $AMBULANCE_HEALTH
{ //commented out of Rockstar's original code
while $FLAG_BODYCAST_CLEAR == 0
    wait 0
    get_object_coordinates $INJURED_COP_RC5 $IC_X $IC_Y $IC_Z
    if 8119:   NOT  is_car_dead $AMBULANCE_RC5
        if NOT locate_car_3D  $AMBULANCE_RC5 $IC_X $IC_Y $IC_Z 5.0 5.0 5.0 false
            0382: set_object_collision $INJURED_COP_RC5 1
            $FLAG_BODYCAST_CLEAR = 1
        end
    else
        0382: set_object_collision $INJURED_COP_RC5 1
        $FLAG_BODYCAST_CLEAR = 1
    end
end //while
}
03C4: set_status_text_to $BODYCAST_HEALTH 1 (bar)  'DAM'   // // Damage
00BC: print_now 'RM5_6' 3000 ms 1   // // ~g~He's bailed out!! Smash his bodycast with a vehicle or an explosion!!
while 8366:   NOT   object $INJURED_COP_RC5 damaged
    wait 0 ms
    01BB: store_object $INJURED_COP_RC5 position_to $IC_X $IC_Y $IC_Z
    03D7: set_wav 1 location $IC_X $IC_Y $IC_Z
    03F8: get_body_cast_health  $BODYCAST_HEALTH
    0010: $BODYCAST_HEALTH *= -1
    0008: $BODYCAST_HEALTH += 1000
    0014: $BODYCAST_HEALTH /= 10
    if
        0038:   $FLAG_AUDIO == 0
    then
        03D1: play_wav 1
    end
    if
        03D2:   wav 1 ended
    then
        0004: $FLAG_AUDIO = 1
    end
    if and
        02D7:   player $PLAYER currentweapon == 17
        80E0:   NOT   player $PLAYER driving
    then
        00BB: text_lowpriority 'RM5_4' 500 ms 1   // // ~g~Bullets won't get through that armored bodycast!!
    end
    if and
        02D7:   player $PLAYER currentweapon == 23
        80E0:   NOT   player $PLAYER driving
    then
        00BB: text_lowpriority 'RM5_4' 500 ms 1   // // ~g~Bullets won't get through that armored bodycast!!
    end
    if and
        02D7:   player $PLAYER currentweapon == 21
        80E0:   NOT   player $PLAYER driving
    then
        00BB: text_lowpriority 'RM5_4' 500 ms 1   // // ~g~Bullets won't get through that armored bodycast!!
    end
    if and
        02D7:   player $PLAYER currentweapon == 26
        80E0:   NOT   player $PLAYER driving
    then
        00BB: text_lowpriority 'RM5_4' 500 ms 1   // // ~g~Bullets won't get through that armored bodycast!!
    end
    if and
        02D7:   player $PLAYER currentweapon == 25
        80E0:   NOT   player $PLAYER driving
    then
        00BB: text_lowpriority 'RM5_4' 500 ms 1   // // ~g~Bullets won't get through that armored bodycast!!
    end
    if and
        02D7:   player $PLAYER currentweapon == 31
        80E0:   NOT   player $PLAYER driving
    then
        00BB: text_lowpriority 'RM5_5' 500 ms 1   // // ~g~That armored bodycast is flame retardant!!
    end
    if and
        02D7:   player $PLAYER currentweapon == 15
        80E0:   NOT   player $PLAYER driving
    then
        00BB: text_lowpriority 'RM5_5' 500 ms 1   // // ~g~That armored bodycast is flame retardant!!
    end
    if
        0022:   7.0 > $IC_Z
    then
        00BC: print_now 'RM5_8' 3000 ms 1   // // ~g~Witness has drowned!!
        jump @QUENTIN
    end
    gosub @SWAT_TEAM
end //while

:QUENTIN
0164: remove_blip $BLIP_INJURED_COP_RC5
jump @MISSION_RAY5_PASSED

:MISSION_RAY5_FAILED
00BC: print_now 'RM5_7' 3000 ms 1   // // ~r~Witness has been delivered!!
00BA: text_styled 'M_FAIL' 2000 ms 1   // // MISSION FAILED!
return

:MISSION_RAY5_PASSED
0004: $PLASTER_BLASTER_COMPLETED = 1
01E3: text_1number_styled 'M_PASS' 10000 5000 ms 1   // // MISSION PASSED! $~1~
0394: play_music 1
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 10000
0318: set_latest_mission_passed 'RM5'   // // 'PLASTER BLASTER'
030C: set_mission_points += 1
if and
    8038:   NOT   $A_DROP_IN_THE_OCEAN_COMPLETED == 1
    82BD:   NOT   debug_mode == DEBUG_MASTERDEBUG
then
   0164: remove_blip $RAY_MISSION_MARKER
else
    004F: create_thread @RAY_MISSION6_LOOP
end
return

:MISSION_CLEANUP_RAY5
0151: remove_status_text $AMBULANCE_HEALTH
0151: remove_status_text $BODYCAST_HEALTH
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_RAY = 0
01C4: remove_references_to_object $INJURED_COP_RC5  // This object will now disappear when the player looks away
01C2: remove_references_to_actor $SWAT1_RC5  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $SWAT2_RC5  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $SWAT3_RC5  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $SWAT4_RC5  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $COP_DRIVER  // Like turning an actor into a random pedestrian
0249: mark_model_as_no_longer_needed #AMBULAN
0249: mark_model_as_no_longer_needed #SWAT
0249: mark_model_as_no_longer_needed #ENFORCER
0164: remove_blip $BLIP_AMBULANCE_RC5
mission_cleanup
return

//------GOSUB------------------------------
:SWAT_TEAM
if
    0057:   player $PLAYER 0 in_cube 31.0 -1146.0 27.0 61.0 -1134.0 34.0
then
    if
        8118:   NOT   actor $SWAT1_RC5 dead
    then
        01CC: actor $SWAT1_RC5 kill_player $PLAYER
    end
    if
        8118:   NOT   actor $SWAT2_RC5 dead
    then
        01CC: actor $SWAT2_RC5 kill_player $PLAYER
    end
end
if
    0057:   player $PLAYER 0 in_cube -17.0 -1170.0 28.0 31.0 -1120.0 31.0
then
    if
        8118:   NOT   actor $SWAT1_RC5 dead
    then
        01CC: actor $SWAT1_RC5 kill_player $PLAYER
    end
    if
        8118:   NOT   actor $SWAT2_RC5 dead
    then
        01CC: actor $SWAT2_RC5 kill_player $PLAYER
    end
    if
        8118:   NOT   actor $SWAT3_RC5 dead
    then
        01CC: actor $SWAT3_RC5 kill_player $PLAYER
    end
    if
        8118:   NOT   actor $SWAT4_RC5 dead
    then
        01CC: actor $SWAT4_RC5 kill_player $PLAYER
    end
end
return
