:PORTLAND_SAVE
03A4: name_thread 'I_SAVE'

while true
    wait 250 ms
    if
        0256:   player $PLAYER defined
    then
        if
            03C6:   is_collision_in_memory 1
        then
            if
                0038:   $FLAG_PORTLAND_SAVE_ON_RADAR == 0
            then
                0164: remove_blip $PORTLAND_SAVE_MARKER
                02A7: $PORTLAND_SAVE_MARKER = create_icon_marker_and_sphere 20 at 535.0 -308.188 -100.0
                04CE: $PORTLAND_AMMUNATION_MARKER = create icon marker without sphere 23 at 735.75 -396.938 20.1875
                04CE: $PORTLAND_PAYNSPRAY_MARKER = create icon marker without sphere 21 at 590.0 -359.5  16.0
                04CE: $PORTLAND_BOMBSHOP_MARKER = create icon marker without sphere 27 at 947.0 -104.0  20.0
                018B: change_blip $PORTLAND_SAVE_MARKER display 2
                0004: $FLAG_PORTLAND_SAVE_ON_RADAR = 1
            end
            if
                0121:   player $PLAYER in_zone 'REDLIGH'
            then
                if
                    0038:   $LUIGIS_GIRLS_COMPLETED == 1
                then
                    if
                        0038:   $FLAG_PLAYER_ON_MISSION == 0
                    then
                        while 834D:   NOT unknown_rotate_object $PORTLAND_HIDEOUT_DOOR angle 210.0 10.0 0
                            wait 0 ms
                        end
                    else
                        while 834D:   NOT unknown_rotate_object $PORTLAND_HIDEOUT_DOOR angle 0.0 10.0 0
                            wait 0 ms
                        end
                    end
                end
                if
                    0256:   player $PLAYER defined
                then
                    if
                        03EE:   player $PLAYER controllable
                    then
                        if
                            0038:   $FLAG_PLAYER_ON_MISSION == 0
                        then
                            if
                                019C:   player $PLAYER 0 in_cube_on_foot 556.188 -309.688 13.6875 564.25 -303.25 18.6875  // never used in VC
                            then
                                01B4: set_player $PLAYER can_move 0 (frozen)
                                015F: set_camera_position 549.5 -305.312 19.5 0.0 0.0 0.0
                                0160: point_camera 550.25 -305.812 19.0 2
                                03CF: load_wav 'DOOR_1' as 1
                                gosub @AUDIO1_PLAY
                                while 834D:   NOT unknown_rotate_object $PORTLAND_HIDEOUT_DOOR angle 0.0 8.0 0
                                    wait 0 ms
                                end
                                while 83D2:   NOT   wav 1 ended
                                    wait 0 ms
                                end
                                040D: unload_wav 1
                                03D8: show_save_screen
                                wait 0 ms
                                while 83D9:   NOT   save_done
                                    wait 0 ms
                                end
                                0169: set_fade_color 0 0 0
                                016A: fade 0 (in)  1000 ms
                                if
                                    0256:   player $PLAYER defined
                                then
                                    01B4: set_player $PLAYER can_move 0 (frozen)
                                end
                                wait 1000 ms
                                while 834D:   NOT unknown_rotate_object $PORTLAND_HIDEOUT_DOOR angle 210.0 10.0 0
                                    wait 0 ms
                                end
                                0395: clear_area 1 at 553.562 -308.375 -100.0 range 1.0
                                if
                                    0256:   player $PLAYER defined
                                then
                                    0055: set_player_coordinates $PLAYER at 553.562 -308.375 -100.0
                                    0171: set_player $PLAYER z_angle_to 90.0
                                    016A: fade 1 (out)  1000 ms
                                    02EB: restore_camera_jumpcut
                                    03C8: set_camera_in_front_of_player
                                end
                                wait 1000 ms
                                if
                                    0256:   player $PLAYER defined
                                then
                                    01B4: set_player $PLAYER can_move 1 (unfrozen)
                                end
                            end
                        end
                    end
                end
            end
        else // not in Portland
            if
                0038:   $FLAG_PORTLAND_SAVE_ON_RADAR == 1
            then
                0164: remove_blip $PORTLAND_SAVE_MARKER
                0164: remove_blip $PORTLAND_AMMUNATION_MARKER
                0164: remove_blip $PORTLAND_PAYNSPRAY_MARKER
                0164: remove_blip $PORTLAND_BOMBSHOP_MARKER
                0004: $FLAG_PORTLAND_SAVE_ON_RADAR = 0
            end
        end
    end
end

//#####################################################################################
//#####################################################################################
// END RED LIGHT SAVE / BEGIN STAUNTON SAVE
//#####################################################################################
//#####################################################################################

:STAUNTON_SAVE
03A4: name_thread 'C_SAVE'

while true
    wait 250 ms
    if
        0256:   player $PLAYER defined
    then
        if
            03C6:   is_collision_in_memory 2
        then
            if
                0038:   $FLAG_STAUNTON_SAVE_ON_RADAR == 0
            then
                0164: remove_blip $STAUNTON_SAVE_MARKER
                02A7: $STAUNTON_SAVE_MARKER = create_icon_marker_and_sphere 20 at -231.75 -469.188 -100.0
                018B: change_blip $STAUNTON_SAVE_MARKER display 2
                04CE: $STAUNTON_AMMUNATION_MARKER = create icon marker without sphere 23 at 10.5 -713.5  32.0625
                04CE: $STAUNTON_PAYNSPRAY_MARKER = create icon marker without sphere 21 at 44.0 -493.75  31.1875
                04CE: $STAUNTON_BOMBSHOP_MARKER = create icon marker without sphere 27 at 45.0 -577.0 31.0625
                0004: $FLAG_STAUNTON_SAVE_ON_RADAR = 1
            end
            if
                0121:   player $PLAYER in_zone 'PARK'
            then
                if
                    0038:   $FLAG_PLAYER_ON_MISSION == 0
                then
                    while true
                        if or
                            834E:   NOT slide_object $STAUNTON_HIDEOUT_DOOR1 to -229.688 -482.75 22.25 angle 0.0625 0.0 0.0 0
                            834E:   NOT slide_object $STAUNTON_HIDEOUT_DOOR2 to -234.312 -482.75 22.25 angle 0.0625 0.0 0.0 0
                        jf break
                        wait 0 ms
                    end
                else
                    while true
                        if or
                            834E:   NOT slide_object $STAUNTON_HIDEOUT_DOOR1 to -231.188 -482.75 22.25 angle 0.0625 0.0 0.0 0
                            834E:   NOT slide_object $STAUNTON_HIDEOUT_DOOR2 to -232.812 -482.75 22.25 angle 0.0625 0.0 0.0 0
                        jf break
                        wait 0 ms
                    end
                end
                if
                    0256:   player $PLAYER defined
                then
                    if
                        03EE:   player $PLAYER controllable
                    then
                        if
                            0038:   $FLAG_PLAYER_ON_MISSION == 0
                        then
                            if
                                019C:   player $PLAYER 0 in_cube_on_foot -229.312 -486.0 21.0 -234.25 -483.375 24.0  // never used in VC
                            then
                                01B4: set_player $PLAYER can_move 0 (frozen)
                                015F: set_camera_position -236.5 -472.0 25.8125 0.0 0.0 0.0
                                0160: point_camera -236.0625 -472.875 25.4375 2
                                03CF: load_wav 'DOOR_3' as 1
                                gosub @AUDIO1_PLAY
                                while true
                                    if or
                                        834E:   NOT slide_object $STAUNTON_HIDEOUT_DOOR1 to -231.188 -482.75 22.25 angle 0.0625 0.0 0.0 0
                                        834E:   NOT slide_object $STAUNTON_HIDEOUT_DOOR2 to -232.812 -482.75 22.25 angle 0.0625 0.0 0.0 0
                                    jf break
                                    wait 0 ms
                                end
                                while 83D2:   NOT   wav 1 ended
                                    wait 0 ms
                                end
                                040D: unload_wav 1
                                03D8: show_save_screen
                                wait 0 ms
                                while 83D9:   NOT   save_done
                                    wait 0 ms
                                end
                                0169: set_fade_color 0 0 0
                                016A: fade 0 (in)  1000 ms
                                if
                                    0256:   player $PLAYER defined
                                then
                                    01B4: set_player $PLAYER can_move 0 (frozen)
                                end
                                wait 1000 ms
                                while true
                                    if or
                                        834E:   NOT slide_object $STAUNTON_HIDEOUT_DOOR1 to -229.688 -482.75 22.25 angle 0.0625 0.0 0.0 0
                                        834E:   NOT slide_object $STAUNTON_HIDEOUT_DOOR2 to -234.312 -482.75 22.25 angle 0.0625 0.0 0.0 0
                                    jf break
                                    wait 0 ms
                                end
                                0395: clear_area 1 at -232.0 -478.5 20.875 range 1.0
                                if
                                    0256:   player $PLAYER defined
                                then
                                    0055: set_player_coordinates $PLAYER at -232.0 -478.5 20.875
                                    0171: set_player $PLAYER z_angle_to 0.0
                                    016A: fade 1 (out)  1000 ms
                                    02EB: restore_camera_jumpcut
                                    03C8: set_camera_in_front_of_player
                                end
                                wait 1000 ms
                                if
                                    0256:   player $PLAYER defined
                                then
                                    01B4: set_player $PLAYER can_move 1 (unfrozen)
                                end
                            end
                        end
                    end
                end
            end
        else // not in Staunton
            if
                0038:   $FLAG_STAUNTON_SAVE_ON_RADAR == 1
            then
                0164: remove_blip $STAUNTON_SAVE_MARKER
                0164: remove_blip $STAUNTON_AMMUNATION_MARKER
                0164: remove_blip $STAUNTON_PAYNSPRAY_MARKER
                0164: remove_blip $STAUNTON_BOMBSHOP_MARKER
                0004: $FLAG_STAUNTON_SAVE_ON_RADAR = 0
            end
        end
    end
end

//#####################################################################################
//#####################################################################################
// END STAUNTON SAVE / BEGIN SSV SAVE
//#####################################################################################
//#####################################################################################

:SSV_SAVE
03A4: name_thread 'S_SAVE'

while true
    wait 250 ms
    if
        0256:   player $PLAYER defined
    then
        if
            03C6:   is_collision_in_memory 3
        then
            if
                0038:   $FLAG_SHORESIDE_SAVE_ON_RADAR == 0
            then
                0164: remove_blip $SHORESIDE_SAVE_MARKER
                02A7: $SHORESIDE_SAVE_MARKER = create_icon_marker_and_sphere 20 at -1000.0 -6.5 -100.0
                018B: change_blip $SHORESIDE_SAVE_MARKER display 2
                04CE: $SSV_PAYNSPRAY_MARKER = create icon marker without sphere 21 at -1463.0 32.5 -100.0
                04CE: $SSV_BOMBSHOP_MARKER = create icon marker without sphere 27 at -1417.5 53.5 62.0
                0004: $FLAG_SHORESIDE_SAVE_ON_RADAR = 1
            end
            if
                0121:   player $PLAYER in_zone 'PROJECT'
            then
                if
                    0038:   $FLAG_PLAYER_ON_MISSION == 0
                then
                    while 834D:   NOT unknown_rotate_object $SSV_HIDEOUT_DOOR angle 250.0 10.0 0
                        wait 0 ms
                    end
                else
                    while 834D:   NOT unknown_rotate_object $SSV_HIDEOUT_DOOR angle 180.0 10.0 0
                        wait 0 ms
                    end
                end
            end
            if
                0256:   player $PLAYER defined
            then
                if
                    03EE:   player $PLAYER controllable
                then
                    if
                        0038:   $FLAG_PLAYER_ON_MISSION == 0
                    then
                        if
                            019C:   player $PLAYER 0 in_cube_on_foot -1005.5 3.875 24.0 -995.0 12.6875 28.0  // never used in VC
                        then
                            01B4: set_player $PLAYER can_move 0 (frozen)
                            015F: set_camera_position -1013.125 -6.4375 30.4375 0.0 0.0 0.0
                            0160: point_camera -1012.375 -5.875 30.0625 2
                            while 834D:   NOT unknown_rotate_object $SSV_HIDEOUT_DOOR angle 180.0 8.0 0
                                wait 0 ms
                            end
                            03D8: show_save_screen
                            wait 0 ms
                            while 83D9:   NOT   save_done
                                wait 0 ms
                            end
                            0169: set_fade_color 0 0 0
                            016A: fade 0 (in)  1000 ms
                            if
                                0256:   player $PLAYER defined
                            then
                                01B4: set_player $PLAYER can_move 0 (frozen)
                            end
                            wait 1000 ms
                            while 834D:   NOT unknown_rotate_object $SSV_HIDEOUT_DOOR angle 250.0 10.0 0
                                wait 0 ms
                            end
                            0395: clear_area 1 at -1001.75 -1.75 -100.0 range 1.0
                            if
                                0256:   player $PLAYER defined
                            then
                                0055: set_player_coordinates $PLAYER at -1001.75 -1.75 -100.0
                                0171: set_player $PLAYER z_angle_to 180.0
                                016A: fade 1 (out)  1000 ms
                                02EB: restore_camera_jumpcut
                                03C8: set_camera_in_front_of_player
                            end
                            wait 1000 ms
                            if
                                0256:   player $PLAYER defined
                            then
                                01B4: set_player $PLAYER can_move 1 (unfrozen)
                            end
                        end
                    end
                end
            end
        else // not in SSV
            if
                0038:   $FLAG_SHORESIDE_SAVE_ON_RADAR == 1
            then
                0164: remove_blip $SHORESIDE_SAVE_MARKER
                0164: remove_blip $SSV_PAYNSPRAY_MARKER
                0164: remove_blip $SSV_BOMBSHOP_MARKER
                0004: $FLAG_SHORESIDE_SAVE_ON_RADAR = 0
            end
        end
    end
end

//#####################################################################################
//#####################################################################################
// END SSV SAVE / BEGIN PORTLAND RESTART
//#####################################################################################
//#####################################################################################

:PORTLAND_RESTART
03A4: name_thread 'I_RSTRT'
while true
    wait 1000 ms
    if
        0256:   player $PLAYER defined
    then
        if
            03C6:   is_collision_in_memory 1
        then
            016C: restart_if_wasted at 809.25 -596.875 19.875 angle 90.0
            016D: restart_if_busted at 808.88 -675.188 19.992 angle 90.0
            058D: set_restart_mission_taxi_start 785.5 -585.01 20.77 angle 180.0
            058D: set_restart_mission_taxi_start 785.5 -655.64 20.77 angle 180.0
            if
                02BD:   debug_mode == DEBUG_MASTERDEBUG
            then
                01F0: set_max_wanted_level_to 6
            else
                01F0: set_max_wanted_level_to 4
            end
            end_thread
        end
    end
end //while

//#####################################################################################
//#####################################################################################
// END PORTLAND RESTART / BEGIN STAUNTON RESTART
//#####################################################################################
//#####################################################################################

:STAUNTON_RESTART
03A4: name_thread 'C_RSTRT'
while true
    wait 1000 ms
    if
        0256:   player $PLAYER defined
    then
        if
            03C6:   is_collision_in_memory 2
        then
            if or
                0038:   $FLAG_STAUNTON_OPEN == 1
                02BD:   debug_mode == DEBUG_MASTERDEBUG
            then
                016C: restart_if_wasted at -151.5 -17.75 22.1875 180.0
                016D: restart_if_busted at 5.25 -1123.38 31.0 180.0
                058D: set_restart_mission_taxi_start -132.53 -51.07 27.12 angle 90.0
                058D: set_restart_mission_taxi_start 5.0 -1138.0 28.0 angle 270.0
                if
                    02BD:   debug_mode == DEBUG_MASTERDEBUG
                then
                    01F0: set_max_wanted_level_to 6
                else
                    01F0: set_max_wanted_level_to 5
                end
                end_thread
            end
        end
    end
end

//#####################################################################################
//#####################################################################################
// END STAUNTON RESTART / BEGIN SSV RESTART
//#####################################################################################
//#####################################################################################

:SSV_RESTART
03A4: name_thread 'S_RSTRT'
while true
    wait 1000 ms
    if
        0256:   player $PLAYER defined
    then
        if
            03C6:   is_collision_in_memory 3
        then
            if or
                0038:   $FLAG_SHORESIDE_OPEN == 1
                02BD:   debug_mode == DEBUG_MASTERDEBUG
            then
                016C: restart_if_wasted at -1588.0 -138.188 63.75 90.0
                016D: restart_if_busted at -1594.5 -44.5 63.75 90.0
                058D: set_restart_mission_taxi_start -1604.0 -132.0 63.0 angle 0.0
                058D: set_restart_mission_taxi_start -1577.5 -54.5 62.5 angle 90.0
                01F0: set_max_wanted_level_to 6
                end_thread
            end
        end
    end
end