//-------------Mission 82-------------
// "Taxi Driver" mission from Grand Theft Auto: Liberty City Stories
// Converted by spaceeinstein to work in the GTA: Liberty City mod
// Written for Sanny Builder 3.2.2

:M82_TAXI
var
$SCORE_FOR_THIS_FARE : int
$TAXI_COUNTDOWN : int
$TAXI_PASSED_THIS_SHOT : int
4@ : int
8@ : int
9@ : int
10@ : int
16@ : int
$taxidr_lvar_16  : int
$taxidr_lvar_18  : int
$IN_A_ROW_NUMBER : int
$taxidr_lvar_20  : int
$taxidr_lvar_22  : int
$taxidr_lvar_23  : int
$taxidr_lvar_39  : int
$taxidr_lvar_42  : int
$TAXI_DESTX1     : float
$TAXI_DESTY1     : float
$TAXI_DESTX2     : float
$TAXI_DESTY2     : float
$TAXI_DESTZ1     : float
$TAXI_DESTZ2     : float
$TAXI_BLIPX      : float
$TAXI_BLIPY      : float
$TAXI_BLIPZ      : float
$taxidr_lvar_37  : float
$taxidr_lvar_44  : float
$taxidr_lvar_45  : float
$taxidr_lvar_46  : float
$taxidr_lvar_47  : float
end
03A4: name_thread 'TAXIDR'
gosub @TAXIDR_42
if
    0112:   wasted_or_busted
then
    gosub @TAXIDR_FAIL
end
gosub @TAXIDR_CLEANUP
004E: end_thread

:TAXIDR_42

// added initialisations
$taxidr_var_3910 = 0
$taxidr_lvar_16 = 0
$taxidr_lvar_18 = 0
$taxidr_lvar_22 = 0
$taxidr_lvar_23 = 0
$taxidr_lvar_39 = 0
$taxidr_lvar_41 = 0
$taxidr_lvar_42 = 0

$FLAG_PLAYER_ON_MISSION = 1
0@ = -1
6@ = 0
$TAXI_PASSED_THIS_SHOT = 0
$TAXI_COUNTDOWN = 0
$IN_A_ROW_NUMBER = 5
$taxidr_lvar_20 = 125
$taxidr_lvar_27 = 0
054C: use_GXT_table 'TAX2'  // Taxi
00BE: text_clear_all
if
    0256:   player $PLAYER defined
then
    01B4: set_player $PLAYER can_move 1
    03BF: set_player $PLAYER ignored_by_everyone_to 0
    01F7: set_player $PLAYER ignored_by_cops_state_to 0
    02A3: enable_widescreen 0
end
0373: set_camera_directly_behind_player
02EB: restore_camera_with_jumpcut
//05AE: constant_params 0 variable_params 0 unknown 48 call_with_params @MDLMAC_2412
// begin 05AE
0169: set_fade_color 0 0 1
016A: fade 1 1000 ms
while if 016B:   fading
    wait 0 ms
end
// end 05AE
//05AE: constant_params 1 variable_params 0 unknown 48 call_with_params @MDLMAC_1048 1
    // set counter color 200 200 200 255
03C4: set_status_text_to $TAXI_PASSED_THIS_SHOT 0 'FARES'  // Fares
if
    8256:   not player $PLAYER defined
then
    $taxidr_lvar_41 = 9
    return
else
    if
        00E0:   player $PLAYER in_any_car
    then
        03C1: 1@ = player $PLAYER car_no_save
    end
end
9@ = -1
if
    8185:   not car 1@ health >= 500
then
    00BC: text_highpriority 'TAXI7' 5000 ms 1  // ~w~Your car is trashed, get it repaired!
    jump @TAXIDR_2237
end

:TAXIDR_243
$taxidr_lvar_25 = 0
0216: set_car 1@ taxi_available_light_to 1
if
    not  0@ == -1
then
    if
        056D:   actor 0@ defined
    then
        01C2: mark_actor_as_no_longer_needed 0@
    end
end
$taxidr_lvar_42 = 16@ //10@
$taxidr_lvar_42 += 2000

:TAXIDR_287
wait 0 ms
gosub @TAXIDR_4081
gosub @TAXIDR_3884
if
    $taxidr_lvar_41 > 0
then
    jump @TAXIDR_FAIL
end
if
    8@ == 1
then
    02DD: get_random_actor 0@ in_zone 'IND_ZON' 1 0 0  // Portland
else
    if
        8@ == 2
    then
        02DD: get_random_actor 0@ in_zone 'COM_ZON' 1 0 0  // Staunton Island
    else
        if
            8@ == 3
        then
            02DD: get_random_actor 0@ in_zone 'SUB_ZON' 1 0 0  // Shoreside Vale
        else
            0@ = -1
        end
    end
end
if
    not  0@ == -1
then
    if
        056D:   actor 0@ defined
    then
        if
            8118:   not actor 0@ dead
        then
            if
                02F2:   actor 0@ model == #TAXI_D
            then
                jump @TAXIDR_287
            end
        end
    end
else
    if
        8185:   not car 1@ health >= 500
    then
        00BC: text_highpriority 'TAXI7' 5000 ms 1  // ~w~Your car is trashed, get it repaired!
        jump @TAXIDR_2237
    end
    if
        16@ > $taxidr_lvar_42 //10@
    then
        00BB: text_lowpriority 'TAXI1A' 1000 ms 1  // ~w~There aren't any fares around here - keep looking!
        $taxidr_lvar_42 = 16@ //10@
        $taxidr_lvar_42 += 1000
    end
    jump @TAXIDR_287
end

:TAXIDR_565
if
    0118:   actor 0@ dead
then
    jump @TAXIDR_287
end
009F: set_actor 0@ idle
01ED: reset_actor 0@ flags
0291: set_actor 0@ heed_threats 0
//05C7:  0@ 0
0164: disable_marker 2@
0187: 2@ = create_marker_above_actor 0@
0165: set_marker 2@ color_to 2
0365: set_actor 0@ objective_hail_taxi
10@ = 0
03D5: remove_text 'TAXI1A'  // ~w~There aren't any fares around here - keep looking!
00BC: text_highpriority 'TAXI1' 5000 ms 1  // ~w~Look for a ~b~fare.

:TAXIDR_640
wait 0 ms
gosub @TAXIDR_4081
gosub @TAXIDR_3884
if
    $taxidr_lvar_41 > 0
then
    jump @TAXIDR_FAIL
end
if
    $taxidr_var_3910 == -1
then
    if
        $DISPLAYED_TAXI_HELP_MESSAGE == 0
    then
        $DISPLAYED_TAXI_HELP_MESSAGE = 1
        03E5: text_box 'TAXIH1'  // ~w~Stop near a ~h~highlighted pedestrian~w~ to pick them up, then drive them to their destination quickly.
    end
end
if
    056D:   actor 0@ defined
then
    if
        0118:   actor 0@ dead
    then
        gosub @TAXIDR_PASSENGER_EXIT
        jump @TAXIDR_287
    end
else
    gosub @TAXIDR_PASSENGER_EXIT
    jump @TAXIDR_287
end
if
    8118:   not actor 0@ dead
then
    if
        80FD:   not player $PLAYER 0 0@ in_car radius 70.0 70.0 20.0
    then
        gosub @TAXIDR_PASSENGER_EXIT
        jump @TAXIDR_287
    end
end
00A0: store_actor 0@ position_to 11@ 12@ 13@
if
    8185:   not car 1@ health >= 500
then
    00BC: text_highpriority 'TAXI7' 5000 ms 1  // ~w~Your car is trashed, get it repaired!
    gosub @TAXIDR_PASSENGER_EXIT
    jump @TAXIDR_2237
end
if
    10@ == 0
then
    if
        00FA:   player $PLAYER stopped 0 11@ 12@ 13@ radius 7.0 7.0 2.0
    then
        0319: set_actor 0@ running 1
        01D4: actor 0@ go_to_car 1@ and_enter_it_as_a_passenger
        10@ = 1
    else
        020F: actor 0@ look_at_player $PLAYER
    end
else
    if
        80F7:   not player $PLAYER sphere 0 near_point_in_car 11@ 12@ 13@ radius 7.0 7.0 2.0
    then
        jump @TAXIDR_565
    end
end
if
    00DB:   actor 0@ in_car 1@
then
else
    jump @TAXIDR_640
end
03D5: remove_text 'TAXI1'  // ~w~Look for a ~b~fare.
0164: disable_marker 2@
0216: set_car 1@ taxi_available_light_to 0
gosub @TAXIDR_4557
$TAXI_BLIPX = $TAXI_DESTX1
$TAXI_BLIPX += $TAXI_DESTX2
$TAXI_BLIPX /= 2.0
$TAXI_BLIPY = $TAXI_DESTY1
$TAXI_BLIPY += $TAXI_DESTY2
$TAXI_BLIPY /= 2.0

// added z
$TAXI_BLIPZ = $TAXI_DESTZ1
$TAXI_BLIPZ += $TAXI_DESTZ2
$TAXI_BLIPZ /= 2.0

0164: disable_marker 3@
018A: 3@ = create_checkpoint_at $TAXI_BLIPX $TAXI_BLIPY $TAXI_BLIPZ //-100.0
018B: set_marker 3@ display 2
$taxidr_lvar_37 = 0
if or
    $taxidr_lvar_16 == 3
    8@ == 3
then
    $taxidr_lvar_37 += 85.0
end
if
    $taxidr_lvar_16 == 8@
then
    if
        8@ == 3
    then
        0509: $taxidr_lvar_47 = distance_between_point 11@ 12@ and_point -1359.8 278.568 //-1024.8 278.568
        $taxidr_lvar_37 += $taxidr_lvar_47
        0509: $taxidr_lvar_47 = distance_between_point -1359.8 278.568 and_point $TAXI_BLIPX $TAXI_BLIPY //-1024.8 278.568
        $taxidr_lvar_37 += $taxidr_lvar_47
    else
        0509: $taxidr_lvar_37 = distance_between_point $TAXI_BLIPX $TAXI_BLIPY and_point 11@ 12@
    end
else
    if
        8@ == 1
    then
        0509: $taxidr_lvar_47 = distance_between_point 11@ 12@ and_point 280.59 -929.986 //615.59 -929.986
        $taxidr_lvar_37 += $taxidr_lvar_47
        if
            $taxidr_lvar_16 == 2
        then
            0509: $taxidr_lvar_47 = distance_between_point 280.59 -929.986 and_point $TAXI_BLIPX $TAXI_BLIPY //615.59 -929.986
            $taxidr_lvar_37 += $taxidr_lvar_47
        else
            0509: $taxidr_lvar_47 = distance_between_point 280.59 -929.986 and_point -619.697 -631.626 //615.59 -929.986 //-284.697 -631.626
            $taxidr_lvar_37 += $taxidr_lvar_47
            $taxidr_lvar_37 += 85.0
            0509: $taxidr_lvar_47 = distance_between_point -619.697 -631.626 and_point -1359.8 278.568 //-284.697 -631.626 //-1024.8 278.568
            $taxidr_lvar_37 += $taxidr_lvar_47
            0509: $taxidr_lvar_47 = distance_between_point -1359.8 278.568 and_point $TAXI_BLIPX $TAXI_BLIPY //-1024.8 278.568
            $taxidr_lvar_37 += $taxidr_lvar_47
        end
    else
        if
            8@ == 2
        then
            if
                $taxidr_lvar_16 == 1
            then
                0509: $taxidr_lvar_47 = distance_between_point 11@ 12@ and_point 280.59 -929.986 //615.59 -929.986
                $taxidr_lvar_37 += $taxidr_lvar_47
                0509: $taxidr_lvar_47 = distance_between_point 280.59 -929.986 and_point $TAXI_BLIPX $TAXI_BLIPY //615.59 -929.986
                $taxidr_lvar_37 += $taxidr_lvar_47
            else
                0509: $taxidr_lvar_47 = distance_between_point 11@ 12@ and_point -619.697 -631.626 //-284.697 -631.626
                $taxidr_lvar_37 += $taxidr_lvar_47
                $taxidr_lvar_37 += 85.0
                0509: $taxidr_lvar_47 = distance_between_point -619.697 -631.626 and_point -1359.8 278.568 //-284.697 -631.626 //-1024.8 278.568
                $taxidr_lvar_37 += $taxidr_lvar_47
                0509: $taxidr_lvar_47 = distance_between_point -1359.8 278.568 and_point $TAXI_BLIPX $TAXI_BLIPY //-1024.8 278.568
                $taxidr_lvar_37 += $taxidr_lvar_47
            end
        else
            if
                8@ == 3
            then
                0509: $taxidr_lvar_47 = distance_between_point 11@ 12@ and_point -1359.8 278.568 //-1024.8 278.568
                $taxidr_lvar_37 += $taxidr_lvar_47
                0509: $taxidr_lvar_47 = distance_between_point -1359.8 278.568 and_point -619.697 -631.626 //-1024.8 278.568 //-284.697 -631.626
                $taxidr_lvar_37 += $taxidr_lvar_47
                $taxidr_lvar_37 += 85.0
                if
                    $taxidr_lvar_16 == 2
                then
                    0509: $taxidr_lvar_47 = distance_between_point -619.697 -631.626 and_point $TAXI_BLIPX $TAXI_BLIPY //-284.697 -631.626
                    $taxidr_lvar_37 += $taxidr_lvar_47
                else
                    0509: $taxidr_lvar_47 = distance_between_point -619.697 -631.626 and_point 280.59 -929.986 //-284.697 -631.626 //615.59 -929.986
                    $taxidr_lvar_37 += $taxidr_lvar_47
                    0509: $taxidr_lvar_47 = distance_between_point 280.59 -929.986 and_point $TAXI_BLIPX $TAXI_BLIPY //615.59 -929.986
                    $taxidr_lvar_37 += $taxidr_lvar_47
                end
            end
        end
    end
end
008C: $SCORE_FOR_THIS_FARE = float_to_integer $taxidr_lvar_37
$taxidr_lvar_39 = $SCORE_FOR_THIS_FARE
$taxidr_lvar_39 *= 90
008D: $taxidr_lvar_40 = integer_to_float $taxidr_lvar_39
008C: $taxidr_lvar_39 = float_to_integer $taxidr_lvar_40
$TAXI_COUNTDOWN += $taxidr_lvar_39
if
    $TAXI_PASSED_THIS_SHOT == 0
then
    $TAXI_COUNTDOWN += 10000
end
if
    003B:  8@ == $taxidr_lvar_16
then
    if
        $TAXI_COUNTDOWN > 150000
    then
        $TAXI_COUNTDOWN = 150000
    end
else
    if
        $TAXI_COUNTDOWN > 240000
    then
        $TAXI_COUNTDOWN = 240000
    end
end
$taxidr_lvar_45 = $taxidr_lvar_37
$taxidr_lvar_45 *= 0.5
$taxidr_lvar_46 = $taxidr_lvar_45
$taxidr_var_3916 = 100
if
    6@ == 0
then
    //05AE: constant_params 1 variable_params 0 unknown 48 call_with_params @MDLMAC_1048 5
        // set counter color 214 173 82 255
    03C3: set_timer_with_text_to $TAXI_COUNTDOWN type 1 text 'TIME'  // Timer
    6@ = 1
end
if
    7@ == 1
then
    0151: remove_status_text $taxidr_var_3916
end
//05AE: constant_params 1 variable_params 0 unknown 48 call_with_params @MDLMAC_1048 1
    // set counter color 200 200 200 255
04F7: status_text $taxidr_var_3916 1 line 2 'TIP'  // Tip
7@ = 1
if
    8119:   not car 1@ wrecked
then
    0227: $taxidr_lvar_23 = car 1@ health
    $taxidr_lvar_23 -= 50
end
if
    $taxidr_lvar_21 == 0
then
    17@ = 0 //11@
end
$taxidr_lvar_25 = 1
if
    8118:   not actor 0@ dead
then
end

:TAXIDR_1888
wait 0 ms
gosub @TAXIDR_4081
gosub @TAXIDR_3884
if
    $taxidr_lvar_41 > 0
then
    jump @TAXIDR_FAIL
end
if
    $taxidr_var_3910 == -1
then
    if
        $taxidr_lvar_21 == 0
    then
        if
            17@ > 5000 //11@
        then
            $taxidr_lvar_21 = 1
            03E5: text_box 'TIPHLP'  // ~w~The ~h~tip bar~w~ decreases over ~h~time~w~, and when your taxi gets ~h~damaged.
        end
    end
end
if
    8185:   not car 1@ health >= 500
then
    jump @TAXIDR_2171
end
if and
    01F4:   car 1@ flipped
    01C1:   car 1@ stopped
then
    jump @TAXIDR_2171
end
0227: $taxidr_lvar_22 = car 1@ health
if
    $taxidr_lvar_23 > $taxidr_lvar_22
then
    $taxidr_lvar_23 = $taxidr_lvar_22
    $taxidr_lvar_23 -= 50
    $taxidr_lvar_47 = $taxidr_lvar_45
    $taxidr_lvar_47 /= 5.0
    $taxidr_lvar_46 -= $taxidr_lvar_47
end
$taxidr_lvar_46 -= 0.4
if and
    $taxidr_var_3916 > 1
    $taxidr_lvar_46 > 0
then
    $taxidr_lvar_47 = 100.0
    $taxidr_lvar_47 /= $taxidr_lvar_45
    $taxidr_lvar_44 = $taxidr_lvar_47
    $taxidr_lvar_44 *= $taxidr_lvar_46
    008C: $taxidr_var_3916 = float_to_integer $taxidr_lvar_44
else
    if
        not  $taxidr_var_3916 == -1
    then
        0151: remove_status_text $taxidr_var_3916
        $taxidr_var_3916 = -1
    end
end
if
    00B1:   car 1@ 1 $TAXI_DESTX1 $TAXI_DESTY1 $TAXI_DESTZ1 $TAXI_DESTX2 $TAXI_DESTY2 $TAXI_DESTZ2
then
    jump @TAXIDR_2668
end
jump @TAXIDR_1888

:TAXIDR_2171
if
    056D:   actor 0@ defined
then
    if
        8118:   not actor 0@ dead
    then
        0593: set_actor 0@ frightened_in_jacked_car 1
        0193: set_actor 0@ objective_to_act_like_ped
    end
end
if
    7@ == 1
then
    0151: remove_status_text $taxidr_var_3916
end
00BC: text_highpriority 'TAXI7' 5000 ms 1  // ~w~Your car is trashed, get it repaired!
jump @TAXIDR_2237

:TAXIDR_2237
0164: disable_marker 3@
$taxidr_lvar_24 = 0
if or
    $241 > 4
    $1119 == 1
    $240 == 1
then
else
    03E5: text_box 'HELP41'  // ~w~Park in the ~h~Pay 'n' Spray~w~ to respray and repair your car. Follow the ~h~Spray Can blip~w~ on the radar to find the ~h~Pay 'n' Spray.
end
if
    8@ == 1
then
    //05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 3 2
    // begin 05AE
    if
        $1151 == 1
    then
        0164: disable_marker $1154
        02A8: $1154 = create_marker 21 at 590.0 -359.5 -100.0 //27 //925.492 -359.519 9.805
    else
        02A8: $1154 = create_marker 21 at 590.0 -359.5 -100.0 //27 //925.492 -359.519 9.805
        $1151 = 1
    end
    // end 05AE
else
    if
        8@ == 2
    then
        //05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 4 2
        // begin 05AE
        if
            $1152 == 1
        then
            0164: disable_marker $1155
            02A8: $1155 = create_marker 21 at 44.0 -493.75 -100.0 //27 //379.86 -494.03 25.17
        else
            02A8: $1155 = create_marker 21 at 44.0 -493.75 -100.0 //27 //379.86 -494.03 25.17
            $1152 = 1
        end
        // end 05AE
    else
        if
            8@ == 3
        then
            //05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 5 2
            // begin 05AE
            if
                $1153 == 1
            then
                0164: disable_marker $1156
                02A8: $1156 = create_marker 21 at -1463.0 32.5 -100.0 //27 //-1142.37 34.89 57.82
            else
                02A8: $1156 = create_marker 21 at -1463.0 32.5 -100.0 //27 //-1142.37 34.89 57.82
                $1153 = 1
            end
            // end 05AE
        end
    end
end
$taxidr_lvar_27 = 1

:TAXIDR_2387
wait 0 ms
gosub @TAXIDR_4081
gosub @TAXIDR_3884
if
    $taxidr_lvar_41 > 0
then
    jump @TAXIDR_FAIL
end
if
    $taxidr_lvar_25 == 1
then
    if
        $taxidr_lvar_24 == 0
    then
        if
            056D:   actor 0@ defined
        then
            if
                8118:   not actor 0@ dead
            then
                if
                    80DB:   not actor 0@ in_car 1@
                then
                    01C2: mark_actor_as_no_longer_needed 0@
                    00BB: text_lowpriority 'TAXI3' 5000 ms 1  // ~w~Your passenger fled in terror!
                    $taxidr_lvar_24 = 1
                end
            end
        end
    end
end
if
    8185:   not car 1@ health >= 500
then
    17@ = 0 //11@
end
if
    17@ > 3000 //11@
then
else
    jump @TAXIDR_2387
end
$taxidr_lvar_27 = 0
03D5: remove_text 'TAXI3'  // ~w~Your passenger fled in terror!
03D5: remove_text 'TAXI7'  // ~w~Your car is trashed, get it repaired!
03E6: remove_text_box
if
    8@ == 1
then
    //05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 3 1
    // begin 05AE
    if
        $1151 == 1
    then
        0164: disable_marker $1154
        04CE: $1154 = create_icon_marker_without_sphere 21 at 590.0 -359.5 -100.0 //27 //925.492 -359.519 9.805
    else
        04CE: $1154 = create_icon_marker_without_sphere 21 at 590.0 -359.5 -100.0 //27 //925.492 -359.519 9.805
        $1151 = 1
    end
    // end 05AE
else
    if
        8@ == 2
    then
        //05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 4 1
        // begin 05AE
        if
            $1152 == 1
        then
            0164: disable_marker $1155
            04CE: $1155 = create_icon_marker_without_sphere 21 at 44.0 -493.75 -100.0 //27 //379.86 -494.03 25.17
        else
            04CE: $1155 = create_icon_marker_without_sphere 21 at 44.0 -493.75 -100.0 //27 //379.86 -494.03 25.17
            $1152 = 1
        end
        // end 05AE
    else
        if
            8@ == 3
        then
            //05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 5 1
            // begin 05AE
            if
                $1153 == 1
            then
                0164: disable_marker $1156
                04CE: $1156 = create_icon_marker_without_sphere 21 at -1463.0 32.5 -100.0 //27 //-1142.37 34.89 57.82
            else
                04CE: $1156 = create_icon_marker_without_sphere 21 at -1463.0 32.5 -100.0 //27 //-1142.37 34.89 57.82
                $1153 = 1
            end
            // end 05AE
        end
    end
end
jump @TAXIDR_243

:TAXIDR_2668
0151: remove_status_text $taxidr_var_3916
0396: pause_timer 1
0164: disable_marker 3@
if
    8118:   not actor 0@ dead
then
    if
        8119:   not car 1@ wrecked
    then
        01D3: actor 0@ leave_car 1@
        0526: set_actor 0@ stay_in_car_when_jacked 0
    end
end
if
    0256:   player $PLAYER defined
then
    01B4: set_player $PLAYER can_move 0
end
jump @TAXIDR_2840

:TAXIDR_2730
wait 0 ms
gosub @TAXIDR_4081
gosub @TAXIDR_3884
if
    $taxidr_lvar_41 > 0
then
    jump @TAXIDR_FAIL
end
if
    8118:   not actor 0@ dead
then
    if
        8119:   not car 1@ wrecked
    then
        if
            80DB:   not actor 0@ in_car 1@
        then
            gosub @TAXIDR_PASSENGER_EXIT
            if
                0256:   player $PLAYER defined
            then
                0316: save_taxi_earnings_from $SCORE_FOR_THIS_FARE
                01B4: set_player $PLAYER can_move 1
            end
            0396: pause_timer 0
            jump @TAXIDR_243
        end
    end
end
jump @TAXIDR_2730

:TAXIDR_2840
0315: increment_taxi_dropoffs
$TAXI_PASSED_THIS_SHOT += 1
$TAXI_MISSION_DELIVERIES += 1
018C: play_sound 1 at 0 0 0
00BE: text_clear_all
$taxidr_lvar_37 /= 30.0
008C: $SCORE_FOR_THIS_FARE = float_to_integer $taxidr_lvar_37
if
    5 > $SCORE_FOR_THIS_FARE
then
    $SCORE_FOR_THIS_FARE = 5
end
if
    $TAXI_PASSED_THIS_SHOT == $IN_A_ROW_NUMBER
then
    if
        not  $taxidr_var_3916 == -1
    then
        $taxidr_lvar_47 = 100.0
        $taxidr_lvar_47 /= $taxidr_lvar_45
        $taxidr_lvar_44 = $taxidr_lvar_47
        $taxidr_lvar_44 *= $taxidr_lvar_46
        $taxidr_lvar_44 *= 3.0
        $taxidr_lvar_44 /= 100.0
        $taxidr_lvar_44 += 1.25
        008D: $taxidr_lvar_37 = integer_to_float $SCORE_FOR_THIS_FARE
        $taxidr_lvar_37 *= $taxidr_lvar_44
        008C: $SCORE_FOR_THIS_FARE = float_to_integer $taxidr_lvar_37
        02FF: text_3numbers 'TAXI5A' $SCORE_FOR_THIS_FARE $TAXI_PASSED_THIS_SHOT $taxidr_lvar_20 time time 5000 5  // ~w~SPEED BONUS: $~1~ + ~1~ IN A ROW bonus! $~1~
    else
        02FF: text_3numbers 'TAXI4A' $SCORE_FOR_THIS_FARE $TAXI_PASSED_THIS_SHOT $taxidr_lvar_20 time time 5000 5  // ~w~Fare complete: $~1~ + ~1~ IN A ROW bonus! $~1~
    end
    $taxidr_lvar_18 += $SCORE_FOR_THIS_FARE
    0109: player $PLAYER money += $SCORE_FOR_THIS_FARE
    0109: player $PLAYER money += $taxidr_lvar_20
    $taxidr_lvar_18 += $taxidr_lvar_20
    $IN_A_ROW_NUMBER += 5
    $taxidr_lvar_20 += 125
else
    if
        not  $taxidr_var_3916 == -1
    then
        $taxidr_lvar_47 = 100.0
        $taxidr_lvar_47 /= $taxidr_lvar_45
        $taxidr_lvar_44 = $taxidr_lvar_47
        $taxidr_lvar_44 *= $taxidr_lvar_46
        $taxidr_lvar_44 *= 3.0
        $taxidr_lvar_44 /= 100.0
        $taxidr_lvar_44 += 1.25
        008D: $taxidr_lvar_37 = integer_to_float $SCORE_FOR_THIS_FARE
        $taxidr_lvar_37 *= $taxidr_lvar_44
        008C: $SCORE_FOR_THIS_FARE = float_to_integer $taxidr_lvar_37
        01E5: text_1number_highpriority 'TAXI5' $SCORE_FOR_THIS_FARE 5000 ms 5  // ~w~SPEED BONUS: $~1~
    else
        01E5: text_1number_highpriority 'TAXI4' $SCORE_FOR_THIS_FARE 5000 ms 5  // ~w~Fare complete: $~1~
    end
    $taxidr_lvar_18 += $SCORE_FOR_THIS_FARE
    0109: player $PLAYER money += $SCORE_FOR_THIS_FARE
end
if
    $NEW_TAXI_CREATED_BEFORE == 0
then
    if
        $TAXI_MISSION_DELIVERIES == 100
    then
        0151: remove_status_text $TAXI_PASSED_THIS_SHOT
        014F: stop_timer $TAXI_COUNTDOWN
        0151: remove_status_text $taxidr_var_3916
        014C: set_parked_car_generator $SWANK_TAXI cars_to_generate_to 101
        0317: increment_mission_attempts
        0595: mission_complete
        030C: progress_made += 1
        0394: play_music 1
        00BA: text_styled 'M_PASSN' 1000 ms 1  // ~Y~MISSION PASSED!
        03E5: text_box 'NEW_TAX'  // ~w~Taxi Driver mission complete! Mean Street Taxis have taken delivery of a new vehicle at their Trenton depot!
        $NEW_TAXI_CREATED_BEFORE = 1
        $taxidr_lvar_43 = 1
    end
end
if
    $taxidr_lvar_43 == 1
then
    17@ = 0 //11@

    while if 5000 > 17@ //11@
        wait 0 ms
        gosub @TAXIDR_4081
        gosub @TAXIDR_3884
        if
            $taxidr_lvar_41 > 0
        then
            jump @TAXIDR_FAIL
        end
    end
    //061A:
    //05AE: constant_params 1 variable_params 0 unknown 48 call_with_params @MDLMAC_1048 5
        // set counter color 214 173 82 255
    03C3: set_timer_with_text_to $TAXI_COUNTDOWN type 1 text 'TIME'  // Timer
    //05AE: constant_params 1 variable_params 0 unknown 48 call_with_params @MDLMAC_1048 1
        // set counter color 200 200 200 255
    03C4: set_status_text_to $TAXI_PASSED_THIS_SHOT 0 'FARES'  // Fares
    $taxidr_lvar_43 = 0
end
$TAXI_COUNTDOWN += 10000
jump @TAXIDR_2730

// BEGIN TAXI DRIVER FAIL

:TAXIDR_FAIL
if
    8119:   not car 1@ wrecked
then
    0216: set_car 1@ taxi_available_light_to 0
end
0151: remove_status_text $TAXI_PASSED_THIS_SHOT
if
    6@ == 0
then
    014F: stop_timer $TAXI_COUNTDOWN
end
if
    7@ == 1
then
    0151: remove_status_text $taxidr_var_3916
end
00BE: text_clear_all
//061A:
if
    $taxidr_lvar_41 == 1
then
    00BA: text_styled 'TAXI2' 5000 ms 8  // ~r~You're out of time!
end
if
    $taxidr_lvar_41 == 2
then
    00BA: text_styled 'TAXI9' 5000 ms 8  // ~r~Your taxi has been destroyed!
end
if
    $taxidr_lvar_41 == 10
then
    00BA: text_styled 'TAXI8' 5000 ms 8  // ~r~Taxi mission cancelled.
    00BA: text_styled 'M_OVER' 1000 ms 1  // MISSION OVER!
else
    00BA: text_styled 'M_FAIL' 1000 ms 1  // MISSION FAILED!
end
if
    $TAXI_PASSED_THIS_SHOT > 0
then
end
0051: return

// END TAXI DRIVER FAIL // BEGIN TAXI DRIVER CLEANUP

:TAXIDR_CLEANUP
if
    0256:   player $PLAYER defined
then
    01B4: set_player $PLAYER can_move 1
end
if
    8119:   not car 1@ wrecked
then
    0216: set_car 1@ taxi_available_light_to 0
end
0151: remove_status_text $TAXI_PASSED_THIS_SHOT
if
    6@ == 1
then
    014F: stop_timer $TAXI_COUNTDOWN
end
if
    7@ == 1
then
    0151: remove_status_text $taxidr_var_3916
end
if
    8@ == 1
then
    //05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 3 1
    // begin 05AE
    if
        $1151 == 1
    then
        0164: disable_marker $1154
        //04CE: $1154 = create_icon_marker_without_sphere 21 at 590.0 -359.5 -100.0 //27 //925.492 -359.519 9.805
    else
        //04CE: $1154 = create_icon_marker_without_sphere 21 at 590.0 -359.5 -100.0 //27 //925.492 -359.519 9.805
        $1151 = 1
    end
    //end 05AE
else
    if
        8@ == 2
    then
        //05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 4 1
        // begin 05AE
        if
            $1152 == 1
        then
            0164: disable_marker $1155
            //04CE: $1155 = create_icon_marker_without_sphere 21 at 44.0 -493.75 -100.0 //27 //379.86 -494.03 25.17
        else
            //04CE: $1155 = create_icon_marker_without_sphere 21 at 44.0 -493.75 -100.0 //27 //379.86 -494.03 25.17
            $1152 = 1
        end
        //end 05AE
    else
        if
            8@ == 3
        then
            //05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 5 1
            // begin 05AE
            if
                $1153 == 1
            then
                0164: disable_marker $1156
                //04CE: $1156 = create_icon_marker_without_sphere 21 at -1463.0 32.5 -100.0 //27 //-1142.37 34.89 57.82
            else
                //04CE: $1156 = create_icon_marker_without_sphere 21 at -1463.0 32.5 -100.0 //27 //-1142.37 34.89 57.82
                $1153 = 1
            end
            //end 05AE
        end
    end
end
0164: disable_marker 2@
0164: disable_marker 3@
if
    056D:   actor 0@ defined
then
    if
        8118:   not actor 0@ dead
    then
        if
            8119:   not car 1@ wrecked
        then
            if
                00DB:   actor 0@ in_car 1@
            then
                0593: set_actor 0@ frightened_in_jacked_car 1
                0193: set_actor 0@ objective_to_act_like_ped
            else
                011C: actor 0@ clear_objective
                009C: set_actor 0@ wander_direction -1
            end
        else
            011C: actor 0@ clear_objective
            009C: set_actor 0@ wander_direction -1
        end
        01C2: mark_actor_as_no_longer_needed 0@
    end
end
//05AE: constant_params 0 variable_params 0 unknown 48 call_with_params @Noname_1_2814
$FLAG_PLAYER_ON_MISSION = 0
$ON_TAXI_MISSION = 0
00D8: mission_cleanup
0051: return

// END TAXI DRIVER CLEANUP // BEGIN TAXI DRIVER PASSENGER EXIT

:TAXIDR_PASSENGER_EXIT
03D5: remove_text 'TAXI1'  // ~w~Look for a ~b~fare.
0164: disable_marker 2@
if
    056D:   actor 0@ defined
then
    if
        8118:   not actor 0@ dead
    then
        009C: set_actor 0@ wander_direction -1
        01C2: mark_actor_as_no_longer_needed 0@
    end
end
0051: return

// END TAXI DRIVER PASSENGER EXIT

:TAXIDR_3884
if and
80DE:   not player $PLAYER driving_vehicle_type #BORGNINE
80DE:   not player $PLAYER driving_vehicle_type #CABBIE
80DE:   not player $PLAYER driving_vehicle_type #TAXI
004D: jump_if_false @TAXIDR_3923
$taxidr_lvar_41 = 10
0051: return

:TAXIDR_3923
//05AB:  0 5@
  00E1:   key_pressed 0 19 //  5@ > 0
004D: jump_if_false @TAXIDR_3984
4@ = 1 //5@
  $taxidr_var_3910 == -1
004D: jump_if_false @TAXIDR_3977
008A: $taxidr_var_3910 = 16@ //10@
$taxidr_var_3910 += 2500
03E5: text_box 'CAN_CON'  // ~w~Press~h~ ~k~~TOGGLE_SUBMISSIONS~ ~w~again to cancel the mission.

:TAXIDR_3977
jump @TAXIDR_4079

:TAXIDR_3984
  not  $taxidr_var_3910 == -1
004D: jump_if_false @TAXIDR_4079
001F:  16@ > $taxidr_var_3910 //10@
004D: jump_if_false @TAXIDR_4029
$taxidr_var_3910 = -1
$taxidr_var_3911 = 0
03E6: remove_text_box
jump @TAXIDR_4079

:TAXIDR_4029
  4@ > 0
004D: jump_if_false @TAXIDR_4075
  $taxidr_var_3911 == 1
004D: jump_if_false @TAXIDR_4069
03E6: remove_text_box
$taxidr_lvar_41 = 10
0051: return
jump @TAXIDR_4075

:TAXIDR_4069
$taxidr_var_3911 = 1

:TAXIDR_4075
4@ = 0

:TAXIDR_4079
0051: return

:TAXIDR_4081
8256:   not player $PLAYER defined
004D: jump_if_false @TAXIDR_4106
$taxidr_lvar_41 = 9
0051: return
jump @TAXIDR_4122

:TAXIDR_4106
00E0:   player $PLAYER in_any_car
004D: jump_if_false @TAXIDR_4122
03C1: 1@ = player $PLAYER car_no_save

:TAXIDR_4122
0119:   car 1@ wrecked
004D: jump_if_false @TAXIDR_4139
$taxidr_lvar_41 = 2
0051: return

:TAXIDR_4139
  6@ == 1
004D: jump_if_false @TAXIDR_4171
001A:   1 > $TAXI_COUNTDOWN
004D: jump_if_false @TAXIDR_4171
$taxidr_lvar_41 = 1
0051: return

:TAXIDR_4171
03C6:   current_island == 1
004D: jump_if_false @TAXIDR_4194
8@ = 1
jump @TAXIDR_4245

:TAXIDR_4194
03C6:   current_island == 2
004D: jump_if_false @TAXIDR_4217
8@ = 2
jump @TAXIDR_4245

:TAXIDR_4217
03C6:   current_island == 3
004D: jump_if_false @TAXIDR_4240
8@ = 3
jump @TAXIDR_4245

:TAXIDR_4240
8@ = 4

:TAXIDR_4245
  not  8@ == 9@
004D: jump_if_false @TAXIDR_4555
  9@ == 1
004D: jump_if_false @TAXIDR_4289
//05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 3 3
    // begin 05AE
    if
        $1151 == 1
    then
        0164: disable_marker $1154
        $1151 = 0
    end
    // end 05AE
jump @TAXIDR_4348

:TAXIDR_4289
  9@ == 2
004D: jump_if_false @TAXIDR_4322
//05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 4 3
    // begin 05AE
    if
        $1152 == 1
    then
        0164: disable_marker $1155
        $1152 = 0
    end
    // end 05AE
jump @TAXIDR_4348

:TAXIDR_4322
  9@ == 3
004D: jump_if_false @TAXIDR_4348
//05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 5 3
    // begin 05AE
    if
        $1153 == 1
    then
        0164: disable_marker $1156
        $1153 = 0
    end
    // end 05AE

:TAXIDR_4348
  $taxidr_lvar_27 == 1
004D: jump_if_false @TAXIDR_4459
  8@ == 1
004D: jump_if_false @TAXIDR_4393
//05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 3 2
    // begin 05AE
    if
        $1151 == 1
    then
        0164: disable_marker $1154
        02A8: $1154 = create_marker 21 at 590.0 -359.5 -100.0 //27 //925.492 -359.519 9.805
    else
        02A8: $1154 = create_marker 21 at 590.0 -359.5 -100.0 //27 //925.492 -359.519 9.805
        $1151 = 1
    end
    // end 05AE
jump @TAXIDR_4452

:TAXIDR_4393
  8@ == 2
004D: jump_if_false @TAXIDR_4426
//05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 4 2
    // begin 05AE
    if
        $1152 == 1
    then
        0164: disable_marker $1155
        02A8: $1155 = create_marker 21 at 44.0 -493.75 -100.0 //27 //379.86 -494.03 25.17
    else
        02A8: $1155 = create_marker 21 at 44.0 -493.75 -100.0 //27 //379.86 -494.03 25.17
        $1152 = 1
    end
    // end 05AE
jump @TAXIDR_4452

:TAXIDR_4426
  8@ == 3
004D: jump_if_false @TAXIDR_4452
//05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 5 2
    // begin 05AE
    if
        $1153 == 1
    then
        0164: disable_marker $1156
        02A8: $1156 = create_marker 21 at -1463.0 32.5 -100.0 //27 //-1142.37 34.89 57.82
    else
        02A8: $1156 = create_marker 21 at -1463.0 32.5 -100.0 //27 //-1142.37 34.89 57.82
        $1153 = 1
    end
    // end 05AE

:TAXIDR_4452
jump @TAXIDR_4551

:TAXIDR_4459
  8@ == 1
004D: jump_if_false @TAXIDR_4492
//05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 3 1
    // begin 05AE
    if
        $1151 == 1
    then
        0164: disable_marker $1154
        04CE: $1154 = create_icon_marker_without_sphere 21 at 590.0 -359.5 -100.0 //27 //925.492 -359.519 9.805
    else
        04CE: $1154 = create_icon_marker_without_sphere 21 at 590.0 -359.5 -100.0 //27 //925.492 -359.519 9.805
        $1151 = 1
    end
    // end 05AE
jump @TAXIDR_4551

:TAXIDR_4492
  8@ == 2
004D: jump_if_false @TAXIDR_4525
//05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 4 1
    // begin 05AE
    if
        $1152 == 1
    then
        0164: disable_marker $1155
        04CE: $1155 = create_icon_marker_without_sphere 21 at 44.0 -493.75 -100.0 //27 //379.86 -494.03 25.17
    else
        04CE: $1155 = create_icon_marker_without_sphere 21 at 44.0 -493.75 -100.0 //27 //379.86 -494.03 25.17
        $1152 = 1
    end
    // end 05AE
jump @TAXIDR_4551

:TAXIDR_4525
  8@ == 3
004D: jump_if_false @TAXIDR_4551
//05AE: constant_params 2 variable_params 0 unknown 48 call_with_params @MDLMAC_31742 5 1
    // begin 05AE
    if
        $1153 == 1
    then
        0164: disable_marker $1156
        04CE: $1156 = create_icon_marker_without_sphere 21 at -1463.0 32.5 -100.0 //27 //-1142.37 34.89 57.82
    else
        04CE: $1156 = create_icon_marker_without_sphere 21 at -1463.0 32.5 -100.0 //27 //-1142.37 34.89 57.82
        $1153 = 1
    end
    // end 05AE

:TAXIDR_4551
9@ = 8@

:TAXIDR_4555
0051: return

:TAXIDR_4557
$taxidr_lvar_16 = 8@
if and
  $taxidr_lvar_26 > 9
  $1119 == 1
004D: jump_if_false @TAXIDR_4660
14@ = 1
  $1120 == 1
004D: jump_if_false @TAXIDR_4613
15@ = 4
jump @TAXIDR_4643

:TAXIDR_4613
  $1119 == 1
004D: jump_if_false @TAXIDR_4638
15@ = 3
jump @TAXIDR_4643

:TAXIDR_4638
15@ = 2

:TAXIDR_4643
  15@ > 2
004D: jump_if_false @TAXIDR_4660
0209: $taxidr_lvar_16 = random_int_in_ranges 14@ 15@

:TAXIDR_4660
  $taxidr_lvar_16 == 1
004D: jump_if_false @TAXIDR_6108
0209: $BEEN_IN_TAXI2_BEFORE = random_int_in_ranges 1 13
  $BEEN_IN_TAXI2_BEFORE == 1
004D: jump_if_false @TAXIDR_4847
0121:   player $PLAYER in_zone 'REDLIGH'  // Red Light District
004D: jump_if_false @TAXIDR_4719
jump @TAXIDR_4557

:TAXIDR_4719
  $1135 == 1
004D: jump_if_false @TAXIDR_4754
00BC: text_highpriority 'FARE1A' 7000 ms 1  // ~w~Destination ~y~'Paulie's Revue Bar'~w~, Red Light District.
jump @TAXIDR_4796

:TAXIDR_4754
  $1135 == 2
004D: jump_if_false @TAXIDR_4781
jump @TAXIDR_4557
jump @TAXIDR_4796

:TAXIDR_4781
00BC: text_highpriority 'FARE1C' 7000 ms 1  // ~w~Destination ~y~'Sex Club Seven'~w~, Red Light District.

:TAXIDR_4796
$TAXI_DESTX1 = 567.0 //902.0
$TAXI_DESTY1 = -421.4
$TAXI_DESTZ1 = 19.5 //13.5
$TAXI_DESTX2 = 575.7 //910.7
$TAXI_DESTY2 = -404.5
$TAXI_DESTZ2 = 22.4 //16.4
jump @TAXIDR_6040

:TAXIDR_4847
  $BEEN_IN_TAXI2_BEFORE == 2
004D: jump_if_false @TAXIDR_4954
0121:   player $PLAYER in_zone 'HARWOOD'  // Harwood
004D: jump_if_false @TAXIDR_4886
jump @TAXIDR_4557

:TAXIDR_4886
00BC: text_highpriority 'FARE2' 7000 ms 1  // ~w~Destination ~y~'Head Radio'~w~, Harwood.
$TAXI_DESTX1 = 638.4 //973.4
$TAXI_DESTY1 = -51.1
$TAXI_DESTZ1 = 11.8 //5.8
$TAXI_DESTX2 = 647.7 //982.7
$TAXI_DESTY2 = -41.5
$TAXI_DESTZ2 = 14.8 //8.8
jump @TAXIDR_6040

:TAXIDR_4954
  $BEEN_IN_TAXI2_BEFORE == 3
004D: jump_if_false @TAXIDR_5076
0121:   player $PLAYER in_zone 'HARWOOD'  // Harwood
004D: jump_if_false @TAXIDR_4993
jump @TAXIDR_4557

:TAXIDR_4993
  $1119 == 0
004D: jump_if_false @TAXIDR_5012
jump @TAXIDR_4557

:TAXIDR_5012
00BC: text_highpriority 'FARE3' 7000 ms 1  // ~w~Destination ~y~'The Ferry Port'~w~, Harwood.
$TAXI_DESTX1 = 508.4 //843.4
$TAXI_DESTY1 = 169.7
$TAXI_DESTZ1 = 8.0 //2.0
$TAXI_DESTX2 = 524.0 //859.0
$TAXI_DESTY2 = 184.6
$TAXI_DESTZ2 = 11.0 //5.0
jump @TAXIDR_6040

:TAXIDR_5076
  $BEEN_IN_TAXI2_BEFORE == 4
004D: jump_if_false @TAXIDR_5181
0121:   player $PLAYER in_zone 'S_VIEW'  // Portland View
004D: jump_if_false @TAXIDR_5115
jump @TAXIDR_4557

:TAXIDR_5115
00BC: text_highpriority 'FARE4' 7000 ms 1  // ~w~Destination ~y~'The Hospital'~w~, Portland View.
$TAXI_DESTX1 = 801.3 //1136.3
$TAXI_DESTY1 = -610.8
$TAXI_DESTZ1 = 19.5 //13.5
$TAXI_DESTX2 = 810.1 //1145.1
$TAXI_DESTY2 = -585.2
$TAXI_DESTZ2 = 22.5 //16.5
jump @TAXIDR_6040

:TAXIDR_5181
  $BEEN_IN_TAXI2_BEFORE == 5
004D: jump_if_false @TAXIDR_5290
0121:   player $PLAYER in_zone 'REDLIGH'  // Red Light District
004D: jump_if_false @TAXIDR_5220
jump @TAXIDR_4557

:TAXIDR_5220
00BC: text_highpriority 'FARE5' 7000 ms 1  // ~w~Destination ~y~'Ammu-Nation'~w~, Red Light District.
$TAXI_DESTX1 = 730.4 //1065.4
$TAXI_DESTY1 = -394.1
$TAXI_DESTZ1 = 20.3 //14.3
$TAXI_DESTX2 = 722.9 //1057.9
$TAXI_DESTY2 = -408.9
$TAXI_DESTZ2 = 22.3 //16.3
jump @TAXIDR_6040

:TAXIDR_5290
  $BEEN_IN_TAXI2_BEFORE == 6
004D: jump_if_false @TAXIDR_5392
0121:   player $PLAYER in_zone 'LITTLEI'  // Saint Mark's
004D: jump_if_false @TAXIDR_5329
jump @TAXIDR_4557

:TAXIDR_5329
00BC: text_highpriority 'FARE6' 7000 ms 1  // ~w~Destination ~y~'Capital Autos'~w~, Saint Mark's.
$TAXI_DESTX1 = 869.2 //1204.2
$TAXI_DESTY1 = -105.5
$TAXI_DESTZ1 = 18.0 //12.0
$TAXI_DESTX2 = 880.0 //1215.0
$TAXI_DESTY2 = -92.1
$TAXI_DESTZ2 = 22.0 //16.0
jump @TAXIDR_6040

:TAXIDR_5392
  $BEEN_IN_TAXI2_BEFORE == 7
004D: jump_if_false @TAXIDR_5497
0121:   player $PLAYER in_zone 'TOWERS'  // Hepburn Heights
004D: jump_if_false @TAXIDR_5431
jump @TAXIDR_4557

:TAXIDR_5431
00BC: text_highpriority 'FARE7' 7000 ms 1  // ~w~Destination ~y~'The Construction Site'~w~, Hepburn Heights.
$TAXI_DESTX1 = 600.7 //935.7
$TAXI_DESTY1 = -230.1
$TAXI_DESTZ1 = 9.0 //3.0
$TAXI_DESTX2 = 609.1 //944.1
$TAXI_DESTY2 = -215.8
$TAXI_DESTZ2 = 11.0 //5.0
jump @TAXIDR_6040

:TAXIDR_5497
  $BEEN_IN_TAXI2_BEFORE == 8
004D: jump_if_false @TAXIDR_5601
0121:   player $PLAYER in_zone 'LITTLEI'  // Saint Mark's
004D: jump_if_false @TAXIDR_5536
jump @TAXIDR_4557

:TAXIDR_5536
00BC: text_highpriority 'FARE8' 7000 ms 1  // ~w~Destination ~y~'Cipriani Restaurant'~w~, Saint Mark's.
$TAXI_DESTX1 = 863.3 //1198.3
$TAXI_DESTY1 = -326.6
$TAXI_DESTZ1 = 29.0 //23.0
$TAXI_DESTX2 = 870.5 //1205.5
$TAXI_DESTY2 = -315.8
$TAXI_DESTZ2 = 32.0 //26.0
jump @TAXIDR_6040

:TAXIDR_5601
  $BEEN_IN_TAXI2_BEFORE == 9
004D: jump_if_false @TAXIDR_5729
0121:   player $PLAYER in_zone 'PORT_E'  // Portland Harbor
004D: jump_if_false @TAXIDR_5640
jump @TAXIDR_4557

:TAXIDR_5640
  $1119 == 0
004D: jump_if_false @TAXIDR_5659
jump @TAXIDR_4557

:TAXIDR_5659
00BC: text_highpriority 'FARE9' 7000 ms 1  // ~w~Destination ~y~'Portland docks'.
$TAXI_DESTX1 = 1046.7 //1381.7
$TAXI_DESTY1 = -863.1
$TAXI_DESTZ1 = 16.3 //10.3
$TAXI_DESTX2 = 1052.4 //1387.4
$TAXI_DESTY2 = -854.2
$TAXI_DESTZ2 = 19.3 //13.3
jump @TAXIDR_6040

:TAXIDR_5729
  $BEEN_IN_TAXI2_BEFORE == 10
004D: jump_if_false @TAXIDR_5838
0121:   player $PLAYER in_zone 'CHINA'  // Chinatown
004D: jump_if_false @TAXIDR_5768
jump @TAXIDR_4557

:TAXIDR_5768
00BC: text_highpriority 'FARE10' 7000 ms 1  // ~w~Destination ~y~'Punk Noodles'~w~, Chinatown.
$TAXI_DESTX1 = 704.1 //1039.1
$TAXI_DESTY1 = -660.1
$TAXI_DESTZ1 = 20.4 //14.4
$TAXI_DESTX2 = 708.9 //1043.9
$TAXI_DESTY2 = -647.9
$TAXI_DESTZ2 = 22.4 //16.4
jump @TAXIDR_6040

:TAXIDR_5838
  $BEEN_IN_TAXI2_BEFORE == 11
004D: jump_if_false @TAXIDR_5943
0121:   player $PLAYER in_zone 'PORT_I'  // Trenton
004D: jump_if_false @TAXIDR_5877
jump @TAXIDR_4557

:TAXIDR_5877
00BC: text_highpriority 'FARE27' 7000 ms 1  // ~w~Destination ~y~'The Coach Depot'~w~, Trenton.
$TAXI_DESTX1 = 978.7 //1313.7
$TAXI_DESTY1 = -1009.7
$TAXI_DESTZ1 = 19.0 //13.0
$TAXI_DESTX2 = 990.8 //1325.8
$TAXI_DESTY2 = -997.3
$TAXI_DESTZ2 = 21.0 //15.0
jump @TAXIDR_6040

:TAXIDR_5943
  $BEEN_IN_TAXI2_BEFORE == 12
004D: jump_if_false @TAXIDR_6040
0121:   player $PLAYER in_zone 'CHINA'  // Chinatown
004D: jump_if_false @TAXIDR_5982
jump @TAXIDR_4557

:TAXIDR_5982
00BC: text_highpriority 'FARE28' 7000 ms 1  // ~w~Destination ~y~'Mr. Benz'~w~, Chinatown.
$TAXI_DESTX1 = 718.5 //1053.5
$TAXI_DESTY1 = -777.9
$TAXI_DESTZ1 = 19.0 //13.0
$TAXI_DESTX2 = 727.2 //1062.2
$TAXI_DESTY2 = -768.9
$TAXI_DESTZ2 = 21.0 //15.0

:TAXIDR_6040
  8@ == 1
004D: jump_if_false @TAXIDR_6065
$taxidr_lvar_17 = 1.0
jump @TAXIDR_6108

:TAXIDR_6065
  8@ == 2
004D: jump_if_false @TAXIDR_6090
$taxidr_lvar_17 = 1.5
jump @TAXIDR_6108

:TAXIDR_6090
  8@ == 3
004D: jump_if_false @TAXIDR_6108
$taxidr_lvar_17 = 2.25

:TAXIDR_6108
  $taxidr_lvar_16 == 2
004D: jump_if_false @TAXIDR_7281
0209: $BEEN_IN_TAXI2_BEFORE = random_int_in_ranges 11 21
  $BEEN_IN_TAXI2_BEFORE == 11
004D: jump_if_false @TAXIDR_6248
if or
0121:   player $PLAYER in_zone 'SHOPING'  // Bedford Point
0121:   player $PLAYER in_zone 'YAKUSA'  // Torrington
004D: jump_if_false @TAXIDR_6183
jump @TAXIDR_4557

:TAXIDR_6183
00BC: text_highpriority 'FARE11' 7000 ms 1  // ~w~Destination ~y~'Phil Cassidy's Fully Cocked Gun Shop'~w~, Bedford Point.
$TAXI_DESTX1 = -157.6 //177.4
$TAXI_DESTY1 = -1264.3
$TAXI_DESTZ1 = 30.0 //24.0
$TAXI_DESTX2 = -148.6 //186.4
$TAXI_DESTY2 = -1253.0
$TAXI_DESTZ2 = 34.0 //28.0
jump @TAXIDR_7213

:TAXIDR_6248
  $BEEN_IN_TAXI2_BEFORE == 12
004D: jump_if_false @TAXIDR_6373
if or
0121:   player $PLAYER in_zone 'HOSPI_2'  // Rockford
0121:   player $PLAYER in_zone 'STADIUM'  // Aspatria
004D: jump_if_false @TAXIDR_6303
jump @TAXIDR_4557

:TAXIDR_6303
00BC: text_highpriority 'FARE12' 7000 ms 1  // ~w~Destination ~y~'The Ferry Port'~w~, Rockford.
$TAXI_DESTX1 = -149.8 //185.2
$TAXI_DESTY1 = 227.3
$TAXI_DESTZ1 = 16.2 //10.2
$TAXI_DESTX2 = -162.8 //172.2
$TAXI_DESTY2 = 212.2
$TAXI_DESTZ2 = 18.2 //12.2
jump @TAXIDR_7213

:TAXIDR_6373
  $BEEN_IN_TAXI2_BEFORE == 13
004D: jump_if_false @TAXIDR_6476
0121:   player $PLAYER in_zone 'SHOPING'  // Bedford Point
004D: jump_if_false @TAXIDR_6412
jump @TAXIDR_4557

:TAXIDR_6412
00BC: text_highpriority 'FARE13' 7000 ms 1  // ~w~Destination ~y~'The Church'~w~, Bedford Point.
$TAXI_DESTX1 = -371.1 //-36.1
$TAXI_DESTY1 = -1171.2
$TAXI_DESTZ1 = 31.0 //25.0
$TAXI_DESTX2 = -362.5 //-27.5
$TAXI_DESTY2 = -1142.3
$TAXI_DESTZ2 = 33.0 //27.0
jump @TAXIDR_7213

:TAXIDR_6476
  $BEEN_IN_TAXI2_BEFORE == 14
004D: jump_if_false @TAXIDR_6580
0121:   player $PLAYER in_zone 'SHOPING'  // Bedford Point
004D: jump_if_false @TAXIDR_6515
jump @TAXIDR_4557

:TAXIDR_6515
00BC: text_highpriority 'FARE14' 7000 ms 1  // ~w~Destination ~y~'Liberty Tree Offices'~w~, Bedford Point.
$TAXI_DESTX1 = -421.8 //-86.8
$TAXI_DESTY1 = -1365.5
$TAXI_DESTZ1 = 30.5 //24.5
$TAXI_DESTX2 = -436.2 //-101.2
$TAXI_DESTY2 = -1380.1
$TAXI_DESTZ2 = 32.5 //26.5
jump @TAXIDR_7213

:TAXIDR_6580
  $BEEN_IN_TAXI2_BEFORE == 15
004D: jump_if_false @TAXIDR_6687
0121:   player $PLAYER in_zone 'UNIVERS'  // Liberty Campus
004D: jump_if_false @TAXIDR_6619
jump @TAXIDR_4557

:TAXIDR_6619
00BC: text_highpriority 'FARE15' 7000 ms 1  // ~w~Destination ~y~'Liberty University'~w~, Liberty Campus.
$TAXI_DESTX1 = -151.85 //183.15
$TAXI_DESTY1 = -125.5
$TAXI_DESTZ1 = 21.02 //15.02
$TAXI_DESTX2 = -163.79 //171.21
$TAXI_DESTY2 = -136.22
$TAXI_DESTZ2 = 25.29 //19.29
jump @TAXIDR_7213

:TAXIDR_6687
  $BEEN_IN_TAXI2_BEFORE == 16
004D: jump_if_false @TAXIDR_6792
0121:   player $PLAYER in_zone 'PARK'  // Belleville Park
004D: jump_if_false @TAXIDR_6726
jump @TAXIDR_4557

:TAXIDR_6726
00BC: text_highpriority 'FARE16' 7000 ms 1  // ~w~Destination ~y~'Hogs 'n' Cogs'~w~, Belleville Park Area.
$TAXI_DESTX1 = -423.4 //-88.4
$TAXI_DESTY1 = -469.9
$TAXI_DESTZ1 = 20.5 //14.5
$TAXI_DESTX2 = -431.4 //-96.4
$TAXI_DESTY2 = -481.7
$TAXI_DESTZ2 = 22.5 //16.5
jump @TAXIDR_7213

:TAXIDR_6792
  $BEEN_IN_TAXI2_BEFORE == 17
004D: jump_if_false @TAXIDR_6897
0121:   player $PLAYER in_zone 'PARK'  // Belleville Park
004D: jump_if_false @TAXIDR_6831
jump @TAXIDR_4557

:TAXIDR_6831
00BC: text_highpriority 'FARE17' 7000 ms 1  // ~w~Destination ~y~'Courthouse'~w~, Belleville Park Area.
$TAXI_DESTX1 = -248.7297 //86.2703
$TAXI_DESTY1 = -956.2859
$TAXI_DESTZ1 = 31.0 //25.0
$TAXI_DESTX2 = -230.7918 //104.2082
$TAXI_DESTY2 = -946.6459
$TAXI_DESTZ2 = 33.0 //27.0
jump @TAXIDR_7213

:TAXIDR_6897
  $BEEN_IN_TAXI2_BEFORE == 18
004D: jump_if_false @TAXIDR_7006
0121:   player $PLAYER in_zone 'SHOPING'  // Bedford Point
004D: jump_if_false @TAXIDR_6936
jump @TAXIDR_4557

:TAXIDR_6936
00BC: text_highpriority 'FARE18' 7000 ms 1  // ~w~Destination ~y~'Mr. Benz'~w~, Bedford Point.
$TAXI_DESTX1 = -353.7 //-18.7
$TAXI_DESTY1 = -1603.4
$TAXI_DESTZ1 = 30.2 //24.2
$TAXI_DESTX2 = -346.1 //-11.1
$TAXI_DESTY2 = -1591.7
$TAXI_DESTZ2 = 32.2 //26.2
jump @TAXIDR_7213

:TAXIDR_7006
  $BEEN_IN_TAXI2_BEFORE == 19
004D: jump_if_false @TAXIDR_7111
0121:   player $PLAYER in_zone 'SHOPING'  // Bedford Point
004D: jump_if_false @TAXIDR_7045
jump @TAXIDR_4557

:TAXIDR_7045
00BC: text_highpriority 'FARE19' 7000 ms 1  // ~w~Destination ~y~'Joe's Pizza'~w~, Bedford Point.
$TAXI_DESTX1 = -196.1 //138.9
$TAXI_DESTY1 = -1268.2
$TAXI_DESTZ1 = 30.5 //24.5
$TAXI_DESTX2 = -189.6 //145.4
$TAXI_DESTY2 = -1257.4
$TAXI_DESTZ2 = 32.5 //26.5
jump @TAXIDR_7213

:TAXIDR_7111
  $BEEN_IN_TAXI2_BEFORE == 20
004D: jump_if_false @TAXIDR_7213
0121:   player $PLAYER in_zone 'PARK'  // Belleville Park
004D: jump_if_false @TAXIDR_7150
jump @TAXIDR_4557

:TAXIDR_7150
00BC: text_highpriority 'FARE20' 7000 ms 1  // ~w~Destination ~y~'The Park' ~w~in Belleville.
$TAXI_DESTX1 = -307.44 //27.56
$TAXI_DESTY1 = -776.42
$TAXI_DESTZ1 = 32.26 //26.26
$TAXI_DESTX2 = -296.21 //38.79
$TAXI_DESTY2 = -765.06
$TAXI_DESTZ2 = 34.57 //28.57

:TAXIDR_7213
  8@ == 1
004D: jump_if_false @TAXIDR_7238
$taxidr_lvar_17 = 1.5
jump @TAXIDR_7281

:TAXIDR_7238
  8@ == 2
004D: jump_if_false @TAXIDR_7263
$taxidr_lvar_17 = 1.0
jump @TAXIDR_7281

:TAXIDR_7263
  8@ == 3
004D: jump_if_false @TAXIDR_7281
$taxidr_lvar_17 = 1.5

:TAXIDR_7281
  $taxidr_lvar_16 == 3
004D: jump_if_false @TAXIDR_8449
0209: $BEEN_IN_TAXI2_BEFORE = random_int_in_ranges 21 31
  $BEEN_IN_TAXI2_BEFORE == 21
004D: jump_if_false @TAXIDR_7406
0121:   player $PLAYER in_zone 'AIRPORT'  // Francis Intl. Airport
004D: jump_if_false @TAXIDR_7340
jump @TAXIDR_4557

:TAXIDR_7340
00BC: text_highpriority 'FARE21' 7000 ms 1  // ~w~Destination ~y~'Terminal A'~w~, Francis International Airport.
$TAXI_DESTX1 = -1076.7054 //-741.7054
$TAXI_DESTY1 = -538.3871
$TAXI_DESTZ1 = 13.5 //7.5
$TAXI_DESTX2 = -1086.9435 //-751.9435
$TAXI_DESTY2 = -561.2413
$TAXI_DESTZ2 = 15.5 //9.5
jump @TAXIDR_8382

:TAXIDR_7406
  $BEEN_IN_TAXI2_BEFORE == 22
004D: jump_if_false @TAXIDR_7515
0121:   player $PLAYER in_zone 'BIG_DAM'  // Cochrane Dam
004D: jump_if_false @TAXIDR_7445
jump @TAXIDR_4557

:TAXIDR_7445
00BC: text_highpriority 'FARE22' 7000 ms 1  // ~w~Destination ~y~'Cochrane Dam'.
$TAXI_DESTX1 = -1507.776 //-1172.776
$TAXI_DESTY1 = 289.2328
$TAXI_DESTZ1 = 8.2 //2.2
$TAXI_DESTX2 = -1526.48 //-1191.48
$TAXI_DESTY2 = 284.9869
$TAXI_DESTZ2 = 10.2 //4.2
jump @TAXIDR_8382

:TAXIDR_7515
  $BEEN_IN_TAXI2_BEFORE == 23
004D: jump_if_false @TAXIDR_7628
if or
0121:   player $PLAYER in_zone 'SWANKS'  // Cedar Grove
  3 > 8@
004D: jump_if_false @TAXIDR_7563
jump @TAXIDR_4557

:TAXIDR_7563
00BC: text_highpriority 'FARE23' 7000 ms 1  // ~w~Destination ~y~'The Mansion'~w~, Cedar Grove.
$TAXI_DESTX1 = -703.9 //-368.9
$TAXI_DESTY1 = 234.4
$TAXI_DESTZ1 = 64.0 //58.0
$TAXI_DESTX2 = -690.6 //-355.6
$TAXI_DESTY2 = 248.5
$TAXI_DESTZ2 = 69.0 //63.0
jump @TAXIDR_8382

:TAXIDR_7628
  $BEEN_IN_TAXI2_BEFORE == 24
004D: jump_if_false @TAXIDR_7731
0121:   player $PLAYER in_zone 'SUB_IND'  // Pike Creek
004D: jump_if_false @TAXIDR_7667
jump @TAXIDR_4557

:TAXIDR_7667
00BC: text_highpriority 'FARE24' 7000 ms 1  // ~w~Destination ~y~'The Hospital'~w~, Pike Creek.
$TAXI_DESTX1 = -1601.7 //-1266.7
$TAXI_DESTY1 = -125.5
$TAXI_DESTZ1 = 63.0 //57.0
$TAXI_DESTX2 = -1589.1 //-1254.1
$TAXI_DESTY2 = -109.4
$TAXI_DESTZ2 = 66.0 //60.0
jump @TAXIDR_8382

:TAXIDR_7731
  $BEEN_IN_TAXI2_BEFORE == 25
004D: jump_if_false @TAXIDR_7853
if or
0121:   player $PLAYER in_zone 'SUB_ZO2'  // Shoreside Vale
0121:   player $PLAYER in_zone 'SUB_ZO3'  // Shoreside Vale
  3 > 8@
004D: jump_if_false @TAXIDR_7791
jump @TAXIDR_4557

:TAXIDR_7791
00BC: text_highpriority 'FARE25' 7000 ms 1  // ~w~Destination ~y~'The Park'~w~, Shoreside Vale.
$TAXI_DESTX1 = -565.1 //-230.1
$TAXI_DESTY1 = 311.5
$TAXI_DESTZ1 = 6.0 //0
$TAXI_DESTX2 = -555.2 //-220.2
$TAXI_DESTY2 = 322.5
$TAXI_DESTZ2 = 16.0 //10.0
jump @TAXIDR_8382

:TAXIDR_7853
  $BEEN_IN_TAXI2_BEFORE == 26
004D: jump_if_false @TAXIDR_7965
if or
0121:   player $PLAYER in_zone 'PROJECT'  // Wichita Gardens
  3 > 8@
004D: jump_if_false @TAXIDR_7901
jump @TAXIDR_4557

:TAXIDR_7901
00BC: text_highpriority 'FARE26' 7000 ms 1  // ~w~Destination ~y~'North West Towers'~w~, Wichita Gardens.
$TAXI_DESTX1 = -987.5 //-652.5
$TAXI_DESTY1 = -54.7
$TAXI_DESTZ1 = 16.0 //10.0
$TAXI_DESTX2 = -972.5 //-637.5
$TAXI_DESTY2 = -39.7
$TAXI_DESTZ2 = 31.0 //25.0
jump @TAXIDR_8382

:TAXIDR_7965
  $BEEN_IN_TAXI2_BEFORE == 27
004D: jump_if_false @TAXIDR_8074
0121:   player $PLAYER in_zone 'SUB_IND'  // Pike Creek
004D: jump_if_false @TAXIDR_8004
jump @TAXIDR_4557

:TAXIDR_8004
00BC: text_highpriority 'FARE29' 7000 ms 1  // ~w~Destination ~y~'Mr. Benz'~w~, Pike Creek.
$TAXI_DESTX1 = -1467.1 //-1132.1
$TAXI_DESTY1 = 26.8
$TAXI_DESTZ1 = 63.3 //57.3
$TAXI_DESTX2 = -1454.8 //-1119.8
$TAXI_DESTY2 = 39.9
$TAXI_DESTZ2 = 65.3 //59.3
jump @TAXIDR_8382

:TAXIDR_8074
  $BEEN_IN_TAXI2_BEFORE == 28
004D: jump_if_false @TAXIDR_8179
0121:   player $PLAYER in_zone 'AIRPORT'  // Francis Intl. Airport
004D: jump_if_false @TAXIDR_8113
jump @TAXIDR_4557

:TAXIDR_8113
00BC: text_highpriority 'FARE30' 7000 ms 1  // ~w~Destination ~y~'Terminal C'~w~, Francis International Airport.
$TAXI_DESTX1 = -1071.7289 //-736.7289
$TAXI_DESTY1 = -641.1589
$TAXI_DESTZ1 = 13.5 //7.5
$TAXI_DESTX2 = -1080.1031 //-745.1031
$TAXI_DESTY2 = -650.3922
$TAXI_DESTZ2 = 15.5 //9.5
jump @TAXIDR_8382

:TAXIDR_8179
  $BEEN_IN_TAXI2_BEFORE == 29
004D: jump_if_false @TAXIDR_8284
0121:   player $PLAYER in_zone 'SUB_IND'  // Pike Creek
004D: jump_if_false @TAXIDR_8218
jump @TAXIDR_4557

:TAXIDR_8218
00BC: text_highpriority 'FARE31' 7000 ms 1  // ~w~Destination ~y~'AM Petroleum'~w~, Pike Creek.
$TAXI_DESTX1 = -1409.679 //-1074.679
$TAXI_DESTY1 = -114.1043
$TAXI_DESTZ1 = 48.5 //42.5
$TAXI_DESTX2 = -1396.63 //-1061.63
$TAXI_DESTY2 = -106.6058
$TAXI_DESTZ2 = 50.5 //44.5
jump @TAXIDR_8382

:TAXIDR_8284
  $BEEN_IN_TAXI2_BEFORE == 30
004D: jump_if_false @TAXIDR_8382
0121:   player $PLAYER in_zone 'SUB_IND'  // Pike Creek
004D: jump_if_false @TAXIDR_8323
jump @TAXIDR_4557

:TAXIDR_8323
00BC: text_highpriority 'FARE32' 7000 ms 1  // ~w~Destination ~y~'Liberty Pharmaceuticals'~w~, Pike Creek.
$TAXI_DESTX1 = -1452.282 //-1117.282
$TAXI_DESTY1 = -44.1906
$TAXI_DESTZ1 = 53.5 //47.5
$TAXI_DESTX2 = -1440.455 //-1105.455
$TAXI_DESTY2 = -33.4123
$TAXI_DESTZ2 = 55.5 //49.5

:TAXIDR_8382
  8@ == 1
004D: jump_if_false @TAXIDR_8406
$taxidr_lvar_17 = 2.0
jump @TAXIDR_8449

:TAXIDR_8406
  8@ == 2
004D: jump_if_false @TAXIDR_8431
$taxidr_lvar_17 = 1.5
jump @TAXIDR_8449

:TAXIDR_8431
  8@ == 3
004D: jump_if_false @TAXIDR_8449
$taxidr_lvar_17 = 1.0

:TAXIDR_8449
0509: $taxidr_lvar_47 = distance_between_point 11@ 12@ and_point $TAXI_DESTX1 $TAXI_DESTY1
0023:   125.0 > $taxidr_lvar_47
004D: jump_if_false @TAXIDR_8476
jump @TAXIDR_4557

:TAXIDR_8476
  $taxidr_lvar_16 == 8@
004D: jump_if_false @TAXIDR_8499
$taxidr_lvar_26 += 1
jump @TAXIDR_8503

:TAXIDR_8499
$taxidr_lvar_26 = 0

:TAXIDR_8503
0051: return
