//-------------Mission 33-------------
// Originally: Toni mission 4 'TRIADS AND TRIBULATIONS'

:M33_TRIADSANDTRIBULATIONS
03A4: name_thread 'TONI4'
054C: use GXT table 'TONI4'
058E: set_restart_mission_taxi_destination 864.4 -320.6 30.57 0.0
gosub @MISSION_START_TONI4
if
    wasted_or_busted
then
    gosub @MISSION_TONI4_FAILED
end
gosub @MISSION_CLEANUP_TONI4
end_thread

:MISSION_START_TONI4
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_TONI = 1
wait 0 ms
0004: $GRUNTS1_BEEN_CREATED_BEFORE = 0
0004: $GRUNTS2_BEEN_CREATED_BEFORE = 0
0004: $GRUNTS3_BEEN_CREATED_BEFORE = 0
//0004: $GRABBED_PEDS_BEFORE = 0
0004: $BEEN_IN_FISH_FACTORY = 0
0004: $AUDIO_PLAYED_TM4 = 0
0004: $TRIAD1_CAN_LEG_IT = 0
0004: $PAY_BACK_FOR_TRAIDS1 = 0
0004: $PAY_BACK_FOR_TRAIDS2 = 0
0004: $PAY_BACK_FOR_TRAIDS3 = 0
0247: request_model #GANG01
0247: request_model #GANG02
0247: request_model #IND_NEWRIZZOS
0247: request_model #UZI
0247: request_model #SHOTGUN
023C: load_special_actor 1 'PLAYER'
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'NOTE'
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #GANG01 available
        8248:   NOT   model #GANG02 available
        8248:   NOT   model #IND_NEWRIZZOS available
        8248:   NOT   model #UZI available
        8248:   NOT   model #SHOTGUN
    jf break
    wait 0 ms
end
while true
    if
        823D:   NOT   special_actor 1 loaded
    jf break
    wait 0 ms
end
009A: $TONI4_MAFIA1 = create_actor 7 #GANG02 at 881.38 -309.875 35.0
009A: $TONI4_MAFIA2 = create_actor 7 #GANG01 at 880.88 -311.188 35.0
if and
    8118:   NOT   actor $TONI4_MAFIA1 dead
    8118:   NOT   actor $TONI4_MAFIA2 dead
then
    01B2: give_actor $TONI4_MAFIA1 weapon 23 ammo 300  // Load the weapon model before using this
    011A: set_actor $TONI4_MAFIA1 flags 64
    011A: set_actor $TONI4_MAFIA1 flags 256
    0319: set_actor $TONI4_MAFIA1 running 1
    020E: actor $TONI4_MAFIA1 look_at_actor $TONI4_MAFIA2
    03F9: make_actors $TONI4_MAFIA1 $TONI4_MAFIA2 converse_in 24000 ms
    01B2: give_actor $TONI4_MAFIA2 weapon 23 ammo 300  // Load the weapon model before using this
    011A: set_actor $TONI4_MAFIA2 flags 64
    011A: set_actor $TONI4_MAFIA2 flags 256
    0319: set_actor $TONI4_MAFIA2 running 1
    020E: actor $TONI4_MAFIA2 look_at_actor $TONI4_MAFIA1
end
02E4: load_cutscene_data 'T4_TAT'
0244: set_cutscene_pos 883.38 -314.5 34.875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
//02F4: create_cutscene_actor $PLAYER_CSHEAD from_head #CUTOBJ01 and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
02E5: $CS_NOTE = create_cutscene_object #CUTOBJ02
02E6: set_cutscene_anim $CS_NOTE 'NOTE'
0395: clear_area 1 at 884.5601 -323.0 31.5625 range 1.0
0055: set_player_coordinates $PLAYER at 884.5601 -323.0 31.5625
0171: set_player $PLAYER z_angle_to 180.0
0395: clear_area 1 at 881.0601 -313.0 35.875 range 10.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   82 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM4_A' 10000 ms 1   // // ~w~Oh it's you. TONI ain't here.
while 001A:   2415 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM4_A2' 10000 ms 1   // // ~w~But he left one of his sugary love letters for you.
while 001A:   4420 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM4_B' 10000 ms 1   // // ~w~We're at WAR! The Triads have a fish factory as a front.
while 001A:   7629 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM4_C' 10000 ms 1   // // ~w~Most of their business goes down at the fish market in Chinatown.
while 001A:   11110 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM4_D' 10000 ms 1   // // ~w~That laundry still owes us protection.
while 001A:   13283 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM4_E' 10000 ms 1   // // ~w~They reckon the Triads are protecting them now so I say we exact a fitting punishment.
while 001A:   18058 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM4_F' 10000 ms 1   // // ~w~Take these boys over and whack the Triad Warlords!
while 001A:   21248 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'TM4_G' 10000 ms 1   // // ~w~Hell if you get a chance pop some of their soldiers too.
while 001A:   24000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
03AD: set_rubbish 1 (visible)
02EA: clear_cutscene
03C8: set_camera_in_front_of_player
if and
    8118:   NOT   actor $TONI4_MAFIA1 dead
    8118:   NOT   actor $TONI4_MAFIA2 dead
then
    03F9: make_actors $TONI4_MAFIA1 $TONI4_MAFIA2 converse_in 0 ms
end
01B1: give_player $PLAYER weapon 21 ammo 20  // Load the weapon model before using this
01B8: set_player $PLAYER armed_weapon_to 21
if and
    8118:   NOT   actor $TONI4_MAFIA1 dead
    8118:   NOT   actor $TONI4_MAFIA2 dead
then
    00A1: put_actor $TONI4_MAFIA1 at 885.1899 -321.75 32.375
    00A1: put_actor $TONI4_MAFIA2 at 884.0 -321.25 32.375
end
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #IND_NEWRIZZOS
0247: request_model #GANG03
0247: request_model #GANG04
while true
    if or
        8248:   NOT   model #GANG03 available
        8248:   NOT   model #GANG04 available
    jf break
    wait 0 ms
end
03F1: pedtype 8 add_threat 1
0004: $WARLORDS_DEAD = 0
0004: $TRIADS_SPOT_YOU = 0
0004: $CLEAR_TRIADS_THREATS = 0
if
    8118:   NOT   actor $TONI4_MAFIA1 dead
then
    01DF: tie_actor $TONI4_MAFIA1 to_player $PLAYER
end
if
    8118:   NOT   actor $TONI4_MAFIA2 dead
then
    01DF: tie_actor $TONI4_MAFIA2 to_player $PLAYER
end
015C: set_zone_gang_info 'LITTLEI' 1 (day)  15 500 250 0 0 0 0 0 0 0 0
015C: set_zone_gang_info 'LITTLEI' 0 (night)  8 500 250 0 0 0 0 0 0 0 0
015C: set_zone_gang_info 'CHINA' 1 (day)  30 350 600 0 0 0 0 0 0 0 0
015C: set_zone_gang_info 'CHINA' 0 (night)  30 350 600 0 0 0 0 0 0 0 0
009A: $TRIAD_HEAD1 = create_actor 8 #GANG04 at 571.375 -541.375 20.375      //Fish warhouse
01B2: give_actor $TRIAD_HEAD1 weapon 23 ammo 80  // Load the weapon model before using this
0173: set_actor $TRIAD_HEAD1 z_angle_to 109.0
0187: $BLIP1_TM4 = create_marker_above_actor $TRIAD_HEAD1
035F: set_actor $TRIAD_HEAD1 armour_to 100
011A: set_actor $TRIAD_HEAD1 flags 1
02A9: set_actor $TRIAD_HEAD1 immune_to_nonplayer 1
0350: set_char_stay_in_same_place $TRIAD_HEAD1  1
009A: $TRIAD_HEAD2 = create_actor 8 #GANG04 at 633.562 -682.188 20.25        //Market place
01B2: give_actor $TRIAD_HEAD2 weapon 23 ammo 80  // Load the weapon model before using this
0187: $BLIP2_TM4 = create_marker_above_actor $TRIAD_HEAD2
035F: set_actor $TRIAD_HEAD2 armour_to 100
011A: set_actor $TRIAD_HEAD2 flags 1
02A9: set_actor $TRIAD_HEAD2 immune_to_nonplayer 1
0350: set_char_stay_in_same_place $TRIAD_HEAD2  1
009A: $TRIAD_HEAD3 = create_actor 8 #GANG04 at 633.25 -1136.75 21.0          //Fish factory
01B2: give_actor $TRIAD_HEAD3 weapon 23 ammo 80  // Load the weapon model before using this
0173: set_actor $TRIAD_HEAD3 z_angle_to 38.0
0187: $BLIP3_TM4 = create_marker_above_actor $TRIAD_HEAD3
035F: set_actor $TRIAD_HEAD3 armour_to 100
011A: set_actor $TRIAD_HEAD3 flags 1
02A9: set_actor $TRIAD_HEAD3 immune_to_nonplayer 1
0350: set_char_stay_in_same_place $TRIAD_HEAD3  1
0004: $CHAR_ALREADY_DEAD1 = 0
0004: $CHAR_ALREADY_DEAD2 = 0
0004: $CHAR_ALREADY_DEAD3 = 0
03CF: load_wav 'T4_A' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
while 8038:   NOT   $WARLORDS_DEAD == 3
    wait 0 ms
    if and
        0118:   actor $TRIAD_HEAD1 dead
        0038:   $CHAR_ALREADY_DEAD1 == 0
    then
        0164: remove_blip $BLIP1_TM4
        0008: $WARLORDS_DEAD += 1
        0004: $CHAR_ALREADY_DEAD1 = 1
    end
    if and
        0118:   actor $TRIAD_HEAD2 dead
        0038:   $CHAR_ALREADY_DEAD2 == 0
    then
        0164: remove_blip $BLIP2_TM4
        0008: $WARLORDS_DEAD += 1
        0004: $CHAR_ALREADY_DEAD2 = 1
    end
    if and
        0118:   actor $TRIAD_HEAD3 dead
        0038:   $CHAR_ALREADY_DEAD3 == 0
    then
        0164: remove_blip $BLIP3_TM4
        0008: $WARLORDS_DEAD += 1
        0004: $CHAR_ALREADY_DEAD3 = 1
    end
    if and
        0121:   player $PLAYER in_zone 'PORT_W'
        0038:   $HAS_PLAYER_BEEN_AT_FISH_BEFORE == 1
        0038:   $CLEAR_TRIADS_THREATS == 0
    then
        if
            8118:   NOT   actor $FISH_TRIAD1 dead
        then
            01ED: reset_actor $FISH_TRIAD1 flags
        end
        if
            8118:   NOT   actor $FISH_TRIAD2 dead
        then
            01ED: reset_actor $FISH_TRIAD2 flags
        end
        if
            8118:   NOT   actor $FISH_TRIAD3 dead
        then
            01ED: reset_actor $FISH_TRIAD3 flags
        end
        if
            8118:   NOT   actor $FISH_TRIAD4 dead
        then
            01ED: reset_actor $FISH_TRIAD4 flags
        end
        if
            8118:   NOT   actor $FISH_TRIAD5 dead
        then
            01ED: reset_actor $FISH_TRIAD5 flags
        end
        if
            8118:   NOT   actor $FISH_TRIAD6 dead
        then
            01ED: reset_actor $FISH_TRIAD6 flags
        end
        03F2: pedgroup 8 remove_threat 1
        0004: $CLEAR_TRIADS_THREATS = 1
    end
    if
        0057:   player $PLAYER  0 ()in cube 609.208 -1149.81 -3.72576 681.14 -1076.01 46.2742
        //0121:   player $PLAYER in_zone 'FISHFAC'  // CAUSED a CRASH, above line replaces it
    then
        if
            0038:   $TRIADS_SPOT_YOU == 0
        then
            if
                80E0:   NOT   player $PLAYER driving
            then
                if
                    8118:   NOT   actor $FISH_TRIAD1 dead
                then
                    011A: set_actor $FISH_TRIAD1 flags 1
                end
                if
                    8118:   NOT   actor $FISH_TRIAD2 dead
                then
                    011A: set_actor $FISH_TRIAD2 flags 1
                end
                if
                    8118:   NOT   actor $FISH_TRIAD3 dead
                then
                    011A: set_actor $FISH_TRIAD3 flags 1
                end
                if
                    8118:   NOT   actor $FISH_TRIAD4 dead
                then
                    011A: set_actor $FISH_TRIAD4 flags 1
                end
                if
                    8118:   NOT   actor $FISH_TRIAD5 dead
                then
                    011A: set_actor $FISH_TRIAD5 flags 1
                end
                if
                    8118:   NOT   actor $FISH_TRIAD6 dead
                then
                    011A: set_actor $FISH_TRIAD6 flags 1
                end
                0004: $TRIADS_SPOT_YOU = 1
            end
            if or
                0118:   actor $FISH_TRIAD1 dead
                0118:   actor $FISH_TRIAD2 dead
                0118:   actor $FISH_TRIAD3 dead
                0118:   actor $FISH_TRIAD4 dead
                0118:   actor $FISH_TRIAD5 dead
                0118:   actor $FISH_TRIAD6 dead
            then
                if
                    8118:   NOT   actor $FISH_TRIAD1 dead
                then
                    011A: set_actor $FISH_TRIAD1 flags 1
                end
                if
                    8118:   NOT   actor $FISH_TRIAD2 dead
                then
                    011A: set_actor $FISH_TRIAD2 flags 1
                end
                if
                    8118:   NOT   actor $FISH_TRIAD3 dead
                then
                    011A: set_actor $FISH_TRIAD3 flags 1
                end
                if
                    8118:   NOT   actor $FISH_TRIAD4 dead
                then
                    011A: set_actor $FISH_TRIAD4 flags 1
                end
                if
                    8118:   NOT   actor $FISH_TRIAD5 dead
                then
                    011A: set_actor $FISH_TRIAD5 flags 1
                end
                if
                    8118:   NOT   actor $FISH_TRIAD6 dead
                then
                    011A: set_actor $FISH_TRIAD6 flags 1
                end
                0004: $TRIADS_SPOT_YOU = 1
            end
        end
    end
    if and
        0121:   player $PLAYER in_zone 'CHINA'
        0038:   $AUDIO_PLAYED_TM4 == 0
    then
        03D1: play_wav 1
        0004: $AUDIO_PLAYED_TM4 = 1
    end
    if
        0038:   $GRUNTS1_BEEN_CREATED_BEFORE == 0
    then
        if
            8118:   NOT   actor $TRIAD_HEAD1 dead
        then
            if
                00E9:   player $PLAYER 0 near_actor $TRIAD_HEAD1 radius 80.0 80.0
            then
                009A: $TONI4_TRIAD4 = create_actor 8 #GANG04 at 572.375 -542.375 20.375
                0173: set_actor $TONI4_TRIAD4 z_angle_to 180.0
                01B2: give_actor $TONI4_TRIAD4 weapon 23 ammo 80  // Load the weapon model before using this
                01DE: tie_actor $TONI4_TRIAD4 to_actor $TRIAD_HEAD1
                011A: set_actor $TONI4_TRIAD4 flags 1
                009A: $TONI4_TRIAD5 = create_actor 8 #GANG04 at 572.375 -542.375 20.375
                0173: set_actor $TONI4_TRIAD5 z_angle_to 160.0
                01B2: give_actor $TONI4_TRIAD5 weapon 23 ammo 80  // Load the weapon model before using this
                01DE: tie_actor $TONI4_TRIAD5 to_actor $TRIAD_HEAD1
                011A: set_actor $TONI4_TRIAD5 flags 1
                02A9: set_actor $TRIAD_HEAD1 immune_to_nonplayer 0
                0004: $GRUNTS1_BEEN_CREATED_BEFORE = 1
            end
        end
    end
    if
        8118:   NOT   actor $TRIAD_HEAD1 dead
    then
        if and
            00E9:   player $PLAYER 0 near_actor $TRIAD_HEAD1 radius 30.0 30.0
            0038:   $TRIAD1_CAN_LEG_IT == 0
        then
            0350: set_char_stay_in_same_place $TRIAD_HEAD1  0
            0004: $TRIAD1_CAN_LEG_IT = 1
        end
    end
    if
        0038:   $GRUNTS2_BEEN_CREATED_BEFORE == 0
    then
        if
            8118:   NOT   actor $TRIAD_HEAD2 dead
        then
            if
                00E9:   player $PLAYER 0 near_actor $TRIAD_HEAD2 radius 80.0 80.0
            then
                009A: $TONI4_TRIAD6 = create_actor 8 #GANG04 at 630.562 -680.188 20.25
                01B2: give_actor $TONI4_TRIAD6 weapon 23 ammo 80  // Load the weapon model before using this
                01DE: tie_actor $TONI4_TRIAD6 to_actor $TRIAD_HEAD2
                011A: set_actor $TONI4_TRIAD6 flags 1
                009A: $TONI4_TRIAD7 = create_actor 8 #GANG04 at 630.5 -683.0 20.25
                01B2: give_actor $TONI4_TRIAD7 weapon 23 ammo 80  // Load the weapon model before using this
                01DE: tie_actor $TONI4_TRIAD7 to_actor $TRIAD_HEAD2
                011A: set_actor $TONI4_TRIAD7 flags 1
                02A9: set_actor $TRIAD_HEAD2 immune_to_nonplayer 0
                0004: $GRUNTS2_BEEN_CREATED_BEFORE = 1
            end
        end
    end
    if
        8118:   NOT   actor $TRIAD_HEAD2 dead
    then
        if and
            00E9:   player $PLAYER 0 near_actor $TRIAD_HEAD2 radius 30.0 30.0
            0038:   $TRIAD2_CAN_LEG_IT == 0
        then
            0350: set_char_stay_in_same_place $TRIAD_HEAD2  0
            0004: $TRIAD2_CAN_LEG_IT = 1
        end
    end
    if
        0038:   $GRUNTS3_BEEN_CREATED_BEFORE == 0
    then
        if
            8118:   NOT   actor $TRIAD_HEAD3 dead
        then
            if
                00E9:   player $PLAYER 0 near_actor $TRIAD_HEAD3 radius 80.0 80.0
            then
                009A: $TONI4_TRIAD8 = create_actor 8 #GANG04 at 632.062 -1134.0 21.0
                01B2: give_actor $TONI4_TRIAD8 weapon 23 ammo 80  // Load the weapon model before using this
                01DE: tie_actor $TONI4_TRIAD8 to_actor $TRIAD_HEAD3
                011A: set_actor $TONI4_TRIAD8 flags 1
                02A9: set_actor $TRIAD_HEAD3 immune_to_nonplayer 0
                009A: $TONI4_TRIAD9 = create_actor 8 #GANG04 at 631.062 -1129.0 21.0
                01B2: give_actor $TONI4_TRIAD9 weapon 23 ammo 80  // Load the weapon model before using this
                01DE: tie_actor $TONI4_TRIAD9 to_actor $TRIAD_HEAD3
                011A: set_actor $TONI4_TRIAD9 flags 1
                02A9: set_actor $TRIAD_HEAD3 immune_to_nonplayer 0
                0004: $GRUNTS3_BEEN_CREATED_BEFORE = 1
            end
        end
    end
    if and
        0038:   $GRUNTS1_BEEN_CREATED_BEFORE == 1
        0038:   $PAY_BACK_FOR_TRAIDS1 == 0
    then
        if or
            0118:   actor $TONI4_TRIAD4 dead
            0118:   actor $TONI4_TRIAD5 dead
            0118:   actor $TRIAD_HEAD1 dead
        then
            if
                8118:   NOT   actor $TONI4_TRIAD4 dead
            then
                01CA: actor $TONI4_TRIAD4 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $TONI4_TRIAD5 dead
            then
                01CA: actor $TONI4_TRIAD5 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $TRIAD_HEAD1 dead
            then
                01CA: actor $TRIAD_HEAD1 kill_player $PLAYER
            end
            0004: $PAY_BACK_FOR_TRAIDS1 = 1
        end
    end
    if and
        0038:   $GRUNTS2_BEEN_CREATED_BEFORE == 1
        0038:   $PAY_BACK_FOR_TRAIDS2 == 0
    then
        if or
            0118:   actor $TONI4_TRIAD6 dead
            0118:   actor $TONI4_TRIAD7 dead
            0118:   actor $TRIAD_HEAD2 dead
        then
            if
                8118:   NOT   actor $TONI4_TRIAD6 dead
            then
                01CA: actor $TONI4_TRIAD6 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $TONI4_TRIAD7 dead
            then
                01CA: actor $TONI4_TRIAD7 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $TRIAD_HEAD2 dead
            then
                01CA: actor $TRIAD_HEAD2 kill_player $PLAYER
            end
            0004: $PAY_BACK_FOR_TRAIDS2 = 1
        end
    end
    if and
        0038:   $GRUNTS3_BEEN_CREATED_BEFORE == 1
        0038:   $PAY_BACK_FOR_TRAIDS3 == 0
    then
        if or
            0118:   actor $TONI4_TRIAD8 dead
            0118:   actor $TONI4_TRIAD9 dead
            0118:   actor $TRIAD_HEAD3 dead
        then
            if
                8118:   NOT   actor $TONI4_TRIAD8 dead
            then
                01CA: actor $TONI4_TRIAD8 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $TONI4_TRIAD9 dead
            then
                01CA: actor $TONI4_TRIAD9 kill_player $PLAYER
            end
            if
                8118:   NOT   actor $TRIAD_HEAD3 dead
            then
                01CA: actor $TRIAD_HEAD3 kill_player $PLAYER
            end
            0004: $PAY_BACK_FOR_TRAIDS3 = 1
        end
    end
    if
        8118:   NOT   actor $TRIAD_HEAD3 dead
    then
        if and
            00E9:   player $PLAYER 0 near_actor $TRIAD_HEAD3 radius 30.0 30.0
            0038:   $TRIAD3_CAN_LEG_IT == 0
        then
            0350: set_char_stay_in_same_place $TRIAD_HEAD3  0
            0004: $TRIAD3_CAN_LEG_IT = 1
        end
    end
    if
        8118:   NOT   actor $TONI4_MAFIA1 dead
    then
        if
            80E9:   NOT   player $PLAYER 0 near_actor $TONI4_MAFIA1 radius 120.0 120.0
        then
            009B: destroy_actor_instantly $TONI4_MAFIA1
        else
            if
                8320:   NOT   actor $TONI4_MAFIA1 in_range_of_player $PLAYER
            then
                01DF: tie_actor $TONI4_MAFIA1 to_player $PLAYER
            end
        end
    end
    if
        8118:   NOT   actor $TONI4_MAFIA2 dead
    then
        if
            80E9:   NOT   player $PLAYER 0 near_actor $TONI4_MAFIA2 radius 120.0 120.0
        then
            009B: destroy_actor_instantly $TONI4_MAFIA2
        else
            if
                8320:   NOT   actor $TONI4_MAFIA2 in_range_of_player $PLAYER
            then
                01DF: tie_actor $TONI4_MAFIA2 to_player $PLAYER
            end
        end
    end
    if
        0057:   player $PLAYER 0 in_cube 690.1899 -1108.38 18.0 674.19 -1098.38 22.0
    then
        if and
            80DE:   NOT   player $PLAYER driving_vehicle_type #BELLYUP
            80DE:   NOT   player $PLAYER driving_vehicle_type #TRASH
        then
            if and
                0057:   player $PLAYER 0 in_cube 680.56 -1100.5 18.0 674.19 -1108.0601 22.0
                0038:   $BEEN_IN_FISH_FACTORY == 0
            then
                0004: $BEEN_IN_FISH_FACTORY = 1
            end
            if
                0038:   $BEEN_IN_FISH_FACTORY == 0
            then
                00BC: print_now 'TM4_GAT' 5000 ms 1   // // ~g~You need a 'Triad fish van' to enter.
            end
        end
    end
end //while
jump @MISSION_TONI4_PASSED

:MISSION_TONI4_FAILED
015C: set_zone_gang_info 'CHINA' 1 (day)  20 0 300 0 0 0 0 0 0 0 20
015C: set_zone_gang_info 'CHINA' 0 (night)  10 0 400 0 0 0 0 0 0 0 10
return

:MISSION_TONI4_PASSED
0004: $TRIADS_AND_TRIBULATIONS_COMPLETED = 1
0394: play_music 1
01E3: text_1number_styled 'M_PASS' 30000 5000 ms 1   // // MISSION PASSED! $~1~
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 30000
0318: set_latest_mission_passed 'TM4'   // // 'TRIADS AND TRIBULATIONS'
030C: set_mission_points += 1
004F: create_thread @TONI_MISSION5_LOOP
015C: set_zone_gang_info 'CHINA' 1 (day)  20 0 200 0 0 0 0 0 0 0 20
015C: set_zone_gang_info 'CHINA' 0 (night)  10 0 300 0 0 0 0 0 0 0 10
return

:MISSION_CLEANUP_TONI4
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_TONI = 0
0164: remove_blip $BLIP1_TM4
0164: remove_blip $BLIP2_TM4
0164: remove_blip $BLIP3_TM4
0249: mark_model_as_no_longer_needed #GANG01
0249: mark_model_as_no_longer_needed #GANG02
0249: mark_model_as_no_longer_needed #GANG03
0249: mark_model_as_no_longer_needed #GANG04
0249: mark_model_as_no_longer_needed #UZI
0249: mark_model_as_no_longer_needed #SHOTGUN
040D: unload_wav 1
03F1: pedtype 8 add_threat 1
015C: set_zone_gang_info 'LITTLEI' 1 (day)  17 300 0 0 0 0 0 0 0 0 20
015C: set_zone_gang_info 'LITTLEI' 0 (night)  11 400 0 0 0 0 0 0 0 0 10
mission_cleanup
return
