//-------------Mission 2-------------
// Originally: Police station cut scene

:M02_POLICEHELP
03A4: name_thread 'WANTED'
gosub @WANTED_INFO_START
gosub @WANTED_INFO_CLEANUP
end_thread

:WANTED_INFO_START
$FLAG_PLAYER_ON_MISSION = 1  
wait 0 ms
$INFO_TIME_LAPSED = 0  
$INFO_TIME_NOW = 0  
$INFO_TIME_START = 0  
$FLAG_INFO = 0  
$FLAG_COPCAR_PROGRESS = 0  
$FLAG_SWAT_PROGRESS = 0  
$FLAG_INTRO_JUMP = 0  
$WANTED_LEVEL = 0  
01C0: $WANTED_LEVEL = player $PLAYER wanted_level
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
01B4: set_player $PLAYER can_move 0 (frozen)
03AF: set_streaming 0 (disabled)
0247: request_model #ENFORCER
0247: request_model #SWAT
0247: request_model #DIABLOS
0247: request_model #GANG06
0247: request_model #SHOTGUN
038B: load_all_models_now

while true
    if or
        8248:   NOT   model #ENFORCER available
        8248:   NOT   model #SWAT available
        8248:   NOT   model #GANG06 available
        8248:   NOT   model #DIABLOS available
        8248:   NOT   model #SHOTGUN available        
    jf break
    wait 0 
end
03AF: set_streaming 1 (enabled)

while true
    if
        13 > $FLAG_INFO  
    jf break
    wait 0 ms
    if
        $FLAG_INFO == 0  
    then
        01BD: $INFO_TIME_START = current_time_in_ms
        00A5: $BUSTED_HELP_POLICECAR_1 = create_car #POLICE at 775.0 -823.0 21.0
        0175: set_car $BUSTED_HELP_POLICECAR_1 z_angle_to 330.0
        0129: $BUSTED_HELP_COP_1 = create_actor 4 #COP in_car $BUSTED_HELP_POLICECAR_1 driverseat
        00A5: $BUSTED_HELP_POLICECAR_2 = create_car #POLICE at 770.0 -828.0 21.0
        0175: set_car $BUSTED_HELP_POLICECAR_2 z_angle_to 330.0
        0129: $BUSTED_HELP_COP_2 = create_actor 4 #COP in_car $BUSTED_HELP_POLICECAR_2 driverseat
        00A5: $BUSTED_HELP_DIABLOCAR = create_car #DIABLOS at 780.0 -818.0 21.0
        0175: set_car $BUSTED_HELP_DIABLOCAR z_angle_to 0.0
        0129: $BUSTED_HELP_DIABLO = create_actor 9 #GANG06 in_car $BUSTED_HELP_DIABLOCAR driverseat
        01EB: set_car_density_to 0.25
        03DE: set_pedestrians_density_multiplier_to 0.0
        03E5: text_box 'WANT_A'   // You will only be arrested if you have a ~h~wanted level.
        $FLAG_INFO = 1  
    end
    if
        $FLAG_INTRO_JUMP == 0  
    then
        01BD: $INFO_TIME_NOW = current_time_in_ms
        0084: $INFO_TIME_LAPSED = $INFO_TIME_NOW   
        0060: $INFO_TIME_LAPSED -= $INFO_TIME_START  
    end
    if and
        $INFO_TIME_LAPSED > 3500  
        $FLAG_INFO == 1  
    then
        03E5: text_box 'WANT_G'   // When you are ~h~'busted'~w~ you are returned to the nearest police station.
        if and
            8119:   NOT   car $BUSTED_HELP_POLICECAR_1 wrecked
            8119:   NOT   car $BUSTED_HELP_POLICECAR_2 wrecked
            8119:   NOT   car $BUSTED_HELP_DIABLOCAR wrecked
        then
            00AD: set_car $BUSTED_HELP_POLICECAR_2 max_speed_to 75.0
            00AE: set_car $BUSTED_HELP_POLICECAR_2 driving_style 3  // DRIVINGMODE_PLOUGHTHROUGH
            032C: car $BUSTED_HELP_POLICECAR_2 ram $BUSTED_HELP_DIABLOCAR
            00AD: set_car $BUSTED_HELP_POLICECAR_1 max_speed_to 70.0
            00AE: set_car $BUSTED_HELP_POLICECAR_1 driving_style 3  // DRIVINGMODE_PLOUGHTHROUGH
            032C: car $BUSTED_HELP_POLICECAR_1 ram $BUSTED_HELP_DIABLOCAR
        end
    
        015F: set_camera_position 799.0 -695.0 24.0 0.0 0.0 0.0
        if
            8119:   NOT   car $BUSTED_HELP_DIABLOCAR wrecked
        then
            0158: camera_on_vehicle $BUSTED_HELP_DIABLOCAR 15 2
        end
        if
            8119:   NOT   car $BUSTED_HELP_DIABLOCAR wrecked
        then
            00AD: set_car $BUSTED_HELP_DIABLOCAR max_speed_to 50.0
            00AE: set_car $BUSTED_HELP_DIABLOCAR driving_style 2  // DRIVINGMODE_AVOIDCARS
            00A7: car $BUSTED_HELP_DIABLOCAR drive_to 647.0 -617.0 21.0
        end
        if and
            8119:   NOT   car $BUSTED_HELP_POLICECAR_1 wrecked
            8119:   NOT   car $BUSTED_HELP_POLICECAR_2 wrecked
        then
            0397: car $BUSTED_HELP_POLICECAR_1 siren = 1 (on)   // never used in VC
            0397: car $BUSTED_HELP_POLICECAR_2 siren = 1 (on)   // never used in VC
        end
        $FLAG_INFO = 2  
    end
    if and
        $INFO_TIME_LAPSED > 5500  
        $FLAG_COPCAR_PROGRESS == 0  
    then
        0395: clear_area 1 at 807.0 -666.0 20.75 range 10.0
        00A5: $BUSTED_HELP_ENFORCER = create_car #ENFORCER at 807.0 -666.0 20.75
        0175: set_car $BUSTED_HELP_ENFORCER z_angle_to 90.0
        020A: set_car $BUSTED_HELP_ENFORCER door_status_to 1
        00A9: set_car $BUSTED_HELP_ENFORCER to_normal_driver
        009A: $BUSTED_HELP_SWAT_1 = create_actor 4 #SWAT at 803.0 -671.0 21.0
        009A: $BUSTED_HELP_SWAT_2 = create_actor 4 #SWAT at 802.75 -661.25 21.0
        01B2: give_actor $BUSTED_HELP_SWAT_2 weapon 21 ammo 60  // Load the weapon model before using this
        0173: set_actor $BUSTED_HELP_SWAT_1 z_angle_to 110.0
        0173: set_actor $BUSTED_HELP_SWAT_2 z_angle_to 80.0
        if
            8118:   NOT   actor $BUSTED_HELP_DIABLO dead
        then
            022C: set_actor $BUSTED_HELP_SWAT_2 to_look_at_actor $BUSTED_HELP_DIABLO
        end
        if
            8118:   NOT   actor $BUSTED_HELP_COP_1 dead
        then
            022C: set_actor $BUSTED_HELP_SWAT_1 to_look_at_actor $BUSTED_HELP_COP_1
        end
        $FLAG_COPCAR_PROGRESS = 1  
    end
    if and
        $INFO_TIME_LAPSED > 7500  
        $FLAG_INFO == 2  
    then
        03E5: text_box 'WANT_H'   // The cops will take all your weapons and some of your cash as a bribe.
        0004: $FLAG_INFO = 3  
    end
    if and
        $INFO_TIME_LAPSED > 10500  
        $FLAG_INFO == 3  
    then
        03E5: text_box 'WANT_I'   // Any mission you were on will be failed.
        0004: $FLAG_INFO = 4  
    end
    if and
        $INFO_TIME_LAPSED > 12500  
        $FLAG_INFO == 4  
    then
        03E5: text_box 'WANT_B'   // Your ~h~wanted level~w~ is represented by the row of stars in the top right of the screen.
        if
            8119:   NOT   car $BUSTED_HELP_ENFORCER wrecked
        then
            015F: set_camera_position 800.75 -673.0 20.75 0.0 0.0 0.0
            0158: camera_on_vehicle $BUSTED_HELP_ENFORCER 15 2
            00A6: destroy_car $BUSTED_HELP_POLICECAR_1
            00A6: destroy_car $BUSTED_HELP_POLICECAR_2
            00A6: destroy_car $BUSTED_HELP_DIABLOCAR
        end
        $FLAG_INFO = 5  
    end
    if and
        $INFO_TIME_LAPSED > 13500  
        $FLAG_INFO == 5  
    then
        if and
            8119:   NOT   car $BUSTED_HELP_ENFORCER wrecked
            8118:   NOT   actor $BUSTED_HELP_SWAT_1 dead
        then
            022F: set_actor $BUSTED_HELP_SWAT_1 stop_looking
            01D5: actor $BUSTED_HELP_SWAT_1 go_to_and_drive_car $BUSTED_HELP_ENFORCER
        end
        $FLAG_INFO = 6  
    end
    if and
        $INFO_TIME_LAPSED > 16000  
        $FLAG_INFO == 6  
    then
        03E5: text_box 'WANT_C'   // You now have a ~h~wanted level~w~ of one...
        010D: set_player $PLAYER wanted_level_to 1
        if and
            8119:   NOT   car $BUSTED_HELP_ENFORCER wrecked
            8118:   NOT   actor $BUSTED_HELP_SWAT_2 dead
        then
            01D4: actor $BUSTED_HELP_SWAT_2 go_to_car $BUSTED_HELP_ENFORCER and_enter_it_as_a_passenger
        end
        0004: $FLAG_INFO = 7  
    end
    if and
        $INFO_TIME_LAPSED > 18000  
        $FLAG_INFO == 7  
    then
        03E5: text_box 'WANT_D'   // two...
        010D: set_player $PLAYER wanted_level_to 2
        0004: $FLAG_INFO = 8  
    end
    if and
        $INFO_TIME_LAPSED > 20000  
        $FLAG_INFO == 8  
    then
        03E5: text_box 'WANT_E'   // three...
        010D: set_player $PLAYER wanted_level_to 3
        0004: $FLAG_INFO = 9  
    end
    if and
        $INFO_TIME_LAPSED > 22000  
        $FLAG_INFO == 9  
    then
        03E5: text_box 'WANT_F'   // As your ~h~wanted level~w~ increases you will attract more powerful forms of law enforcement.
        0004: $FLAG_INFO = 10  
    end
    if and
        $INFO_TIME_LAPSED > 26000  
        $FLAG_INFO == 10  
    then
        015F: set_camera_position 800.0 -672.5 21.5 0.0 0.0 0.0
        0157: camera_on_player $PLAYER 15 2
        03E5: text_box 'WANT_J'   // You will find ways of reducing your wanted level the more you play.
        0213: $BUSTED_HELP_BRIBE = create_pickup #BRIBE type 14 at 808.0 -671.0 21.0
        0160: point_camera 808.0 -671.0 21.0 1
        0004: $FLAG_INFO = 11  
    end
    if and
        $INFO_TIME_LAPSED > 30000  
        $FLAG_INFO == 11  
    then
        $FLAG_INFO = 12  
    end
    if and
        $INFO_TIME_LAPSED > 34000  
        $FLAG_INFO == 12  
    then
        03E6: remove_text_box
        0169: set_fade_color 0 0 0
        016A: fade 0 (in)  1500 ms
        while fading
            wait 0 ms
        end
        0215: destroy_pickup $BUSTED_HELP_BRIBE
        009B: destroy_actor_instantly $BUSTED_HELP_DIABLO
        00A6: destroy_car $BUSTED_HELP_DIABLOCAR
        009B: destroy_actor_instantly $BUSTED_HELP_COP_1
        00A6: destroy_car $BUSTED_HELP_POLICECAR_1
        009B: destroy_actor_instantly $BUSTED_HELP_COP_2
        00A6: destroy_car $BUSTED_HELP_POLICECAR_2
        009B: destroy_actor_instantly $BUSTED_HELP_SWAT_2
        009B: destroy_actor_instantly $BUSTED_HELP_SWAT_1
        00A6: destroy_car $BUSTED_HELP_ENFORCER
        02EB: restore_camera_jumpcut
        01B4: set_player $PLAYER can_move 1 (unfrozen)
        010D: set_player $PLAYER wanted_level_to $WANTED_LEVEL
        0169: set_fade_color 0 0 0
        016A: fade 1 (out)  1500 ms
        while fading
            wait 0 ms
        end
        $FLAG_INFO = 13  
    end
    if and
        8119:   NOT   car $BUSTED_HELP_ENFORCER wrecked
        8118:   NOT   actor $BUSTED_HELP_SWAT_2 dead
        8118:   NOT   actor $BUSTED_HELP_SWAT_1 dead
    then
        if and
            $FLAG_SWAT_PROGRESS == 0  
            $INFO_TIME_LAPSED > 21000  
        then
            if and
                00DB:   actor $BUSTED_HELP_SWAT_2 in_car $BUSTED_HELP_ENFORCER
                00DB:   actor $BUSTED_HELP_SWAT_1 in_car $BUSTED_HELP_ENFORCER
            then
                00AD: set_car $BUSTED_HELP_ENFORCER max_speed_to 10.0
                00AE: set_car $BUSTED_HELP_ENFORCER driving_style 2  // DRIVINGMODE_AVOIDCARS
                02C2: car $BUSTED_HELP_ENFORCER drive_to_point 798.0 -669.0 21.0
                $FLAG_SWAT_PROGRESS = 1  
            end
        end
    end
    if
        8119:   NOT   car $BUSTED_HELP_ENFORCER wrecked
    then
        if and
            01AD:   car $BUSTED_HELP_ENFORCER 0 near_point 798.0 -669.0 3.0 3.0
            $FLAG_SWAT_PROGRESS == 1  
            $INFO_TIME_LAPSED > 22000  
        then
            00A7: car $BUSTED_HELP_ENFORCER drive_to 647.0 -617.0 21.0
            00AD: set_car $BUSTED_HELP_ENFORCER max_speed_to 30.0
            00AE: set_car $BUSTED_HELP_ENFORCER driving_style 3  // DRIVINGMODE_PLOUGHTHROUGH
            0397: car $BUSTED_HELP_ENFORCER siren = 1 (on)   // never used in VC
            $FLAG_SWAT_PROGRESS = 2  
        end
    end
    if and
        $FLAG_INTRO_JUMP == 0  
        12 > $FLAG_INFO  
    then
        if
            00E1:   key_pressed 0 16
        then
            $INFO_TIME_LAPSED = 34001  
            $FLAG_INFO = 12  
            $FLAG_INTRO_JUMP = 1  
        end
    end
end
return

:WANTED_INFO_CLEANUP
02EB: restore_camera_jumpcut
02A3: toggle_widescreen 0 (off)
01B4: set_player $PLAYER can_move 1 (unfrozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
if
    8119:   NOT   car $BUSTED_HELP_ENFORCER wrecked
then
    00A8: set_car $BUSTED_HELP_ENFORCER to_psycho_driver
end
if
    8119:   NOT   car $BUSTED_HELP_POLICECAR_1 wrecked
then
    00A8: set_car $BUSTED_HELP_POLICECAR_1 to_psycho_driver
end
if
    8119:   NOT   car $BUSTED_HELP_DIABLOCAR wrecked
then
    00A8: set_car $BUSTED_HELP_DIABLOCAR to_psycho_driver
end
01EB: set_car_density_to 1.0
03DE: set_pedestrians_density_multiplier_to 1.0
01C3: remove_references_to_car $BUSTED_HELP_ENFORCER  // Like turning a car into any random car
01C3: remove_references_to_car $BUSTED_HELP_POLICECAR_1  // Like turning a car into any random car
01C3: remove_references_to_car $BUSTED_HELP_DIABLOCAR  // Like turning a car into any random car
01C2: remove_references_to_actor $BUSTED_HELP_COP_1  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $BUSTED_HELP_SWAT_2  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $BUSTED_HELP_SWAT_1  // Like turning an actor into a random pedestrian
01C2: remove_references_to_actor $BUSTED_HELP_DIABLO  // Like turning an actor into a random pedestrian
0249: mark_model_as_no_longer_needed #COP
0249: mark_model_as_no_longer_needed #GANG06
0249: mark_model_as_no_longer_needed #SWAT
0249: mark_model_as_no_longer_needed #DIABLOS
0249: mark_model_as_no_longer_needed #ENFORCER
0249: mark_model_as_no_longer_needed #POLICE
0249: mark_model_as_no_longer_needed #SHOTGUN
$FLAG_PLAYER_ON_MISSION = 0  
$FLAG_WANTED_INFO = 1  
mission_cleanup
return
