:WARPER
03A4: name_thread 'WARPER'

while true
    wait 250 ms
    if
        0256:   player $PLAYER defined
    then
        if
            00F5:   player $PLAYER in_sphere 0 near_point 5.45 -1118.67 31.98 radius 1.5 1.5 3.0      // Staunton Police Station ground level
        then
            0007: 0@ = 14.89
            0007: 1@ = -1106.23
            0007: 2@ = 82.48
            0007: 3@ = 90.8
            0006: 4@ = 0
            gosub @BUILDINGWARP_TELEPORT
        end

        if
            00F5:   player $PLAYER in_sphere 0 near_point 15.89 -1106.23 82.48 radius 1.5 1.5 3.0      // Staunton Police Station roof
        then
            0007: 0@ = 5.69
            0007: 1@ = -1119.77
            0007: 2@ = 31.68
            0007: 3@ = 185.0
            0006: 4@ = 0
            gosub @BUILDINGWARP_TELEPORT
        end

        if
            00F5:   player $PLAYER in_sphere 0 near_point -244.71 -1548.66 34.31 radius 1.5 1.5 3.0      // Love Media ground level
        then
            0007: 0@ = -252.5
            0007: 1@ = -1554.4
            0007: 2@ = 79.15
            0007: 3@ = 90.7
            0006: 4@ = 0
            gosub @BUILDINGWARP_TELEPORT
        end

        if
            00F5:   player $PLAYER in_sphere 0 near_point -251.43 -1554.4 79.13 radius 1.5 1.5 3.0      // Love Media roof
        then
            0007: 0@ = -243.55
            0007: 1@ = -1548.63
            0007: 2@ = 34.31
            0007: 3@ = 94.0
            0006: 4@ = 0
            gosub @BUILDINGWARP_TELEPORT
        end

        if
            00F5:   player $PLAYER in_sphere 0 near_point 984.46 -452.97 60.52 radius 1.5 1.5 3.0      // Bistro exterior
        then
            if or
                $LAST_REQUESTS_COMPLETED == 0            // If the mafia like you
                02BD:   debug_mode == DEBUG_MASTERDEBUG  // Or you can go in anyway
            then
                004F: create thread @BISTRO_SOUND
                0007: 0@ = 966.5
                0007: 1@ = -467.0
                0007: 2@ = 60.18
                0007: 3@ = 0.0
                0006: 4@ = 0
                gosub @BUILDINGWARP_TELEPORT
            end
        end

        if
            00F5:   player $PLAYER in_sphere 0 near_point 966.5 -468.0 60.18 radius 1.5 1.5 3.0      // Bistro interior
        then
            0007: 0@ = 984.46
            0007: 1@ = -452.97
            0007: 2@ = 60.52
            0007: 3@ = 270.0
            0006: 4@ = 1    // Bistro audio needs to be disabled
            gosub @BUILDINGWARP_TELEPORT
        end
    end
end

:BUILDINGWARP_TELEPORT
if and
    00E0:   player $PLAYER driving
    847E:   not player $PLAYER driving_a_motorbike
then
    return
end
0169: set_fade_color 1 1 1
016A: fade 0 500 ms
while fading
    wait 0 ms
end
01B4: set_player $PLAYER can_move 0
0395: clear_area 1 at 0@ 1@ 2@ range 1.5
0055: set_player_coordinates $PLAYER at 0@ 1@ 2@
0171: set_player $PLAYER z_angle_to 3@
0373: set_camera_directly_behind_player
if
    4@ == 1
then
    $BISTRO_AUDIO_LAUNCHED = 0
    0459: end_thread_named 'BISAUD'
    040D: unload_wav 2
end
wait 500 ms
01B4: set_player $PLAYER can_move 1

0169: set_fade_color 1 1 1
016A: fade 1 500 ms

while 00F5:   player $PLAYER in_sphere 0 near_point 0@ 1@ 2@ radius 3.0 3.0 5.0
    wait 0 ms
end
return

:BISTRO_SOUND
03A4: name_thread 'BISAUD'
if
    $BISTRO_AUDIO_LAUNCHED == 1     // The same thread is running already?
then
    end_thread
end
$BISTRO_AUDIO_LAUNCHED = 1

while true
    wait 250 ms
    if
        0256:   player $PLAYER defined
    then
        if
            0057:   player $PLAYER 0 in cube 965.0 -471.0 55.0 983.0 -447.8 65.0
        then
            03CF: load_wav 'BISTRO' as 2
            gosub @AUDIO2_PLAY 
            while 0057:   player $PLAYER 0 in cube 965.0 -471.0 55.0 983.0 -447.8 65.0
                wait 250 ms
                if
                    03D2:   wav 2 ended
                then
                    03D1: play_wav 2
                end
            end
            040D: unload_wav 2
        end
    end
end