//-------------Mission 45-------------
// Originally: Asuka mission 2 'UNDER SURVEILLANCE'

:M45_UNDERSURVEILLANCE
03A4: name_thread 'ASUKA2'
054C: use_GXT_table 'ASU2'
058E: set_restart_mission_taxi_destination 118.24 -684.80 21.96 angle 181.0
gosub @MISSION_START_ASUKA2
if
    wasted_or_busted
then
    gosub @MISSION_ASUKA2_FAILED
end
gosub @MISSION_CLEANUP_ASUKA2
end_thread

:MISSION_START_ASUKA2
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_ASUKA1 = 1
wait 0 ms
0004: $NUMBER_OF_FEDS_KILLED = 0
0004: $BEEN_DAMAGED_BEFORE = 0
0004: $FBI_SPOTTED_PLAYER = 0
0004: $FBI_SPOTTED_PLAYER2 = 0
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'ASUKAH'
02F3: load_object #CUTOBJ03 'KENJIH'
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'ASUKA'
023C: load_special_actor 3 'KENJI'
0247: request_model #CONDO_IVY
0247: request_model #KMRICNDO01
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        823D:   NOT   special_actor 3 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CUTOBJ03 available
    jf break
    wait 0 ms
end
while true
    if or
        8248:   NOT   model #CONDO_IVY available
        8248:   NOT   model #KMRICNDO01 available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'A3_SS'
0244: set_cutscene_pos 188.062 -636.938 21.5625
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_ASUKA = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_ASUKA 'ASUKA'
02E5: $CUTSCENE_KENJI = create_cutscene_object #SPECIAL03
02E6: set_cutscene_anim $CUTSCENE_KENJI 'KENJI'
//02F4: create_cutscene_actor $PLAYER_CSHEAD from_head #CUTOBJ01 and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
//02F4: create_cutscene_actor $ASUKA_CSHEAD from_head #CUTOBJ02 and_body $CUTSCENE_ASUKA
//02F5: set_head_anim $ASUKA_CSHEAD 'ASUKA'
//02F4: create_cutscene_actor $KENJI_CSHEAD from_head #CUTOBJ03 and_body $CUTSCENE_KENJI
//02F5: set_head_anim $KENJI_CSHEAD 'KENJI'
0395: clear_area 1 at 188.562 -639.375 22.5625 range 1.0
0055: set_player_coordinates $PLAYER at 188.562 -639.375 22.0
0171: set_player $PLAYER z_angle_to 180.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   1892 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM2_A' 10000 ms 1   // Salvatore's death comes as pleasurable news
while 001A:   4983 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM2_A2' 10000 ms 1   // you are an efficient killer. I like that in a man.
while 001A:   8705 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM2_B' 10000 ms 1   // This is my brother Kenji.
while 001A:   10494 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM2_C' 10000 ms 1   // Asuka has a little job for you but when you're done drop by my casino and we can talk.
while 001A:   16940 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM2_D' 10000 ms 1   // Just like Kenji always trying to play with my toys.
while 001A:   22566 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM2_E' 10000 ms 1   // My police source indicates that the Mafia are watching our interests around the city
while 001A:   26394 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM2_E2' 10000 ms 1   // in a bid to track you down.
while 001A:   28456 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM2_F' 10000 ms 1   // We cannot continue our operations until they are dealt with.
while 001A:   32144 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM2_G' 10000 ms 1   // Take out these spying fools and end this vendetta once and for all.
while 001A:   36663 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BE: text_clear_all
while 001A:   39000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
03AD: set_rubbish 1 (visible)
02EA: clear_cutscene
03C8: set_camera_in_front_of_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CUTOBJ03
0249: mark_model_as_no_longer_needed #CONDO_IVY
0249: mark_model_as_no_longer_needed #KMRICNDO01
0296: unload_special_actor 1
0296: unload_special_actor 2
0296: unload_special_actor 3
0247: request_model #GANG01
0247: request_model #GANG02
0247: request_model #RUMPO
0247: request_model #M16
0247: request_model #UZI
while true
    if or
        8248:   NOT   model #GANG01 available
        8248:   NOT   model #GANG02 available
        8248:   NOT   model #RUMPO available
        8248:   NOT   model #M16 available
        8248:   NOT   model #UZI available
    jf break
    wait 0 ms
end
0004: $FED1_ALREADY_DEAD = 0
0004: $FED2_ALREADY_DEAD = 0
0004: $FED3_ALREADY_DEAD = 0
0004: $FED4_ALREADY_DEAD = 0
0004: $FED5_ALREADY_DEAD = 0
0004: $FED6_ALREADY_DEAD = 0
0004: $FED7_ALREADY_DEAD = 0
0004: $FED8_ALREADY_DEAD = 0
0004: $FED9_ALREADY_DEAD = 0
0004: $FED10_ALREADY_DEAD = 0
// 0004: $FEDVAN1_ALREADY_DEAD = 0
0004: $COUNTDOWN_AS2 = 391000
014E: set_timer_to $COUNTDOWN_AS2 type 1
009A: $FBI1 = create_actor 4 #GANG01 at 48.0 -1447.88 57.375
0173: set_actor $FBI1 z_angle_to 304.0
011A: set_actor $FBI1 flags 1
01B2: give_actor $FBI1 weapon 26 ammo 600  // Load the weapon model before using this
0350: set_char_stay_in_same_place $FBI1  1
0243: set_actor $FBI1 ped_stats_to 16
0187: $BLIP1_FBI1 = create_marker_above_actor $FBI1
009A: $FBI2 = create_actor 4 #GANG02 at 46.188 -1438.1899 69.375
0173: set_actor $FBI2 z_angle_to 304.0
011A: set_actor $FBI2 flags 1
01B2: give_actor $FBI2 weapon 26 ammo 600  // Load the weapon model before using this
0350: set_char_stay_in_same_place $FBI2  1
0243: set_actor $FBI2 ped_stats_to 16
0187: $BLIP2_FBI2 = create_marker_above_actor $FBI2
009A: $FBI3 = create_actor 4 #GANG01 at 48.3 -1452.25 75.5 // 48.5 -1452.25 75.5
0173: set_actor $FBI3 z_angle_to 304.0
011A: set_actor $FBI3 flags 1
01B2: give_actor $FBI3 weapon 26 ammo 600  // Load the weapon model before using this
0350: set_char_stay_in_same_place $FBI3  1
0243: set_actor $FBI3 ped_stats_to 16
0187: $BLIP3_FBI3 = create_marker_above_actor $FBI3
009A: $FBI8 = create_actor 4 #GANG02 at 46.562 -1451.6899 63.5
0173: set_actor $FBI8 z_angle_to 304.0
011A: set_actor $FBI8 flags 1
01B2: give_actor $FBI8 weapon 26 ammo 600  // Load the weapon model before using this
0350: set_char_stay_in_same_place $FBI8  1
0243: set_actor $FBI8 ped_stats_to 16
0187: $BLIP8_FBI8 = create_marker_above_actor $FBI8
009A: $FBI9 = create_actor 4 #GANG01 at 46.2 -1443.5 81.5 // 46.375 -1443.5 81.5
0173: set_actor $FBI9 z_angle_to 304.0
011A: set_actor $FBI9 flags 1
01B2: give_actor $FBI9 weapon 26 ammo 600  // Load the weapon model before using this
0350: set_char_stay_in_same_place $FBI9  1
0243: set_actor $FBI9 ped_stats_to 16
0187: $BLIP9_FBI9 = create_marker_above_actor $FBI9
009A: $FBI10 = create_actor 4 #GANG02 at 44.0 -1449.5601 87.375
0173: set_actor $FBI10 z_angle_to 304.0
011A: set_actor $FBI10 flags 1
01B2: give_actor $FBI10 weapon 26 ammo 600  // Load the weapon model before using this
0350: set_char_stay_in_same_place $FBI10  1
0243: set_actor $FBI10 ped_stats_to 16
0187: $BLIP10_FBI10 = create_marker_above_actor $FBI10
009A: $FBI4 = create_actor 4 #GANG01 at -286.625 -642.75 35.0
0173: set_actor $FBI4 z_angle_to 169.0
011A: set_actor $FBI4 flags 1
01B2: give_actor $FBI4 weapon 25 ammo 100  // Load the weapon model before using this
0350: set_char_stay_in_same_place $FBI4  1
0243: set_actor $FBI4 ped_stats_to 16
0187: $BLIP4_FBI4 = create_marker_above_actor $FBI4
009A: $FBI7 = create_actor 4 #GANG02 at -292.8125 -641.25 33.75
0173: set_actor $FBI7 z_angle_to 208.0
011A: set_actor $FBI7 flags 1
01B2: give_actor $FBI7 weapon 25 ammo 600  // Load the weapon model before using this
0350: set_char_stay_in_same_place $FBI7  1
0243: set_actor $FBI7 ped_stats_to 16
0187: $BLIP7_FBI7 = create_marker_above_actor $FBI7
00A5: $FBI_VAN1 = create_car #RUMPO at -273.75 -1389.38 32.25
0229: set_car $FBI_VAN1 color_to 0 0
02AA: set_car $FBI_VAN1 immune_to_nonplayer 1
020A: set_car $FBI_VAN1 door_status_to 2
0175: set_car $FBI_VAN1 z_angle_to 151.0
0129: $FBI5 = create_actor 4 #GANG01 in_car $FBI_VAN1 driverseat
0187: $BLIP5_FBI5 = create_marker_above_actor $FBI5
01C8: $FBI6 = create_actor 4 #GANG02 in_car $FBI_VAN1 passenger_seat 2
0187: $BLIP6_FBI6 = create_marker_above_actor $FBI6
00A9: set_car $FBI_VAN1 to_normal_driver
011A: set_actor $FBI5 flags 1
011A: set_actor $FBI6 flags 1
0243: set_actor $FBI5 ped_stats_to 16
0243: set_actor $FBI6 ped_stats_to 16
01B2: give_actor $FBI5 weapon 25 ammo 600  // Load the weapon model before using this
01B2: give_actor $FBI6 weapon 25 ammo 600  // Load the weapon model before using this
while 8038:   NOT   $NUMBER_OF_FEDS_KILLED == 10
    wait 0 ms
    if and
        0118:   actor $FBI1 dead
        0038:   $FED1_ALREADY_DEAD == 0
    then
        0164: remove_blip $BLIP1_FBI1
        0008: $NUMBER_OF_FEDS_KILLED += 1
        0004: $FED1_ALREADY_DEAD = 1
    end
    if and
        0118:   actor $FBI2 dead
        0038:   $FED2_ALREADY_DEAD == 0
    then
        0164: remove_blip $BLIP2_FBI2
        0008: $NUMBER_OF_FEDS_KILLED += 1
        0004: $FED2_ALREADY_DEAD = 1
    end
    if and
        0118:   actor $FBI3 dead
        0038:   $FED3_ALREADY_DEAD == 0
    then
        0164: remove_blip $BLIP3_FBI3
        0008: $NUMBER_OF_FEDS_KILLED += 1
        0004: $FED3_ALREADY_DEAD = 1
    end
    if and
        0118:   actor $FBI4 dead
        0038:   $FED4_ALREADY_DEAD == 0
    then
        0164: remove_blip $BLIP4_FBI4
        0008: $NUMBER_OF_FEDS_KILLED += 1
        0004: $FED4_ALREADY_DEAD = 1
    end
    if and
        0118:   actor $FBI5 dead
        0038:   $FED5_ALREADY_DEAD == 0
    then
        0164: remove_blip $BLIP5_FBI5
        0008: $NUMBER_OF_FEDS_KILLED += 1
        0004: $FED5_ALREADY_DEAD = 1
    end
    if and
        0118:   actor $FBI6 dead
        0038:   $FED6_ALREADY_DEAD == 0
    then
        0164: remove_blip $BLIP6_FBI6
        0008: $NUMBER_OF_FEDS_KILLED += 1
        0004: $FED6_ALREADY_DEAD = 1
    end
    if and
        0118:   actor $FBI7 dead
        0038:   $FED7_ALREADY_DEAD == 0
    then
        0164: remove_blip $BLIP7_FBI7
        0008: $NUMBER_OF_FEDS_KILLED += 1
        0004: $FED7_ALREADY_DEAD = 1
    end
    if and
        0118:   actor $FBI8 dead
        0038:   $FED8_ALREADY_DEAD == 0
    then
        0164: remove_blip $BLIP8_FBI8
        0008: $NUMBER_OF_FEDS_KILLED += 1
        0004: $FED8_ALREADY_DEAD = 1
    end
    if and
        0118:   actor $FBI9 dead
        0038:   $FED9_ALREADY_DEAD == 0
    then
        0164: remove_blip $BLIP9_FBI9
        0008: $NUMBER_OF_FEDS_KILLED += 1
        0004: $FED9_ALREADY_DEAD = 1
    end
    if and
        0118:   actor $FBI10 dead
        0038:   $FED10_ALREADY_DEAD == 0
    then
        0164: remove_blip $BLIP10_FBI10
        0008: $NUMBER_OF_FEDS_KILLED += 1
        0004: $FED10_ALREADY_DEAD = 1
    end
    if
        8118:   NOT   actor $FBI1 dead
    then
        0226: $FBI1HEALTH = actor $FBI1 health
    end
    if
        8118:   NOT   actor $FBI2 dead
    then
        0226: $FBI2HEALTH = actor $FBI2 health
    end
    if
        8118:   NOT   actor $FBI3 dead
    then
        0226: $FBI3HEALTH = actor $FBI3 health
    end
    if
        8118:   NOT   actor $FBI4 dead
    then
        0226: $FBI4HEALTH = actor $FBI4 health
    end
    if
        8118:   NOT   actor $FBI7 dead
    then
        0226: $FBI7HEALTH = actor $FBI7 health
    end
    if
        8118:   NOT   actor $FBI8 dead
    then
        0226: $FBI8HEALTH = actor $FBI8 health
    end
    if
        8118:   NOT   actor $FBI9 dead
    then
        0226: $FBI9HEALTH = actor $FBI9 health
    end
    if
        8118:   NOT   actor $FBI10 dead
    then
        0226: $FBI10HEALTH = actor $FBI10 health
    end
    if or
        001A:   100 > $FBI4HEALTH
        001A:   100 > $FBI7HEALTH
    then
        if
            0038:   $FBI_SPOTTED_PLAYER2 == 0
        then
            if
                8118:   NOT   actor $FBI4 dead
            then
                01CA: actor $FBI4 kill_player $PLAYER
                02E2: set_actor $FBI4 weapon_accuracy_to 70
            end
            if
                8118:   NOT   actor $FBI7 dead
            then
                01CA: actor $FBI7 kill_player $PLAYER
                02E2: set_actor $FBI7 weapon_accuracy_to 70
            end
            0004: $FBI_SPOTTED_PLAYER2 = 1
        end
    end
    if or
        0118:   actor $FBI4 dead
        0118:   actor $FBI7 dead
    then
        if
            0038:   $FBI_SPOTTED_PLAYER2 == 0
        then
            if
                8118:   NOT   actor $FBI4 dead
            then
                01CA: actor $FBI4 kill_player $PLAYER
                02E2: set_actor $FBI4 weapon_accuracy_to 70
            end
            if
                8118:   NOT   actor $FBI7 dead
            then
                01CA: actor $FBI7 kill_player $PLAYER
                02E2: set_actor $FBI7 weapon_accuracy_to 70
            end
            0004: $FBI_SPOTTED_PLAYER2 = 1
         end
    end
    if or
        001A:   100 > $FBI1HEALTH
        001A:   100 > $FBI2HEALTH
        001A:   100 > $FBI3HEALTH
        001A:   100 > $FBI8HEALTH
        001A:   100 > $FBI9HEALTH
        001A:   100 > $FBI10HEALTH
    then
        if
            0038:   $FBI_SPOTTED_PLAYER == 0
        then
            if
                8118:   NOT   actor $FBI1 dead
            then
                01CA: actor $FBI1 kill_player $PLAYER
                02E2: set_actor $FBI1 weapon_accuracy_to 50
            end
            if
                8118:   NOT   actor $FBI2 dead
            then
                01CA: actor $FBI2 kill_player $PLAYER
                02E2: set_actor $FBI2 weapon_accuracy_to 50
            end
            if
                8118:   NOT   actor $FBI3 dead
            then
                wait 500 ms
                if
                    8118:   NOT   actor $FBI3 dead
                then
                    01CA: actor $FBI3 kill_player $PLAYER
                    02E2: set_actor $FBI3 weapon_accuracy_to 50
                end
            end
            if
                8118:   NOT   actor $FBI8 dead
            then
                01CA: actor $FBI8 kill_player $PLAYER
                02E2: set_actor $FBI8 weapon_accuracy_to 50
            end
            if
                8118:   NOT   actor $FBI9 dead
            then
                wait 1000 ms
                if
                    8118:   NOT   actor $FBI9 dead
                then
                    01CA: actor $FBI9 kill_player $PLAYER
                    02E2: set_actor $FBI9 weapon_accuracy_to 50
                end
            end
            if
                8118:   NOT   actor $FBI10 dead
            then
                wait 1000 ms
                if
                    8118:   NOT   actor $FBI10 dead
                then
                    01CA: actor $FBI10 kill_player $PLAYER
                    02E2: set_actor $FBI10 weapon_accuracy_to 70
                end
            end
            0004: $FBI_SPOTTED_PLAYER = 1
        end
    end
    if or
        0118:   actor $FBI1 dead
        0118:   actor $FBI2 dead
        0118:   actor $FBI3 dead
        0118:   actor $FBI8 dead
        0118:   actor $FBI9 dead
        0118:   actor $FBI10 dead
    then
        if
            0038:   $FBI_SPOTTED_PLAYER == 0
        then
            if
                8118:   NOT   actor $FBI1 dead
            then
                01CA: actor $FBI1 kill_player $PLAYER
                02E2: set_actor $FBI1 weapon_accuracy_to 40
            end
            if
                8118:   NOT   actor $FBI2 dead
            then
                01CA: actor $FBI2 kill_player $PLAYER
                02E2: set_actor $FBI2 weapon_accuracy_to 40
            end
            if
                8118:   NOT   actor $FBI3 dead
            then
                wait 500 ms
                if
                    8118:   NOT   actor $FBI3 dead
                then
                    01CA: actor $FBI3 kill_player $PLAYER
                    02E2: set_actor $FBI3 weapon_accuracy_to 50
                end
            end
            if
                8118:   NOT   actor $FBI8 dead
            then
                01CA: actor $FBI8 kill_player $PLAYER
                02E2: set_actor $FBI8 weapon_accuracy_to 40
            end
            if
                8118:   NOT   actor $FBI9 dead
            then
                wait 1000 ms
                if
                    8118:   NOT   actor $FBI9 dead
                then
                    01CA: actor $FBI9 kill_player $PLAYER
                    02E2: set_actor $FBI9 weapon_accuracy_to 50
                end
            end
            if
                8118:   NOT   actor $FBI10 dead
            then
                wait 1000 ms
                if
                    8118:   NOT   actor $FBI10 dead
                then
                    01CA: actor $FBI10 kill_player $PLAYER
                    02E2: set_actor $FBI10 weapon_accuracy_to 70
                end
            end
            0004: $FBI_SPOTTED_PLAYER = 1
        end
    end
    if
        8119:   NOT   car $FBI_VAN1 wrecked
    then
        if and
            8185:   NOT   car $FBI_VAN1 health >= 999
            0038:   $BEEN_DAMAGED_BEFORE == 0
        then
            if and
                8118:   NOT   actor $FBI5 dead
                8118:   NOT   actor $FBI6 dead
            then
                02AA: set_car $FBI_VAN1 immune_to_nonplayer 0
                01CC: actor $FBI5 kill_player $PLAYER
                01CC: actor $FBI6 kill_player $PLAYER
                020A: set_car $FBI_VAN1 door_status_to 1
                0004: $BEEN_DAMAGED_BEFORE = 1
            end
        end
    end
    if
        0038:   $COUNTDOWN_AS2 == 0
    then
        jump @MISSION_ASUKA2_FAILED
    end
end //while
jump @MISSION_ASUKA2_PASSED

:MISSION_ASUKA2_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
return

:MISSION_ASUKA2_PASSED
0004: $UNDER_SURVEILLANCE_COMPLETED = 1
0394: play_music 1
01E3: text_1number_styled 'M_PASS' 15000 5000 ms 1   // MISSION PASSED! $~1~
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 15000
0318: set_latest_mission_passed 'AM2'   // 'UNDER SURVEILLANCE'
030C: set_mission_points += 1
0164: remove_blip $STAUNTON_AMMUNATION_MARKER
0164: remove_blip $STAUNTON_PAYNSPRAY_MARKER
004F: create_thread @ASUKA_MISSION3_LOOP
// if started with DEBUG_MASTERDEBUG on, these are already running
0164: remove_blip $KENJI_MISION_MARKER
02A7: $KENJI_MISION_MARKER = create_icon_marker_and_sphere 14 at 124.062 -1413.0 32.0625
0459: end_thread_named 'KM1'
004F: create_thread @KENJI_MISSION1_LOOP
return

:MISSION_CLEANUP_ASUKA2
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_ASUKA1 = 0
0249: mark_model_as_no_longer_needed #GANG01
0249: mark_model_as_no_longer_needed #GANG02
0249: mark_model_as_no_longer_needed #RUMPO
0164: remove_blip $BLIP1_FBI1
0164: remove_blip $BLIP2_FBI2
0164: remove_blip $BLIP3_FBI3
0164: remove_blip $BLIP4_FBI4
0164: remove_blip $BLIP5_FBI5
0164: remove_blip $BLIP6_FBI6
0164: remove_blip $BLIP7_FBI7
0164: remove_blip $BLIP8_FBI8
0164: remove_blip $BLIP9_FBI9
0164: remove_blip $BLIP10_FBI10
014F: stop_timer $COUNTDOWN_AS2
mission_cleanup
return