//-------------Mission 48-------------
// Originally: Asuka mission 5 'TWO_FACED TANNER'

:M48_TWOFACEDTANNER
03A4: name_thread 'ASUKA5'
054C: use_GXT_table 'ASU5'
058E: set_restart_mission_taxi_destination 118.24 -684.80 21.96 angle 181.0
gosub @MISSION_START_ASUKA5
if
    wasted_or_busted
then
    gosub @MISSION_ASUKA5_FAILED
end
gosub @MISSION_CLEANUP_ASUKA5
end_thread

:MISSION_START_ASUKA5
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_ASUKA1 = 1
wait 0 ms
01F0: set_max_wanted_level_to 5
0004: $CLEARED_TIMER_ONCE_ASUKA5 = 0
0004: $GOT_TO_COORD_ONCE = 0
023C: load_special_actor 1 'PLAYER'
02F3: load_object #CUTOBJ02 'NOTE'
02F3: load_object #CUTOBJ01 'PLAYERH'
0247: request_model #CONDO_IVY
0247: request_model #KMRICNDO01
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CONDO_IVY available
        8248:   NOT   model #KMRICNDO01 available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'A5_K2FT'
0244: set_cutscene_pos 188.062 -636.938 21.5625
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CS_NOTE = create_cutscene_object #CUTOBJ02
02E6: set_cutscene_anim $CS_NOTE 'NOTE'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
0395: clear_area 1 at 188.562 -639.375 22.5625 range 1.0
0055: set_player_coordinates $PLAYER at 188.562 -639.375 22.0
0171: set_player $PLAYER z_angle_to 180.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   2220 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM5_A' 10000 ms 1   // // Maria and I have gone shopping.
while 001A:   4363 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM5_B' 10000 ms 1   // // Our source in the police has informed us that one of our drivers is a strangely animated undercover cop!
while 001A:   11558 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM5_C' 10000 ms 1   // // He's more or less useless out of his car so we've tagged it with a tracer.
while 001A:   16227 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'AM5_D' 10000 ms 1   // // Make him bleed!
while 001A:   17342 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BE: text_clear_all
while 001A:   17666 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
03AD: set_rubbish 1 (visible)
02EA: clear_cutscene
03C8: set_camera_in_front_of_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CONDO_IVY
0249: mark_model_as_no_longer_needed #KMRICNDO01
0247: request_model #ESPERANT
023C: load_special_actor 1 'TANNER'
while true
    if or
        823D:   NOT   special_actor 1 loaded
        8248:   NOT   model #ESPERANT available
    jf break
    wait 0 ms
end
03CF: load_wav 'A5_A' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
00A5: $TANNER_CAR = create_car #ESPERANT at 85.875 -1396.5 32.0
053F: set car $TANNER_CAR tires vulnerable  0
0175: set_car $TANNER_CAR z_angle_to 90.0
02AA: set_car $TANNER_CAR immune_to_nonplayer 1
020A: set_car $TANNER_CAR door_status_to 3
03FB: car $TANNER_CAR bind_to_current_island 1 (true)
0428: set_car_avoid_level_transitions $TANNER_CAR flag 1
018A: $BLIP1_AS5 = create_checkpoint_at 79.0 -1378.0 -100.0
018B: change_blip $BLIP1_AS5 display 2

while 819E:   NOT   player $PLAYER stopped 1 in_cube 76.75 -1375.25 31.5625 82.0 -1381.88 34.5625  // never used in VC
    wait 0 ms
    if
        0119:   car $TANNER_CAR wrecked
    then
        jump @MISSION_ASUKA5_FAILED
    end
    if or
        8185:   NOT   car $TANNER_CAR health >= 999
        80B0:   NOT   car $TANNER_CAR 0 in_rectangle 82.062 -1398.0 90.375 -1394.88
    then
        00BC: print_now 'AM5_1' 5000 ms 1   // // Tanner's on to you!
        jump @MISSION_ASUKA5_FAILED
    end
end
0164: remove_blip $BLIP1_AS5
0186: $BLIP2_AS5 = create_marker_above_car $TANNER_CAR
01B4: set_player $PLAYER can_move 0 (frozen)
0395: clear_area 1 at 92.875 -1392.6899 27.0625 range 20.0
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
02A3: toggle_widescreen 1 (on)
009A: $TANNER = create_actor 21 #SPECIAL01 at 101.5 -1399.75 39.6875
0319: set_actor $TANNER running 1
015F: set_camera_position 102.375 -1387.38 36.875 0.0 0.0 0.0
0159: camera_on_ped $TANNER 15 2
0006: 17@ = 0
0239: actor $TANNER run_to 100.688 -1388.75
while 8126:   NOT   actor $TANNER walking
    wait 0 ms
    if
        0118:   actor $TANNER dead
    then
        jump @MISSION_ASUKA5_PASSED
    end
    if
        0119:   car $TANNER_CAR wrecked
    then
        jump @MISSION_ASUKA5_FAILED
    end
    if
        0019:   17@ > 10000
    then
        if
            8118:   NOT   actor $JOEY1_MIKELIPS dead
        then
            00A1: put_actor $TANNER at 100.688 -1388.75 -100.0
        end
    end
end
0006: 17@ = 0
0239: actor $TANNER run_to 88.5 -1388.75
while 8126:   NOT   actor $TANNER walking
    wait 0 ms
    if
        0118:   actor $TANNER dead
    then
        jump @MISSION_ASUKA5_PASSED
    end
    if
        0119:   car $TANNER_CAR wrecked
    then
        jump @MISSION_ASUKA5_FAILED
    end
    if
        0019:   17@ > 10000
    then
        if
            8118:   NOT   actor $JOEY1_MIKELIPS dead
        then
            00A1: put_actor $TANNER at 92.25 -1388.5601 31.0
        end
    end
end
0006: 17@ = 0
0239: actor $TANNER run_to 88.562 -1393.0601
while 8126:   NOT   actor $TANNER walking
    wait 0 ms
    if
        0118:   actor $TANNER dead
    then
        jump @MISSION_ASUKA5_PASSED
    end
    if
        0119:   car $TANNER_CAR wrecked
    then
        jump @MISSION_ASUKA5_FAILED
    end
    if
        0019:   17@ > 10000
    then
        if
            8118:   NOT   actor $JOEY1_MIKELIPS dead
        then
            00A1: put_actor $TANNER at 88.562 -1393.0601 31.0
        end
    end
end
015F: set_camera_position 101.0 -1390.75 37.0 0.0 0.0 0.0
0159: camera_on_ped $TANNER 15 1
01D5: actor $TANNER go_to_and_drive_car $TANNER_CAR
while 80DB:   NOT   actor $TANNER in_car $TANNER_CAR
    wait 0 ms
    if
        0118:   actor $TANNER dead
    then
        jump @MISSION_ASUKA5_PASSED
    end
    if
        0119:   car $TANNER_CAR wrecked
    then
        jump @MISSION_ASUKA5_FAILED
    end
end
if
    0118:   actor $TANNER dead
then
    jump @MISSION_ASUKA5_PASSED
end
0395: clear_area 1 at 92.875 -1392.6899 27.0625 range 20.0
0158: camera_on_vehicle $TANNER_CAR 15 1
03C4: set_status_text_to $TEST_TANNER_HEALTH_COUNTER 1 (bar)  'DAM'   // // Damage
gosub @TANNER_HEALTH
02C2: car $TANNER_CAR drive_to_point -15.125 -1388.5601 -100.0
00AF: set_car $TANNER_CAR mission 13  // MISSION_GOTOCOORDS_STRAIGHT_ACCURATE
00AD: set_car $TANNER_CAR max_speed_to 20.0
00AE: set_car $TANNER_CAR driving_style 2  // DRIVINGMODE_AVOIDCARS
wait 1000 ms
02EB: restore_camera_jumpcut
01B4: set_player $PLAYER can_move 1 (unfrozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
02A3: toggle_widescreen 0 (off)
if
    8119:   NOT   car $TANNER_CAR wrecked
then
    while 0185:   car $TANNER_CAR health >= 999
        wait 0 ms
        if
            0118:   actor $TANNER dead
        then
            jump @MISSION_ASUKA5_PASSED
        end
        if and
            0119:   car $TANNER_CAR wrecked
            0038:   $CLEARED_TIMER_ONCE_ASUKA5 == 0
        then
            0151: remove_status_text $TEST_TANNER_HEALTH_COUNTER
            0004: $CLEARED_TIMER_ONCE_ASUKA5 = 1
        end
        if
            81AD:   NOT   car $TANNER_CAR 0 near_point -15.125 -1388.5601 8.0 8.0
        then
            if
                0038:   $GOT_TO_COORD_ONCE == 0
            then
                02C2: car $TANNER_CAR drive_to_point -15.125 -1388.5601 -100.0
                00AF: set_car $TANNER_CAR mission 13  // MISSION_GOTOCOORDS_STRAIGHT_ACCURATE
            end
        else
            00A8: set_car $TANNER_CAR to_psycho_driver
            0004: $GOT_TO_COORD_ONCE = 1
        end
        if and
            01F4:   car $TANNER_CAR flipped
            01C1:   car $TANNER_CAR stopped
        then
            jump @TANNER_SHITS_IT
        end
        gosub @TANNER_HEALTH
    end //while
end
if
    0118:   actor $TANNER dead
then
    jump @MISSION_ASUKA5_PASSED
end
if and
    0119:   car $TANNER_CAR wrecked
    0038:   $CLEARED_TIMER_ONCE_ASUKA5 == 0
then
    0151: remove_status_text $TEST_TANNER_HEALTH_COUNTER
    0004: $CLEARED_TIMER_ONCE_ASUKA5 = 1
end
03D1: play_wav 1
00AD: set_car $TANNER_CAR max_speed_to 30.0
010E: set_player $PLAYER minimum_wanted_level_to 4
if
    8119:   NOT   car $TANNER_CAR wrecked
then
    0227: $OLD_TANNER_HEALTH = car $TANNER_CAR health
end
while 0185:   car $TANNER_CAR health >= 300
    wait 0 ms
    if
        0118:   actor $TANNER dead
    then
        jump @MISSION_ASUKA5_PASSED
    end
    if and
        0119:   car $TANNER_CAR wrecked
        0038:   $CLEARED_TIMER_ONCE_ASUKA5 == 0
    then
        0151: remove_status_text $TEST_TANNER_HEALTH_COUNTER
        0004: $CLEARED_TIMER_ONCE_ASUKA5 = 1
    end
    if
        81AD:   NOT   car $TANNER_CAR 0 near_point -15.125 -1388.5601 6.0 6.0
    then
        if
            0038:   $GOT_TO_COORD_ONCE == 0
        then
            02C2: car $TANNER_CAR drive_to_point -15.125 -1388.5601 -100.0
            00AF: set_car $TANNER_CAR mission 13  // MISSION_GOTOCOORDS_STRAIGHT_ACCURATE
        end
    else
        00A8: set_car $TANNER_CAR to_psycho_driver
        0004: $GOT_TO_COORD_ONCE = 1
    end
    if and
        01F4:   car $TANNER_CAR flipped
        01C1:   car $TANNER_CAR stopped
    then
        jump @TANNER_SHITS_IT
    end
    gosub @TANNER_HEALTH
end //while

:TANNER_SHITS_IT
if
    0118:   actor $TANNER dead
then
    jump @MISSION_ASUKA5_PASSED
end
0151: remove_status_text $TEST_TANNER_HEALTH_COUNTER
0164: remove_blip $BLIP2_AS5
020A: set_car $TANNER_CAR door_status_to 1
01D3: actor $TANNER leave_car $TANNER_CAR
0187: $BLIP3_AS5 = create_marker_above_actor $TANNER
00AD: set_car $TANNER_CAR max_speed_to 0.0
00AF: set_car $TANNER_CAR mission 11  // MISSION_STOP_FOREVER
while 00DB:   actor $TANNER in_car $TANNER_CAR
    wait 0 ms
    if
        0118:   actor $TANNER dead
    then
        jump @MISSION_ASUKA5_PASSED
    end
    if and
        0119:   car $TANNER_CAR wrecked
        0038:   $CLEARED_TIMER_ONCE_ASUKA5 == 0
    then
        0151: remove_status_text $TEST_TANNER_HEALTH_COUNTER
        0004: $CLEARED_TIMER_ONCE_ASUKA5 = 1
    end
end
if
    0118:   actor $TANNER dead
then
    jump @MISSION_ASUKA5_PASSED
end
02A9: set_actor $TANNER immune_to_nonplayer 1
if and
    0119:   car $TANNER_CAR wrecked
    0038:   $CLEARED_TIMER_ONCE_ASUKA5 == 0
then
    0151: remove_status_text $TEST_TANNER_HEALTH_COUNTER
    0004: $CLEARED_TIMER_ONCE_ASUKA5 = 1
end
01D0: actor $TANNER avoid_player $PLAYER
0245: actor $TANNER walk_style =  50    //ANIM_PANIC_CHUNKYPED
while 8118:   NOT   actor $TANNER dead
    wait 0 ms
    if and
        0119:   car $TANNER_CAR wrecked
        0038:   $CLEARED_TIMER_ONCE_ASUKA5 == 0
    then
        0151: remove_status_text $TEST_TANNER_HEALTH_COUNTER
        0004: $CLEARED_TIMER_ONCE_ASUKA5 = 1
    end
end
jump @MISSION_ASUKA5_PASSED

:MISSION_ASUKA5_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // // MISSION FAILED!
return

:MISSION_ASUKA5_PASSED
if
    02BD:   debug_mode == DEBUG_MASTERDEBUG
then
    01F0: set_max_wanted_level_to 6
end
0004: $TWO_FACED_TANNER_COMPLETED = 1
0394: play_music 1
01E3: text_1number_styled 'M_PASS' 20000 5000 ms 1   // // MISSION PASSED! $~1~
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 20000
0164: remove_blip $ASUKA_MISSION_MARKER
0318: set_latest_mission_passed 'AM5'   // // 'TWO_FACED TANNER'
030C: set_mission_points += 1
return

:MISSION_CLEANUP_ASUKA5
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_ASUKA1 = 0
0249: mark_model_as_no_longer_needed #ESPERANT
0296: unload_special_actor 1
if
    8118:   NOT   actor $TANNER dead
then
    034F: remove_char_elegantly $TANNER
end
0164: remove_blip $BLIP1_AS5
0164: remove_blip $BLIP2_AS5
0164: remove_blip $BLIP3_AS5
0151: remove_status_text $TEST_TANNER_HEALTH_COUNTER
mission_cleanup
return

:TANNER_HEALTH
if
    8119:   NOT   car $TANNER_CAR wrecked
then
    0227: $TEST_TANNER_HEALTH_COUNTER = car $TANNER_CAR health
    if
        001C:   $OLD_TANNER_HEALTH > $TEST_TANNER_HEALTH_COUNTER
    then
        010E: set_player $PLAYER minimum_wanted_level_to 4
    end
    0084: $OLD_TANNER_HEALTH = $TEST_TANNER_HEALTH_COUNTER
    0004: $TEST_TANNER_HEALTH_COUNTER2 = 1000
    0060: $TEST_TANNER_HEALTH_COUNTER2 -= $TEST_TANNER_HEALTH_COUNTER
    if
        0018:   $TEST_TANNER_HEALTH_COUNTER2 > 700
    then
        0004: $TEST_TANNER_HEALTH_COUNTER2 = 700
    end
    0084: $TEST_TANNER_HEALTH_COUNTER = $TEST_TANNER_HEALTH_COUNTER2
    0014: $TEST_TANNER_HEALTH_COUNTER /= 7
end
return
