//-------------Mission 80-------------
// 'Motorbike challenges'
// (Loosely) based on 'PCJ Playground' and 'Little Haiti Chopper Checkpoint'

:M80_BIKECHALLENGE
03A4: name_thread 'BIKEMIS'
054C: use_GXT_table 'T4X4'
gosub @MISSION_START_BIKE
if
	wasted_or_busted
then
    gosub @MISSION_BIKE_FAILED
end
gosub @MISSION_CLEANUP_BIKE
end_thread

:MISSION_START_BIKE
if and
    $ALLEYS_ANGELS_COMPLETED == 0
    $BIKE_ISLAND == 0
then
    0317: increment_mission_attempts
end
if and
    $COLLEGE_TOUR_COMPLETED == 0
    $BIKE_ISLAND == 1
then
    0317: increment_mission_attempts
end
if and
    $AIRPORT_AGGRESSION_COMPLETED == 0
    $BIKE_ISLAND == 2
then
    0317: increment_mission_attempts
end
0004: $FLAG_PLAYER_ON_MISSION = 1
wait  0 ms
0004:  $CUR_COORD =  0
0006: 0@ = 0
0006: 2@ = 0
00BC: print_now 'T4X4_5A'  15000 ms  1 // Test your skills with the Bike, see how quickly you can complete the course.
03C0: $BIKE_TYPE = actor $SCRIPT_CONTROLLED_PLAYER car

if
    0038:   $BIKE_ISLAND == 0
then
    0004: $BIKE_COORDS = @ALLEYS_ANGELS_COORDS
    0004: $NUM_COORDS = 26
    //0004: $BIKE_TYPE = #ANGEL
    0004: $BIKE_REWARD = 5000
    0004: $BIKE_TIME_LIMIT =  120000  // 2 minutes
    jump @BIKE_START
end
if
    0038:   $BIKE_ISLAND == 1
then
    0004: $BIKE_COORDS = @COLLEGE_TOUR_COORDS
    0004: $NUM_COORDS = 34
    //0004: $BIKE_TYPE = #SANCHEZ
    0004: $BIKE_REWARD = 5000
    0004: $BIKE_TIME_LIMIT =  150000  // 2.5 minutes
    jump @BIKE_START
end
if
    0038:   $BIKE_ISLAND == 2
then
    0004: $BIKE_COORDS = @AIRPORT_AGGRESSION_COORDS
    0004: $NUM_COORDS = 57
    //0004: $BIKE_TYPE = #PCJ600
    0004: $BIKE_REWARD = 5000
    0004: $BIKE_TIME_LIMIT =  360000  // 6 minutes
    jump @BIKE_START
end
end_thread

:BIKE_START
03C3: set_timer_with_text_to  $BIKE_TIME_LIMIT type  1 text 'T4X4_5B' // TIME:
01BD: $BIKE_TIMER_START = current_time_in_ms

:BIKE_LOOP
//wait 0 ms
if
    801C:  NOT  $NUM_COORDS > $CUR_COORD
then
    jump @BIKE_GET_TIME
end

005c: 0@ += $CUR_COORD
0012: 0@ *= -37
005c: 0@ += $BIKE_COORDS
//01E4: text 1number lowpriority 'A_TIME' 0@  1000 ms  1
jump 0@

:AIRPORT_AGGRESSION_COORDS
// Add
0005: $BIKERS_X = -1070.71
0005: $BIKERS_Y = -539.1329
0005: $BIKERS_Z = 14.23208
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -1070.486
0005: $BIKERS_Y = -582.9036
0005: $BIKERS_Z = 14.23573
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -1070.482
0005: $BIKERS_Y = -645.2526
0005: $BIKERS_Z = 14.23584
jump @BIKE_MAKE_COORDS

// Add - Replace
//0005: $BIKERS_X = -1051.513
//0005: $BIKERS_Y = -657.1052
//0005: $BIKERS_Z = 16.21865
//jump @BIKE_MAKE_COORDS

// With
0005: $BIKERS_X = -1046.177
0005: $BIKERS_Y = -671.0533
0005: $BIKERS_Z = 17.28572
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -1009.504
0005: $BIKERS_Y = -661.9672
0005: $BIKERS_Z = 24.38259
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -978.2298
0005: $BIKERS_Y = -635.2673
0005: $BIKERS_Z = 24.32102
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -947.0762
0005: $BIKERS_Y = -578.1423
0005: $BIKERS_Z = 24.03214
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -941.3722
0005: $BIKERS_Y = -537.7734
0005: $BIKERS_Z = 22.79166
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -967.2513
0005: $BIKERS_Y = -500.459
0005: $BIKERS_Z = 28.95376
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -990.6125
0005: $BIKERS_Y = -413.9779
0005: $BIKERS_Z = 24.07325
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1015.433
0005: $BIKERS_Y = -490.8354
0005: $BIKERS_Z = 25.17741
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1037.119
0005: $BIKERS_Y = -555.02
0005: $BIKERS_Z = 26.90478
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1038.878
0005: $BIKERS_Y = -605.3829
0005: $BIKERS_Z = 21.9984
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1093.05
0005: $BIKERS_Y = -638.6996
0005: $BIKERS_Z = 16.85731
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1099.724
0005: $BIKERS_Y = -597.8374
0005: $BIKERS_Z = 16.8573
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1084.96
0005: $BIKERS_Y = -544.9719
0005: $BIKERS_Z = 14.38328
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1099.841
0005: $BIKERS_Y = -498.5577
0005: $BIKERS_Z = 16.85896
jump @BIKE_MAKE_COORDS

// Replace
//0005: $BIKERS_X = -1094.889
//0005: $BIKERS_Y = -444.9826
//0005: $BIKERS_Z = 16.12186
//jump @BIKE_MAKE_COORDS

// With
0005: $BIKERS_X = -1103.704
0005: $BIKERS_Y = -442.422
0005: $BIKERS_Z = 16.452
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -1169.329
0005: $BIKERS_Y = -442.2622
0005: $BIKERS_Z = 16.64223
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1224.114
0005: $BIKERS_Y = -450.1807
0005: $BIKERS_Z = 16.62935
jump @BIKE_MAKE_COORDS

// Replace
//0005: $BIKERS_X = -1183.617
//0005: $BIKERS_Y = -632.5894
//0005: $BIKERS_Z = 19.3655
//jump @BIKE_MAKE_COORDS

// With
//0005: $BIKERS_X = -1183.412
//0005: $BIKERS_Y = -634.8092
//0005: $BIKERS_Z = 20.2049
//jump @BIKE_MAKE_COORDS

// Again
0005: $BIKERS_X = -1182.033
0005: $BIKERS_Y = -642.5072
0005: $BIKERS_Z = 21.16159
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -1183.005
0005: $BIKERS_Y = -678.5187
0005: $BIKERS_Z = 20.8
jump @BIKE_MAKE_COORDS

// Replace
//0005: $BIKERS_X = -1215.784
//0005: $BIKERS_Y = -712.7156
//0005: $BIKERS_Z = 20.26139
//jump @BIKE_MAKE_COORDS

// With
//0005: $BIKERS_X = -1216.789
//0005: $BIKERS_Y = -718.8401
//0005: $BIKERS_Z = 21.47421
//jump @BIKE_MAKE_COORDS

// Again
0005: $BIKERS_X = -1215.62
0005: $BIKERS_Y = -720.2772
0005: $BIKERS_Z = 22.06518
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1196.396
0005: $BIKERS_Y = -779.9675
0005: $BIKERS_Z = 16.30512
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1351.277
0005: $BIKERS_Y = -853.4147
0005: $BIKERS_Z = 16.61973
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1158.019
0005: $BIKERS_Y = -876.0634
0005: $BIKERS_Z = 16.62319
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1158.129
0005: $BIKERS_Y = -971.6228
0005: $BIKERS_Z = 16.78159
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1397.905
0005: $BIKERS_Y = -972.631
0005: $BIKERS_Z = 16.7635
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1404.758
0005: $BIKERS_Y = -888.9863
0005: $BIKERS_Z = 16.63803
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1363.303
0005: $BIKERS_Y = -857.1381
0005: $BIKERS_Z = 16.47318
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1514.174
0005: $BIKERS_Y = -821.8722
0005: $BIKERS_Z = 16.63859
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1614.518
0005: $BIKERS_Y = -888.9416
0005: $BIKERS_Z = 16.63091
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1619.357
0005: $BIKERS_Y = -956.1227
0005: $BIKERS_Z = 16.64551
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1762.557
0005: $BIKERS_Y = -972.5121
0005: $BIKERS_Z = 16.37247
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1917.936
0005: $BIKERS_Y = -972.7158
0005: $BIKERS_Z = 16.36877
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1877.76
0005: $BIKERS_Y = -946.8181
0005: $BIKERS_Z = 20.03131
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1877.048
0005: $BIKERS_Y = -926.9174
0005: $BIKERS_Z = 20.0445
jump @BIKE_MAKE_COORDS

// Replace
//0005: $BIKERS_X = -1891.362
//0005: $BIKERS_Y = -875.223
//0005: $BIKERS_Z = 22.4087
//jump @BIKE_MAKE_COORDS

// With
0005: $BIKERS_X = -1889.789
0005: $BIKERS_Y = -867.1462
0005: $BIKERS_Z = 24.68909
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1878.94
0005: $BIKERS_Y = -818.463
0005: $BIKERS_Z = 16.64268
jump @BIKE_MAKE_COORDS

// Replace
//0005: $BIKERS_X = -1777.013
//0005: $BIKERS_Y = -783.6058
//0005: $BIKERS_Z = 18.15979
//jump @BIKE_MAKE_COORDS

// With
0005: $BIKERS_X = -1757.684
0005: $BIKERS_Y = -771.9256
0005: $BIKERS_Z = 20.86658
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1735.524
0005: $BIKERS_Y = -712.5634
0005: $BIKERS_Z = 16.64247
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1713.452
0005: $BIKERS_Y = -593.327
0005: $BIKERS_Z = 24.03834
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1715.376
0005: $BIKERS_Y = -448.031
0005: $BIKERS_Z = 28.70986
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1661.137
0005: $BIKERS_Y = -426.18
0005: $BIKERS_Z = 48.44915
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1578.969
0005: $BIKERS_Y = -369.241
0005: $BIKERS_Z = 68.37883
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1574.842
0005: $BIKERS_Y = -409.089
0005: $BIKERS_Z = 51.52085
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1542.477
0005: $BIKERS_Y = -507.153
0005: $BIKERS_Z = 16.63818
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1540.202
0005: $BIKERS_Y = -535.9384
0005: $BIKERS_Z = 16.63852
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1492.57
0005: $BIKERS_Y = -548.1092
0005: $BIKERS_Z = 16.63949
jump @BIKE_MAKE_COORDS

// Replace
//0005: $BIKERS_X = -1427.73
//0005: $BIKERS_Y = -566.3157
//0005: $BIKERS_Z = 18.03905
//jump @BIKE_MAKE_COORDS

// With
//0005: $BIKERS_X = -1427.022
//0005: $BIKERS_Y = -569.4914
//0005: $BIKERS_Z = 19.33254
//jump @BIKE_MAKE_COORDS

// Again
0005: $BIKERS_X = -1427.745
0005: $BIKERS_Y = -568.5732
0005: $BIKERS_Z = 19.24334
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1428.196
0005: $BIKERS_Y = -587.1387
0005: $BIKERS_Z = 16.6033
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1501.9
0005: $BIKERS_Y = -570.1901
0005: $BIKERS_Z = 16.49158
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1511.066
0005: $BIKERS_Y = -570.4712
0005: $BIKERS_Z = 21.05934
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1517.19
0005: $BIKERS_Y = -570.9488
0005: $BIKERS_Z = 23.84234
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1558.0
0005: $BIKERS_Y = -574.1878
0005: $BIKERS_Z = 16.59665
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1605.325
0005: $BIKERS_Y = -544.4454
0005: $BIKERS_Z = 16.64102
jump @BIKE_MAKE_COORDS

0005: $BIKERS_X = -1603.246
0005: $BIKERS_Y = -507.2127
0005: $BIKERS_Z = 16.64209
jump @BIKE_MAKE_COORDS


:COLLEGE_TOUR_COORDS
// Add
0005: $BIKERS_X = -34.6642
0005: $BIKERS_Y = -299.1055
0005: $BIKERS_Z = 22.6901
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 0.6985
0005: $BIKERS_Y = -359.304
0005: $BIKERS_Z = 23.2281
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 29.8514
0005: $BIKERS_Y = -339.6639
0005: $BIKERS_Z = 22.3565
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 39.859
0005: $BIKERS_Y = -315.5563
0005: $BIKERS_Z = 25.5662
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 39.8917
0005: $BIKERS_Y = -296.2517
0005: $BIKERS_Z = 23.7814
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 36.4742
0005: $BIKERS_Y = -263.828
0005: $BIKERS_Z = 23.7809
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 18.5689
0005: $BIKERS_Y = -239.106
0005: $BIKERS_Z = 21.7885
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -4.9698
0005: $BIKERS_Y = -145.5262
0005: $BIKERS_Z = 17.2389
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 26.8987
0005: $BIKERS_Y = -71.7394
0005: $BIKERS_Z = 21.9689
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 96.9135
0005: $BIKERS_Y = -49.7124
0005: $BIKERS_Z = 25.0849
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 118.9265
0005: $BIKERS_Y = -48.586
0005: $BIKERS_Z = 26.1263
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 163.0797
0005: $BIKERS_Y = 5.6058
0005: $BIKERS_Z = 11.0151
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 38.5214
0005: $BIKERS_Y = 84.4077
0005: $BIKERS_Z = 20.8653
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -143.0259
0005: $BIKERS_Y = 91.7502
0005: $BIKERS_Z = 21.6524
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -171.5584
0005: $BIKERS_Y = 135.1554
0005: $BIKERS_Z = 19.3462
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -208.7652
0005: $BIKERS_Y = 166.2427
0005: $BIKERS_Z = 17.2221
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -251.2359
0005: $BIKERS_Y = 184.1941
0005: $BIKERS_Z = 11.3682
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -346.8617
0005: $BIKERS_Y = 177.045
0005: $BIKERS_Z = 11.255
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -435.0186
0005: $BIKERS_Y = 126.6448
0005: $BIKERS_Z = 8.6235
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -431.8036
0005: $BIKERS_Y = 105.5713
0005: $BIKERS_Z = 17.3073
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -427.4793
0005: $BIKERS_Y = 83.003
0005: $BIKERS_Z = 21.7976
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -335.4502
0005: $BIKERS_Y = 75.2225
0005: $BIKERS_Z = 21.6463
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -239.9254
0005: $BIKERS_Y = 0.3531
0005: $BIKERS_Z = 21.8015
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -210.7567
0005: $BIKERS_Y = -35.4655
0005: $BIKERS_Z = 21.8497
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -166.2208
0005: $BIKERS_Y = -36.075
0005: $BIKERS_Z = 21.8444
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -66.8498
0005: $BIKERS_Y = 2.0745
0005: $BIKERS_Z = 21.8507
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 8.9074
0005: $BIKERS_Y = 33.2144
0005: $BIKERS_Z = 21.4729
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 53.573
0005: $BIKERS_Y = 4.534
0005: $BIKERS_Z = 16.9068
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 4.3805
0005: $BIKERS_Y = -52.7498
0005: $BIKERS_Z = 21.058
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -94.8252
0005: $BIKERS_Y = -63.856
0005: $BIKERS_Z = 26.5019
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -103.8493
0005: $BIKERS_Y = -92.0283
0005: $BIKERS_Z = 19.526
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -105.6387
0005: $BIKERS_Y = -125.2175
0005: $BIKERS_Z = 9.47
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -96.2432
0005: $BIKERS_Y = -143.16
0005: $BIKERS_Z = 3.9339
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = -87.9256
0005: $BIKERS_Y = -153.216
0005: $BIKERS_Z = 3.9342
jump @BIKE_MAKE_COORDS


:ALLEYS_ANGELS_COORDS
// Add
0005: $BIKERS_X = 947.25
0005: $BIKERS_Y = -86.62
0005: $BIKERS_Z = 19.99
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 978.74
0005: $BIKERS_Y = -83.5842
0005: $BIKERS_Z = 21.7734
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 985.06
0005: $BIKERS_Y = -102.11
0005: $BIKERS_Z = 22.36
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 985.2881
0005: $BIKERS_Y = -150.1381
0005: $BIKERS_Z = 20.7666
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 985.507
0005: $BIKERS_Y = -220.9131
0005: $BIKERS_Z = 20.778
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 985.6282
0005: $BIKERS_Y = -346.1071
0005: $BIKERS_Z = 20.7779
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 985.6531
0005: $BIKERS_Y = -544.7043
0005: $BIKERS_Z = 20.773
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 960.6295
0005: $BIKERS_Y = -568.0419
0005: $BIKERS_Z = 19.9735
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 902.1375
0005: $BIKERS_Y = -565.5785
0005: $BIKERS_Z = 17.7031
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 869.7067
0005: $BIKERS_Y = -565.1983
0005: $BIKERS_Z = 25.4667
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 860.6325
0005: $BIKERS_Y = -460.5916
0005: $BIKERS_Z = 30.4148
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 868.7637
0005: $BIKERS_Y = -389.8271
0005: $BIKERS_Z = 30.4594
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 938.1895
0005: $BIKERS_Y = -382.3839
0005: $BIKERS_Z = 38.5594
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 982.181
0005: $BIKERS_Y = -384.032
0005: $BIKERS_Z = 47.0561
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 1021.5521
0005: $BIKERS_Y = -388.7724
0005: $BIKERS_Z = 55.5483
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 1049.0504
0005: $BIKERS_Y = -441.9054
0005: $BIKERS_Z = 55.5587
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 1069.1394
0005: $BIKERS_Y = -446.0193
0005: $BIKERS_Z = 54.0556
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 1073.2837
0005: $BIKERS_Y = -376.7421
0005: $BIKERS_Z = 55.0328
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 1067.5789
0005: $BIKERS_Y = -293.5495
0005: $BIKERS_Z = 55.9588
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 1017.9881
0005: $BIKERS_Y = -255.6596
0005: $BIKERS_Z = 55.4687
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 966.8081
0005: $BIKERS_Y = -248.0031
0005: $BIKERS_Z = 58.7811
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 891.7999
0005: $BIKERS_Y = -246.1391
0005: $BIKERS_Z = 41.5313
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 865.2187
0005: $BIKERS_Y = -232.0577
0005: $BIKERS_Z = 30.2735
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 860.8849
0005: $BIKERS_Y = -107.9367
0005: $BIKERS_Z = 20.2267
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 870.0856
0005: $BIKERS_Y = -49.5732
0005: $BIKERS_Z = 15.3055
jump @BIKE_MAKE_COORDS

// Add
0005: $BIKERS_X = 950.0348
0005: $BIKERS_Y = -50.6235
0005: $BIKERS_Z = 21.5348

:BIKE_MAKE_COORDS
if
    0039:    2@ ==  0
then
    018A:  $CHECKPOINT1 = create_checkpoint_at  $BIKERS_X  $BIKERS_Y  $BIKERS_Z
    018B: change_blip $CHECKPOINT1 display 2
    0086: $BIKER_TX = $BIKERS_X
    0086: $BIKER_TY = $BIKERS_Y
    0086: $BIKER_TZ = $BIKERS_Z
    008B:  1@ = $CUR_COORD
    000A:  1@ +=  1
    0006: 0@ = 1
    0006: 2@ = 1
    if
        003C:   $NUM_COORDS == 1@
    then
        jump @BIKE_LOOP2
    end
    jump @BIKE_LOOP
end
018A:  $CHECKPOINT2 = create_checkpoint_at  $BIKERS_X  $BIKERS_Y  $BIKERS_Z
018B: change_blip $CHECKPOINT2 display 2
0168: show_on_radar  $CHECKPOINT2  2
0166: set_marker  $CHECKPOINT2 brightness_to  1
0006: 0@ = 0
0006: 2@ = 0
008B:  1@ = $CUR_COORD
000A:  1@ +=  1
if
    003c:   $NUM_COORDS == 1@
then
    000E:  1@ -=  1
    jump @BIKE_LOOP2
end
000E:  1@ -=  1

:BIKE_LOOP2
wait 0 ms
if
    0 >= $BIKE_TIME_LIMIT
then
    jump @MISSION_BIKE_FAILED
end
if
    00DC:   player $PLAYER driving $BIKE_TYPE
then
    if
        00F7:   player  $PLAYER  0 ()near_point_in_car  $BIKER_TX  $BIKER_TY  $BIKER_TZ radius  2.5  2.5  2.5
    then
        018C: play_sound  1 at  0.0  0.0  0.0
        0008:  $CUR_COORD +=  1
        0164: remove_blip  $CHECKPOINT1
        if
            003A:  $CUR_COORD == $NUM_COORDS
        then
            jump @BIKE_LOOP
        end
        0164: remove_blip  $CHECKPOINT2
        // Only disable  it if it existed
        jump @BIKE_LOOP
    end
    if
        003A:   $NUM_COORDS == 1@
    then
        024F: create_corona  1.0  5  0 with_color  200  0  0 at_point  $BIKER_TX  $BIKER_TY  $BIKER_TZ
        jump @BIKE_LOOP2
    end
    024F: create_corona  1.0  5  0 with_color   0  200  200 at_point  $BIKER_TX  $BIKER_TY  $BIKER_TZ
    jump @BIKE_LOOP2
end
0164: remove_blip  $CHECKPOINT1
if
    803A:   NOT $CUR_COORD == $NUM_COORDS
then
    0164: remove_blip  $CHECKPOINT2
end
0186: 9@ = create_marker_above_car $BIKE_TYPE
// Made it harder, you have to do it in one go, otherwise it's dead easy!
0006: 16@ = 0

:BIKE_FELL_OFF
0006: 10@ = 16000  //bumped it up to 15 seconds
0062: 10@ -= 16@
0016: 10@ /= 1000
if
    8019:  NOT  10@ >  0
then
    jump @BIKE_TOO_SLOW
end
if
    0119:   car $BIKE_TYPE wrecked
then
    jump @MISSION_BIKE_FAILED
end
if
    80DC:   NOT player $PLAYER driving $BIKE_TYPE
then
    wait 0 ms
    if
        0038:   $BIKE_ISLAND ==  0
    then
        if
            0019:   10@ > 1
        then
            01E5: text_1number_highpriority 'T4X4_5C'  10@  10 ms  1 // You have ~1~ seconds to get back on the Angel!
        else
            01E5: text_1number_highpriority 'T4X4_5D'  10@  10 ms  1 // You have ~1~ second to get back on the Angel!
        end
        jump @BIKE_FELL_OFF
    end
    if
        0038:   $BIKE_ISLAND ==  1
    then
        if
            0019:   10@ > 1
        then
            01E5: text_1number_highpriority 'T4X4_5E'  10@  10 ms  1 // You have ~1~ seconds to get back on the Sanchez!
        else
            01E5: text_1number_highpriority 'T4X4_5F'  10@  10 ms  1 // You have ~1~ second to get back on the Sanchez!
        end
        jump @BIKE_FELL_OFF
    end
    if
        0038:   $BIKE_ISLAND ==  2
    then
        if
            0019:   10@ > 1
        then
            01E5: text_1number_highpriority 'T4X4_5G'  10@  10 ms  1 // You have ~1~ seconds to get back on the PCJ 600!
        else
            01E5: text_1number_highpriority 'T4X4_5H'  10@  10 ms  1 // You have ~1~ second to get back on the PCJ 600!
        end
        jump @BIKE_FELL_OFF
    end
end
00BE: text_clear_all
0164: remove_blip 9@
018A:  $CHECKPOINT1 = create_checkpoint_at  $BIKER_TX  $BIKER_TY  $BIKER_TZ
018B: change_blip $CHECKPOINT1 display 2
008B:  3@ = $CUR_COORD
000A:  3@ +=  1
if
    003C:   $NUM_COORDS == 3@
then
else
end
if
    803C:   not $NUM_COORDS == 3@
then
    018A:  $CHECKPOINT2 = create_checkpoint_at  $BIKERS_X  $BIKERS_Y  $BIKERS_Z
    018B: change_blip $CHECKPOINT2 display 2
    0168: show_on_radar  $CHECKPOINT2  2
    0166: set_marker  $CHECKPOINT2 brightness_to  1
    if
        003c:   $NUM_COORDS == 3@
    then
    else
    end
end
jump @BIKE_LOOP2

:BIKE_TOO_SLOW
00BC: print_now 'T4X4_F'  3000 ms  1 // ~o~You bailed! Too tough for you?!

:MISSION_BIKE_FAILED
00BA: text_styled 'M_FAIL'  2000 ms  1 // MISSION FAILED!
return

:MISSION_CLEANUP_BIKE
0004: $FLAG_PLAYER_ON_MISSION = 0
014F: stop_timer  $BIKE_TIME_LIMIT
mission_cleanup
0164: remove_blip 9@
0164: remove_blip $CHECKPOINT1
0164: remove_blip $CHECKPOINT2
return

:BIKE_GET_TIME
01BD: $BIKE_TIMER_END = current_time_in_ms
0060: $BIKE_TIMER_END -= $BIKE_TIMER_START
0014: $BIKE_TIMER_END /= 1000  //  total time for race in seconds

0084: $RACE_TIME_MIN =  $BIKE_TIMER_END
0014: $RACE_TIME_MIN /=  60

0084: $RACE_TEMP_SEC =  $RACE_TIME_MIN
0010: $RACE_TEMP_SEC *=  60

0084: $RACE_TIME_SEC =  $BIKE_TIMER_END
0060: $RACE_TIME_SEC -=  $RACE_TEMP_SEC

if
    0038:   $BIKE_ISLAND == 0
then
    if
        0038:   $ALLEYS_ANGELS_COMPLETED == 0
    then
        0084:  $ALLEYS_ANGELS_BEST_TIME = $BIKE_TIMER_END
        gosub @BIKE_RECORD_TIME
    else
        if
            001C:    $ALLEYS_ANGELS_BEST_TIME > $BIKE_TIMER_END
        then
            0084:  $ALLEYS_ANGELS_BEST_TIME = $BIKE_TIMER_END
            gosub @BIKE_RECORD_TIME
        else
            0014:  $BIKE_REWARD /=  5
            gosub @BIKE_SHOW_TIME
        end
    end
end
if
    0038:   $BIKE_ISLAND == 1
then
    if
        0038:   $COLLEGE_TOUR_COMPLETED == 0
    then
        0084:  $COLLEGE_TOUR_BEST_TIME = $BIKE_TIMER_END
        gosub @BIKE_RECORD_TIME
    else
        if
            001C:    $COLLEGE_TOUR_BEST_TIME > $BIKE_TIMER_END
        then
            0084:  $COLLEGE_TOUR_BEST_TIME = $BIKE_TIMER_END
            gosub @BIKE_RECORD_TIME
        else
            0014:  $BIKE_REWARD /=  5
            gosub @BIKE_SHOW_TIME
        end
    end
end
if
    0038:   $BIKE_ISLAND == 2
then
    if
        0038:   $AIRPORT_AGGRESSION_COMPLETED == 0
    then
        0084:  $AIRPORT_AGGRESSION_BEST_TIME = $BIKE_TIMER_END
        gosub @BIKE_RECORD_TIME
    else
        if
            001C:    $AIRPORT_AGGRESSION_BEST_TIME > $BIKE_TIMER_END
        then
            0084:  $AIRPORT_AGGRESSION_BEST_TIME = $BIKE_TIMER_END
            gosub @BIKE_RECORD_TIME
        else
            0014:  $BIKE_REWARD /=  5
            gosub @BIKE_SHOW_TIME
        end
    end
end
01E3: text_1number_styled 'M_PASS'  $BIKE_REWARD  5000 ms  1 // MISSION PASSED: $~1~
0109: player  $PLAYER money +=  $BIKE_REWARD
0110: clear_player  $PLAYER wanted_level
0394: play_music  1
if and
    0038:   $BIKE_ISLAND == 0
    0038:   $ALLEYS_ANGELS_COMPLETED == 0
then
    0318: set_latest_mission_passed 'BIKE_0'   // 'ALLEYS AND ANGELS'
    030C: set_mission_points += 1
    0004: $ALLEYS_ANGELS_COMPLETED = 1
    042E: save_time_record  3  $ALLEYS_ANGELS_BEST_TIME
end
if and
    0038:   $BIKE_ISLAND == 1
    0038:   $COLLEGE_TOUR_COMPLETED == 0
then
    0318: set_latest_mission_passed 'BIKE_1'   // 'COLLEGE TOUR'
    030C: set_mission_points += 1
    0004: $COLLEGE_TOUR_COMPLETED = 1
    042E: save_time_record  4  $COLLEGE_TOUR_BEST_TIME
end
if and
    0038:   $BIKE_ISLAND == 2
    0038:   $AIRPORT_AGGRESSION_COMPLETED == 0
then
    0318: set_latest_mission_passed 'BIKE_2'   // 'AIRPORT AGGRESSION'
    030C: set_mission_points += 1
    0004: $AIRPORT_AGGRESSION_COMPLETED = 1
    042E: save_time_record  5  $AIRPORT_AGGRESSION_BEST_TIME
end
return

:BIKE_SHOW_TIME
if
    0018:    $RACE_TIME_SEC >  9
then
    02FD: text_2numbers_lowpriority 'T4X4_5I'  $RACE_TIME_MIN  $RACE_TIME_SEC  10000 ms  1 // Time: ~1~:~1~
else
    02FD: text_2numbers_lowpriority 'T4X4_5J'  $RACE_TIME_MIN  $RACE_TIME_SEC  10000 ms  1 // Time: ~1~:0~1~
end
return

:BIKE_RECORD_TIME
if
    0018:    $RACE_TIME_SEC >  9
then
    02FD: text_2numbers_lowpriority 'T4X4_5K'  $RACE_TIME_MIN  $RACE_TIME_SEC  10000 ms  1 // New best time: ~1~:~1~
else
    02FD: text_2numbers_lowpriority 'T4X4_5L'  $RACE_TIME_MIN  $RACE_TIME_SEC  10000 ms  1 // New best time: ~1~:0~1~
end
return