:CRAIGSCODE
create_thread @GENLEE_HORN
// These next 4 threads control the DeLorean code
create_thread @TIME
create_thread @CONV
create_thread @DELOREAN_CONDENSE
create_thread @DELOREAN_HELP
end_thread

:GENLEE_HORN
03A4: name_thread 'C2_HORN'
while true
    wait 100 ms
    if
        0256:   player $PLAYER defined
    then
        if
            00DE:   player $PLAYER driving_vehicle_type #GENLEE
        then
            if //or
                00E1:   key_pressed 0 $kHorn
             //   00E1:   key_pressed 0 19
            then
                03CF: load_wav 'GL_HORN' as 2
                gosub @AUDIO2_PLAY
                while 83D2:  NOT  wav 2 ended
                    wait 0 ms
                end
                040D: unload_wav 2
           end
        end
    end
end

:DELGLSPAWN
03A4: name_thread 'DGLSPWN'
const
    HEADING = 0@
    CAR1X   = 1@
    CAR1Y   = 2@
    CAR1Z   = 3@
    CAR2X   = 4@
    CAR2Y   = 5@
    CAR2Z   = 6@
    CAR1    = 7@
    CAR2    = 8@
end

while true
    wait 500 ms
    if
        0256:   player $PLAYER defined
    then
        if
            80E0:   NOT   player $PLAYER driving
        then
            if and
                00E1:   key_pressed 0 16
                00E1:   key_pressed 0 19
                80E1:   not key_pressed 0 8
            then
                018C: play_sound 1 at 0.0 0.0 0.0
                0172: HEADING = actor $SCRIPT_CONTROLLED_PLAYER z_angle
                04C4: create_coordinate CAR1X CAR1Y CAR1Z from_actor $SCRIPT_CONTROLLED_PLAYER offset -4.0 0.0 0.0
                04C4: create_coordinate CAR2X CAR2Y CAR2Z from_actor $SCRIPT_CONTROLLED_PLAYER offset 3.9 0.0 0.0
                0247: request_model #GENLEE
                0247: request_model #DELODRV
                038B: load_all_models_now
                while true
                    if or
                        8248:  NOT  model #GENLEE available
                        8248:  NOT  model #DELODRV available
                    jf break
                    wait 0 ms
                end
                00A5: CAR1 = create_car #GENLEE at CAR1X CAR1Y CAR1Z
                00A5: CAR2 = create_car #DELODRV at CAR2X CAR2Y CAR2Z
                02AC: set_car CAR1 immunities 1 1 1 1 1
                02AC: set_car CAR2 immunities 1 1 1 1 1
                0175: set_car CAR1 z_angle_to HEADING
                0175: set_car CAR2 z_angle_to HEADING
                0249: mark_model_as_no_longer_needed #GENLEE
                0249: mark_model_as_no_longer_needed #DELODRV
                01C3: remove_references_to_car CAR1  // Like turning a car into any random car
                01C3: remove_references_to_car CAR2  // Like turning a car into any random car
            end
        end
    end
end

:TIME      //The majority of this code was written by DeLorean88US/bluespace for the GTA:Hill Valley BTTF mod. Used with permission
thread 'TIME'
0247: request_model #D_WHEEL1
0247: request_model #D_STRUT1
0247: request_model #D_WHEEL2
0247: request_model #D_STRUT2
while true
    if or
        8248:   NOT   model available #D_WHEEL1
        8248:   NOT   model available #D_STRUT1
        8248:   NOT   model available #D_WHEEL2
        8248:   NOT   model available #D_STRUT2
    jf break
    wait 0 ms
end
0107: $LEFTWHEEL = create_object #D_WHEEL1 at 0.0 0.0 1000.0  // placing objects high above so don't need time wasted loading these
0107: $LEFTSTRUT = create_object #D_STRUT1 at 0.0 0.0 1000.0
0107: $RIGHTWHEEL = create_object #D_WHEEL2 at 0.0 0.0 1000.0
0107: $RIGHTSTRUT = create_object #D_STRUT2 at 0.0 0.0 1000.0
$TIME_CIRCUITS = 0

while true
    wait 0
    0293: $CONTROLMODE = current_controls
    if
        $CONTROLMODE == 0
    then
        $kHorn   = 18   //L3
        $kTC     = 19   //R3
        $kFly    =  3   //Right stick up/down
        $kFly2   =  3   //Right stick up/down
        $kBoost  =  6   //R1
        $kRadio  =  4   //L1
        $kRadio2 =  4   //L1
    end
    if
        $CONTROLMODE == 1
    then
        $kHorn   =  4   //L1
        $kTC     = 19   //R3
        $kFly    =  3   //Right stick up/down
        $kFly2   =  3   //Right stick up/down
        $kBoost  =  6   //R1
        $kRadio  = 13   //Select
        $kRadio2 = 13   //Select
    end
    if
        $CONTROLMODE == 2
    then
        $kHorn   =  6   //R1
        $kTC     = 19   //R3
        $kFly    =  3   //Right stick up/down
        $kFly2   =  3   //Right stick up/down
        $kBoost  = 15   //Triangle
        $kRadio  = 18   //L3
        $kRadio2 = 18   //L3
    end
    if
        $CONTROLMODE == 3
    then
        $kHorn   = 18   //L3
        $kTC     = 14   //Square
        $kFly    =  8   //D-pad up
        $kFly2   =  9   //D-pad down
        $kBoost  =  4   //L1
        $kRadio  = 17   //Circle
        $kRadio2 = 17   //Circle
    end
    if
        $CONTROLMODE == 4
    then
        $kHorn   = 18   //L3
        $kTC     = 19   //R3
        $kFly    =  8   //D-pad up
        $kFly2   =  9   //D-pad down
        $kBoost  = 16   //Cross
        $kRadio  = 10   //D-pad left
        $kRadio2 = 11   //D-pad right
    end
    if
        0256:   player $PLAYER defined
    then
        if or
            00DE:   player $PLAYER driving_vehicle_type #DELODRV      // Driving DeLorean
            00DE:   player $PLAYER driving_vehicle_type #DELOFLY      // Flying  DeLorean
        then
            03C1: 0@ = player $PLAYER car
            053F: set_car 0@ tires_vulnerable 0
            02E3: 1@ = car 0@ speed
            gosub @RADIO
            if
                00E1:   key_pressed 0 $kTC             //Sub-mission button - to activate time travel
            then
                if
                    $TIME_CIRCUITS == 0 //currently off
                then
                    //load del_06, else load del_07
                    03CF: load_wav 'DEL_06' as 2
                    03E5: text_box 'CIR_ON'   // Time circuits on
                else
                    03CF: load_wav 'DEL_07' as 2
                    03E5: text_box 'CIR_OFF'   // Time circuits off
                end
                //toggles circuits and plays audio
                $TIME_CIRCUITS *= -1
                $TIME_CIRCUITS += 1
                gosub @AUDIO2_PLAY
                wait 500 ms
            end
            if or
                00E1:   key_pressed 0 $kFly         // up/down button on the right axis pad
                00E1:   key_pressed 0 $kFly2        // This line allows up or down on the d-pad in CS3 and CS4
            then
                if
                    81F4:   not car 0@ flipped      // added to check if not flipped before tranforming
                then
                    0508: vehicle 0@ close_all_doors // added to fix potential crash when door is left opened
                    gosub @TIME_TRANSFORMATION     // fly/drive swap
                end
            end

            if and
                1@ > 43.5         //80 mph
                $TIME_CIRCUITS == 1
            then
                gosub @TIME_GET_SPEED
                1@ += 2.25
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.95 1@ -0.225
                0437: scatter_particle 2 0.25 at 2@ 3@ 4@ 0 0 0
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.95 1@ -0.225
                0437: scatter_particle 2 0.25 at 2@ 3@ 4@ 0 0 0
                gosub @TIME_GET_SPEED
                1@ += 2.45
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.9 1@ -0.225
                0437: scatter_particle 2 0.25 at 2@ 3@ 4@ 0 0 0
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.7 1@ -0.225
                0437: scatter_particle 2 0.25 at 2@ 3@ 4@ 0 0 0
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.5 1@ -0.225
                0437: scatter_particle 2 0.25 at 2@ 3@ 4@ 0 0 0
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.3 1@ -0.225
                0437: scatter_particle 2 0.25 at 2@ 3@ 4@ 0 0 0
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.1 1@ -0.225
                0437: scatter_particle 2 0.25 at 2@ 3@ 4@ 0 0 0
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.1 1@ -0.225
                0437: scatter_particle 2 0.25 at 2@ 3@ 4@ 0 0 0
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.3 1@ -0.225
                0437: scatter_particle 2 0.25 at 2@ 3@ 4@ 0 0 0
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.5 1@ -0.225
                0437: scatter_particle 2 0.25 at 2@ 3@ 4@ 0 0 0
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.7 1@ -0.225
                0437: scatter_particle 2 0.25 at 2@ 3@ 4@ 0 0 0
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.9 1@ -0.225
                0437: scatter_particle 2 0.25 at 2@ 3@ 4@ 0 0 0
                gosub @TIME_GET_SPEED
                1@ += -0.9
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.4 1@ 0.6
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.6 1@ 0.6
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.4 1@ 0.6
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.6 1@ 0.6
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -0.915
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.7 1@ 0.5
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.7 1@ 0.5
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -0.93
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.8 1@ 0.4
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.8 1@ 0.4
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -0.945
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.9 1@ 0.3
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.9 1@ 0.3
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -0.96
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -1.0 1@ 0.2
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 1.0 1@ 0.2
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -1.16
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.995 1@ 0.2
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.995 1@ 0.2
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -1.36
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.99 1@ 0.2
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.99 1@ 0.2
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -1.56
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.985 1@ 0.2
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.985 1@ 0.2
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -1.76
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.98 1@ 0.2
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.98 1@ 0.2
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -1.86
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.98 1@ 0.1
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.98 1@ 0.1
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -1.955
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.98 1@ 0.0
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.98 1@ 0.0
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -2.045
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.98 1@ -0.1
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.98 1@ -0.1
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -2.13
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.98 1@ -0.2
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.98 1@ -0.2
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                gosub @TIME_GET_SPEED
                1@ += -2.21
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.88 1@ -0.3
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.88 1@ -0.3
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.78 1@ -0.3
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.78 1@ -0.3
                04D5: create_corona_at 2@ 3@ 4@ radius 0.25 type 1 flare 0 RGB 64 128 255
                02E3: 1@ = car 0@ speed
                if
                    1@ > 44.5         //81.4 mph
                then
                    03D1: play_wav 2
                    if or
                        03D2:   wav 2 ended
                        83D0:   not wav 2 loaded
                    then
                        03CF: load_wav 'DEL_01' as 2
                    end
                    1@ -= 44.5
                    if
                        1@ >= 2.0  ////(never used in VC or GTA 3)
                    then
                        1@ = 2.0
                    end
                    0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.0 5.0 0.15
                    04D5: create_corona_at 2@ 3@ 4@ radius 1@ type 1 flare 0 RGB 64 128 255
                    1@ /= 1.25
                    0437: scatter_particle 50 1@ at 2@ 3@ 4@ 0 0 0
                    0437: scatter_particle 50 1@ at 2@ 3@ 4@ 0 0 0
                    if
                        $SPARKS == 0
                    then
                        16@ = 0
                        $REPEAT = 0
                        $SPARKS = 1
                    else
                        if
                            16@ > 100
                        then
                            16@ = 0
                        end
                    end
                    if
                        not Car.Model(0@) == #DELOFLY
                    then
                        0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.98 -0.4 -0.75
                        gosub @TIME_MAKE_FLAME
                        0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.98 -0.4 -0.75
                        gosub @TIME_MAKE_FLAME
                        0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.98 -0.6 -0.75
                        gosub @TIME_MAKE_FLAME
                        04D5: create_corona_at  2@ 3@ 4@ radius 1.0 type 1 flare 0 RGB 255 175 128
                        0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.98 -0.6 -0.75
                        gosub @TIME_MAKE_FLAME
                        04D5: create_corona_at  2@ 3@ 4@ radius 1.0 type 1 flare 0 RGB 255 175 128
                        0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.98 -0.8 -0.75
                        gosub @TIME_MAKE_FLAME
                        0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.98 -0.8 -0.75
                        gosub @TIME_MAKE_FLAME
                        0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.98 2.6 -0.75
                        gosub @TIME_MAKE_FLAME
                        0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.98 2.6 -0.75
                        gosub @TIME_MAKE_FLAME
                        0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.98 2.4 -0.75
                        gosub @TIME_MAKE_FLAME
                        04D5: create_corona_at  2@ 3@ 4@ radius 1.0 type 1 flare 0 RGB 255 175 128
                        0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.98 2.4 -0.75
                        gosub @TIME_MAKE_FLAME
                        04D5: create_corona_at  2@ 3@ 4@ radius 1.0 type 1 flare 0 RGB 255 175 128
                        0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset -0.98 2.2 -0.75
                        gosub @TIME_MAKE_FLAME
                        0407: create_coordinate 2@ 3@ 4@ from_car 0@ offset 0.98 2.2 -0.75
                        gosub @TIME_MAKE_FLAME
                    end
                    02E3: 1@ = car 0@ speed
                    if
                        1@ > 48.1    //At this point, you're gonna see some serious shit.
                    then
                        //Travel in time
                        040D: unload_wav 2
                        03CF: load_wav 'DEL_02' as 2
                        gosub @AUDIO2_PLAY
                        0169: set_fade_color 255 255 255
                        043C: set_game_sounds_disable_on_fade 0
                        fade 0 0
                        wait 0
                        0110: clear_player $PLAYER wanted_level
                        0209: $DEL_HOUR = random_int 0 23
                        0209: $DEL_MIN = random_int 0 59
                        00C0: set_current_time $DEL_HOUR $DEL_MIN
                        0209: $DEL_WEATHER = random_int 0 10
                        if
                            $DEL_WEATHER > 5       //This makes it so it's sunny more often than not
                        then
                            $DEL_WEATHER = 0
                        end
                        01B6: set_weather $DEL_WEATHER
                        01B7: release_weather
                        03BA: clear_cars_from_cube -5000.0 -5000.0 -5000.0 5000.0 5000.0 5000.0
                        042B: clear_peds_from_cube -5000.0 -5000.0 -5000.0 5000.0 5000.0 5000.0
                        0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.0 0.0 0.0
                        0395: clear_area 1 at 1@ 2@ 3@ range 5000.0
                        fade 1 100
                        wait 1000
                        040D: unload_wav 2
                        $TIME_CIRCUITS = 0
                    end
                end
                $SPARKS = 0
                040D: unload_wav 2
            end
        end
    end
end

:TIME_GET_SPEED
02E3: 1@ = car 0@ speed
1@ /= 30.0
return

:TIME_MAKE_FLAME
0437: scatter_particle 13 0.4 at 2@ 3@ 4@ 0 0 0  //CREATE_SINGLE_PARTICLE
0437: scatter_particle 13 0.4 at 2@ 3@ 4@ 0 0 0
return

:TIME_TRANSFORMATION
//transformation + wheels anims
{
0@ = car handle
1@ = temp x
2@ = temp y
3@ = temp z
4@ = car angle
5@ = car speed
6@ = car health, wheel object offset
10@ = car model
11@ = wheel object angle, constant
}
040D: unload_wav 2
if
    0137:   car 0@ id == #DELODRV  // check if driving deluxo
then
    0006: 10@ = #DELOFLY  // if yes, create sparrow at the end
    $LANDING = 0
    03CF: load_wav 'DEL_03' as 2
else
    0006: 10@ = #DELODRV  // if not, create deluxo at the end
    $LANDING = 1
    03CF: load_wav 'DEL_04' as 2
end
0247: request_model #DELODRV
0247: request_model #DELOFLY
0247: request_model #D_WHEEL1
0247: request_model #D_WHEEL2
0247: request_model #D_STRUT1
0247: request_model #D_STRUT2
038B: load_all_models_now
while true
    if or
        83D0:   not wav 2 loaded
        8248:   not model #DELODRV available
        8248:   not model #DELOFLY available
        8248:   not model #D_WHEEL1 available
        8248:   not model #D_WHEEL2 available
        8248:   not model #D_STRUT1 available
        8248:   not model #D_STRUT2 available
    jf break
    wait 0 ms
end
03D1: play_wav 2
0506: vehicle_model #DELOFLY set_next_variation -1 -1
//0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.0 0.0 100.0  // better opcode below
//012A: put_player $PLAYER at 1@ 2@ 3@ and_remove_from_car
00AA: store_car 0@ position_to 1@ 2@ 3@
3@ += 50.0
012A: put_player $PLAYER at 1@ 2@ 100.0 and_remove_from_car
if
  8431:   not car 0@ passenger_seat_free 0
then
  0432: $DEL_PAS = get_actor_handle_from_car 0@ passenger_seat 0
  if
    8118:   NOT   actor $DEL_PAS dead
  then
    0362: remove_actor $DEL_PAS from_car_and_place_at 1@ 2@ 105.0
  end
end
0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.0 -5.0 0.0  // redundant? removing these have no adverse effects
015F: set_camera_position 1@ 2@ 3@ 0.0 0.0 0.0
0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.0 0.0 -0.75
0460: set_camera_pointing_time 0.0 100
0160: point_camera 1@ 2@ 3@ 1
0174: 4@ = car 0@ z_angle
02E3: 5@ = car 0@ speed
00A6: destroy_car 0@
00A5: 0@ = create_car #DELOFLY at 1@ 2@ 3@
0175: set_car 0@ z_angle_to 4@
04BA: set_car 0@ speed_instantly 5@
//0224: set_car 0@ health_to 6@
wait 0 ms
$FLY = 1
0369: put_player $PLAYER in_car 0@
if
  8118:   NOT   actor $DEL_PAS dead
then
  0430: put_actor $DEL_PAS into_car 0@ passenger_seat 0
end
041E: set_radio_station $SET_RADIO -1  // added
02AC: set_car 0@ immunities 1 1 1 1 1
053F: set_car 0@ tires_vulnerable 0
015A: restore_camera
0373: set_camera_directly_behind_player
if
    $LANDING == 1  // check if player transitioning from sparrow to deluxo
then
    11@ = 90.0  // if yes, final angle of wheel is vertical (on ground)
    6@ = 1.15  // object's x offset from center of vehicle
else
    11@ = 0.0  // if no, final angle of wheel is horizontal (in air)
    6@ = 0.85  // object's x offset from center of vehicle
end
gosub @TIME_WHEEL_ROTATE
6@ *= -1.0  // left offset
0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 6@ 0.0 -0.3
01BC: put_object $LEFTWHEEL at 1@ 2@ 3@
01BC: put_object $LEFTSTRUT at 1@ 2@ 3@
0063: 8@ -= 11@
0453: object $LEFTWHEEL set_rotation 7@ 8@ 4@
005B: 8@ += 11@
6@ *= -1.0  // right offset
0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 6@ 0.0 -0.3
01BC: put_object $RIGHTWHEEL at 1@ 2@ 3@
01BC: put_object $RIGHTSTRUT at 1@ 2@ 3@
005B: 8@ += 11@
0453: object $RIGHTWHEEL set_rotation 7@ 8@ 4@
0063: 8@ -= 11@
while true
    wait 0 ms
    if
        $LANDING == 0  // check if player transitioning from deluxo to sparrow
    then
        02E3: 4@ = car 0@ speed
        4@ /= 30.0
        4@ += 0.8
        0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.75 4@ -0.425
        0437: scatter_particle 30 0.1 at 1@ 2@ 3@ 0 0 -0.01
        0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset -0.75 4@ -0.425
        0437: scatter_particle 30 0.1 at 1@ 2@ 3@ 0 0 -0.01
        4@ += -1.4
        0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.625 4@ -0.425
        0437: scatter_particle 30 0.1 at 1@ 2@ 3@ 0 0 -0.01
        0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset -0.625 4@ -0.425
        0437: scatter_particle 30 0.1 at 1@ 2@ 3@ 0 0 -0.01
    end
    gosub @TIME_WHEEL_ROTATE
    11@ *= -1.0
    6@ *= -1.0
    035C: place_object $LEFTSTRUT relative_to_car 0@ offset 6@ 0.0 -0.3
    035C: place_object $LEFTWHEEL relative_to_car 0@ offset 6@ 0.0 -0.3
    0453: object $LEFTSTRUT set_rotation 7@ 8@ 4@
    005B: 8@ += 11@
    0453: object $LEFTWHEEL set_rotation 7@ 8@ 4@
    0063: 8@ -= 11@
    11@ *= -1.0
    6@ *= -1.0
    035C: place_object $RIGHTSTRUT relative_to_car 0@ offset 6@ 0.0 -0.3
    035C: place_object $RIGHTWHEEL relative_to_car 0@ offset 6@ 0.0 -0.3
    0453: object $RIGHTSTRUT set_rotation 7@ 8@ 4@
    005B: 8@ += 11@
    0453: object $RIGHTWHEEL set_rotation 7@ 8@ 4@
    0063: 8@ -= 11@
    if
        $LANDING == 0
    then
        if
            NOT  6@ >= 1.15
        then
            6@ += 0.02
            continue
        end
        if
            NOT  11@ >= 90.0
        then
            11@ += 5.0
            continue
        end
    else
        if
            11@ > 0.0
        then
            11@ += -5.0
            continue
        end
        if
            6@ > 0.85
        then
            6@ += -0.02
            continue
        end
    end
    if
        $LANDING == 1
    jf break
    00AA: store_car 0@ position_to 1@ 2@ 3@
    02CE: 4@ = ground_z 1@ 2@ 3@
    0063: 3@ -= 4@
    if
        not  3@ > 5.0
    jf break
    if
        01F3:   not car 0@ in_air_proper
    jf break
end
01BC: put_object $LEFTWHEEL at 0.0 0.0 1000.0
01BC: put_object $LEFTSTRUT at 0.0 0.0 1000.0
01BC: put_object $RIGHTWHEEL at 0.0 0.0 1000.0
01BC: put_object $RIGHTSTRUT at 0.0 0.0 1000.0
0506: vehicle_model #DELOFLY set_next_variation 0 -1
00AA: store_car 0@ position_to 1@ 2@ 3@
012A: put_player $PLAYER at 1@ 2@ 100.0 and_remove_from_car
if
    8431:   not car 0@ passenger_seat_free 0
then
    0432: $DEL_PAS = get_actor_handle_from_car 0@ passenger_seat 0
    if
        8118:   NOT   actor $DEL_PAS dead
    then
        0362: remove_actor $DEL_PAS from_car_and_place_at 1@ 2@ 105.0
    end
end
0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.0 -5.0 0.0
015F: set_camera_position 1@ 2@ 3@ 0.0 0.0 0.0
0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.0 0.0 -0.75
0460: set_camera_pointing_time 0.0 100
0160: point_camera 1@ 2@ 3@ 1
0174: 4@ = car 0@ z_angle
02E3: 5@ = car 0@ speed
//0227: 6@ = car 0@ health
00A6: destroy_car 0@
00A5: 0@ = create_car 10@ at 1@ 2@ 3@
0175: set_car 0@ z_angle_to 4@
04BA: set_car 0@ speed_instantly 5@
//0224: set_car 0@ health_to 6@
wait 0 ms
$FLY = 0
0369: put_player $PLAYER in_car 0@
if
  8118:   NOT   actor $DEL_PAS dead
then
  0430: put_actor $DEL_PAS into_car 0@ passenger_seat 0
end
041E: set_radio_station $SET_RADIO -1  // added
02AC: set_car 0@ immunities 1 1 1 1 1
053F: set_car 0@ tires_vulnerable 0
015A: restore_camera
0373: set_camera_directly_behind_player
0249: mark_model_as_no_longer_needed #DELODRV
0249: mark_model_as_no_longer_needed #DELOFLY
01C3: remove_references_to_car 0@
wait 500 ms
return

:TIME_WHEEL_ROTATE
0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.0 0.0 0.0
0407: create_coordinate 1@ 2@ 7@ from_car 0@ offset 0.0 5.0 0.0
0063: 7@ -= 3@
7@ /= 5.0
7@ *= 100.0
008C: 3@ = float_to_integer 7@
7@ = -90.1
while 803B:  NOT 1@ == 3@
    7@ += 0.1
    02F6: 1@ = sine 7@
    1@ *= 100.0
    008C: 1@ = float_to_integer 1@
end
0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.0 0.0 0.0
0407: create_coordinate 1@ 2@ 8@ from_car 0@ offset -5.0 0.0 0.0
0063: 8@ -= 3@
8@ /= 5.0
8@ *= 100.0
008C: 3@ = float_to_integer 8@
8@ = -90.1
while 803B:  NOT 1@ == 3@
    8@ += 0.1
    02F6: 1@ = sine 8@
    1@ *= 100.0
    008C: 1@ = float_to_integer 1@
end
0174: 4@ = car 0@ z_angle
return

:CONV  // workaround engine limitation
thread 'CONV'

:CONV_LOOP
wait 0
$X_OFF = 0.0
$Y_OFF = 0.0
$Z_OFF = 0.0
if
   8256:   NOT  player $PLAYER defined
then
    jump @CONV_LOOP
end
if and
    80DE:   NOT  player $PLAYER driving_vehicle_type #DELOFLY  // changed to driving only sparrow or deluxo
    80DE:   NOT  player $PLAYER driving_vehicle_type #DELODRV
then
    jump @CONV_LOOP
end
03C1: 0@ = player $PLAYER car
0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.0 1.0 0.0

while true
    wait 0
    if
       8256:   NOT  player $PLAYER defined
    then
        jump @CONV_LOOP
    end
    if and
        80DE:   NOT  player $PLAYER driving_vehicle_type #DELOFLY  // changed to driving only sparrow or deluxo
        80DE:   NOT  player $PLAYER driving_vehicle_type #DELODRV
    then
        jump @CONV_LOOP
    end
    0407: create_coordinate $X_OFF $Y_OFF $Z_OFF from_car 0@ offset 0.0 1.0 0.0
    0067: $X_OFF -= 1@
    0067: $Y_OFF -= 2@
    0067: $Z_OFF -= 3@
    005D: 1@ += $X_OFF
    005D: 2@ += $Y_OFF
    005D: 3@ += $Z_OFF
end

:DELOREAN_CONDENSE
thread 'DELO'
var
//0@ = player car
1@ : float  // temp x, temp speed
2@ : float  // temp y
3@ : float  // temp z
4@ : float  // car speed for y offset corona
5@ : int    // personal var for loaded audio
//6@ freed
7@ : int    // time hour, lights z offset
8@ : int    // time min
//9@ and above freed
end
while true
    wait 0 ms
    if
        0256:   player $PLAYER defined
    then
        if and
            00DE:   player $PLAYER driving_vehicle_type #DELOFLY
            $FLY == 0 //adding this prevents a common crash of boosting while the model is changing from DELODRV to DELOFLY
        then
//thread BOOST
            03C1: 0@ = player $PLAYER car
            0229: set_car 0@ color_to 75 71
            if
                00E1:   key_pressed 0 $kBoost  // handbrake button
            then
                00AA: store_car 0@ position_to 1@ 2@ 3@
                if
                    not 3@ > 500.0  // disable boost if above z = 500
                then
                    if
                        5@ == 0  // check audio has not been played, ran out of local var
                    then
                        040D: unload_wav 2
                        03CF: load_wav 'DEL_05' as 2
                        gosub @AUDIO2_PLAY  // whoosh
                        5@ = 1  // audio has been played
                    end
                    02E3: 1@ = car 0@ speed  // offset to compensate faster speed with displaced coordiantes
                    if
                        7.5 > 1@
                    then
                        1@ = 10.0
                    else
                        if
                            1@ > 44.0
                        then
                            2@ = 1@
                            2@ *= -0.0005
                            2@ += 1.233
                            1@ *= 2@
                        else
                            2@ = 1@
                            2@ *= -0.001
                            2@ += 1.25575
                            1@ *= 2@
                        end
                    end
                    04BA: set_car 0@ speed_instantly 1@
                    02E3: 4@ = car 0@ speed  // offset to compensate faster speed with displaced coordiantes
                    4@ /= 30.0
                    4@ -= 2.345
                    0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.417 4@ 0.476
                    04D5: create_corona_at 1@ 2@ 3@ radius 0.75 type 1 flare 0 RGB 255 225 175
                    0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset -0.417 4@ 0.476
                    04D5: create_corona_at 1@ 2@ 3@ radius 0.75 type 1 flare 0 RGB 255 225 175
                    0229: set_car 0@ color_to 75 95  // awesome visual effect
                end
            else
                5@ = 0  // reset when releasing key
            end
//thread HLIGHTS
            00BF: 7@ = current_time_hours, 8@ = current_time_minutes
            7@ *= 100
            7@ += 8@
            if or
                7@ >= 2020  // time between 20:20 and 6:50
                650 >= 7@
            then
                //0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 0.725 2.286 -0.057  // workaround engine limitation
                1@ = 0.725
                2@ = 2.286
                3@ = -0.057
                gosub @CORONA_SYNC  // rewriting code to use his sync corona code already in use below
                04D5: create_corona_at 1@ 2@ 3@ radius 0.5 type 1 flare 0 RGB 255 255 255  // create headlights
                1@ = -0.725
                2@ = 2.286
                3@ = -0.057
                gosub @CORONA_SYNC
                04D5: create_corona_at 1@ 2@ 3@ radius 0.5 type 1 flare 0 RGB 255 255 255  // create headlights
//thread TLIGHTS
                1@ = 0.578
                2@ = -2.271
                3@ = 0.185
                gosub @CORONA_SYNC
                04D5: create_corona_at 1@ 2@ 3@ radius 0.5 type 1 flare 0 RGB 128 0 0  // creat taillights
                1@ = -0.578
                2@ = -2.271
                3@ = 0.185
                gosub @CORONA_SYNC
                04D5: create_corona_at 1@ 2@ 3@ radius 0.5 type 1 flare 0 RGB 128 0 0  // creat taillights
            end
//thread LIGHTS
            //10@ = 0.9  // set constant, not needed anymore
            1@ = -0.3
            2@ = 0.9
            3@ = -0.4
            gosub @CORONA_SYNC
            04D5: create_corona_at 1@ 2@ 3@ radius 0.25 type 1 flare 0 RGB 25 150 50  // green light beneath the sparrow
            1@ = 0.3
            2@ = 0.9
            3@ = -0.4
            gosub @CORONA_SYNC
            04D5: create_corona_at 1@ 2@ 3@ radius 0.25 type 1 flare 0 RGB 25 150 50
            if
                $FLY == 1
            then
                00BF: 7@ = current_time_hours, 8@ = current_time_minutes
                7@ *= 100
                7@ += 8@
                if or
                    7@ >= 2020
                    650 >= 7@
                then
                    1@ = -1.2
                    2@ = -1.339
                    3@ = -0.5
                    gosub @CORONA_SYNC
                    04D5: create_corona_at 1@ 2@ 3@ radius 0.75 type 1 flare 0 RGB 255 225 175
                    1@ = -1.1
                    2@ = 1.414
                    3@ = -0.5
                    gosub @CORONA_SYNC
                    04D5: create_corona_at 1@ 2@ 3@ radius 0.75 type 1 flare 0 RGB 255 225 175
                    1@ = 1.2
                    2@ = -1.339
                    3@ = -0.5
                    gosub @CORONA_SYNC
                    04D5: create_corona_at 1@ 2@ 3@ radius 0.75 type 1 flare 0 RGB 255 225 175
                    1@ = 1.1
                    2@ = 1.414
                    3@ = -0.5
                    gosub @CORONA_SYNC
                    04D5: create_corona_at 1@ 2@ 3@ radius 0.75 type 1 flare 0 RGB 255 225 175
                end
            end
        end
    end
end

:CORONA_SYNC  // corona sync code, an awesome code
0407: create_coordinate 1@ 2@ 3@ from_car 0@ offset 1@ 2@ 3@
005D: 1@ += $X_OFF
005D: 2@ += $Y_OFF
005D: 3@ += $Z_OFF
return

:RADIO                                          //Add code to allow forward and back radio controls for DeLorean with IV controls
041E: set_radio_station $SET_RADIO -1
if
    00E1:   key_pressed 0 $kRadio
then
    $SET_RADIO += 1
    if
      $SET_RADIO > 9
    then
      $SET_RADIO = 0
    end
    041E: set_radio_station $SET_RADIO -1
end

while 00E1:  key_pressed 0 $kRadio
    wait 0 ms
end
return

:DELOREAN_HELP
03A4: name_thread 'DELHELP'

while true
   wait 1000 ms
   if
       0256:   player $PLAYER defined
   then
       if or
           00DE:   player $PLAYER driving_vehicle_type #DELODRV
           00DE:   player $PLAYER driving_vehicle_type #DELOFLY
       then
           wait 2000 ms
           if
               0256:   player $PLAYER defined
           then
               if
                   82BD:   NOT   debug_mode == DEBUG_SKIPHELP // Only displays when found after getting to 100% in a normal game
               then
                   0293: $CONTROLMODE = current_controls
                   03E5: text_box 'DL_HLP1'       // Great Scott! You have a DeLorean! It can fly as well as travel in time.
                
                   wait 5000 ms                   // $kFly controls
                   if or
                      $CONTROLMODE == 3           // D-pad up or down
                      $CONTROLMODE == 4
                   then
                      03E5: text_box 'DL_HLP5'    // Press ~h~up~w~ or ~h~down on the d-pad~w~ to change the driving DeLorean into a flying car or vice versa.
                   else                           // Else L-stick up/down
                      03E5: text_box 'DL_HLP2'    // Press ~h~~k~~VEHICLE_TURRETUP~~w~ or ~h~~k~~VEHICLE_TURRETDOWN~~w~ to change the driving DeLorean into a flying car or vice versa.                
                   end
                  
                   wait 5000 ms                   // $kBoost controls
                   if or
                      $CONTROLMODE == 0           // R1
                      $CONTROLMODE == 1
                   then
                      03E5: text_box 'DL_HLP3'    // While flying, you can press ~h~~k~~VEHICLE_HANDBRAKE~~w~ to thrust the car forward.
                   end
                   if
                      $CONTROLMODE == 2           // Triangle            This displays L1
                   then
                      03E5: text_box 'DL_HLP7'    // While flying, you can press ~h~~k~~VEHICLE_ENTER_EXIT~~w~ to thrust the car forward.
                   end
                   if
                      $CONTROLMODE == 3           // L1   This crashes the game :o
                   then
                      03E5: text_box 'DL_HLP8'    // While flying, you can press ~h~~k~~VEHICLE_FIREWEAPON_ALT~~w~ to thrust the car forward.
                   end
                   if
                      $CONTROLMODE == 4           // X in 4
                   then
                      03E5: text_box 'DL_HLP9'    // While flying, you can press ~h~~k~~PED_SPRINT~~w~ to thrust the car forward.
                   end
                
                   wait 5000 ms                   // $kTC controls
                   if
                      $CONTROLMODE == 3           // Square
                   then
                      03E5: text_box 'DL_HLP6'    // Press ~h~~k~~PED_JUMPING~~w~ to activate the time circuits. When this baby hits 88 miles per hour, you're gonna see some serious shit.
                   else                           // R3 for all other controls
                      03E5: text_box 'DL_HLP4'    // Press ~h~~k~~TOGGLE_SUBMISSIONS~~w~ to activate the time circuits. When this baby hits 88 miles per hour, you're gonna see some serious shit.
                   end
               end
               end_thread
           end
       end
   end
end