:LUIGI_MESSAGE
03A4: name_thread 'LUIHELP'
wait 1000 ms
if
   0256:   player $PLAYER defined
then
   if
       0038:   $INTRO_HELP_MESSAGE == 0
   then
       if
           0038:   $LUIGIS_GIRLS_COMPLETED == 1
       then
           03E5: text_box 'LM1_8'   // You can go and see Luigi for more work or check out Liberty City.
           0004: $INTRO_HELP_MESSAGE = 1
       end
   end
   if
       0038:   $INTRO_HELP_MESSAGE == 1
   then
       0006: 16@ = 0
       0004: $INTRO_HELP_MESSAGE = 2
   end

   while 001B:   6000 > 16@
       wait 0 ms
   end

   if
       0038:   $INTRO_HELP_MESSAGE == 2
   then
       if
           0038:   $FLAG_PLAYER_ON_MISSION == 0
       then
           03E5: text_box 'LM1_8A'   // To earn some extra cash why not 'borrow' a taxi...
           0006: 16@ = 0
           0004: $INTRO_HELP_MESSAGE = 3
       end
   end

   while 001B:   10000 > 16@
       wait 0 ms
   end

   // No $INTRO_HELP_MESSAGE == 3 check to prevent from bike help box not being showed if player skipped LM1_8A
   0004: $INTRO_HELP_MESSAGE = 4
end
end_thread

//#####################################################################################
//#####################################################################################
// END LUIGI HELP / BEGIN BIKE CONTROLS HELP
//#####################################################################################
//#####################################################################################

:BIKE_HELP
03A4: name_thread 'BIKHELP'

while true
   wait 1000 ms
   if
       0256:   player $PLAYER defined
   then
       if
           047E:   player $PLAYER driving_a_motorbike
       then
           if
               0038:   $INTRO_HELP_MESSAGE == 4
           then
               wait 2000 ms
               if
                   0256:   player $PLAYER defined
               then
                   0293: $CONTROLMODE = current_controls
                   if
                       8038:   NOT   $CONTROLMODE == 3
                   then
                       03E5: text_box 'HELP27'  // Press the ~h~~k~~VEHICLE_TURRETUP~~w~ button and the ~h~~k~~VEHICLE_TURRETDOWN~~w~ button, to shift your weight on a bike.
                   else
                       03E5: text_box 'HELP28'  // Press the ~h~~k~~VEHICLE_TURRETUP~~w~ button and the ~h~~k~~VEHICLE_TURRETDOWN~~w~ button, to shift your weight on a bike.
                   end
                   end_thread
               end
           end
       end
   end
end

//#####################################################################################
//#####################################################################################
// END BIKE CONTROLS HELP / BEGIN AMMUNATION PISTOL MONITOR
//#####################################################################################
//#####################################################################################

:PISTOL_MESSAGE
03A4: name_thread 'PISTOL1'

while true
    wait 10000 ms
    if
        0256:   player $PLAYER defined
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                0038:   $OUT_OF_STOCK_PISTOL == 0
            then
                0215: destroy_pickup $SHOP_PISTOL
                0213: $SHOP_PISTOL2 = create_pickup #COLT45 type 1 at 733.5 -400.75 21.1875
                014D: add_pager_message 'COLT_IN'  140  2  0   // The Pistol is now in stock at Ammunation!
                0004: $OUT_OF_STOCK_PISTOL = 1
            end
        end
        if
            0038:   $OUT_OF_STOCK_PISTOL == 1
        then
            end_thread
        end
    end
end

//#####################################################################################
//#####################################################################################
// END AMMUNATION PISTOL MONITOR / BEGIN AMMUNATION UZI MONITOR
//#####################################################################################
//#####################################################################################

:UZI_MESSAGE
03A4: name_thread 'UZI1'

while true
    wait 5000 ms
    if
        0256:   player $PLAYER defined
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                0038:   $OUT_OF_STOCK_UZI == 0
            then
                014D: add_pager_message 'UZI_IN'  140  2  0   // The Uzi is now in stock at Ammunation!
                0215: destroy_pickup $SHOP_UZI2
                0213: $SHOP_UZI2 = create_pickup #UZI type 1 at 735.5 -400.75 21.1875
                0004: $OUT_OF_STOCK_UZI = 1
            end
        end
        if
            0038:   $OUT_OF_STOCK_UZI == 1
        then
            end_thread
        end
    end
end

//#####################################################################################
//#####################################################################################
// END AMMUNATION UZI MONITOR / BEGIN IE/CRANE/SECURICAR PAGER MESSAGE
//#####################################################################################
//#####################################################################################

:IMP_EXP_PAGER
03A4: name_thread 'IMPEXPP'

while true
    wait 100000 ms
    if
        0038:   $FLAG_PLAYER_ON_MISSION == 0
    then
        if
            0256:   player $PLAYER defined
        then
            014D: add_pager_message 'IMPEXPP'  140  2  0   // Import/Export garage Portland Harbor. We have orders for various vehicles. Check our notice board for our requirements.
            end_thread
        end
    end
end //while

:EMERGENCY_CRANE_PAGER
03A4: name_thread 'EMVHPUP'

while true
wait 200000 ms
    if
        0038:   $FLAG_PLAYER_ON_MISSION == 0
    then
        if
            0256:   player $PLAYER defined
        then
            014D: add_pager_message 'EMVHPUP'  140  2  0   // Great rates paid for new and used Emergency Vehicles. Bring them to the crane in the north east of Portland Harbor.
            end_thread
        end
    end
end

:VAN_HEIST_GARAGE_PAGER
03A4: name_thread 'VANHSTP'

while true
    wait 300000 ms
    if
        0038:   $FLAG_PLAYER_ON_MISSION == 0
    then
        if
            0256:   player $PLAYER defined
        then
            014D: add_pager_message 'VANHSTP'  140  2  0   // Any more Securicars you want cracked? Bring them to our garage in the Portland Harbor.
            end_thread
        end
    end
end

//#####################################################################################
//#####################################################################################
// END IE/CRANE/SECURICAR PAGER MESSAGE / BEGIN JOEY BF INJECTION MONITOR
//#####################################################################################
//#####################################################################################

:JOEYS_BUGGY_LOOP
03A4: name_thread 'JOE_BUG'

while true
    wait 500 ms
    if
        0256:   player $PLAYER defined
    then
        if
            03C6:   is_collision_in_memory 1
        then
            00BF: $CURRENT_TIME_HOURS = current_time_hours, $CURRENT_TIME_MINUTES = current_time_minutes
            if and
                0018:   $CURRENT_TIME_HOURS > 17
                001A:   24 > $CURRENT_TIME_HOURS
            then
                if
                    0038:   $JOEY_VISITING_MISTY == 0
                then
                    014C: set_parked_car_generator $JOEYS_BUGGY cars_to_generate_to 101
                    018D: $JOEY_SOUND = create_sound 91 at 602.062 -275.5 14.875
                    0004: $JOEY_VISITING_MISTY = 1
                end
            else
                if
                    0038:   $JOEY_VISITING_MISTY == 1
                then
                    014C: set_parked_car_generator $JOEYS_BUGGY cars_to_generate_to 0
                    018E: stop_sound $JOEY_SOUND
                    0004: $JOEY_VISITING_MISTY = 0
                end
            end
        end
    end
end

//#####################################################################################
//#####################################################################################
// END JOEY BF INJECTION MONITOR / BEGIN TONI_FR
//#####################################################################################
//#####################################################################################

:TONI5_FLAMES_LOOP
03A4: name_thread 'TONI_FR'

while true
    wait 500 ms
    if
        0256:   player $PLAYER defined
    then
        if
            8121:   NOT   player $PLAYER in_zone 'PORT_W'
        then
            031A: remove_all_fires
            end_thread
        end
    end
end

//#####################################################################################
//#####################################################################################
// END TONI_FR / BEGIN BLOB_HP
//#####################################################################################
//#####################################################################################

:BLOB_HELP_LOOP
03A4: name_thread 'BLOB_HP'

while true
    wait 100 ms
    if
        0256:   player $PLAYER defined
    then
        if
            019C:   player $PLAYER 0 in_cube_on_foot 910.25 -428.0 18.0 915.25 -423.188 24.0  // never used in VC
        then
            03E5: text_box 'HELP12'   // Walk into the center of the blue marker to trigger a mission.
            end_thread
        end
    end
end

//#####################################################################################
//#####################################################################################
// END BLOB_HP / BEGIN TONI4PG
//#####################################################################################
//#####################################################################################

:TONI4_PAGER_LOOP
03A4: name_thread 'TONI4PG'

while true
    wait 10000 ms
    if
        0256:   player $PLAYER defined
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03C6:   is_collision_in_memory 1
            then
                if
                    0038:   $TRIADS_AND_TRIBULATIONS_COMPLETED == 0
                then
                    014D: add_pager_message 'TONI_P'  140  2  0   // I've got some urgent work for you! -Toni
                end
                004F: create_thread @TONI5_PAGER_LOOP
                end_thread
            end
        end
    end
end

//#####################################################################################
//#####################################################################################
// END TONI4PG / BEGIN TONI5PG
//#####################################################################################
//#####################################################################################

:TONI5_PAGER_LOOP
03A4: name_thread 'TONI5PG'

while true
    wait 10000 ms
    if
        0256:   player $PLAYER defined
    then
        if
            0038:   $FLAG_PLAYER_ON_MISSION == 0
        then
            if
                03C6:   is_collision_in_memory 1
            then
                if
                    0038:   $TRIADS_AND_TRIBULATIONS_COMPLETED == 1
                then
                    if
                        0038:   $BLOW_FISH_COMPLETED == 0
                    then
                        014D: add_pager_message 'TONI_P'  140  2  0   // I've got some urgent work for you! -Toni
                    end
                    end_thread
                end
            end
        end
    end
end

//#####################################################################################
//#####################################################################################
// END TONI5PG / BEGIN FUZZDR
//#####################################################################################
//#####################################################################################

:CLOSE_FUZZ_DOORS
03A4: name_thread 'FUZZ_DR'

while true
    if or
        0038:   $FLAG_MOVED_DOOR1_LM5 == 0
        0038:   $FLAG_MOVED_DOOR2_LM5 == 0
    jf break
    wait 0 ms
    if
        0038:   $COUNTER_GIRLS_TRYING_TO_GET_TO_BALL == 0
    then
        if
            8339:   NOT   objects_in_cube 703.0 -899.0 20.0 661.5 -886.5 26.0 0 1 1 0 1
        then
            if
                034D: unknown_rotate_object $FUZZBALL_DOOR1 angle 180.0 10.0 0
            then
                0004: $FLAG_MOVED_DOOR1_LM5 = 1
            end
            if
                034D: unknown_rotate_object $FUZZBALL_DOOR2 angle 0.0 10.0 0
            then
                0004: $FLAG_MOVED_DOOR2_LM5 = 1
            end
        end
    end
end
end_thread

//#####################################################################################
//#####################################################################################
// END FUZZ DR / BEGIN ASUK_DR
//#####################################################################################
//#####################################################################################

:CLOSE_ASUKA1_DOOR
03A4: name_thread 'ASUK_DR'
if
    03CA:   object $LUIGI_BACKDOOR exists
then
    0176: $DOOR_POSITION_A1 = object $LUIGI_BACKDOOR z_angle
    if
        0038:   $DOOR_CRASH_FLAG == 1
    then
        while NOT   $DOOR_POSITION_A1 == 0.0
            if
                0256:   player $PLAYER defined
            then
                if
                    8057:   NOT   player $PLAYER 0 in_cube 554.562 -418.062 21.0 560.125 -412.625 24.0
                then
                    if and
                        0020:   $DOOR_POSITION_A1 > -10.0
                        0022:   10.0 > $DOOR_POSITION_A1
                    then
                        0005: $DOOR_POSITION_A1 = 0.0
                    else
                        000D: $DOOR_POSITION_A1 -= 10.0
                    end
                    0177: set_object $LUIGI_BACKDOOR z_angle_to $DOOR_POSITION_A1
                end
            else
                0005: $DOOR_POSITION_A1 = 0.0
                0177: set_object $LUIGI_BACKDOOR z_angle_to $DOOR_POSITION_A1
            end
            wait 0 ms
        end //while
    end
end
end_thread