//-------------Mission 74-------------
// Originally: Hood Mission 1 'UZI MONEY'

:M74_UZIMONEY
03A4: name_thread 'HOOD1'
054C: use_GXT_table 'HOOD1'
gosub @MISSION_START_HOOD1
if
    wasted_or_busted
then
    gosub @MISSION_HOOD1_FAILED
end
gosub @MISSION_CLEANUP_HOOD1
end_thread

:MISSION_START_HOOD1
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_HOODS = 1
0004: $FLAG_BLIP_ON_HM1 = 0
increment_mission_attempts
wait 0 ms
0111: set_deatharrest_state 0 (disabled)
015C: set_zone_gang_info 'PROJECT' 1 (day)  30 0 0 0 0 0 0 800 0 0 0
015C: set_zone_gang_info 'PROJECT' 0 (night)  30 0 0 0 0 0 0 800 0 0 0
03DE: set_pedestrians_density_multiplier_to 0.0
042B: clear_peds_from_cube -749.5625 97.6875 7.0 -924.25 -101.75 26.0
03CB: set_camera -779.6875 -6.3125 8.875
023C: load_special_actor 1 'PLAYER'
while true
    if
        823D:   NOT   special_actor 1 loaded
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'HD_PH1'
0244: set_cutscene_pos -779.688 -6.3125 8.875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
016A: fade 1 (back)  1500 ms
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime

while 001A:   2096 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM1_A' 10000 ms 1   // Yo! This is D-Ice of the Red Jacks!

while 001A:   4887 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM1_B' 10000 ms 1   // I got a problem they tryin' to play me.

while 001A:   7511 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM1_C' 10000 ms 1   // These young punks they come onto the streets and they got nothing but guns and SPANK on their minds.
while 001A:   12668 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM1_D' 10000 ms 1   // 'Nines' is their tag and purple is their flag and each day they rock their colors...
while 001A:   16765 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM1_G' 10000 ms 1   // is another day the 'Jacks' look soft.
while 001A:   19026 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM1_E' 10000 ms 1   // I want you to show these punk ass bitches how a real drive-by works.
while 001A:   23017 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM1_H' 10000 ms 1   // Take these nines off of here!!
while 001A:   25018 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM1_F' 10000 ms 1   // Watch your back though there'll be Jacks on the street who'll think you're trying to blast them too!
while 001A:   28865 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
03D5: remove_text 'HM1_F'   // Watch your back though there'll be Jacks on the street who'll think you're trying to blast them too!
while 001A:   30000 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
03DE: set_pedestrians_density_multiplier_to 1.0
if
    8256:   NOT   player $PLAYER defined
then
    jump @MISSION_HOOD1_FAILED
end
while fading
    wait 0 ms
    if
        8256:   NOT   player $PLAYER defined
    then
        jump @MISSION_HOOD1_FAILED
    end
end
00BC: print_now 'HM1_2' 5000 ms 1   // ~g~Get a vehicle, remember only Uzi drive by kills count!
if
    0038:   $FLAG_DONE_DRIVE_BY_HELP == 0
then
	// Code optimized and made compatible with GInput
    0293: $CONTROLMODE = current_controls
    if
        0038:   $CONTROLMODE == 2
    then
		// Text altered for GInput
        03E5: text_box 'DRIVE_B'   // Have an Uzi selected when entering a vehicle then look left or right and press the  ~c~  button to fire.
	else
		if
			0038:   $CONTROLMODE == 4
		then
			// New text for GInput
			03E5: text_box 'DRIVE_C'   // Have an Uzi selected when entering a vehicle then look left or right and press the  ~i~  button to fire.
		else
			03E5: text_box 'DRIVE_A'   // Have an Uzi selected when entering a vehicle then look left or right and press the ~h~~k~~PED_FIREWEAPON~ button~w~ to fire.
		end
    end
	0004: $FLAG_DONE_DRIVE_BY_HELP = 1
end

while 80E0:   NOT   player $PLAYER driving
    wait 0 ms
    if
        8256:   NOT   player $PLAYER defined
    then
        jump @MISSION_HOOD1_FAILED
    end
end
00BC: print_now 'HM1_3' 5000 ms 1   // ~g~The 'Nines' walk their turf in Wichita Gardens.
018A: $RADAR_BLIP_COORD_HM1 = create_checkpoint_at -777.25 -6.75 -100.0
0004: $FLAG_BLIP_ON_HM1 = 1

while true
    if and
        8121:   NOT   player $PLAYER in_zone 'PROJECT'
        80E0:   NOT   player $PLAYER driving
    jf break
    wait 0 ms
    if
        8256:   NOT   player $PLAYER defined
    then
        jump @MISSION_HOOD1_FAILED
    end
end
0247: request_model #UZI
038B: load_all_models_now

while 8248:   NOT   model #UZI available
    wait 0 ms
end
0164: remove_blip $RADAR_BLIP_COORD_HM1
0004: $FLAG_BLIP_ON_HM1 = 0
01F9: start_kill_frenzy 'HM1_1' 42 150000 20 #GANG14 -1 -1 -1 0   // ~g~Ice 20 Purple Nines in 2 minutes 30 seconds.
0247: request_model #GANG14
01B1: give_player $PLAYER weapon 23 ammo 9999  // Load the weapon model before using this
01FA: $FRENZY_STATE = rampage_status

while 0038:   $FRENZY_STATE == 1
    wait 0 ms
    01FA: $FRENZY_STATE = rampage_status
    if
        8256:   NOT   player $PLAYER defined
    then
        jump @MISSION_HOOD1_FAILED
    else

        {                                                                maybe needed???   not in original R* code
        0419: $UZI_MONEY_AMMO = player $PLAYER weapon 23 ammo
        if
            0038:   $UZI_MONEY_AMMO == 0
        then
            01B1: give_player $PLAYER weapon 23 ammo 9999  // Load the weapon model before using this
        end   }

        if
            8121:   NOT   player $PLAYER in_zone 'PROJECT'
        then
            if
                0038:   $FLAG_BLIP_ON_HM1 == 0
            then
                018A: $RADAR_BLIP_COORD_HM1 = create_checkpoint_at -777.25 -6.75 -100.0
                00BC: print_now 'HM1_3' 5000 ms 1   // ~g~The 'Nines' walk their turf in Wichita Gardens.
                0004: $FLAG_BLIP_ON_HM1 = 1
            end
        else
            if
                0038:   $FLAG_BLIP_ON_HM1 == 1
            then
                0164: remove_blip $RADAR_BLIP_COORD_HM1
                0004: $FLAG_BLIP_ON_HM1 = 0
            end
        end
    end
end

01FA: $FRENZY_STATE = rampage_status
if
    0038:   $FRENZY_STATE == 2
then
    jump @MISSION_HOOD1_PASSED
end

if           //this does not seem necessary at all
    0038:   $FRENZY_STATE == 3
then
    jump @MISSION_HOOD1_FAILED
end

:MISSION_HOOD1_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
return

:MISSION_HOOD1_PASSED
0004: $UZI_MONEY_COMPLETED = 1
0318: set_latest_mission_passed 'HM_1'   // 'UZI MONEY'
030C: set_mission_points += 1
01E3: text_1number_styled 'M_PASS' 10000 5000 ms 1   // MISSION PASSED! $~1~
0394: play_music 1
0109: player $PLAYER money += 10000
wait 100 ms
0110: clear_player $PLAYER wanted_level
004F: create_thread @HOODS_MISSION2_LOOP
return

:MISSION_CLEANUP_HOOD1
017A: set_player $PLAYER weapon 23 ammo_to $UZI_MONEY_OLD_AMMO
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_HOODS = 0
0164: remove_blip $RADAR_BLIP_COORD_HM1
015C: set_zone_gang_info 'PROJECT' 1 (day)  13 0 0 0 0 0 0 300 0 0 0
015C: set_zone_gang_info 'PROJECT' 0 (night)  9 0 0 0 0 0 0 400 0 0 0
03F2: pedgroup 14 remove_threat 1
0249: mark_model_as_no_longer_needed #GANG14
0249: mark_model_as_no_longer_needed #UZI
mission_cleanup
return
