//-------------Mission 76-------------
// Originally: Hood Mission 3 'RIGGED TO BLOW'

:M76_RIGGEDTOBLOW
03A4: name_thread 'HOOD3'
054C: use_GXT_table 'HOOD3'
gosub @MISSION_START_HOOD3
if
    wasted_or_busted
then
    gosub @MISSION_HOOD3_FAILED
end
gosub @MISSION_CLEANUP_HOOD3
end_thread

:MISSION_START_HOOD3
0004: $FLAG_PLAYER_ON_MISSION = 1  
0004: $ON_MISSION_FOR_HOODS = 1  
increment_mission_attempts
wait 0 ms
0004: $FLAG_PLAYER_HAD_REPAIR_MESSAGE_HM3 = 0  
0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_HM3 = 0  
0004: $FLAG_BLIP2_ON = 0  
0004: $BLOB_FLAG = 1  
0004: $TIMER_HM3 = 361000  
0004: $CAR_HEALTH_HM3 = 1000  
0004: $CAR_DAMAGE_HM3 = 0  
0004: $FLAG_DONT_CHECK_STUFF_HM3 = 0  
0004: $FLAG_PLAYER_HAD_OUT_MESSAGE_HM3 = 0  
03DE: set_pedestrians_density_multiplier_to 0.0
042B: clear_peds_from_cube -749.562 97.6875 7.0 -924.25 -101.75 26.0
03CB: set_camera -779.688 -6.3125 8.875
023C: load_special_actor 1 'PLAYER'
while true
    if
        823D:   NOT   special_actor 1 loaded
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'HD_PH3'
0244: set_cutscene_pos -779.688 -6.3125 8.875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
016A: fade 1 (back)  1500 ms
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime

while 001A:   2000 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM3_A' 10000 ms 1   // Some effa has wired my wheels to blow.
while 001A:   4262 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM3_B' 10000 ms 1   // If I lose those wheels my rep on the street will be dead.
while 001A:   7770 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM3_C' 10000 ms 1   // Pick up my car and take it over to the garage on St. Marks a'right yo.
while 001A:   11514 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM3_D' 10000 ms 1   // Let them diffuse that let them take care of that bomb.
while 001A:   14528 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM3_E' 10000 ms 1   // The clocks ticking and the wiring is messed up.
while 001A:   17707 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM3_F' 10000 ms 1   // One pot hole too many and that thing could blow.
while 001A:   20250 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'HM3_G' 10000 ms 1   // Now move it!
while 001A:   20951 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
03D5: remove_text 'HM3_G'   // Now move it!
while 001A:   21666 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
03DE: set_pedestrians_density_multiplier_to 1.0
03F2: pedgroup 7 remove_threat 1
03F2: pedgroup 8 remove_threat 1
03F2: pedgroup 9 remove_threat 1
03F2: pedgroup 10 remove_threat 1
03F2: pedgroup 11 remove_threat 1
03F2: pedgroup 12 remove_threat 1
03F2: pedgroup 14 remove_threat 1
0247: request_model #INFERNUS
while 8248:   NOT   model #INFERNUS available
    wait 0 ms
end
00A5: $CAR_HM3 = create_car #INFERNUS at -1017.0 76.0 24.5
0175: set_car $CAR_HM3 z_angle_to 0.0
0294: set_can_respray_car $CAR_HM3 flag 0
0186: $RADAR_BLIP_CAR1_HM3 = create_marker_above_car $CAR_HM3
021B: set_garage $GARAGE_HM3 to_accept_car $CAR_HM3
014E: set_timer_to $TIMER_HM3 type 1
if
    0119:   car $CAR_HM3 wrecked
then
    00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
    jump @MISSION_HOOD3_FAILED
end
while 80DC:   NOT   player $PLAYER driving $CAR_HM3
    wait 0 ms
    if
        0119:   car $CAR_HM3 wrecked
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_HOOD3_FAILED
    else
        if and
            01F4:   car $CAR_HM3 flipped
            01C1:   car $CAR_HM3 stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_HOOD3_FAILED
        end
    end
    if
        0038:   $TIMER_HM3 == 0  
    then
        0004: $CAR_DAMAGE_HM3 = 100  
        020B: explode_car $CAR_HM3
    end
end
0164: remove_blip $RADAR_BLIP_CAR1_HM3
00BC: print_now 'HM3_1' 7000 ms 1   // ~g~Get to the garage but watch out if the car takes too much damage it will blow!
018A: $RADAR_BLIP_COORD1_HM3 = create_checkpoint_at 1019.69 -312.875 54.875
03C4: set_status_text_to $CAR_DAMAGE_HM3 1 (bar)  'DETON'   // DETONATION:
while 821C:   NOT  car_inside_garage $GARAGE_HM3
    wait 0 ms
    if
        0119:   car $CAR_HM3 wrecked
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_HOOD3_FAILED
    else
        0227: $CAR_HEALTH_HM3 = car $CAR_HM3 health
        0004: $CAR_DAMAGE_HM3 = 1000  
        0060: $CAR_DAMAGE_HM3 -= $CAR_HEALTH_HM3  
        if
            0018:   $CAR_DAMAGE_HM3 > 100  
        then
            0004: $CAR_DAMAGE_HM3 = 100  
        end
        if and
            01F4:   car $CAR_HM3 flipped
            01C1:   car $CAR_HM3 stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_HOOD3_FAILED
        end
    end
    if
        0038:   $TIMER_HM3 == 0  
    then
        0004: $CAR_DAMAGE_HM3 = 100  
        020B: explode_car $CAR_HM3
    end
    if
        0038:   $CAR_DAMAGE_HM3 == 100  
    then
        020B: explode_car $CAR_HM3
    end
    if and
        80DC:   NOT   player $PLAYER driving $CAR_HM3
        0038:   $FLAG_PLAYER_HAD_CAR_MESSAGE_HM3 == 0  
    then
        00BC: print_now 'IN_VEH' 7000 ms 1   // ~g~Hey! Get back in the vehicle!
        0164: remove_blip $RADAR_BLIP_COORD1_HM3
        0186: $RADAR_BLIP_CAR1_HM3 = create_marker_above_car $CAR_HM3
        0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_HM3 = 1  
    end
    if and
        00DC:   player $PLAYER driving $CAR_HM3
        0038:   $FLAG_PLAYER_HAD_CAR_MESSAGE_HM3 == 1  
    then
        0164: remove_blip $RADAR_BLIP_CAR1_HM3
        018A: $RADAR_BLIP_COORD1_HM3 = create_checkpoint_at 1019.69 -312.875 54.875
        0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_HM3 = 0  
    end
end
0004: $CURRENT_TIME_HM3 = 361000  
0060: $CURRENT_TIME_HM3 -= $TIMER_HM3  
0014: $CURRENT_TIME_HM3 /= 1000  
0164: remove_blip $RADAR_BLIP_COORD1_HM3
0151: remove_status_text $CAR_DAMAGE_HM3
014F: stop_timer $TIMER_HM3
00BC: print_now 'HM3_2' 7000 ms 1   // ~g~Take the car back it has to be in perfect condition - no damage!
018A: $RADAR_BLIP_COORD2_HM3 = create_checkpoint_at -1017.0 76.0 -100.0
0004: $FLAG_BLIP2_ON = 1  
0004: $BLOB_FLAG = 1  

while true
    if or
        81B0:   NOT   car $CAR_HM3 stopped $BLOB_FLAG near_point -1017.0 76.0 23.375 radius 3.0 4.0 4.0
        03C9:   car $CAR_HM3 damaged
        00DC:   player $PLAYER driving $CAR_HM3
    jf break
    wait 0 ms
    if
        0119:   car $CAR_HM3 wrecked
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // ~r~The vehicle is wrecked!
        jump @MISSION_HOOD3_FAILED
    else
        if and
            01F4:   car $CAR_HM3 flipped
            01C1:   car $CAR_HM3 stopped
        then
            00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
            jump @MISSION_HOOD3_FAILED
        end
    end
    if
        01B0:   car $CAR_HM3 stopped 1 near_point -1017.0 76.0 23.375 radius 3.0 4.0 4.0
    then
        if
            83C9:   NOT   car $CAR_HM3 damaged
        then
            0004: $FLAG_DONT_CHECK_STUFF_HM3 = 1  
        end
        if
            0038:   $FLAG_PLAYER_HAD_OUT_MESSAGE_HM3 == 0  
        then
            00BC: print_now 'OUT_VEH' 5000 ms 1   // ~g~Get out of the vehicle!
            0004: $FLAG_PLAYER_HAD_OUT_MESSAGE_HM3 = 1  
        end
    else
        0004: $FLAG_DONT_CHECK_STUFF_HM3 = 0  
        0004: $FLAG_PLAYER_HAD_OUT_MESSAGE_HM3 = 0  
    end
    if
        0038:   $FLAG_DONT_CHECK_STUFF_HM3 == 0  
    then
        if
            00DC:   player $PLAYER driving $CAR_HM3
        then
            if
                0038:   $FLAG_PLAYER_HAD_CAR_MESSAGE_HM3 == 1  
            then
                0164: remove_blip $RADAR_BLIP_CAR1_HM3
                0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_HM3 = 0  
            end
            if
                03C9:   car $CAR_HM3 damaged
            then
                if
                    0038:   $FLAG_PLAYER_HAD_REPAIR_MESSAGE_HM3 == 0  
                then
                    00BC: print_now 'HM3_3' 7000 ms 1   // ~g~Get the car repaired!
                    0164: remove_blip $RADAR_BLIP_COORD2_HM3
                    0004: $FLAG_BLIP2_ON = 0  
                    0004: $FLAG_PLAYER_HAD_REPAIR_MESSAGE_HM3 = 1  
                end
                0004: $BLOB_FLAG = 0  
            else
                if
                    0038:   $FLAG_BLIP2_ON == 0  
                then
                    018A: $RADAR_BLIP_COORD2_HM3 = create_checkpoint_at -1017.0 76.0 -100.0
                    00BC: print_now 'HM3_2' 7000 ms 1   // ~g~Take the car back it has to be in perfect condition - no damage!
                    0004: $FLAG_BLIP2_ON = 1  
                end    
                0004: $BLOB_FLAG = 1  
                0004: $FLAG_PLAYER_HAD_REPAIR_MESSAGE_HM3 = 0  
            end
        else
            if
                0038:   $FLAG_PLAYER_HAD_CAR_MESSAGE_HM3 == 0  
            then
                00BC: print_now 'IN_VEH' 7000 ms 1   // ~g~Hey! Get back in the vehicle!
                0164: remove_blip $RADAR_BLIP_COORD2_HM3
                0004: $FLAG_BLIP2_ON = 0  
                0186: $RADAR_BLIP_CAR1_HM3 = create_marker_above_car $CAR_HM3
                0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_HM3 = 1  
            end
            0004: $BLOB_FLAG = 0  
            0004: $FLAG_PLAYER_HAD_REPAIR_MESSAGE_HM3 = 0  
        end
    end
end
if
    8119:   NOT   car $CAR_HM3 wrecked
then
    0135: change_car $CAR_HM3 lock 2
end
0164: remove_blip $RADAR_BLIP_COORD2_HM3
jump @MISSION_HOOD3_PASSED

:MISSION_HOOD3_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // MISSION FAILED!
if
    0130:  player $PLAYER busted
then
    016E: override_restart at -1594.5 -44.5 63.75 90.0
    //0420: override_police_station  3
end
if
    0117:  player $PLAYER wasted
then
    016E: override_restart at -1588.0 -138.188 63.75 90.0
    //041F: override_hospital  3
end
return

:MISSION_HOOD3_PASSED
if
    0038:   $RIGGED_TO_BLOW_COMPLETED == 0  
then
    0004: $RIGGED_TO_BLOW_COMPLETED = 1  
    0318: set_latest_mission_passed 'HM_3'   // 'RIGGED TO BLOW'
    030C: set_mission_points += 1
    004F: create_thread @HOODS_MISSION4_LOOP
end
0109: player $PLAYER money += 20000
01E3: text_1number_styled 'M_PASS' 20000 5000 ms 1   // MISSION PASSED! $~1~
0394: play_music 1
042E: save_time_record 1 value $CURRENT_TIME_HM3
0110: clear_player $PLAYER wanted_level
return

:MISSION_CLEANUP_HOOD3
0004: $FLAG_PLAYER_ON_MISSION = 0  
0004: $ON_MISSION_FOR_HOODS = 0  
021B: set_garage $GARAGE_HM3 to_accept_car -1
014F: stop_timer $TIMER_HM3
0151: remove_status_text $CAR_DAMAGE_HM3
0249: mark_model_as_no_longer_needed #INFERNUS
0164: remove_blip $RADAR_BLIP_CAR1_HM3
0164: remove_blip $RADAR_BLIP_COORD1_HM3
0164: remove_blip $RADAR_BLIP_COORD2_HM3
if
    0038:   $LAST_REQUESTS_COMPLETED == 1                 //I added this so the gangs don't hate you yet.
then                                                      //When played with a normal game, this would be
    03F1: pedtype 7 add_threat 1    //Mafia               //No different than GTA3
    03F1: pedtype 12 add_threat 1   //Colombians
end
if or
    0038:   $TRIAL_BY_FIRE_COMPLETED == 1  
    0038:   $BLOW_FISH_COMPLETED == 1  
then
    03F1: pedtype 8 add_threat 1   //Triads
end
if
    0038:   $UZI_RIDER_COMPLETED == 1  
then
    03F1: pedtype 9 add_threat 1   //Diablos
end
if
    0038:   $KINGDOM_COME_COMPLETED == 1  
then
    03F1: pedtype 11 add_threat 1   //Yardies
end
mission_cleanup
return

