//-------------Mission 26-------------
// Originally: Joey mission 3 'VAN HEIST'

:M26_VANHEIST
03A4: name_thread 'JOEY3'
054C: use_GXT_table 'JOEY3'
058E: set_restart_mission_taxi_destination 867.48 -868.85 20.77 angle 133.3
03A5: garage $GARAGE_BANK type 1 0  // reset garage if changed elsewhere
gosub @MISSION_START_JOEY3
if
    wasted_or_busted
then
    gosub @MISSION_JOEY3_FAILED
end
gosub @MISSION_CLEANUP_JOEY3
end_thread

:MISSION_START_JOEY3
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_JOEY = 1
wait 0 ms
0004: $IN_THE_LOCATE_JOEY3 = 0
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'JOEY'
02F3: load_object #CUTOBJ01 'JOEYH'
02F3: load_object #CUTOBJ02 'PLAYERH'
02F3: load_object #CUTOBJ03 'TROLL'
0247: request_model #JOGARAGEEXT
0247: request_model #JOGARAGEINT
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CUTOBJ03 available
    jf break
    wait 0 ms
end
while true
    if or
        8248:   NOT   model #JOGARAGEEXT available
        8248:   NOT   model #JOGARAGEINT available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'J3_VH'
0244: set_cutscene_pos 855.0601 -869.812 19.9375
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_JOEY = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_JOEY 'JOEY'
//02F4: create_cutscene_actor $JOEY_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_JOEY
//02F5: set_head_anim $JOEY_CSHEAD 'JOEY'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
02E5: $CS_TROLL = create_cutscene_object #CUTOBJ03
02E6: set_cutscene_anim $CS_TROLL 'TROLL'
0395: clear_area 1 at 856.88 -870.375 21.0 range 1.0
0055: set_player_coordinates $PLAYER at 856.88 -870.375 -100.0
0171: set_player $PLAYER z_angle_to 230.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   5515 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM3_A' 10000 ms 2   // // Alright we're gonna hit the pay role van.
while 001A:   7894 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM3_B' 10000 ms 2   // // It leaves the edge of China Town everyday.
while 001A:   10381 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM3_C' 10000 ms 2   // // Bullets won't even dent the van's armor so get a car and ram it off the road.
while 001A:   14589 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM3_D' 10000 ms 2   // // Now hit it hard and the punk ass security guards should bail.
while 001A:   17518 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM3_E' 10000 ms 2   // // Then take it to the warehouse at the docks and my guys are gonna take over from there.
while 001A:   21627 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'JM3_F' 10000 ms 2   // // Now it won't be doin' it's rounds all day so don't hang around.
while 001A:   24675 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BE: text_clear_all
while 001A:   27333 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
03AD: set_rubbish 1 (visible)
02EA: clear_cutscene
03C8: set_camera_in_front_of_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CUTOBJ03
0249: mark_model_as_no_longer_needed #JOGARAGEEXT
0249: mark_model_as_no_longer_needed #JOGARAGEINT
023C: load_special_actor 2 'S_GUARD'
0247: request_model #SECURICA
while true
    if or
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #SECURICA available
    jf break
    wait 0 ms
end
00A5: $VAN_JM3 = create_car #SECURICA at 728.0 -805.0 20.5625
020A: set_car $VAN_JM3 door_status_to 3
02AA: set_car $VAN_JM3 immune_to_nonplayer 1
02AC: set_car $VAN_JM3 immunities 1 1 0 0 1
00AD: set_car $VAN_JM3 max_speed_to 14.0
00AE: set_car $VAN_JM3 driving_style 0  // DRIVINGMODE_STOPFORCARS
0186: $BLIP1_JM3 = create_marker_above_car $VAN_JM3
0129: $VAN_MAN1_JM3 = create_actor 21 #SPECIAL02 in_car $VAN_JM3 driverseat
0243: set_actor $VAN_MAN1_JM3 ped_stats_to 14
054A: set_actor $VAN_MAN1_JM3 vulnerable_to_car_headshots 0
01C8: $VAN_MAN2_JM3 = create_actor 21 #SPECIAL02 in_car $VAN_JM3 passenger_seat 0
0243: set_actor $VAN_MAN2_JM3 ped_stats_to 14
054A: set_actor $VAN_MAN2_JM3 vulnerable_to_car_headshots 0
0227: $TEST_VAN_HEALTH_COUNTER = car $VAN_JM3 health
03C4: set_status_text_to $TEST_VAN_HEALTH_COUNTER 1 (bar)  'DAM'   // // Damage
0227: $TEST_VAN_HEALTH_COUNTER = car $VAN_JM3 health
0004: $TEST_VAN_HEALTH_COUNTER2 = 1000
0060: $TEST_VAN_HEALTH_COUNTER2 -= $TEST_VAN_HEALTH_COUNTER
if
    0018:   $TEST_VAN_HEALTH_COUNTER2 > 400
then
    0004: $TEST_VAN_HEALTH_COUNTER2 = 400
end
0084: $TEST_VAN_HEALTH_COUNTER = $TEST_VAN_HEALTH_COUNTER2
0014: $TEST_VAN_HEALTH_COUNTER /= 4

while 0185:   car $VAN_JM3 health >= 999
    wait 0 ms
    if
        0119:   car $VAN_JM3 wrecked
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY3_FAILED
    end
    if and
        01F4:   car $VAN_JM3 flipped
        01C1:   car $VAN_JM3 stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_JOEY3_FAILED
    end
    0227: $TEST_VAN_HEALTH_COUNTER = car $VAN_JM3 health
    0004: $TEST_VAN_HEALTH_COUNTER2 = 1000
    0060: $TEST_VAN_HEALTH_COUNTER2 -= $TEST_VAN_HEALTH_COUNTER
    if
        0018:   $TEST_VAN_HEALTH_COUNTER2 > 400
    then
        0004: $TEST_VAN_HEALTH_COUNTER2 = 400
    end
    0084: $TEST_VAN_HEALTH_COUNTER = $TEST_VAN_HEALTH_COUNTER2
    0014: $TEST_VAN_HEALTH_COUNTER /= 4
end
if
    8119:   NOT   car $VAN_JM3 wrecked
then
    00AE: set_car $VAN_JM3 driving_style 2  // DRIVINGMODE_AVOIDCARS
    00AD: set_car $VAN_JM3 max_speed_to 20.0
    010E: set_player $PLAYER minimum_wanted_level_to 1
    02AA: set_car $VAN_JM3 immune_to_nonplayer 0
    0227: $OLD_VAN_HEALTH = car $VAN_JM3 health
end
while 0185:   car $VAN_JM3 health >= 750
    wait 0 ms
    if
        0119:   car $VAN_JM3 wrecked
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY3_FAILED
    end
    if and
        01F4:   car $VAN_JM3 flipped
        01C1:   car $VAN_JM3 stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_JOEY3_FAILED
    end
    if
        8119:   NOT   car $VAN_JM3 wrecked
    then
        0227: $TEST_VAN_HEALTH_COUNTER = car $VAN_JM3 health
        if
            001C:   $OLD_VAN_HEALTH > $TEST_VAN_HEALTH_COUNTER
        then
            010E: set_player $PLAYER minimum_wanted_level_to 1
        end
        0084: $OLD_VAN_HEALTH = $TEST_VAN_HEALTH_COUNTER
        0004: $TEST_VAN_HEALTH_COUNTER2 = 1000
        0060: $TEST_VAN_HEALTH_COUNTER2 -= $TEST_VAN_HEALTH_COUNTER
        if
            0018:   $TEST_VAN_HEALTH_COUNTER2 > 400
        then
            0004: $TEST_VAN_HEALTH_COUNTER2 = 400
        end
        0084: $TEST_VAN_HEALTH_COUNTER = $TEST_VAN_HEALTH_COUNTER2
        0014: $TEST_VAN_HEALTH_COUNTER /= 4
    end
end
while 0185:   car $VAN_JM3 health >= 600
    wait 0 ms
    if
        0119:   car $VAN_JM3 wrecked
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY3_FAILED
    end
    if and
        01F4:   car $VAN_JM3 flipped
        01C1:   car $VAN_JM3 stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_JOEY3_FAILED
    end
    if
        8119:   NOT   car $VAN_JM3 wrecked
    then
        0227: $TEST_VAN_HEALTH_COUNTER = car $VAN_JM3 health
        if
            001C:   $OLD_VAN_HEALTH > $TEST_VAN_HEALTH_COUNTER
        then
            010E: set_player $PLAYER minimum_wanted_level_to 2
        end
        0084: $OLD_VAN_HEALTH = $TEST_VAN_HEALTH_COUNTER
        0004: $TEST_VAN_HEALTH_COUNTER2 = 1000
        0060: $TEST_VAN_HEALTH_COUNTER2 -= $TEST_VAN_HEALTH_COUNTER
        if
            0018:   $TEST_VAN_HEALTH_COUNTER2 > 400
        then
            0004: $TEST_VAN_HEALTH_COUNTER2 = 400
        end
        0084: $TEST_VAN_HEALTH_COUNTER = $TEST_VAN_HEALTH_COUNTER2
        0014: $TEST_VAN_HEALTH_COUNTER /= 4
    end
end
if
    8119:   NOT   car $VAN_JM3 wrecked
then
    020A: set_car $VAN_JM3 door_status_to 1
    0151: remove_status_text $TEST_VAN_HEALTH_COUNTER
    if
        8118:   NOT   actor $VAN_MAN1_JM3 dead
    then
        01D3: actor $VAN_MAN1_JM3 leave_car $VAN_JM3
    end
    if
        8118:   NOT   actor $VAN_MAN2_JM3 dead
    then
        01D3: actor $VAN_MAN2_JM3 leave_car $VAN_JM3
    end
end
if
    0119:   car $VAN_JM3 wrecked
then
    00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
    jump @MISSION_JOEY3_FAILED
end
while true
    if or
        80DB:   NOT   actor $VAN_MAN1_JM3 in_car $VAN_JM3
        80DB:   NOT   actor $VAN_MAN2_JM3 in_car $VAN_JM3
    jf break
    wait 0 ms
    if
        0119:   car $VAN_JM3 wrecked
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY3_FAILED
    end
    if and
        01F4:   car $VAN_JM3 flipped
        01C1:   car $VAN_JM3 stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_JOEY3_FAILED
    end
end
wait 1600 ms
if
    0119:   car $VAN_JM3 wrecked
then
    00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
    jump @MISSION_JOEY3_FAILED
end
if and
    8118:   NOT   actor $VAN_MAN1_JM3 dead
    8118:   NOT   actor $VAN_MAN2_JM3 dead
then
    01D0: actor $VAN_MAN1_JM3 avoid_player $PLAYER
    01D0: actor $VAN_MAN2_JM3 avoid_player $PLAYER
    041C: actor $VAN_MAN2_JM3 say 96  // dinput8.dll
end
if
    8119:   NOT   car $VAN_JM3 wrecked
then
    021B: set_garage $GARAGE_BANK to_accept_car $VAN_JM3
end
0004: $FLAG_CAR_BLIP_DISPLAYED_JM3 = 1

:GARAGE_STOP
0006: 17@ = 0

while true
    if or
        81AC:   NOT   car $VAN_JM3 stopped 0 in_cube 1105.6899 -805.562 16.875 1114.75 -782.062 21.875  // never used in VC
        80DC:   NOT   player $PLAYER driving $VAN_JM3
    jf break
    wait 0 ms
    if
        0119:   car $VAN_JM3 wrecked
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY3_FAILED
    end
    if
        00DC:   player $PLAYER driving $VAN_JM3
    then
        if
            0038:   $FLAG_CAR_BLIP_DISPLAYED_JM3 == 1
        then
            018A: $BLIP2_JM3 = create_checkpoint_at 1110.75 -796.6875 16.82
            018B: change_blip $BLIP2_JM3 display 2
            0164: remove_blip $BLIP1_JM3
            00BC: print_now 'JM3_1' 5000 ms 1   // // ~g~Take the van to the lock up.
            0004: $FLAG_CAR_BLIP_DISPLAYED_JM3 = 0
        end
    end
    if
        80DC:   NOT   player $PLAYER driving $VAN_JM3
    then
        if
            0038:   $FLAG_CAR_BLIP_DISPLAYED_JM3 == 0
        then
            0186: $BLIP1_JM3 = create_marker_above_car $VAN_JM3
            0164: remove_blip $BLIP2_JM3
            00BC: print_now 'IN_VEH' 5000 ms 1   // // ~g~Hey! Get back in the vehicle!
            0004: $FLAG_CAR_BLIP_DISPLAYED_JM3 = 1
        end
    end
    if and
        01F4:   car $VAN_JM3 flipped
        01C1:   car $VAN_JM3 stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_JOEY3_FAILED
    end
    if
        8118:   NOT   actor $VAN_MAN2_JM3 dead
    then
        if
            0019:   17@ > 4000
        then
            0006: 17@ = 0
            041C: actor $VAN_MAN2_JM3 say 96  // dinput8.dll
        end
    end
    if
        0038:   $IN_THE_LOCATE_JOEY3 == 0
    then
        if
            00F7:   player $PLAYER in-sphere 1 near_point_in_car 1110.0 -811.5 17.75 radius 4.0 6.0 4.0
        then
            0110: clear_player $PLAYER wanted_level
            0004: $IN_THE_LOCATE_JOEY3 = 1
        end
    end
    if
        0038:   $IN_THE_LOCATE_JOEY3 == 1
    then
        if and
            80B1:   NOT   car $VAN_JM3 0 in_cube 1105.6899 -805.562 16.875 1114.75 -782.062 21.875
            80F7:   NOT   player $PLAYER 0 near_point_in_car 1110.0 -811.5 17.75 radius 4.0 6.0 4.0
        then
            0004: $IN_THE_LOCATE_JOEY3 = 0
        end
    end
end
00BC: print_now 'OUT_VEH' 5000 ms 2   // // ~g~Get out of the vehicle!

while 821C:   NOT   car_inside_garage $GARAGE_BANK
    if
        0119:   car $VAN_JM3 wrecked
    then
        00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
        jump @MISSION_JOEY3_FAILED
    end
    if
        80B1:   NOT   car $VAN_JM3 0 in_cube 1105.6899 -805.562 16.875 1114.75 -782.062 21.875
    then
        jump @GARAGE_STOP
    end
    if and
        01F4:   car $VAN_JM3 flipped
        01C1:   car $VAN_JM3 stopped
    then
        00BC: print_now 'UPSIDE' 5000 ms 1   // ~r~You flipped your wheels!
        jump @MISSION_JOEY3_FAILED
    end
    wait 0 ms
end

0164: remove_blip $BLIP2_JM3
jump @MISSION_JOEY3_PASSED

:MISSION_JOEY3_FAILED
00BA: text_styled 'M_FAIL' 2000 ms 1   // // MISSION FAILED!
return

:MISSION_JOEY3_PASSED
0004: $VAN_HEIST_COMPLETED = 1
0394: play_music 1
01E3: text_1number_styled 'M_PASS' 20000 5000 ms 1   // // MISSION PASSED! $~1~
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 20000
0318: set_latest_mission_passed 'JM3'   // // 'VAN HEIST'
030C: set_mission_points += 1
03A5: garage $GARAGE_BANK type 7 #SECURICA
004F: create_thread @VAN_HEIST_GARAGE_PAGER
004F: create_thread @JOEY_MISSION4_LOOP
if
    82BD:   NOT   debug_mode == DEBUG_MASTERDEBUG
then
    004F: create_thread @DIABLO_PHONE_START
end
return

:MISSION_CLEANUP_JOEY3
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_JOEY = 0
0164: remove_blip $BLIP1_JM3
0164: remove_blip $BLIP2_JM3
0296: unload_special_actor 2
021B: set_garage $GARAGE_BANK to_accept_car -1
0249: mark_model_as_no_longer_needed #SECURICA
0151: remove_status_text $TEST_VAN_HEALTH_COUNTER
if
    02BD:   debug_mode == DEBUG_MASTERDEBUG
then
    03A5: garage $GARAGE_BANK type 7 #SECURICA
end
mission_cleanup
return
