//-------------Mission 49-------------
// Originally: Kenji mission 1 'KANBU BUST-OUT'

:M49_KANBUBUSTOUT
03A4: name_thread 'KENJI1'
054C: use_GXT_table 'KENJI1'
058E: set_restart_mission_taxi_destination 75.0 -1400.0 31.65 0.0
gosub @MISSION_START_KENJI1
if
    wasted_or_busted
then
    gosub @MISSION_KENJI1_FAILED
end
gosub @MISSION_CLEANUP_KENJI1
end_thread

:MISSION_START_KENJI1
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_KENJI = 1
0317: increment_mission_attempts
wait 0 ms
0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_KM1 = 0
0004: $FLAG_PLAYER_HAD_BOMB_MESSAGE_KM1 = 0
0004: $FLAG_PLAYER_GOT_COPS_MESSAGE_KM1 = 0
// 0004: $FLAG_PLAYER_WANTED_LEVEL_CHANGED = 0
0004: $FLAG_BLIP_ON_YAKUZA_PED1_KM1 = 0
0004: $FLAG_CAR_GOT_BOMB_KM1 = 0
//0004: $TOTAL_COUNTER_KM1 = 0
0004: $COUNTER_BOMB_KM1 = 0
//0004: $COUNTER_POLICE_KM1 = 0
0004: $FLAG_HAD_BOMB_MESSAGE_KM1 = 0
0004: $FLAG_BLIP_ON_KM1 = 0
0004: $BLOB_FLAG = 1
0004: $FLAG_AREA_BOMB_MESSAGE_KM1 = 0
0004: $FLAG_SPRAY_BLIP_ON_KM1 = 0
0004: $FLAG_BOMB_KM1 = 0
//0005: $DEBRIS1_X = 0.0
//0005: $DEBRIS1_Y = 0.0
//0005: $DEBRIS1_Z = 0.0
//0005: $DEBRIS2_X = 0.0
//0005: $DEBRIS2_Y = 0.0
//0005: $DEBRIS2_Z = 0.0
//0005: $DEBRIS3_X = 0.0
//0005: $DEBRIS3_Y = 0.0
//0005: $DEBRIS3_Z = 0.0
//0005: $DEBRIS4_X = 0.0
//0005: $DEBRIS4_Y = 0.0
//0005: $DEBRIS4_Z = 0.0
0004: $FLAG_DOJO_BLIP_ON = 0
//0004: $FLAG_PLAYER_WANTED = 0
//0004: $FLAG_KANBU_IN_GROUP = 0
0004: $FLAG_PLAYER_HAD_DOME_MESSAGE_KM1 = 0
0004: $FLAG_PLAYED_COP_RADIO_KM1 = 0
//0004: $KENJI1_PLAYER_CAR_BOMB_STATUS = 0
if
    0038:   $FLAG_NEED_WALL_CHANGE_KM1 == 1
then
    03B6: replace_model_at -7.0 -1090.25 32.9375 radius 2.0 from #POLICE_CELHOLE to #POLICE_CELL_WALL
    0004: $FLAG_NEED_WALL_CHANGE_KM1 = 0
end
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'KENJI'
0247: request_model #GANG07
0247: request_model #CASINO_GARDEN
02F3: load_object #CUTOBJ01 'KENJIH'
02F3: load_object #CUTOBJ02 'PLAYERH'
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #GANG07 available
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CASINO_GARDEN available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'K1_KBO'
0244: set_cutscene_pos 141.375 -1382.12 73.3125
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_KENJI = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_KENJI 'KENJI'
02E5: $CUTSCENE_YAKUZA = create_cutscene_object #GANG07
02E6: set_cutscene_anim $CUTSCENE_YAKUZA 'GANG07'
//02F4: create_cutscene_actor $KENJI_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_KENJI
//02F5: set_head_anim $KENJI_CSHEAD 'KENJI'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
0395: clear_area 1 at 124.062 -1413.0 31.0625 range 1.0
0055: set_player_coordinates $PLAYER at 124.062 -1413.0 31.0625
0171: set_player $PLAYER z_angle_to 132.0
016A: fade 1 (back)  1500 ms
03AD: set_rubbish 0 (invisible)
03AF: set_streaming 1 (enabled)
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   8392 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM1_A' 10000 ms 1   // // My sister speaks highly of you
while 001A:   9918 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM1_E' 10000 ms 1   // // though I am yet to be convinced that a gaijin can offer anything but disappointment.
while 001A:   13732 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM1_B' 10000 ms 1   // // Perhaps you could help deal with a situation that has me at a disadvantage.
while 001A:   17547 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM1_F' 10000 ms 1   // // Of course failure has its own disgrace.
while 001A:   20683 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM1_C' 10000 ms 1   // // A Yakuza Kanbu is in custody awaiting transfer for trial.
while 001A:   23650 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM1_G' 10000 ms 1   // // He is a valued member of the family.
while 001A:   25430 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'KM1_H' 10000 ms 1   // // Break him out of custody and get him to the dojo at Bedford Point.
while 001A:   28749 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
03D5: remove_text 'KM1_H'   // // Break him out of custody and get him to the dojo at Bedford Point.
while 001A:   31200 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
03AD: set_rubbish 1 (visible)
03C8: set_camera_in_front_of_player
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #CASINO_GARDEN
00BC: print_now 'KM1_1' 5000 ms 1   // // ~g~Steal a cop car!
0247: request_model #RUBBLE01
0247: request_model #RUBBLE02
03CF: load_wav 'K1_A' as 1
while true
    if or
        8248:   NOT   model #RUBBLE01 available
        8248:   NOT   model #RUBBLE02 available
        83D0:   NOT   wav 1 loaded
    jf break
    wait 0 ms
end
018D: $CELL_BEATING = create_sound 77 at -8.625 -1092.375 32.0
while 80DE:   NOT   player $PLAYER driving_vehicle_type #POLICE
    wait 0 ms
end
00DA: $MISSION_COP_CAR_KM1 = player $PLAYER car
00BC: print_now 'KM1_2' 5000 ms 1   // // ~g~Rig the car with a bomb!
03BC: $SPHERE_KM1 = create_sphere 38.875 -576.375 31.0625 4.0
02A8: $RADAR_BLIP_COORD1_KM1 = create_marker 27 at 45.0 -577.0 31.0625
while 8038:   NOT   $FLAG_CAR_GOT_BOMB_KM1 == 1
    wait 0 ms
    if
        00DE:   player $PLAYER driving_vehicle_type #POLICE
    then
        00DA: $MISSION_COP_CAR_KM1 = player $PLAYER car
        if
            0038:   $FLAG_PLAYER_HAD_CAR_MESSAGE_KM1 == 1
        then
            02A8: $RADAR_BLIP_COORD1_KM1 = create_marker 27 at 45.0 -577.0 31.0625
            if
                0038:   $FLAG_PLAYER_HAD_DOME_MESSAGE_KM1 == 0
            then
                03BC: $SPHERE_KM1 = create_sphere 38.875 -576.375 31.0625 4.0
            end
            0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_KM1 = 0
        end
        if
            0228:   car $MISSION_COP_CAR_KM1 bomb_status == 1  // never used in VC  -
        then
            0004: $FLAG_CAR_GOT_BOMB_KM1 = 1
        else
            if
                0038:   $FLAG_HAD_BOMB_MESSAGE_KM1 == 0
            then
                00BC: print_now 'KM1_2' 5000 ms 1   // // ~g~Rig the car with a bomb!
                0004: $FLAG_HAD_BOMB_MESSAGE_KM1 = 1
            end
        end
    else
        if
            0038:   $FLAG_PLAYER_HAD_CAR_MESSAGE_KM1 == 0
        then
            00BC: print_now 'KM1_4' 7000 ms 1   // // ~g~You need a cop car to do the job!
            0164: remove_blip $RADAR_BLIP_COORD1_KM1
            03BD: destroy_sphere $SPHERE_KM1
            0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_KM1 = 1
        end
        0004: $FLAG_HAD_BOMB_MESSAGE_KM1 = 0
    end
    if
        00E5:   player $PLAYER 0 near_point_in_car 38.875 -576.375 radius 2.0 2.0
    then
        if
            0038:   $FLAG_PLAYER_HAD_DOME_MESSAGE_KM1 == 0
        then
            03E5: text_box 'KM1_13'   // // Drive the vehicle into the garage!
            03BD: destroy_sphere $SPHERE_KM1
            0004: $FLAG_PLAYER_HAD_DOME_MESSAGE_KM1 = 1
        end
    else
        0004: $FLAG_PLAYER_HAD_DOME_MESSAGE_KM1 = 0
    end
end //while
0164: remove_blip $RADAR_BLIP_COORD1_KM1
03BD: destroy_sphere $SPHERE_KM1
00BC: print_now 'KM1_5' 7000 ms 1   // // ~g~Okay now go to the police station.
018A: $RADAR_BLIP_COORD2_KM1 = create_checkpoint_at -8.0 -1086.0 -100.0
0004: $BLOB_FLAG = 1
0004: $FLAG_BLIP_ON_KM1 = 1
while 0038:   $COUNTER_BOMB_KM1 == 0
    wait 0 ms
    if
        0038:   $FLAG_AREA_BOMB_MESSAGE_KM1 == 0
    then
        if
            00DE:   player $PLAYER driving_vehicle_type #POLICE
        then
            00DA: $MISSION_COP_CAR_KM1 = player $PLAYER car
            0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_KM1 = 0
            if or
                0228:   car $MISSION_COP_CAR_KM1 bomb_status == 1  // never used in VC
                0228:   car $MISSION_COP_CAR_KM1 bomb_status == 4  // never used in VC
            then
                if
                    0038:   $FLAG_PLAYER_HAD_BOMB_MESSAGE_KM1 == 1
                then
                    0164: remove_blip $RADAR_BLIP_COORD1_KM1
                    0004: $FLAG_PLAYER_HAD_BOMB_MESSAGE_KM1 = 0
                end
                if
                    0038:   $FLAG_BLIP_ON_KM1 == 0
                then
                    018A: $RADAR_BLIP_COORD2_KM1 = create_checkpoint_at -8.0 -1086.0 32.0
                    0004: $FLAG_BLIP_ON_KM1 = 1
                    0004: $BLOB_FLAG = 1
                end
                if
                    00B1:   car $MISSION_COP_CAR_KM1 $BLOB_FLAG in_cube -3.312 -1091.0 30.0 -11.312 -1078.25 39.0
                then
                    // Code optimized and made compatible with GInput
                    0293: $CONTROLMODE = current_controls
                    if
                        0038:   $FLAG_BOMB_KM1 == 0
                    then
                        if
                            0038:   $CONTROLMODE == 2
                        then
                            // Text altered for GInput
                            03E5: text_box 'KM1_8C'   // Press the  ~c~  button to ~h~activate the bomb,~w~ remember to get out of the way.
                        else
                            if
                                0038:   $CONTROLMODE == 4
                            then
                                // New text for GInput
                                03E5: text_box 'KM1_8E'   // Press the  ~i~  button to ~h~activate the bomb,~w~ remember to get out of the way.
                            else
                                03E5: text_box 'KM1_8A'   // Press the~h~ ~k~~PED_FIREWEAPON~ button~w~ to ~h~activate the bomb~w~ remember to get out of the way.
                            end
                        end
                        0004: $FLAG_BOMB_KM1 = 1
                    end
                    if
                        0228:   car $MISSION_COP_CAR_KM1 bomb_status == 4  // never used in VC
                    then
                        0004: $COUNTER_BOMB_KM1 = 1
                        0004: $FLAG_AREA_BOMB_MESSAGE_KM1 = 1
                    else
                        0004: $FLAG_AREA_BOMB_MESSAGE_KM1 = 0
                    end
                end
            else
                if
                    0038:   $FLAG_AREA_BOMB_MESSAGE_KM1 == 0
                then
                    if
                        0038:   $FLAG_PLAYER_HAD_BOMB_MESSAGE_KM1 == 0
                    then
                        00BC: print_now 'KM1_6' 7000 ms 1   // // ~g~Fit the car with a bomb!
                        02A8: $RADAR_BLIP_COORD1_KM1 = create_marker 27 at 45.0 -577.0 31.0625
                        0004: $FLAG_PLAYER_HAD_BOMB_MESSAGE_KM1 = 1
                        if
                            0038:   $FLAG_BLIP_ON_KM1 == 1
                        then
                            0164: remove_blip $RADAR_BLIP_COORD2_KM1
                            0004: $FLAG_BLIP_ON_KM1 = 0
                            0004: $BLOB_FLAG = 0
                        end
                    end
                end
            end
        else
            0004: $BLOB_FLAG = 0
            if
                0038:   $FLAG_PLAYER_HAD_CAR_MESSAGE_KM1 == 0
            then
                00BC: print_now 'KM1_4' 7000 ms 1   // // ~g~You need a cop car to do the job!
                0164: remove_blip $RADAR_BLIP_COORD2_KM1
                0004: $FLAG_BLIP_ON_KM1 = 0
                0004: $FLAG_PLAYER_HAD_CAR_MESSAGE_KM1 = 1
            end
            if
                0038:   $FLAG_PLAYER_HAD_BOMB_MESSAGE_KM1 == 1
            then
                0164: remove_blip $RADAR_BLIP_COORD1_KM1
                0004: $FLAG_PLAYER_HAD_BOMB_MESSAGE_KM1 = 0
            end
        end
    end
end //while
03E6: remove_text_box
0164: remove_blip $RADAR_BLIP_COORD2_KM1
// Waiting for the player to destroy the car outside the cell
while 8356:   NOT  is_explosion_in_area 3 -11.75 -1072.5601 30.0 0.5 -1094.0 39.0
    if
        0119:   car $MISSION_COP_CAR_KM1 wrecked
    then
        00BC: print_now 'KM1_11' 5000 ms 1   // // ~r~You brought the heat down on yourself!
        010E: set_player $PLAYER minimum_wanted_level_to 3
        jump @MISSION_KENJI1_FAILED
    end
    wait 0 ms
end //while
if
    8119:   NOT   car $MISSION_COP_CAR_KM1 wrecked
then
    00BC: print_now 'KM1_11' 5000 ms 1   // // ~r~You brought the heat down on yourself!
    010E: set_player $PLAYER minimum_wanted_level_to 3
    jump @MISSION_KENJI1_FAILED
else
    gosub @WALL_EXPLOSION
end
018E: stop_sound $CELL_BEATING
018D: $POLICE_ALARM = create_sound 0 at -6.625 -1088.12 34.25
0395: clear_area 1 at -8.0 -1086.0 -100.0 range 4.0
03B6: replace_model_at -7.0 -1090.25 32.9375 radius 2.0 from #POLICE_CELL_WALL to #POLICE_CELHOLE
0004: $FLAG_NEED_WALL_CHANGE_KM1 = 1
0164: remove_blip $RADAR_BLIP_COORD2_KM1
wait 500 ms
009A: $KENJI1_KANBU = create_actor 10 #GANG07 at -6.812 -1092.1899 30.875
0319: set_actor $KENJI1_KANBU running 1
01ED: reset_actor $KENJI1_KANBU flags
01DF: tie_actor $KENJI1_KANBU to_player $PLAYER
00BC: print_now 'KM1_12' 7000 ms 1   // // ~g~Get him to the dojo but get rid of the cops first!
010E: set_player $PLAYER minimum_wanted_level_to 3
02A8: $SPRAY_BLIP_KM1 = create_marker 21 at 44.0 -493.75 31.1875
0006: 16@ = 0
while 010F:   player $PLAYER wanted_level > 0
    wait 0 ms
    if
        0038:   $FLAG_PLAYED_COP_RADIO_KM1 == 0
    then
        if
            0019:   16@ > 2000
        then
            03D1: play_wav 1
            0004: $FLAG_PLAYED_COP_RADIO_KM1 = 1
        end
    end
    if
        0118:   actor $KENJI1_KANBU dead
    then
        00BC: print_now 'KM1_10' 5000 ms 1   // // ~r~The Yakuza Kanbu is dead -along with your honor!
        jump @MISSION_KENJI1_FAILED
    end
    if
        8320:   NOT   actor $KENJI1_KANBU in_range_of_player $PLAYER
    then
        if
            0038:   $FLAG_BLIP_ON_YAKUZA_PED1_KM1 == 0
        then
            00BC: print_now 'HEY6' 5000 ms 1   // // ~g~You left your honor with the Yakuza Kanbu. You must protect him!
            0187: $RADAR_BLIP_PED1_KM1 = create_marker_above_actor $KENJI1_KANBU
            0164: remove_blip $SPRAY_BLIP_KM1
            0004: $FLAG_BLIP_ON_YAKUZA_PED1_KM1 = 1
        end
    end
    if and
        00E9:   player $PLAYER 0 near_actor $KENJI1_KANBU radius 8.0 8.0
        0038:   $FLAG_BLIP_ON_YAKUZA_PED1_KM1 == 1
    then
        01DF: tie_actor $KENJI1_KANBU to_player $PLAYER
        02A8: $SPRAY_BLIP_KM1 = create_marker 21 at 44.0 -493.75 31.1875
        0164: remove_blip $RADAR_BLIP_PED1_KM1
        0004: $FLAG_BLIP_ON_YAKUZA_PED1_KM1 = 0
    end
end //while
0164: remove_blip $SPRAY_BLIP_KM1
00BC: print_now 'KM1_3' 7000 ms 1   // // ~g~Now get him to the Yakuza dojo.
018A: $RADAR_BLIP_COORD3_KM1 = create_checkpoint_at -229.438 -1292.62 -100.0
0004: $FLAG_DOJO_BLIP_ON = 1
03CF: load_wav 'K1_B' as 1
0004: $BLOB_FLAG = 1
while true
    if or
        80E6:   NOT   player $PLAYER stopped $BLOB_FLAG near_point -229.438 -1292.62 radius 3.0 4.0  // never used in VC
        80EF:   NOT   actor $KENJI1_KANBU stopped 0 near_point -229.438 -1292.62 radius 3.0 4.0  // never used in VC
        83D0:   NOT   wav 1 loaded
        010F:   player $PLAYER wanted_level > 0
    jf break
    wait 0 ms
    if
        0118:   actor $KENJI1_KANBU dead
    then
        00BC: print_now 'KM1_10' 5000 ms 1   // // ~r~The Yakuza Kanbu is dead -along with your honor!
        jump @MISSION_KENJI1_FAILED
    end
    if
        8320:   NOT   actor $KENJI1_KANBU in_range_of_player $PLAYER
    then
        if
            0038:   $FLAG_BLIP_ON_YAKUZA_PED1_KM1 == 0
        then
            00BC: print_now 'HEY6' 5000 ms 1   // // ~g~You left your honor with the Yakuza Kanbu. You must protect him!
            0187: $RADAR_BLIP_PED1_KM1 = create_marker_above_actor $KENJI1_KANBU
            0004: $FLAG_BLIP_ON_YAKUZA_PED1_KM1 = 1
            0004: $BLOB_FLAG = 0
        end
        if
            0038:   $FLAG_SPRAY_BLIP_ON_KM1 == 1
        then
            0164: remove_blip $SPRAY_BLIP_KM1
            0004: $FLAG_SPRAY_BLIP_ON_KM1 = 0
            0004: $FLAG_PLAYER_GOT_COPS_MESSAGE_KM1 = 0
        end
    end
    if and
        00E9:   player $PLAYER 0 near_actor $KENJI1_KANBU radius 8.0 8.0
        0038:   $FLAG_BLIP_ON_YAKUZA_PED1_KM1 == 1
    then
        01DF: tie_actor $KENJI1_KANBU to_player $PLAYER
        0164: remove_blip $RADAR_BLIP_PED1_KM1
        0004: $FLAG_BLIP_ON_YAKUZA_PED1_KM1 = 0
        0004: $BLOB_FLAG = 1
    end
    if
        010F:   player $PLAYER wanted_level > 0
    then
        if
            0038:   $FLAG_PLAYER_GOT_COPS_MESSAGE_KM1 == 0
        then
            if
                0038:   $FLAG_BLIP_ON_YAKUZA_PED1_KM1 == 0
            then
                00BC: print_now 'WANTED1' 7000 ms 1   // // ~g~Shake the cops and lose your wanted level!
                02A8: $SPRAY_BLIP_KM1 = create_marker 21 at 44.0 -493.75 31.1875
                0004: $FLAG_PLAYER_GOT_COPS_MESSAGE_KM1 = 1
                0004: $FLAG_SPRAY_BLIP_ON_KM1 = 1
            end
        end
    else
        0004: $FLAG_PLAYER_GOT_COPS_MESSAGE_KM1 = 0
        if
            0038:   $FLAG_SPRAY_BLIP_ON_KM1 == 1
        then
            0164: remove_blip $SPRAY_BLIP_KM1
            0004: $FLAG_SPRAY_BLIP_ON_KM1 = 0
        end
    end
    if
        0038:   $FLAG_SPRAY_BLIP_ON_KM1 == 0
    then
        if
            0038:   $FLAG_BLIP_ON_YAKUZA_PED1_KM1 == 0
        then
            if
                0038:   $FLAG_DOJO_BLIP_ON == 0
            then
                018A: $RADAR_BLIP_COORD3_KM1 = create_checkpoint_at -229.438 -1292.62 -100.0
                00BC: print_now 'KM1_3' 7000 ms 1   // // ~g~Now get him to the Yakuza dojo.
                0004: $BLOB_FLAG = 1
                0004: $FLAG_DOJO_BLIP_ON = 1
            end
        end
    end
    if
        0038:   $FLAG_DOJO_BLIP_ON == 1
    then
        if or
            0038:   $FLAG_SPRAY_BLIP_ON_KM1 == 1
            0038:   $FLAG_BLIP_ON_YAKUZA_PED1_KM1 == 1
        then
            0164: remove_blip $RADAR_BLIP_COORD3_KM1
            0004: $BLOB_FLAG = 0
            0004: $FLAG_DOJO_BLIP_ON = 0
        end
    end
end //while
0164: remove_blip $RADAR_BLIP_COORD3_KM1
01B4: set_player $PLAYER can_move 0 (frozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
03BF: set_player $PLAYER ignored_by_everyone_to 1
02A3: toggle_widescreen 1 (on)
01E0: leave_group $KENJI1_KANBU
03D1: play_wav 1
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        0118:   actor $KENJI1_KANBU dead
    then
        00BC: print_now 'KM1_10' 5000 ms 1   // // ~r~The Yakuza Kanbu is dead -along with your honor!
        jump @MISSION_KENJI1_FAILED
    end
end
015F: set_camera_position -241.5625 -1279.25 41.0625 0.0 0.0 0.0
0160: point_camera -240.8125 -1279.88 40.75 2
0319: set_actor $KENJI1_KANBU running 0
if
    00DF:   actor $KENJI1_KANBU driving
then
    00D9: $CAR_KM1 = actor $KENJI1_KANBU car
    01D3: actor $KENJI1_KANBU leave_car $CAR_KM1
    while 00DB:   actor $KENJI1_KANBU in_car $CAR_KM1
        wait 0 ms
        if
            0118:   actor $KENJI1_KANBU dead
        then
            00BC: print_now 'KM1_10' 5000 ms 1   // // ~r~The Yakuza Kanbu is dead -along with your honor!
            jump @MISSION_KENJI1_FAILED
        end
        if
            0119:   car $CAR_KM1 wrecked
        then
            00BC: print_now 'WRECKED' 5000 ms 1   // // ~r~The vehicle is wrecked!
            jump @MISSION_KENJI1_FAILED
        end
    end //while
end
0395: clear_area 1 at -224.0 -1274.75 31.125 range 6.0
0239: actor $KENJI1_KANBU run_to -224.0 -1274.75
0006: 17@ = 0
while 80FF:   NOT   actor $KENJI1_KANBU 0 near_point_on_foot -224.0 -1274.75 31.125 radius 2.0 2.0 2.0
    wait 0 ms
    if
        0118:   actor $KENJI1_KANBU dead
    then
        00BC: print_now 'KM1_10' 5000 ms 1   // // ~r~The Yakuza Kanbu is dead -along with your honor!
        jump @MISSION_KENJI1_FAILED
    end
    if
        0029:   17@ >= 8000
    then
        if
            80FF:   NOT   actor $KENJI1_KANBU 0 near_point_on_foot -224.0 -1274.75 31.125 radius 2.0 2.0 2.0
        then
            034F: remove_char_elegantly $KENJI1_KANBU
            jump @MISSION_BLOKE_GOT_STUCK_KM1
        end
    end
end //while

:MISSION_BLOKE_GOT_STUCK_KM1
009B: destroy_actor_instantly $KENJI1_KANBU
02A3: toggle_widescreen 0 (off)
01B4: set_player $PLAYER can_move 1 (unfrozen)
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
03BF: set_player $PLAYER ignored_by_everyone_to 0 (false)
02EB: restore_camera_jumpcut
jump @MISSION_KENJI1_PASSED

:MISSION_KENJI1_FAILED
00BA: text_styled 'M_FAIL' 5000 ms 1   // // MISSION FAILED!
return

:MISSION_KENJI1_PASSED
0004: $KANBU_BUST_OUT_COMPLETED = 1
0318: set_latest_mission_passed 'KM1'   // // 'KANBU BUST-OUT'
030C: set_mission_points += 1
01E3: text_1number_styled 'M_PASS' 30000 5000 ms 1   // // MISSION PASSED! $~1~
0394: play_music 1
0109: player $PLAYER money += 30000
0110: clear_player $PLAYER wanted_level
004F: create_thread @KENJI_MISSION2_LOOP
return

:MISSION_CLEANUP_KENJI1
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_KENJI = 0
018E: stop_sound $POLICE_ALARM
018E: stop_sound $CELL_BEATING
040D: unload_wav 1
0249: mark_model_as_no_longer_needed #GANG07
0249: mark_model_as_no_longer_needed #RUBBLE01
0249: mark_model_as_no_longer_needed #RUBBLE02
0164: remove_blip $RADAR_BLIP_COORD1_KM1
0164: remove_blip $RADAR_BLIP_COORD2_KM1
0164: remove_blip $RADAR_BLIP_COORD3_KM1
0164: remove_blip $RADAR_BLIP_PED1_KM1
0164: remove_blip $SPRAY_BLIP_KM1
03BD: destroy_sphere $SPHERE_KM1
mission_cleanup
return

:WALL_EXPLOSION
020C: create_explosion_with_radius 5 at -6.938 -1087.5 33.6875
039D: scatter_particles 17 4.0 0 0 0 3000 at -6.938 -1088.25 32.0 0.0 0.0 0.0
0107: $DEBRIS1 = create_object #RUBBLE02 at -6.938 -1084.0601 33.0
0107: $DEBRIS2 = create_object #RUBBLE02 at -6.5 -1084.6899 33.0
0107: $DEBRIS3 = create_object #RUBBLE01 at -8.438 -1083.6899 32.0
0107: $DEBRIS4 = create_object #RUBBLE01 at -5.0 -1084.38 33.0
0392: object $DEBRIS1 toggle_in_moving_list 1
0392: object $DEBRIS2 toggle_in_moving_list 1
0392: object $DEBRIS3 toggle_in_moving_list 1
0392: object $DEBRIS4 toggle_in_moving_list 1
0381: throw_object $DEBRIS1 distance 3.0 16.0 15.0
0381: throw_object $DEBRIS2 distance -5.0 10.0 5.0
0381: throw_object $DEBRIS3 distance 7.0 7.0 7.0
0381: throw_object $DEBRIS4 distance -4.0 13.0 10.0
return
