//-------------Mission 55-------------
// Originally: Ray mission 2 'ARMS SHORTAGE'

:M55_ARMSSHORTAGE
03A4: name_thread 'RAY2'
054C: use_GXT_table 'RAY2'
058E: set_restart_mission_taxi_destination -221.6 -696.3 31.66 180.0
gosub @MISSION_START_RAY2
if
    wasted_or_busted
then
    gosub @MISSION_RAY2_FAILED
end
gosub @MISSION_CLEANUP_RAY2
end_thread

:MISSION_START_RAY2
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_RAY = 1
0004: $ON_ARMS_SHORTAGE_MISSION = 1
0004: $RAYS_CUTSCENE_FLAG = 1
wait 0 ms
0004: $FLAG_M16_GONE = 0
0004: $FLAG_UZI_GONE = 0
0004: $FLAG_ROCKET_GONE = 0
0004: $FLAG_SHOTGUN_GONE = 0
0004: $FLAG_MOLOTOV_GONE = 0

//0004: $FLAG_PHIL_IN_AREA = 0
0004: $FLAG_PHIL_ARRIVED = 0
0004: $FLAG_PHIL_DEAD = 0

0004: $FLAG_TRUCKS = 0

0004: $FLAG_V1_DEAD = 0
0004: $FLAG_V2_DEAD = 0
0004: $FLAG_V3_DEAD = 0
0004: $FLAG_V4_DEAD = 0
0004: $FLAG_V5_DEAD = 0
0004: $FLAG_V6_DEAD = 0
0004: $FLAG_V7_DEAD = 0
0004: $FLAG_V8_DEAD = 0
0004: $FLAG_V9_DEAD = 0
0004: $FLAG_V10_DEAD = 0
0004: $FLAG_V11_DEAD = 0
0004: $FLAG_V12_DEAD = 0
0004: $COUNTER_DEAD_VARMINTS = 0

0004: $FLAG_CARTEL_ARRIVED = 0

0004: $STALLION_BAILOUT = 0
0004: $SENTINEL_BAILOUT = 0
0004: $PERENIAL_BAILOUT = 0
0004: $FLAG_STALLION_ARRIVED = 0
0004: $FLAG_SENTINEL_ARRIVED = 0
0004: $FLAG_PERENIAL_ARRIVED = 0

0004: $FLAG_STALLION_CREATED = 0
0004: $FLAG_SENTINEL_CREATED = 0
0004: $FLAG_PERENIAL_CREATED = 0

0004: $FLAG_LAUNCH_STALLION = 0
0004: $FLAG_LAUNCH_PERENIAL = 0

0004: $FLAG_SNEAKY_1 = 0
0004: $FLAG_SNEAKY_2 = 0

0004: $FLAG_AUDIO = 0
0004: $FLAG_GATE = 0

0005: $WH_X_RM2 = -197.875
0005: $WH_Y_RM2 = 192.375
//0005: $WH2_X_RM2 = -213.5     unused
//0005: $WH2_Y_RM2 = 214.6

0005: $VARMINT_GEN1_X = -161.0
0005: $VARMINT_GEN1_Y = 170.0

0005: $STAGE_3_X = -182.0
0005: $STAGE_3_Y = 220.0
0005: $STAGE_1_X = -163.0
0005: $STAGE_1_Y = 207.0
0005: $STAGE_2_X = -183.0
0005: $STAGE_2_Y = 204.0

0005: $PHILS_DEFCON_X = -198.5
0005: $PHILS_DEFCON_Y = 176.7
0005: $PHILS_DEFCON_Z = 17.5625

0005: $M16_X = -189.5
0005: $M16_Y = 170.0

0005: $UZI_X = -191.5
0005: $UZI_Y = 170.0

0005: $SHOTGUN_X = -193.5
0005: $SHOTGUN_Y = 170.0

0005: $ROCKET_X = -208.02
0005: $ROCKET_Y = 198.24
0005: $ROCKET_Z = 20.53

0005: $MOLOTOV_X = -208.02
0005: $MOLOTOV_Y = 191.73
0005: $MOLOTOV_Z = 20.53
023C: load_special_actor 1 'PLAYER'
023C: load_special_actor 2 'RAY'
02F3: load_object #CUTOBJ01 'PLAYERH'
02F3: load_object #CUTOBJ02 'RAYH'
0247: request_model #TOILET
038B: load_all_models_now
while true
    if or
        823D:   NOT   special_actor 1 loaded
        823D:   NOT   special_actor 2 loaded
        8248:   NOT   model #CUTOBJ02 available
        8248:   NOT   model #CUTOBJ01 available
        8248:   NOT   model #TOILET available
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'R2_AP'
03AF: set_streaming 1 (enabled)
0244: set_cutscene_pos -295.625 -726.625 27.6875
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
02E5: $CUTSCENE_RAY = create_cutscene_object #SPECIAL02
02E6: set_cutscene_anim $CUTSCENE_RAY 'RAY'
//02F4: create_cutscene_actor $PLAYER_CSHEAD _from_head #CUTOBJ01 _and_body $CUTSCENE_PLAYER
//02F5: set_head_anim $PLAYER_CSHEAD 'PLAYER'
//02F4: create_cutscene_actor $RAY_CSHEAD _from_head #CUTOBJ02 _and_body $CUTSCENE_RAY
//02F5: set_head_anim $RAY_CSHEAD 'RAY'
0395: clear_area 1 at -296.0 -723.5 28.0 range 1.0
0055: set_player_coordinates $PLAYER at -296.0 -723.5 28.0
0171: set_player $PLAYER z_angle_to 90.0
016A: fade 1 (back)  250 ms
041D: set_camera_near_clip .1875
02E7: start_cutscene
03AF: set_streaming 0 (disabled)
03AD: set_rubbish 0 (invisible)
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   6426 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM2_A1' 10000 ms 1   // // Hey kid over here!
while 001A:   8218 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM2_A' 10000 ms 1   // // An old army buddy of mine runs a business in Rockford.
while 001A:   11093 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM2_B' 10000 ms 1   // // We saw action in Nicaragua back when the country knew what it was doing.
while 001A:   14634 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM2_C' 10000 ms 1   // // Some Cartel scum roughed him up yesterday said they'd be back for some of his stock today.
while 001A:   20938 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM2_D' 10000 ms 1   // // He's gonna need some back-up and in return he'll give you knock-down rates on any hardware you buy.
while 001A:   26599 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'RM2_D1' 10000 ms 1   // // I'd go myself but the old sciatica's playing up again -cough cough- so eerr-hhrrmmm good luck.
while 001A:   38333 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1000 ms
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
00BE: text_clear_all
while fading
    wait 0 ms
end
02EA: clear_cutscene
016A: fade 0  0 ms
0373: set_camera_directly_behind_player
041D: set_camera_near_clip .875
wait 500 ms
016A: fade 1 (back)  1000 ms
0296: unload_special_actor 1
0296: unload_special_actor 2
0249: mark_model_as_no_longer_needed #CUTOBJ01
0249: mark_model_as_no_longer_needed #CUTOBJ02
0249: mark_model_as_no_longer_needed #TOILET
03AF: set_streaming 1 (enabled)
03AD: set_rubbish 1 (visible)
0004: $RAYS_CUTSCENE_FLAG = 0
018A: $BLIP_WAREHOUSE_RM2 = create_checkpoint_at $WH_X_RM2 $WH_Y_RM2 17.2
0247: request_model #GANG11
while 8248:   NOT   model #GANG11 available
    wait 0 ms
end
023C: load_special_actor 1 'DEALER'
while 823D:   NOT   special_actor 1 loaded
    wait 0 ms
end
0247: request_model #GANG12
while 8248:   NOT   model #GANG12 available
    wait 0 ms
end
0247: request_model #COLUMB
while 8248:   NOT   model #COLUMB available
    wait 0 ms
end
0247: request_model #BARRACKS
0247: request_model #SHOTGUN
0247: request_model #COLT45
0247: request_model #AK47
0247: request_model #BODYARMOUR
0247: request_model #RHINO
0247: request_model #M16
0247: request_model #UZI
0247: request_model #MOLOTOV
while true
    if or
        8248:   NOT   model #BARRACKS available
        8248:   NOT   model #SHOTGUN available
        8248:   NOT   model #COLT45 available
        8248:   NOT   model #AK47 available
        8248:   NOT   model #BODYARMOUR available
    jf break
    wait 0 ms
end
while true
    if or
        8248:   NOT   model #RHINO available
        8248:   NOT   model #M16 available
        8248:   NOT   model #UZI available
        8248:   NOT   model #MOLOTOV available
    jf break
    wait 0 ms
end
while 80E3:   NOT   player $PLAYER 1 near_point $WH_X_RM2 $WH_Y_RM2 radius 4.0 4.0
    wait 0 ms
    if and
        0121:   player $PLAYER in_zone 'HOSPI_2'
        0038:   $FLAG_TRUCKS == 0
    then
        00A5: $PHIL_TRUCK_1 = create_car #RHINO at -203.0 173.875 17.5625
        0175: set_car $PHIL_TRUCK_1 z_angle_to 0.0
        00A9: set_car $PHIL_TRUCK_1 to_normal_driver
        02AC: set_car $PHIL_TRUCK_1 immunities 1 0 0 0 0
        020A: set_car $PHIL_TRUCK_1 door_status_to 2
        00A5: $PHIL_TRUCK_2 = create_car #BARRACKS at -201.5 208.75 17.875
        0175: set_car $PHIL_TRUCK_2 z_angle_to 180.0
        00A9: set_car $PHIL_TRUCK_2 to_normal_driver
        02AC: set_car $PHIL_TRUCK_2 immunities 1 0 0 0 0
        020A: set_car $PHIL_TRUCK_2 door_status_to 2
        0004: $FLAG_TRUCKS = 1
    end
    if
        0038:   $FLAG_GATE == 0
    then
        if
            0038:   $GATE2_SFX1 == 0
        then
            018C: play_sound 92 at -187.812 207.312 16.5625
            0004: $GATE2_SFX1 = 1
        end
        while 834E:   NOT slide_object $PHILS_COMPND_GATE to -187.812 214.812 16.5625 angle 0.0 0.0625 0.0 0
            wait 0 ms
        end
        if
            0038:   $NOT_CLUNKED_YET == 1
        then
            0004: $GATE_SFX2 = 0
            0004: $NOT_CLUNKED_YET = 0
        end
        if
            0038:   $GATE2_SFX2 == 0
        then
            018C: play_sound 93 at -187.812 214.812 16.5625
            0004: $GATE2_SFX2 = 1
        end
        0004: $FLAG_GATE = 1
    end
end //while
0395: clear_area 1 at $PHILS_DEFCON_X $PHILS_DEFCON_Y 17.5 range 20.0
009A: $PHIL = create_actor 21 #SPECIAL01 at $PHILS_DEFCON_X $PHILS_DEFCON_Y $PHILS_DEFCON_Z
0173: set_actor $PHIL z_angle_to 360.0
01B2: give_actor $PHIL weapon 26 ammo 200  // Load the weapon model before using this
035F: set_actor $PHIL armour_to 100
0243: set_actor $PHIL ped_stats_to 16
01ED: reset_actor $PHIL flags
011A: set_actor $PHIL flags 4096
0350: set_char_stay_in_same_place $PHIL  1
0215: destroy_pickup $PHIL_SHOTGUN
0215: destroy_pickup $PHIL_M16
0215: destroy_pickup $PHIL_ROCKET
032B: $PHILS_M16 = create_weapon_pickup #M16 3 ammo 60 at $M16_X $M16_Y 17.5
0213: $PHILS_UZI = create_pickup #UZI type 3 at $UZI_X $UZI_Y 17.5
0213: $PHILS_SHOTGUN = create_pickup #SHOTGUN type 3 at $SHOTGUN_X $SHOTGUN_Y 17.5
0213: $PHILS_ROCKET = create_pickup #ROCKET type 3 at $ROCKET_X $ROCKET_Y $ROCKET_Z
0213: $PHILS_MOLOTOV = create_pickup #MOLOTOV type 3 at $MOLOTOV_X $MOLOTOV_Y $MOLOTOV_Z
0213: $PHILS_ARMOUR = create_pickup #BODYARMOUR type 15 at -213.875 194.875 17.53
0164: remove_blip $BLIP_WAREHOUSE_RM2
01B4: set_player $PLAYER can_move 0 (frozen)
01F5: $RAY2_PLAYER_ACTOR = get_player_char $PLAYER
015F: set_camera_position -193.5 184.5 18.5 0.0 0.0 0.0
02A3: toggle_widescreen 1 (on)
if
    00E0:   player $PLAYER driving
then
    00DA: $PLAYER_RM2 = player $PLAYER car
    0221: set_player $PLAYER trapped_in_car 1
    00A9: set_car $PLAYER_RM2 to_normal_driver
    0158: camera_on_vehicle $PLAYER_RM2 15 2
    01D3: actor $RAY2_PLAYER_ACTOR leave_car $PLAYER_RM2
    while 00DB:   actor $RAY2_PLAYER_ACTOR in_car $PLAYER_RM2
        wait 0 ms
        if
            0119:   car $PLAYER_RM2 wrecked
        then
            jump @BIBBLE
        end
    end
end
0159: camera_on_ped $RAY2_PLAYER_ACTOR 15 2

:BIBBLE
wait 0 ms
0009: $PHILS_DEFCON_Y += 3.0
0239: actor $RAY2_PLAYER_ACTOR run_to $PHILS_DEFCON_X $PHILS_DEFCON_Y
while 80E3:   NOT   player $PLAYER 0 near_point $PHILS_DEFCON_X $PHILS_DEFCON_Y radius 2.0 2.0
    wait 0 ms
end
03CF: load_wav 'R2_A' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @PEEDLE
    end
end
03D7: set_wav 1 location $PHILS_DEFCON_X $PHILS_DEFCON_Y $PHILS_DEFCON_Z
03D1: play_wav 1
00BC: print_now 'RM2_E' 4000 ms 1   // Ray phoned ahead...but I thought there'd be more of you.
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @PEEDLE
    end
end
03CF: load_wav 'R2_B' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @PEEDLE
    end
end
03D7: set_wav 1 location $PHILS_DEFCON_X $PHILS_DEFCON_Y $PHILS_DEFCON_Z
03D1: play_wav 1
00BC: print_now 'RM2_E1' 4000 ms 1   // // I can't believe those yellow-bellied bastards left me without proper cover again!
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @PEEDLE
    end
end
03CF: load_wav 'R2_C' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @PEEDLE
    end
end
03D7: set_wav 1 location $PHILS_DEFCON_X $PHILS_DEFCON_Y $PHILS_DEFCON_Z
03D1: play_wav 1
00BC: print_now 'RM2_F' 4000 ms 1   // // Well three arms are better than one so grab whatever you need.
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @PEEDLE
    end
end
03CF: load_wav 'R2_D' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @PEEDLE
    end
end
03D7: set_wav 1 location $PHILS_DEFCON_X $PHILS_DEFCON_Y $PHILS_DEFCON_Z
03D1: play_wav 1
00BC: print_now 'RM2_F1' 4000 ms 1   // // Those Colombians'll be here any minute!
while 83D2:   NOT   wav 1 ended
    wait 0 ms
    if
        00E1:   key_pressed 0 16
    then
        jump @PEEDLE
    end
end

:PEEDLE
040D: unload_wav 1
00BE: text_clear_all
01B4: set_player $PLAYER can_move 1 (unfrozen)
02EB: restore_camera_jumpcut
02A3: toggle_widescreen 0 (off)
01BD: $TIMER_START_RM2 = current_time_in_ms
01BD: $TIMER_NOW_RM2 = current_time_in_ms
0084: $TIMER_DIF_RM2 = $TIMER_NOW_RM2
0060: $TIMER_DIF_RM2 -= $TIMER_START_RM2
0395: clear_area 1 at $VARMINT_GEN1_X $VARMINT_GEN1_Y 17.5 range 20.0
0395: clear_area 1 at $STAGE_3_X $STAGE_3_Y range 17.5 20.0
0395: clear_area 1 at $STAGE_1_X $STAGE_1_Y range 17.5 20.0
0395: clear_area 1 at $STAGE_2_X $STAGE_2_Y range 17.5 20.0
if
    8119:   NOT   car $PHIL_TRUCK_2 wrecked
then
    020A: set_car $PHIL_TRUCK_2 door_status_to 1
end
while true
    if and
        001A:   25000 > $TIMER_DIF_RM2
        0056:   player $PLAYER 0 in_rectangle -216.0 167.0 -188.0 246.0
    jf break
    wait 0 ms
    gosub @PICKUPS
    if
        0056:   player $PLAYER 0 in_rectangle -188.0 198.0 -179.0 208.0
    then
        jump @HERRING
    end
    if
        00E0:   player $PLAYER driving
    then
        jump @HERRING
    end
    01BD: $TIMER_NOW_RM2 = current_time_in_ms
    0084: $TIMER_DIF_RM2 = $TIMER_NOW_RM2
    0060: $TIMER_DIF_RM2 -= $TIMER_START_RM2
    if
        0118:   actor $PHIL dead
    then
        0004: $FLAG_PHIL_DEAD = 1
        jump @MISSION_RAY2_FAILED
    end
end //while

:HERRING
03CF: load_wav 'R2_E' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
01BD: $TIMER_START_RM2 = current_time_in_ms
//-----------------MAIN LOOP-----------------------------------------
while 001A:   12 > $COUNTER_DEAD_VARMINTS
    wait 0 ms
    01BD: $TIMER_NOW_RM2 = current_time_in_ms
    0084: $TIMER_DIF_RM2 = $TIMER_NOW_RM2
    0060: $TIMER_DIF_RM2 -= $TIMER_START_RM2
    gosub @PICKUPS
    if and
        0018:   $TIMER_DIF_RM2 > 2000
        0038:   $FLAG_SENTINEL_CREATED == 0
    then
        00A5: $SENTINEL1_RM2 = create_car #COLUMB at $VARMINT_GEN1_X $VARMINT_GEN1_Y -100.0
        02AA: set_car $SENTINEL1_RM2 immune_to_nonplayer 1
        020A: set_car $SENTINEL1_RM2 door_status_to 2
        0186: $BLIP_SENTINEL1 = create_marker_above_car $SENTINEL1_RM2
        0129: $VARMINT_1 = create_actor 12 #GANG12 in_car $SENTINEL1_RM2 driverseat
        01C8: $VARMINT_2 = create_actor 12 #GANG12 in_car $SENTINEL1_RM2 passenger_seat 0
        01C8: $VARMINT_3 = create_actor 12 #GANG12 in_car $SENTINEL1_RM2 passenger_seat 1
        01C8: $VARMINT_4 = create_actor 12 #GANG11 in_car $SENTINEL1_RM2 passenger_seat 2
        00AD: set_car $SENTINEL1_RM2 max_speed_to 10.0
        00AE: set_car $SENTINEL1_RM2 driving_style 3  // DRIVINGMODE_PLOUGHTHROUGH
        02C2: car $SENTINEL1_RM2 drive_to_point $STAGE_1_X $STAGE_1_Y 17.5625
        0004: $FLAG_SENTINEL_CREATED = 1
    end
    if and
        0038:   $FLAG_LAUNCH_STALLION == 0
        0038:   $FLAG_SENTINEL_CREATED == 1
    then
        if
            8119:   NOT   car $SENTINEL1_RM2 wrecked
        then
            if
                01AD:   car $SENTINEL1_RM2 0 near_point $STAGE_1_X $STAGE_1_Y 4.0 4.0
            then
                02C2: car $SENTINEL1_RM2 drive_to_point $STAGE_2_X $STAGE_2_Y 17.6
                0004: $FLAG_LAUNCH_STALLION = 1
            end
        end
    end
    if and
        0038:   $FLAG_LAUNCH_STALLION == 1
        0038:   $FLAG_SENTINEL_CREATED == 1
    then
        if
            8119:   NOT   car $SENTINEL1_RM2 wrecked
        then
            if
                01AD:   car $SENTINEL1_RM2 0 near_point $STAGE_2_X $STAGE_2_Y 4.0 4.0
            then
                0004: $FLAG_LAUNCH_STALLION = 2
                0004: $FLAG_SENTINEL_ARRIVED = 1
                02AA: set_car $SENTINEL1_RM2 immune_to_nonplayer 0
                020A: set_car $SENTINEL1_RM2 door_status_to 1
                if
                    001A:   2 > $FLAG_CARTEL_ARRIVED
                then
                    0004: $FLAG_CARTEL_ARRIVED = 1
                end
            end
        end
    end
    if
        0038:   $FLAG_SENTINEL_CREATED == 1
    then
        if
            0119:   car $SENTINEL1_RM2 wrecked
        then
            0004: $FLAG_LAUNCH_STALLION = 1
            0164: remove_blip $BLIP_SENTINEL1
        else
            if
                8185:   NOT   car $SENTINEL1_RM2 health >= 950
            then
                0004: $FLAG_SENTINEL_ARRIVED = 1
                if
                    0038:   $FLAG_LAUNCH_STALLION == 0
                then
                    0004: $FLAG_LAUNCH_STALLION = 1
                end
                if
                    0038:   $FLAG_CARTEL_ARRIVED == 0
                then
                    0004: $FLAG_CARTEL_ARRIVED = 1
                end
            end
        end
    end
    if and
        0018:   $TIMER_DIF_RM2 > 4000
        0038:   $FLAG_STALLION_CREATED == 0
        0018:   $FLAG_LAUNCH_STALLION > 0
    then
        00A5: $STALLION1_RM2 = create_car #COLUMB at $VARMINT_GEN1_X $VARMINT_GEN1_Y -100.0
        02AA: set_car $STALLION1_RM2 immune_to_nonplayer 1
        020A: set_car $STALLION1_RM2 door_status_to 2
        0186: $BLIP_STALLION1 = create_marker_above_car $STALLION1_RM2
        0129: $VARMINT_5 = create_actor 12 #GANG11 in_car $STALLION1_RM2 driverseat
        01C8: $VARMINT_6 = create_actor 12 #GANG12 in_car $STALLION1_RM2 passenger_seat 0
        00AD: set_car $STALLION1_RM2 max_speed_to 10.0
        00AE: set_car $STALLION1_RM2 driving_style 3  // DRIVINGMODE_PLOUGHTHROUGH
        02C2: car $STALLION1_RM2 drive_to_point $STAGE_1_X $STAGE_1_Y 17.6
        0004: $FLAG_STALLION_CREATED = 1
    end
    if and
        0038:   $FLAG_LAUNCH_PERENIAL == 0
        0038:   $FLAG_STALLION_CREATED == 1
    then
        if
            8119:   NOT   car $STALLION1_RM2 wrecked
        then
            if
                01AD:   car $STALLION1_RM2 0 near_point $STAGE_1_X $STAGE_1_Y 4.0 4.0
            then
                02C2: car $STALLION1_RM2 drive_to_point $STAGE_3_X $STAGE_3_Y 17.5625
                0004: $FLAG_LAUNCH_PERENIAL = 1
            end
        end
    end
    if and
        0038:   $FLAG_LAUNCH_PERENIAL == 1
        0038:   $FLAG_STALLION_CREATED == 1
    then
        if
            8119:   NOT   car $STALLION1_RM2 wrecked
        then
            if
                01AD:   car $STALLION1_RM2 0 near_point $STAGE_3_X $STAGE_3_Y 4.0 4.0
            then
                0004: $FLAG_LAUNCH_PERENIAL = 2
                0004: $FLAG_STALLION_ARRIVED = 1
                02AA: set_car $STALLION1_RM2 immune_to_nonplayer 0
                020A: set_car $STALLION1_RM2 door_status_to 1
                if
                    001A:   2 > $FLAG_CARTEL_ARRIVED
                then
                    0004: $FLAG_CARTEL_ARRIVED = 1
                end
            end
        end
    end
    if
        0038:   $FLAG_STALLION_CREATED == 1
    then
        if
            0119:   car $STALLION1_RM2 wrecked
        then
            0004: $FLAG_LAUNCH_PERENIAL = 1
            0164: remove_blip $BLIP_STALLION1
        else
            if
                8185:   NOT   car $STALLION1_RM2 health >= 950
            then
                0004: $FLAG_STALLION_ARRIVED = 1
                if
                    0038:   $FLAG_CARTEL_ARRIVED == 0
                then
                    0004: $FLAG_CARTEL_ARRIVED = 1
                end
            end
        end
    end
    if and
        0018:   $TIMER_DIF_RM2 > 6000
        0038:   $FLAG_PERENIAL_CREATED == 0
        0018:   $FLAG_LAUNCH_PERENIAL > 0
    then
        00A5: $PERENIAL1_RM2 = create_car #COLUMB at $VARMINT_GEN1_X $VARMINT_GEN1_Y -100.0
        02AA: set_car $PERENIAL1_RM2 immune_to_nonplayer 1
        020A: set_car $PERENIAL1_RM2 door_status_to 2
        0186: $BLIP_PERENIAL1 = create_marker_above_car $PERENIAL1_RM2
        0129: $VARMINT_7 = create_actor 12 #GANG12 in_car $PERENIAL1_RM2 driverseat
        01C8: $VARMINT_8 = create_actor 12 #GANG12 in_car $PERENIAL1_RM2 passenger_seat 0
        01C8: $VARMINT_9 = create_actor 12 #GANG12 in_car $PERENIAL1_RM2 passenger_seat 1
        01C8: $VARMINT_10 = create_actor 12 #GANG11 in_car $PERENIAL1_RM2 passenger_seat 2
        00AD: set_car $PERENIAL1_RM2 max_speed_to 10.0
        00AE: set_car $PERENIAL1_RM2 driving_style 3  // DRIVINGMODE_PLOUGHTHROUGH
        02C2: car $PERENIAL1_RM2 drive_to_point $STAGE_1_X $STAGE_1_Y 17.5625
        0004: $FLAG_PERENIAL_CREATED = 1
    end
    if
        0038:   $FLAG_PERENIAL_CREATED == 1
    then
        if
            8119:   NOT   car $PERENIAL1_RM2 wrecked
        then
            if
                01AD:   car $PERENIAL1_RM2 0 near_point $STAGE_1_X $STAGE_1_Y 4.0 4.0
            then
                0004: $FLAG_PERENIAL_ARRIVED = 1
                02AA: set_car $PERENIAL1_RM2 immune_to_nonplayer 0
                020A: set_car $PERENIAL1_RM2 door_status_to 1
                if
                    001A:   2 > $FLAG_CARTEL_ARRIVED
                then
                    0004: $FLAG_CARTEL_ARRIVED = 1
                end
            end
        end
    end
    if
        0038:   $FLAG_PERENIAL_CREATED == 1
    then
        if
            0119:   car $PERENIAL1_RM2 wrecked
        then
            0164: remove_blip $BLIP_PERENIAL1
        else
            if
                8185:   NOT   car $PERENIAL1_RM2 health >= 950
            then
                0004: $FLAG_PERENIAL_ARRIVED = 1
                if
                    0038:   $FLAG_CARTEL_ARRIVED == 0
                then
                    0004: $FLAG_CARTEL_ARRIVED = 1
                end
            end
        end
    end
    //----------------Sneaky backstab----------------------------------------
    if and
        0018:   $FLAG_CARTEL_ARRIVED > 0
        0018:   $TIMER_DIF_RM2 > 12000
    then
        if
            0038:   $FLAG_SNEAKY_1 == 0
        then
            if
                80C2:   NOT   sphere_onscreen -213.75 217.688 17.5 2.5
            then
                009A: $VARMINT_11 = create_actor 12 #GANG11 at -213.75 235.688 17.5
                01B2: give_actor $VARMINT_11 weapon 25 ammo 80  // Load the weapon model before using this
                035F: set_actor $VARMINT_11 armour_to 100
                0162: tie_marker $BLIP_V11 to_actor $VARMINT_11 1 2
                0239: actor $VARMINT_11 run_to $PHILS_DEFCON_X $PHILS_DEFCON_Y
                011A: set_actor $VARMINT_11 flags 1
                011A: set_actor $VARMINT_11 flags 524288
                0291: set_char_heed_threats $VARMINT_11  1
                0004: $FLAG_SNEAKY_1 = 1
            end
        end
        if
            0038:   $FLAG_SNEAKY_2 == 0
        then
            if
                80C2:   NOT   sphere_onscreen -213.75 241.562 17.5 2.5
            then
                009A: $VARMINT_12 = create_actor 12 #GANG11 at -213.75 241.562 17.5
                01B2: give_actor $VARMINT_12 weapon 21 ammo 20  // Load the weapon model before using this
                035F: set_actor $VARMINT_12 armour_to 100
                0162: tie_marker $BLIP_V12 to_actor $VARMINT_12 1 2
                0239: actor $VARMINT_12 run_to -210.875 184.688
                011A: set_actor $VARMINT_12 flags 1
                011A: set_actor $VARMINT_12 flags 524288
                0291: set_char_heed_threats $VARMINT_12  1
                0004: $FLAG_SNEAKY_2 = 1
            end
        end
    end
    if
        0118:   actor $PHIL dead
    then
        0004: $FLAG_PHIL_DEAD = 1
        jump @MISSION_RAY2_FAILED
    end
    if
        0038:   $FLAG_CARTEL_ARRIVED == 1
    then
        03D7: set_wav 1 location $PHILS_DEFCON_X $PHILS_DEFCON_Y $PHILS_DEFCON_Z
        03D1: play_wav 1
        00BC: print_now 'RM2_K' 4000 ms 1   // // Goddam they're here!! LOCK'N'LOAD!!
        0004: $FLAG_CARTEL_ARRIVED = 2
    end
    gosub @VARMINT_DEATHS
    gosub @BIG_BAILOUT_ROUTINE
end //while
//-------All Cartel Varmints dead-----------------------------------------------
if
    8118:   NOT   actor $PHIL dead
then
    0223: set_actor $PHIL health_to 5
end
if
    8118:   NOT   actor $PHIL dead
then
    0350: set_char_stay_in_same_place $PHIL  1
    00A0: store_actor $PHIL position_to $PHILS_DEFCON_X $PHILS_DEFCON_Y $PHILS_DEFCON_Z
    if
        80E3:   NOT   player $PLAYER 0 near_point $PHILS_DEFCON_X $PHILS_DEFCON_Y radius 2.0 2.0
    then
        00BC: print_now 'RM2_G' 2500 ms 1   // // ~g~Go and check on Phil!
        0187: $BLIP_PHIL = create_marker_above_actor $PHIL
        while 80E3:   NOT   player $PLAYER 0 near_point $PHILS_DEFCON_X $PHILS_DEFCON_Y radius 2.0 2.0
            wait 0 ms
            if
                0118:   actor $PHIL dead
            then
                0004: $FLAG_PHIL_DEAD = 1
                0164: remove_blip $BLIP_PHIL
                jump @MISSION_RAY2_FAILED
            end
        end
    end
end
if
    0118:   actor $PHIL dead
then
    0004: $FLAG_PHIL_DEAD = 1
    0164: remove_blip $BLIP_PHIL
    jump @MISSION_RAY2_FAILED
else
    0223: set_actor $PHIL health_to 100
end
0164: remove_blip $BLIP_PHIL
01B4: set_player $PLAYER can_move 0 (frozen)
02A3: toggle_widescreen 1 (on)
015F: set_camera_position -200.438 184.688 17.125 0.0 0.0 0.0
if
    00E0:   player $PLAYER driving
then
    00DA: $PLAYER_RM2 = player $PLAYER car
    0221: set_player $PLAYER trapped_in_car 1
    00A9: set_car $PLAYER_RM2 to_normal_driver
    0158: camera_on_vehicle $PLAYER_RM2 15 2
    01D3: actor $RAY2_PLAYER_ACTOR leave_car $PLAYER_RM2
    while 00DB:   actor $RAY2_PLAYER_ACTOR in_car $PLAYER_RM2
        wait 0 ms
        if
            0119:   car $PLAYER_RM2 wrecked
        then
            jump @BOOBBLE
        end
        if
            0118:   actor $PHIL dead
        then
            0004: $FLAG_PHIL_DEAD = 1
            0164: remove_blip $BLIP_PHIL
            jump @MISSION_RAY2_FAILED
        end
    end
end

:BOOBBLE
01F5: $RAY2_PLAYER_ACTOR = get_player_char $PLAYER
if
    8118:   NOT   actor $PHIL dead
then
    020E: actor $PHIL look_at_actor $RAY2_PLAYER_ACTOR
    0159: camera_on_ped $PHIL 15 2
end
03CF: load_wav 'R2_F' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D7: set_wav 1 location $PHILS_DEFCON_X $PHILS_DEFCON_Y $PHILS_DEFCON_Z
03D1: play_wav 1
00BC: print_now 'RM2_L' 3000 ms 1   // // Heh-hey! If I'd teamed up with you in Nicaragua maybe I'd still have my arm!
while 83D2:   NOT   wav 1 ended
    wait 0 ms
end
if
    0038:   $FLAG_M16_GONE == 0
then
    0215: destroy_pickup $PHILS_M16
end
if
    0038:   $FLAG_SHOTGUN_GONE == 0
then
    0215: destroy_pickup $PHILS_SHOTGUN
end
if
    0038:   $FLAG_UZI_GONE == 0
then
    0215: destroy_pickup $PHILS_UZI
end
if
    0038:   $FLAG_MOLOTOV_GONE == 0
then
    0215: destroy_pickup $PHILS_MOLOTOV
end
if
    0038:   $FLAG_ROCKET_GONE == 0
then
    0215: destroy_pickup $PHILS_ROCKET
end
if
    0038:   $ARMS_SHORTAGE_COMPLETED == 0
then
    0215: destroy_pickup $PHILS_ARMOUR
end
0004: $FLAG_M16_GONE = 1
0004: $FLAG_UZI_GONE = 1
0004: $FLAG_SHOTGUN_GONE = 1
03CF: load_wav 'R2_G' as 1
0213: $PHIL_SHOTGUN = create_pickup #SHOTGUN type 1 at -191.5 170.0 17.5
0213: $PHIL_M16 = create_pickup #M16 type 1 at -189.5 170.0 17.5
0213: $PHIL_ROCKET = create_pickup #ROCKET type 1 at -193.5 170.0 17.5
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D7: set_wav 1 location $PHILS_DEFCON_X $PHILS_DEFCON_Y $PHILS_DEFCON_Z
03D1: play_wav 1
00BC: print_now 'RM2_M' 3000 ms 1   // // If you need any firepower just drop by and take what you need from the lockers.
015F: set_camera_position -191.5 179.0 17.5 0.0 0.0 0.0
0160: point_camera -191.0 170.688 17.5 2
while 83D2:   NOT   wav 1 ended               //10000
    wait 0 ms
end
03CF: load_wav 'R2_H' as 1
while 83D0:   NOT   wav 1 loaded
    wait 0 ms
end
03D7: set_wav 1 location $PHILS_DEFCON_X $PHILS_DEFCON_Y $PHILS_DEFCON_Z
03D1: play_wav 1
00BC: print_now 'RM2_N' 3000 ms 1   // // Leave the cash behind. Now get out of here I'll handle the cops.
while 83D2:   NOT   wav 1 ended            //13000
    wait 0 ms
end
0157: camera_on_player $PLAYER 15 1
wait 2000 ms
if
    8118:   NOT   actor $PHIL dead
then
    011C: actor $PHIL clear_objective
    0211: actor $PHIL walk_to -191.0 174.375
end
while 0038:   $FLAG_PHIL_ARRIVED == 0
    wait 0 ms
    if
        8118:   NOT   actor $PHIL dead
    then
        if
            00ED:   actor $PHIL 0 near_point_on_foot -191.0 174.375 radius 1.0 1.0
        then
            0004: $FLAG_PHIL_ARRIVED = 1
        end
    else
        jump @MISSION_RAY2_FAILED
    end
end //while
009B: destroy_actor_instantly $PHIL
02A3: toggle_widescreen 0 (off)
02EB: restore_camera_jumpcut
01B4: set_player $PLAYER can_move 1 (unfrozen)
jump @MISSION_RAY2_PASSED

:MISSION_RAY2_FAILED
if
    0038:   $FLAG_PHIL_DEAD == 1
then
    00BC: print_now 'RM2_H' 3000 ms 1   // // ~r~Phil has been killed!!
end
00BA: text_styled 'M_FAIL' 2000 ms 1   // // MISSION FAILED!
return

:MISSION_RAY2_PASSED
if
    0038:   $FLAG_M16_GONE == 0
then
    0215: destroy_pickup $PHILS_M16
    0004: $FLAG_M16_GONE = 1
end
if
    0038:   $FLAG_SHOTGUN_GONE == 0
then
    0215: destroy_pickup $PHILS_SHOTGUN
    0004: $FLAG_SHOTGUN_GONE = 1
end
if
    0038:   $FLAG_UZI_GONE == 0
then
    0215: destroy_pickup $PHILS_UZI
    0004: $FLAG_UZI_GONE = 1
end
if
    0038:   $FLAG_MOLOTOV_GONE == 0
then
    0215: destroy_pickup $PHILS_MOLOTOV
    0004: $FLAG_MOLOTOV_GONE = 1
end
if
    0038:   $FLAG_ROCKET_GONE == 0
then
    0215: destroy_pickup $PHILS_ROCKET
    0004: $FLAG_ROCKET_GONE = 1
end
0004: $ARMS_SHORTAGE_COMPLETED = 1
01E3: text_1number_styled 'M_PASS' 10000 5000 ms 1   // // MISSION PASSED! $~1~
0394: play_music 1
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 10000
0318: set_latest_mission_passed 'RM2'   // // 'ARMS SHORTAGE'
030C: set_mission_points += 1
004F: create_thread @RAY_MISSION3_LOOP
return

:MISSION_CLEANUP_RAY2
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_RAY = 0
0004: $ON_ARMS_SHORTAGE_MISSION = 0
01B4: set_player $PLAYER can_move 1 (unfrozen)
02A3: toggle_widescreen 0 (off)
02EB: restore_camera_jumpcut
040D: unload_wav 1
0249: mark_model_as_no_longer_needed #SPECIAL01
0249: mark_model_as_no_longer_needed #RHINO
0249: mark_model_as_no_longer_needed #PATRIOT
0249: mark_model_as_no_longer_needed #BARRACKS
0249: mark_model_as_no_longer_needed #SENTINEL
0249: mark_model_as_no_longer_needed #STALLION
0249: mark_model_as_no_longer_needed #GANG11
0249: mark_model_as_no_longer_needed #SHOTGUN
0249: mark_model_as_no_longer_needed #COLT45
0249: mark_model_as_no_longer_needed #AK47
0296: unload_special_actor 1
0164: remove_blip $BLIP_WAREHOUSE_RM2
0164: remove_blip $BLIP_SENTINEL1
0164: remove_blip $BLIP_STALLION1
0164: remove_blip $BLIP_PERENIAL1
gosub @BLIP_REMOVAL_RM2
if
    0038:   $FLAG_M16_GONE == 0
then
    0215: destroy_pickup $PHILS_M16
end
if
    0038:   $FLAG_SHOTGUN_GONE == 0
then
    0215: destroy_pickup $PHILS_SHOTGUN
end
if
    0038:   $FLAG_UZI_GONE == 0
then
    0215: destroy_pickup $PHILS_UZI
end
if
    0038:   $FLAG_MOLOTOV_GONE == 0
then
    0215: destroy_pickup $PHILS_MOLOTOV
end
if
    0038:   $FLAG_ROCKET_GONE == 0
then
    0215: destroy_pickup $PHILS_ROCKET
end
if
    0038:   $ARMS_SHORTAGE_COMPLETED == 0
then
    0215: destroy_pickup $PHILS_ARMOUR
end
mission_cleanup
return

:BIG_BAILOUT_ROUTINE
if and
    0038:   $STALLION_BAILOUT == 0
    0038:   $FLAG_STALLION_ARRIVED == 1
then
    if
        8118:   NOT   actor $VARMINT_5 dead
    then
        if
            8119:   NOT   car $STALLION1_RM2 wrecked
        then
            01D3: actor $VARMINT_5 leave_car $STALLION1_RM2
            while 00DB:   actor $VARMINT_5 in_car $STALLION1_RM2
                wait 0 ms
                if
                    0119:   car $STALLION1_RM2 wrecked
                then
                    jump @PLOOK2
                end
                if
                    0118:   actor $VARMINT_5 dead
                then
                    jump @PLOOK1
                end
            end //while
            if
                8118:   NOT   actor $VARMINT_5 dead
            then
                0162: tie_marker $BLIP_V5 to_actor $VARMINT_5 1 2
                035F: set_actor $VARMINT_5 armour_to 100
                01B2: give_actor $VARMINT_5 weapon 23 ammo 60  // Load the weapon model before using this
                0239: actor $VARMINT_5 run_to $WH_X_RM2 $WH_Y_RM2
                011A: set_actor $VARMINT_5 flags 1
                011A: set_actor $VARMINT_5 flags 524288
                0291: set_char_heed_threats $VARMINT_5  1
            end
        end
    end
    :PLOOK1
    if
        8118:   NOT   actor $VARMINT_6 dead
    then
        if
            8119:   NOT   car $STALLION1_RM2 wrecked
        then
            01D3: actor $VARMINT_6 leave_car $STALLION1_RM2
            while 00DB:   actor $VARMINT_6 in_car $STALLION1_RM2
                wait 0 ms
                if
                    0119:   car $STALLION1_RM2 wrecked
                then
                    jump @PLOOK2
                end
                if
                    0118:   actor $VARMINT_6 dead
                then
                    jump @PLOOK2
                end
            end //while
            if
                8118:   NOT   actor $VARMINT_6 dead
            then
                0162: tie_marker $BLIP_V6 to_actor $VARMINT_6 1 2
                01B2: give_actor $VARMINT_6 weapon 23 ammo 60  // Load the weapon model before using this
                0239: actor $VARMINT_6 run_to $WH_X_RM2 $WH_Y_RM2
                011A: set_actor $VARMINT_6 flags 1
                011A: set_actor $VARMINT_6 flags 524288
                0291: set_char_heed_threats $VARMINT_6  1
            end
        end
    end
    :PLOOK2
    0164: remove_blip $BLIP_STALLION1
    0004: $STALLION_BAILOUT = 1
end
if and
    0038:   $SENTINEL_BAILOUT == 0
    0038:   $FLAG_SENTINEL_ARRIVED == 1
then
    if
        8118:   NOT   actor $VARMINT_1 dead
    then
        if
            8119:   NOT   car $SENTINEL1_RM2 wrecked
        then
            01D3: actor $VARMINT_1 leave_car $SENTINEL1_RM2
            while 00DB:   actor $VARMINT_1 in_car $SENTINEL1_RM2
                wait 0 ms
                if
                    0119:   car $SENTINEL1_RM2 wrecked
                then
                    jump @PLOOK6
                end
                if
                    0118:   actor $VARMINT_1 dead
                then
                    jump @PLOOK3
                end
            end //while
            if
                8118:   NOT   actor $VARMINT_1 dead
            then
                0162: tie_marker $BLIP_V1 to_actor $VARMINT_1 1 2
                01B2: give_actor $VARMINT_1 weapon 21 ammo 20  // Load the weapon model before using this
                0239: actor $VARMINT_1 run_to $WH_X_RM2 $WH_Y_RM2
                011A: set_actor $VARMINT_1 flags 1
                011A: set_actor $VARMINT_1 flags 524288
                0291: set_char_heed_threats $VARMINT_1  1
            end
        end
    end
    :PLOOK3
    if
        8118:   NOT   actor $VARMINT_2 dead
    then
        if
            8119:   NOT   car $SENTINEL1_RM2 wrecked
        then
            01D3: actor $VARMINT_2 leave_car $SENTINEL1_RM2
            while 00DB:   actor $VARMINT_2 in_car $SENTINEL1_RM2
                wait 0 ms
                if
                    0119:   car $SENTINEL1_RM2 wrecked
                then
                    jump @PLOOK6
                end
                if
                    0118:   actor $VARMINT_2 dead
                then
                    jump @PLOOK4
                end
            end //while
            if
                8118:   NOT   actor $VARMINT_2 dead
            then
                0162: tie_marker $BLIP_V2 to_actor $VARMINT_2 1 2
                01B2: give_actor $VARMINT_2 weapon 21 ammo 20  // Load the weapon model before using this
                0239: actor $VARMINT_2 run_to $WH_X_RM2 $WH_Y_RM2
                011A: set_actor $VARMINT_2 flags 1
                011A: set_actor $VARMINT_2 flags 524288
                0291: set_char_heed_threats $VARMINT_2  1
            end
        end
    end
    :PLOOK4
    if
        8118:   NOT   actor $VARMINT_3 dead
    then
        if
            8119:   NOT   car $SENTINEL1_RM2 wrecked
        then
            01D3: actor $VARMINT_3 leave_car $SENTINEL1_RM2
            while 00DB:   actor $VARMINT_3 in_car $SENTINEL1_RM2
                wait 0 ms
                if
                    0119:   car $SENTINEL1_RM2 wrecked
                then
                    jump @PLOOK6
                end
                if
                    0118:   actor $VARMINT_3 dead
                then
                    jump @PLOOK5
                end
            end //while
            if
                8118:   NOT   actor $VARMINT_3 dead
            then
                0162: tie_marker $BLIP_V3 to_actor $VARMINT_3 1 2
                01B2: give_actor $VARMINT_3 weapon 25 ammo 80  // Load the weapon model before using this
                0239: actor $VARMINT_3 run_to -195.0 209.5
                011A: set_actor $VARMINT_3 flags 1
                011A: set_actor $VARMINT_3 flags 524288
                0291: set_char_heed_threats $VARMINT_3  1
            end
        end
    end
    :PLOOK5
    if
        8118:   NOT   actor $VARMINT_4 dead
    then
        if
            8119:   NOT   car $SENTINEL1_RM2 wrecked
        then
            01D3: actor $VARMINT_4 leave_car $SENTINEL1_RM2
            while 00DB:   actor $VARMINT_4 in_car $SENTINEL1_RM2
                wait 0 ms
                if
                    0119:   car $SENTINEL1_RM2 wrecked
                then
                    jump @PLOOK6
                end
                if
                    0118:   actor $VARMINT_4 dead
                then
                    jump @PLOOK6
                end
            end //while
            if
                8118:   NOT   actor $VARMINT_4 dead
            then
                0162: tie_marker $BLIP_V4 to_actor $VARMINT_4 1 2
                035F: set_actor $VARMINT_4 armour_to 100
                01B2: give_actor $VARMINT_4 weapon 15 ammo 5  // Load the weapon model before using this
                0239: actor $VARMINT_4 run_to $WH_X_RM2 $WH_Y_RM2
                011A: set_actor $VARMINT_4 flags 1
                011A: set_actor $VARMINT_4 flags 524288
                0291: set_char_heed_threats $VARMINT_4  1
            end
        end
    end
    :PLOOK6
    0164: remove_blip $BLIP_SENTINEL1
    0004: $SENTINEL_BAILOUT = 1
end
if and
    0038:   $PERENIAL_BAILOUT == 0
    0038:   $FLAG_PERENIAL_ARRIVED == 1
then
    if
        8118:   NOT   actor $VARMINT_7 dead
    then
        if
            8119:   NOT   car $PERENIAL1_RM2 wrecked
        then
            01D3: actor $VARMINT_7 leave_car $PERENIAL1_RM2
            while 00DB:   actor $VARMINT_7 in_car $PERENIAL1_RM2
                wait 0 ms
                if
                    0119:   car $PERENIAL1_RM2 wrecked
                then
                    jump @PLOOK10
                end
                if
                    0118:   actor $VARMINT_7 dead
                then
                    jump @PLOOK7
                end
            end //while
            if
                8118:   NOT   actor $VARMINT_7 dead
            then
                0162: tie_marker $BLIP_V7 to_actor $VARMINT_7 1 2
                01B2: give_actor $VARMINT_7 weapon 21 ammo 10  // Load the weapon model before using this
                0239: actor $VARMINT_7 run_to $WH_X_RM2 $WH_Y_RM2
                011A: set_actor $VARMINT_7 flags 1
                011A: set_actor $VARMINT_7 flags 524288
                0291: set_char_heed_threats $VARMINT_7  1
            end
        end
    end
    :PLOOK7
    if
        8118:   NOT   actor $VARMINT_8 dead
    then
        if
            8119:   NOT   car $PERENIAL1_RM2 wrecked
        then
            01D3: actor $VARMINT_8 leave_car $PERENIAL1_RM2
            while 00DB:   actor $VARMINT_8 in_car $PERENIAL1_RM2
                wait 0 ms
                if
                    0119:   car $PERENIAL1_RM2 wrecked
                then
                    jump @PLOOK10
                end
                if
                    0118:   actor $VARMINT_8 dead
                then
                    jump @PLOOK8
                end
            end //while
            if
                8118:   NOT   actor $VARMINT_8 dead
            then
                0162: tie_marker $BLIP_V8 to_actor $VARMINT_8 1 2
                01B2: give_actor $VARMINT_8 weapon 25 ammo 45  // Load the weapon model before using this
                0239: actor $VARMINT_8 run_to -205.312 199.75
                011A: set_actor $VARMINT_8 flags 1
                011A: set_actor $VARMINT_8 flags 524288
                0291: set_char_heed_threats $VARMINT_8  1
            end
        end
    end
    :PLOOK8
    if
        8118:   NOT   actor $VARMINT_9 dead
    then
        if
            8119:   NOT   car $PERENIAL1_RM2 wrecked
        then
            01D3: actor $VARMINT_9 leave_car $PERENIAL1_RM2
            while 00DB:   actor $VARMINT_9 in_car $PERENIAL1_RM2
                wait 0 ms
                if
                    0119:   car $PERENIAL1_RM2 wrecked
                then
                    jump @PLOOK10
                end
                if
                    0118:   actor $VARMINT_9 dead
                then
                    jump @PLOOK9
                end
            end //while
            if
                8118:   NOT   actor $VARMINT_9 dead
            then
                0162: tie_marker $BLIP_V9 to_actor $VARMINT_9 1 2
                01B2: give_actor $VARMINT_9 weapon 17 ammo 30  // Load the weapon model before using this
                0239: actor $VARMINT_9 run_to $WH_X_RM2 $WH_Y_RM2
                011A: set_actor $VARMINT_9 flags 1
                011A: set_actor $VARMINT_9 flags 524288
                0291: set_char_heed_threats $VARMINT_9  1
            end
        end
    end
    :PLOOK9
    if
        8118:   NOT   actor $VARMINT_10 dead
    then
        if
            8119:   NOT   car $PERENIAL1_RM2 wrecked
        then
            01D3: actor $VARMINT_10 leave_car $PERENIAL1_RM2
            while 00DB:   actor $VARMINT_10 in_car $PERENIAL1_RM2
                wait 0 ms
                if
                    0119:   car $PERENIAL1_RM2 wrecked
                then
                    jump @PLOOK10
                end
                if
                    0118:   actor $VARMINT_10 dead
                then
                    jump @PLOOK10
                end
            end //while
            if
                8118:   NOT   actor $VARMINT_10 dead
            then
                0162: tie_marker $BLIP_V10 to_actor $VARMINT_10 1 2
                01B2: give_actor $VARMINT_10 weapon 21 ammo 20  // Load the weapon model before using this
                035F: set_actor $VARMINT_10 armour_to 100
                0239: actor $VARMINT_10 run_to $WH_X_RM2 $WH_Y_RM2
                011A: set_actor $VARMINT_10 flags 1
                011A: set_actor $VARMINT_10 flags 524288
                0291: set_char_heed_threats $VARMINT_10  1
            end
        end
    end
    :PLOOK10
    0164: remove_blip $BLIP_PERENIAL1
    0004: $PERENIAL_BAILOUT = 1
end
return

:VARMINT_DEATHS
if
    0038:   $FLAG_SENTINEL_CREATED == 1
then
    if
        0038:   $FLAG_V1_DEAD == 0
    then
        if
            0118:   actor $VARMINT_1 dead
        then
            0004: $FLAG_V1_DEAD = 1
            0008: $COUNTER_DEAD_VARMINTS += 1
            0164: remove_blip $BLIP_V1
        end
    end
    if
        0038:   $FLAG_V2_DEAD == 0
    then
        if
            0118:   actor $VARMINT_2 dead
        then
            0004: $FLAG_V2_DEAD = 1
            0008: $COUNTER_DEAD_VARMINTS += 1
            0164: remove_blip $BLIP_V2
        end
    end
    if
        0038:   $FLAG_V3_DEAD == 0
    then
        if
            0118:   actor $VARMINT_3 dead
        then
            0004: $FLAG_V3_DEAD = 1
            0008: $COUNTER_DEAD_VARMINTS += 1
            0164: remove_blip $BLIP_V3
        end
    end
    if
        0038:   $FLAG_V4_DEAD == 0
    then
        if
            0118:   actor $VARMINT_4 dead
        then
            0004: $FLAG_V4_DEAD = 1
            0008: $COUNTER_DEAD_VARMINTS += 1
            0164: remove_blip $BLIP_V4
        end
    end
end
if
    0038:   $FLAG_STALLION_CREATED == 1
then
    if
        0038:   $FLAG_V5_DEAD == 0
    then
        if
            0118:   actor $VARMINT_5 dead
        then
            0004: $FLAG_V5_DEAD = 1
            0008: $COUNTER_DEAD_VARMINTS += 1
            0164: remove_blip $BLIP_V5
        end
    end
    if
        0038:   $FLAG_V6_DEAD == 0
    then
        if
            0118:   actor $VARMINT_6 dead
        then
            0004: $FLAG_V6_DEAD = 1
            0008: $COUNTER_DEAD_VARMINTS += 1
            0164: remove_blip $BLIP_V6
        end
    end
end
if
    0038:   $FLAG_PERENIAL_CREATED == 1
then
    if
        0038:   $FLAG_V7_DEAD == 0
    then
        if
            0118:   actor $VARMINT_7 dead
        then
            0004: $FLAG_V7_DEAD = 1
            0008: $COUNTER_DEAD_VARMINTS += 1
            0164: remove_blip $BLIP_V7
        end
    end
    if
        0038:   $FLAG_V8_DEAD == 0
    then
        if
            0118:   actor $VARMINT_8 dead
        then
            0004: $FLAG_V8_DEAD = 1
            0008: $COUNTER_DEAD_VARMINTS += 1
            0164: remove_blip $BLIP_V8
        end
    end
    if
        0038:   $FLAG_V9_DEAD == 0
    then
        if
            0118:   actor $VARMINT_9 dead
        then
            0004: $FLAG_V9_DEAD = 1
            0008: $COUNTER_DEAD_VARMINTS += 1
            0164: remove_blip $BLIP_V9
        end
    end
    if
        0038:   $FLAG_V10_DEAD == 0
    then
        if
            0118:   actor $VARMINT_10 dead
        then
            0004: $FLAG_V10_DEAD = 1
            0008: $COUNTER_DEAD_VARMINTS += 1
            0164: remove_blip $BLIP_V10
        end
    end
end
if
    0038:   $FLAG_SNEAKY_1 == 1
then
    if
        0038:   $FLAG_V11_DEAD == 0
    then
        if
            0118:   actor $VARMINT_11 dead
        then
            0004: $FLAG_V11_DEAD = 1
            0008: $COUNTER_DEAD_VARMINTS += 1
            0164: remove_blip $BLIP_V11
        end
    end
end
if
    0038:   $FLAG_SNEAKY_2 == 1
then
    if
        0038:   $FLAG_V12_DEAD == 0
    then
        if
            0118:   actor $VARMINT_12 dead
        then
            0004: $FLAG_V12_DEAD = 1
            0008: $COUNTER_DEAD_VARMINTS += 1
            0164: remove_blip $BLIP_V12
        end
    end
end
return

:PICKUPS
if
    0038:   $FLAG_M16_GONE == 0
then
    if
        0214:   pickup $PHILS_M16 picked_up
    then
        01B8: set_player $PLAYER armed_weapon_to 26
        0004: $FLAG_M16_GONE = 1
    end
end
if
    0038:   $FLAG_UZI_GONE == 0
then
    if
        0214:   pickup $PHILS_UZI picked_up
    then
        01B8: set_player $PLAYER armed_weapon_to 23
        0004: $FLAG_UZI_GONE = 1
    end
end
if
    0038:   $FLAG_ROCKET_GONE == 0
then
    if
        0214:   pickup $PHILS_ROCKET picked_up
    then
        01B8: set_player $PLAYER armed_weapon_to 30
        0004: $FLAG_ROCKET_GONE = 1
    end
end
if
    0038:   $FLAG_SHOTGUN_GONE == 0
then
    if
        0214:   pickup $PHILS_SHOTGUN picked_up
    then
        01B8: set_player $PLAYER armed_weapon_to 21
        0004: $FLAG_SHOTGUN_GONE = 1
    end
end
if
    0038:   $FLAG_MOLOTOV_GONE == 0
then
    if
        0214:   pickup $PHILS_MOLOTOV picked_up
    then
        01B8: set_player $PLAYER armed_weapon_to 15
        0004: $FLAG_MOLOTOV_GONE = 1
    end
end
return

:BLIP_REMOVAL_RM2
0164: remove_blip $BLIP_V1
0164: remove_blip $BLIP_V2
0164: remove_blip $BLIP_V3
0164: remove_blip $BLIP_V4
0164: remove_blip $BLIP_V5
0164: remove_blip $BLIP_V6
0164: remove_blip $BLIP_V7
0164: remove_blip $BLIP_V8
0164: remove_blip $BLIP_V9
0164: remove_blip $BLIP_V10
0164: remove_blip $BLIP_V11
0164: remove_blip $BLIP_V12
return
