//-------------Mission 14-------------
// Originally: Taxi sub-mission

:M14_TAXI
03A4: name_thread 'TAXI'
054C: use_GXT_table 'TAXI'
gosub @MISSION_START_TAXI1
gosub @MISSION_CLEANUP_TAXI1
end_thread

:MISSION_START_TAXI1
0111: set_deatharrest_state 0 (disabled)
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $TAXI_COUNTDOWN_ALREADY_STARTED = 0
0004: $TAXI_COUNTDOWN = 0
0004: $TAXI_PASSED_THIS_SHOT = 0
0004: $TAXI_SCORE = 0
0004: $TAXI_PED1 = -1
0004: $SPRAY_BLIP_ONSCREEN = 0
0004: $TAXI_FUCKED_FLAG = 0
0004: $IN_A_ROW_NUMBER = 5
0004: $IN_A_ROW_CASH = 2000
wait 0 ms
03C4: set_status_text_to $TAXI_PASSED_THIS_SHOT 0 (number)  'FARES'   // FARES:
if
    8256:   NOT   player $PLAYER defined
then
    jump @MISSION_TAXI1_FAILED
end
if
    00E0:   player $PLAYER driving
then
    00DA: $TAXI_CAR = player $PLAYER car
else
    jump @MISSION_TAXI1_FAILED
end
0216: set_car $TAXI_CAR taxi_available_light_to 1 (on)
00BC: print_now 'TAXI1' 1500 ms 1   // ~g~Look for a fare.
wait 0 ms

:START_TAXI_MISSION
if
    0038:   $DISPLAYED_TAXI_HELP_MESSAGE == 0
then
    if
        82BD:   NOT   debug_mode == DEBUG_SKIPHELP
    then
        03E5: text_box 'TAXIH1'   // Stop near a highlighted pedestrian to pick them up then drive them to their destination before the time runs out.
    end
    0004: $DISPLAYED_TAXI_HELP_MESSAGE = 1
end
0004: $SCORE_FOR_THIS_FARE = 0
if
    8256:   NOT   player $PLAYER defined
then
    jump @MISSION_TAXI1_FAILED
end
if
    0119:   car $TAXI_CAR wrecked
then
    jump @MISSION_TAXI1_FAILED
end
if
    80DC:   NOT   player $PLAYER driving $TAXI_CAR
then
   jump @MISSION_TAXI1_FAILED
end
if
    8038:   NOT   $CONTROLMODE == 3
then
    if and
        00E1:   key_pressed 0 19
        0038:   $FLAG_PLAYER_ON_MISSION == 1
    then
        jump @TAXI_FAIL_BUTTON_PRESSED
    end
else
    if and
        00E1:   key_pressed 0 14
        0038:   $FLAG_PLAYER_ON_MISSION == 1
    then
        jump @TAXI_FAIL_BUTTON_PRESSED
    end
end
if and
    0038:   $TAXI_COUNTDOWN_ALREADY_STARTED == 1
    0038:   $TAXI_COUNTDOWN == 0
then
    jump @MISSION_TAXI1_FAILED
end
02DD: set_actor $TAXI_PED1 creation_zone 'VICE_C' 1 1 1
if
    0038:   $TAXI_PED1 == -1
then
    wait 0 ms
    jump @START_TAXI_MISSION
end
009F: set_actor $TAXI_PED1 idle
01ED: reset_actor $TAXI_PED1 flags
0291: set_char_heed_threats $TAXI_PED1  0
0187: $BLIP1_CT1 = create_marker_above_actor $TAXI_PED1
0365: set_actor $TAXI_PED1 objective_hail_taxi

:PED_GET_IN_TAXI
while true
    if or
        80FD:   NOT   player $PLAYER 0 near_actor $TAXI_PED1 in_car radius 7.0 7.0 2.0
        81C1:   NOT   car $TAXI_CAR stopped
    jf break
    wait 0 ms
    if
        8256:   NOT   player $PLAYER defined
    then
        jump @MISSION_TAXI1_FAILED
    end
    if
        0119:   car $TAXI_CAR wrecked
    then
        jump @MISSION_TAXI1_FAILED
    end
    if
        0118:   actor $TAXI_PED1 dead
    then
        jump @MISSION_TAXI1_PASSED
    end
    if
        80DC:   NOT   player $PLAYER driving $TAXI_CAR
    then
        jump @MISSION_TAXI1_FAILED
    end
    if
        80FD:   NOT   player $PLAYER 0 near_actor $TAXI_PED1 in_car radius 90.0 90.0 20.0
    then
        jump @MISSION_TAXI1_PASSED
    end
    if
        8038:   NOT   $CONTROLMODE == 3
    then
        if and
            00E1:   key_pressed 0 19
            0038:   $FLAG_PLAYER_ON_MISSION == 1
        then
            jump @TAXI_FAIL_BUTTON_PRESSED
        end
    else
        if and
            00E1:   key_pressed 0 14
            0038:   $FLAG_PLAYER_ON_MISSION == 1
        then
            jump @TAXI_FAIL_BUTTON_PRESSED
        end
    end
    if and
        0038:   $TAXI_COUNTDOWN_ALREADY_STARTED == 1
        0038:   $TAXI_COUNTDOWN == 0
    then
        jump @MISSION_TAXI1_FAILED
    end
    if and
        0185:   car $TAXI_CAR health >= 500
        0038:   $SPRAY_BLIP_ONSCREEN == 1
    then
        0164: remove_blip $SPRAY_TAXI
        0004: $SPRAY_BLIP_ONSCREEN = 0
        0004: $TAXI_FUCKED_FLAG = 0
    end
    if
        8118:   NOT   actor $TAXI_PED1 dead
    then
        020F: actor $TAXI_PED1 look_at_player $PLAYER
    end
end
if
    8185:   NOT   car $TAXI_CAR health >= 500
then
    00BC: print_now 'TAXI7' 4000 ms 1   // ~r~Your car is trashed, get it repaired.
    if
        0038:   $SPRAY_BLIP_ONSCREEN == 0
    then
        0164: remove_blip $SPRAY_TAXI
        if
            03C6:   is_collision_in_memory 1
        then
            02A8: $SPRAY_TAXI = create_marker 21 at 590.0 -359.5 -100.0
        end
        if
            03C6:   is_collision_in_memory 2
        then
            02A8: $SPRAY_TAXI = create_marker 21 at 44.0 -493.75 -100.0
        end
        if
            03C6:   is_collision_in_memory 3
        then
            02A8: $SPRAY_TAXI = create_marker 21 at -1463.0 32.5 -100.0
        end
        0004: $SPRAY_BLIP_ONSCREEN = 1
        0004: $TAXI_FUCKED_FLAG = 1
    end
    jump @MISSION_TAXI1_PASSED
end
0319: set_actor $TAXI_PED1 running 1
01D4: actor $TAXI_PED1 go_to_car $TAXI_CAR and_enter_it_as_a_passenger

while 80DB:   NOT   actor $TAXI_PED1 in_car $TAXI_CAR
    wait 0 ms
    if
        8256:   NOT   player $PLAYER defined
    then
        jump @MISSION_TAXI1_FAILED
    end
    if
        0119:   car $TAXI_CAR wrecked
    then
        jump @MISSION_TAXI1_FAILED
    end
    if
        0118:   actor $TAXI_PED1 dead
    then
        jump @MISSION_TAXI1_PASSED
    end
    if
        80DC:   NOT   player $PLAYER driving $TAXI_CAR
    then
        jump @MISSION_TAXI1_FAILED
    end
    if
        80FD:   NOT   player $PLAYER 0 near_actor $TAXI_PED1 in_car radius 90.0 90.0 20.0
    then
        jump @MISSION_TAXI1_PASSED
    end
    if
        8038:   NOT   $CONTROLMODE == 3
    then
        if and
            00E1:   key_pressed 0 19
            0038:   $FLAG_PLAYER_ON_MISSION == 1
        then
            jump @TAXI_FAIL_BUTTON_PRESSED
        end
    else
        if and
            00E1:   key_pressed 0 14
            0038:   $FLAG_PLAYER_ON_MISSION == 1
        then
            jump @TAXI_FAIL_BUTTON_PRESSED
        end
    end
    if and
        0038:   $TAXI_COUNTDOWN_ALREADY_STARTED == 1
        0038:   $TAXI_COUNTDOWN == 0
    then
        jump @MISSION_TAXI1_FAILED
    end
    if and
        0185:   car $TAXI_CAR health >= 500
        0038:   $SPRAY_BLIP_ONSCREEN == 1
    then
        0164: remove_blip $SPRAY_TAXI
        0004: $SPRAY_BLIP_ONSCREEN = 0
    end
    if
        80FD:   NOT   player $PLAYER 0 near_actor $TAXI_PED1 in_car radius 7.0 7.0 2.0
    then
        jump @PED_GET_IN_TAXI
    end
end
00A0: store_actor $TAXI_PED1 position_to $TAXI_PED_X $TAXI_PED_Y $TAXI_PED_Z
0164: remove_blip $BLIP1_CT1
0216: set_car $TAXI_CAR taxi_available_light_to 0 (off)

:PASSENGER_DESTINATION
wait 0 ms
if
    8256:   NOT   player $PLAYER defined
then
    jump @MISSION_TAXI1_FAILED
end
if
    03C6:   is_collision_in_memory 1
then
    0209: $BEEN_IN_TAXI1_BEFORE = random_int 1 11
    if
        8256:   NOT   player $PLAYER defined
    then
        jump @MISSION_TAXI1_FAILED
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 1
    then
        if
            0121:   player $PLAYER in_zone 'REDLIGH'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE1' 5000 ms 1   // ~g~Destination ~w~'Meeouch Sex Kitten Club' ~g~in Redlight.
        0005: $TAXI_DESTX1 = 601.25
        0005: $TAXI_DESTY1 = -462.5625
        0005: $TAXI_DESTZ1 = 20.375
        0005: $TAXI_DESTX2 = 578.6875
        0005: $TAXI_DESTY2 = -456.0
        0005: $TAXI_DESTZ2 = 22.375
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 2
    then
        if
            0121:   player $PLAYER in_zone 'S_VIEW'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE2' 5000 ms 1   // ~g~Destination ~w~'Supa Save' ~g~in Portland View.
        0005: $TAXI_DESTX1 = 933.5
        0005: $TAXI_DESTY1 = -616.375
        0005: $TAXI_DESTZ1 = 17.6875
        0005: $TAXI_DESTX2 = 953.25
        0005: $TAXI_DESTY2 = -627.5625
        0005: $TAXI_DESTZ2 = 19.6875
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 3
    then
        if
            0121:   player $PLAYER in_zone 'CHINA'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE3' 5000 ms 1   // ~g~Destination ~w~'old school hall' ~g~in Chinatown.
        0005: $TAXI_DESTX1 = 673.875
        0005: $TAXI_DESTY1 = -871.875
        0005: $TAXI_DESTZ1 = 20.375
        0005: $TAXI_DESTX2 = 660.25
        0005: $TAXI_DESTY2 = -881.875
        0005: $TAXI_DESTZ2 = 22.375
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 4
    then
        if
            0121:   player $PLAYER in_zone 'PORT_W'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE4' 5000 ms 1   // ~g~Destination ~w~'Greasy Joe's Cafe' ~g~in Callahan Point.
        0005: $TAXI_DESTX1 = 514.25
        0005: $TAXI_DESTY1 = -990.0625
        0005: $TAXI_DESTZ1 = 10.5
        0005: $TAXI_DESTX2 = 534.375
        0005: $TAXI_DESTY2 = -1002.563
        0005: $TAXI_DESTZ2 = 12.5
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 5
    then
        if
            0121:   player $PLAYER in_zone 'REDLIGH'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE5' 5000 ms 1   // ~g~Destination ~w~'AmmuNation' ~g~in Redlight.
        0005: $TAXI_DESTX1 = 730.375
        0005: $TAXI_DESTY1 = -394.0625
        0005: $TAXI_DESTZ1 = 20.25
        0005: $TAXI_DESTX2 = 722.875
        0005: $TAXI_DESTY2 = -408.875
        0005: $TAXI_DESTZ2 = 22.25
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 6
    then
        if
            0121:   player $PLAYER in_zone 'LITTLEI'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE6' 5000 ms 1   // ~g~Destination ~w~'Easy Credit Autos' ~g~in Saint Mark's.
        0005: $TAXI_DESTX1 = 872.0
        0005: $TAXI_DESTY1 = -122.0
        0005: $TAXI_DESTZ1 = 20.0
        0005: $TAXI_DESTX2 = 889.0
        0005: $TAXI_DESTY2 = -108.0
        0005: $TAXI_DESTZ2 = 22.0
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 7
    then
        if
            0121:   player $PLAYER in_zone 'REDLIGH'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE7' 5000 ms 1   // ~g~Destination ~w~'Woody's topless bar' ~g~in Redlight.
        0005: $TAXI_DESTX1 = 577.875
        0005: $TAXI_DESTY1 = -419.0
        0005: $TAXI_DESTZ1 = 20.0
        0005: $TAXI_DESTX2 = 584.5
        0005: $TAXI_DESTY2 = -401.25
        0005: $TAXI_DESTZ2 = 22.0
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 8
    then
        if
            0121:   player $PLAYER in_zone 'LITTLEI'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE8' 5000 ms 1   // ~g~Destination ~w~'Marcos Bistro' ~g~in Saint Mark's.
        0005: $TAXI_DESTX1 = 1010.75
        0005: $TAXI_DESTY1 = -461.75
        0005: $TAXI_DESTZ1 = 55.375
        0005: $TAXI_DESTX2 = 999.688
        0005: $TAXI_DESTY2 = -447.0
        0005: $TAXI_DESTZ2 = 57.375
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 9
    then
        if
            0121:   player $PLAYER in_zone 'PORT_E'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE9' 5000 ms 1   // ~g~Destination ~w~'import export garage' ~g~in Portland Harbor.
        0005: $TAXI_DESTX1 = 1140.0
        0005: $TAXI_DESTY1 = -686.0
        0005: $TAXI_DESTZ1 = 17.25
        0005: $TAXI_DESTX2 = 1150.25
        0005: $TAXI_DESTY2 = -667.5
        0005: $TAXI_DESTZ2 = 19.25
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 10
    then
        if
            0121:   player $PLAYER in_zone 'CHINA'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE10' 5000 ms 1   // ~g~Destination ~w~'Punk Noodles' ~g~in Chinatown.
        0005: $TAXI_DESTX1 = 704.063
        0005: $TAXI_DESTY1 = -660.0625
        0005: $TAXI_DESTZ1 = 20.375
        0005: $TAXI_DESTX2 = 708.875
        0005: $TAXI_DESTY2 = -647.875
        0005: $TAXI_DESTZ2 = 22.375
    end
end
if
    03C6:   is_collision_in_memory 2
then
    0209: $BEEN_IN_TAXI1_BEFORE = random_int 11 21
    if
        8256:   NOT   player $PLAYER defined
    then
        jump @MISSION_TAXI1_FAILED
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 11
    then
        if
            0121:   player $PLAYER in_zone 'CONSTRU'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE11' 5000 ms 1   // ~g~Destination ~w~'Construction site' ~g~in Fort staunton.
        0005: $TAXI_DESTX1 = 106.8125
        0005: $TAXI_DESTY1 = -193.0
        0005: $TAXI_DESTZ1 = 26.3125
        0005: $TAXI_DESTX2 = 112.375
        0005: $TAXI_DESTY2 = -201.875
        0005: $TAXI_DESTZ2 = 28.1875
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 12
    then
        if
            0121:   player $PLAYER in_zone 'STADIUM'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE12' 5000 ms 1   // ~g~Destination ~w~'Football Stadium' ~g~in Aspatria.
        0005: $TAXI_DESTX1 = -362.0
        0005: $TAXI_DESTY1 = -269.5625
        0005: $TAXI_DESTZ1 = 20.9375
        0005: $TAXI_DESTX2 = -346.6875
        0005: $TAXI_DESTY2 = -278.875
        0005: $TAXI_DESTZ2 = 22.875
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 13
    then
        if
            0121:   player $PLAYER in_zone 'SHOPING'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE13' 5000 ms 1   // ~g~Destination ~w~'The Church' ~g~in Bedford Point
        0005: $TAXI_DESTX1 = -312.9375
        0005: $TAXI_DESTY1 = -1136.938
        0005: $TAXI_DESTZ1 = 31.125
        0005: $TAXI_DESTX2 = -306.0625
        0005: $TAXI_DESTY2 = -1125.625
        0005: $TAXI_DESTZ2 = 33.0625
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 14
    then
        if
            0121:   player $PLAYER in_zone 'YAKUSA'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE14' 5000 ms 1   // ~g~Destination ~w~'The Casino' ~g~in Torrington
        0005: $TAXI_DESTX1 = 86.375
        0005: $TAXI_DESTY1 = -1390.813
        0005: $TAXI_DESTZ1 = 30.9375
        0005: $TAXI_DESTX2 = 80.4375
        0005: $TAXI_DESTY2 = -1401.188
        0005: $TAXI_DESTZ2 = 32.875
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 15
    then
        if
            0121:   player $PLAYER in_zone 'UNIVERS'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE15' 5000 ms 1   // ~g~Destination ~w~'Liberty University' ~g~in Liberty Campus
        0005: $TAXI_DESTX1 = -151.875
        0005: $TAXI_DESTY1 = -215.5
        0005: $TAXI_DESTZ1 = 23.0
        0005: $TAXI_DESTX2 = -167.8125
        0005: $TAXI_DESTY2 = -221.1875
        0005: $TAXI_DESTZ2 = 25.25
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 16
    then
        if
            0121:   player $PLAYER in_zone 'PARK'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE16' 5000 ms 1   // ~g~Destination ~w~'Shopping Mall' ~g~in Belleville Park Area
        0005: $TAXI_DESTX1 = -141.25
        0005: $TAXI_DESTY1 = -626.1875
        0005: $TAXI_DESTZ1 = 31.0625
        0005: $TAXI_DESTX2 = -154.0
        0005: $TAXI_DESTY2 = -616.5
        0005: $TAXI_DESTZ2 = 33.0625
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 17
    then
        if
            0121:   player $PLAYER in_zone 'COM_EAS'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE17' 5000 ms 1   // ~g~Destination ~w~'Museum' ~g~in Newport
        0005: $TAXI_DESTX1 = -8.9375
        0005: $TAXI_DESTY1 = -1001.688
        0005: $TAXI_DESTZ1 = 35.0
        0005: $TAXI_DESTX2 = -18.75
        0005: $TAXI_DESTY2 = -1012.375
        0005: $TAXI_DESTZ2 = 30.4375
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 18
    then
        if
            0121:   player $PLAYER in_zone 'YAKUSA'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE18' 5000 ms 1   // ~g~Destination ~w~'AmCo Building' ~g~in Torrington
        0005: $TAXI_DESTX1 = -88.8125
        0005: $TAXI_DESTY1 = -1192.75
        0005: $TAXI_DESTZ1 = 30.6875
        0005: $TAXI_DESTX2 = -78.375
        0005: $TAXI_DESTY2 = -1184.125
        0005: $TAXI_DESTZ2 = 32.6875
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 19
    then
        if
            0121:   player $PLAYER in_zone 'SHOPING'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE19' 5000 ms 1   // ~g~Destination ~w~'Bolt Burgers' ~g~in Bedford Point
        0005: $TAXI_DESTX1 = -306.3125
        0005: $TAXI_DESTY1 = -1066.625
        0005: $TAXI_DESTZ1 = 32.6875
        0005: $TAXI_DESTX2 = -300.9375
        0005: $TAXI_DESTY2 = -1078.938
        0005: $TAXI_DESTZ2 = 30.9375
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 20
    then
        if
            0121:   player $PLAYER in_zone 'PARK'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE20' 5000 ms 1   // ~g~Destination ~w~'The Park' ~g~in Belleville
        0005: $TAXI_DESTX1 = -307.5
        0005: $TAXI_DESTY1 = -776.375
        0005: $TAXI_DESTZ1 = 32.25
        0005: $TAXI_DESTX2 = -296.25
        0005: $TAXI_DESTY2 = -765.0
        0005: $TAXI_DESTZ2 = 34.5625
    end
end
if
    03C6:   is_collision_in_memory 3
then
    0209: $BEEN_IN_TAXI1_BEFORE = random_int 21 27
    if
        8256:   NOT   player $PLAYER defined
    then
        jump @MISSION_TAXI1_FAILED
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 21
    then
        if
            0121:   player $PLAYER in_zone 'AIRPORT'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE21' 5000 ms 1   // ~g~Destination ~w~'Francis intl. Airport'
        0005: $TAXI_DESTX1 = -1079.5
        0005: $TAXI_DESTY1 = -598.5625
        0005: $TAXI_DESTZ1 = 14.0
        0005: $TAXI_DESTX2 = -1087.0
        0005: $TAXI_DESTY2 = -617.1875
        0005: $TAXI_DESTZ2 = 21.0
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 22
    then
        if
            0121:   player $PLAYER in_zone 'BIG_DAM'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE22' 5000 ms 1   // ~g~Destination ~w~'Cochrane Dam'
        0005: $TAXI_DESTX1 = -1446.25
        0005: $TAXI_DESTY1 = 522.875
        0005: $TAXI_DESTZ1 = 71.0
        0005: $TAXI_DESTX2 = -1436.0
        0005: $TAXI_DESTY2 = 516.6875
        0005: $TAXI_DESTZ2 = 76.0
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 23
    then
        if
            0121:   player $PLAYER in_zone 'SUB_IND'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE23' 5000 ms 1   // ~g~Destination ~w~'import export garage' ~g~in Cochrane Dam district
        0005: $TAXI_DESTX1 = -1442.875
        0005: $TAXI_DESTY1 = 163.5
        0005: $TAXI_DESTZ1 = 56.0
        0005: $TAXI_DESTX2 = -1450.375
        0005: $TAXI_DESTY2 = 155.5625
        0005: $TAXI_DESTZ2 = 74.0
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 24
    then
        if
            0121:   player $PLAYER in_zone 'SUB_IND'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE24' 5000 ms 1   // ~g~Destination ~w~'The hospital' ~g~in Pike Creek
        0005: $TAXI_DESTX1 = -1588.0
        0005: $TAXI_DESTY1 = -136.5625
        0005: $TAXI_DESTZ1 = 61.0
        0005: $TAXI_DESTX2 = -1595.25
        0005: $TAXI_DESTY2 = -148.375
        0005: $TAXI_DESTZ2 = 68.0
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 25
    then
        if or
            0121:   player $PLAYER in_zone 'SUB_ZO2'
            0121:   player $PLAYER in_zone 'SUB_ZO3'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE25' 5000 ms 1   // ~g~Destination ~w~'The Park' ~g~in Shoreside Vale
        0005: $TAXI_DESTX1 = -565.0625
        0005: $TAXI_DESTY1 = 311.5
        0005: $TAXI_DESTZ1 = 6.0
        0005: $TAXI_DESTX2 = -555.1875
        0005: $TAXI_DESTY2 = 322.5
        0005: $TAXI_DESTZ2 = 16.0
    end
    if
        0038:   $BEEN_IN_TAXI1_BEFORE == 26
    then
        if or
            0121:   player $PLAYER in_zone 'PROJECT'
            0121:   player $PLAYER in_zone 'SWANKS'
        then
            jump @PASSENGER_DESTINATION
        end
        00BC: print_now 'FARE26' 5000 ms 1   // ~g~Destination ~w~'North West Towers' ~g~in Wichita Gardens
        0005: $TAXI_DESTX1 = -1017.5
        0005: $TAXI_DESTY1 = 95.25
        0005: $TAXI_DESTZ1 = 16.0
        0005: $TAXI_DESTX2 = -1008.0
        0005: $TAXI_DESTY2 = 88.375
        0005: $TAXI_DESTZ2 = 31.0
    end
end
0086: $TAXI_BLIPX = $TAXI_DESTX1
0059: $TAXI_BLIPX += $TAXI_DESTX2
0015: $TAXI_BLIPX /= 2.0
0086: $TAXI_BLIPY = $TAXI_DESTY1
0059: $TAXI_BLIPY += $TAXI_DESTY2
0015: $TAXI_BLIPY /= 2.0
0086: $TAXI_BLIPZ = $TAXI_DESTZ1
0059: $TAXI_BLIPZ += $TAXI_DESTZ2
0015: $TAXI_BLIPZ /= 2.0
018A: $BLIP2_CT1 = create_checkpoint_at $TAXI_BLIPX $TAXI_BLIPY $TAXI_BLIPZ  // don't use -100.0
018B: change_blip $BLIP2_CT1 display 2
if
    0119:   car $TAXI_CAR wrecked
then
    jump @MISSION_TAXI1_FAILED
end
0086: $X_DIFF = $TAXI_PED_X
0061: $X_DIFF -= $TAXI_BLIPX
0086: $Y_DIFF = $TAXI_PED_Y
0061: $Y_DIFF -= $TAXI_BLIPY
0086: $X_DIFF_SQ = $X_DIFF
0069: $X_DIFF_SQ *= $X_DIFF
0086: $Y_DIFF_SQ = $Y_DIFF
0069: $Y_DIFF_SQ *= $Y_DIFF
0086: $TAXI_DISTANCE_SQ = $X_DIFF_SQ
0059: $TAXI_DISTANCE_SQ += $Y_DIFF_SQ
01FB: $TAXI_DISTANCE = square_root $TAXI_DISTANCE_SQ
008C: $TAXI_DISTANCE_INT = float_to_integer $TAXI_DISTANCE
0084: $TAXI_DISTANCE_INT_OLD = $TAXI_DISTANCE_INT
if
    03C6:   is_collision_in_memory 1
then
    if
        0038:   $TAXI_PASSED_THIS_SHOT == 0
    then
        0010: $TAXI_DISTANCE_INT *= 100
    end
end
if
    03C6:   is_collision_in_memory 2
then
    if
        0038:   $TAXI_PASSED_THIS_SHOT == 0
    then
        0010: $TAXI_DISTANCE_INT *= 95
    end
end
if
    03C6:   is_collision_in_memory 3
then
    if
        0038:   $TAXI_PASSED_THIS_SHOT == 0
    then
        0010: $TAXI_DISTANCE_INT *= 115
    end
end
if
    0038:   $TAXI_PASSED_THIS_SHOT == 1
then
    0010: $TAXI_DISTANCE_INT *= 90
end
if
    0038:   $TAXI_PASSED_THIS_SHOT == 2
then
    0010: $TAXI_DISTANCE_INT *= 85
end
if
    0038:   $TAXI_PASSED_THIS_SHOT == 3
then
    0010: $TAXI_DISTANCE_INT *= 84
end
if
    0038:   $TAXI_PASSED_THIS_SHOT == 4
then
    0010: $TAXI_DISTANCE_INT *= 83
end
if
    0038:   $TAXI_PASSED_THIS_SHOT == 5
then
    0010: $TAXI_DISTANCE_INT *= 82
end
if and
    0018:   $TAXI_PASSED_THIS_SHOT > 5
    002A:   10 >= $TAXI_PASSED_THIS_SHOT
then
    0010: $TAXI_DISTANCE_INT *= 80
end
if and
    0018:   $TAXI_PASSED_THIS_SHOT > 11
    002A:   20 >= $TAXI_PASSED_THIS_SHOT
then
    0010: $TAXI_DISTANCE_INT *= 75
end
if and
    0018:   $TAXI_PASSED_THIS_SHOT > 20
    002A:   50 >= $TAXI_PASSED_THIS_SHOT
then
    0010: $TAXI_DISTANCE_INT *= 70
end
if
    0018:   $TAXI_PASSED_THIS_SHOT > 50
then
    0010: $TAXI_DISTANCE_INT *= 60
end
0058: $TAXI_COUNTDOWN += $TAXI_DISTANCE_INT
0084: $SPEEDBONUS = $TAXI_DISTANCE_INT
0014: $SPEEDBONUS /= 100
0010: $SPEEDBONUS *= 65
0006: 17@ = 0
if
    0038:   $TAXI_COUNTDOWN_ALREADY_STARTED == 0
then
    03C3: set_timer_with_text_to $TAXI_COUNTDOWN type 1 text 'SEG3_1'
    0004: $TAXI_COUNTDOWN_ALREADY_STARTED = 1
end
if
    03C6:   is_collision_in_memory 3
then
    if
        0038:   $TAXI_PASSED_THIS_SHOT == 0
    then
        0008: $TAXI_COUNTDOWN += 15000
    end
else
    if
        0038:   $TAXI_PASSED_THIS_SHOT == 0
    then
        0008: $TAXI_COUNTDOWN += 10000
    end
end

while true
    if or
        80FA:   NOT   player $PLAYER stopped 1 near_point_in_car $TAXI_BLIPX $TAXI_BLIPY $TAXI_BLIPZ radius 4.0 4.0 4.0
        80DC:   NOT   player $PLAYER driving $TAXI_CAR
    jf break
    wait 0 ms
    if
        8256:   NOT   player $PLAYER defined
    then
        jump @MISSION_TAXI1_FAILED
    end
    if
        0119:   car $TAXI_CAR wrecked
    then
        jump @MISSION_TAXI1_FAILED
    end
    if
        80DC:   NOT   player $PLAYER driving $TAXI_CAR
    then
        jump @MISSION_TAXI1_FAILED
    end
    0293: $CONTROLMODE = current_controls
    if
        8038:   NOT   $CONTROLMODE == 3
    then
        if and
            00E1:   key_pressed 0 19
            0038:   $FLAG_PLAYER_ON_MISSION == 1
        then
            jump @TAXI_FAIL_BUTTON_PRESSED
        end
    else
        if and
            00E1:   key_pressed 0 14
            0038:   $FLAG_PLAYER_ON_MISSION == 1
        then
            jump @TAXI_FAIL_BUTTON_PRESSED
        end
    end
    if
        0038:   $TAXI_COUNTDOWN == 0
    then
        jump @TAXI_OUT_OF_TIME
    end
    if
        8185:   NOT   car $TAXI_CAR health >= 500
    then
        if
            0038:   $SPRAY_BLIP_ONSCREEN == 0
        then
            0164: remove_blip $SPRAY_TAXI
            if
                03C6:   is_collision_in_memory 1
            then
                02A8: $SPRAY_TAXI = create_marker 21 at 590.0 -359.5  16.0
            end
            if
                03C6:   is_collision_in_memory 2
            then
                02A8: $SPRAY_TAXI = create_marker 21 at 44.0 -493.75 -100.0
            end
            if
                03C6:   is_collision_in_memory 3
            then
                02A8: $SPRAY_TAXI = create_marker 21 at -1463.0 32.5 -100.0
            end
            0004: $SPRAY_BLIP_ONSCREEN = 1
            gosub @TAXI_FUCKED
            jump @MISSION_TAXI1_PASSED
        end
    end
    if
        8119:   NOT   car $TAXI_CAR wrecked
    then
        if and
            0185:   car $TAXI_CAR health >= 500
            0038:   $SPRAY_BLIP_ONSCREEN == 1
        then
            0164: remove_blip $SPRAY_TAXI
            0004: $SPRAY_BLIP_ONSCREEN = 0
            0004: $TAXI_FUCKED_FLAG = 0
        end
    end
    if and
        01F4:   car $TAXI_CAR flipped
        01C1:   car $TAXI_CAR stopped
    then
        jump @TAXI_FUCKED
    end
end //while
if
    03C6:   is_collision_in_memory 3
then
    if
        001F:   17@ > $SPEEDBONUS
    then
        0084: $SCORE_FOR_THIS_FARE = $TAXI_DISTANCE_INT_OLD
        00BA: text_styled 'TAXI4' 5000 ms 5   // Fare complete!
    else
        0084: $SCORE_FOR_THIS_FARE = $TAXI_DISTANCE_INT_OLD
        0010: $SCORE_FOR_THIS_FARE *= 2
        00BA: text_styled 'TAXI5' 5000 ms 5   // SPEED BONUS!!
    end
else
    if
        001F:   17@ > $SPEEDBONUS
    then
        0084: $SCORE_FOR_THIS_FARE = $TAXI_DISTANCE_INT_OLD
        0014: $SCORE_FOR_THIS_FARE /= 2
        00BA: text_styled 'TAXI4' 5000 ms 5   // Fare complete!
    else
        0084: $SCORE_FOR_THIS_FARE = $TAXI_DISTANCE_INT_OLD
        00BA: text_styled 'TAXI5' 5000 ms 5   // SPEED BONUS!!
    end
end
0109: player $PLAYER money += $SCORE_FOR_THIS_FARE
01E3: text_1number_styled 'TSCORE2' $SCORE_FOR_THIS_FARE 6000 ms 6   // $~1~
018C: play_sound 1 at 0.0 0.0 0.0
0058: $TAXI_SCORE += $SCORE_FOR_THIS_FARE
0008: $TAXI_MISSION_DELIVERIES += 1
0315: increment_taxi_dropoffs
0008: $TAXI_PASSED_THIS_SHOT += 1
if and
    0038:   $NEW_TAXI_CREATED_BEFORE == 0
    0038:   $TAXI_MISSION_DELIVERIES == 100
then
    014D: add_pager_message 'NEW_TAX'  140  2  0   // BIGGER! FASTER! HARDER! new Borgnine taxis open for business in Harwood. Call 555-BORGNINE today!
    014C: set_parked_car_generator $SWANK_TAXI cars_to_generate_to 101
    030C: set_mission_points += 1
    0004: $NEW_TAXI_CREATED_BEFORE = 1
end
0008: $TAXI_COUNTDOWN += 10000
gosub @MISSION_TAXI1_FAILED
if
    003A:   $TAXI_PASSED_THIS_SHOT == $IN_A_ROW_NUMBER
then
    036D: text_2numbers_styled 'IN_ROW' $TAXI_PASSED_THIS_SHOT $IN_A_ROW_CASH 5000 ms 6   // ~1~ IN A ROW bonus! $~1~
    0109: player $PLAYER money += $IN_A_ROW_CASH
    0058: $TAXI_SCORE += $IN_A_ROW_CASH
    0008: $IN_A_ROW_NUMBER += 5
    0008: $IN_A_ROW_CASH += 2000
end
jump @MISSION_TAXI1_PASSED

:TAXI_OUT_OF_TIME
00BC: print_now 'TAXI2' 5000 ms 1   // ~r~You're out of time!
jump @MISSION_TAXI1_FAILED

:TAXI_FUCKED
wait 0 ms
00BC: print_now 'TAXI3' 5000 ms 1   // ~r~Your passenger fled in terror!
if
    8118:   NOT   actor $TAXI_PED1 dead
then
    0193: set_actor $TAXI_PED1 objective_to_act_like_ped
end
0004: $TAXI_FUCKED_FLAG = 1
jump @MISSION_TAXI1_FAILED

:TAXI_FAIL_BUTTON_PRESSED
0293: $CONTROLMODE = current_controls
if
    8038:   NOT   $CONTROLMODE == 3
then
    while 00E1:   key_pressed 0 19
        wait 0 ms
        if
            8256:   NOT   player $PLAYER defined
        then
            jump @MISSION_TAXI1_FAILED
        end
    end
else
    while 00E1:   key_pressed 0 14
        wait 0 ms
        if
            8256:   NOT   player $PLAYER defined
        then
            jump @MISSION_TAXI1_FAILED
        end
    end
end
jump @MISSION_TAXI1_FAILED

:MISSION_TAXI1_PASSED
0164: remove_blip $BLIP1_CT1
0164: remove_blip $BLIP2_CT1
01C2: remove_references_to_actor $TAXI_PED1  // Like turning an actor into a random pedestrian
if
    8119:   NOT   car $TAXI_CAR wrecked
then
    0216: set_car $TAXI_CAR taxi_available_light_to 1 (on)
end
wait 0 ms
00BB: text_lowpriority 'TAXI1' 1500 ms 1   // ~g~Look for a fare.
jump @START_TAXI_MISSION
return

:MISSION_TAXI1_FAILED
if
    8118:   NOT   actor $TAXI_PED1 dead
then
    if
        8119:   NOT   car $TAXI_CAR wrecked
    then
        if
            00DB:   actor $TAXI_PED1 in_car $TAXI_CAR
        then
            01D3: actor $TAXI_PED1 leave_car $TAXI_CAR
            if
                0256:   player $PLAYER defined
            then
                01B4: set_player $PLAYER can_move 0 (frozen)
            end
            while 00DB:   actor $TAXI_PED1 in_car $TAXI_CAR
                wait 0 ms
                if or
                    0118:   actor $TAXI_PED1 dead
                    0119:   car $TAXI_CAR wrecked
                then
                    jump @TAXI_PED_LEAVE2
                end
                if
                    8256:   NOT   player $PLAYER defined
                then
                    jump @TAXI_PED_LEAVE2
                end
                if
                    80DC:   NOT   player $PLAYER driving $TAXI_CAR
                then
                    jump @TAXI_PED_LEAVE2
                end
                0293: $CONTROLMODE = current_controls
                if
                    8038:   NOT   $CONTROLMODE == 3
                then
                    if and
                        00E1:   key_pressed 0 19
                        0038:   $FLAG_PLAYER_ON_MISSION == 1
                    then
                        jump @TAXI_PED_LEAVE2
                    end
                else
                    if and
                        00E1:   key_pressed 0 14
                        0038:   $FLAG_PLAYER_ON_MISSION == 1
                    then
                        jump @TAXI_PED_LEAVE2
                    end
                end
            end //while
        end
    end
end
if
    0256:   player $PLAYER defined
then
    01B4: set_player $PLAYER can_move 1 (unfrozen)
end
if
    0038:   $TAXI_FUCKED_FLAG == 1
then
    return
end

:TAXI_PED_LEAVE2
wait 0 ms
if
    8118:   NOT   actor $TAXI_PED1 dead
then
    if
        8119:   NOT   car $TAXI_CAR wrecked
    then
        if
            80DB:   NOT   actor $TAXI_PED1 in_car $TAXI_CAR
        then
            009C: set_actor $TAXI_PED1 wander_path_to 0
            01C2: remove_references_to_actor $TAXI_PED1  // Like turning an actor into a random pedestrian
        end
    end
end
if
    0256:   player $PLAYER defined
then
    01B4: set_player $PLAYER can_move 1 (unfrozen)
end
return

:MISSION_CLEANUP_TAXI1
014F: stop_timer $TAXI_COUNTDOWN
0151: remove_status_text $TAXI_PASSED_THIS_SHOT
if
    8119:   NOT   car $TAXI_CAR wrecked
then
    0216: set_car $TAXI_CAR taxi_available_light_to 0 (off)
end
0164: remove_blip $BLIP1_CT1
0164: remove_blip $BLIP2_CT1
0164: remove_blip $SPRAY_TAXI
01C2: remove_references_to_actor $TAXI_PED1  // Like turning an actor into a random pedestrian
00BA: text_styled 'TAXI6' 5000 ms 5   // Taxi mission over
01E3: text_1number_styled 'TSCORE' $TAXI_SCORE 6000 ms 6   // EARNINGS: $~1~
0316: save_taxi_earnings_from $TAXI_SCORE
0111: set_deatharrest_state 1 (enabled)
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_TAXI_MISSION = 0
if
    0256:   player $PLAYER defined
then
    01B4: set_player $PLAYER can_move 1 (unfrozen)
end
03E6: remove_text_box
mission_cleanup
return
