//-------------Mission 63-------------
// Originally: Yardies mission 1 'BLING-BLING SCRAMBLE'

:M63_BLINGBLINGSCRAMBLE
03A4: name_thread 'YARD1'
054C: use_GXT_table 'YARD1'
gosub @MISSION_START_YD1
if
    wasted_or_busted
then
    gosub @MISSION_YD1_FAILED
end
gosub @MISSION_CLEANUP_YD1
end_thread

:MISSION_START_YD1
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1
0004: $ON_MISSION_FOR_YARDIES = 1
wait 0 ms
03DE: set_pedestrians_density_multiplier_to 0.0
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
042B: clear_peds_from_cube -234.5 -250.0 6.0 -204.5 -290.0 31.0
03CB: set_camera -215.0 -272.25 21.25
023C: load_special_actor 1 'PLAYER'
while true
    if
        823D:   NOT   special_actor 1 loaded
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'YD_PH1'
0244: set_cutscene_pos -214.0 -272.25 21.25
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
016A: fade 1 (back)  1500 ms
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   2237 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD1_A' 10000 ms 1   // ~w~This is King Courtney.
while 001A:   3791 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD1_A1' 10000 ms 1   // ~w~My Yardie posse could do with a driver and you've got a reputation for hot moves.
while 001A:   8312 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD1_B' 10000 ms 1   // ~w~Get to the waste ground opposite the stadium in a car and wait for the other hopefuls.
while 001A:   12880 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD1_C' 10000 ms 1   // ~w~I've got men watching checkpoints all over Staunton.
while 001A:   15965 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD1_D' 10000 ms 1   // ~w~First driver to a checkpoint gets a Grand then it's on to the next stop.
while 001A:   20462 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD1_D1' 10000 ms 1   // ~w~If you get more checkpoints than any other driver I could have some work for you.
while 001A:   25166 > $CUT_SCENE_TIME
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while fading
    wait 0 ms
end
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
end
03AF: set_streaming 1 (enabled)
00BE: text_clear_all
02EA: clear_cutscene
03DE: set_pedestrians_density_multiplier_to 1.0
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
wait 500 ms
016A: fade 1 (back)  1500 ms
0296: unload_special_actor 1
0005: $FINISH_X = -228.0
0005: $FINISH_Y = -288.0
0005: $START_X = -285.0
0005: $START_Y = 70.0

0004: $FLAG_CORONA_YD1 = 0
0004: $FLAG_HOTROD1_START = 0
0004: $FLAG_HOTROD2_START = 0
0004: $FLAG_HOTROD3_START = 0

0004: $COUNTER_RUSH_START = 0
0004: $COUNTER_HOTRODS = 0
0004: $COUNTER_PLAYER_POINTS = 0
0004: $COUNTER_NONPLAYER1_POINTS = 0
0004: $COUNTER_NONPLAYER2_POINTS = 0
0004: $COUNTER_NONPLAYER3_POINTS = 0
0004: $COUNTER_FINISH = 0
0004: $COUNTER_PLACING = 0
0004: $COUNTER_JOINT_PLACING = 0

if
    02BD:   debug_mode == DEBUG_MASTEREXTRAS2
then
    0004: $BBS_TOTAL = 20
else
    0004: $BBS_TOTAL = 15
end

018A: $BLIP_START_YD1 = create_checkpoint_at $START_X $START_Y 22.5

//0004: $FLAG_LEADER = 0
0004: $FLAG_RANDOM_YD1 = 0
0247: request_model #MALE02
0247: request_model #PATRIOT
0247: request_model #CHEETAH
0247: request_model #BOBCAT
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #MALE02 available
        8248:   NOT   model #PATRIOT available
        8248:   NOT   model #CHEETAH available
        8248:   NOT   model #BOBCAT available
    jf break
    wait 1000 ms
end

:IS_PLAYER_THERE
if
    019B:   player $PLAYER stopped 1 in_rectangle_in_car -290.0 65.0 -280.0 75.0
then
    00DA: $PLAYER_CAR = player $PLAYER car
    jump @PLAYER_IS_THERE
end
if
    00E4:   player $PLAYER 0 near_point_on_foot $START_X $START_Y radius 5.0 5.0
then
    00BC: print_now 'YD1_G' 2000 ms 1   // ~r~This is a CAR RACE. You need a CAR fool!
end
wait 0 ms
jump @IS_PLAYER_THERE

:PLAYER_IS_THERE
01C0: $WANTED_YD1 = player $PLAYER wanted_level
0110: clear_player $PLAYER wanted_level
0164: remove_blip $BLIP_START_YD1
01B4: set_player $PLAYER can_move 0 (frozen)
020A: set_car $PLAYER_CAR door_status_to 2
015F: set_camera_position -269.6875 51.0 24.0 0.0 0.0 0.0
016A: fade 0  1500 ms
wait 1500 ms
0157: camera_on_player $PLAYER 15 2
02A3: toggle_widescreen 1 (on)
0169: set_fade_color 0 0 0
016A: fade 1 (out)  1500 ms
wait 1500 ms
0395: clear_area 1 at -244.0 50.0 22.0 range 20.0
0395: clear_area 1 at -242.0 57.0 22.0 range 20.0
0395: clear_area 1 at -257.0 50.0 22.0 range 20.0
0395: clear_area 1 at -242.0 43.0 22.0 range 20.0
01EB: set_car_density_to 0.0
03DE: set_pedestrians_density_multiplier_to 0.0
wait 2000 ms
0160: point_camera -245.0 50.0 22.0 1
0395: clear_area 1 at -233.0 90.0 22.0 range 20.0
00A5: $HOT_ROD_1 = create_car #PATRIOT at -231.0 90.0 22.0
0129: $STREET_RACER_1 = create_actor 4 #MALE02 in_car $HOT_ROD_1 driverseat
054A: set_actor $STREET_RACER_1 vulnerable_to_car_headshots 0
039C: set_car_watertight $HOT_ROD_1 1
03ED: set_upsidedown_car_not_damaged $HOT_ROD_1 1
020A: set_car $HOT_ROD_1 door_status_to 2
0175: set_car $HOT_ROD_1 z_angle_to 190.0
00AD: set_car $HOT_ROD_1 max_speed_to 20.0
00AE: set_car $HOT_ROD_1 driving_style 2  // DRIVINGMODE_AVOIDCARS
02C2: car $HOT_ROD_1 drive_to_point -242.0 57.0 22.0
0395: clear_area 1 at -260.0 76.0 22.0 range 20.0
00A5: $HOT_ROD_2 = create_car #CHEETAH at -260.0 76.0 22.0
0129: $STREET_RACER_2 = create_actor 4 #MALE02 in_car $HOT_ROD_2 driverseat
054A: set_actor $STREET_RACER_2 vulnerable_to_car_headshots 0
039C: set_car_watertight $HOT_ROD_2 1
03ED: set_upsidedown_car_not_damaged $HOT_ROD_2 1
020A: set_car $HOT_ROD_2 door_status_to 2
0175: set_car $HOT_ROD_2 z_angle_to 220.0
00AD: set_car $HOT_ROD_2 max_speed_to 20.0
00AE: set_car $HOT_ROD_2 driving_style 2  // DRIVINGMODE_AVOIDCARS
02C2: car $HOT_ROD_2 drive_to_point -257.0 50.0 22.0
0395: clear_area 1 at -227.0 3.0 22.0 range 20.0
00A5: $HOT_ROD_3 = create_car #BOBCAT at -227.0 3.0 22.0
0129: $STREET_RACER_3 = create_actor 4 #MALE02 in_car $HOT_ROD_3 driverseat
054A: set_actor $STREET_RACER_3 vulnerable_to_car_headshots 0
039C: set_car_watertight $HOT_ROD_3 1
03ED: set_upsidedown_car_not_damaged $HOT_ROD_3 1
020A: set_car $HOT_ROD_3 door_status_to 2
00AD: set_car $HOT_ROD_3 max_speed_to 10.0
00AE: set_car $HOT_ROD_3 driving_style 2  // DRIVINGMODE_AVOIDCARS
02C2: car $HOT_ROD_3 drive_to_point -242.0 43.0 22.0
0186: $BLIP_HOT_ROD_3 = create_marker_above_car $HOT_ROD_3
0186: $BLIP_HOT_ROD_2 = create_marker_above_car $HOT_ROD_2
0186: $BLIP_HOT_ROD_1 = create_marker_above_car $HOT_ROD_1
00BC: print_now 'YD1_E' 3000 ms 2   // ~g~Prepare to race!
018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
0373: set_camera_directly_behind_player

while 001A:   3 > $COUNTER_HOTRODS
    wait 0 ms
    if
        8119:   NOT   car $HOT_ROD_1 wrecked
    then
        if and
            01AD:   car $HOT_ROD_1 0 near_point -242.0 57.0 3.0 3.0
            0038:   $FLAG_HOTROD1_START == 0
        then
            00A9: set_car $HOT_ROD_1 to_normal_driver
            0004: $FLAG_HOTROD1_START = 1
            0008: $COUNTER_HOTRODS += 1
        end
    end
    0224: set_car $HOT_ROD_1 health_to 1000
    if
        8119:   NOT   car $HOT_ROD_2 wrecked
    then
        if and
            01AD:   car $HOT_ROD_2 0 near_point -257.0 50.0 3.0 3.0
            0038:   $FLAG_HOTROD2_START == 0
        then
            00A9: set_car $HOT_ROD_2 to_normal_driver
            0004: $FLAG_HOTROD2_START = 1
            0008: $COUNTER_HOTRODS += 1
        end
    end
    0224: set_car $HOT_ROD_2 health_to 1000
    if
        8119:   NOT   car $HOT_ROD_3 wrecked
    then
        if and
            01AD:   car $HOT_ROD_3 0 near_point -242.0 43.0 3.0 3.0
            0038:   $FLAG_HOTROD3_START == 0
        then
            00A9: set_car $HOT_ROD_3 to_normal_driver
            0004: $FLAG_HOTROD3_START = 1
            0008: $COUNTER_HOTRODS += 1
        end
    end
    0224: set_car $HOT_ROD_3 health_to 1000
end //while
wait 1500 ms
0169: set_fade_color 0 0 0
016A: fade 0  1500 ms
wait 1500 ms
02EB: restore_camera_jumpcut
02A3: toggle_widescreen 0 (off)
010D: set_player $PLAYER wanted_level_to $WANTED_YD1
016A: fade 1 (out)  1500 ms
wait 1500 ms
if
    8119:   NOT   car $PLAYER_CAR wrecked
then
    020A: set_car $PLAYER_CAR door_status_to 1
end
01EB: set_car_density_to 1.0
03DE: set_pedestrians_density_multiplier_to 1.0
0099: $RANDOM_YD1 = random_integer_0-to-65535
if and
    0018:   $RANDOM_YD1 > 21845
    001A:   43691 > $RANDOM_YD1
then
    0004: $FLAG_RANDOM_YD1 = 1
end
if
    0018:   $RANDOM_YD1 > 43690
then
    0004: $FLAG_RANDOM_YD1 = 2
end
01E8: switch_roads_off 165.0 60.0 -19.0 265.0 140.0 6.0
01E8: switch_roads_off -735.0 60.0 -19.0 -635.0 140.0 6.0
if
    00E0:   player $PLAYER driving
then
    00DA: $PLAYER_CAR = player $PLAYER car
end
while true
    if and
        8119:   NOT   car $PLAYER_CAR wrecked
        01AD:   car $PLAYER_CAR 0 near_point $START_X $START_Y 10.0 10.0
    jf break
    wait 1000 ms
    if
        0038:   $COUNTER_RUSH_START == 4
    then
        jump @AND_ITS_GO_GO_GO
    end
    if
        0038:   $COUNTER_RUSH_START == 3
    then
        00BA: text_styled 'YD1GO' 1000 ms 4   // ~g~GO!!
        0008: $COUNTER_RUSH_START += 1
        01B4: set_player $PLAYER can_move 1 (unfrozen)
        018C: play_sound 10 at 0.0 0.0 0.0
    end
    if
        0038:   $COUNTER_RUSH_START == 2
    then
        00BA: text_styled 'YD1_1' 1000 ms 4   // ~r~1
        0008: $COUNTER_RUSH_START += 1
        018C: play_sound 9 at 0.0 0.0 0.0
    end
    if
        0038:   $COUNTER_RUSH_START == 1
    then
        00BA: text_styled 'YD1_2' 1000 ms 4   // ~r~2
        0008: $COUNTER_RUSH_START += 1
        018C: play_sound 8 at 0.0 0.0 0.0
    end
    if
        0038:   $COUNTER_RUSH_START == 0
    then
        00BA: text_styled 'YD1_3' 1000 ms 4   // ~r~3
        0008: $COUNTER_RUSH_START += 1
        018C: play_sound 7 at 0.0 0.0 0.0
    end
end //while
00BC: print_now 'YD1_F' 4000 ms 2   // ~g~You jumped the start -I like your style!!

:AND_ITS_GO_GO_GO
gosub @DRIVING_STYLE_CAR_1
gosub @DRIVING_STYLE_CAR_2
gosub @DRIVING_STYLE_CAR_3

:MAIN_LOOP
if
    0038:   $FLAG_CORONA_YD1 == 0
then
    024F: create_corona 2.0 6 0 with_color 200 120 120 at_point $FINISH_X $FINISH_Y -100.0
end
if
    00E0:   player $PLAYER driving
then
    00DA: $PLAYER_CAR = player $PLAYER car
    00AA: store_car $PLAYER_CAR position_to $PLAYER_CAR_X $PLAYER_CAR_Y $PLAYER_CAR_Z
    0086: $X_SUM = $FINISH_X
    0061: $X_SUM -= $PLAYER_CAR_X
    0086: $Y_SUM = $FINISH_Y
    0061: $Y_SUM -= $PLAYER_CAR_Y
    0069: $X_SUM *= $X_SUM
    0069: $Y_SUM *= $Y_SUM
    0086: $PLAYER_DIST = $X_SUM
    0059: $PLAYER_DIST += $Y_SUM
    if or
        8119:   NOT   car $HOT_ROD_1 wrecked
        02BF:   car $HOT_ROD_1 sunk
    then
        if and
            8118:   NOT   actor $STREET_RACER_1 dead
            80DC:   NOT   player $PLAYER driving $HOT_ROD_1
        then
            00AA: store_car $HOT_ROD_1 position_to $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z
            if
                0022:   6.0 > $HOT_ROD_1_Z
            then
                03D3: point $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z get_nearby_vector $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z $HOT_ROD_HEADING
                if
                    80C2:   NOT   sphere onscreen $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z 9.0
                then
                    00AB: put_car $HOT_ROD_1 at $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z
                    0175: set_car $HOT_ROD_1 z_angle_to $HOT_ROD_HEADING
                end
            end
            if
                8185:   NOT   car $HOT_ROD_1 health >= 450
            then
                0224: set_car $HOT_ROD_1 health_to 600
            end
            if and
                01F4:   car $HOT_ROD_1 flipped
                01C1:   car $HOT_ROD_1 stopped
            then
                01D3: actor $STREET_RACER_1 leave_car $HOT_ROD_1
                if
                    82CA:   NOT   car $HOT_ROD_1 bounding_sphere visible
                then
                    00AA: store_car $HOT_ROD_1 position_to $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z
                    03D3: point $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z get_nearby_vector $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z $HOT_ROD_HEADING
                    if
                        80C2:   NOT   sphere onscreen $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z 9.0
                    then
                        00AB: put_car $HOT_ROD_1 at $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z
                        0175: set_car $HOT_ROD_1 z_angle_to $HOT_ROD_HEADING
                        009B: destroy_actor_instantly $STREET_RACER_1
                        0129: $STREET_RACER_1 = create_actor 4 #MALE02 in_car $HOT_ROD_1 driverseat
                    end
                end
            end
            if
                02BF:   car $HOT_ROD_1 sunk
            then
                if
                    82CA:   NOT   car $HOT_ROD_1 bounding_sphere visible
                then
                    00AA: store_car $HOT_ROD_1 position_to $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z
                    03D3: point $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z get_nearby_vector $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z $HOT_ROD_HEADING
                    if
                        80C2:   NOT   sphere onscreen $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z 9.0
                    then
                        00AB: put_car $HOT_ROD_1 at $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z
                        0175: set_car $HOT_ROD_1 z_angle_to $HOT_ROD_HEADING
                        009B: destroy_actor_instantly $STREET_RACER_1
                        0129: $STREET_RACER_1 = create_actor 4 #MALE02 in_car $HOT_ROD_1 driverseat
                    end
                end
            end
            if
                0038:   $TIMER_RESET_HR1 == 1
            then
                if
                    81C1:   NOT   car $HOT_ROD_1 stopped
                then
                    0004: $TIMER_RESET_HR1 = 0
                end
            end
            if
                01C1:   car $HOT_ROD_1 stopped
            then
                if
                    0038:   $TIMER_RESET_HR1 == 0
                then
                    01BD: $TIMER_START_HR1 = current_time_in_ms
                    0004: $TIMER_RESET_HR1 = 1
                end
                if
                    0038:   $TIMER_RESET_HR1 == 1
                then
                    01BD: $TIMER_CURRENT_HR1 = current_time_in_ms
                    0084: $HR1_TIME_DIF = $TIMER_CURRENT_HR1
                    0060: $HR1_TIME_DIF -= $TIMER_START_HR1
                end
                if
                    0018:   $HR1_TIME_DIF > 4000
                then
                    if
                        82CA:   NOT   car $HOT_ROD_1 bounding_sphere visible
                    then
                        00AA: store_car $HOT_ROD_1 position_to $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z
                        03D3: point $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z get_nearby_vector $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z $HOT_ROD_HEADING
                        if
                            80C2:   NOT   sphere onscreen $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z 9.0
                        then
                            00AB: put_car $HOT_ROD_1 at $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z
                            0175: set_car $HOT_ROD_1 z_angle_to $HOT_ROD_HEADING
                            0004: $TIMER_RESET_HR1 = 0
                        end
                    end
                end
            end
            00AA: store_car $HOT_ROD_1 position_to $HOT_ROD_1_X $HOT_ROD_1_Y $HOT_ROD_1_Z
            0086: $X_SUM = $FINISH_X
            0061: $X_SUM -= $HOT_ROD_1_X
            0086: $Y_SUM = $FINISH_Y
            0061: $Y_SUM -= $HOT_ROD_1_Y
            0069: $X_SUM *= $X_SUM
            0069: $Y_SUM *= $Y_SUM
            0086: $HOT_ROD_1_DIST = $X_SUM
            0059: $HOT_ROD_1_DIST += $Y_SUM
            if
                0024:   $HOT_ROD_1_DIST > $PLAYER_DIST
            then
                00AF: set_car $HOT_ROD_1 mission 2  // MISSION_RAMPLAYER_FARAWAY
            end
            if
                0024:   $PLAYER_DIST > $HOT_ROD_1_DIST
            then
                gosub @DRIVING_STYLE_CAR_1
            end
        else
            00A9: set_car $HOT_ROD_1 to_normal_driver
        end
    end
    if or
        8119:   NOT   car $HOT_ROD_2 wrecked
        02BF:   car $HOT_ROD_2 sunk
    then
        if and
            8118:   NOT   actor $STREET_RACER_2 dead
            80DC:   NOT   player $PLAYER driving $HOT_ROD_2
        then
            00AA: store_car $HOT_ROD_2 position_to $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z
            if
                0022:   6.0 > $HOT_ROD_2_Z
            then
                03D3: point $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z get_nearby_vector $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z $HOT_ROD_HEADING
                if
                    80C2:   NOT   sphere onscreen $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z 3.0
                then
                    00AB: put_car $HOT_ROD_2 at $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z
                    0175: set_car $HOT_ROD_2 z_angle_to $HOT_ROD_HEADING
                end
            end
            if
                8185:   NOT   car $HOT_ROD_2 health >= 450
            then
                0224: set_car $HOT_ROD_2 health_to 600
            end
            if and
                01F4:   car $HOT_ROD_2 flipped
                01C1:   car $HOT_ROD_2 stopped
            then
                01D3: actor $STREET_RACER_2 leave_car $HOT_ROD_2
                if
                    82CA:   NOT   car $HOT_ROD_2 bounding_sphere visible
                then
                    00AA: store_car $HOT_ROD_2 position_to $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z
                    03D3: point $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z get_nearby_vector $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z $HOT_ROD_HEADING
                    if
                        80C2:   NOT   sphere onscreen $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z 3.0
                    then
                        00AB: put_car $HOT_ROD_2 at $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z
                        0175: set_car $HOT_ROD_2 z_angle_to $HOT_ROD_HEADING
                        009B: destroy_actor_instantly $STREET_RACER_2
                        0129: $STREET_RACER_2 = create_actor 4 #MALE02 in_car $HOT_ROD_2 driverseat
                    end
                end
            end
            if
                02BF:   car $HOT_ROD_2 sunk
            then
                if
                    82CA:   NOT   car $HOT_ROD_2 bounding_sphere visible
                then
                    00AA: store_car $HOT_ROD_2 position_to $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z
                    03D3: point $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z get_nearby_vector $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z $HOT_ROD_HEADING
                    if
                        80C2:   NOT   sphere onscreen $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z 3.0
                    then
                        00AB: put_car $HOT_ROD_2 at $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z
                        0175: set_car $HOT_ROD_2 z_angle_to $HOT_ROD_HEADING
                        009B: destroy_actor_instantly $STREET_RACER_2
                        0129: $STREET_RACER_2 = create_actor 4 #MALE02 in_car $HOT_ROD_2 driverseat
                    end
                end
            end
            if
                0038:   $TIMER_RESET_HR2 == 1
            then
                if
                    81C1:   NOT   car $HOT_ROD_2 stopped
                then
                    0004: $TIMER_RESET_HR2 = 0
                end
            end
            if
                01C1:   car $HOT_ROD_2 stopped
            then
                if
                    0038:   $TIMER_RESET_HR2 == 0
                then
                    01BD: $TIMER_START_HR2 = current_time_in_ms
                    0004: $TIMER_RESET_HR2 = 1
                end
                if
                    0038:   $TIMER_RESET_HR2 == 1
                then
                    01BD: $TIMER_CURRENT_HR2 = current_time_in_ms
                    0084: $HR2_TIME_DIF = $TIMER_CURRENT_HR2
                    0060: $HR2_TIME_DIF -= $TIMER_START_HR2
                end
                if
                    0018:   $HR2_TIME_DIF > 4000
                then
                    if
                        82CA:   NOT   car $HOT_ROD_2 bounding_sphere visible
                    then
                        00AA: store_car $HOT_ROD_2 position_to $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z
                        03D3: point $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z get_nearby_vector $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z $HOT_ROD_HEADING
                        if
                            80C2:   NOT   sphere onscreen $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z 3.0
                        then
                            00AB: put_car $HOT_ROD_2 at $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z
                            0175: set_car $HOT_ROD_2 z_angle_to $HOT_ROD_HEADING
                            0004: $TIMER_RESET_HR2 = 0
                        end
                    end
                end
            end
            00AA: store_car $HOT_ROD_2 position_to $HOT_ROD_2_X $HOT_ROD_2_Y $HOT_ROD_2_Z
            0086: $X_SUM = $FINISH_X
            0061: $X_SUM -= $HOT_ROD_2_X
            0086: $Y_SUM = $FINISH_Y
            0061: $Y_SUM -= $HOT_ROD_2_Y
            0069: $X_SUM *= $X_SUM
            0069: $Y_SUM *= $Y_SUM
            0086: $HOT_ROD_2_DIST = $X_SUM
            0059: $HOT_ROD_2_DIST += $Y_SUM
            if
                0024:   $HOT_ROD_2_DIST > $PLAYER_DIST
            then
                00AF: set_car $HOT_ROD_2 mission 2  // MISSION_RAMPLAYER_FARAWAY
            end
            if
                0024:   $PLAYER_DIST > $HOT_ROD_2_DIST
            then
                gosub @DRIVING_STYLE_CAR_2
            end
        else
            00A9: set_car $HOT_ROD_2 to_normal_driver
        end
    end
    if or
        8119:   NOT   car $HOT_ROD_3 wrecked
        02BF:   car $HOT_ROD_3 sunk
    then
        if and
            8118:   NOT   actor $STREET_RACER_3 dead
            80DC:   NOT   player $PLAYER driving $HOT_ROD_3
        then
            00AA: store_car $HOT_ROD_3 position_to $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z
            if
                0022:   6.0 > $HOT_ROD_3_Z
            then
                03D3: point $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z get_nearby_vector $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z $HOT_ROD_HEADING
                if
                    80C2:   NOT   sphere onscreen $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z 3.0
                then
                    00AB: put_car $HOT_ROD_3 at $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z
                    0175: set_car $HOT_ROD_3 z_angle_to $HOT_ROD_HEADING
                end
            end
            if
                8185:   NOT   car $HOT_ROD_3 health >= 450
            then
                0224: set_car $HOT_ROD_3 health_to 600
            end
            if and
                01F4:   car $HOT_ROD_3 flipped
                01C1:   car $HOT_ROD_3 stopped
            then
                01D3: actor $STREET_RACER_3 leave_car $HOT_ROD_3
                if
                    82CA:   NOT   car $HOT_ROD_3 bounding_sphere visible
                then
                    00AA: store_car $HOT_ROD_3 position_to $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z
                    03D3: point $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z get_nearby_vector $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z $HOT_ROD_HEADING
                    if
                        80C2:   NOT   sphere onscreen $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z 3.0
                    then
                        00AB: put_car $HOT_ROD_3 at $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z
                        0175: set_car $HOT_ROD_3 z_angle_to $HOT_ROD_HEADING
                        009B: destroy_actor_instantly $STREET_RACER_3
                        0129: $STREET_RACER_3 = create_actor 4 #MALE02 in_car $HOT_ROD_3 driverseat
                    end
                end
            end
            if
                02BF:   car $HOT_ROD_3 sunk
            then
                if
                    82CA:   NOT   car $HOT_ROD_3 bounding_sphere visible
                then
                    00AA: store_car $HOT_ROD_3 position_to $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z
                    03D3: point $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z get_nearby_vector $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z $HOT_ROD_HEADING
                    if
                        80C2:   NOT   sphere onscreen $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z 3.0
                    then
                        00AB: put_car $HOT_ROD_3 at $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z
                        0175: set_car $HOT_ROD_3 z_angle_to $HOT_ROD_HEADING
                        009B: destroy_actor_instantly $STREET_RACER_3
                        0129: $STREET_RACER_3 = create_actor 4 #MALE02 in_car $HOT_ROD_3 driverseat
                    end
                end
            end
            if
                0038:   $TIMER_RESET_HR3 == 1
            then
                if
                    81C1:   NOT   car $HOT_ROD_3 stopped
                then
                    0004: $TIMER_RESET_HR3 = 0
                end
            end
            if
                01C1:   car $HOT_ROD_3 stopped
            then
                if
                    0038:   $TIMER_RESET_HR3 == 0
                then
                    01BD: $TIMER_START_HR3 = current_time_in_ms
                    0004: $TIMER_RESET_HR3 = 1
                end
                if
                    0038:   $TIMER_RESET_HR3 == 1
                then
                    01BD: $TIMER_CURRENT_HR3 = current_time_in_ms
                    0084: $HR3_TIME_DIF = $TIMER_CURRENT_HR3
                    0060: $HR3_TIME_DIF -= $TIMER_START_HR3
                end
                if
                    0018:   $HR3_TIME_DIF > 4000
                then
                    if
                        82CA:   NOT   car $HOT_ROD_3 bounding_sphere visible
                    then
                        00AA: store_car $HOT_ROD_3 position_to $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z
                        03D3: point $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z get_nearby_vector $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z $HOT_ROD_HEADING
                        if
                            80C2:   NOT   sphere onscreen $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z 3.0
                        then
                            00AB: put_car $HOT_ROD_3 at $HOT_ROD_3_X $HOT_ROD_3_Y $HOT_ROD_3_Z
                            0175: set_car $HOT_ROD_3 z_angle_to $HOT_ROD_HEADING
                            0004: $TIMER_RESET_HR3 = 0
                        end
                    end
                end
            end
        else
            00A9: set_car $HOT_ROD_3 to_normal_driver
        end
    end
end
if
    80E0:   NOT   player $PLAYER driving
then
    gosub @DRIVING_STYLE_CAR_1
    gosub @DRIVING_STYLE_CAR_2
    gosub @DRIVING_STYLE_CAR_3
end
if
    00E5:   player $PLAYER 0 near_point_in_car $FINISH_X $FINISH_Y radius 6.0 6.0
then
    018C: play sound  1 at  0.0  0.0  0.0
    gosub @PLAYER_POINTS
end
if
    8119:   NOT   car $HOT_ROD_1 wrecked
then
    if
        01AD:   car $HOT_ROD_1 0 near_point $FINISH_X $FINISH_Y 6.0 6.0
    then
        gosub @NONPLAYER_POINTS_1
    end
end
if
    8119:   NOT   car $HOT_ROD_2 wrecked
then
    if
        01AD:   car $HOT_ROD_2 0 near_point $FINISH_X $FINISH_Y 6.0 6.0
    then
        gosub @NONPLAYER_POINTS_2
    end
end
if
    8119:   NOT   car $HOT_ROD_3 wrecked
then
    if
        01AD:   car $HOT_ROD_3 0 near_point $FINISH_X $FINISH_Y 6.0 6.0
    then
        gosub @NONPLAYER_POINTS_3
    end
end
wait 0 ms
gosub @DRIVING_STYLE_CAR_3
if
    003A:   $COUNTER_FINISH == $BBS_TOTAL
then
    jump @RACE_FINISHED
end
jump @MAIN_LOOP

:RACE_FINISHED
if
    003A:   $COUNTER_PLAYER_POINTS == $COUNTER_NONPLAYER1_POINTS
then
    0008: $COUNTER_JOINT_PLACING += 1
end
if
    003A:   $COUNTER_PLAYER_POINTS == $COUNTER_NONPLAYER2_POINTS
then
    0008: $COUNTER_JOINT_PLACING += 1
end
if
    003A:   $COUNTER_PLAYER_POINTS == $COUNTER_NONPLAYER3_POINTS
then
    0008: $COUNTER_JOINT_PLACING += 1
end
if
    001C:   $COUNTER_PLAYER_POINTS > $COUNTER_NONPLAYER1_POINTS
then
    0008: $COUNTER_PLACING += 1
end
if
    001C:   $COUNTER_PLAYER_POINTS > $COUNTER_NONPLAYER2_POINTS
then
    0008: $COUNTER_PLACING += 1
end
if
    001C:   $COUNTER_PLAYER_POINTS > $COUNTER_NONPLAYER3_POINTS
then
    0008: $COUNTER_PLACING += 1
end
if
    0038:   $COUNTER_PLACING == 3
then
    jump @MISSION_YD1_PASSED
end
if
    001A:   3 > $COUNTER_PLACING
then
    jump @MISSION_YD1_FAILED
end

:MISSION_YD1_FAILED
00BA: text_styled 'M_FAIL' 2000 ms 1   // MISSION FAILED!
wait 2000 ms
if
    0038:   $COUNTER_JOINT_PLACING == 0
then
    if
        0038:   $COUNTER_PLACING == 2
    then
        01E5: text_1number_highpriority 'Y1_2ND' $COUNTER_PLAYER_POINTS 4000 ms 1   // ~y~2nd with ~1~ successful checkpoints. ~y~Close but you just ain't the best!
        wait 2000 ms
    end
    if
        0038:   $COUNTER_PLACING == 1
    then
        01E5: text_1number_highpriority 'Y1_3RD' $COUNTER_PLAYER_POINTS 4000 ms 1   // ~r~3rd with ~1~ successful checkpoints. ~r~I thought you said you were good!
        wait 2000 ms
    end
    if
        0038:   $COUNTER_PLACING == 0
    then
        01E5: text_1number_highpriority 'Y1_LAST' $COUNTER_PLAYER_POINTS 4000 ms 1   // ~r~You were last! ~r~You wasted my time FOOL!
        wait 2000 ms
    end
end
if
    0038:   $COUNTER_JOINT_PLACING == 1
then
    if
        0038:   $COUNTER_PLACING == 2
    then
        01E5: text_1number_highpriority 'Y1_J1ST' $COUNTER_PLAYER_POINTS 4000 ms 1   // ~y~Joint 1st with ~1~ successful checkpoints. ~y~Good but you gotta be the best to drive for Queen Lizzy!
        wait 2000 ms
    end
    if
        0038:   $COUNTER_PLACING == 1
    then
        01E5: text_1number_highpriority 'Y1_J2ND' $COUNTER_PLAYER_POINTS 4000 ms 1   // ~r~Joint 2nd with ~1~ successful checkpoints. You drive like a crazed monkey!
        wait 2000 ms
    end
    if
        0038:   $COUNTER_PLACING == 0
    then
        01E5: text_1number_highpriority 'Y1JLAST' $COUNTER_PLAYER_POINTS 4000 ms 1   // ~r~Joint last! You talk like a driver but you drive like a talker!
        wait 2000 ms
    end
end
if
    0038:   $COUNTER_JOINT_PLACING == 2
then
    if
        0038:   $COUNTER_PLACING == 1
    then
        01E5: text_1number_highpriority 'Y1_J1ST' $COUNTER_PLAYER_POINTS 4000 ms 1   // ~y~Joint 1st with ~1~ successful checkpoints. ~y~Good but you gotta be the best to drive for Queen Lizzy!
        wait 2000 ms
    end
    if
        0038:   $COUNTER_PLACING == 0
    then
        01E5: text_1number_highpriority 'Y1JLAST' $COUNTER_PLAYER_POINTS 4000 ms 1   // ~r~Joint last! You talk like a driver but you drive like a talker!
        wait 2000 ms
    end
end
return

:MISSION_YD1_PASSED
if
    0038:   $KINGDOM_COME_COMPLETED == 0
then
    0318: set_latest_mission_passed 'YD1'   // 'BLING-BLING SCRAMBLE'
    030C: set_mission_points += 1
    0004: $BLING_BLING_SCRAMBLE_COMPLETED = 1
    004F: create_thread @YARDIE_MISSION2_LOOP
end
0004: $BLING_BLING_REWARD = 1000
0068: $BLING_BLING_REWARD *= $COUNTER_PLAYER_POINTS
01E3: text_1number_styled 'M_PASS' $BLING_BLING_REWARD 5000 ms 1   // MISSION PASSED! $~1~
0394: play_music 1
01E5: text_1number_highpriority 'Y1_1ST' $COUNTER_PLAYER_POINTS 4000 ms 1   // ~g~You came first with ~1~ successful checkpoints!
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += $BLING_BLING_REWARD
042F: register_highest_int_stat 0 to $COUNTER_PLAYER_POINTS
return

:MISSION_CLEANUP_YD1
02EB: restore_camera_jumpcut
02A3: toggle_widescreen 0 (off)
0164: remove_blip $BLIP_HOT_ROD_1
0164: remove_blip $BLIP_HOT_ROD_2
0164: remove_blip $BLIP_HOT_ROD_3
0164: remove_blip $BLIP_START_YD1
0249: mark_model_as_no_longer_needed #MALE02
0249: mark_model_as_no_longer_needed #PATRIOT
0249: mark_model_as_no_longer_needed #CHEETAH
0249: mark_model_as_no_longer_needed #BOBCAT
01E7: switch_roads_on 165.0 60.0 -19.0 265.0 140.0 6.0
01E7: switch_roads_on -735.0 60.0 -19.0 -635.0 140.0 6.0
0004: $FLAG_PLAYER_ON_MISSION = 0
0004: $ON_MISSION_FOR_YARDIES = 0
0164: remove_blip $BLIP_RUSH_DESTINATION
mission_cleanup
return

:DRIVING_STYLE_CAR_1
if
    8119:   NOT   car $HOT_ROD_1 wrecked
then
    00AD: set_car $HOT_ROD_1 max_speed_to 40.0
    00AE: set_car $HOT_ROD_1 driving_style 2   //was 3
    02C2: car $HOT_ROD_1 drive_to_point $FINISH_X $FINISH_Y 5.0
    //0004: $FLAG_DRIVE_MODE_1 = 0   //part of R*s code, but never used anywhere else
end
return

:DRIVING_STYLE_CAR_2
if
    8119:   NOT   car $HOT_ROD_2 wrecked
then
    00AD: set_car $HOT_ROD_2 max_speed_to 45.0
    00AE: set_car $HOT_ROD_2 driving_style 2  // DRIVINGMODE_AVOIDCARS
    02C2: car $HOT_ROD_2 drive_to_point $FINISH_X $FINISH_Y 5.0
    //0004: $FLAG_DRIVE_MODE_2 = 0
end
return

:DRIVING_STYLE_CAR_3
if
    8119:   NOT   car $HOT_ROD_3 wrecked
then
    00AD: set_car $HOT_ROD_3 max_speed_to 35.0
    00AE: set_car $HOT_ROD_3 driving_style 2  // DRIVINGMODE_AVOIDCARS
    02C2: car $HOT_ROD_3 drive_to_point $FINISH_X $FINISH_Y 5.0
    //0004: $FLAG_DRIVE_MODE_3 = 0
end
return

:PLAYER_POINTS
0008: $COUNTER_PLAYER_POINTS += 1
0008: $COUNTER_FINISH += 1
036D: text_1number_styled 'YD1_CNT' $COUNTER_PLAYER_POINTS $BBS_TOTAL 2000 ms 4   // ~1~ of ~1~!
018C: play_sound 1 at $PLAYER_CAR_X $PLAYER_CAR_Y $PLAYER_CAR_Z
gosub @FINISH_COORD_GENERATOR
return

:NONPLAYER_POINTS_1
0008: $COUNTER_NONPLAYER1_POINTS += 1
0008: $COUNTER_FINISH += 1
018C: play_sound 1 at $PLAYER_CAR_X $PLAYER_CAR_Y $PLAYER_CAR_Z
gosub @FINISH_COORD_GENERATOR
return

:NONPLAYER_POINTS_2
0008: $COUNTER_NONPLAYER2_POINTS += 1
0008: $COUNTER_FINISH += 1
018C: play_sound 1 at $PLAYER_CAR_X $PLAYER_CAR_Y $PLAYER_CAR_Z
gosub @FINISH_COORD_GENERATOR
return

:NONPLAYER_POINTS_3
0008: $COUNTER_NONPLAYER3_POINTS += 1
0008: $COUNTER_FINISH += 1
018C: play_sound 1 at $PLAYER_CAR_X $PLAYER_CAR_Y $PLAYER_CAR_Z
gosub @FINISH_COORD_GENERATOR
return

:FINISH_COORD_GENERATOR
if
    0038:   $FLAG_RANDOM_YD1 == 0
then
    if
        0038:   $COUNTER_FINISH == 1
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -229.0
        0005: $FINISH_Y = -403.312
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 2
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -249.75
        0005: $FINISH_Y = -538.562
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 3
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -162.5
        0005: $FINISH_Y = -696.562
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 4
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -170.0
        0005: $FINISH_Y = -886.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 5
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -257.5
        0005: $FINISH_Y = -945.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 6
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -404.375
        0005: $FINISH_Y = -926.188
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 7
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -128.75
        0005: $FINISH_Y = -1041.5
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 8
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -285.9
        0005: $FINISH_Y = -1034.1
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 9
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -261.25
        0005: $FINISH_Y = -920.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 10
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -230.5
        0005: $FINISH_Y = -1095.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 11
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -449.0
        0005: $FINISH_Y = -499.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 12
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -345.79
        0005: $FINISH_Y = -463.1
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 13
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = 11.0
        0005: $FINISH_Y = -1211.4
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 14
    then
        if
            02BD:   debug_mode == DEBUG_MASTEREXTRAS2
        then
            0164: remove_blip $BLIP_RUSH_DESTINATION
            0005: $FINISH_X = 189.3
            0005: $FINISH_Y = -519.6
            018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
        else
            0164: remove_blip $BLIP_RUSH_DESTINATION
            0086: $FINISH_X = $START_X
            0086: $FINISH_Y = $START_Y
            018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
        end
    end
    if
        0038:   $COUNTER_FINISH == 15
    then
        if
            02BD:   debug_mode == DEBUG_MASTEREXTRAS2
        then
            0164: remove_blip $BLIP_RUSH_DESTINATION
            0005: $FINISH_X = 195.4
            0005: $FINISH_Y = -55.2
            018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
        else
            0164: remove_blip $BLIP_RUSH_DESTINATION
        end
    end
    if
        0038:   $COUNTER_FINISH == 16
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = 213.5
        0005: $FINISH_Y = -370.5
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 17
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -265.2
        0005: $FINISH_Y = 107.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 18
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -376.6
        0005: $FINISH_Y = -1353.5
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 19
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0086: $FINISH_X = $START_X
        0086: $FINISH_Y = $START_Y
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 20
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
    end
end
if
    0038:   $FLAG_RANDOM_YD1 == 1
then
    if
        0038:   $COUNTER_FINISH == 1
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -162.5
        0005: $FINISH_Y = -696.562
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 2
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -479.0
        0005: $FINISH_Y = -499.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 3
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -345.75
        0005: $FINISH_Y = -463.062
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 4
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -257.5
        0005: $FINISH_Y = -945.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 5
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -404.375
        0005: $FINISH_Y = -926.188
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 6
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -408.375
        0005: $FINISH_Y = -1013.56
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 7
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -128.75
        0005: $FINISH_Y = -1041.5
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 8
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -249.75
        0005: $FINISH_Y = -538.562
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 9
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -286.0625
        0005: $FINISH_Y = -1034.0601
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 10
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -261.25
        0005: $FINISH_Y = -920.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 11
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -230.5
        0005: $FINISH_Y = -1095.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 12
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = 11.0
        0005: $FINISH_Y = -1211.38
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 13
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -343.375
        0005: $FINISH_Y = -803.188
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 14
    then
        if
            02BD:   debug_mode == DEBUG_MASTEREXTRAS2
        then
            0164: remove_blip $BLIP_RUSH_DESTINATION
            0005: $FINISH_X = 213.5
            0005: $FINISH_Y = -370.5
            018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
        else
            0164: remove_blip $BLIP_RUSH_DESTINATION
            0086: $FINISH_X = $START_X
            0086: $FINISH_Y = $START_Y
            018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
        end
    end
    if
        0038:   $COUNTER_FINISH == 15
    then
        if
            02BD:   debug_mode == DEBUG_MASTEREXTRAS2
        then
            0164: remove_blip $BLIP_RUSH_DESTINATION
            0005: $FINISH_X = -170.0
            0005: $FINISH_Y = -886.0
            018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
        else
            0164: remove_blip $BLIP_RUSH_DESTINATION
        end
    end
    if
        0038:   $COUNTER_FINISH == 16
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -265.2
        0005: $FINISH_Y = 107.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 17
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -376.6
        0005: $FINISH_Y = -1353.5
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 18
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -229.0
        0005: $FINISH_Y = -403.36
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 19
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0086: $FINISH_X = $START_X
        0086: $FINISH_Y = $START_Y
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 20
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
    end
end
if
    0038:   $FLAG_RANDOM_YD1 == 2
then
    if
        0038:   $COUNTER_FINISH == 1
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -162.5
        0005: $FINISH_Y = -696.562
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 2
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -213.062
        0005: $FINISH_Y = -932.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 3
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -229.0
        0005: $FINISH_Y = -403.312
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 4
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -376.5625
        0005: $FINISH_Y = -1353.5
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 5
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -407.5
        0005: $FINISH_Y = -803.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 6
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -170.0
        0005: $FINISH_Y = -886.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 7
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -84.5
        0005: $FINISH_Y = -208.5
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 8
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -343.375
        0005: $FINISH_Y = -803.188
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 9
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = 11.0
        0005: $FINISH_Y = -1211.38
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 10
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -230.5
        0005: $FINISH_Y = -1095.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 11
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -261.25
        0005: $FINISH_Y = -920.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 12
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -286.0625
        0005: $FINISH_Y = -1034.0601
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 13
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -249.75
        0005: $FINISH_Y = -538.562
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 14
    then
        if
            02BD:   debug_mode == DEBUG_MASTEREXTRAS2
        then
            0164: remove_blip $BLIP_RUSH_DESTINATION
            0005: $FINISH_X = -162.2
            0005: $FINISH_Y = -1066.9
            018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
        else
            0164: remove_blip $BLIP_RUSH_DESTINATION
            0086: $FINISH_X = $START_X
            0086: $FINISH_Y = $START_Y
            018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
        end
    end
    if
        0038:   $COUNTER_FINISH == 15
    then
        if
            02BD:   debug_mode == DEBUG_MASTEREXTRAS2
        then
            0164: remove_blip $BLIP_RUSH_DESTINATION
            0005: $FINISH_X = 189.3
            0005: $FINISH_Y = -519.6
            018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
        else
            0164: remove_blip $BLIP_RUSH_DESTINATION
        end
    end
    if
        0038:   $COUNTER_FINISH == 16
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -404.4
        0005: $FINISH_Y = -926.2
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 17
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -256.5
        0005: $FINISH_Y = -945.0
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 18
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0005: $FINISH_X = -345.79
        0005: $FINISH_Y = -463.1
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 19
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
        0086: $FINISH_X = $START_X
        0086: $FINISH_Y = $START_Y
        018A: $BLIP_RUSH_DESTINATION = create_checkpoint_at $FINISH_X $FINISH_Y -100.0
    end
    if
        0038:   $COUNTER_FINISH == 20
    then
        0164: remove_blip $BLIP_RUSH_DESTINATION
    end
end
return
