//-------------Mission 66-------------
// Originally: Yardies mission 4 'KINGDOM COME'

:M66_KINGDOMCOME
03A4: name_thread 'YARD4'
054C: use_GXT_table 'YARD4'
gosub @MISSION_START_YARDIE4
if
    wasted_or_busted
then
    gosub @MISSION_YD4_FAILED
end
gosub @MISSION_CLEANUP_YARDIE4
end_thread

:MISSION_START_YARDIE4
0317: increment_mission_attempts
0004: $FLAG_PLAYER_ON_MISSION = 1  
0004: $ON_MISSION_FOR_YARDIES = 1  
wait 0 ms
03DE: set_pedestrians_density_multiplier_to 0.0
01F7: set_player $PLAYER ignored_by_cops_state_to 1 (true)
042B: clear_peds_from_cube -234.5 -250.0 6.0 -204.5 -290.0 31.0
03CB: set_camera -215.0 -272.25 21.25
023C: load_special_actor 1 'PLAYER'
while true
    if
        823D:   NOT   special_actor 1 loaded
    jf break
    wait 0 ms
end
02E4: load_cutscene_data 'YD_PH4'
0244: set_cutscene_pos -214.0 -272.25 21.25
02E5: $CUTSCENE_PLAYER = create_cutscene_object #SPECIAL01
02E6: set_cutscene_anim $CUTSCENE_PLAYER 'PLAYER'
016A: fade 1 (back)  1500 ms
02E7: start_cutscene
02E8: $CUT_SCENE_TIME = cutscenetime
while 001A:   2000 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD4_A' 10000 ms 1   // Listen up!
while 001A:   3000 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD4_A1' 10000 ms 1   // Get over to Bedford Point.
while 001A:   5322 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
00BC: print_now 'YD4_A2' 10000 ms 1   // There's a stash in an old car I need pronto!
while 001A:   8600 > $CUT_SCENE_TIME  
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
016A: fade 0  1500 ms
while fading
    wait 0 ms
end
while 82E9:   NOT cutscene_reached_end
    wait 0 ms
    02E8: $CUT_SCENE_TIME = cutscenetime
end
03AF: set_streaming 1 (enabled)
00BE: text_clear_all
02EA: clear_cutscene
wait 500 ms
0296: unload_special_actor 1
03DE: set_pedestrians_density_multiplier_to 1.0
01F7: set_player $PLAYER ignored_by_cops_state_to 0 (false)
016A: fade 1 (out)  1500 ms
0004: $FLAG_VAN1_ARRIVED = 0  
0004: $FLAG_BOMB1_ACTIVE = 0  
0004: $FLAG_BOMB4_ACTIVE = 0  
0004: $FLAG_BOMB7_ACTIVE = 0  
0004: $FLAG_BOMB9_ACTIVE = 0  
0005: $GEN1_X = -448.562  
0005: $GEN1_Y = -1420.5  
0005: $GEN2_X = -425.5  
0005: $GEN2_Y = -1480.0  
0005: $GEN3_X = -373.375  
0005: $GEN3_Y = -1447.0  
0005: $GEN4_X = -388.1875  
0005: $GEN4_Y = -1501.0  
//0005: $COUNTER_BOMB1 = 0
//0005: $COUNTER_BOMB4 = 0
//0005: $COUNTER_BOMB7 = 0
//0005: $COUNTER_BOMB9 = 0
0005: $ABANDONED_CAR_X = -406.5  
0005: $ABANDONED_CAR_Y = -1471.0  
0247: request_model #ESPERANT
0247: request_model #PONY
038B: load_all_models_now
while true
    if or
        8248:   NOT   model #ESPERANT available
        8248:   NOT   model #PONY available
    jf break
    wait 0 ms
end
023C: load_special_actor 1 'BOMBER'
while 823D:   NOT   special_actor 1 loaded
    wait 0 ms
end
0004: $TIMER_Y4 = 90000  
while fading
    wait 0 ms
end
014E: set_timer_to $TIMER_Y4 type 1
00A5: $ABANDONED_CAR_Y4 = create_car #ESPERANT at $ABANDONED_CAR_X $ABANDONED_CAR_Y 33.0
0175: set_car $ABANDONED_CAR_Y4 z_angle_to 270.0
00A9: set_car $ABANDONED_CAR_Y4 to_normal_driver
0186: $BLIP_ABANDONED_CAR_Y4 = create_marker_above_car $ABANDONED_CAR_Y4
00A5: $GEN2_VAN = create_car #PONY at $GEN2_X $GEN2_Y 33.0
0175: set_car $GEN2_VAN z_angle_to 345.0
00A9: set_car $GEN2_VAN to_normal_driver
020A: set_car $GEN2_VAN door_status_to 3    //CARLOCK_LOCKOUT_PLAYER_ONLY
if
    8119:   NOT   car $ABANDONED_CAR_Y4 wrecked
then
    while 80DC:   NOT   player $PLAYER driving $ABANDONED_CAR_Y4
        wait 0 ms
        if
            001A:   1 > $TIMER_Y4  
        then
            00BC: print_now 'TAXI2' 3000 ms 1   // ~r~You're out of time!
            jump @MISSION_YD4_FAILED
        end
        if
            0119:   car $ABANDONED_CAR_Y4 wrecked
        then
            00BC: print_now 'WRECKED' 3000 ms 1   // ~r~The vehicle is wrecked!
            jump @MISSION_YD4_FAILED
        end
    end //while
else
    00BC: print_now 'WRECKED' 3000 ms 1   // ~r~The vehicle is wrecked!
    jump @MISSION_YD4_FAILED
end
0164: remove_blip $BLIP_ABANDONED_CAR_Y4
01B4: set_player $PLAYER can_move 0 (frozen)
014F: stop_timer $TIMER_Y4
0395: clear_area 1 at -448.375 -1431.5 32.0 range 20.0
00A5: $GEN1_VAN = create_car #PONY at $GEN1_X $GEN1_Y 32.1875
0175: set_car $GEN1_VAN z_angle_to 180.0
00A9: set_car $GEN1_VAN to_normal_driver
020A: set_car $GEN1_VAN door_status_to 3
01C8: $HUMAN_BOMB_DEMO = create_actor 21 #SPECIAL01 in_car $GEN1_VAN passenger_seat 0
00A5: $GEN3_VAN = create_car #PONY at $GEN3_X $GEN3_Y 32.1875
0175: set_car $GEN3_VAN z_angle_to 90.0
00A9: set_car $GEN3_VAN to_normal_driver
020A: set_car $GEN3_VAN door_status_to 3
00A5: $GEN4_VAN = create_car #PONY at $GEN4_X $GEN4_Y 32.1875
0175: set_car $GEN4_VAN z_angle_to 90.0
00A9: set_car $GEN4_VAN to_normal_driver
020A: set_car $GEN4_VAN door_status_to 3
015F: set_camera_position -417.0 -1472.0 33.5 0.0 0.0 0.0
if
    8119:   NOT   car $ABANDONED_CAR_Y4 wrecked
then
    0158: camera_on_vehicle $ABANDONED_CAR_Y4 15 2
end
02A3: toggle_widescreen 1 (on)
00BC: print_now 'YD4_B' 3500 ms 2   // LETTER: I hear you've been a busy boy. Well I've been a busy girl.
02A1: message_wait 3500 1
00BC: print_now 'YD4_C' 3500 ms 2   // I think it's time you witnessed the real power of 'SPANK'! Besos y fuderes Catalina xxx.
02A1: message_wait 3500 1
00BC: print_now 'YD4_D' 2500 ms 2   // PS: DIE PEEG DOG DIE!!
02A1: message_wait 2500 1
if
    8119:   NOT   car $GEN1_VAN wrecked
then
    02C2: car $GEN1_VAN drive_to_point -448.188 -1442.5 32.1875
    0158: camera_on_vehicle $GEN1_VAN 15 1
end
if
    8119:   NOT   car $GEN3_VAN wrecked
then
    00A7: car $GEN3_VAN drive_to -388.5 -1446.6899 32.1875
end
while 0038:   $FLAG_VAN1_ARRIVED == 0  
    wait 0 ms
    if
        8119:   NOT   car $GEN1_VAN wrecked
    then
        if
            01AD:   car $GEN1_VAN 0 near_point -448.188 -1442.5 4.0 4.0
        then
            0004: $FLAG_VAN1_ARRIVED = 1  
        end
    else
        jump @MISSION_YD4_FAILED
    end
end //while
if and
    8119:   NOT   car $GEN1_VAN wrecked
    8118:   NOT   actor $HUMAN_BOMB_DEMO dead
then
    01D3: actor $HUMAN_BOMB_DEMO leave_car $GEN1_VAN
    while 00DB:   actor $HUMAN_BOMB_DEMO in_car $GEN1_VAN
        wait 0 ms
        if
            8118:   NOT   actor $HUMAN_BOMB_DEMO dead
        then
            00A0: store_actor $HUMAN_BOMB_DEMO position_to $BOMB_X $BOMB_Y $BOMB_Z
        end
        if
            0118:   actor $HUMAN_BOMB_DEMO dead
        then
            jump @SELKIRK
        end
        if
            0119:   car $GEN1_VAN wrecked
        then
            jump @SELKIRK
        end
    end //while
end
0173: set_actor $HUMAN_BOMB_DEMO z_angle_to 180.0
015F: set_camera_position -450.75 -1455.0 31.875 0.0 0.0 0.0
009F: set_actor $HUMAN_BOMB_DEMO objective_to-1
0159: camera_on_ped $HUMAN_BOMB_DEMO 15 2
00BC: print_now 'YD4_1' 3000 ms 1   // ~g~SPANKED-up madmen!
if
    8118:   NOT   actor $HUMAN_BOMB_DEMO dead
then
    0239: actor $HUMAN_BOMB_DEMO run_to -449.5 -1452.38
    while 80ED:   NOT   actor $HUMAN_BOMB_DEMO 0 near_point_on_foot -449.5 -1452.38 radius 3.0 3.0
        wait 0 ms
        if
            8118:   NOT   actor $HUMAN_BOMB_DEMO dead
        then
            00A0: store_actor $HUMAN_BOMB_DEMO position_to $BOMB_X $BOMB_Y $BOMB_Z
        else
            jump @SELKIRK
        end
    end //while
end
wait 3000 ms
if
    8118:   NOT   actor $HUMAN_BOMB_DEMO dead
then
    0054: store_player $PLAYER position_to $Y4_X $Y4_Y $Y4_Z
    0159: camera_on_ped $HUMAN_BOMB_DEMO 4 1
    0239: actor $HUMAN_BOMB_DEMO run_to $Y4_X $Y4_Y
    while 80ED:   NOT   actor $HUMAN_BOMB_DEMO 0 near_point_on_foot $Y4_X $Y4_Y radius 5.0 5.0
        wait 0 ms
        if
            8118:   NOT   actor $HUMAN_BOMB_DEMO dead
        then
            00A0: store_actor $HUMAN_BOMB_DEMO position_to $BOMB_X $BOMB_Y $BOMB_Z
        end
        if
            0118:   actor $HUMAN_BOMB_DEMO dead
        then
            jump @SELKIRK
        end
    end //while
end

:SELKIRK
020C: create_explosion_with_radius 0 at $BOMB_X $BOMB_Y $BOMB_Z
018C: play_sound 0 at $BOMB_X $BOMB_Y $BOMB_Z
0003: shake_camera 500
wait 1000 ms
02EB: restore_camera_jumpcut
02A3: toggle_widescreen 0 (off)
01B4: set_player $PLAYER can_move 1 (unfrozen)
wait 0 ms
01C2: remove_references_to_actor $HUMAN_BOMB_DEMO  // Like turning an actor into a random pedestrian
00BC: print_now 'YD4_2' 3000 ms 1   // ~g~Destroy the madmens' vans!!
jump @LE_LOOP_DE_MORT

// GENERATORS*****GENERATORS*****GENERATORS*****GENERATORS*****GENERATORS*****GENERATORS*****
//111111111111111111111111111111111111111111111111111111111111111111111

:GENERATOR_1_EASY
if
    8119:   NOT   car $GEN1_VAN wrecked
then
    01C8: $HUMAN_BOMB_1 = create_actor 21 #SPECIAL01 in_car $GEN1_VAN passenger_seat 0
    0004: $FLAG_BOMB1_ACTIVE = 1  
    01D3: actor $HUMAN_BOMB_1 leave_car $GEN1_VAN
    0187: $BLIP_BOMBER_1 = create_marker_above_actor $HUMAN_BOMB_1
    while 00DB:   actor $HUMAN_BOMB_1 in_car $GEN1_VAN
        00A0: store_actor $HUMAN_BOMB_1 position_to $BOMB_X $BOMB_Y $BOMB_Z
        wait 0 ms
        if or
            0118:   actor $HUMAN_BOMB_1 dead
            0119:   car $GEN1_VAN wrecked
        then
            return
        end
    end
end
return
//222222222222222222222222222222222222222222222222222222222222222222222222
:GENERATOR_2_EASY
if
    8119:   NOT   car $GEN2_VAN wrecked
then
    01C8: $HUMAN_BOMB_4 = create_actor 21 #SPECIAL01 in_car $GEN2_VAN passenger_seat 0
    0004: $FLAG_BOMB4_ACTIVE = 1  
    01D3: actor $HUMAN_BOMB_4 leave_car $GEN2_VAN
    0187: $BLIP_BOMBER_4 = create_marker_above_actor $HUMAN_BOMB_4
    while 00DB:   actor $HUMAN_BOMB_4 in_car $GEN2_VAN
        00A0: store_actor $HUMAN_BOMB_4 position_to $BOMB4_X $BOMB4_Y $BOMB4_Z
        wait 0 ms
        if or
            0118:   actor $HUMAN_BOMB_4 dead
            0119:   car $GEN2_VAN wrecked
        then
            return
        end
    end
end
return

:GENERATOR_3_EASY
if
    8119:   NOT   car $GEN3_VAN wrecked
then
    01C8: $HUMAN_BOMB_7 = create_actor 21 #SPECIAL01 in_car $GEN3_VAN passenger_seat 0
    0004: $FLAG_BOMB7_ACTIVE = 1  
    01D3: actor $HUMAN_BOMB_7 leave_car $GEN3_VAN
    0187: $BLIP_BOMBER_7 = create_marker_above_actor $HUMAN_BOMB_7
    while 00DB:   actor $HUMAN_BOMB_7 in_car $GEN3_VAN
        00A0: store_actor $HUMAN_BOMB_7 position_to $BOMB7_X $BOMB7_Y $BOMB7_Z
        wait 0 ms
        if or
            0118:   actor $HUMAN_BOMB_7 dead
            0119:   car $GEN3_VAN wrecked
        then
            return
        end
    end
end
return

:GENERATOR_4_EASY
if
    8119:   NOT   car $GEN4_VAN wrecked
then
    01C8: $HUMAN_BOMB_9 = create_actor 21 #SPECIAL01 in_car $GEN4_VAN passenger_seat 0
    0004: $FLAG_BOMB9_ACTIVE = 1  
    01D3: actor $HUMAN_BOMB_9 leave_car $GEN4_VAN
    0187: $BLIP_BOMBER_9 = create_marker_above_actor $HUMAN_BOMB_9
    while 00DB:   actor $HUMAN_BOMB_9 in_car $GEN4_VAN
        00A0: store_actor $HUMAN_BOMB_9 position_to $BOMB9_X $BOMB9_Y $BOMB9_Z
        wait 0 ms
        if or
            0118:   actor $HUMAN_BOMB_9 dead
            0119:   car $GEN4_VAN wrecked
        then
            return
        end
    end    
end
return

// MAIN LOOP*****MAIN LOOP*****MAIN LOOP*****MAIN LOOP*****MAIN LOOP*****MAIN LOOP*****MAIN LOOP*****MAIN LOOP*****MAIN LOOP*****

:LE_LOOP_DE_MORT
wait 0 ms
if
    0038:   $FLAG_BOMB1_ACTIVE == 0  
then
    gosub @GENERATOR_1_EASY
else
    if
        8118:   NOT   actor $HUMAN_BOMB_1 dead
    then
        0054: store_player $PLAYER position_to $Y4_X $Y4_Y $Y4_Z
        0239: actor $HUMAN_BOMB_1 run_to $Y4_X $Y4_Y
        00A0: store_actor $HUMAN_BOMB_1 position_to $BOMB_X $BOMB_Y $BOMB_Z
        01ED: reset_actor $HUMAN_BOMB_1 flags
        if or
            00FE:   actor $HUMAN_BOMB_1 0 near_point $Y4_X $Y4_Y $Y4_Z radius 3.0 3.0 4.0
            8184:   NOT   actor $HUMAN_BOMB_1 health >= 95
        then
            gosub @DETONATE_1
            01C2: remove_references_to_actor $HUMAN_BOMB_1  // Like turning an actor into a random pedestrian
            0004: $FLAG_BOMB1_ACTIVE = 0  
            gosub @GENERATOR_1_EASY
        end
    else
        gosub @DETONATE_1
        01C2: remove_references_to_actor $HUMAN_BOMB_1  // Like turning an actor into a random pedestrian
        0004: $FLAG_BOMB1_ACTIVE = 0  
    end
end
if
    0038:   $FLAG_BOMB4_ACTIVE == 0  
then
    gosub @GENERATOR_2_EASY
else
    if
        8118:   NOT   actor $HUMAN_BOMB_4 dead
    then
        0054: store_player $PLAYER position_to $Y4_X $Y4_Y $Y4_Z
        0239: actor $HUMAN_BOMB_4 run_to $Y4_X $Y4_Y
        00A0: store_actor $HUMAN_BOMB_4 position_to $BOMB4_X $BOMB4_Y $BOMB4_Z
        01ED: reset_actor $HUMAN_BOMB_4 flags
        
        if or
            00FE:   actor $HUMAN_BOMB_4 0 near_point $Y4_X $Y4_Y $Y4_Z radius 3.0 3.0 4.0
            8184:   NOT   actor $HUMAN_BOMB_4 health >= 95
        then
            gosub @DETONATE_4
            01C2: remove_references_to_actor $HUMAN_BOMB_4  // Like turning an actor into a random pedestrian
            0004: $FLAG_BOMB4_ACTIVE = 0  
        end
    else
        gosub @DETONATE_4
        01C2: remove_references_to_actor $HUMAN_BOMB_4  // Like turning an actor into a random pedestrian
        0004: $FLAG_BOMB4_ACTIVE = 0  
    end
end
if
    0038:   $FLAG_BOMB7_ACTIVE == 0  
then
    gosub @GENERATOR_3_EASY
else
    if
        8118:   NOT   actor $HUMAN_BOMB_7 dead
    then
        0054: store_player $PLAYER position_to $Y4_X $Y4_Y $Y4_Z
        0239: actor $HUMAN_BOMB_7 run_to $Y4_X $Y4_Y
        00A0: store_actor $HUMAN_BOMB_7 position_to $BOMB7_X $BOMB7_Y $BOMB7_Z
        01ED: reset_actor $HUMAN_BOMB_7 flags
        if or
            00FE:   actor $HUMAN_BOMB_7 0 near_point $Y4_X $Y4_Y $Y4_Z radius 3.0 3.0 4.0
            8184:   NOT   actor $HUMAN_BOMB_7 health >= 95
        then
            gosub @DETONATE_7
            01C2: remove_references_to_actor $HUMAN_BOMB_7  // Like turning an actor into a random pedestrian
            0004: $FLAG_BOMB7_ACTIVE = 0  
        end    
    else
        gosub @DETONATE_7
        01C2: remove_references_to_actor $HUMAN_BOMB_7  // Like turning an actor into a random pedestrian
        0004: $FLAG_BOMB7_ACTIVE = 0  
    end
end
if
    0038:   $FLAG_BOMB9_ACTIVE == 0  
then
    gosub @GENERATOR_4_EASY
else
    if
        8118:   NOT   actor $HUMAN_BOMB_9 dead
    then
        0054: store_player $PLAYER position_to $Y4_X $Y4_Y $Y4_Z
        00A0: store_actor $HUMAN_BOMB_9 position_to $BOMB9_X $BOMB9_Y $BOMB9_Z
        01ED: reset_actor $HUMAN_BOMB_9 flags
        0239: actor $HUMAN_BOMB_9 run_to $Y4_X $Y4_Y
        if or
            00FE:   actor $HUMAN_BOMB_9 0 near_point $Y4_X $Y4_Y $Y4_Z radius 3.0 3.0 4.0
            8184:   NOT   actor $HUMAN_BOMB_9 health >= 95
        then
            gosub @DETONATE_9
            01C2: remove_references_to_actor $HUMAN_BOMB_9  // Like turning an actor into a random pedestrian
            0004: $FLAG_BOMB9_ACTIVE = 0  
        end
    else
        gosub @DETONATE_9
        01C2: remove_references_to_actor $HUMAN_BOMB_9  // Like turning an actor into a random pedestrian
        0004: $FLAG_BOMB9_ACTIVE = 0  
    end
end
if and
    0119:   car $GEN1_VAN wrecked
    0119:   car $GEN2_VAN wrecked
    0119:   car $GEN3_VAN wrecked
    0119:   car $GEN4_VAN wrecked
then
    if and
        0118:   actor $HUMAN_BOMB_1 dead
        0118:   actor $HUMAN_BOMB_4 dead
        0118:   actor $HUMAN_BOMB_7 dead
        0118:   actor $HUMAN_BOMB_9 dead
    then
        jump @MISSION_YARDIE4_PASSED
    end
end
jump @LE_LOOP_DE_MORT

// DETONATIONS*****DETONATIONS*****DETONATIONS*****DETONATIONS*****DETONATIONS*****DETONATIONS*****DETONATIONS*****
:DETONATE_1
if
    0038:   $FLAG_BOMB1_ACTIVE == 1  
then
    020C: create_explosion_with_radius 0 at $BOMB_X $BOMB_Y $BOMB_Z
    018C: play_sound 0 at $BOMB_X $BOMB_Y $BOMB_Z
    0003: shake_camera 500
    0004: $FLAG_BOMB1_ACTIVE = 0  
    0164: remove_blip $BLIP_BOMBER_1
end
return

:DETONATE_4
if
    0038:   $FLAG_BOMB4_ACTIVE == 1  
then
    020C: create_explosion_with_radius 0 at $BOMB4_X $BOMB4_Y $BOMB4_Z
    018C: play_sound 0 at $BOMB4_X $BOMB4_Y $BOMB4_Z
    0003: shake_camera 500
    0004: $FLAG_BOMB4_ACTIVE = 0        //GUESSING THIS WAS ACCIDENTALLY LEFT OUT OF R*S CODE
    0164: remove_blip $BLIP_BOMBER_4
end
return

:DETONATE_7
if
    0038:   $FLAG_BOMB7_ACTIVE == 1  
then
    020C: create_explosion_with_radius 0 at $BOMB7_X $BOMB7_Y $BOMB7_Z
    018C: play_sound 0 at $BOMB7_X $BOMB7_Y $BOMB7_Z
    0003: shake_camera 500
    0004: $FLAG_BOMB7_ACTIVE = 0  
    0164: remove_blip $BLIP_BOMBER_7
end
return

:DETONATE_9
if
    0038:   $FLAG_BOMB9_ACTIVE == 1  
then
    020C: create_explosion_with_radius 0 at $BOMB9_X $BOMB9_Y $BOMB9_Z
    018C: play_sound 0 at $BOMB9_X $BOMB9_Y $BOMB9_Z
    0003: shake_camera 500
    0004: $FLAG_BOMB9_ACTIVE = 0  
    0164: remove_blip $BLIP_BOMBER_9
end
return

:MISSION_YD4_FAILED
00BA: text_styled 'M_FAIL' 2000 ms 1   // MISSION FAILED!
return

:MISSION_YARDIE4_PASSED
0004: $KINGDOM_COME_COMPLETED = 1  
01E3: text_1number_styled 'M_PASS' 10000 5000 ms 1   // MISSION PASSED! $~1~
0394: play_music 1
0110: clear_player $PLAYER wanted_level
0109: player $PLAYER money += 10000
0318: set_latest_mission_passed 'YD4'   // 'KINGDOM COME'
030C: set_mission_points += 1
03F1: pedtype 11 add_threat 1

// all blips removed because game can fail to remove them
0164: remove_blip $BLIP_BOMBER_1
0164: remove_blip $BLIP_BOMBER_4
0164: remove_blip $BLIP_BOMBER_7
0164: remove_blip $BLIP_BOMBER_9

0164: remove_blip $YARDIE_PHONE_MARKER
004F: create_thread @YARDIE_MISSION1_LOOP
return

:MISSION_CLEANUP_YARDIE4
0004: $FLAG_PLAYER_ON_MISSION = 0  
0004: $ON_MISSION_FOR_YARDIES = 0  
0164: remove_blip $BLIP_ABANDONED_CAR_Y4
014F: stop_timer $TIMER_Y4
0296: unload_special_actor 1
0249: mark_model_as_no_longer_needed #SPECIAL01
0249: mark_model_as_no_longer_needed #ESPERANT
0249: mark_model_as_no_longer_needed #PONY
mission_cleanup
return